theory BinaryRenSound = SatSec + BinaryRen + UnaryRenSound:

lemma renState_inj_Invv: "\<lbrakk>renState \<gamma> f \<delta>; inj_on f (dom f)\<rbrakk> \<Longrightarrow> renState \<delta> (Invv f) \<gamma>"
apply (simp add: renState_def)
apply (case_tac \<gamma>, case_tac \<delta>, clarsimp)
apply rule apply (erule MapN_f_inj_Invv) apply assumption
apply rule apply (erule Renames_STATE_Invv) apply (simp add: inj_finMap_def)
apply rule apply (erule Renames_STATE_Invv) apply (simp add: inj_finMap_def)
apply (subgoal_tac "dom (Invv f) = ran f")
prefer 2 apply (rule inj_finMap_dom_invv_ran)  apply (simp add: inj_finMap_def)   
apply rule apply (drule MapN_dom) apply simp apply (rule Img_dom_ran)           
apply rule apply (subgoal_tac "inj_finMap f") apply (drule inj_finMap_Invv) 
              apply (simp add: inj_finMap_def) apply (erule inj_on_subset) 
              apply (drule MapN_dom) apply (rule SetTriv101, rule ObjIDs_in_Dom) 
              apply (simp add: Img_def, clarsimp) apply (erule ranI)
           apply (simp add: inj_finMap_def)
apply (simp add: State_noDangColours_def Renames_STATE_def, clarsimp)
apply (frule MapN_dom, simp)
apply rule apply (drule_tac S=a in MAP_OPSTACK_set_Img) apply simp apply (erule Img_Monotone)
apply rule apply clarsimp apply (drule AL_codD, clarsimp) 
  apply (drule_tac s=aa in MAP_STORE_D_right) apply assumption apply clarsimp apply (simp add: Img_def) 
  apply (rule_tac x=c in exI, clarsimp)  
apply rule apply (drule_tac N=b in MapHP_dom) apply simp apply (erule Img_Monotone)
apply rule apply (rule SetTriv101) apply (erule MapHP_AbsFields_Img)  apply (erule Img_Monotone)
apply rule apply clarsimp 
            apply (drule_tac N=b in MapHP_dom) apply simp  
            apply (simp add: Img_def, clarsimp)
            apply (drule_tac x=s and Y="ObjIDs ab" in SetTriv) apply assumption
            apply (drule MapN_TypePreserving) apply (simp add: ObjIDs_def, clarsimp)
            apply (drule TypePreserving_D) apply assumption apply assumption apply clarsimp
apply rule apply (simp add: State_good_def, clarsimp)
           apply rule apply (drule_tac s=aa in MAP_STORE_AL) apply simp
           apply (drule_tac H=b in MapHP_AL2) apply assumption apply assumption apply simp
apply rule apply (erule MapN_AL_Aux1)
apply rule apply (drule_tac S=ac in MAP_OPSTACK_set_Img) apply simp apply (erule Img_Monotone)
apply rule apply clarsimp apply (drule AL_codD, clarsimp) 
  apply (drule_tac s=ad in MAP_STORE_D_right) apply assumption apply clarsimp apply (simp add: Img_def) 
  apply (rule_tac x=c in exI, clarsimp)  
apply rule apply (drule_tac N=ba in MapHP_dom) apply simp apply (erule Img_Monotone)
apply rule apply (rule SetTriv101) apply (erule MapHP_AbsFields_Img)  apply (erule Img_Monotone)
apply rule apply clarsimp 
            apply (drule_tac N=ba in MapHP_dom) apply simp  
            apply (simp add: Img_def, clarsimp)
            apply (drule_tac x=s and Y="ObjIDs ab" in SetTriv) apply assumption
            apply (drule MapN_TypePreserving) apply (simp add: ObjIDs_def, clarsimp)
            apply (drule TypePreserving_D) apply assumption apply assumption apply clarsimp
apply rule apply (simp add: State_good_def, clarsimp)
           apply rule apply (drule_tac s=ad in MAP_STORE_AL) apply simp
           apply (drule_tac H=ba in MapHP_AL2) apply assumption apply assumption apply simp
apply (erule MapN_AL_Aux1)
done

lemma SV:
" \<lbrakk> renState ((S, \<Gamma>, H), N, T, \<Delta>, K) f ((fS, f\<Gamma>, fH), fN, fT, f\<Delta>, fK);
    renState ((S', \<Gamma>', H'), N', T', \<Delta>', K') g ((gS', g\<Gamma>', gH'), gN', gT', g\<Delta>', gK');
    renState ((S, \<Gamma>, H_Ha), N_Na, T, \<Delta>, K_Ka) (f ++ fa) ((fS, f\<Gamma>, fH_HHmap), ffa_N_Na, fT, f\<Delta>, fK_KKmap);
    \<forall>c. c \<in> AL_dom N_Na \<longrightarrow>
            Invariant c (S', \<Gamma>', H'Ha) ([v], emp, h) I1 N_Na (S, \<Gamma>, H_Ha) (ops1, s1, h1) (map_compose I (f ++ fa)) \<and>
            Invariant c (T', \<Delta>', K'Ka) ([w], emp, k) J1 N_Na (T, \<Delta>, K_Ka) (ops2, s2, h2) (map_compose J (f ++ fa));
    welldef ((gS', g\<Gamma>', gfa_H'Ha), gfa_N'Na, gT', g\<Delta>', gfa_K'Ka);
    welldef ((fS, f\<Gamma>, fH_HH), ffa_N_Na, fT, f\<Delta>, fK_KK);
    welldef ((S', \<Gamma>', H'Ha), N'Na, T', \<Delta>', K'Ka); 
    \<forall> c. ffa_N_Na\<down>c = Some intTP \<longrightarrow>
            c \<in> DOM (fS, f\<Gamma>, fH_HH) \<and> c \<in> DOM (fT, f\<Delta>, fK_KK) \<longrightarrow>
              singleVal c ((fS, f\<Gamma>, fH_HH), ffa_N_Na, fT, f\<Delta>, fK_KK) (ops1, s1, h1) I (ops2, s2, h2) J;
    \<forall> c. N'Na\<down>c = Some intTP \<longrightarrow>
            c \<in> DOM (S', \<Gamma>', H'Ha) \<and> c \<in> DOM (T', \<Delta>', K'Ka) \<longrightarrow>
             singleVal c ((S', \<Gamma>', H'Ha), N'Na, T', \<Delta>', K'Ka) ([v], emp, h) I1 ([w], emp, k) J1;
        StateSatisfiesAbstraction (ops1, s1, h1) (fS, f\<Gamma>, fH_HH) ffa_N_Na I; StateSatisfiesAbstraction (ops2, s2, h2) (fT, f\<Delta>, fK_KK) ffa_N_Na J;
        StateSatisfiesAbstraction ([v], emp, h) (S', \<Gamma>', H'Ha) N'Na I1; StateSatisfiesAbstraction ([w], emp, k) (T', \<Delta>', K'Ka) N'Na J1;
        inj_on g (dom g - dom f); inj_on fa (dom fa); Img g (dom g - dom f) \<inter> Img g (dom f) = {}; 
        contained N N'; AL_dom H \<subseteq> AL_dom H'; AL_dom K \<subseteq> AL_dom K'; 
        AL_sum H Ha H_Ha; AL_sum K Ka K_Ka; AL_sum N Na N_Na; 
        AL_sum H' Ha H'Ha; AL_sum K' Ka K'Ka; AL_sum N' Na N'Na; 
        AL_sum fH HH fH_HH; AL_sum fH HH fH_HHmap; AL_sum gH' HH gH'HH;
        AL_sum fK KK fK_KK; AL_sum fK KK fK_KKmap; AL_sum gK' KK gK'KK;
        AL_sum fN NN fN_NN; AL_sum gN' NN gN'NN; AL_sum fN NN ffa_N_Na; 


        AL_sum gH' HH gfa_H'Ha;  AL_sum gK' KK gfa_K'Ka; AL_sum gN' NN gfa_N'Na; 

        AL_dom Ha \<subseteq> ObjIDs N_Na; AL_dom Ka \<subseteq> ObjIDs N_Na; 
        AL_dom H \<subseteq> ObjIDs N; AL_dom K \<subseteq> ObjIDs N; 

        AL_dom gN' \<inter> ran fa = {}; AL_dom Na = dom fa; AL_dom NN = ran fa; dom fa \<inter> AL_dom N' = {};

        (Na, g ++ fa, NN) \<in> MapN; (N_Na, f ++ fa, ffa_N_Na) \<in> MapN; (N'Na, g ++ fa, gfa_N'Na) \<in> MapN; 

        (Ha, f ++ fa, HH) \<in> MapHP; (Ka, f ++ fa, KK) \<in> MapHP; 
        (H'Ha, g ++ fa, gfa_H'Ha) \<in> MapHP; (K'Ka, g ++ fa, gfa_K'Ka) \<in> MapHP;
         
        \<forall>c fc. f c = Some fc \<longrightarrow> g c = Some fc; 

        \<forall> d . d \<in> AL_dom N' \<longrightarrow> (g ++ fa) d = g d;
        (g ++ fa) cc = Some c; N'Na\<down>cc = Some intTP; gfa_N'Na\<down>c = Some intTP \<rbrakk>
       \<Longrightarrow> singleVal c ((gS', g\<Gamma>', gfa_H'Ha), gfa_N'Na, gT', g\<Delta>', gfa_K'Ka) ([v], emp, h) (map_compose I1 (Invv (g ++ fa)))
           ([w], emp, k) (map_compose J1 (Invv (g ++ fa)))"
apply (subgoal_tac "fH_HHmap \<in> AL")
prefer 2 apply (simp add: renState_def Renames_STATE_def, (erule conjE)+)
         apply (erule MapHP_AL_right)
apply (subgoal_tac "fK_KKmap \<in> AL")
prefer 2 apply (simp add: renState_def Renames_STATE_def, (erule conjE)+)
         apply (erule MapHP_AL_right)
apply (subgoal_tac "inj_on (g ++ fa) (ObjIDs N'Na)")
prefer 2 
  apply (erule thin_rl) apply (rotate_tac 1, erule thin_rl, erule thin_rl)
  apply (simp add: renState_def, clarsimp)
  apply (erule inj_on_MapN_sum) apply assumption+ 
apply (subgoal_tac "contained fN gN'") 
prefer 2 apply (simp (no_asm) add: contained_def, clarsimp)
         apply (simp add: renState_def, clarsimp)
         apply (drule_tac N=N in MapN_D_right, assumption, clarsimp)
         apply (drule contained3, assumption)
         apply (drule_tac N=N' in MapN_D_left, assumption) apply clarsimp
apply (subgoal_tac "inj_on (f ++ fa) (ObjIDs N_Na)")
prefer 2 
  apply (rotate_tac 1, erule thin_rl, erule thin_rl, erule thin_rl)
  apply (simp add: renState_def, clarsimp)
  apply (erule inj_on_MapN_sum) apply assumption+ apply (rule SetTriv103) apply (erule contained5) apply assumption+
           apply (rule SetTriv108) apply (subgoal_tac "AL_dom N \<inter> dom fa = {}", clarsimp) 
           apply (rule SetTriv103) apply (erule contained5) apply (erule SetTriv108)  apply assumption+
apply (subgoal_tac "inj_on (f ++ fa) (ObjIDs N)")
prefer 2 apply (erule inj_on_subset)
         apply (erule AL_sum_ObjIDs_left)
apply (subgoal_tac "(T', g ++ fa, gT') \<in> MAP_OPSTACK")
prefer 2 apply (simp add: renState_def Renames_STATE_def, (erule conjE)+) 
         apply (erule_tac Y="AL_dom N'" in MAP_OPSTACK_Fun_eqOn[rule_format]) apply (erule_tac x=ca in allE, erule mp, clarsimp)
             apply (simp add: State_noDangColours_def)
apply (subgoal_tac "(\<Delta>', g ++ fa, g\<Delta>') \<in> MAP_STORE")
prefer 2 apply (simp add: renState_def Renames_STATE_def, (erule conjE)+) 
           apply (erule_tac Y="AL_dom N'" in MAP_STORE_Fun_eqOn[rule_format]) apply (erule_tac x=ca in allE, erule mp, clarsimp) 
             apply (simp add: State_noDangColours_def)
apply (subgoal_tac "(S', g ++ fa, gS') \<in> MAP_OPSTACK")
prefer 2  apply (simp add: renState_def Renames_STATE_def, (erule conjE)+) 
           apply (erule_tac Y="AL_dom N'" in MAP_OPSTACK_Fun_eqOn[rule_format]) apply (erule_tac x=ca in allE, erule mp, clarsimp) 
             apply (simp add: State_noDangColours_def)
apply (subgoal_tac "(\<Gamma>', g ++ fa, g\<Gamma>') \<in> MAP_STORE")
prefer 2 apply (simp add: renState_def Renames_STATE_def, (erule conjE)+) 
           apply (erule_tac Y="AL_dom N'" in MAP_STORE_Fun_eqOn[rule_format]) apply (erule_tac x=ca in allE, erule mp, clarsimp) 
             apply (simp add: State_noDangColours_def)
apply (subgoal_tac "AL_dom N'Na = dom (g ++ fa)")
prefer 2 apply (simp add: AL_sum_def, clarsimp)
         apply (erule thin_rl, simp add: renState_def) apply fast
apply (subgoal_tac "AL_dom gfa_N'Na = ran (g ++ fa)")
prefer 2 apply (subgoal_tac "AL_dom gfa_N'Na = Img (g++fa) (dom (g ++ fa))") apply (simp only: Img_dom_ran[of "g++fa"])  
         apply (drule_tac N=N'Na in MapN_dom) apply simp
apply (simp (no_asm) add: singleVal_def)
apply (case_tac "c:ran f")
      apply (drule ranD, clarsimp) 
      apply (subgoal_tac "{ d . g d = Some c } = { d . f d = Some c} ")
      prefer 2 apply (rule, clarsimp) 
                 apply (case_tac "x:dom f") apply clarsimp 
                 apply (drule_tac X="Img g (dom g - dom f)" and x=c and y=c in SetTriv106)
                   apply (simp add: Img_def) apply (rule_tac x=x in exI, clarsimp) 
                   apply (simp add: Img_def) apply (rule_tac x=b in exI, clarsimp) 
                   apply simp
               apply clarsimp
      apply (subgoal_tac "({ u . \<exists> d . (g++fa) d = Some c \<and> u : ValuesRepresented d (S', \<Gamma>', H'Ha) ([v], emp, h) I1},
                           { u . \<exists> d . (g++fa) d = Some c \<and> u : ValuesRepresented d (T', \<Delta>', K'Ka) ([w], emp, k) J1}) \<in> twSet")
        apply (rule_tac X="{u. \<exists>d. (g++fa) d = Some c \<and> u \<in> ValuesRepresented d (S', \<Gamma>', H'Ha) ([v], emp, h) I1}" in twSet_Triv9) 
          apply (erule_tac Y="{u. \<exists>d. (g++fa) d = Some c \<and> u \<in> ValuesRepresented d (T', \<Delta>', K'Ka) ([w], emp, k) J1}" in twSet_Triv10)
          apply (erule_tac N=N'Na in Ren_ValuesRepresented2) apply assumption apply (simp add: welldef_def) apply (simp add: welldef_def)
                   apply (simp add: Renames_STATE_def) apply assumption apply simp apply (erule AL_domI)
        apply (erule_tac N=N'Na in Ren_ValuesRepresented2) apply assumption apply (simp add: welldef_def) apply (simp add: welldef_def)
                 apply (simp add: Renames_STATE_def) apply assumption apply simp apply (erule AL_domI)
      apply (subgoal_tac "c:AL_dom ffa_N_Na") prefer 2 apply (drule_tac N=N_Na in MapN_dom, simp add: Img_def) 
                                                       apply (rule_tac x=b in exI) apply (simp add: AL_sum_def renState_def) 
                                                        apply rule apply (rule disjI1) apply clarsimp 
                                                        apply (case_tac "fa b", simp add: map_add_def) 
                                                        apply (drule_tac X="dom fa" and y=b in SetTriv106) 
                                                          apply (erule domI)
                                                          apply clarsimp
                                                         apply simp
      apply (subgoal_tac "ffa_N_Na\<down>c = Some intTP")
      prefer 2 apply (drule AL_domD, clarsimp) apply (drule_tac N=ffa_N_Na in AL_sum_split, assumption)
               apply (drule_tac N=gfa_N'Na in AL_sum_split, assumption)
               apply (rotate_tac -2, erule disjE) apply (drule contained3, assumption)
                 apply (erule disjE) apply clarsimp
                   apply (drule_tac X="AL_dom gN'" in SetTriv106) apply (erule AL_domI) 
                   apply (drule_tac H=NN in AL_domI) apply clarsimp apply assumption
                   apply simp
                apply (erule disjE) 
                apply (drule_tac X="AL_dom gN'" in SetTriv106) apply (erule AL_domI) 
                  apply (drule_tac H=NN in AL_domI) apply clarsimp apply assumption
                apply simp
              apply clarsimp
      apply (subgoal_tac "singleVal c ((fS, f\<Gamma>, fH_HH), ffa_N_Na, fT, f\<Delta>, fK_KK) (ops1, s1, h1) I (ops2, s2, h2) J")
      prefer 2 apply (erule_tac x=c in allE, erule impE, assumption)        
               apply (case_tac "c \<in> DOM (fS, f\<Gamma>, fH_HH)")
                 apply (case_tac " c \<in> DOM (fT, f\<Delta>, fK_KK)", simp)
                 apply (subgoal_tac "uniqueValues (fS, f\<Gamma>, fH_HH) (ops1, s1, h1) I")
                 prefer 2 apply (simp add: StateSatisfiesAbstraction_def)
                 apply (simp add: uniqueValues_def) apply (erule_tac x=c in allE, erule impE, assumption, erule exE)
                 apply (simp add: singleVal_def)
                 apply (rule twSetEmpR) apply (erule ValuesRepresented_notin_DOM) apply simp
               apply (case_tac " c \<in> DOM (fT, f\<Delta>, fK_KK)", simp)
                 apply (subgoal_tac "uniqueValues (fT, f\<Delta>, fK_KK) (ops2, s2, h2) J")
                 prefer 2 apply (simp add: StateSatisfiesAbstraction_def)
                 apply (simp add: uniqueValues_def) apply (erule_tac x=c in allE, erule impE, assumption, erule exE)
                 apply (simp add: singleVal_def)
                 apply (rule twSetEmpL) apply (erule ValuesRepresented_notin_DOM) apply simp
               apply (simp add: singleVal_def)
                 apply (rule twSetEmp) apply (erule ValuesRepresented_notin_DOM) apply (erule ValuesRepresented_notin_DOM)
      apply (simp add: singleVal_def)
        apply (rule twSet_Triv9)
          apply (erule twSet_Triv10)
              apply (rule_tac Y="{u. \<exists>d. (f++fa) d = Some c \<and> u \<in> ValuesRepresented d (T', \<Delta>', K'Ka) ([w], emp, k) J1}" in SetTriv101) 
                apply clarsimp apply (rule_tac x=d in exI, clarsimp)  apply (rotate_tac -1, erule disjE) apply simp apply clarsimp
                               apply (subgoal_tac "d:{d. g d = Some c}") apply (drule SetTriv104, assumption) apply clarsimp apply (simp add: map_add_def)
                               apply fast
              apply (rule_tac Y="{u. \<exists>d. (f++fa) d = Some c \<and> u \<in> ValuesRepresented d (T, \<Delta>, K_Ka) (ops2, s2, h2) (map_compose J (f++fa))}" in SetTriv101)
                apply clarsimp apply (rule_tac x=d in exI, rule)  apply (rotate_tac -1, erule disjE) apply (simp add: map_add_def) apply (simp add: map_add_def)
                               apply (erule_tac x=d in allE, erule impE) apply (simp add: AL_sum_def renState_def, clarsimp)
                               apply (erule conjE, rotate_tac -2, erule thin_rl)
                               apply (simp add: Invariant_def  ValRepEQ, (erule conjE)+)
                               apply (erule SetTriv, assumption)
              apply clarsimp
                apply (rule_tac X="ValuesRepresented c (fT, f\<Delta>, fK_KKmap) (ops2, s2, h2) J" in SetTriv104)
                  apply (erule SetTriv) apply (rule_tac N=N_Na in Ren_ValuesRepresented) 
                                        apply assumption
                                        apply assumption
                                        apply (simp add: welldef_def renState_def , (erule conjE)+)
                                          apply (erule Ren_State_welldef) 
                                            apply (erule State_welldef_HPextensional) apply (erule AL_sum_extensional, assumption) apply assumption
                                          apply assumption
                                          apply assumption
                                          apply assumption
                                        apply (simp add: renState_def Renames_STATE_def)
                     apply (rotate_tac -1, erule disjE) apply (simp add: map_add_def) apply (simp add: map_add_def)
                  apply (rule ValuesRepresented_HPextensional) apply (erule AL_sum_extensional) apply assumption
           apply (rule_tac Y="{u. \<exists>d. (f++fa) d = Some c \<and> u \<in> ValuesRepresented d (S', \<Gamma>', H'Ha) ([v], emp, h) I1}" in SetTriv101) 
                apply clarsimp apply (rule_tac x=d in exI, clarsimp)  apply (rotate_tac -1, erule disjE) apply simp apply clarsimp
                               apply (subgoal_tac "d:{d. g d = Some c}") apply (drule SetTriv104, assumption) apply clarsimp apply (simp add: map_add_def)
                               apply fast
              apply (rule_tac Y="{u. \<exists>d. (f++fa) d = Some c \<and> u \<in> ValuesRepresented d (S, \<Gamma>, H_Ha) (ops1, s1, h1) (map_compose I (f ++ fa))}" in SetTriv101)
                apply clarsimp apply (rule_tac x=d in exI, rule)  apply (rotate_tac -1, erule disjE) apply (simp add: map_add_def) apply (simp add: map_add_def)
                               apply (erule_tac x=d in allE, erule impE) apply (simp add: AL_sum_def renState_def, clarsimp)
                               apply (erule conjE, rotate_tac -1, erule thin_rl)
                               apply (simp add: Invariant_def  ValRepEQ, (erule conjE)+)
                               apply (erule SetTriv, assumption)
              apply clarsimp
                apply (rule_tac X="ValuesRepresented c  (fS, f\<Gamma>, fH_HHmap) (ops1, s1, h1) I" in SetTriv104)
                  apply (erule SetTriv) apply (rule_tac N=N_Na in Ren_ValuesRepresented) 
                                        apply assumption
                                        apply assumption
                                        apply (simp add: welldef_def renState_def , (erule conjE)+)
                                          apply (erule Ren_State_welldef) 
                                            apply (erule State_welldef_HPextensional) apply (erule AL_sum_extensional, assumption) apply assumption
                                          apply assumption
                                          apply assumption
                                          apply assumption
                                        apply (simp add: renState_def Renames_STATE_def)
                     apply (rotate_tac -1, erule disjE) apply (simp add: map_add_def) apply (simp add: map_add_def)
                  apply (rule ValuesRepresented_HPextensional) apply (erule AL_sum_extensional) apply assumption
    (*c \<notin> ran f*)
    apply (subgoal_tac "singleVal cc ((S', \<Gamma>', H'Ha), N'Na, T', \<Delta>', K'Ka) ([v], emp, h) I1 ([w], emp, k) J1")
    prefer 2 apply (erule_tac x=cc in allE, erule impE, assumption)
             apply (case_tac "cc \<in> DOM (S', \<Gamma>', H'Ha)")
               apply (case_tac "cc \<in> DOM (T', \<Delta>', K'Ka)", simp)
               apply (subgoal_tac "uniqueValues (S', \<Gamma>', H'Ha) ([v], emp, h) I1")
               prefer 2 apply (simp add: StateSatisfiesAbstraction_def)
               apply (simp add: uniqueValues_def) apply (erule_tac x=cc in allE, erule impE, assumption, erule exE)
                 apply (simp add: singleVal_def)
                 apply (rule twSetEmpR) apply (erule ValuesRepresented_notin_DOM) apply simp
             apply (case_tac "cc \<in> DOM (T', \<Delta>', K'Ka)", simp)
               apply (subgoal_tac "uniqueValues (T', \<Delta>', K'Ka) ([w], emp, k) J1")
               prefer 2 apply (simp add: StateSatisfiesAbstraction_def)
               apply (simp add: uniqueValues_def) apply (erule_tac x=cc in allE, erule impE, assumption, erule exE)
               apply (simp add: singleVal_def)
               apply (rule twSetEmpL) apply (erule ValuesRepresented_notin_DOM) apply simp
             apply (simp add: singleVal_def)
                 apply (rule twSetEmp) apply (erule ValuesRepresented_notin_DOM) apply (erule ValuesRepresented_notin_DOM)
    apply (simp add: singleVal_def)
    apply (rule twSet_Triv9)
      apply (erule twSet_Triv10)
        apply (rule SetTriv101)
          apply (erule_tac S=T' and \<Gamma>=\<Delta>' and H=K'Ka and N=N'Na in Ren_ValuesRepresented2) apply assumption 
                   apply (simp add: welldef_def) apply (simp add: welldef_def)
                   apply (simp add: Renames_STATE_def) apply assumption apply simp apply (erule AL_domI)
          apply clarsimp
          apply (subgoal_tac "cc=d", clarsimp) 
          apply (erule disjE)
            apply (erule disjE)
              apply (erule_tac f=fa and A="dom fa" in inj_onD, simp) apply (erule domI) apply (erule domI)
            apply clarsimp apply (drule_tac X="AL_dom gN'" and x=c and y=c in SetTriv106)
                             apply (erule thin_rl, simp add: renState_def, (erule conjE)+)
                               apply (drule_tac N=N' in MapN_dom, simp add: Img_def) apply (rule_tac x=d in exI, clarsimp)
                               apply (erule ranI)
                             apply simp
            apply (erule disjE)
              apply clarsimp apply (drule_tac X="AL_dom gN'" and x=c and y=c in SetTriv106)
                             apply (erule thin_rl, simp add: renState_def, (erule conjE)+)
                               apply (drule_tac N=N' in MapN_dom, simp add: Img_def) apply (rule_tac x=cc in exI, clarsimp)
                               apply (erule ranI)
                             apply simp
            apply clarsimp 
            apply (erule_tac x=cc and y=d and A="dom g - dom f" in inj_onD, simp)
              apply (clarsimp, rule, erule domI) apply clarsimp apply (drule_tac m=f in ranI) apply simp 
              apply (clarsimp, rule, erule domI) apply clarsimp apply (drule_tac m=f in ranI) apply simp
      apply (rule SetTriv101)
        apply (erule_tac S=S' and \<Gamma>=\<Gamma>' and  N=N'Na and H=H'Ha in Ren_ValuesRepresented2) apply assumption 
                 apply (simp add: welldef_def) apply (simp add: welldef_def) 
                 apply (simp add: Renames_STATE_def) apply assumption apply simp apply (erule AL_domI)
          apply clarsimp 
          apply (subgoal_tac "cc=d", clarsimp) 
          apply (erule disjE)
            apply (erule disjE)
              apply (erule_tac f=fa and A="dom fa" in inj_onD, simp) apply (erule domI) apply (erule domI)
            apply clarsimp apply (drule_tac X="AL_dom gN'" and x=c and y=c in SetTriv106)
                             apply (erule thin_rl, simp add: renState_def, (erule conjE)+)
                               apply (drule_tac N=N' in MapN_dom, simp add: Img_def) apply (rule_tac x=d in exI, clarsimp)
                               apply (erule ranI)
                             apply simp
            apply (erule disjE)
              apply clarsimp apply (drule_tac X="AL_dom gN'" and x=c and y=c in SetTriv106)
                             apply (erule thin_rl, simp add: renState_def, (erule conjE)+)
                               apply (drule_tac N=N' in MapN_dom, simp add: Img_def) apply (rule_tac x=cc in exI, clarsimp)
                               apply (erule ranI)
                             apply simp
            apply clarsimp 
            apply (erule_tac x=cc and y=d and A="dom g - dom f" in inj_onD, simp)
              apply (clarsimp, rule, erule domI) apply clarsimp apply (drule_tac m=f in ranI) apply simp 
              apply (clarsimp, rule, erule domI) apply clarsimp apply (drule_tac m=f in ranI) apply simp
done

lemma Ren_Aux:
"\<lbrakk>renState ((S, \<Gamma>, H), N, T, \<Delta>, K) f ((fS, f\<Gamma>, fH), fN, fT, f\<Delta>, fK); renState ((S', \<Gamma>', H'), N', T', \<Delta>', K') g ((gS', g\<Gamma>', gH'), gN', gT', g\<Delta>', gK');
        sat ([v], emp, h) ([w], emp, k) ((S', \<Gamma>', H'Ha), N'Na, T', \<Delta>', K'Ka) I1 J1;
        \<forall>c. c \<in> AL_dom N_Na \<longrightarrow>
            Invariant c (S', \<Gamma>', H'Ha) ([v], emp, h) I1 N_Na (S, \<Gamma>, H_Ha) (ops1, s1, h1) (map_compose I (f ++ fa)) \<and>
            Invariant c (T', \<Delta>', K'Ka) ([w], emp, k) J1 N_Na (T, \<Delta>, K_Ka) (ops2, s2, h2) (map_compose J (f ++ fa));
        (Na, g ++ fa, NN) \<in> MapN; \<forall>c. c \<in> AL_dom N' \<longrightarrow> (g ++ fa) c = g c; contained N_Na N'Na; (Ha, g ++ fa, HH) \<in> MapHP; HP_good H' (AL_dom N');
        (H', g ++ fa, gH') \<in> MapHP; (Ka, g ++ fa, KK) \<in> MapHP; HP_good K' (AL_dom N'); (K', g ++ fa, gK') \<in> MapHP;
        \<forall>c fc. f c = Some fc \<longrightarrow> g c = Some fc; inj_on g (dom g - dom f); Img g (dom g - dom f) \<inter> Img g (dom f) = {}; contained N N'; contained fN gN';
        AL_dom H \<subseteq> AL_dom H'; AL_dom K \<subseteq> AL_dom K'; AL_dom fH \<subseteq> AL_dom gH'; AL_dom fK \<subseteq> AL_dom gK'; fH_HH \<in> AL; gH'HH \<in> AL; fK_KK \<in> AL; gK'KK \<in> AL; fN_NN \<in> AL;
        gN'NN \<in> AL; AL_sum fH HH fH_HH; AL_sum gH' HH gH'HH; AL_sum fK KK fK_KK; AL_sum gK' KK gK'KK; AL_sum fN NN fN_NN; AL_sum gN' NN gN'NN;
        AL_dom fH \<inter> AL_dom HH = {}; AL_dom gH' \<inter> AL_dom HH = {}; AL_dom fN \<inter> ran fa = {}; AL_dom fK \<inter> AL_dom KK = {}; AL_dom gN' \<inter> ran fa = {};
        AL_dom gK' \<inter> AL_dom KK = {}; AL_dom Na = dom fa; AL_dom NN = ran fa; dom fa \<inter> AL_dom N' = {}; inj_on fa (dom fa); (N, f ++ fa, fN) \<in> MapN; AL_sum N Na N_Na;
        N_Na \<in> AL; (N_Na, f ++ fa, ffa_N_Na) \<in> MapN; AL_sum fN NN ffa_N_Na; sat (ops1, s1, h1) (ops2, s2, h2) ((fS, f\<Gamma>, fH_HH), ffa_N_Na, fT, f\<Delta>, fK_KK) I J;
        HP_good HH (AL_dom ffa_N_Na); (Ha, f ++ fa, HH) \<in> MapHP; Ha \<in> AL; AL_dom Ha \<subseteq> ObjIDs N_Na; inj_on (f ++ fa) (AL_dom Ha); HP_good Ha (AL_dom N_Na);
        HPdom_is Ha (f ++ fa) HH N_Na; AL_dom H' \<inter> AL_dom Ha = {}; AL_dom H \<inter> AL_dom Ha = {}; AL_sum H Ha H_Ha; HP_good KK (AL_dom ffa_N_Na);
        (Ka, f ++ fa, KK) \<in> MapHP; Ka \<in> AL; AL_dom Ka \<subseteq> ObjIDs N_Na; inj_on (f ++ fa) (AL_dom Ka); HP_good Ka (AL_dom N_Na); HPdom_is Ka (f ++ fa) KK N_Na;
        AL_dom K' \<inter> AL_dom Ka = {}; AL_dom K \<inter> AL_dom Ka = {}; AL_sum K Ka K_Ka; Na \<in> AL; NN \<in> AL; AL_dom H \<subseteq> ObjIDs N; AL_dom K \<subseteq> ObjIDs N;
        (H, f ++ fa, fH) \<in> MapHP; (H_Ha, f ++ fa, fH_HHmap) \<in> MapHP; AL_sum fH HH fH_HHmap; (K, f ++ fa, fK) \<in> MapHP; (K_Ka, f ++ fa, fK_KKmap) \<in> MapHP;
        AL_sum fK KK fK_KKmap; AL_sum K' Ka K'Ka; K'Ka \<in> AL; AL_sum H' Ha H'Ha; H'Ha \<in> AL; AL_dom N' \<inter> AL_dom Na = {}; AL_sum N' Na N'Na; N'Na \<in> AL;
        renState ((S, \<Gamma>, H_Ha), N_Na, T, \<Delta>, K_Ka) (f ++ fa) ((fS, f\<Gamma>, fH_HHmap), ffa_N_Na, fT, f\<Delta>, fK_KKmap); inj_on (f ++ fa) (ObjIDs N_Na)\<rbrakk>
       \<Longrightarrow> sat ([v], emp, h) ([w], emp, k) ((gS', g\<Gamma>', gH'HH), gN'NN, gT', g\<Delta>', gK'KK) (map_compose I1 (Invv (g ++ fa))) (map_compose J1 (Invv (g ++ fa))) \<and>
          (\<forall>c. c \<in> AL_dom fN_NN \<longrightarrow>
               Invariant c (gS', g\<Gamma>', gH'HH) ([v], emp, h) (map_compose I1 (Invv (g ++ fa))) fN_NN (fS, f\<Gamma>, fH_HH) (ops1, s1, h1) I \<and>
               Invariant c (gT', g\<Delta>', gK'KK) ([w], emp, k) (map_compose J1 (Invv (g ++ fa))) fN_NN (fT, f\<Delta>, fK_KK) (ops2, s2, h2) J)"
apply (frule_tac fN=gN' and fM=NN and N=N' and NM=N'Na in MapN_sum) 
  apply assumption
  apply assumption
  apply clarsimp 
    apply (erule disjE) 
      apply (subgoal_tac "x:AL_dom Na", frule_tac d=x and H=Na in AL_domD, erule exE)      
      apply (frule_tac f="g++fa" in MapN_D_left, assumption) apply clarsimp
      apply (erule disjE) 
        apply (subgoal_tac "y:AL_dom Na", frule_tac d=y and H=Na in AL_domD, erule exE)
        apply (drule_tac A="dom fa" and x=x and y=y in inj_onD, simp) apply (erule domI) apply (erule domI) apply simp
        apply clarsimp
      apply clarsimp
        apply (subgoal_tac "y:AL_dom N'") prefer 2 apply (simp add: AL_sum_def) apply (erule disjE, assumption) apply clarsimp
        apply (drule_tac d=y and H=N' in AL_domD, erule exE) 
          apply (subgoal_tac "(N',g,gN'):MapN") prefer 2 apply (simp add: renState_def)
          apply (frule_tac f=g and c=y in MapN_D_left, assumption) apply clarsimp 
          apply (drule_tac X="AL_dom gN'" in SetTriv106) apply (erule AL_domI) apply (erule ranI) apply simp
        apply clarsimp
      apply clarsimp
        apply (subgoal_tac "x:AL_dom N'") prefer 2 apply (simp add: AL_sum_def) apply (erule disjE, assumption) apply clarsimp
        apply (drule_tac d=x and H=N' in AL_domD, erule exE) 
        apply (subgoal_tac "(N',g,gN'):MapN") prefer 2 apply (simp add: renState_def)
        apply (frule_tac f=g and c=x in MapN_D_left, assumption) apply clarsimp 
        apply (erule disjE)
          apply (drule_tac X="AL_dom gN'" in SetTriv106) apply (erule AL_domI) apply (erule ranI) apply simp
        apply clarsimp
        apply (subgoal_tac "y:AL_dom N'") prefer 2 apply (simp add: AL_sum_def) apply (erule disjE, assumption) apply clarsimp
        apply (drule_tac d=y and H=N' in AL_domD, erule exE) 
        apply (frule_tac f=g and c=y in MapN_D_left, assumption) apply clarsimp 
        apply (frule_tac x=x in AL_sum3, assumption)
        apply (frule_tac x=y in AL_sum3, assumption)
        apply simp
  apply (simp add: AL_sum_def, clarsimp)
    apply rule apply (subgoal_tac "(N',g,gN'):MapN") prefer 2 apply (simp add: renState_def)
               apply (drule_tac N=N' in MapN_domf) apply (erule_tac Y=" dom g" in SetTriv101) apply fast
         apply fast
  apply (subgoal_tac "(N',g,gN'):MapN") prefer 2 apply (simp add: renState_def)
    apply (erule MapN_extend_f)
    apply (subgoal_tac "fa x = None", simp add: map_add_def)
    apply (case_tac "x:dom fa")
      apply (drule_tac X="dom fa" in SetTriv106) apply assumption apply assumption apply simp
    apply clarsimp 
apply (subgoal_tac "inj_on (g++fa) (ObjIDs N'Na)")
prefer 2 apply (erule thin_rl) apply (simp add: renState_def, clarsimp)
         apply (erule inj_on_MapN_sum) apply assumption+
apply (erule exE, rename_tac gfa_N'Na, erule conjE)
apply (drule_tac NM=H'Ha and fM=HH and f="g++fa" and fN=gH' and X="AL_dom N'Na" in MapHP_sum) 
  apply assumption
  apply assumption
  apply assumption
  apply (erule HP_good_subset, rule contained_refl) apply (erule AL_sum3b)
  apply (erule HP_good_subset, rule contained_refl) apply (simp add: AL_sum_def) 
      apply rule apply (rule SetTriv101) apply (erule contained5) apply fast 
                 apply fast
  apply (erule MapN_domf)
  apply (erule MapHP_domf)
  apply (erule MapHP_domf)
  apply (erule_tac X="ObjIDs N'Na" in inj_on_subset) 
    apply (erule SetTriv101) apply (erule contained_ObjIds_subset) 
  apply (erule_tac X="ObjIDs N'Na" in inj_on_subset)
     apply (rule_tac Y="ObjIDs N'" in SetTriv101) apply (simp add: renState_def State_noDangColours_def) 
    apply (rule contained_ObjIds_subset) apply (simp add: AL_sum_def)
  apply (rule, rule, clarsimp)
    apply (simp add: Img_def, clarsimp)
    apply (subgoal_tac "s:AL_dom N'")
    prefer 2 apply (erule_tac X="AL_dom H'" in SetTriv) apply (simp add: renState_def State_noDangColours_def, clarsimp)
                                  apply (drule_tac x=xa and X="AL_dom H'" in SetTriv, assumption)  apply clarsimp
    apply (case_tac "s:AL_dom Na") apply (drule_tac X="dom fa" and x=s and y=s in SetTriv106) apply clarsimp
                                     apply assumption apply simp
    apply (subgoal_tac "fa s = None", clarsimp) prefer 2 apply clarsimp
    apply (erule disjE) 
      apply (drule_tac X="AL_dom gN'" and x=x and y=x in SetTriv106) 
        apply (simp add: renState_def, (erule conjE)+) apply (drule_tac N=N' in MapN_dom) 
          apply (simp add: Img_def) apply (rule_tac x=s in exI, simp) 
        apply (erule ranI) 
        apply simp 
    apply clarsimp apply (drule_tac A="ObjIDs N'Na" and x=s and y=sa in inj_onD, simp) apply (simp add: map_add_def) 
                     apply (erule SetTriv) apply (rule_tac Y="ObjIDs N'" in SetTriv101) 
                                             apply (simp add: renState_def State_noDangColours_def)
                                           apply (rule contained_ObjIds_subset) apply (simp add: AL_sum_def) 
                     apply (erule SetTriv) apply (erule SetTriv101) apply (erule contained_ObjIds_subset) 
                     apply clarsimp
                       apply (drule_tac X="AL_dom H'" in SetTriv106) apply assumption apply assumption apply simp
   apply fast
apply (erule exE, rename_tac gfa_H'Ha, erule conjE)
apply (drule_tac NM=K'Ka and fM=KK and f="g++fa" and fN=gK' and X="AL_dom N'Na" in MapHP_sum) 
  apply assumption
  apply assumption
  apply assumption
  apply (erule HP_good_subset, rule contained_refl) apply (erule AL_sum3b)
  apply (erule HP_good_subset, rule contained_refl) apply (simp add: AL_sum_def) 
      apply rule apply (rule SetTriv101) apply (erule contained5) apply fast 
                 apply fast
  apply (erule MapN_domf)
  apply (erule MapHP_domf)
  apply (erule MapHP_domf)
  apply (erule_tac X="ObjIDs N'Na" in inj_on_subset) 
    apply (erule SetTriv101) apply (erule contained_ObjIds_subset) 
  apply (erule_tac X="ObjIDs N'Na" in inj_on_subset)
     apply (rule_tac Y="ObjIDs N'" in SetTriv101) apply (simp add: renState_def State_noDangColours_def) 
    apply (rule contained_ObjIds_subset) apply (simp add: AL_sum_def)
  apply (rule, rule, clarsimp)
    apply (simp add: Img_def, clarsimp)
    apply (subgoal_tac "s:AL_dom N'")
    prefer 2 apply (erule_tac X="AL_dom K'" in SetTriv) apply (simp add: renState_def State_noDangColours_def, clarsimp)
                                  apply (drule_tac x=xa and X="AL_dom K'" in SetTriv, assumption) apply clarsimp
    apply (case_tac "s:AL_dom Na") apply (drule_tac X="dom fa" and x=s and y=s in SetTriv106) apply clarsimp
                                     apply assumption apply simp
    apply (subgoal_tac "fa s = None", clarsimp) prefer 2 apply clarsimp
    apply (erule disjE) 
      apply (drule_tac X="AL_dom gN'" and x=x and y=x in SetTriv106) 
        apply (simp add: renState_def, (erule conjE)+) apply (drule_tac N=N' in MapN_dom) 
          apply (simp add: Img_def) apply (rule_tac x=s in exI, simp) 
        apply (erule ranI) 
        apply simp 
    apply clarsimp apply (drule_tac A="ObjIDs N'Na" and x=s and y=sa in inj_onD, simp) apply (simp add: map_add_def) 
                     apply (erule SetTriv) apply (rule_tac Y="ObjIDs N'" in SetTriv101) 
                                             apply (simp add: renState_def State_noDangColours_def)
                                           apply (rule contained_ObjIds_subset) apply (simp add: AL_sum_def) 
                     apply (erule SetTriv) apply (erule SetTriv101) apply (erule contained_ObjIds_subset) 
                     apply clarsimp
                       apply (drule_tac X="AL_dom K'" in SetTriv106) apply assumption apply assumption apply simp
   apply fast
apply (erule exE, rename_tac gfa_K'Ka, erule conjE)

apply (subgoal_tac "welldef ((gS', g\<Gamma>', gfa_H'Ha), gfa_N'Na, gT', g\<Delta>', gfa_K'Ka)")
prefer 2 (*apply (rotate_tac -16)*) apply (rotate_tac 3) apply(erule thin_rl) 
           apply (simp add: sat_def welldef_def, clarsimp)
           apply (rule, rule_tac f="g++fa" in Ren_State_welldef2) apply assumption apply assumption 
             apply (simp add: renState_def Renames_STATE_def, (erule conjE)+)
             apply (rule, erule_tac Y="AL_dom N'" in MAP_OPSTACK_Fun_eqOn[rule_format])
               apply (erule_tac x=c in allE, erule mp, clarsimp)
               apply (simp add: State_noDangColours_def)
             apply (erule_tac Y="AL_dom N'" in MAP_STORE_Fun_eqOn[rule_format])
               apply (erule_tac x=c in allE, erule mp, clarsimp)
               apply (simp add: State_noDangColours_def)
             (*"inj_on (g++fa) (ObjIDs N'Na)")*) apply assumption 
           apply (rule_tac S=T' and f="g++fa" in Ren_State_welldef2) apply assumption apply assumption 
             apply (simp add: renState_def Renames_STATE_def, (erule conjE)+)
             apply (rule, erule_tac Y="AL_dom N'" in MAP_OPSTACK_Fun_eqOn[rule_format])
               apply (erule_tac x=c in allE, erule mp, clarsimp)
               apply (simp add: State_noDangColours_def)
             apply (erule_tac Y="AL_dom N'" in MAP_STORE_Fun_eqOn[rule_format])
               apply (erule_tac x=c in allE, erule mp, clarsimp)
               apply (simp add: State_noDangColours_def)
             (*"inj_on (g++fa) (ObjIDs N'Na)")*) apply assumption 
apply (subgoal_tac "contained ffa_N_Na gfa_N'Na")
prefer 2 apply (simp (no_asm) add: contained_def,  clarsimp)
         apply (drule AL_sum_split, assumption)
         apply (erule disjE) apply (erule AL_sum3) apply (erule contained3, assumption)
                             apply (erule AL_sum4, assumption)
apply (subgoal_tac "sat ([v], emp, h) ([w], emp, k) ((gS', g\<Gamma>', gfa_H'Ha), gfa_N'Na, (gT', g\<Delta>', gfa_K'Ka)) 
                    (map_compose I1 (Invv (g ++ fa))) (map_compose J1 (Invv (g ++ fa)))")
prefer 2 apply (simp add: sat_def)
  apply rule apply (simp add: welldef_def, clarsimp)
     apply (rule_tac S=S and \<Gamma>=\<Gamma> and H=H and N=N and f=f and fS=fS and f\<Gamma>=f\<Gamma> and fH=fH and fN=fN and 
                      S'=S' and \<Gamma>'=\<Gamma>' and H'=H' and N'=N' and g=g and gS'=gS' and g\<Gamma>'=g\<Gamma>' and gH'=gH' and gN'=gN' and 
                      fa=fa and NN=NN and gN'NN=gN'NN and fN_NN=fN_NN and fH_HH=fH_HH and gH'_HH=gH'HH and
                      I=I in RenAuxStateSatisfiesAbstraction) 
             apply (simp add: renState_def renUniState_def)
             apply (simp add: renState_def renUniState_def)
             apply assumption+
             apply (simp add: renState_def State_noDangColours_def State_good_def) 
             apply assumption+ apply clarsimp
  apply rule apply (simp add: welldef_def, clarsimp)
     apply (rule_tac S=T and \<Gamma>=\<Delta> and H=K and N=N and f=f and fS=fT and f\<Gamma>=f\<Delta> and fH=fK and fN=fN and 
                      S'=T' and \<Gamma>'=\<Delta>' and H'=K' and N'=N' and g=g and gS'=gT' and g\<Gamma>'=g\<Delta>' and gH'=gK' and gN'=gN' and 
                      fa=fa and NN=NN and gN'NN=gN'NN and fN_NN=fN_NN and fH_HH=fK_KK and gH'_HH=gK'KK and
                      I=J in RenAuxStateSatisfiesAbstraction) 
             apply (simp add: renState_def renUniState_def)
             apply (simp add: renState_def renUniState_def)
             apply assumption+ 
             apply (simp add: renState_def State_noDangColours_def State_good_def)
             apply assumption+ apply clarsimp
  apply clarsimp apply (frule MapN_D_right, assumption) apply (erule exE, rename_tac cc, erule conjE)
    apply (erule_tac fH_HH=fH_HH and fK_KK=fK_KK and gH'HH=gH'HH and gK'KK=gK'KK and fN_NN=fN_NN and gN'NN=gN'NN 
            and fK_KKmap=fK_KKmap and fH_HHmap=fH_HHmap and ffa_N_Na=ffa_N_Na and gfa_N'Na=gfa_N'Na and gfa_H'Ha=gfa_H'Ha and gfa_K'Ka=gfa_K'Ka 
                and H_Ha=H_Ha and K_Ka=K_Ka and N_Na=N_Na in SV) 
       apply (assumption, assumption, assumption, assumption, assumption) 
       apply (assumption, assumption, assumption, assumption, assumption)
       apply (assumption, assumption, assumption, assumption, assumption)
       apply (assumption, assumption, assumption, assumption, assumption)
       apply (assumption, assumption, assumption, assumption, assumption)
       apply (assumption, assumption, assumption, assumption, assumption)
       apply (assumption, assumption, assumption, assumption, assumption)
       apply (assumption, assumption, assumption, assumption, assumption)
       apply (assumption, assumption, assumption, assumption, assumption)
       apply (assumption, assumption, assumption, assumption, assumption)
       apply (assumption, assumption, assumption, assumption, assumption)
       apply assumption
apply rule
  apply (rule sat_leftHPextensional)
    apply (rule sat_symm)
    apply (rule sat_leftHPextensional)
      apply (rule sat_symm) apply (erule sat_MPextensional) apply (erule AL_sum_extensional, assumption) apply assumption
    apply (erule AL_sum_extensional, assumption) apply assumption
  apply (erule AL_sum_extensional, assumption) apply assumption
(*Invariant*)
apply clarsimp
apply (subgoal_tac "AL_dom N_Na = dom (f++fa)")
prefer 2 apply (rotate_tac 1, erule thin_rl, simp add: renState_def)
apply rule
  apply (subgoal_tac "Invariant c (gS', g\<Gamma>', gfa_H'Ha) ([v], emp, h) (map_compose I1 (Invv (g ++ fa))) ffa_N_Na (fS, f\<Gamma>, fH_HHmap) (ops1, s1, h1) I")
  apply (erule Invariant_HPMP_extensional) 
    apply (erule AL_sum_extensional, assumption) 
    apply (erule AL_sum_extensional, assumption) 
    apply (erule AL_sum_extensional, assumption)
    apply (erule MapN_AL_Aux1)
    apply (erule MapHP_AL_right)
    apply (erule MapHP_AL_right)
  apply (rule_tac f="f++fa" and bj=fH and ap=N'Na in Ren_Invariant) 
    apply clarsimp apply (erule disjE) apply (simp add: map_add_def) apply (simp add: map_add_def)
    apply (simp (no_asm) add: inj_on_def, clarsimp)
      apply (erule disjE) apply clarsimp
      apply (erule disjE, clarsimp)
      apply clarsimp apply (simp add: map_add_def)
        apply (erule_tac A="(dom g - dom f)" and x=x and y=y in inj_onD, simp)
          apply clarsimp apply (rule, clarsimp) apply clarsimp
          apply clarsimp apply (rule, clarsimp) apply clarsimp
    apply (simp add: Img_def)
      apply (rule, rule, clarsimp) 
        apply (erule disjE, clarsimp)
        apply (erule disjE, clarsimp) apply (drule_tac X="AL_dom gN'" and x=x and y=x in SetTriv106)
                                        apply (erule thin_rl, simp add: renState_def, (erule conjE)+) 
                                        apply (drule_tac N=N' in MapN_dom, simp add: Img_def) apply (rule_tac x=s in exI, clarsimp)
                                       apply (erule ranI)
                                      apply simp
        apply (erule disjE, clarsimp) apply (drule_tac X="AL_dom gN'" and x=x and y=x in SetTriv106)
                                        apply (erule thin_rl, simp add: renState_def, (erule conjE)+) 
                                        apply (drule_tac N=N' in MapN_dom, simp add: Img_def) apply (rule_tac x=s in exI, clarsimp)
                                       apply (erule ranI)
                                      apply simp
        apply clarsimp
          apply (case_tac "s:dom f", clarsimp) 
          apply (drule_tac X="{x. \<exists>s. s \<in> dom g \<and> s \<notin> dom f \<and> g s = Some x}" and x=x and y=x in SetTriv106)
            apply clarsimp apply (rotate_tac -1, erule_tac x=s in allE, clarsimp) apply (erule impE, clarsimp) apply clarsimp
            apply clarsimp apply (rotate_tac -1, erule_tac x=sa in allE, clarsimp) 
            apply clarsimp
     apply fast
  apply (rule, rule) apply (erule_tac x=ca in allE, erule impE) apply clarsimp 
    apply (erule conjE, assumption)
  apply assumption
  apply (simp add: sat_def welldef_def) 
  apply assumption
  apply assumption
  apply assumption
  apply (simp add: Renames_STATE_def) 
    apply rule apply (erule thin_rl, simp add: renState_def Renames_STATE_def, (erule conjE)+) 
                 apply (erule_tac Y="AL_dom N'" in MAP_OPSTACK_Fun_eqOn[rule_format])
                 apply (erule_tac x=ca in allE, erule mp) apply clarsimp
                 apply (simp add: State_noDangColours_def)
    apply (erule thin_rl, simp add: renState_def Renames_STATE_def, (erule conjE)+) 
                 apply (erule_tac Y="AL_dom N'" in MAP_STORE_Fun_eqOn[rule_format])
                 apply (erule_tac x=ca in allE, erule mp, clarsimp)
                 apply (simp add: State_noDangColours_def)
  apply assumption
  apply (erule thin_rl, simp add: renState_def AL_sum_def) apply fast
    apply (subgoal_tac "AL_dom ffa_N_Na = Img (f++fa) (dom (f++fa))", simp only: Img_dom_ran [of "f++fa"]) 
    apply (drule_tac N=N_Na in MapN_dom) apply clarsimp
  apply (erule thin_rl, simp add: renState_def AL_sum_def) 
    apply (subgoal_tac "AL_dom gfa_N'Na = Img (g++fa) (dom (g++fa))", simp only: Img_dom_ran [of "g++fa"]) 
    apply (drule_tac N=N'Na in MapN_dom) apply (subgoal_tac "AL_dom N'Na =dom (g ++ fa)") apply clarsimp apply clarsimp apply fast
  apply assumption
  apply assumption
  apply assumption
  apply (erule MapN_AL_Aux1)
  apply assumption
  apply assumption
  apply (simp add: welldef_def)
  apply (simp add: renState_def)
  apply (simp add: renState_def, (erule conjE)+)
    apply (erule_tac L=ffa_N_Na in Ren_State_welldef)  apply (simp add: sat_def welldef_def, (erule conjE)+)
      apply (erule State_welldef_HPextensional) apply (erule AL_sum_extensional, assumption)
      apply (erule MapHP_AL_right)
    apply assumption
    apply assumption
    apply assumption
    apply (simp add: AL_sum_def renState_def) apply (erule disjE, clarsimp) 
      apply (drule_tac N=N and f=f in MapN_dom, simp add: Img_def) apply clarsimp
      apply (case_tac "s:dom fa") apply (drule_tac X="dom fa" and y=s in SetTriv106)
                                    apply assumption apply clarsimp apply simp
      apply (rule_tac a=s in ranI) apply (subgoal_tac "fa s = None") apply (simp add: map_add_def) apply clarsimp
      apply (drule ranD, clarsimp) apply (rule_tac a=b in ranI) apply simp

(*second Invariant term*)
  apply (subgoal_tac "Invariant c (gT', g\<Delta>', gfa_K'Ka) ([w], emp, k) (map_compose J1 (Invv (g ++ fa))) ffa_N_Na (fT, f\<Delta>,fK_KKmap) (ops2, s2, h2) J")
  apply (erule Invariant_HPMP_extensional) 
    apply (erule AL_sum_extensional, assumption) 
    apply (erule AL_sum_extensional, assumption) 
    apply (erule AL_sum_extensional, assumption)
    apply (erule MapN_AL_Aux1)
    apply (erule MapHP_AL_right)
    apply (erule MapHP_AL_right)
  apply (rule_tac f="f++fa" and bj=fK and ap=N'Na in Ren_Invariant) 
    apply clarsimp apply (erule disjE) apply (simp add: map_add_def) apply (simp add: map_add_def)
    apply (simp (no_asm) add: inj_on_def, clarsimp)
      apply (erule disjE) apply clarsimp
      apply (erule disjE, clarsimp)
      apply clarsimp apply (simp add: map_add_def)
        apply (erule_tac A="(dom g - dom f)" and x=x and y=y in inj_onD, simp)
          apply clarsimp apply (rule, clarsimp) apply clarsimp
          apply clarsimp apply (rule, clarsimp) apply clarsimp
    apply (simp add: Img_def)
      apply (rule, rule, clarsimp) 
        apply (erule disjE, clarsimp)
        apply (erule disjE, clarsimp) apply (drule_tac X="AL_dom gN'" and x=x and y=x in SetTriv106)
                                        apply (erule thin_rl, simp add: renState_def, (erule conjE)+) 
                                        apply (drule_tac N=N' in MapN_dom, simp add: Img_def) apply (rule_tac x=s in exI, clarsimp)
                                       apply (erule ranI)
                                      apply simp
        apply (erule disjE, clarsimp) apply (drule_tac X="AL_dom gN'" and x=x and y=x in SetTriv106)
                                        apply (erule thin_rl, simp add: renState_def, (erule conjE)+) 
                                        apply (drule_tac N=N' in MapN_dom, simp add: Img_def) apply (rule_tac x=s in exI, clarsimp)
                                       apply (erule ranI)
                                      apply simp
        apply clarsimp
          apply (case_tac "s:dom f", clarsimp) 
          apply (drule_tac X="{x. \<exists>s. s \<in> dom g \<and> s \<notin> dom f \<and> g s = Some x}" and x=x and y=x in SetTriv106)
            apply clarsimp apply (rotate_tac -1, erule_tac x=s in allE, clarsimp) apply (erule impE, clarsimp) apply clarsimp
            apply clarsimp apply (rotate_tac -1, erule_tac x=sa in allE, clarsimp) 
            apply clarsimp
     apply fast
  apply (rule, rule) apply (erule_tac x=ca in allE, erule impE) apply clarsimp 
    apply (erule conjE, assumption)
  apply assumption
  apply (simp add: sat_def welldef_def) 
  apply assumption
  apply assumption
  apply assumption
  apply (simp add: Renames_STATE_def) 
    apply rule apply (erule thin_rl, simp add: renState_def Renames_STATE_def, (erule conjE)+) 
                 apply (erule_tac Y="AL_dom N'" in MAP_OPSTACK_Fun_eqOn[rule_format])
                 apply (erule_tac x=ca in allE, erule mp) apply clarsimp
                 apply (simp add: State_noDangColours_def)
    apply (erule thin_rl, simp add: renState_def Renames_STATE_def, (erule conjE)+) 
                 apply (erule_tac Y="AL_dom N'" in MAP_STORE_Fun_eqOn[rule_format])
                 apply (erule_tac x=ca in allE, erule mp, clarsimp)
                 apply (simp add: State_noDangColours_def)
  apply assumption
  apply (erule thin_rl, simp add: renState_def AL_sum_def) apply fast
    apply (subgoal_tac "AL_dom ffa_N_Na = Img (f++fa) (dom (f++fa))", simp only: Img_dom_ran [of "f++fa"]) 
    apply (drule_tac N=N_Na in MapN_dom) apply clarsimp
  apply (erule thin_rl, simp add: renState_def AL_sum_def) 
    apply (subgoal_tac "AL_dom gfa_N'Na = Img (g++fa) (dom (g++fa))", simp only: Img_dom_ran [of "g++fa"]) 
    apply (drule_tac N=N'Na in MapN_dom) apply (subgoal_tac "AL_dom N'Na =dom (g ++ fa)") apply clarsimp apply clarsimp apply fast
  apply assumption
  apply assumption
  apply assumption
  apply (erule MapN_AL_Aux1)
  apply assumption
  apply assumption
  apply (simp add: welldef_def)
  apply (simp add: renState_def)
  apply (simp add: renState_def, (erule conjE)+)
    apply (erule_tac L=ffa_N_Na in Ren_State_welldef)  apply (simp add: sat_def welldef_def, (erule conjE)+)
      apply (erule State_welldef_HPextensional) apply (erule AL_sum_extensional, assumption)
      apply (erule MapHP_AL_right)
    apply assumption
    apply assumption
    apply assumption
    apply (simp add: AL_sum_def renState_def) apply (erule disjE, clarsimp) 
      apply (drule_tac N=N and f=f in MapN_dom, simp add: Img_def) apply clarsimp
      apply (case_tac "s:dom fa") apply (drule_tac X="dom fa" and y=s in SetTriv106)
                                    apply assumption apply clarsimp apply simp
      apply (rule_tac a=s in ranI) apply (subgoal_tac "fa s = None") apply (simp add: map_add_def) apply clarsimp
      apply (drule ranD, clarsimp) apply (rule_tac a=b in ranI) apply simp
done

lemma renState_renUniState:
"renState (\<Sigma>, N, \<Pi>) f (\<Sigma>', N', \<Pi>') = (renUniState (\<Sigma>, N) f (\<Sigma>', N') \<and> renUniState (\<Pi>,N) f (\<Pi>',N'))"
apply (simp add: renState_def renUniState_def) apply fast
done

lemma renState_preserved:
  "\<lbrakk> renState \<gamma> f \<gamma>'; renState \<delta> g \<delta>'; preserved \<gamma> \<delta>; \<forall>c fc. f c = Some fc \<longrightarrow> g c = Some fc; 
     inj_on g (dom g - dom f); Img g (dom g - dom f) \<inter> Img g (dom f) = {}\<rbrakk>
  \<Longrightarrow> preserved \<gamma>' \<delta>'"
apply (case_tac \<gamma>, clarsimp)
apply (case_tac \<delta>, clarsimp)
apply (case_tac \<gamma>', clarsimp)
apply (case_tac \<delta>', clarsimp)
apply (simp add: renState_renUniState, clarsimp)
apply (simp add: preserved_def, clarsimp)
apply (drule_tac \<Sigma>="(a, aa, b)" and \<Pi>="(ae, af, bb)" in renUniState_preserved)
  apply assumption+ apply clarsimp apply assumption
apply (drule_tac \<Sigma>="(ac, ad, ba)" and \<Pi>="(ah, ai, bc)" in renUniState_preserved)
  apply assumption+ apply clarsimp apply assumption
apply clarsimp
done

lemma Ren_sat:
  "\<lbrakk>  sat s t \<gamma> I J;  renState \<delta> f \<gamma>; inj_on f (ObjIDs (fst(snd \<delta>)))\<rbrakk>
  \<Longrightarrow> sat s t \<delta> (map_compose I f) (map_compose J f)"
apply (simp add: sat_def renState_def, clarsimp)
apply (case_tac \<delta>, clarsimp)
apply (case_tac \<gamma>, clarsimp)
apply (subgoal_tac "welldef ((a, aa, b), ab, ac, ad, ba)", simp)
prefer 2 apply (simp add: welldef_def, clarsimp)
  apply (rule, erule Ren_State_welldef) apply assumption apply assumption apply assumption apply assumption
  apply (erule Ren_State_welldef) apply assumption apply assumption apply assumption apply assumption
apply (rule, erule Ren_StateStateAbstr) apply assumption apply assumption apply assumption 
    apply (simp add: welldef_def) apply assumption apply simp
apply (rule, erule Ren_StateStateAbstr) apply assumption apply assumption apply assumption 
    apply (simp add: welldef_def) apply assumption apply simp
apply clarsimp
  apply (frule MapN_D_left, assumption, clarsimp) 
  apply (erule_tac x=fc in allE, erule impE, assumption)
  apply (erule impE) 
    apply rule
      apply (rule_tac X="Img f  (DOM  (a, aa, b))" in SetTriv) apply (simp add: Img_def)  apply (rule_tac x=c in exI, simp)
      apply (erule Renames_STATE_DOM2)
        apply (erule inj_on_subset) apply (simp add: welldef_def, (erule conjE)+) apply (erule State_welldef_D_Heap_ObjIDs)
    apply (rule_tac X="Img f  (DOM  (ac, ad, ba))" in SetTriv) apply (simp add: Img_def)  apply (rule_tac x=c in exI, simp)
      apply (erule Renames_STATE_DOM2)
       apply (erule inj_on_subset) apply (simp add: welldef_def, (erule conjE)+) apply (erule State_welldef_D_Heap_ObjIDs)
  apply (simp add: singleVal_def)
  apply (rule twSet_Triv9)
    apply (erule twSet_Triv10)
    apply (erule Ren_ValuesRepresented) apply assumption apply (simp add: welldef_def) apply assumption apply assumption
  apply (erule Ren_ValuesRepresented) apply assumption apply (simp add: welldef_def) apply assumption apply assumption
done

lemma RenSound:
  "\<lbrakk> renState \<gamma> f \<gamma>'; renState \<delta> g \<delta>';
     \<forall>c fc. f c = Some fc \<longrightarrow> g c = Some fc; 
     inj_on g (dom g - dom f); Img g (dom g - dom f) \<inter> Img g (dom f) = {};
     SecN (Suc n) \<gamma> M l MM ll \<delta>\<rbrakk>
     \<Longrightarrow> SecN (Suc n) \<gamma>' M l MM ll \<delta>'"
apply (unfold SecN_def, (erule conjE)+)
apply (subgoal_tac "preserved \<gamma>' \<delta>'", rule, assumption)
prefer 2 apply (rotate_tac -1, erule thin_rl)
         apply (erule renState_preserved, assumption+)
apply (rule, rule, rule)
apply (erule_tac x=na in allE, erule_tac x=m in allE, erule impE, assumption)
apply (rotate_tac -2, erule thin_rl)
apply (rule allI)+
apply (rule impI)+
apply (erule_tac x=s in allE, erule_tac x=h in allE, erule_tac x=v in allE)
apply (erule_tac x=t in allE, erule_tac x=k in allE, erule_tac x=w in allE)
apply clarsimp
apply (rotate_tac -3) apply (erule thin_rl, erule thin_rl)
apply (case_tac \<gamma>', clarsimp)
apply (case_tac \<delta>', clarsimp)
apply (case_tac \<gamma>, clarsimp)
apply (case_tac \<delta>, clarsimp)
apply (simp add: RSD_sum_def preserved_def, clarsimp)
apply (rename_tac ops1 s1 h1 h v ops2 s2 h2 k w HH NN KK fH_HH fN_NN fK_KK gH'HH gN'NN gK'KK I J fS f\<Gamma> fH fN fT f\<Delta> fK gS' g\<Gamma>' gH' gN' gT' g\<Delta>' gK'  S \<Gamma> H N T \<Delta> K S' \<Gamma>' H' N' T' \<Delta>' K')
apply (drule_tac M=NN and X="AL_dom N'" in MapN_InvExists)
apply ((erule exE)+, (erule conjE)+)
apply (drule_tac N=Na and g="f++fa" in MapN_extend_f) apply clarsimp
apply (subgoal_tac "(N,f,fN):MapN") prefer 2 apply (simp add: renState_def)
apply (drule_tac N=N and g="f++fa" in MapN_extend_f) 
  apply (erule thin_rl) apply clarsimp 
  apply (drule contained6, assumption)
  apply (subgoal_tac "fa x = None", simp add: map_add_def)
  apply (case_tac "x:dom fa")
   apply (drule_tac X="dom fa" and Y="AL_dom N'" and x=x and y=x in SetTriv106) apply assumption apply assumption apply simp
  apply clarsimp
apply (subgoal_tac "AL_dom N \<inter> AL_dom Na = {}")
prefer 2 apply (rule SetTriv103) apply (erule contained5) apply (erule SetTriv108) 
apply (drule_tac N=N in AL_sum_exists_AL) apply clarsimp apply (rename_tac N_Na)
apply (frule_tac fN=fN and fM=NN in MapN_sum) 
  prefer 5 apply assumption
  prefer 2 apply assumption
  apply assumption
  apply clarsimp apply (erule thin_rl) 
    apply (simp add: AL_sum_def)
    apply (erule disjE) apply (frule_tac m=fa and a=x in domI)
      apply (erule disjE) apply (frule_tac m=fa and a=y in domI)
        apply (drule_tac A="dom fa" and x=x and y=y in inj_onD, simp) apply assumption apply assumption apply simp
      apply clarsimp apply (erule disjE) apply (drule_tac X="AL_dom fN" and x=fx and y=fx in SetTriv106)
                                           apply (simp add: renState_def, clarsimp) 
                                             apply (drule_tac N=N and f=f in MapN_dom) apply (simp add: Img_def) apply (rule_tac x=y in exI, simp) apply (erule domI)
                                           apply (erule ranI)
                                         apply simp
                     apply clarsimp
    apply clarsimp apply (erule disjE) 
                     apply (erule disjE) apply (drule_tac X="AL_dom fN" and x=fx and y=fx in SetTriv106)
                                           apply (simp add: renState_def, clarsimp) 
                                             apply (drule_tac N=N and f=f in MapN_dom) apply (simp add: Img_def) apply (rule_tac x=x in exI, simp) apply (erule domI)
                                           apply (erule ranI)
                                         apply simp
                     apply clarsimp
                   apply clarsimp 
                     apply (erule disjE) apply (drule_tac d=x in AL_domD, clarsimp)
                       apply (erule disjE) apply (drule_tac d=y in AL_domD, clarsimp) 
                                           apply (simp add: renState_def, clarsimp) 
                                           apply (frule_tac f=f and c=x in MapN_D_left, assumption) apply clarsimp
                                           apply (frule_tac f=f and c=y in MapN_D_left, assumption) apply clarsimp 
                                           apply (frule_tac NN=N_Na and c=x in contained3, assumption) 
                                           apply (frule_tac NN=N_Na and c=y in contained3, assumption) 
                                           apply simp 
                       apply clarsimp
                     apply clarsimp
  apply (erule thin_rl)
    apply (simp add: AL_sum_def, clarsimp) 
    apply (rule, simp add: renState_def, (erule conjE)+) apply fast apply fast
apply (erule exE, erule conjE) apply (rename_tac ffa_N_Na)
apply (drule_tac NN=ffa_N_Na in sat_MPextensional) 
  apply clarsimp apply rule apply (drule AL_sum_split, assumption) 
                            apply (erule disjE) 
                              apply (erule AL_sum3, assumption)
                            apply (erule AL_sum4, assumption)
                 apply (drule AL_sum_split, assumption) 
                            apply (erule disjE) 
                              apply (erule AL_sum3, assumption)
                            apply (erule AL_sum4, assumption) 
  apply (erule MapN_AL_Aux1) 
(*apply (subgoal_tac "inj_on (f ++ fa) (ObjIDs N_Na)")
prefer 2 apply (erule thin_rl)
  apply (simp add: renState_def, clarsimp)
  apply (erule inj_on_MapN_sum) apply assumption+
           apply (rule SetTriv108) apply (rule SetTriv103) prefer 2 apply (erule SetTriv108) apply clarsimp apply assumption+ *)
apply (subgoal_tac "HP_good HH (AL_dom ffa_N_Na)")
prefer 2 apply (erule thin_rl)
         apply (subgoal_tac "HP_good fH_HH (AL_dom ffa_N_Na)")
           apply (erule_tac H=fH_HH in HP_good_subset) apply (simp add: AL_sum_def) apply simp
         apply (simp add: sat_def welldef_def State_welldef_def State_good_def)
apply (subgoal_tac "inj_on (f ++ fa) (ObjIDs N_Na)")
prefer 2 apply (erule thin_rl) apply (simp add: renState_def, clarsimp)
                        apply (erule inj_on_MapN_sum) apply assumption+
                        apply (rule SetTriv108) apply (rule SetTriv103) prefer 2 apply (erule SetTriv108) 
                        apply clarsimp apply assumption+
apply (drule_tac KK=HH and f="f++fa" and NN=ffa_N_Na and N=N_Na in MapHP_ReverseExists_Full3[rule_format])
  apply (rule contained_refl)
  apply (erule MapN_domf)
  apply assumption
  apply assumption
  apply assumption
  apply (erule thin_rl) 
           apply (rule SetTriv101) apply (erule AL_sum4b) 
           apply (simp add: sat_def welldef_def, (erule conjE)+) apply (erule State_welldef_D_Heap_ObjIDs) 
apply (erule exE, (erule conjE)+)
apply (subgoal_tac "AL_dom H' \<inter> AL_dom Ha = {}")
prefer 2 apply (erule thin_rl)
         apply (rule, rule, clarsimp)
           apply (subgoal_tac "x:AL_dom N'") prefer 2 apply (simp add: renState_def Renames_STATE_def State_noDangColours_def, (erule conjE)+)
                                                      apply (drule_tac x=x and X="AL_dom H'" in SetTriv, assumption)  apply clarsimp
           apply (subgoal_tac "fa x = None") prefer 2 apply (case_tac "x:dom fa")
                                                        apply (drule_tac X="dom fa" and x=x and y=x in SetTriv106) apply assumption apply assumption apply simp
                                                      apply clarsimp
           apply (simp add: renState_def Renames_STATE_def, clarsimp)
           apply (drule AL_domD, clarsimp)
           apply (drule AL_domD, clarsimp)
           apply (drule_tac N=H' in MapHP_D_left) apply (erule_tac X="ObjIDs N'" in inj_on_subset) apply (simp add: State_noDangColours_def) apply assumption
           apply clarsimp 
           apply (drule_tac N=Ha in MapHP_D_left) apply assumption
                                                 apply assumption
           apply clarsimp 
           apply (drule_tac X="AL_dom gH'" and x=y and y=y in SetTriv106) apply (erule AL_domI) apply (erule AL_domI) apply simp
       apply fast
apply (subgoal_tac "AL_dom H \<inter> AL_dom Ha = {}")
prefer 2 apply (erule thin_rl)
         apply (erule SetTriv103, assumption)
apply (frule_tac N=H in AL_sum_exists_AL) apply (erule exE, erule conjE) apply (rename_tac H_Ha)
apply (subgoal_tac "HP_good KK (AL_dom ffa_N_Na)")
prefer 2 apply (erule thin_rl)
         apply (subgoal_tac "HP_good fK_KK (AL_dom ffa_N_Na)")
           apply (erule_tac H=fK_KK in HP_good_subset) apply (simp add: AL_sum_def) apply simp
         apply (simp add: sat_def welldef_def State_welldef_def State_good_def)
apply (drule_tac KK=KK and f="f++fa" and NN=ffa_N_Na and N=N_Na in MapHP_ReverseExists_Full3[rule_format])
  apply (rule contained_refl)
  apply (erule MapN_domf)
  apply assumption
  apply assumption
  apply assumption
  apply (erule thin_rl) 
           apply (rule SetTriv101) apply (erule AL_sum4b) 
           apply (simp add: sat_def welldef_def, (erule conjE)+) apply (erule State_welldef_D_Heap_ObjIDs) 
apply (erule exE, (erule conjE)+) apply (rename_tac Ka)
apply (subgoal_tac "AL_dom K' \<inter> AL_dom Ka = {}")
prefer 2 apply (erule thin_rl)
         apply (rule, rule, clarsimp)
           apply (subgoal_tac "x:AL_dom N'") prefer 2 apply (simp add: renState_def Renames_STATE_def State_noDangColours_def, clarsimp)
                                                      apply (drule_tac x=x and X="AL_dom K'" in SetTriv, assumption)  apply clarsimp
           apply (subgoal_tac "fa x = None") prefer 2 apply (case_tac "x:dom fa")
                                                        apply (drule_tac X="dom fa" in SetTriv106) apply assumption apply assumption apply simp
                                                      apply clarsimp
           apply (simp add: renState_def Renames_STATE_def, clarsimp)
           apply (drule AL_domD, clarsimp)
           apply (drule AL_domD, clarsimp)
           apply (drule_tac N=K' in MapHP_D_left) apply (erule_tac X="ObjIDs N'" in inj_on_subset) apply (simp add: State_noDangColours_def) apply assumption
           apply clarsimp 
           apply (drule_tac N=Ka in MapHP_D_left) apply assumption
                                                 apply assumption
           apply clarsimp 
           apply (drule_tac X="AL_dom gK'" and x=y and y=y in SetTriv106) apply (erule AL_domI) apply (erule AL_domI) apply simp
       apply fast
apply (subgoal_tac "AL_dom K \<inter> AL_dom Ka = {}")
prefer 2 apply (erule thin_rl)
         apply (erule SetTriv103, assumption)
apply (frule_tac N=K in AL_sum_exists_AL) apply (erule exE, erule conjE) apply (rename_tac K_Ka)
apply (frule_tac H=Na in  MapN_AL_Aux3, erule conjE)
apply (subgoal_tac "AL_dom H \<subseteq> ObjIDs N")
prefer 2 apply (erule thin_rl) apply (simp add: renState_def  Renames_STATE_def  State_noDangColours_def) 
apply (subgoal_tac "AL_dom K \<subseteq> ObjIDs N")
prefer 2 apply (erule thin_rl) apply (simp add: renState_def  Renames_STATE_def  State_noDangColours_def)
apply (subgoal_tac "(H, f ++ fa, fH) \<in> MapHP")
prefer 2 apply (erule thin_rl)
    apply (simp add: renState_def  Renames_STATE_def, (erule conjE)+)
    apply (erule_tac Y="AL_dom N" in MapHP_Fun_eqOn[rule_format]) apply simp
    apply (subgoal_tac "fa c = None", simp add: map_add_def) 
    apply (case_tac "c:dom fa")
      apply (drule_tac X="dom fa" and y=c in SetTriv106) 
        apply assumption 
        apply clarsimp
        apply simp
      apply clarsimp
    apply (simp add: State_noDangColours_def)
    apply (simp add: State_noDangColours_def State_good_def)
apply (erule_tac x=Ha in allE, erule_tac x=Na in allE, erule_tac x=Ka in allE)
apply clarsimp
apply (erule_tac x=H_Ha in allE, erule_tac x=N_Na in allE, erule_tac x=K_Ka in allE)
apply clarsimp
apply (drule_tac NM=H_Ha and fN=fH and X="AL_dom N_Na" in MapHP_sum) 
  apply assumption
  apply assumption
  apply assumption
  apply (rotate_tac -1, erule thin_rl) 
    apply (rule_tac H=H and X="AL_dom N" in HP_good_subset)
      apply (simp add: renState_def  Renames_STATE_def State_noDangColours_def State_good_def, clarsimp) 
      apply (rule contained_refl)
      apply (erule AL_sum3b) 
  apply assumption
  apply (erule MapN_domf)
  apply (rotate_tac -1, erule thin_rl) 
    apply (simp add: renState_def  Renames_STATE_def, (erule conjE)+) 
      apply (drule_tac H=H in MapHP_domf) apply simp (*apply (erule_tac Y="dom f" in SetTriv101) apply fast*)
  apply (erule SetTriv101) apply (rule SetTriv101) apply (rule ObjIDs_in_Dom) apply (erule MapN_domf)
  apply assumption
  apply (erule_tac X="ObjIDs N_Na" in inj_on_subset) 
      apply (erule_tac Y="ObjIDs N" in SetTriv101) 
        apply (rule contained_ObjIds_subset) apply (simp add: AL_sum_def)
  apply (rotate_tac -1, erule thin_rl)
    apply (rule, rule, simp add: Img_def, clarsimp)
      apply (subgoal_tac "s:AL_dom N'") 
      prefer 2 apply (erule contained6) apply (drule_tac x=s and Y="ObjIDs N" in SetTriv, assumption) apply (erule SetTriv, rule ObjIDs_in_Dom) 
      apply (subgoal_tac "fa s = None")
      prefer 2 apply (case_tac "s:dom fa") apply (drule_tac X="dom fa" in SetTriv106) apply assumption apply assumption apply simp
               apply clarsimp
      apply (erule disjE) apply clarsimp apply clarsimp
                          apply (subgoal_tac "s:AL_dom N", drule_tac H=N in AL_domD, clarsimp) 
                          apply (drule_tac N=N in MapN_D_left, assumption) apply clarsimp
                          apply (erule disjE) 
                            apply (drule_tac X="AL_dom fN" in SetTriv106) apply (erule AL_domI) apply (erule ranI) apply simp
                          apply clarsimp
                            apply (drule_tac X="AL_dom fH" and x=fc and y=fc in SetTriv106)
                              apply (simp add: renState_def Renames_STATE_def, (erule conjE)+) apply (drule_tac N=H in MapHP_dom)
                                apply (simp add: Img_def)  apply (rule_tac x=s in exI, simp add: map_add_def)
                              apply (drule_tac N=Ha in MapHP_dom)
                                apply (simp add: Img_def)  apply (rule_tac x=sa in exI, simp add: map_add_def)
                              apply simp
                           apply (drule_tac x=s and Y="ObjIDs N" in SetTriv, assumption) apply (erule SetTriv, rule ObjIDs_in_Dom) 
    apply fast
apply (erule exE, erule conjE) apply (rename_tac fH_HHmap)
apply (subgoal_tac "(K, f ++ fa, fK) \<in> MapHP")
prefer 2 apply (rotate_tac -3, erule thin_rl)
    apply (simp add: renState_def  Renames_STATE_def, (erule conjE)+)
    apply (erule_tac Y="AL_dom N" in MapHP_Fun_eqOn[rule_format]) apply simp
    apply (subgoal_tac "fa c = None", simp add: map_add_def) 
    apply (case_tac "c:dom fa")
      apply (drule_tac X="dom fa" and y=c in SetTriv106) 
        apply assumption 
        apply clarsimp
        apply simp
      apply clarsimp
    apply (simp add: State_noDangColours_def)
    apply (simp add: State_noDangColours_def State_good_def)
apply (drule_tac NM=K_Ka and fN=fK and X="AL_dom N_Na" in MapHP_sum) 
  apply assumption
  apply assumption
  apply assumption
  apply (rotate_tac -4) apply (erule thin_rl)
    apply (rule_tac H=K and X="AL_dom N" in HP_good_subset)
      apply (simp add: renState_def  Renames_STATE_def State_noDangColours_def State_good_def) apply clarsimp
      apply (rule contained_refl) 
      apply (simp add: AL_sum_def) apply fast 
  apply assumption
  apply (erule MapN_domf)
  apply (rotate_tac -4, erule thin_rl) 
    apply (simp add: renState_def  Renames_STATE_def, (erule conjE)+) apply (drule_tac H=K in MapHP_domf) apply simp (*apply (erule_tac Y="dom f" in SetTriv101) apply fast*)
  apply (erule SetTriv101) apply (rule SetTriv101) apply (rule ObjIDs_in_Dom) apply (erule MapN_domf)
  apply assumption
  apply (erule_tac X="ObjIDs N_Na" in inj_on_subset) 
      apply (erule_tac Y="ObjIDs N" in SetTriv101) 
         apply (rule contained_ObjIds_subset) apply (simp add: AL_sum_def)
  apply (rotate_tac -4, erule thin_rl)
    apply (rule, rule, simp add: Img_def, clarsimp)
      apply (subgoal_tac "s:AL_dom N'") 
      prefer 2 apply (erule contained6) apply (drule_tac x=s and Y="ObjIDs N" in SetTriv, assumption) apply (erule SetTriv, rule ObjIDs_in_Dom) 
      apply (subgoal_tac "fa s = None")
      prefer 2 apply (case_tac "s:dom fa") apply (drule_tac X="dom fa" in SetTriv106) apply assumption apply assumption apply simp
               apply clarsimp
      apply (erule disjE) apply clarsimp apply clarsimp
                          apply (subgoal_tac "s:AL_dom N", drule_tac H=N in AL_domD, clarsimp) 
                          apply (drule_tac N=N in MapN_D_left, assumption) apply clarsimp
                          apply (erule disjE) 
                            apply (drule_tac X="AL_dom fN" in SetTriv106) apply (erule AL_domI) apply (erule ranI) apply simp
                          apply clarsimp
                            apply (drule_tac X="AL_dom fK" and x=fc and y=fc in SetTriv106)
                              apply (simp add: renState_def Renames_STATE_def, (erule conjE)+) apply (drule_tac N=K in MapHP_dom)
                                apply (simp add: Img_def)  apply (rule_tac x=s in exI, simp add: map_add_def)
                              apply (drule_tac N=Ka in MapHP_dom)
                                apply (simp add: Img_def)  apply (rule_tac x=sa in exI, simp add: map_add_def)
                              apply simp
                           apply (drule_tac x=s and Y="ObjIDs N" in SetTriv, assumption) apply (erule SetTriv, rule ObjIDs_in_Dom) 
    apply fast
apply (erule exE, erule conjE) apply (rename_tac fK_KKmap)
apply (frule_tac N=K' in AL_sum_exists_AL) apply (erule exE, rename_tac K'Ka, erule conjE)
apply (frule_tac N=H' in AL_sum_exists_AL) apply (erule exE, rename_tac H'Ha, erule conjE)
apply (subgoal_tac "AL_dom N' \<inter> AL_dom Na = {}")
prefer 2 apply (rule SetTriv108) apply clarsimp
apply (frule_tac N=N' in AL_sum_exists_AL) apply (erule exE, rename_tac N'Na, erule conjE)

apply (subgoal_tac "renState ((S, \<Gamma>, H_Ha), N_Na, T, \<Delta>, K_Ka) (f ++ fa) ((fS, f\<Gamma>, fH_HHmap), ffa_N_Na, fT, f\<Delta>, fK_KKmap)")
prefer 2 apply (rotate_tac -13) apply (erule thin_rl) 
         apply (subgoal_tac "\<forall> x . x:AL_dom N \<longrightarrow> (f ++ fa) x = f x") 
           apply (simp add: renState_def Renames_STATE_def) apply clarsimp
           apply (rule, erule_tac Y="AL_dom N" in MAP_OPSTACK_Fun_eqOn[rule_format]) apply (erule_tac x=c in allE, erule mp, clarsimp) 
             apply (simp add: State_noDangColours_def)
           apply (rule, erule_tac Y="AL_dom N" in MAP_STORE_Fun_eqOn[rule_format]) apply (erule_tac x=c in allE, erule mp, clarsimp) 
             apply (simp add: State_noDangColours_def)
           apply (rule, erule_tac Y="AL_dom N" in MAP_OPSTACK_Fun_eqOn[rule_format]) apply (erule_tac x=c in allE, erule mp, clarsimp) 
             apply (simp add: State_noDangColours_def)
           apply (rule, erule_tac Y="AL_dom N" in MAP_STORE_Fun_eqOn[rule_format]) apply (erule_tac x=c in allE, erule mp, clarsimp) 
             apply (simp add: State_noDangColours_def)
           apply (rule, simp add: AL_sum_def) apply fast
                                        apply rule apply (rule State_noDangColours_HPsum)
                                                     apply (erule State_noDangColours_MPcontained) apply (simp add: AL_sum_def) apply assumption
                                                     prefer 2 apply assumption
                                                     apply (simp add: State_noDangColours_def, (erule conjE)+) 
                                                       apply (rule,simp add: AL_cod_emp)
                                                       apply (rule, erule SetTriv101) apply (rule ObjIDs_in_Dom)
                                                       apply (rule, erule HP_good_AbsFields)
                                                       apply (simp add: State_good_def) apply (rule AL_EMP)
                                                     apply (erule MapHP_AL_left)
                                         apply (rule State_noDangColours_HPsum)
                                                     apply (erule State_noDangColours_MPcontained) apply (simp add: AL_sum_def) apply assumption
                                                     prefer 2 apply assumption
                                                     apply (simp add: State_noDangColours_def, (erule conjE)+) 
                                                       apply (rule,simp add: AL_cod_emp)
                                                       apply (rule, erule SetTriv101) apply (rule ObjIDs_in_Dom)
                                                       apply (rule, erule HP_good_AbsFields)
                                                       apply (simp add: State_good_def) apply (rule AL_EMP)
                                                     apply (erule MapHP_AL_left)
         apply clarsimp apply (subgoal_tac "fa x = None", simp add: map_add_def)
                        apply (case_tac "x:dom fa")
                          apply (drule_tac X="dom fa" in SetTriv106) apply assumption apply (erule contained6, assumption) apply simp
                          apply clarsimp
apply (erule_tac x=H'Ha in allE, erule_tac x=N'Na in allE, erule_tac x=K'Ka in allE)
apply (erule_tac x="map_compose I (f++fa)" in allE, erule_tac x="map_compose J (f++fa)" in allE)
apply (erule impE) apply (rule Ren_sat) apply (rule_tac HH=fH_HHmap in sat_leftHPextensional) apply (rule sat_symm) 
                                          apply (rule_tac HH=fK_KKmap in sat_leftHPextensional) apply (erule sat_symm) 
                                          apply (erule AL_sum_extensional) apply assumption apply (erule MapHP_AL_right)
                                        apply (erule AL_sum_extensional) apply assumption apply (erule MapHP_AL_right)
                                      apply assumption apply simp
apply (erule impE) apply (rule SetTriv103) apply (erule contained5) apply (erule SetTriv108)
apply (erule impE, simp) 
apply ((erule exE)+, (erule conjE)+) 
apply (rule_tac x="(map_compose I1 (Invv (g++fa)))" in exI)
apply (rule_tac x="(map_compose J1 (Invv (g++fa)))" in exI)

apply (drule_tac N=Na and g="g++fa" in MapN_extend_f) 
  apply (rotate_tac -2, erule thin_rl) apply clarsimp
apply (subgoal_tac "\<forall> c . c \<in> AL_dom N' \<longrightarrow> (g ++ fa) c = g c")
prefer 2 apply clarsimp 
         apply (subgoal_tac "fa c = None", simp add: map_add_def)
         apply (case_tac "c:dom fa")
             apply (drule_tac X="dom fa" in SetTriv106) apply assumption apply assumption apply simp
           apply clarsimp
apply (subgoal_tac "inj_on (g ++ fa) (ObjIDs N'Na)")
prefer 2 apply (erule thin_rl) apply (simp add: renState_def, clarsimp)
                                                   apply (erule inj_on_MapN_sum) apply assumption+
apply (subgoal_tac "contained N_Na N'Na")
prefer 2 apply (simp (no_asm) add: contained_def, clarsimp)
         apply (drule AL_sum_split, assumption)
         apply (erule disjE) 
           apply (erule AL_sum3) apply (erule contained3, assumption)
         apply (erule AL_sum4, assumption)
apply (subgoal_tac "(Ha, g ++ fa, HH) \<in> MapHP")
prefer 2 apply (erule_tac Y="AL_dom N_Na" in MapHP_Fun_eqOn[rule_format])
         apply (simp add: AL_sum_def)
         apply (erule disjE)
           apply (subgoal_tac "fa c = None", simp add: map_add_def)
             apply (subgoal_tac "c : dom f", clarsimp)
             apply (erule SetTriv) apply (simp add: renState_def, (erule conjE)+) 
           apply (case_tac "c:AL_dom Na", clarsimp)
             apply (drule_tac X="dom fa" in SetTriv106) apply (erule domI) apply (erule contained6, assumption) apply simp
           apply clarsimp
         apply clarsimp
       apply (erule SetTriv101) apply (rule ObjIDs_in_Dom)
       apply assumption
apply (subgoal_tac "HP_good H' (AL_dom N')")
prefer 2 apply (simp add: renState_def Renames_STATE_def State_noDangColours_def State_good_def, clarsimp) 
apply (subgoal_tac "(H', g ++ fa, gH') \<in> MapHP")
prefer 2 apply (simp add: renState_def Renames_STATE_def, (erule conjE)+) 
         apply (erule_tac Y="AL_dom N'" in MapHP_Fun_eqOn[rule_format]) 
           apply (erule_tac x=c in allE, erule mp, clarsimp)
           apply (rule_tac Y="ObjIDs N'" in SetTriv101) apply (simp add: State_noDangColours_def) apply (rule ObjIDs_in_Dom)
           apply clarsimp
apply (subgoal_tac "(Ka, g ++ fa, KK) \<in> MapHP")
prefer 2 apply (erule_tac Y="AL_dom N_Na" in MapHP_Fun_eqOn[rule_format])
         apply (simp add: AL_sum_def)
         apply (erule disjE)
           apply (subgoal_tac "fa c = None", simp add: map_add_def)
             apply (subgoal_tac "c : dom f", clarsimp)
             apply (erule SetTriv) apply (simp add: renState_def, (erule conjE)+) 
           apply (case_tac "c:AL_dom Na", clarsimp)
             apply (drule_tac X="dom fa" in SetTriv106) apply (erule domI) apply (erule contained6, assumption) apply simp
           apply clarsimp
         apply clarsimp
       apply (erule SetTriv101) apply (rule ObjIDs_in_Dom)
       apply assumption
apply (subgoal_tac "HP_good K' (AL_dom N')")
prefer 2 apply (simp add: renState_def Renames_STATE_def State_noDangColours_def State_good_def, clarsimp) 
apply (subgoal_tac "(K', g ++ fa, gK') \<in> MapHP")
prefer 2 apply (simp add: renState_def Renames_STATE_def, (erule conjE)+) 
         apply (erule_tac Y="AL_dom N'" in MapHP_Fun_eqOn[rule_format]) 
           apply (erule_tac x=c in allE, erule mp, clarsimp)
           apply (rule_tac Y="ObjIDs N'" in SetTriv101) apply (simp add: State_noDangColours_def) apply (rule ObjIDs_in_Dom)
           apply clarsimp
apply (subgoal_tac "sat ([v], emp, h) ([w], emp, k) ((gS', g\<Gamma>', gH'HH), gN'NN, gT', g\<Delta>', gK'KK) (map_compose I1 (Invv (g ++ fa))) (map_compose J1 (Invv (g ++ fa))) \<and>
          (\<forall>c. c \<in> AL_dom fN_NN \<longrightarrow>
               Invariant c (gS', g\<Gamma>', gH'HH) ([v], emp, h) (map_compose I1 (Invv (g ++ fa))) fN_NN (fS, f\<Gamma>, fH_HH) (ops1, s1, h1) I \<and>
               Invariant c (gT', g\<Delta>', gK'KK) ([w], emp, k) (map_compose J1 (Invv (g ++ fa))) fN_NN (fT, f\<Delta>, fK_KK) (ops2, s2, h2) J)") 
apply clarsimp 
apply (erule_tac f=f and g=g and fa=fa and HH=HH and KK=KK in Ren_Aux) 
  apply (assumption, assumption, assumption, assumption, assumption)
  apply (assumption, assumption, assumption, assumption, assumption)
  apply (assumption, assumption, assumption, assumption, assumption)
  apply (assumption, assumption, assumption, assumption, assumption)
  apply (assumption, assumption, assumption, assumption, assumption)
  apply (assumption, assumption, assumption, assumption, assumption)
  apply (assumption, assumption, assumption, assumption, assumption)
  apply (assumption, assumption, assumption, assumption, assumption)
  apply (assumption, assumption, assumption, assumption, assumption)
  apply (assumption, assumption, assumption, assumption, assumption)
  apply (assumption, assumption, assumption, assumption, assumption)
  apply (assumption, assumption, assumption, assumption, assumption)
  apply (assumption, assumption, assumption, assumption, assumption)
  apply (assumption, assumption, assumption, assumption, assumption)
  apply (assumption, assumption, assumption, assumption, assumption)
  apply (assumption, assumption, assumption, assumption, assumption)
  apply (assumption, assumption, assumption, assumption, assumption)
  apply (assumption, assumption, assumption)
done

end