(*<*)
theory ExampleBase = RSD_TYPING:
(*>*)

constdefs star::"('a,'b)AssList \<Rightarrow> ('a,'b)AssList \<Rightarrow> ('a,'b)AssList \<Rightarrow> bool"
"star H K HK \<equiv> AL_sum H K HK \<and> AL_dom H \<inter> AL_dom K = {} \<and> HK:AL"

constdefs starOpt::"('a,'b)AssList option \<Rightarrow> ('a,'b)AssList option \<Rightarrow> ('a,'b)AssList \<Rightarrow> bool"
"starOpt Hopt Kopt HK \<equiv> \<exists> H K . Hopt=Some H \<and> Kopt = Some K \<and> star H K HK"

lemma starOptDEF:
"starOpt Hopt Kopt HK = (\<exists> H K . Hopt=Some H \<and> Kopt = Some K \<and> AL_sum H K HK \<and> AL_dom H \<inter> AL_dom K = {} \<and> HK:AL)"
by (simp add: starOpt_def star_def)

(*<*)
end
(*>*)