theory INSTR_PUT = UniSatSec:

lemma State_welldefPut1:
  "\<lbrakk>State_welldef (cc # dd # S, \<Gamma>, H) N; H\<down>dd = Some (C, F)\<rbrakk> 
 \<Longrightarrow> State_welldef  (S, \<Gamma>, H[dd \<mapsto> (C,F[f \<mapsto> cc])]) N"
apply (simp add: State_welldef_def, clarsimp)
apply rule apply (simp add: AL_dom_upd1) 
apply (rule, clarsimp)
  apply (simp add: AbsFields_expand) apply clarsimp
  apply (drule AL_upd_split)
  apply (erule disjE, clarsimp) 
    apply (drule AL_upd_split)
      apply (erule disjE, clarsimp)
      apply clarsimp
        apply (rule_tac X="{c. \<exists>d C F. H\<down>d = Some (C, F) \<and> (\<exists>f. F\<down>f = Some c)}" in SetTriv)
          apply clarsimp apply (rule_tac x=dd in exI, clarsimp)  apply (rule, assumption) 
          apply assumption
      apply clarsimp
        apply (rule_tac X="{c. \<exists>d C F. H\<down>d = Some (C, F) \<and> (\<exists>f. F\<down>f = Some c)}" in SetTriv)
          apply clarsimp apply (rule_tac x=d in exI, clarsimp)  apply (rule, assumption) 
          apply assumption
apply (rule, clarsimp)
  apply (simp add: AL_dom_upd1)
  apply (case_tac "x=dd", clarsimp) apply clarsimp
  apply (erule disjE)
    apply (rule_tac X="insert cc (insert dd (set S \<union> AL_cod \<Gamma> \<union> AbsFields H)) \<inter> ObjIDs N" in SetTriv)
      apply clarsimp
    apply assumption
  apply (erule disjE)
    apply (rule_tac X="insert cc (insert dd (set S \<union> AL_cod \<Gamma> \<union> AbsFields H)) \<inter> ObjIDs N" in SetTriv)
      apply clarsimp
    apply assumption
  apply (simp add: AbsFields_expand, clarsimp)
    apply (drule AL_upd_split)
      apply (erule disjE, clarsimp)
        apply (drule AL_upd_split)
        apply (erule disjE, clarsimp) 
          apply (rule_tac X="insert cc (insert dd (set S \<union> AL_cod \<Gamma> \<union> {c. \<exists>d C F. H\<down>d = Some (C, F) \<and> (\<exists>f. F\<down>f = Some c)})) \<inter> ObjIDs N" in SetTriv)
            apply clarsimp 
          apply assumption
        apply clarsimp
          apply (rule_tac X="insert cc (insert dd (set S \<union> AL_cod \<Gamma> \<union> {c. \<exists>d C F. H\<down>d = Some (C, F) \<and> (\<exists>f. F\<down>f = Some c)})) \<inter> ObjIDs N" in SetTriv)
            apply clarsimp 
          apply assumption
      apply clarsimp
          apply (rule_tac X="insert cc (insert dd (set S \<union> AL_cod \<Gamma> \<union> {c. \<exists>d C F. H\<down>d = Some (C, F) \<and> (\<exists>f. F\<down>f = Some c)})) \<inter> ObjIDs N" in SetTriv)
            apply clarsimp 
          apply assumption
apply (rule, simp add: AL_dom_upd1)
  apply (drule AL_domI) apply fast
apply (simp add: State_good_def, clarsimp)
  apply (rule, erule AL_UPD)
  apply (simp add: HP_good_def, clarsimp) 
  apply (drule AL_upd_split)
  apply (erule disjE, clarsimp)
    apply (erule_tac x=dd in allE, clarsimp)
    apply (rule, erule AL_UPD)
    apply (rule SetTriv101) apply (rule AL_cod_upd1) apply clarsimp
  apply (erule_tac x=c in allE, clarsimp)
done



lemma State_welldefPut2:
  "\<lbrakk> State_welldef (S, \<Gamma>, bf[c2\<mapsto>(C, F[f\<mapsto>c1])]) ao; AL_sum H Ha bf; H\<down>c2 = Some (C, F); 
     AL_sum H[c2\<mapsto>(C, F[f\<mapsto>c1])] Ha H1; AL_dom H \<inter> AL_dom Ha = {}; H1 \<in> AL\<rbrakk>
  \<Longrightarrow> State_welldef (S, \<Gamma>, H1) ao"
apply (simp add: State_welldef_def, clarsimp)
apply (rule, simp add: AL_sum_def AL_dom_upd1)
apply (rule, simp add: AbsFields_expand, clarsimp)
  apply (drule AL_sum_split, assumption)
  apply (erule disjE)
    apply (drule AL_upd_split)
    apply (erule disjE, clarsimp)
      apply (drule AL_upd_split)
      apply (erule disjE, clarsimp) 
        apply (rule_tac X="{c. \<exists>d Ca Fa. bf[c2\<mapsto>(C, F[f\<mapsto>c1])]\<down>d = Some (Ca, Fa) \<and> (\<exists>f. Fa\<down>f = Some c)}" in SetTriv)
          apply clarsimp apply (rule_tac x=c2 in exI, simp add: AL_update1) apply (rule, rule AL_update1)
        apply assumption
      apply clarsimp
        apply (rule_tac X="{c. \<exists>d Ca Fa. bf[c2\<mapsto>(C, F[f\<mapsto>c1])]\<down>d = Some (Ca, Fa) \<and> (\<exists>f. Fa\<down>f = Some c)}" in SetTriv)
          apply clarsimp apply (rule_tac x=c2 in exI, simp add: AL_update1) apply (rule, erule AL_update5) apply assumption
        apply assumption
      apply clarsimp
        apply (rule_tac X="{c. \<exists>d Ca Fa. bf[c2\<mapsto>(C, F[f\<mapsto>c1])]\<down>d = Some (Ca, Fa) \<and> (\<exists>f. Fa\<down>f = Some c)}" in SetTriv)
          apply clarsimp apply (rule_tac x=d in exI, rule_tac x=Ca in exI, rule_tac x=Fa in exI)
            apply rule apply (rule AL_update5) apply (erule AL_sum3, assumption) apply assumption
            apply (rule, assumption)
        apply assumption
      apply (rule_tac X="{c. \<exists>d Ca Fa. bf[c2\<mapsto>(C, F[f\<mapsto>c1])]\<down>d = Some (Ca, Fa) \<and> (\<exists>f. Fa\<down>f = Some c)}" in SetTriv)
          apply clarsimp apply (rule_tac x=d in exI, rule_tac x=Ca in exI, rule_tac x=Fa in exI)
            apply rule apply (rule AL_update5) apply (erule AL_sum4, assumption)
                       apply (drule_tac d=c2 in AL_domI) apply (drule_tac H=Ha and d=d in AL_domI) apply fast 
            apply (rule, assumption)
        apply assumption
apply (rule, clarsimp)
  apply (subgoal_tac "AL_dom bf[c2\<mapsto>(C, F[f\<mapsto>c1])] \<subseteq> AL_dom H1")
  prefer 2  apply (simp add: AL_dom_upd1) apply (rule, erule AL_sum3a) apply (rule AL_dom_upd2)
            apply (simp add: AL_sum_def, clarsimp)
              apply (rule, clarsimp) apply (simp add: AL_dom_upd1)
              apply fast
  apply (erule disjE)
    apply (rule SetTriv) prefer 2 apply assumption
    apply (rule SetTriv) prefer 2 apply assumption
    apply clarsimp
  apply (erule disjE)
    apply (rule SetTriv) prefer 2 apply assumption
    apply (rule SetTriv) prefer 2 apply assumption
    apply clarsimp
  apply (rule SetTriv) prefer 2 apply assumption
    apply (rule SetTriv) prefer 2 apply assumption
    apply clarsimp 
      apply (simp add: AbsFields_expand, clarsimp)
      apply (drule AL_sum_split, assumption)
      apply (erule disjE)
        apply (drule AL_upd_split)
        apply (erule disjE, clarsimp)
            apply (erule_tac x=c2 in allE, simp add: AL_update1)
        apply clarsimp
            apply (erule_tac x=d in allE, erule_tac x=Ca in allE, erule_tac x=Fa in allE, erule impE)
            apply (rule AL_update5) apply (erule AL_sum3, assumption) apply assumption
            apply (erule_tac x=fa in allE, clarsimp)
     apply (erule_tac x=d in allE, erule_tac x=Ca in allE, erule_tac x=Fa in allE, erule impE)
       apply (rule AL_update5) apply (erule AL_sum4, assumption) 
         apply (drule_tac d=c2 in AL_domI) apply (drule_tac H=Ha and d=d in AL_domI) apply fast 
       apply (erule_tac x=fa in allE, clarsimp)
apply (rule, simp add: AL_sum_def, clarsimp)
  apply (rule, simp add: AL_dom_upd1) 
  apply (rule SetTriv101) prefer 2 apply assumption
  apply (rule SetTriv101) apply (erule contained5) apply (rule AL_dom_upd)
apply (simp add: State_good_def, clarsimp)
    apply (erule HP_good_subset)
      apply (simp add: contained_def, clarsimp)
      apply (drule AL_sum_split, assumption)
      apply (erule disjE)
        apply (drule AL_upd_split)
        apply (erule disjE, clarsimp) apply (rule AL_update1)
        apply clarsimp apply (rule AL_update5) apply (erule AL_sum3) apply assumption apply assumption
      apply (rule AL_update5) apply (erule AL_sum4) apply assumption
         apply (drule_tac d=c2 in AL_domI) apply (drule_tac H=Ha and d=a in AL_domI) apply fast  
    apply simp 
done


lemma Values_Represented_PUT:
  "\<lbrakk> H\<down>c2 = Some (D, F); h\<down>a = Some (C, Flds);
     AL_sum H Ha HHa; AL_sum H[c2\<mapsto>(D, F[f\<mapsto>c1])] Ha H1;  inj_on I (AL_dom HHa);   
     I c2 = Some a\<rbrakk>
   \<Longrightarrow> Values_Represented c (S, \<Gamma>, H1) (ops, s, h[a\<mapsto>(C, Flds[f\<mapsto>v])]) I \<subseteq> 
       Values_Represented c (c1 # c2 # S, \<Gamma>, HHa) (v # RVal (Loc a) # ops, s, h) I"   
apply (simp add: Values_Represented_def)
        apply (rule, simp add: OpsValues_Represented_def, clarsimp)
          apply (rule_tac x="Suc(Suc n)" in exI, simp)
        apply (rule, fast)
        apply (rule, simp add: AddrValues_Represented_def, clarsimp)
          apply (simp add: AL_sum_def AL_dom_upd1, clarsimp) apply (erule AL_domI)
        apply (simp add: FieldValues_Represented_def, clarsimp)
          apply (drule AL_upd_split)
          apply (erule disjE, clarsimp)
            (*some field of the modified object*)
            apply (drule_tac x=c2 and y=d in inj_onD) apply simp
              apply (erule AL_sum3a) apply (erule AL_domI)
              apply (drule AL_domI) apply (drule_tac d=d in AL_domI)
                apply (simp add: AL_sum_def AL_dom_upd1) apply clarsimp
            apply clarsimp
            apply (frule_tac H="H[c2\<mapsto>(D, F[f\<mapsto>c1])]" in AL_sum3) apply (rule AL_update1) apply clarsimp
            apply (rotate_tac -2, drule AL_upd_split)
            apply (erule disjE, clarsimp)
              (*the modified field of the modified object*)
              apply (simp add: AL_update1) apply clarsimp
              apply (simp add: OpsValues_Represented_def)
              apply (erule_tac x=0 in allE, clarsimp)
            (*some other field of the modified object*)
            apply clarsimp
              apply (drule AL_update3, assumption)
              apply (drule AL_sum3, assumption) 
              apply (rule_tac x=c2 in exI, clarsimp)
              apply (rule_tac x=fa in exI, simp)
          (*some other object*)
          apply clarsimp
            apply (case_tac "c2=d", clarsimp) 
            apply (rule_tac x=d in exI, rule_tac x=Da in exI, rule_tac x=Fa in exI)
            apply rule apply (drule_tac c=d in AL_sum_split, assumption)
                       apply (erule disjE)
                         apply (drule AL_update3, assumption)
                         apply (erule AL_sum3, assumption)
                       apply (erule AL_sum4, assumption)
            apply (rule_tac x=fa in exI, simp)
done



lemma Put_unisat:
  "\<lbrakk>unisat (v # RVal (Loc a) # ops, s, h) (c1 # c2 # S, \<Gamma>, HHa) N I; H\<down>c2 = Some (D, F);
      h\<down>a = Some (C, Flds); AL_sum H Ha HHa; 
     AL_dom H \<inter> AL_dom Ha = {};  AL_sum H[c2\<mapsto>(D, F[f\<mapsto>c1])] Ha H1; H1 \<in> AL\<rbrakk>
  \<Longrightarrow> unisat (ops, s, h[a\<mapsto>(C, Flds[f\<mapsto>v])]) (S, \<Gamma>, H1) N I"
apply (simp add: unisat_def) apply clarify 
apply (rule, drule State_welldefPut1) apply (erule AL_sum3, assumption) apply (erule State_welldefPut2) apply assumption+ 
apply (subgoal_tac "DOM (S, \<Gamma>, H1) \<subseteq> DOM (c1 # c2 # S, \<Gamma>, HHa)")
    prefer 2 apply (simp add: DOM_def)
             apply (rule, fast)
             apply (rule, fast)
             apply (rule, simp add: AL_sum_def AL_dom_upd1, fast)
             apply (simp add: AbsFields_expand, clarsimp)
               apply (drule AL_sum_split, assumption)
               apply (rotate_tac -1, erule disjE)
                 apply (drule AL_upd_split)
                 apply (rotate_tac -1, erule disjE)
                   apply clarsimp 
                   apply (drule AL_upd_split)
                   apply (rotate_tac -1, erule disjE) apply clarsimp
                   apply clarsimp apply (rule, rule, rule, rule, erule AL_sum3, assumption) apply (rule, assumption)
                 apply clarsimp apply (rule_tac x=d in exI, rule, rule, rule, erule AL_sum3, assumption) apply (rule, assumption)
               apply (rule_tac x=d in exI, rule, rule, rule, erule AL_sum4, assumption) apply (rule, assumption)
apply (subgoal_tac "I c2 = Some a")
    prefer 2
             apply (simp add: StateSatisfiesAbstraction_def, clarsimp)
             apply (subgoal_tac "RVal (Loc a) : ValuesRepresented c2 (c1 # c2 # S, \<Gamma>, HHa) (v # RVal (Loc a) # ops, s, h) I") 
             prefer 2 apply (rotate_tac -1, rule  ValuesRepresented7)
             apply (simp add: State_typecorrect_def Heap_typecorrect_expand, clarsimp)
             apply (erule_tac x=c2 in allE, erule_tac x=D in allE, erule_tac x=F in allE)
             apply (erule impE) apply (erule AL_sum3, assumption)
             apply clarsimp
             apply (simp add: uniqueValues_def)
             apply (erule_tac x=c2 in allE, erule impE) apply (simp add: DOM_def) apply clarsimp
             apply (subgoal_tac "RVal(Loc aa) : ValuesRepresented c2 (c1 # c2 # S, \<Gamma>, HHa) (v # RVal (Loc a) # ops, s, h) I", clarsimp)
             apply (subgoal_tac "RVal (Loc aa) \<in> Values_Represented c2 (c1 # c2 # S, \<Gamma>, HHa) (v # RVal (Loc a) # ops, s, h) I", simp add: ValRepEQ)
             apply (simp add: Values_Represented_def)
             apply (rule disjI2) apply (rule disjI2) apply (rule disjI1)
             apply (simp add: AddrValues_Represented_def)
             apply (erule AL_sum3a) apply (erule AL_domI)
  apply (simp add: StateSatisfiesAbstraction_def, clarsimp)
  apply (subgoal_tac "State_typecorrect N (S, \<Gamma>, H1) (ops, s, h[a\<mapsto>(C, Flds[f\<mapsto>v])]) I", rule, assumption)
  prefer 2 apply (simp add: State_typecorrect_def, clarsimp)
    apply rule apply (rule Opstack_typecorrect_Tail) apply (erule Opstack_typecorrect_Tail) 
    apply (simp add: Heap_typecorrect_def, clarsimp)
      apply (frule_tac n=0 in State_welldef_OPS_lookup)  apply simp apply clarsimp
      apply (frule_tac n=1 in State_welldef_OPS_lookup)  apply simp apply clarsimp
      apply (subgoal_tac "\<exists>tp. N\<down>c1 = Some tp \<and> typecorrect v tp", clarsimp)
      prefer 2 apply (simp add: Opstack_typecorrect_def) apply (erule_tac x=0 in allE, clarsimp)
      apply (subgoal_tac "\<exists>tp. N\<down>c2 = Some tp \<and> typecorrect (RVal (Loc a)) tp", clarsimp)
      prefer 2 apply (simp add: Opstack_typecorrect_def) apply (erule_tac x=1 in allE, clarsimp)
      apply (frule AL_sum3, assumption)
      apply (subgoal_tac "(\<exists>C. N\<down>c2 = Some (classTP C) \<and> HeapAbstractsAt N HHa h c2 C I \<and> c2 \<in> dom I)")
      prefer 2 apply (erule_tac x=c2 in allE, erule mp, erule AL_domI)
      apply clarsimp
      apply (frule AL_domD, clarsimp)
      apply (frule_tac c=c in AL_sum_split, assumption)
      apply (erule disjE)
        apply (drule AL_upd_split)
        apply (erule disjE, clarsimp) apply rule prefer 2 apply (erule domI)
          apply (simp add: HeapAbstractsAt_def) apply clarsimp
          apply (rule_tac x=C in exI, simp add: AL_update1) 
            apply (simp add: Fields_typecorrect_def, clarsimp)
            apply (drule AL_upd_split)
            apply (erule disjE, clarsimp) apply (simp add: AL_update1)
            apply clarsimp apply (erule_tac x=fa in allE, clarsimp)
              apply (rule_tac x=va in exI, simp, erule AL_update5) apply assumption
         apply clarsimp
           apply (frule_tac x=c in AL_sum3, assumption) 
           apply (erule_tac x=c in allE, erule impE, erule AL_domI)
           apply clarsimp
           apply (simp add: HeapAbstractsAt_def) apply clarsimp
           apply rule
             apply (rule_tac x=E in exI, clarsimp)
             apply (rule_tac x=G in exI, simp)
             apply (erule AL_update5)
             apply (case_tac "a=y")
               apply (drule_tac x=c2 and y=c in inj_onD) apply simp apply (erule AL_domI) apply (erule AL_domI) apply simp
             apply assumption
           apply (erule domI)
       apply (frule_tac x=c in AL_sum4, assumption) 
           apply (erule_tac x=c in allE, erule impE, erule AL_domI)
           apply clarsimp
           apply (simp add: HeapAbstractsAt_def) apply clarsimp
           apply rule
             apply (rule_tac x=E in exI, clarsimp)
             apply (rule_tac x=G in exI, simp)
             apply (erule AL_update5)
             apply (case_tac "a=y")
               apply (drule_tac x=c2 and y=c in inj_onD) apply simp apply (erule AL_domI) apply (erule AL_domI) apply clarsimp
                 apply (drule_tac H=H in AL_domI) apply (drule_tac H=Ha in AL_domI)  apply fast
             apply assumption
           apply (erule domI)
  apply (rule, simp add: uniqueValues_def, clarsimp)
    apply (subgoal_tac "\<exists>va. Values_Represented c (S, \<Gamma>, H1) (ops, s, h[a\<mapsto>(C, Flds[f\<mapsto>v])]) I = {va}",simp add:ValRepEQ) 
    apply (rule SetTrivUnique)             
      apply (erule State_typecorrect_VR_notEmpty, assumption)
    apply (erule_tac x=c in allE, erule impE, erule SetTriv, assumption)
      apply (erule exE)+
      apply (subgoal_tac " Values_Represented c (c1 # c2 # S, \<Gamma>, HHa) (v # RVal (Loc a) # ops, s, h) I = {va}")
      prefer 2 apply (simp add: ValRepEQ)
      apply (rotate_tac -2, erule thin_rl)
      apply clarsimp
      apply (drule SetTriv, erule Values_Represented_PUT, assumption+)
      apply (drule SetTriv, erule Values_Represented_PUT, assumption+)
      apply fastsimp
  apply (subgoal_tac "AL_dom H1 = AL_dom HHa", simp)
    apply (rule SetTriv101) prefer 2 apply assumption 
    apply fast
    apply (simp add: AL_sum_def AL_dom_upd1) apply (drule AL_domI) apply fast
done

lemma Put_UniInvariantUni: 
  "\<lbrakk> H\<down>c2 = Some (D, F);
     unisat (va # RVal (Loc ay) # ops, aj, h) (c1 # c2 # S, \<Gamma>, bf) ao I;
     h\<down>ay = Some (C, Flds); AL_sum H Ha bf; AL_dom H[c2\<mapsto>(D, F[f\<mapsto>c1])] \<inter> AL_dom Ha = {};
     AL_sum H[c2\<mapsto>(D, F[f\<mapsto>c1])] Ha H1; H1:AL\<rbrakk>
  \<Longrightarrow> Invariant c  (S, \<Gamma>, H1) (ops, aj, h[ay\<mapsto>(C, Flds[f\<mapsto>va])]) I ao (c1 # c2 # S, \<Gamma>, bf) (va # RVal (Loc ay) # ops, aj, h) I"
apply (subgoal_tac "AL_dom bf = AL_dom H1")
prefer 2 apply (drule AL_domI, simp add: AL_dom_upd1 AL_sum_def) apply fast
apply (frule AL_domI)
apply (frule AL_sum3a) apply assumption
apply (frule AL_sum3, assumption)
apply (subgoal_tac "H1\<down>c2 = Some ((D, F[f\<mapsto>c1]))") prefer 2 apply (erule AL_sum3) apply (rule AL_update1)
apply (subgoal_tac "\<forall> d . d \<noteq> c2 \<longrightarrow> bf\<down>d = H1\<down>d")
prefer 2 apply clarsimp apply (case_tac "H1\<down>d")
                          apply (case_tac "bf\<down>d", simp)
                          apply (frule_tac d=d in AL_domI)
                          apply (subgoal_tac "d \<in> AL_dom H \<or> d:AL_dom Ha") prefer 2 apply (simp add: AL_sum_def AL_dom_upd1)
                          apply (erule disjE)
                            apply (drule_tac H=H and d=d in AL_domD) apply clarsimp
                            apply (drule_tac H="H[c2\<mapsto>(D, F[f\<mapsto>c1])]" and x=d in AL_sum3) apply (erule AL_update5a, assumption) 
                            apply clarsimp
                          apply (drule_tac H=Ha and d=d in AL_domD) apply clarsimp
                            apply (drule_tac H="H[c2\<mapsto>(D, F[f\<mapsto>c1])]" and x=d in AL_sum4) apply assumption
                            apply clarsimp
                        apply (drule_tac c=d in AL_sum_split, assumption)
                          apply (erule disjE)
                            apply (drule AL_upd_split)
                            apply (erule disjE, clarsimp) 
                            apply clarsimp apply (erule AL_sum3,assumption)
                          apply clarsimp apply (erule AL_sum4, assumption)
  apply (subgoal_tac "I c2 = Some ay")
  prefer 2 apply (simp add: unisat_def StateSatisfiesAbstraction_def, clarsimp) 
         apply (simp add: State_typecorrect_def, clarsimp) 
         apply (simp add: Opstack_typecorrect_def) 
         apply (erule_tac x=1 in allE, clarsimp)
         apply (simp add: Heap_typecorrect_def) 
         apply (erule_tac x=c2 in allE, erule impE, assumption) 
         apply (simp add: HeapAbstracts_def, clarsimp)
         apply (drule State_welldef_lookupHeap1) apply (erule AL_domI) apply (drule AL_domD, clarsimp)
         apply (simp add: uniqueValues_def)
         apply (subgoal_tac "c2 \<in> DOM (c1 # c2 # S, \<Gamma>, bf)") prefer 2 apply (simp add: DOM_def)
         apply (erule_tac x=c2 in allE, erule impE, assumption) 
         apply clarsimp
         apply (subgoal_tac "RVal(Loc ay):ValuesRepresented c2 (c1 # c2 # S, \<Gamma>, bf) (va # RVal (Loc ay) # ops, aj, h) I")
         prefer 2 apply (rule ValuesRepresented7)
         apply (drule SetTrivPut2, assumption) apply clarsimp
         apply (subgoal_tac "RVal(Loc y):ValuesRepresented c2 (c1 # c2 # S, \<Gamma>, bf) (va # RVal (Loc ay) # ops, aj, h) I")
         prefer 2 apply (rule ValuesRepresented3) apply (erule AL_sum3a) apply (erule AL_domI) apply assumption
         apply (drule SetTrivPut2, assumption) apply clarsimp
apply (simp add: Invariant_def)
apply clarsimp apply (erule SetTriv) apply (erule Values_Represented_PUT) apply assumption+
                apply (simp add: unisat_def StateSatisfiesAbstraction_def 
                                 State_typecorrect_def Opstack_typecorrect_def Heap_typecorrect_def)
                apply assumption
done

lemma UniPut_SoundUni:
 "\<lbrakk> get_ins M l = Some (putfield C f); \<Sigma> = (c1 # c2 # S, \<Gamma>, H); H\<down>c2 = Some (D, F); L = {l + 1}; 
    \<Pi> = (S, \<Gamma>, H[c2\<mapsto>(D, F[f\<mapsto>c1])]); NN=N\<rbrakk>
       \<Longrightarrow> get_ins M l \<noteq> Some vreturn \<and>
          (\<forall>n S \<Gamma> H Sp \<Gamma>p Hp.
              UniCtxtUniValidN n U \<longrightarrow> \<Sigma> = (S, \<Gamma>, H) \<longrightarrow> \<Pi> = (Sp, \<Gamma>p, Hp) \<longrightarrow> AL_dom H \<subseteq> AL_dom Hp \<and> contained N NN \<and> UniSS_UniSecN (Suc n) \<Sigma> N \<Pi> NN M l L)"
apply (unfold UniSS_UniSecN_def)
apply rule apply simp
apply (rule allI)+
apply (rule impI)+
apply (rule, clarsimp) apply (erule SetTriv) apply (rule AL_dom_upd)
apply (rule, clarsimp, rule contained_refl)
apply (rule, clarsimp) apply (erule SetTriv) apply (rule AL_dom_upd)
apply (rule, clarsimp, rule contained_refl)
apply (rule, rule)
apply (rule allI)+
apply (rule impI)+
apply clarsimp
apply (drule PutElim1) apply assumption apply clarsimp
apply (simp add: SD_sum_def, clarsimp)
apply (subgoal_tac "AL_dom (H[c2\<mapsto>(D, F[f\<mapsto>c1])]) \<inter> (AL_dom Ha) = {}")
prefer 2 apply (drule AL_domI, simp add: AL_dom_upd1) 
apply (frule_tac N="H[c2\<mapsto>(D, F[f\<mapsto>c1])]" in AL_sum_exists_AL) apply clarsimp
apply (rule_tac x=I in exI)
  apply (rule, rule_tac H=H in Put_unisat) 
       apply (erule unisat_MPextensional) apply (erule AL_sum_extensional, assumption) apply assumption
       apply assumption apply assumption apply assumption 
   apply assumption apply assumption 
   apply assumption
apply clarsimp 
apply (rule Put_UniInvariantUni) apply assumption+ 
done

end