theory RuleInvvInvv =  InvokeRelationalBasics:

lemma InvVInvV_satFrame:
  "\<lbrakk> sat (ops, s, h) (ops1,t,k) ((S2,\<Gamma>2,H2), NN, (T2,\<Delta>2,K2)) I J; 
     (S1, P1, \<Gamma>1, d # S) \<in> absFrame;
     (T1, Q1, \<Delta>1, c # T) \<in> absFrame;
     (ops, P1, ss, RVal (Loc an) # os) \<in> Frame; 
     (ops1, Q1, tt, RVal (Loc am) # os1) \<in> Frame; 
     SD_sum (S1, \<Gamma>, H) Ha (S2,\<Gamma>2,H2);
     SD_sum (T1, \<Delta>, K) Ka (T2,\<Delta>2,K2);
     NN\<down>d = Some (classTP D);
     NN\<down>c = Some (classTP C)\<rbrakk>
   \<Longrightarrow> sat ([], ss[this\<mapsto>(RVal (Loc an))], h) ([],tt[this\<mapsto>(RVal(Loc am))],k) (([], \<Gamma>1[this\<mapsto>d], H2), NN, ([],\<Delta>1[this\<mapsto>c],K2)) I J"
apply (simp add: sat_def, clarsimp)
apply (frule AL_domI)
apply (simp add: SD_sum_def)
apply (simp add: welldef_def, clarsimp)
apply (rule, erule absFrame_State_welldefInvV, assumption) 
apply (rule, erule absFrame_State_welldefInvV, assumption)
apply (rule, erule absFrame_InvV_StateSatisfiesAbstraction, assumption+)
apply (rule, erule absFrame_InvV_StateSatisfiesAbstraction, assumption+) 
apply (rule, rule, rule)
apply (erule conjE)
apply (erule_tac x=ca in allE, erule impE, assumption)
apply (erule impE)
  apply rule apply (erule SetTriv, erule absFrame_DOM_InvV) apply (erule SetTriv, erule absFrame_DOM_InvV)
apply (simp add: singleVal_def)
  apply (rule twSet_Triv9)
    apply (erule twSet_Triv10)
      apply (rule SetTriv101) apply (erule ValuesRepresented_InvV) apply assumption
                              apply (rule ValuesRepresented13)
    apply (rule SetTriv101) apply (erule ValuesRepresented_InvV) apply assumption
                            apply (rule ValuesRepresented13)
done

lemma InvvInvv_SingleVal:
 "\<lbrakk> (S1, params, \<Gamma>1, d1 # S) \<in> absFrame; (T1, paramsa, \<Delta>1, d2 # T) \<in> absFrame;
    (ai, params, Sa, RVal (Loc av) # os) \<in> Frame; (ak, paramsa, Sb, RVal (Loc ar) # osa) \<in> Frame; 
    singleVal c ((S1, \<Gamma>, bf), ao, T1, \<Delta>, bg) (ai, aj, bd) I (ak, al, be) J;
    Invariant c ([c1], emp, bh) ([va], emp, hh) I1 ao ([], \<Gamma>1[this\<mapsto>d1], bf) ([], Sa[this\<mapsto>(RVal (Loc av))], bd) I;
    Invariant c ([c2], emp, bi) ([vb], emp, hha) J1 ao ([], \<Delta>1[this\<mapsto>d2], bg) ([], Sb[this\<mapsto>(RVal (Loc ar))], be) J\<rbrakk>
       \<Longrightarrow> singleVal c ((c1 # S, \<Gamma>, bh), NN, c2 # T, \<Delta>, bi) (va # os, aj, hh) I1 (vb # osa, al, hha) J1"
apply (simp add: singleVal_def Invariant_def  ValRepEQ)
 apply (rule twSet_Triv2) prefer 2 apply (rule ValuesRepresented14)
 apply (rule twSet_Triv4) prefer 2 apply (rule ValuesRepresented14)
 apply (erule conjE)+
 apply (rule twSet_Triv9)
   apply (erule twSet_Triv10)
   apply (erule Invv_SingleVal_Aux2, assumption+)
   apply (erule Invv_SingleVal_Aux2, assumption+) 
done

lemma InvVInvV_satFinal:
  "\<lbrakk> (S1, params, \<Gamma>1, d1 # S) \<in> absFrame;
        (T1, paramsa, \<Delta>1, d2 # T) \<in> absFrame;
        
        sat (ai, aj, bd) (ak, al, be) ((S1, \<Gamma>, bf), ao, T1, \<Delta>, bg) I J; 
        (ai, params, Sa, RVal (Loc av) # os) \<in> Frame; 
        (ak, paramsa, Sb, RVal (Loc ar) # osa) \<in> Frame;
        AL_sum H Ha bf; AL_sum K Ka bg; AL_dom H \<inter> AL_dom Ha = {}; AL_dom K \<inter> AL_dom Ka = {}; 
        
        sat ([], upd Sa this (RVal (Loc av)), bd) ([], upd Sb this (RVal (Loc ar)), be) (([], upd \<Gamma>1 this d1, bf), ao, [], upd \<Delta>1 this d2, bg) I J;
        sat ([va], emp, hh) ([vb], emp, hha) (([c1], emp, bh), NN, [c2], emp, bi) I1 J1; AL_sum HH Ha bh;
        AL_sum KK Ka bi; 
        preserved (([], upd \<Gamma>1 this d1, H), ao, [], upd \<Delta>1 this d2, K) (([c1], emp, HH), NN, [c2], emp, KK); HP_good Ha (AL_dom NN); HP_good Ka (AL_dom NN);
        \<forall>c. c \<in> AL_dom ao \<longrightarrow>
            Invariant c ([c1], emp, bh) ([va], emp, hh) I1 ao ([], upd \<Gamma>1 this d1, bf) ([], upd Sa this (RVal (Loc av)), bd) I \<and>
            Invariant c ([c2], emp, bi) ([vb], emp, hha) J1 ao ([], \<Delta>1[this\<mapsto>d2], bg) ([], upd Sb this (RVal (Loc ar)), be) J\<rbrakk>
       \<Longrightarrow> sat (va # os, aj, hh) (vb # osa, al, hha) ((c1 # S, \<Gamma>, bh), NN, c2 # T, \<Delta>, bi) I1 J1"
apply (simp add: sat_def, clarsimp)
apply (subgoal_tac "welldef ((c1 # S, \<Gamma>, bh), NN, c2 # T, \<Delta>, bi) \<and>
       StateSatisfiesAbstraction (va # os, aj, hh) (c1 # S, \<Gamma>, bh) NN I1 \<and>
       StateSatisfiesAbstraction (vb # osa, al, hha) (c2 # T, \<Delta>, bi) NN J1", simp)
prefer 2 apply (rule, simp add: welldef_def, clarsimp)
    apply rule apply (erule InvokeV_Final_State_welldef) apply assumption apply assumption
                 apply assumption apply assumption apply (simp add: preserved_def) apply (simp add: preserved_def)
    apply (erule InvokeV_Final_State_welldef) apply assumption apply assumption
                 apply assumption apply assumption apply (simp add: preserved_def) apply (simp add: preserved_def)
  apply rule apply (simp add: welldef_def preserved_def, (erule conjE)+)
             apply (erule InvV_StateSatisfiesAbstraction, assumption+) apply simp 
  apply (simp add: welldef_def preserved_def, (erule conjE)+)
             apply (erule InvV_StateSatisfiesAbstraction, assumption+) apply simp 
apply clarsimp
  apply (erule_tac x=c in allE, erule impE, assumption)
  apply (case_tac "c : AL_dom ao")
    apply (subgoal_tac "ao\<down>c = Some intTP") prefer 2 apply (simp add: preserved_def)
                                                         apply (drule AL_domD, clarsimp)
                                                         apply (drule_tac NN=NN and c=c in contained3, assumption) apply clarsimp
    apply (erule_tac x=c in allE, erule impE, assumption, erule conjE)
    apply (subgoal_tac "singleVal c ((S1, \<Gamma>, bf), ao, T1, \<Delta>, bg) (ai, aj, bd) I (ak, al, be) J")
      apply (rule InvvInvv_SingleVal) apply assumption+
    apply (case_tac "c \<in> DOM (S1, \<Gamma>, bf)")
      apply (case_tac "c \<in> DOM (T1, \<Delta>, bg)")
        apply (erule_tac x=c in allE, erule impE, assumption, erule mp, simp)
      apply (subgoal_tac "uniqueValues (S1, \<Gamma>, bf) (ai, aj, bd) I")
        apply (simp add: uniqueValues_def singleVal_def) 
        apply (erule_tac x=c in allE, erule impE, assumption, erule exE)
        apply (rule twSetEmpR) apply (erule ValuesRepresented_notin_DOM) apply assumption
      apply (simp add: StateSatisfiesAbstraction_def)
    apply (case_tac "c \<in> DOM (T1, \<Delta>, bg)")
      apply (subgoal_tac "uniqueValues (T1, \<Delta>, bg) (ak, al, be) J")
        apply (simp add: uniqueValues_def singleVal_def) 
        apply (erule_tac x=c in allE, erule impE, assumption, erule exE)
        apply (rule twSetEmpL) apply (erule ValuesRepresented_notin_DOM) apply assumption
      apply (simp add: StateSatisfiesAbstraction_def) 
    apply (simp add: singleVal_def) apply (rule twSetEmp) apply (erule ValuesRepresented_notin_DOM) apply (erule ValuesRepresented_notin_DOM)
 (*c \<notin> AL_dom ao*)
 apply (subgoal_tac "singleVal c (([c1], emp, bh), NN, [c2], emp, bi) ([va], emp, hh) I1 ([vb], emp, hha) J1")
    apply (simp add: singleVal_def)
    apply (rule twSet_Triv2)  
      apply (erule twSet_Triv4) 
         apply (rule ValuesRepresented16) prefer 2 apply assumption 
           apply (simp add: welldef_def, clarsimp) 
             apply rule apply (erule absFrame_State_welldef_Leftover, assumption) 
             apply (rule State_welldef_Tail) apply (erule absFrame_State_welldef_Leftover, assumption)
       apply (rule ValuesRepresented16) prefer 2 apply assumption 
           apply (simp add: welldef_def, clarsimp) 
             apply rule apply (erule absFrame_State_welldef_Leftover, assumption) 
             apply (rule State_welldef_Tail) apply (erule absFrame_State_welldef_Leftover, assumption)
  apply (erule mp)
    apply (simp add: DOM_def welldef_def) apply (erule conjE)+
    apply rule apply (rotate_tac -11, erule disjE, erule disjI1)
               apply (rotate_tac -1, erule disjE) apply (drule_tac x=c and Y="set (d1#S)" in SetTriv) apply simp apply fast 
                                                  apply (drule_tac x=c in SetTriv, erule absFrame_set_leftover)
                 apply (drule_tac x=c in SetTriv, erule State_welldef_OPS_lookup_set_dom) apply simp
               apply (rotate_tac -1, erule disjE) apply (drule_tac x=c in SetTriv, erule State_welldef_Store_lookup_cod_dom) apply simp
               apply (rule disjI2) apply (erule disjI2)
    apply (rotate_tac -10, erule disjE, erule disjI1)
               apply (rotate_tac -1, erule disjE) apply (drule_tac x=c and Y="set (d2#T)" in SetTriv) apply simp apply fast 
                                                  apply (drule_tac x=c in SetTriv, erule absFrame_set_leftover)
                 apply (drule_tac x=c in SetTriv, erule State_welldef_OPS_lookup_set_dom) apply simp
               apply (rotate_tac -1, erule disjE) apply (drule_tac x=c in SetTriv, erule State_welldef_Store_lookup_cod_dom) apply simp
               apply (rule disjI2) apply (erule disjI2)
done
lemma InvVInvV3_Sound:
  "\<lbrakk>get_ins (a, aa, b) l = Some (invokeV C1 m1); mbody_is C1 m1 (P1, code1, l1); get_ins (ab, ac, ba) ll = Some (invokeV C2 m2);
        mbody_is C2 m2 (P2, code2, l2); (S1, P1, \<Gamma>1, d1 # S) \<in> absFrame; (T1, P2, \<Delta>1, d2 # T) \<in> absFrame;
        H\<down>d1 = Some (D1, F1); K\<down>d2 = Some (D2, F2);
        CtxtValidN n G;
        SecN n ((c1 # S, \<Gamma>, HH), NN, c2 # T, \<Delta>, KK) (a, aa, b) (Suc l) (ab, ac, ba) (Suc ll) ((ad, ae, bb), af, ag, ah, bc);
        \<forall>D1' . subclass_of D1' D1 \<longrightarrow> 
             (\<forall> D2'. subclass_of D2' D2 \<longrightarrow>
                     (\<exists> code1' code2' l1' l2'.
                         mbody_is D1' m1 (P1, code1', l1') \<and>
                         mbody_is D2' m2 (P2, code2', l2') \<and>
                         (\<forall>n. CtxtValidN n G \<longrightarrow>
                              SecN n (([], upd \<Gamma>1 this d1, H), N, [], upd \<Delta>1 this d2, K) (P1, code1', l1') l1' (P2, code2', l2') l2'
                                      (([c1], emp, HH), NN, [c2], emp, KK))))\<rbrakk>
       \<Longrightarrow> SecN (Suc n) ((S1, \<Gamma>, H), N, T1, \<Delta>, K) (a, aa, b) l (ab, ac, ba) ll ((ad, ae, bb), af, ag, ah, bc)"
apply (unfold SecN_def)
apply (erule conjE)+
apply (subgoal_tac "preserved (([], \<Gamma>1[this\<mapsto>d1], H), N, [], \<Delta>1[this\<mapsto>d2], K) (([c1], emp, HH), NN, [c2], emp, KK)")
prefer 2  apply (rotate_tac -1, erule thin_rl) 
          apply (erule_tac x=D1 in allE, erule impE, simp add: subclass_of_refl)
          apply (erule_tac x=D2 in allE, erule impE, simp add: subclass_of_refl)
          apply clarsimp
apply (subgoal_tac " preserved ((S1, \<Gamma>, H), N, T1, \<Delta>, K) ((ad, ae, bb), af, ag, ah, bc)", rule, assumption)
prefer 2 apply (rotate_tac -2, erule thin_rl) apply (rotate_tac -2, erule thin_rl)
         apply (simp add: preserved_def, clarsimp)
         apply (rule, erule contained_transitive, assumption)
         apply (rule, erule SetTriv101, assumption)
         apply (erule SetTriv101, assumption)
apply (rule, rule, rule)
apply (rule, rule, rule)
apply (rule, rule, rule)
apply (rule, rule, rule)
apply (rule, rule, rule)
apply (rule, rule, rule)
apply (rule, rule, rule)
apply (rule, rule, rule)
apply (erule eval_cases) apply clarsimp apply clarsimp 
apply (drule InvokeVElim1) apply assumption apply clarify 
apply (erule eval_cases) apply clarsimp apply clarsimp 
apply (drule InvokeVElim1) apply assumption apply clarify 
apply clarsimp
apply (simp add: RSD_sum_def, clarsimp)
apply (simp add: mbody_is_def, clarsimp)
apply (erule_tac x=d in allE, erule impE)
    apply (frule_tac H=H in AL_sum3, assumption)
    apply (erule InvV_InvokerIsSubclass) apply assumption apply assumption apply assumption apply assumption
apply (erule_tac x=da in allE, erule impE)
    apply (frule_tac H=K in AL_sum3, assumption)
    apply (rule InvV_InvokerIsSubclass) apply (erule sat_symm) apply assumption apply assumption apply assumption apply assumption 
apply (erule exE)+ apply (erule conjE)+
apply (erule exE)+ apply (erule conjE)+
apply (erule exE)+ apply (erule conjE)+
apply (erule_tac x=n in allE, erule impE, assumption)
apply (rotate_tac -1, erule_tac x=ka in allE, erule_tac x=kb in allE, erule impE, erule Arith_15) 
apply (subgoal_tac "d1 : ObjIDs afa")
prefer 2 apply (rotate_tac -1, erule thin_rl)
         apply (simp add: sat_def welldef_def, clarsimp)
         apply (rule SetTriv, erule AL_domI) apply (rule SetTriv101, erule AL_sum3b) apply (erule State_welldef_D_Heap_ObjIDs)
apply (subgoal_tac "d2 : ObjIDs afa")
prefer 2 apply (rotate_tac -1, erule thin_rl)
         apply (simp add: sat_def welldef_def, clarsimp)
         apply (rule SetTriv, erule AL_domI) apply (rule SetTriv101, erule AL_sum3b) apply (erule State_welldef_D_Heap_ObjIDs)
apply (simp add: ObjIDs_def, clarsimp)
apply (frule_tac d=d1 and c=d2 in InvVInvV_satFrame)
  apply assumption apply assumption
  apply assumption apply assumption
  apply (simp add: SD_sum_def) apply (rule,simp) apply (rule,assumption) apply assumption
  apply (simp add: SD_sum_def) apply (rule,simp) apply (rule,assumption) apply assumption
  apply assumption apply assumption
apply (erule_tac x="[]" in allE, erule_tac x="Sa[this\<mapsto>(RVal (Loc ar))]" in allE, erule_tac x=bd in allE)
apply (erule_tac x=hh in allE, erule_tac x=va in allE, clarsimp)
apply (erule_tac x="[]" in allE, erule_tac x="Saa[this\<mapsto>(RVal (Loc an))]" in allE, erule_tac x=baa in allE)
apply (erule_tac x=hha in allE, erule_tac x=vb in allE, clarsimp)
apply (erule_tac x=Ha in allE, erule_tac x=Na in allE, erule_tac x=Ka in allE)
apply (erule_tac x=bba in allE, erule_tac x=afa in allE, erule_tac x=bca in allE)
apply (subgoal_tac "AL_dom HH \<inter> AL_dom Ha = {}")
prefer 2 apply (rotate_tac -1, erule thin_rl) 
         apply (rotate_tac 12) apply (erule thin_rl)
         apply (rule_tac Y="AL_dom bb" in SetTriv103)
           apply (simp add: preserved_def)
           apply assumption
apply (frule_tac N=HH in AL_sum_exists_AL)
apply (erule exE, rename_tac HHa, erule conjE)
apply (subgoal_tac "AL_dom KK \<inter> AL_dom Ka = {}")
prefer 2 apply (rotate_tac -4, erule thin_rl) 
         apply (rotate_tac 15) apply (erule thin_rl)
         apply (rule_tac Y="AL_dom bc" in SetTriv103)
           apply (simp add: preserved_def)
           apply assumption
apply (frule_tac N=KK in AL_sum_exists_AL)
apply (erule exE, rename_tac KKa, erule conjE)
apply (subgoal_tac "AL_dom NN \<inter> AL_dom Na = {}")
prefer 2 apply (rotate_tac -7, erule thin_rl) 
         apply (rotate_tac 18) apply (erule thin_rl)
         apply (rule_tac Y="AL_dom af" in SetTriv103)
           apply (simp add: preserved_def, (erule conjE)+) apply (erule contained5)
           apply assumption
apply (frule_tac N=NN in AL_sum_exists_AL)
apply (erule exE, rename_tac NNa, erule conjE)
apply (erule_tac x=HHa in allE, erule_tac x=NNa in allE, erule_tac x=KKa in allE)
apply (erule_tac x=I in allE, erule_tac x=J in allE)
apply clarsimp
apply (erule_tac x=ma in allE, erule_tac x=mb in allE, erule impE, erule Arith_16) 
apply (erule_tac x="va # os" in allE, erule_tac x=aaa in allE, erule_tac x=hh in allE)
apply (erule_tac x=h in allE, erule_tac x=v in allE, clarsimp)
apply (erule_tac x="vb # osa" in allE, erule_tac x=aca in allE, erule_tac x=hha in allE)
apply (erule_tac x=k in allE, erule_tac x=w in allE, clarsimp)
apply (erule_tac x=Ha in allE, erule_tac x=Na in allE, erule_tac x=Ka in allE)
apply (erule_tac x=HHa in allE, erule_tac x=NNa in allE, erule_tac x=KKa in allE, clarsimp)
apply (erule_tac x=bda in allE, erule_tac x=ak in allE, erule_tac x=be in allE, clarsimp)
apply (subgoal_tac "contained afa NNa")
prefer 2 apply (simp add: preserved_def, (erule conjE)+)
         apply (erule contained8, assumption, assumption) 
apply (erule_tac x=I1 in allE, erule_tac x=J1 in allE, erule impE)
  apply (erule  InvVInvV_satFinal) apply assumption apply assumption apply assumption apply assumption apply assumption
                                   apply assumption apply assumption apply assumption apply assumption
                                   apply assumption apply assumption apply assumption 
                                   apply (simp add: preserved_def)
                                   apply (rule_tac H=HHa and X="AL_dom NNa" in HP_good_subset)
                                     apply (simp add: sat_def welldef_def State_welldef_def State_good_def)
                                       apply (simp add: AL_sum_def)
                                       apply simp
                                   apply (rule_tac H=KKa and X="AL_dom NNa" in HP_good_subset)
                                     apply (simp add: sat_def welldef_def State_welldef_def State_good_def)
                                       apply (simp add: AL_sum_def)
                                       apply simp
                                   apply assumption
apply clarsimp
apply (rule_tac x=I1a in exI, rule_tac x=J1a in exI)
apply clarsimp
  apply (erule_tac x=c in allE, erule impE, assumption)
  apply (erule_tac x=c in allE, erule impE) apply (erule contained6,assumption)
  apply (erule conjE)+
  apply rule apply (rotate_tac -1, erule thin_rl) apply (rotate_tac -2, erule thin_rl) 
               apply (drule_tac \<Gamma>=\<Gamma> and NN=NNa and aa=aaa in InvV_Invariant) apply assumption apply assumption 
                 apply (simp add: sat_def welldef_def)
                 apply (simp add: sat_def welldef_def)
                 apply assumption
                 apply (simp add: AL_sum_def preserved_def, clarsimp) apply rule apply fast apply fast
                 apply (simp add: Invariant_def, clarsimp)
                 apply rule apply rule apply(erule impE, assumption)
                            apply (erule impE) apply (erule SetTriv, erule contained_ObjIds_subset) apply simp
                 apply (erule SetTriv101) apply assumption
  apply (rotate_tac -2, erule thin_rl) apply (rotate_tac -2, erule thin_rl) 
               apply (drule_tac \<Gamma>=\<Delta> and NN=NNa and aa=aca in InvV_Invariant) apply assumption apply assumption 
                 apply (simp add: sat_def welldef_def)
                 apply (simp add: sat_def welldef_def)
                 apply assumption
                 apply (simp add: AL_sum_def preserved_def, clarsimp) apply rule apply fast apply fast
                 apply (simp add: Invariant_def, clarsimp)
                 apply rule apply rule apply(erule impE, assumption)
                            apply (erule impE) apply (erule SetTriv, erule contained_ObjIds_subset) apply simp
                 apply (erule SetTriv101) apply assumption
done
lemma InvVInvV_Sound:
  "\<lbrakk>get_ins (a, aa, b) l = Some (invokeV C1 m1); mbody_is C1 m1 (P1, code1, l1); get_ins (ab, ac, ba) ll = Some (invokeV C2 m2);
        mbody_is C2 m2 (P2, code2, l2); (S1, P1, \<Gamma>1, d1 # S) \<in> absFrame; (T1, P2, \<Delta>1, d2 # T) \<in> absFrame;
        H\<down>d1 = Some (D1, F1); subclass_of D1 C1; K\<down>d2 = Some (D2, F2); subclass_of D2 C2;
        CtxtValidN n G;
        SecN n ((c1 # S, \<Gamma>, HH), NN, c2 # T, \<Delta>, KK) (a, aa, b) (Suc l) (ab, ac, ba) (Suc ll) ((ad, ae, bb), af, ag, ah, bc);
        \<forall>D1'. subclass_of D1' C1 \<longrightarrow>
              (\<forall>D2'. subclass_of D2' C2 \<longrightarrow>
                     (\<forall>code1' code2' l1'.
                         mbody_is D1' m1 (P1, code1', l1') \<longrightarrow>
                         (\<forall>l2'. mbody_is D2' m2 (P2, code2', l2') \<longrightarrow>
                                (\<forall>n. CtxtValidN n G \<longrightarrow>
                                     SecN n (([], upd \<Gamma>1 this d1, H), N, [], upd \<Delta>1 this d2, K) (P1, code1', l1') l1' (P2, code2', l2') l2' 
                                      (([c1], emp, HH), NN, [c2], emp, KK)))))\<rbrakk>
       \<Longrightarrow> SecN (Suc n) ((S1, \<Gamma>, H), N, T1, \<Delta>, K) (a, aa, b) l (ab, ac, ba) ll ((ad, ae, bb), af, ag, ah, bc)"
apply (unfold SecN_def)
apply (erule conjE)+
apply (subgoal_tac "preserved (([], \<Gamma>1[this\<mapsto>d1], H), N, [], \<Delta>1[this\<mapsto>d2], K) (([c1], emp, HH), NN, [c2], emp, KK)")
prefer 2  apply (rotate_tac -1, erule thin_rl) 
          apply (erule_tac x=C1 in allE, erule impE, simp add: subclass_of_refl)
          apply (erule_tac x=C2 in allE, erule impE, simp add: subclass_of_refl)
          apply (erule_tac x=code1 in allE, erule_tac x=code2 in allE, erule_tac x=l1 in allE, erule impE, assumption)
          apply (erule_tac x=l2 in allE, erule impE, assumption)
          apply clarsimp
apply (subgoal_tac " preserved ((S1, \<Gamma>, H), N, T1, \<Delta>, K) ((ad, ae, bb), af, ag, ah, bc)", rule, assumption)
prefer 2 apply (rotate_tac -2, erule thin_rl) apply (rotate_tac -3, erule thin_rl)
         apply (simp add: preserved_def, clarsimp)
         apply (rule, erule contained_transitive, assumption)
         apply (rule, erule SetTriv101, assumption)
         apply (erule SetTriv101, assumption)
apply (rule, rule, rule)
apply (rule, rule, rule)
apply (rule, rule, rule)
apply (rule, rule, rule)
apply (rule, rule, rule)
apply (rule, rule, rule)
apply (rule, rule, rule)
apply (rule, rule, rule)
apply (erule eval_cases) apply clarsimp apply clarsimp 
apply (drule InvokeVElim1) apply assumption apply clarify 
apply (erule eval_cases) apply clarsimp apply clarsimp 
apply (drule InvokeVElim1) apply assumption apply clarify 
apply clarsimp
apply (simp add: RSD_sum_def, clarsimp)
apply (simp add: mbody_is_def, clarsimp)
apply (erule_tac x=d in allE, erule impE)
  apply (rule subclass_of_trans)
    apply (erule InvV_InvokerIsSubclass) apply assumption apply assumption apply assumption apply (erule AL_sum3, assumption)
    apply assumption
apply (erule_tac x=da in allE, erule impE)
  apply (rule subclass_of_trans)
    apply (rule InvV_InvokerIsSubclass) apply (erule sat_symm) apply assumption apply assumption apply assumption 
      apply (erule AL_sum3, assumption)
    apply assumption
apply (erule_tac x=code1a in allE, erule_tac x=code1aa in allE, erule_tac x=l1a in allE, erule impE)
  apply (rule_tac x=CDEFc in exI, simp)
apply (erule_tac x=l1aa in allE, erule impE)
  apply (rule_tac x=CDEFe in exI, simp)
apply (erule_tac x=n in allE, erule impE, assumption)
apply (rotate_tac -1, erule_tac x=ka in allE, erule_tac x=kb in allE, erule impE, erule Arith_15) 
apply (subgoal_tac "d1 : ObjIDs afa")
prefer 2 apply (rotate_tac -1, erule thin_rl)
         apply (simp add: sat_def welldef_def, clarsimp)
         apply (rule SetTriv, erule AL_domI) apply (rule SetTriv101, erule AL_sum3b) apply (erule State_welldef_D_Heap_ObjIDs)
apply (subgoal_tac "d2 : ObjIDs afa")
prefer 2 apply (rotate_tac -1, erule thin_rl)
         apply (simp add: sat_def welldef_def, clarsimp)
         apply (rule SetTriv, erule AL_domI) apply (rule SetTriv101, erule AL_sum3b) apply (erule State_welldef_D_Heap_ObjIDs)
apply (simp add: ObjIDs_def, clarsimp)
apply (frule_tac d=d1 and c=d2 in InvVInvV_satFrame)
  apply assumption apply assumption
  apply assumption apply assumption
  apply (simp add: SD_sum_def) apply (rule,simp) apply (rule,assumption) apply assumption
  apply (simp add: SD_sum_def) apply (rule,simp) apply (rule,assumption) apply assumption
  apply assumption apply assumption
apply (erule_tac x="[]" in allE, erule_tac x="Sa[this\<mapsto>(RVal (Loc ar))]" in allE, erule_tac x=bd in allE)
apply (erule_tac x=hh in allE, erule_tac x=va in allE, clarsimp)
apply (erule_tac x="[]" in allE, erule_tac x="Saa[this\<mapsto>(RVal (Loc an))]" in allE, erule_tac x=baa in allE)
apply (erule_tac x=hha in allE, erule_tac x=vb in allE, clarsimp)
apply (erule_tac x=Ha in allE, erule_tac x=Na in allE, erule_tac x=Ka in allE)
apply (erule_tac x=bba in allE, erule_tac x=afa in allE, erule_tac x=bca in allE)
apply (subgoal_tac "AL_dom HH \<inter> AL_dom Ha = {}")
prefer 2 apply (rotate_tac -1, erule thin_rl) 
         apply (rotate_tac 12) apply (erule thin_rl)
         apply (rule_tac Y="AL_dom bb" in SetTriv103)
           apply (simp add: preserved_def)
           apply assumption
apply (frule_tac N=HH in AL_sum_exists_AL)
apply (erule exE, rename_tac HHa, erule conjE)
apply (subgoal_tac "AL_dom KK \<inter> AL_dom Ka = {}")
prefer 2 apply (rotate_tac -4, erule thin_rl) 
         apply (rotate_tac 15) apply (erule thin_rl)
         apply (rule_tac Y="AL_dom bc" in SetTriv103)
           apply (simp add: preserved_def)
           apply assumption
apply (frule_tac N=KK in AL_sum_exists_AL)
apply (erule exE, rename_tac KKa, erule conjE)
apply (subgoal_tac "AL_dom NN \<inter> AL_dom Na = {}")
prefer 2 apply (rotate_tac -7, erule thin_rl) 
         apply (rotate_tac 18) apply (erule thin_rl)
         apply (rule_tac Y="AL_dom af" in SetTriv103)
           apply (simp add: preserved_def, (erule conjE)+) apply (erule contained5)
           apply assumption
apply (frule_tac N=NN in AL_sum_exists_AL)
apply (erule exE, rename_tac NNa, erule conjE)
apply (erule_tac x=HHa in allE, erule_tac x=NNa in allE, erule_tac x=KKa in allE)
apply (erule_tac x=I in allE, erule_tac x=J in allE)
apply clarsimp
apply (erule_tac x=ma in allE, erule_tac x=mb in allE, erule impE, erule Arith_16) 
apply (erule_tac x="va # os" in allE, erule_tac x=aaa in allE, erule_tac x=hh in allE)
apply (erule_tac x=h in allE, erule_tac x=v in allE, clarsimp)
apply (erule_tac x="vb # osa" in allE, erule_tac x=aca in allE, erule_tac x=hha in allE)
apply (erule_tac x=k in allE, erule_tac x=w in allE, clarsimp)
apply (erule_tac x=Ha in allE, erule_tac x=Na in allE, erule_tac x=Ka in allE)
apply (erule_tac x=HHa in allE, erule_tac x=NNa in allE, erule_tac x=KKa in allE, clarsimp)
apply (erule_tac x=bda in allE, erule_tac x=ak in allE, erule_tac x=be in allE, clarsimp)
apply (subgoal_tac "contained afa NNa")
prefer 2 apply (simp add: preserved_def, (erule conjE)+)
         apply (erule contained8, assumption, assumption) 
apply (erule_tac x=I1 in allE, erule_tac x=J1 in allE, erule impE)
  apply (erule  InvVInvV_satFinal) apply assumption apply assumption apply assumption apply assumption apply assumption
                                   apply assumption apply assumption apply assumption apply assumption
                                   apply assumption apply assumption apply assumption 
                                   apply (simp add: preserved_def)
                                   apply (rule_tac H=HHa and X="AL_dom NNa" in HP_good_subset)
                                     apply (simp add: sat_def welldef_def State_welldef_def State_good_def)
                                       apply (simp add: AL_sum_def)
                                       apply simp
                                   apply (rule_tac H=KKa and X="AL_dom NNa" in HP_good_subset)
                                     apply (simp add: sat_def welldef_def State_welldef_def State_good_def)
                                       apply (simp add: AL_sum_def)
                                       apply simp
                                   apply assumption
apply clarsimp
apply (rule_tac x=I1a in exI, rule_tac x=J1a in exI)
apply clarsimp
  apply (erule_tac x=c in allE, erule impE, assumption)
  apply (erule_tac x=c in allE, erule impE) apply (erule contained6,assumption)
  apply (erule conjE)+
  apply rule apply (rotate_tac -1, erule thin_rl) apply (rotate_tac -2, erule thin_rl) 
               apply (drule_tac \<Gamma>=\<Gamma> and NN=NNa and aa=aaa in InvV_Invariant) apply assumption apply assumption 
                 apply (simp add: sat_def welldef_def)
                 apply (simp add: sat_def welldef_def)
                 apply assumption
                 apply (simp add: AL_sum_def preserved_def, clarsimp) apply rule apply fast apply fast
                 apply (simp add: Invariant_def, clarsimp)
                 apply rule apply rule apply(erule impE, assumption) 
                            apply (erule impE) apply (erule SetTriv, erule contained_ObjIds_subset) apply simp
                 apply (erule SetTriv101) apply assumption
  apply (rotate_tac -2, erule thin_rl) apply (rotate_tac -2, erule thin_rl) 
               apply (drule_tac \<Gamma>=\<Delta> and NN=NNa and aa=aca in InvV_Invariant) apply assumption apply assumption 
                 apply (simp add: sat_def welldef_def)
                 apply (simp add: sat_def welldef_def)
                 apply assumption
                 apply (simp add: AL_sum_def preserved_def, clarsimp) apply rule apply fast apply fast
                 apply (simp add: Invariant_def, clarsimp)
                 apply rule apply rule apply(erule impE, assumption) 
                            apply (erule impE) apply (erule SetTriv, erule contained_ObjIds_subset) apply simp
                 apply (erule SetTriv101) apply assumption
done

end