theory RuleUniInvS = UniSatSec + InvokeBasics:

lemma UniInvS_unisat_Frame:
  "\<lbrakk> unisat (ops, s, h) \<Sigma> NN I; 
     (S1, P1, \<Gamma>1, S) \<in> absFrame; 
     (ops, P1, ss, ops1) \<in> Frame; 
     SD_sum (S1, \<Gamma>, H) Ha \<Sigma>; bb=snd(snd \<Sigma>)\<rbrakk>
   \<Longrightarrow> unisat ([], ss, h) ([], \<Gamma>1, bb) NN I"
apply (simp add: unisat_def)
apply (case_tac \<Sigma>, clarsimp)
apply (simp add: SD_sum_def)
apply (erule conjE)+
apply (rule, clarsimp) 
  apply (erule absFrame_State_welldef) apply assumption
apply (erule absFrame_InvS_StateSatisfiesAbstraction) apply assumption apply assumption
done


lemma Uni_InvS_SoundUni: 
  "\<lbrakk>get_ins M l = Some (invokeS C m); mbody_is C m (P1, code, l0); \<Sigma> = (S1, \<Gamma>, H); (S1, P1, \<Gamma>1, S) \<in> absFrame; \<Pi> = (c # S, \<Gamma>, HH);
        L = {l + 1};
        AL_dom H \<subseteq> AL_dom HH; contained N NN; NN \<in> AL; UniBS_UniSecN n ([], \<Gamma>1, H) N HH c NN (P1, code, l0) l0\<rbrakk>
       \<Longrightarrow> UniSS_UniSecN (Suc n) \<Sigma> N \<Pi> NN M l L"
apply (unfold UniSS_UniSecN_def)
apply rule apply simp
apply (rule, assumption)
apply (rule, rule)
apply (rule allI)+
apply (rule impI)+
apply clarsimp
apply (drule InvokeSElim1) apply assumption apply clarify 
apply (simp add: mbody_is_def) apply clarsimp
apply (unfold UniBS_UniSecN_def)
apply (erule conjE)+
apply (erule_tac x=k in allE)
apply (erule impE, assumption)
apply (frule UniInvS_unisat_Frame) apply assumption apply assumption apply assumption apply simp
apply (erule_tac x="([], SS, b)" in allE)
apply (erule_tac x=I in allE, erule_tac x=hh in allE)
apply (erule_tac x=v in allE, erule_tac x=Ha in allE)
apply (erule_tac x=Nx in allE, erule_tac x=N0 in allE)
apply (erule_tac x="([], \<Gamma>1, bb)" in allE)
apply (erule_tac x="([c], emp, bc)" in allE)
apply (erule_tac x=N1 in allE)
apply (erule impE, assumption)
apply (erule impE, simp add: SD_sum_def)
apply (erule impE, simp add: SD_sum_def)
apply (erule impE, assumption)
apply (erule impE, assumption)
apply (erule impE, assumption)
apply (erule impE, assumption)
apply (erule impE, assumption)
apply (erule impE, assumption)
apply (erule impE, simp)
apply (erule impE, simp)
apply (erule impE, assumption)
apply (erule impE, assumption)
apply (erule exE)+ apply (erule conjE)+
apply (rule_tac x=I1 in exI)
apply (subgoal_tac "contained N0 N1") 
prefer 2 apply (simp (no_asm) add: contained_def, clarsimp)
         apply (drule AL_sum_split, assumption)
         apply (erule disjE)
           apply (erule AL_sum3) apply (erule contained3, assumption) 
           apply (erule AL_sum4, assumption)
apply rule
(*Goal: unisat*)
  apply (simp add: unisat_def SD_sum_def, clarsimp)
  apply rule apply (erule Invoke_Final_State_welldef) apply assumption apply assumption apply assumption apply assumption
                apply assumption apply assumption
  apply (rule InvS_StateSatisfiesAbstraction) apply assumption apply assumption apply assumption
               apply assumption apply assumption apply assumption apply assumption 
               prefer 3 apply assumption prefer 3 apply assumption prefer 3 apply assumption
               apply assumption apply (rule contained_refl) apply assumption
apply clarsimp
(*Goal: Invariant I*)
         apply (simp add: SD_sum_def) apply clarsimp
         apply (erule_tac x=ca in allE, erule impE, assumption) 
          apply (rule InvS_Invariant) apply assumption apply assumption apply assumption 
            apply (simp add: unisat_def)
            apply (simp add: unisat_def, (erule conjE)+) apply assumption  
            apply assumption
            apply (simp add: AL_sum_def) apply fastsimp
done

end