theory RuleUniInvV =  UniSatSec + InvokeBasics:

lemma UniInvV_unisatFrame:
  "\<lbrakk> unisat (ops, s, h) (T,\<Delta>,K) NN I; 
     (S1, P1, \<Gamma>1, d # S) \<in> absFrame;
     (ops, P1, ss, RVal (Loc an) # ops1) \<in> Frame; 
     SD_sum (S1, \<Gamma>, H) Ha (T,\<Delta>,K);
     NN\<down>d = Some (classTP C)\<rbrakk>
   \<Longrightarrow> unisat ([], ss[this\<mapsto>(RVal (Loc an))], h) ([], \<Gamma>1[this\<mapsto>d], K) NN I"
apply (simp add: unisat_def, clarsimp)
apply (frule AL_domI)
apply (simp add: SD_sum_def)
apply (erule conjE)+
apply (rule, erule absFrame_State_welldefInvV, assumption)
apply (erule absFrame_InvV_StateSatisfiesAbstraction, assumption+) 
done

lemma Uni_InvV3_SoundUni:
   "\<lbrakk>get_ins M l = Some (invokeV C m); mbody_is C m (P1, code, l0); \<Sigma> = (S1, \<Gamma>, H); (S1, P1, \<Gamma>1, d # S) \<in> absFrame; H\<down>d = Some (D, F);
        \<Pi> = (c # S, \<Gamma>, HH); L = {l + 1};
        \<forall>E . subclass_of E D \<longrightarrow>
           (\<exists>  code1 l1 . mbody_is E m (P1, code1, l1) \<and>
           (U, ([], \<Gamma>1[this\<mapsto>d], H), N, (P1, code1, l1), l1, True, HH, c, NN) \<in> UniBS \<and>
           (\<forall>n k S \<Gamma> Ha.
               UniCtxtUniValidN n U \<longrightarrow>
               ([], \<Gamma>1[this\<mapsto>d], H) = (S, \<Gamma>, Ha) \<longrightarrow>
               (True \<longrightarrow> k = n) \<longrightarrow>
               (\<not> True \<longrightarrow> k = Suc n) \<longrightarrow> AL_dom Ha \<subseteq> AL_dom HH \<and> contained N NN \<and> UniBS_UniSecN k ([], \<Gamma>1[this\<mapsto>d], H) N HH c NN (P1, code1, l1) l1));
        UniCtxtUniValidN n U; AL_dom H \<subseteq> AL_dom HH; contained N NN; NN \<in> AL\<rbrakk>
       \<Longrightarrow> UniSS_UniSecN (Suc n) \<Sigma> N \<Pi> NN M l L"
apply (unfold UniSS_UniSecN_def)
apply rule apply simp
apply (rule, assumption)
apply (rule, rule)
apply (rule allI)+
apply (rule impI)+
apply clarsimp
apply (drule InvokeVElim1) apply assumption apply clarify 
apply (erule exE)+ apply (erule conjE)+
apply (simp add: mbody_is_def) apply clarsimp
apply (erule_tac x=da in allE)
apply (erule impE) apply (simp add: SD_sum_def, clarsimp) 
                   apply (frule AL_sum3, assumption)
                   apply (erule InvV_InvokerIsSubclassUni) apply assumption apply assumption apply assumption apply assumption
apply clarsimp
apply (rotate_tac -2, erule thin_rl)
apply (erule_tac x=n in allE, erule impE, assumption)
apply (unfold UniBS_UniSecN_def)
apply (erule conjE)+
apply (erule_tac x=k in allE)
apply (erule impE, assumption)
apply (subgoal_tac "(\<exists>C. N0\<down>d = Some (classTP C) \<and>
             subclass_of D C \<and> (\<exists>a. I d = Some a \<and> (\<exists>aa ba. b\<down>a = Some (aa, ba) \<and> Object_typecorrect N0 (D, F) (aa, ba))))")
prefer 2 apply (rotate_tac -1, erule thin_rl) 
         apply (simp add: unisat_def StateSatisfiesAbstraction_def, (erule conjE)+)
         apply (simp add: State_typecorrect_def, (erule conjE)+) 
         apply (simp add: Heap_typecorrect_expand)
         apply (erule_tac x=d in allE, erule_tac x=D in allE, erule_tac x=F in allE, erule mp)
         apply (simp add: SD_sum_def, (erule conjE)+) apply (erule AL_sum3) apply assumption
apply clarify
apply (frule UniInvV_unisatFrame) apply assumption apply assumption apply assumption apply assumption
apply (erule_tac x="([], Sa[this\<mapsto>(RVal (Loc ah))], b)" in allE)
apply (erule_tac x=I in allE, erule_tac x=hh in allE)
apply (erule_tac x=v in allE, erule_tac x=Ha in allE)
apply (erule_tac x=Nx in allE, erule_tac x=N0 in allE)
apply (erule_tac x="([], \<Gamma>1[this\<mapsto>d], bb)" in allE, erule_tac x="([c], emp, bc)"  in allE)
apply (erule_tac x=N1 in allE)
apply (erule impE, assumption)
apply (erule impE, simp add: SD_sum_def)
apply (erule impE, simp add: SD_sum_def)
apply (erule impE, assumption)
apply (erule impE, assumption)
apply (erule impE, assumption)
apply (erule impE, assumption)
apply (erule impE, assumption)
apply (erule impE, assumption)
apply (erule impE, simp)
apply (erule impE, simp)
apply (erule impE, assumption)
apply (erule impE, assumption)
apply (erule exE)+ apply (erule conjE)+
apply (rule_tac x=I1 in exI)
apply (subgoal_tac "contained N0 N1") 
prefer 2 apply (simp (no_asm) add: contained_def, clarsimp)
         apply (drule_tac c=ac in AL_sum_split, assumption)
         apply (erule disjE)
           apply (erule AL_sum3) apply (erule contained3, assumption) 
           apply (erule AL_sum4, assumption)
apply rule
prefer 2 apply (simp add: SD_sum_def) apply clarsimp
         apply (rotate_tac -7) 
         apply( erule_tac x=ca in allE, clarsimp) 
         apply (erule InvV_Invariant) apply assumption apply assumption 
            apply (simp add: unisat_def)
            prefer 2 apply assumption
            apply (simp add: unisat_def)
            apply (simp add: AL_sum_def) apply fast
apply (simp add: unisat_def SD_sum_def, clarsimp)
  apply rule apply (erule InvokeV_Final_State_welldef) apply assumption apply assumption apply assumption apply assumption
                apply assumption apply assumption 
  apply (erule InvV_StateSatisfiesAbstraction) apply assumption+ 
done

end