theory UnaryRenSound = UnaryRen:

lemma RenAuxStateSatisfiesAbstraction:
"\<lbrakk>renUniState ((S, \<Gamma>, H), N) f ((fS, f\<Gamma>, fH), fN); renUniState ((S', \<Gamma>', H'), N') g ((gS', g\<Gamma>', gH'), gN'); \<forall>c fc. f c = Some fc \<longrightarrow> g c = Some fc; LEQ p q;
        inj_on g (dom g - dom f); Img g (dom g - dom f) \<inter> Img g (dom f) = {}; AL_dom H \<subseteq> AL_dom H'; contained N N'; AL_dom fH \<subseteq> AL_dom gH'; contained fN gN';
        AL_dom gN' \<inter> ran fa = {}; AL_sum gN' NN gN'NN; fN_NN \<in> AL; fH_HH \<in> AL; gH'_HH \<in> AL; gN'NN \<in> AL; 
        AL_sum fN NN fN_NN; AL_sum fH HH fH_HH; AL_dom fH \<inter> AL_dom HH = {}; AL_sum gH' HH gH'_HH; AL_dom gH' \<inter> AL_dom HH = {}; AL_dom Na = dom fa; AL_dom NN = ran fa;
        dom fa \<inter> AL_dom N' = {}; inj_on fa (dom fa); (N, f ++ fa, fN) \<in> MapN; AL_sum N Na N_Na; N_Na \<in> AL; (N_Na, f ++ fa, ffa_N_Na) \<in> MapN; AL_sum fN NN ffa_N_Na;
        HP_good HH (AL_dom ffa_N_Na); (Ha, f ++ fa, HH) \<in> MapHP; Ha \<in> AL; AL_dom Ha \<subseteq> ObjIDs N_Na; inj_on (f ++ fa) (AL_dom Ha); HP_good Ha (AL_dom N_Na);
        HPdom_is Ha (f ++ fa) HH N_Na; AL_dom H' \<inter> AL_dom Ha = {}; AL_sum H' Ha H'Ha; AL_dom H \<inter> AL_dom Ha = {}; AL_sum H Ha H_Ha; H_Ha \<in> AL; Na \<in> AL; NN \<in> AL;
        AL_dom H \<subseteq> ObjIDs N; (H, f ++ fa, fH) \<in> MapHP; (H_Ha, f ++ fa, fH_HHmap) \<in> MapHP; AL_sum fH HH fH_HHmap;
        inj_on (f ++ fa) (ObjIDs N_Na);  AL_sum N' Na N'Na; N'Na \<in> AL; l1 \<in> L;
        (Na, g ++ fa, NN) \<in> MapN; \<forall>c. c \<in> AL_dom N' \<longrightarrow> (g ++ fa) c = g c; contained N_Na N'Na; (Ha, g ++ fa, HH) \<in> MapHP; HP_good H' (AL_dom N');
        (H', g ++ fa, gH') \<in> MapHP;  (N'Na, g ++ fa, gfa_N'Na) \<in> MapN; AL_sum gN' NN gfa_N'Na; (H'Ha, g ++ fa, gfa_H'Ha) \<in> MapHP;
        AL_sum gH' HH gfa_H'Ha; contained ffa_N_Na gfa_N'Na; inj_on (g ++ fa) (ObjIDs N'Na);
        State_welldef (fS, f\<Gamma>, fH_HH) ffa_N_Na; State_welldef (S', \<Gamma>', H'Ha) N'Na; State_welldef (gS', g\<Gamma>', gfa_H'Ha) gfa_N'Na;
        StateSatisfiesAbstraction (ops1, s1, h1) (fS, f\<Gamma>, fH_HH) ffa_N_Na I; 
        StateSatisfiesAbstraction (ops, s, h) (S', \<Gamma>', H'Ha) N'Na I1;
        \<forall>c. c \<in> AL_dom N_Na \<longrightarrow>
            Invariant c (S', \<Gamma>', H'Ha) (ops, s, h) I1 N_Na (S, \<Gamma>, H_Ha) (ops1, s1, h1) (map_compose I (f ++ fa))\<rbrakk>
       \<Longrightarrow> StateSatisfiesAbstraction (ops, s, h) (gS', g\<Gamma>', gfa_H'Ha) gfa_N'Na (map_compose I1 (Invv (g ++ fa)))"
             apply (simp add:  StateSatisfiesAbstraction_def, clarsimp)            
             apply (subgoal_tac "State_typecorrect gfa_N'Na (gS', g\<Gamma>', gfa_H'Ha) (ops, s, h) (map_compose I1 (Invv (g ++ fa)))")
             prefer 2 apply (simp add: Renames_STATE_def  renUniState_def State_typecorrect_def, clarsimp)
               apply (rule, simp add: Opstack_typecorrect_def, clarsimp)
                 apply (frule_tac S=S' and f=g in MAP_OPSTACK_length, clarsimp) 
                 apply (erule_tac x=n in allE, clarsimp)
                 apply (drule_tac S=S' and f=g  in MAP_OPSTACK_lookupL, assumption) apply simp apply clarsimp
                 apply (subgoal_tac "S'!n : AL_dom N'")
                 prefer 2 apply (simp add: State_noDangColours_def, clarsimp)
                 apply (drule_tac d="S'!n" in AL_domD, clarsimp)                          
                 apply (frule_tac f=g in MapN_TypePreserving)
                 apply (drule TypePreserving_D) apply assumption apply assumption
                 apply (rule_tac x=tp in exI, clarsimp)
                 apply (drule_tac H=N' in AL_sum3, assumption) apply clarsimp
                 apply (erule AL_sum3) apply assumption
               apply (rule, simp add: Store_typecorrect_def, clarsimp)
                 apply (frule_tac t=g\<Gamma>' in MAP_STORE_D_right, assumption) apply clarsimp
                 apply (erule_tac x=x in allE, clarsimp) 
                 apply (drule MAP_STORE_D_left, assumption) apply clarsimp
                 apply (frule_tac f=g in MapN_TypePreserving)
                 apply (subgoal_tac "ca : AL_dom N'")
                 prefer 2 apply (simp add: State_noDangColours_def, clarsimp)    
                 apply (drule_tac d=ca in AL_domD, clarsimp)                     
                 apply (drule TypePreserving_D, assumption) apply assumption
                 apply (rule_tac x=tp in exI, clarsimp)
                 apply (drule_tac H=N' in AL_sum3, assumption) apply clarsimp
                 apply (erule AL_sum3) apply assumption                          
               apply (simp add: Heap_typecorrect_def, clarsimp)
                 apply (drule AL_domD, clarsimp)
                 apply (frule_tac N=H'Ha in MapHP_D_right, assumption) apply clarsimp
                 apply (erule_tac x=ca in allE, erule impE, erule AL_domI) apply clarsimp
                 apply (frule_tac N=N'Na in MapN_TypePreserving)
                 apply (frule_tac fc=c in TypePreserving_D) apply assumption apply (erule disjE, clarsimp) apply clarsimp apply (simp add: map_add_def) 
                 apply clarsimp
                 apply (subgoal_tac "c \<in> dom (map_compose I1 (Invv (g ++ fa)))")
                 prefer 2 apply clarsimp 
                          apply (case_tac "(Invv (g ++ fa)) c")
                            apply (drule InvvD_None) apply (rotate_tac -1, erule_tac x=ca in allE) 
                             apply (erule disjE, clarsimp) apply clarsimp apply (simp add: map_add_def) 
                          apply (frule_tac g=I1 and f="Invv (g ++ fa)" in map_composeD1)
                          apply (subgoal_tac "aa=ca", clarsimp)
                          apply (drule InvvD_Some) 
                          apply (erule_tac f="g++fa" in inj_onD) apply clarsimp 
                             apply (erule disjE) apply (erule disjE, clarsimp) apply simp 
                             apply clarsimp apply (simp add: map_add_def)
                            apply (subgoal_tac "aa: AL_dom N'Na", drule_tac d=aa in AL_domD, clarsimp)
                              apply (drule_tac c=aa and fc=c in TypePreserving_D, assumption)
                                 apply (rotate_tac -2, erule disjE, clarsimp) apply (simp add: map_add_def)
                              apply (simp add: ObjIDs_def)
                            apply (simp add: AL_sum_def map_add_def) apply clarsimp
                            apply (simp add: ObjIDs_def)                          
                apply (simp add: HeapAbstractsAt_def, clarsimp)
                  
                     apply (drule map_composeD3) apply clarsimp apply (drule InvvD_Some)
                       apply (drule_tac f="g++fa" and x=ca and y=ba in inj_onD, simp) 
                         apply (erule disjE, clarsimp) apply (simp add: map_add_def)
                         apply (simp add: ObjIDs_def)
                         apply (subgoal_tac "ba:AL_dom N'Na") 
                           apply (drule_tac d=ba in AL_domD, clarsimp)
                              apply (drule_tac c=ba and fc=c in TypePreserving_D, assumption)
                                 apply (rotate_tac -2, erule disjE, clarsimp) apply (simp add: map_add_def)
                              apply (simp add: ObjIDs_def)
                          apply (simp add: AL_sum_def map_add_def) apply clarsimp
                       apply clarsimp
                     apply (erule Ren_Fields_tc2, assumption) apply assumption
             apply (rule, assumption)
             apply (subgoal_tac "Renames_STATE (S', \<Gamma>', H'Ha) (g ++ fa) (gS', g\<Gamma>', gfa_H'Ha)")
                     prefer 2 apply (simp add: Renames_STATE_def renUniState_def, (erule conjE)+)
                              apply (rule, erule Ren_fg_Map_OPSTACK)
                                apply (case_tac "fa c") apply (simp add: map_add_def)
                                apply (drule_tac X="dom fa" in SetTriv106) apply (erule domI) apply (erule domI) apply simp 
                             apply (erule Ren_fg_Map_STORE)
                               apply (case_tac "fa c") apply (simp add: map_add_def)
                               apply (drule_tac X="dom fa" in SetTriv106) apply (erule domI) apply (erule domI) apply simp
             apply (subgoal_tac "Renames_STATE (S, \<Gamma>, H_Ha) (f ++ fa) (fS, f\<Gamma>, fH_HHmap)")
                     prefer 2 apply (simp add: Renames_STATE_def renUniState_def, (erule conjE)+)
                              apply (rule, erule Ren_fg_Map_OPSTACK)
                                apply (case_tac "fa c") apply (simp add: map_add_def)
                                apply (drule_tac X="dom fa" and x=c and y=c in SetTriv106) apply (erule domI) apply clarsimp apply simp
                              apply (erule Ren_fg_Map_STORE)
                                apply (case_tac "fa c") apply (simp add: map_add_def)
                                apply (drule_tac X="dom fa" and x=c and y=c in SetTriv106) apply (erule domI) apply clarsimp apply simp 
             apply (subgoal_tac "State_welldef (fS, f\<Gamma>, fH_HHmap) ffa_N_Na")
                     prefer 2 apply (rule State_welldef_HPextensional, assumption) apply (erule AL_sum_extensional, assumption) 
                                  apply (erule MapHP_AL_right)
             apply (subgoal_tac "State_welldef (S, \<Gamma>, H_Ha) N_Na") 
                     prefer 2 apply (rule Ren_State_welldef, assumption) 
                                apply assumption
                                apply assumption 
                                apply (rule Renames_noDangColours) prefer 2 apply (simp add: Renames_STATE_def renUniState_def) apply assumption
                                      apply assumption apply (simp add: State_welldef_def State_noDangColours_def)
                                      apply assumption apply assumption apply assumption apply assumption  apply assumption  apply assumption
             apply (rule, simp add: uniqueValues_def, clarsimp) 
                     apply (frule SetTriv, rule_tac S=S' and \<Gamma>=\<Gamma>' and H=H'Ha and f="g ++ fa" in Renames_STATE_DOM1) apply assumption
                     apply (simp add: Img_def, clarsimp)
                     apply (erule_tac x=sa in allE, erule impE, assumption)
                     apply (erule exE)
                     apply (rule_tac x=v in exI, rule)
                       apply (rule SetTriv101)
                         apply (rule_tac S=S' and \<Gamma>=\<Gamma>' and H=H'Ha and N=N'Na in Ren_ValuesRepresented2)
                           apply assumption 
                           apply assumption 
                           apply assumption 
                           apply assumption  
                           apply assumption
                           apply (simp add: renUniState_def)
                             apply (drule_tac M=gfa_N'Na in MapN_AL) apply clarsimp
                             apply (subgoal_tac "Img (g ++ fa) (dom (g ++ fa)) = ran (g ++ fa)")
                             prefer 2  apply(rule Img_dom_ran)
                             apply (subgoal_tac "(AL_dom N'Na) = (dom (g ++ fa))", clarsimp) apply(simp add: AL_sum_def) apply fast
                           apply(simp add: renUniState_def AL_sum_def) apply fast
                           apply (drule_tac M=gfa_N'Na in MapN_AL) apply (simp add: Img_def) apply (rule_tac x=sa in exI,rule)
                             apply (simp add: State_welldef_contract, (erule conjE)+) apply (erule SetTriv, assumption)
                             apply (erule disjE, simp) apply (simp add: map_add_def)
                         apply clarsimp
                       apply (case_tac "sa=d", clarsimp) 
                       apply (subgoal_tac "v:ValuesRepresented sa (S', \<Gamma>', H'Ha) (ops, s, h) I1")
                       prefer 2 apply clarsimp
                       apply (rotate_tac -5, erule thin_rl)
                       apply (erule disjE)
                         apply (erule disjE)
                           apply (drule_tac f=fa and A="dom fa" and x=sa and y=d in inj_onD, simp) apply (erule domI) apply (erule domI) apply simp
                           apply clarsimp apply (drule_tac X="AL_dom gN'" and x=c and y=c in SetTriv106)
                             apply (simp add: renUniState_def, (erule conjE)+)
                               apply (drule_tac N=N' in MapN_dom, simp add: Img_def) apply (rule_tac x=sa in exI, clarsimp)
                               apply (erule ranI)
                             apply simp
                       apply (erule disjE, clarsimp)
                         apply (drule_tac X="AL_dom gN'" and x=c and y=c in SetTriv106)
                             apply (erule thin_rl, simp add: renUniState_def, (erule conjE)+)
                               apply (drule_tac N=N' in MapN_dom, simp add: Img_def) apply (rule_tac x=d in exI, clarsimp)
                               apply (erule ranI)
                             apply simp
                       apply clarsimp
                       apply (case_tac "sa:AL_dom N")
                         apply (subgoal_tac "Invariant sa (S', \<Gamma>', H'Ha) (ops, s, h) I1 N_Na (S, \<Gamma>, H_Ha) (ops1, s1, h1) (map_compose I (f ++ fa))")
                         prefer 2 apply (erule_tac x=sa in allE, erule mp, simp add: AL_sum_def) (*apply simp*)
                         apply (case_tac "d:AL_dom N")
                         prefer 2 apply (drule_tac x=c and y=c in SetTriv106) 
                                  apply clarsimp apply (rule_tac x=d in exI, simp add: renUniState_def) apply (erule domI)
                                  apply clarsimp apply (rule_tac x=sa in exI, simp add: renUniState_def) 
                                  apply simp
                         apply (subgoal_tac "d:AL_dom N_Na") prefer 2 apply (simp add: AL_sum_def) 
                         apply (erule_tac x=d in allE, erule impE, assumption) 
                           apply (simp add: Invariant_def ValRepEQ, (erule conjE)+)
                           apply (drule_tac x=x in SetTriv, assumption) 
                           apply (case_tac "d:DOM (S, \<Gamma>, H_Ha)") 
                           prefer 2 apply (drule_tac \<tau>="(ops1, s1, h1)" and J="(map_compose I (f ++ fa))" in ValuesRepresented_notin_DOM) apply simp
                           apply (simp add: renUniState_def, (erule conjE)+)
                           apply (drule_tac a=d in domD, erule exE)
                           apply (subgoal_tac "c : DOM (fS, f\<Gamma>, fH_HH)")
                             apply (erule_tac x=c in allE, erule impE, assumption) apply clarsimp                
                             apply (drule_tac x=x in SetTriv, rule_tac T=fS and \<Delta>=f\<Gamma> and K=fH_HHmap and N=N_Na in Ren_ValuesRepresented) 
                               apply assumption
                               apply assumption
                               apply assumption
                               apply assumption
                               apply (simp add: map_add_def)
                             apply (drule_tac x=v in SetTriv, assumption)
                             apply (drule_tac x=v in SetTriv, rule_tac T=fS and \<Delta>=f\<Gamma> and K=fH_HHmap and N=N_Na in Ren_ValuesRepresented) 
                               apply assumption
                               apply assumption
                               apply assumption
                               apply assumption
                               apply (simp add: map_add_def)
                             apply (subgoal_tac "ValuesRepresented c (fS, f\<Gamma>, fH_HHmap) (ops1, s1, h1) I = 
                                                 ValuesRepresented c (fS, f\<Gamma>, fH_HH) (ops1, s1, h1) I", clarsimp)
                             apply (rule ValuesRepresented_HPextensional)
                               apply (erule AL_sum_extensional) apply assumption
                           apply (subgoal_tac "DOM (fS, f\<Gamma>, fH_HH) = DOM (fS, f\<Gamma>, fH_HHmap)", clarsimp)
                           prefer 2 apply (rule DOM_HP_extensional) apply (erule AL_sum_extensional) apply assumption
                           apply (rule_tac X="Img (f++fa) (DOM (S, \<Gamma>, H_Ha))" in SetTriv)
                           apply (simp add: Img_def) apply (rule_tac x=d in exI, simp add: map_add_def)
                           apply (erule Renames_STATE_DOM2) 
                           apply (erule_tac X="ObjIDs N_Na" in inj_on_subset)
                           apply (simp add: State_welldef_def)
                       apply (case_tac "d:AL_dom N")
                         apply (drule_tac x=c and y=c in SetTriv106) 
                           apply clarsimp apply (rule_tac x=sa in exI, clarsimp) apply (rule, erule domI) apply (simp add: renUniState_def)
                           apply clarsimp apply (rule_tac x=d in exI, simp add: renUniState_def)
                           apply simp
                       apply (drule_tac x=sa and y=d in inj_onD, simp)
                         apply (simp add: renUniState_def) apply (erule domI)
                         apply (simp add: renUniState_def) apply (erule domI)
                         apply simp
                   apply (subgoal_tac "Values_Represented c (gS', g\<Gamma>', gfa_H'Ha) (ops, s, h) (map_compose I1 (Invv (g ++ fa))) \<noteq> {}")
                   prefer 2 apply (erule_tac N=gfa_N'Na in State_typecorrect_VR_notEmpty) apply assumption
                   apply (subgoal_tac "\<exists> w . w : ValuesRepresented c (gS', g\<Gamma>', gfa_H'Ha) (ops, s, h) (map_compose I1 (Invv (g ++ fa)))", erule exE)
                   prefer 2 apply (simp add: ValRepEQ) apply (erule SetXXX)
                   apply (frule_tac x=w and Y="{u . \<exists>d. (g ++ fa) d = Some c \<and> u: ValuesRepresented d (S', \<Gamma>', H'Ha) (ops, s, h) I1}" in SetTriv) 
                     apply (rule_tac N=N'Na in Ren_ValuesRepresented2) apply assumption apply assumption apply assumption  apply assumption
                        apply assumption
                           apply (simp add: renUniState_def)
                             apply (drule_tac M=gfa_N'Na in MapN_AL) apply clarsimp
                             apply (subgoal_tac "Img (g ++ fa) (dom (g ++ fa)) = ran (g ++ fa)")
                             prefer 2  apply(rule Img_dom_ran)
                             apply (subgoal_tac "(AL_dom N'Na) = (dom (g ++ fa))", clarsimp) apply(simp add: AL_sum_def) apply fast
                           apply(simp add: renUniState_def AL_sum_def) apply fast
                           apply (drule_tac M=gfa_N'Na in MapN_AL) apply (simp add: Img_def) apply (rule_tac x=sa in exI,rule)
                             apply (simp add: State_welldef_contract, (erule conjE)+) apply (erule SetTriv, assumption)
                             apply (erule disjE, simp) apply (simp add: map_add_def)
                         apply clarsimp
                       apply (case_tac "sa=d", clarsimp) 
                       apply (subgoal_tac "v:ValuesRepresented sa (S', \<Gamma>', H'Ha) (ops, s, h) I1")
                       prefer 2 apply clarsimp
                       apply (rotate_tac -7, erule thin_rl)
                       apply (erule disjE)
                         apply (erule disjE)
                           apply (drule_tac f=fa and A="dom fa" and x=sa and y=d in inj_onD, simp) apply (erule domI) apply (erule domI) apply simp
                           apply clarsimp apply (drule_tac X="AL_dom gN'" and x=c and y=c in SetTriv106)
                             apply (simp add: renUniState_def, (erule conjE)+)
                               apply (drule_tac N=N' in MapN_dom, simp add: Img_def) apply (rule_tac x=sa in exI, clarsimp)
                               apply (erule ranI)
                             apply simp
                       apply (erule disjE, clarsimp)
                         apply (drule_tac X="AL_dom gN'" and x=c and y=c in SetTriv106)
                             apply (erule thin_rl, simp add: renUniState_def, (erule conjE)+)
                               apply (drule_tac N=N' in MapN_dom, simp add: Img_def) apply (rule_tac x=d in exI, clarsimp)
                               apply (erule ranI)
                             apply simp
                       apply clarsimp
                       apply (case_tac "sa:AL_dom N")
                         apply (subgoal_tac "Invariant sa (S', \<Gamma>', H'Ha) (ops, s, h) I1 N_Na (S, \<Gamma>, H_Ha) (ops1, s1, h1) (map_compose I (f ++ fa))")
                         prefer 2 apply (erule_tac x=sa in allE, erule mp, simp add: AL_sum_def) (*apply simp*)
                         apply (case_tac "d:AL_dom N")
                         prefer 2 apply (drule_tac x=c and y=c in SetTriv106) 
                                  apply clarsimp apply (rule_tac x=d in exI, simp add: renUniState_def) apply (erule domI)
                                  apply clarsimp apply (rule_tac x=sa in exI, simp add: renUniState_def) 
                                  apply simp
                         apply (subgoal_tac "d \<in> AL_dom N_Na") prefer 2 apply (simp add: AL_sum_def)
                         apply (erule_tac x=d in allE, erule impE, assumption)
                           apply (simp add: Invariant_def ValRepEQ, (erule conjE)+)
                           apply (drule_tac x=w in SetTriv, assumption) 
                           apply (case_tac "d:DOM (S, \<Gamma>, H_Ha)") 
                           prefer 2 apply (drule_tac \<tau>="(ops1, s1, h1)" and J="(map_compose I (f ++ fa))" in ValuesRepresented_notin_DOM) apply simp
                           apply (simp add: renUniState_def, (erule conjE)+)
                           apply (drule_tac a=d in domD, erule exE)
                           apply (subgoal_tac "c : DOM (fS, f\<Gamma>, fH_HH)")
                             apply (erule_tac x=c in allE, erule impE, assumption) apply clarsimp
                             apply (drule_tac x=w and X="ValuesRepresented d (S, \<Gamma>, H_Ha) (ops1, s1, h1) (map_compose I (f ++ fa))" in SetTriv)
                             apply (rule_tac T=fS and \<Delta>=f\<Gamma> and K=fH_HHmap and N=N_Na in Ren_ValuesRepresented) 
                               apply assumption
                               apply assumption
                               apply assumption
                               apply assumption
                               apply (simp add: map_add_def)
                             apply (drule_tac x=v in SetTriv, assumption)
                             apply (drule_tac x=v in SetTriv, rule_tac T=fS and \<Delta>=f\<Gamma> and K=fH_HHmap and N=N_Na in Ren_ValuesRepresented) 
                               apply assumption
                               apply assumption
                               apply assumption
                               apply assumption
                               apply (simp add: map_add_def)
                             apply (subgoal_tac "ValuesRepresented c (fS, f\<Gamma>, fH_HHmap) (ops1, s1, h1) I = 
                                                 ValuesRepresented c (fS, f\<Gamma>, fH_HH) (ops1, s1, h1) I", clarsimp)
                             apply (rule ValuesRepresented_HPextensional)
                               apply (erule AL_sum_extensional) apply assumption
                           apply (subgoal_tac "DOM (fS, f\<Gamma>, fH_HH) = DOM (fS, f\<Gamma>, fH_HHmap)", clarsimp)
                           prefer 2 apply (rule DOM_HP_extensional) apply (erule AL_sum_extensional) apply assumption
                           apply (rule_tac X="Img (f++fa) (DOM (S, \<Gamma>, H_Ha))" in SetTriv)
                           apply (simp add: Img_def) apply (rule_tac x=d in exI, simp add: map_add_def)
                           apply (erule Renames_STATE_DOM2) 
                           apply (erule_tac X="ObjIDs N_Na" in inj_on_subset)
                           apply (simp add: State_welldef_def)
                       apply (case_tac "d:AL_dom N")
                         apply (drule_tac x=c and y=c in SetTriv106) 
                           apply clarsimp apply (rule_tac x=sa in exI, clarsimp) apply (rule, erule domI) apply (simp add: renUniState_def)
                           apply clarsimp apply (rule_tac x=d in exI, simp add: renUniState_def)
                           apply simp
                       apply (drule_tac x=sa and y=d in inj_onD, simp)
                         apply (simp add: renUniState_def) apply (erule domI)
                         apply (simp add: renUniState_def) apply (erule domI)
                         apply simp
    apply (rule, simp add: renUniState_def Renames_STATE_def, (erule conjE)+)
      apply (drule_tac S=S' in MAP_OPSTACK_length) apply simp
    apply (rule, clarsimp)
      apply (frule SetTriv, erule Renames_STATE_DOM1) apply(simp add: Img_def) apply (erule exE, erule conjE)
      apply (case_tac "map_compose I1 (Invv (g ++ fa)) x", clarsimp) prefer 2 apply (rule, assumption)
        apply (drule map_composeD4) 
        apply (rotate_tac -1, erule disjE)
          apply (drule InvvD_None) apply (rotate_tac -1, erule_tac x=sa in allE) apply (rotate_tac -2, erule disjE, clarsimp) apply (simp add: map_add_def)
        apply clarsimp apply (drule InvvD_Some) apply clarsimp
         apply (subgoal_tac "sa:ObjIDs N'Na")
         prefer 2 apply (simp add: ObjIDs_def, clarsimp)
                  apply (drule_tac x=sa and Y="AL_dom N'Na" in SetTriv) apply (simp add: State_welldef_contract) 
                  apply (drule AL_domD, clarsimp)
                  apply (drule_tac N=N'Na in MapN_D_left, assumption) apply clarsimp apply (erule disjE) apply clarsimp apply clarsimp 
         apply (subgoal_tac "sa : dom I1")
         prefer 2 apply (rule SetTriv) prefer 2 apply assumption apply clarsimp                  
         apply (case_tac "sa=b", clarsimp)
         apply (subgoal_tac "b: ObjIDs N'Na")
         prefer 2 apply (subgoal_tac "b:AL_dom N'Na", drule_tac d=b in AL_domD, clarsimp) 
                    apply (drule_tac N=N'Na and f="g++fa" in MapN_D_left, assumption) apply clarsimp 
                    apply (rotate_tac -1, erule disjE, clarsimp) apply (simp add: ObjIDs_def)
                    apply clarsimp apply (simp add: ObjIDs_def)
                  apply (simp add: renUniState_def AL_sum_def)
                   apply (rotate_tac -4, erule disjE) apply (rule disjI2, erule domI) apply (erule conjE, rule disjI1, erule domI)
         apply (drule_tac A="ObjIDs N'Na" and x=sa and y=b in inj_onD) 
           apply (rotate_tac -7, erule disjE) 
             apply (erule disjE) apply (simp add: map_add_def) apply (simp add: map_add_def)
             apply (erule disjE) apply (simp add: map_add_def) apply (simp add: map_add_def) 
           apply assumption 
           apply assumption 
         apply clarsimp
    apply (simp (no_asm) add: inj_on_def, clarsimp)
      apply (subgoal_tac "y:dom (map_compose I1 (Invv (g ++ fa)))", clarsimp)
      prefer 2 apply (simp add: State_typecorrect_def Heap_typecorrect_def, (erule conjE)+)
               apply (rotate_tac -1, erule_tac x=y in allE, clarsimp)
      apply (drule map_composeD3) apply (drule map_composeD3) apply clarsimp
      apply (drule_tac d=x in AL_domD) apply clarsimp
      apply (frule_tac N=H'Ha in MapHP_D_right, assumption) apply clarsimp
      apply (drule InvvD_Some) apply clarsimp 
      apply (subgoal_tac "b=c", clarsimp)
      prefer 2 apply (erule_tac A="ObjIDs N'Na" in inj_onD) 
                 apply (erule disjE) apply (erule disjE) apply (simp add: map_add_def) apply (simp add: map_add_def)
                                     apply (erule disjE) apply (simp add: map_add_def) apply (simp add: map_add_def)
                 prefer 2 apply (rule SetTriv) prefer 2 apply (erule State_welldef_D_Heap_ObjIDs) apply (erule AL_domI)
                 apply (subgoal_tac "x:ObjIDs gfa_N'Na")
                 prefer 2 apply (rule SetTriv) prefer 2 apply (erule State_welldef_D_Heap_ObjIDs) apply (erule AL_domI)
                 apply (subgoal_tac "b:AL_dom N'Na", drule_tac d=b in AL_domD, clarsimp)
                   apply (drule_tac N=N'Na in MapN_D_left, assumption) apply clarsimp
                   apply (rotate_tac -1, erule disjE, clarsimp) apply (simp add: ObjIDs_def) apply (simp add: ObjIDs_def)
                 apply (simp add: renUniState_def AL_sum_def) 
                   apply (rotate_tac -2, erule disjE) apply (rule disjI2, erule domI) apply (erule conjE, rule disjI1, erule domI)
      apply (drule_tac d=y in AL_domD) apply clarsimp
      apply (drule_tac N=H'Ha and fc=y in MapHP_D_right, assumption) apply clarsimp
      apply (drule InvvD_Some) apply clarsimp 
      apply (subgoal_tac "ba=ca", clarsimp)
      prefer 2 apply (erule_tac A="ObjIDs N'Na" in inj_onD) 
                 apply (rotate_tac -4, erule disjE) apply (erule disjE) apply (simp add: map_add_def) apply (simp add: map_add_def)
                                     apply (erule disjE) apply (simp add: map_add_def) apply (simp add: map_add_def)
                 prefer 2 apply (rule SetTriv) prefer 2 apply (erule State_welldef_D_Heap_ObjIDs) apply (erule AL_domI)
                 apply (subgoal_tac "y:ObjIDs gfa_N'Na")
                 prefer 2 apply (rule SetTriv) prefer 2 apply (erule State_welldef_D_Heap_ObjIDs) apply (erule AL_domI)
                 apply (subgoal_tac "ba:AL_dom N'Na", drule_tac d=ba in AL_domD, clarsimp)
                   apply (drule_tac N=N'Na and c=ba in MapN_D_left, assumption) apply clarsimp
                   apply (rotate_tac -1, erule disjE, clarsimp) apply (simp add: ObjIDs_def) apply (simp add: ObjIDs_def)
                 apply (simp add: renUniState_def AL_sum_def) 
                   apply (rotate_tac -2, erule disjE) apply (rule disjI2, erule domI) apply (erule conjE, rule disjI1, erule domI)
      apply (drule_tac x=c and y=ca and A="AL_dom H'Ha" and f=I1 in inj_onD) apply simp apply (erule AL_domI) apply (erule AL_domI)
        apply clarsimp apply (erule disjE) apply clarsimp apply clarsimp 
done

lemma Ren_unisat:
  "\<lbrakk>unisat (ops, s, h) (fS, f\<Gamma>, fH) fN I; 
                   renUniState ((S, \<Gamma>, H), N) f ((fS, f\<Gamma>, fH), fN)\<rbrakk>
               \<Longrightarrow> unisat (ops, s, h) (S, \<Gamma>, H) N (map_compose I f)"
apply (simp add: unisat_def renUniState_def, clarsimp)
apply (subgoal_tac "State_welldef (S, \<Gamma>, H) N", simp)
prefer 2 
  apply (erule Ren_State_welldef) apply assumption apply assumption apply assumption apply assumption
apply (erule Ren_StateStateAbstr) apply assumption apply assumption apply assumption apply assumption apply assumption apply simp
done

lemma map_add_aux_I:
"\<lbrakk>fa d = Some c \<or> fa d = None \<and> g d = Some c; \<forall>c fc. f c = Some fc \<longrightarrow> g c = Some fc; d \<in> dom fa \<or> d \<in> dom f\<rbrakk> \<Longrightarrow> (f ++ fa) d = Some c"
apply (erule disjE) apply (simp add: map_add_def)
apply (erule disjE, clarsimp) apply clarsimp apply (simp add: map_add_def)
done

lemma Uni_Ren_Invariant2:
" \<lbrakk> Invariant ca (S', \<Gamma>', H'Ha) (ops, s, h) I1 N_Na (S, \<Gamma>, H_Ha) (ops1, s1, h1) (map_compose I (f ++ fa));
    renUniState ((S, \<Gamma>, H), N) f ((fS, f\<Gamma>, fH), fN); renUniState ((S', \<Gamma>', H'), N') g ((gS', g\<Gamma>', gH'), gN');
    (N_Na, f ++ fa, ffa_N_Na) \<in> MapN; (Na, g ++ fa, NN) \<in> MapN; (N'Na, g ++ fa, gfa_N'Na) \<in> MapN;
    (Ha, f ++ fa, HH) \<in> MapHP; (H_Ha, f ++ fa, fH_HHmap) \<in> MapHP; 
    (H'Ha, g ++ fa, gfa_H'Ha) \<in> MapHP; 

    inj_on (g ++ fa) (ObjIDs N'Na); AL_dom H \<subseteq> AL_dom H'; 
        
    AL_sum gH' HH gH'_HH; 
        \<forall>c fc. f c = Some fc \<longrightarrow> g c = Some fc; inj_on g (dom g - dom f); Img g (dom g - dom f) \<inter> Img g (dom f) = {};
        contained N N';  contained fN gN'; AL_dom gN' \<inter> ran fa = {};
        AL_sum gN' NN gN'NN; 
        AL_sum fN NN fN_NN; AL_sum fH HH fH_HH;  AL_dom fH \<inter> AL_dom HH = {}; 
        AL_dom Na = dom fa; AL_dom NN = ran fa; dom fa \<inter> AL_dom N' = {}; inj_on fa (dom fa); 
        AL_sum N Na N_Na;AL_sum fN NN ffa_N_Na;
        AL_dom Ha \<subseteq> ObjIDs N_Na; inj_on (f ++ fa) (AL_dom Ha); HP_good Ha (AL_dom N_Na);
        HPdom_is Ha (f ++ fa) HH N_Na; AL_dom H' \<inter> AL_dom Ha = {}; AL_sum H' Ha H'Ha; AL_dom H \<inter> AL_dom Ha = {};
        AL_sum H Ha H_Ha; AL_dom H \<subseteq> ObjIDs N;
        AL_sum fH HH fH_HHmap; H_Ha \<in> AL;gH'_HH \<in> AL; gN'NN \<in> AL;
        inj_on (f ++ fa) (ObjIDs N_Na); AL_sum N' Na N'Na; 
        \<forall>c. c \<in> AL_dom N_Na \<longrightarrow>
            Invariant c (S', \<Gamma>', H'Ha) (ops, s, h) I1 N_Na (S, \<Gamma>, H_Ha) (ops1, s1, h1) (map_compose I (f ++ fa));
        \<forall>c. c \<in> AL_dom N' \<longrightarrow> (g ++ fa) c = g c; contained N_Na N'Na; 
        HP_good H' (AL_dom N');  
        AL_sum gN' NN gfa_N'Na; (H'Ha, g ++ fa, gfa_H'Ha) \<in> MapHP; AL_sum gH' HH gfa_H'Ha;
        State_welldef (gS', g\<Gamma>', gfa_H'Ha) gfa_N'Na; contained ffa_N_Na gfa_N'Na;
       
        fN_NN\<down>c = Some a; ffa_N_Na\<down>c = Some a; N_Na\<down>ca = Some a; fa ca = Some c \<or> fa ca = None \<and> f ca = Some c;
        AL_dom N_Na = dom (f ++ fa); HP_good HH (AL_dom ffa_N_Na);
        unisat (ops1, s1, h1) (fS, f\<Gamma>, fH_HH) ffa_N_Na I ; 
        unisat (ops, s, h) (S', \<Gamma>', H'Ha) N'Na I1\<rbrakk>
       \<Longrightarrow> Invariant c (gS', g\<Gamma>', gH'_HH) (ops, s, h) (map_compose I1 (Invv (g ++ fa))) fN_NN (fS, f\<Gamma>, fH_HH) (ops1, s1, h1) I"
apply (simp (no_asm) add: Invariant_def)
  apply rule apply (rotate_tac -17) apply (erule thin_rl) 
             apply (simp add: Invariant_def, clarsimp)
             apply (rotate_tac -2, erule thin_rl) 
             apply (erule impE) apply (simp add: ObjIDs_def)
             apply (subgoal_tac "(f ++ fa) ca = Some c") apply (drule_tac g=I and f="f++fa" in map_composeD1, clarsimp)
               apply (subgoal_tac "(Invv (g ++ fa)) c = Some ca") apply (drule_tac g=I1 and f="Invv (g++fa)" in map_composeD1, clarsimp)
               apply (subgoal_tac "c:ran (g++fa)")
               prefer 2 apply (rule_tac a=ca in ranI) apply (erule disjE) apply (simp add: map_add_def) apply clarsimp apply (simp add: map_add_def)
               apply (drule f_Invv_f) apply clarsimp
               apply (erule disjE)
                 apply (erule disjE) apply (erule_tac A="dom fa" in inj_onD) apply simp apply (erule domI) apply (erule domI)
                 apply clarsimp apply (drule_tac X="AL_dom gN'" and x=c and y=c in SetTriv106)
                                  apply (simp add: renUniState_def, (erule conjE)+)
                                    apply (drule_tac M=gN' and f=g in MapN_dom) apply (simp add: Img_def) apply (rule_tac x=x in exI, clarsimp)
                                  apply (erule ranI)
                                apply simp
               apply clarsimp
               apply (erule disjE) apply (drule_tac X="AL_dom gN'" and x=c and y=c in SetTriv106)
                                     apply (simp add: renUniState_def, (erule conjE)+)
                                       apply (drule_tac M=gN' and f=g in MapN_dom) apply (simp add: Img_def) apply (rule_tac x=ca in exI, clarsimp)
                                     apply (erule ranI)
                                   apply simp
               apply clarsimp
                 apply (case_tac "x:dom f")
                   apply (simp add: renUniState_def, (erule conjE)+)
                   apply (erule_tac A="ObjIDs N" in inj_onD, clarsimp)
                     apply (subgoal_tac "x : AL_dom N", drule AL_domD, clarsimp)
                       apply (drule_tac N=N and f=f in MapN_D_left, assumption) apply clarsimp
                       apply (drule_tac H=fN and x=c in AL_sum3, assumption)
                       apply (simp add: ObjIDs_def)
                     apply clarsimp
                   apply (simp add: ObjIDs_def) 
                     apply (subgoal_tac "ca : AL_dom N", drule AL_domD, clarsimp)
                       apply (drule_tac H=N and x=ca in AL_sum3, assumption) apply clarsimp
                     apply clarsimp
                 apply (drule_tac X="Img g (dom g - dom f)" and x=c and y=c in SetTriv106)
                   apply (simp add: Img_def) apply (rule_tac x=x in exI, clarsimp)
                   apply (simp add: Img_def) apply (rule_tac x=ca in exI, clarsimp)
                   apply simp
             apply (erule disjE) apply (simp add: map_add_def) apply (simp add: map_add_def)
  apply (subgoal_tac "Renames_STATE (S, \<Gamma>, H_Ha) (f ++ fa) (fS, f\<Gamma>, fH_HHmap)")
  prefer 2 apply (rotate_tac -17) apply(erule thin_rl) apply (simp add: Renames_STATE_def renUniState_def, clarsimp)
                                                           apply (rule, erule_tac Y="AL_dom N" in MAP_OPSTACK_Fun_eqOn[rule_format]) 
                                                               apply (case_tac "cb : dom fa") apply (drule_tac X="dom fa" and x=cb and y=cb in SetTriv106)
                                                                                                apply assumption apply clarsimp apply simp
                                                               apply (subgoal_tac "fa cb = None", clarsimp) apply (simp add: map_add_def)
                                                               apply clarsimp
                                                             apply (simp add: State_noDangColours_def)
                                                           apply (erule_tac Y="AL_dom N" in MAP_STORE_Fun_eqOn[rule_format]) 
                                                               apply (case_tac "cb : dom fa") apply (drule_tac X="dom fa" and x=cb and y=cb in SetTriv106)
                                                                                                apply assumption apply clarsimp apply simp
                                                               apply (subgoal_tac "fa cb = None", clarsimp) apply (simp add: map_add_def)
                                                               apply clarsimp
                                                             apply (simp add: State_noDangColours_def)

  apply (subgoal_tac "AL_dom gfa_N'Na = ran (g ++ fa)")
  prefer 2 apply (erule thin_rl) apply (rotate_tac -18) apply (erule thin_rl)
           apply (drule_tac M=gfa_N'Na in MapN_dom) apply (simp add: Img_dom_ran)
                                           apply (simp add: Img_def AL_sum_def renUniState_def) apply clarsimp
                                           apply (frule_tac M=gN' in MapN_dom) apply (simp add: Img_dom_ran)
                                           apply (subgoal_tac "ran (g ++ fa) = ran g \<union> ran fa", clarsimp) 
                                           apply (rule ran_map_add_on_disj_doms) apply (erule SetTriv108)
  apply (subgoal_tac "State_welldef (S, \<Gamma>, H_Ha) N_Na")
  prefer 2 apply (erule thin_rl)  apply (rotate_tac -18) apply (erule thin_rl)
           apply (rule_tac L=ffa_N_Na in Ren_State_welldef, assumption)
           apply (simp add: unisat_def, (erule conjE)+)
             apply (erule State_welldef_HPextensional)
             apply (erule AL_sum_extensional, assumption) apply (erule MapHP_AL_right)
           apply assumption
                                                                            apply (erule_tac f=f in Renames_noDangColours) 
                                                                              apply assumption
                                                                              apply assumption
                                                                              apply (rule_tac H= fH_HH in State_no_dangColours_HPextensional)
                                                                                apply (simp add: unisat_def State_welldef_def State_noDangColours_def)
                                                                                apply (erule AL_sum_extensional, assumption)
                                                                                apply (erule MapHP_AL_right)
                                                                              apply assumption
                                                                              apply assumption
                                                                              apply assumption
                                                                              apply (simp add: AL_sum_def)
                                                                              apply assumption
                                                                              apply assumption
  apply (subgoal_tac "\<forall> d . (fa d = Some c \<or> fa d = None \<and> g d = Some c) \<longrightarrow> d \<in> AL_dom N_Na")
  prefer 2 apply (erule thin_rl)  apply (rotate_tac -18) apply (erule thin_rl)
               apply (simp add: renUniState_def AL_sum_def, clarsimp) 
               apply rule apply (rule, rule disjI2) apply (erule domI)
               apply (rule, erule conjE) apply (rule disjI1)
               apply (erule disjE)
                 apply (drule_tac X="AL_dom gN'" and x=c and y=c in SetTriv106)
                 apply (drule_tac M=gN' in MapN_dom) apply (simp add: Img_def) apply (rule_tac x=d in exI, clarsimp)
                 apply (erule ranI)
                 apply simp
               apply clarsimp 
                 apply (case_tac "d:dom f", clarsimp)
                 apply (drule_tac X="Img g (dom g - dom f)" and x=c and y=c in SetTriv106)
                   apply (simp add: Img_def) apply (rule_tac x=d in exI, clarsimp)
                   apply (simp add: Img_def) apply (rule_tac x=ca in exI, clarsimp)
                   apply simp
  apply (simp add: Invariant_def  ValRepEQ, clarsimp)
             apply (erule SetTriv)
             apply (rule SetTriv109) apply (rule_tac HH=gfa_H'Ha in ValuesRepresented_HPextensional) apply (erule AL_sum_extensional) apply assumption
             apply (rule SetTriv101) apply (erule thin_rl)
                                     apply (rule_tac S=S' and \<Gamma>=\<Gamma>' and H=H'Ha and N=N'Na in Ren_ValuesRepresented2)
                                       apply assumption
                                       apply assumption
                                       apply (simp add: unisat_def)
                                       apply assumption 
                                       apply (simp add: Renames_STATE_def renUniState_def, (erule conjE)+)
                                         apply (rule, erule_tac Y="AL_dom N'" in MAP_OPSTACK_Fun_eqOn[rule_format])
                                           apply (erule_tac x=cb in allE, erule mp) apply clarsimp
                                           apply (simp add: State_noDangColours_def)
                                         apply (erule_tac Y="AL_dom N'" in MAP_STORE_Fun_eqOn[rule_format])
                                           apply (erule_tac x=cb in allE, erule mp, clarsimp)
                                           apply (simp add: State_noDangColours_def)
                                       apply assumption 
                                       apply (simp add: AL_sum_def renUniState_def) apply fast
                                       apply (rule SetTriv) apply (erule_tac H=ffa_N_Na in AL_domI) apply (erule contained5)
             apply clarsimp
             apply (subgoal_tac "d \<in> dom fa \<or> d \<in> dom f")
             prefer 2 apply (rotate_tac -6) apply(erule_tac x=d in allE, erule conjE)
                      apply (erule disjE) apply (erule mp, assumption) apply (erule mp, assumption)
             apply (subgoal_tac "(d \<in> ObjIDs N_Na \<longrightarrow> I1 d = map_compose I (f ++ fa) d) \<and>
           ValuesRepresented d (S', \<Gamma>', H'Ha) (ops, s, h) I1 \<subseteq> ValuesRepresented d (S, \<Gamma>, H_Ha) (ops1, s1, h1) (map_compose I (f ++ fa))",
                 (erule conjE)+)
             prefer 2 apply (rotate_tac -1, erule disjE) apply (erule_tac x=d in allE, erule conjE, erule impE, assumption) apply simp
                                                         apply (erule_tac x=d in allE, erule conjE, erule impE, assumption) apply simp
             apply (rotate_tac -28) apply (erule thin_rl) 
             apply (drule_tac x=x in SetTriv, assumption) 
(*             apply (subgoal_tac " x \<in> ValuesRepresented c (fS, f\<Gamma>, fH_HHmap) (ops1, s1, h1) I")*)
             apply (rule SetTriv104) prefer 2 apply (rule_tac H=fH_HHmap in ValuesRepresented_HPextensional) apply (erule AL_sum_extensional, assumption)
                                                  apply (erule SetTriv) apply (rule_tac N=N_Na in Ren_ValuesRepresented)
                                                                          apply assumption
                                                                          apply assumption
                                                                          apply assumption
                                                                          apply assumption
                                                                          apply (erule map_add_aux_I) apply assumption apply assumption
done

lemma Invariant_UniRenAux:
"\<lbrakk>renUniState ((S, \<Gamma>, H), N) f ((fS, f\<Gamma>, fH), fN); renUniState ((S', \<Gamma>', H'), N') g ((gS', g\<Gamma>', gH'), gN');
        \<forall>c fc. f c = Some fc \<longrightarrow> g c = Some fc; inj_on g (dom g - dom f); Img g (dom g - dom f) \<inter> Img g (dom f) = {}; AL_dom H \<subseteq> AL_dom H';
        contained N N'; AL_dom fH \<subseteq> AL_dom gH'; contained fN gN'; AL_sum fN NN fN_NN; AL_dom gN' \<inter> ran fa = {}; AL_sum gN' NN gN'NN; fN_NN \<in> AL;
        fH_HH \<in> AL; gH'_HH \<in> AL; gN'NN \<in> AL; AL_sum fH HH fH_HH; AL_dom fH \<inter> AL_dom HH = {};
        AL_sum gH' HH gH'_HH; AL_dom gH' \<inter> AL_dom HH = {}; AL_dom Na = dom fa; AL_dom NN = ran fa; dom fa \<inter> AL_dom N' = {}; inj_on fa (dom fa);
        (N, f ++ fa, fN) \<in> MapN; AL_sum N Na N_Na; N_Na \<in> AL; (N_Na, f ++ fa, ffa_N_Na) \<in> MapN; AL_sum fN NN ffa_N_Na; inj_on (f ++ fa) (ObjIDs N_Na);
        unisat (ops1, s1, h1) (fS, f\<Gamma>, fH_HH) ffa_N_Na I; HP_good HH (AL_dom ffa_N_Na); (Ha, f ++ fa, HH) \<in> MapHP; Ha \<in> AL; AL_dom Ha \<subseteq> ObjIDs N_Na;
        inj_on (f ++ fa) (AL_dom Ha); HP_good Ha (AL_dom N_Na); HPdom_is Ha (f ++ fa) HH N_Na; AL_dom H' \<inter> AL_dom Ha = {}; AL_sum H' Ha H'Ha;
        H'Ha \<in> AL; AL_dom H \<inter> AL_dom Ha = {}; AL_sum H Ha H_Ha; H_Ha \<in> AL; Na \<in> AL; NN \<in> AL; AL_dom H \<subseteq> ObjIDs N; (H, f ++ fa, fH) \<in> MapHP;
        (H_Ha, f ++ fa, fH_HHmap) \<in> MapHP; AL_sum fH HH fH_HHmap; AL_sum N' Na N'Na; N'Na \<in> AL; l1 \<in> L; unisat (ops, s, h) (S', \<Gamma>', H'Ha) N'Na I1;
        \<forall>c. c \<in> AL_dom N_Na \<longrightarrow> Invariant c (S', \<Gamma>', H'Ha) (ops, s, h) I1 N_Na (S, \<Gamma>, H_Ha) (ops1, s1, h1) (map_compose I (f ++ fa));
        (Na, g ++ fa, NN) \<in> MapN; \<forall>c. c \<in> AL_dom N' \<longrightarrow> (g ++ fa) c = g c; contained N_Na N'Na; (Ha, g ++ fa, HH) \<in> MapHP; HP_good H' (AL_dom N');
        (H', g ++ fa, gH') \<in> MapHP\<rbrakk>
       \<Longrightarrow> unisat (ops, s, h) (gS', g\<Gamma>', gH'_HH) gN'NN (map_compose I1 (Invv (g ++ fa))) \<and>
          (\<forall>c. c \<in> AL_dom fN_NN \<longrightarrow>
               Invariant c (gS', g\<Gamma>', gH'_HH) (ops, s, h) (map_compose I1 (Invv (g ++ fa))) fN_NN (fS, f\<Gamma>, fH_HH) (ops1, s1, h1) I)"
apply (frule_tac fN=gN' and fM=NN and N=N' and NM=N'Na in MapN_sum) 
  apply assumption
  apply assumption
  apply clarsimp 
    apply (erule disjE) 
      apply (subgoal_tac "x:AL_dom Na", frule_tac d=x and H=Na in AL_domD, erule exE)      
      apply (frule_tac f="g++fa" in MapN_D_left, assumption) apply clarsimp
      apply (erule disjE) 
        apply (subgoal_tac "y:AL_dom Na", frule_tac d=y and H=Na in AL_domD, erule exE)
        apply (drule_tac A="dom fa" and x=x and y=y in inj_onD, simp) apply (erule domI) apply (erule domI) apply simp
        apply clarsimp
      apply clarsimp
        apply (subgoal_tac "y:AL_dom N'") prefer 2 apply (simp add: AL_sum_def) apply (erule disjE, assumption) apply clarsimp
        apply (drule_tac d=y and H=N' in AL_domD, erule exE) 
          apply (subgoal_tac "(N',g,gN'):MapN") prefer 2 apply (simp add: renUniState_def)
          apply (frule_tac f=g and c=y in MapN_D_left, assumption) apply clarsimp 
          apply (drule_tac X="AL_dom gN'" in SetTriv106) apply (erule AL_domI) apply (erule ranI) apply simp
        apply clarsimp
      apply clarsimp
        apply (subgoal_tac "x:AL_dom N'") prefer 2 apply (simp add: AL_sum_def) apply (erule disjE, assumption) apply clarsimp
        apply (drule_tac d=x and H=N' in AL_domD, erule exE) 
        apply (subgoal_tac "(N',g,gN'):MapN") prefer 2 apply (simp add: renUniState_def)
        apply (frule_tac f=g and c=x in MapN_D_left, assumption) apply clarsimp 
        apply (erule disjE)
          apply (drule_tac X="AL_dom gN'" in SetTriv106) apply (erule AL_domI) apply (erule ranI) apply simp
        apply clarsimp
        apply (subgoal_tac "y:AL_dom N'") prefer 2 apply (simp add: AL_sum_def) apply (erule disjE, assumption) apply clarsimp
        apply (drule_tac d=y and H=N' in AL_domD, erule exE) 
        apply (frule_tac f=g and c=y in MapN_D_left, assumption) apply clarsimp 
        apply (frule_tac x=x in AL_sum3, assumption)
        apply (frule_tac x=y in AL_sum3, assumption)
        apply simp
  apply (simp add: AL_sum_def, clarsimp)
    apply rule apply (subgoal_tac "(N',g,gN'):MapN") prefer 2 apply (simp add: renUniState_def)
               apply (drule_tac N=N' in MapN_domf) apply (erule_tac Y=" dom g" in SetTriv101) apply fast
         apply fast
  apply (subgoal_tac "(N',g,gN'):MapN") prefer 2 apply (simp add: renUniState_def)
    apply (erule MapN_extend_f)
    apply (subgoal_tac "fa x = None", simp add: map_add_def)
    apply (case_tac "x:dom fa")
      apply (drule_tac X="dom fa" in SetTriv106) apply assumption apply assumption apply simp
    apply clarsimp
apply (erule exE, rename_tac gfa_N'Na, erule conjE)
apply (subgoal_tac "inj_on (g++fa) (ObjIDs N'Na)")
prefer 2 apply (erule thin_rl) apply (simp add: renUniState_def, clarsimp)
                        apply (erule inj_on_MapN_sum) apply assumption+
apply (drule_tac NM=H'Ha and fM=HH and f="g++fa" and fN=gH' and X="AL_dom N'Na" in MapHP_sum) 
  apply assumption
  apply assumption
  apply assumption
  apply (erule HP_good_subset, rule contained_refl) apply (erule AL_sum3b)
  apply (erule HP_good_subset, rule contained_refl) apply (simp add: AL_sum_def) 
      apply rule apply (rule SetTriv101) apply (erule contained5) apply fast 
                 apply fast
  apply (erule MapN_domf)
  apply (erule MapHP_domf)
  apply (erule MapHP_domf)
  apply (erule_tac X="ObjIDs N'Na" in inj_on_subset) 
    apply (erule SetTriv101) apply (erule contained_ObjIds_subset) 
  apply (erule_tac X="ObjIDs N'Na" in inj_on_subset)
     apply (rule_tac Y="ObjIDs N'" in SetTriv101) apply (simp add: renUniState_def State_noDangColours_def) 
    apply (rule contained_ObjIds_subset) apply (simp add: AL_sum_def)
  apply (rule, rule, clarsimp)
    apply (simp add: Img_def, clarsimp)
    apply (subgoal_tac "sa:AL_dom N'")
    prefer 2 apply (erule_tac X="AL_dom H'" in SetTriv) apply (simp add: renUniState_def State_noDangColours_def, clarsimp)
                                  apply (drule_tac x=xa and X="AL_dom H'" in SetTriv, assumption)  apply clarsimp
    apply (case_tac "sa:AL_dom Na") apply (drule_tac X="dom fa" and x=sa and y=sa in SetTriv106) apply clarsimp
                                     apply assumption apply simp
    apply (subgoal_tac "fa sa = None", clarsimp) prefer 2 apply clarsimp
    apply (erule disjE) 
      apply (drule_tac X="AL_dom gN'" and x=x and y=x in SetTriv106) 
        apply (simp add: renUniState_def, (erule conjE)+) apply (drule_tac N=N' in MapN_dom) 
          apply (simp add: Img_def) apply (rule_tac x=sa in exI, simp) 
        apply (erule ranI) 
        apply simp 
    apply clarsimp apply (drule_tac A="ObjIDs N'Na" and x=sa and y=saa in inj_onD, simp) apply (simp add: map_add_def) 
                     apply (erule SetTriv) apply (rule_tac Y="ObjIDs N'" in SetTriv101) 
                                             apply (simp add: renUniState_def State_noDangColours_def)
                                           apply (rule contained_ObjIds_subset) apply (simp add: AL_sum_def) 
                     apply (erule SetTriv) apply (erule SetTriv101) apply (erule contained_ObjIds_subset) 
                     apply clarsimp
                       apply (drule_tac X="AL_dom H'" in SetTriv106) apply assumption apply assumption apply simp
   apply fast
apply (erule exE, rename_tac gfa_H'Ha, erule conjE)
apply (subgoal_tac "State_welldef (gS', g\<Gamma>', gfa_H'Ha) gfa_N'Na")
prefer 2 apply (rotate_tac -12) apply(erule thin_rl)
         apply (simp add: unisat_def, clarsimp)
           apply (rule_tac f="g++fa" in Ren_State_welldef2) apply assumption apply assumption
             apply (simp add: renUniState_def Renames_STATE_def, (erule conjE)+)
             apply (rule, erule_tac Y="AL_dom N'" in MAP_OPSTACK_Fun_eqOn[rule_format])
               apply (erule_tac x=c in allE, erule mp, clarsimp)
               apply (simp add: State_noDangColours_def)
             apply (erule_tac Y="AL_dom N'" in MAP_STORE_Fun_eqOn[rule_format])
               apply (erule_tac x=c in allE, erule mp, clarsimp)
               apply (simp add: State_noDangColours_def)
             apply assumption 
apply (subgoal_tac "contained ffa_N_Na gfa_N'Na")
prefer 2 apply (simp (no_asm) add: contained_def, clarsimp)
         apply (drule AL_sum_split, assumption)
         apply (erule disjE)
           apply (drule contained3, assumption) apply (erule AL_sum3, assumption)
         apply (erule AL_sum4, assumption)

apply (subgoal_tac "unisat (ops, s, h) (gS', g\<Gamma>', gfa_H'Ha) gfa_N'Na (map_compose I1 (Invv (g ++ fa)))")

prefer 2 apply (simp add: unisat_def, clarsimp)
     apply (erule_tac S=S and \<Gamma>=\<Gamma> and H=H and N=N and f=f and fS=fS and f\<Gamma>=f\<Gamma> and fH=fH and fN=fN and 
                      S'=S' and \<Gamma>'=\<Gamma>' and H'=H' and N'=N' and g=g and gS'=gS' and g\<Gamma>'=g\<Gamma>' and gH'=gH' and gN'=gN' and 
                      fa=fa and NN=NN and gN'NN=gN'NN and fN_NN=fN_NN and fH_HH=fH_HH and gH'_HH=gH'_HH and
                      I=I in RenAuxStateSatisfiesAbstraction) apply assumption+
       
apply rule
    apply (rule unisat_HPextensional)
      apply (erule unisat_MPextensional) apply (erule AL_sum_extensional, assumption) apply assumption
      apply (erule AL_sum_extensional, assumption) apply assumption
apply clarsimp
apply (drule_tac d=c in AL_domD, clarsimp)
    apply (subgoal_tac "ffa_N_Na\<down>c = Some x")
    prefer 2 apply (subgoal_tac "\<forall> x y . (fN_NN\<down>x = Some y) = (ffa_N_Na\<down>x = Some y)", fast) 
             apply (erule AL_sum_extensional) apply assumption 
    apply (frule MapN_D_right, assumption) apply clarsimp
apply (subgoal_tac "Invariant ca (S', \<Gamma>', H'Ha) (ops, s, h) I1 N_Na (S, \<Gamma>, H_Ha) (ops1, s1, h1) (map_compose I (f ++ fa))")
prefer 2 apply (erule_tac x=ca in allE, erule mp) apply (erule AL_domI)
(*Invariant I*)
apply (subgoal_tac "AL_dom N_Na = dom (f++fa)")
prefer 2 apply (rotate_tac -20) apply (erule thin_rl, simp add: renUniState_def AL_sum_def) apply fast
apply (rule_tac fa=fa and N'Na=N'Na and  S'=S' and \<Gamma>'=\<Gamma>' and H'Ha=H'Ha and ops=ops and s=s and h=h 
        and N_Na=N_Na and S=S and \<Gamma>=\<Gamma> and H_Ha=H_Ha and I=I 
        and f=f and Na=Na and g=g and NN=NN and N'=N' and Ha=Ha and HH=HH and H'=H' and gH'=gH'
        and gfa_N'Na=gfa_N'Na and gN'=gN' and gfa_H'Ha=gfa_H'Ha and gS'=gS'
        and g\<Gamma>'=g\<Gamma>' and ffa_N_Na=ffa_N_Na 
        and H=H and N=N and fS=fS and f\<Gamma>=f\<Gamma> and fH=fH and fN=fN
        and gN'NN=gN'NN and fN_NN=fN_NN and fH_HH=fH_HH and gH'_HH=gH'_HH 
        and fH_HHmap=fH_HHmap in Uni_Ren_Invariant2)
apply (assumption, assumption, assumption, assumption, assumption)
apply (assumption, assumption, assumption, assumption, assumption)
apply (assumption, assumption, assumption, assumption, assumption)
apply (assumption, assumption, assumption, assumption, assumption)
apply (assumption, assumption, assumption, assumption, assumption)
apply (assumption, assumption, assumption, assumption, assumption)
apply (assumption, assumption, assumption, assumption, assumption)
apply (assumption, assumption, assumption, assumption, assumption)
apply (assumption, assumption, assumption) apply assumption
apply (assumption, assumption, assumption, assumption, assumption)
apply (assumption, assumption, assumption, assumption, assumption)
apply (assumption, assumption, assumption, assumption, assumption)
apply assumption
done

lemma UnaryRen_UniSound:
  "\<lbrakk> renUniState (\<Sigma>,N) f (f\<Sigma>,fN); renUniState (\<Pi>,N') g (g\<Pi>,gN');
     \<forall>c fc. f c = Some fc \<longrightarrow> g c = Some fc; 
     inj_on g (dom g - dom f); Img g (dom g - dom f) \<inter> Img g (dom f) = {};
     UniSS_UniSecN nn \<Sigma> N \<Pi> N' M l L\<rbrakk>
     \<Longrightarrow> UniSS_UniSecN nn f\<Sigma> fN g\<Pi> gN' M l L"
apply (unfold UniSS_UniSecN_def, (erule conjE)+)
apply (subgoal_tac "AL_dom (snd (snd f\<Sigma>)) \<subseteq> AL_dom (snd (snd g\<Pi>)) \<and>
       contained fN gN'", (erule conjE)+)
prefer 2 apply (rotate_tac -1, erule thin_rl)
         apply (erule renUniState_preserved, assumption+)
apply (rule, assumption)
apply (rule, assumption)
apply (rule, rule, rule)
apply (erule_tac x=n in allE, erule impE, assumption)
apply (rotate_tac -2, erule thin_rl)
apply (rule allI)+
apply (rule impI)+
apply (case_tac f\<Sigma>, clarsimp) 
apply (case_tac \<Sigma>, clarsimp)
apply (case_tac g\<Pi>, clarsimp) 
apply (case_tac \<Pi>, clarsimp) 
apply (simp add: SD_sum_def, clarsimp)
apply (rename_tac n ops1 s1 h1 I l1 ops s h  HH NN fN_NN fH_HH gH'_HH gN'NN fS f\<Gamma> fH S \<Gamma> H gS' g\<Gamma>' gH' S' \<Gamma>' H')
(*apply (rename_tac n ops1 s1 h1 ops2 s2 h2 qa I J l1 ops s h HH NN fN_NN fH_HH gH'_HH gN'NN ffa_T 
                  ffa_\<Delta> ffa_K fS f\<Gamma> fH S \<Gamma> H gS' g\<Gamma>' gH' S' \<Gamma>' H')*)
apply (erule_tac x=ops1 in allE, erule_tac x=s1 in allE, erule_tac x=h1 in allE)
apply (drule_tac M=NN and X="AL_dom N'" in MapN_InvExists)
apply ((erule exE)+, (erule conjE)+)
apply (drule_tac N=Na and g="f++fa" in MapN_extend_f) apply clarsimp
apply (subgoal_tac "(N,f,fN):MapN") prefer 2 apply (simp add: renUniState_def)
apply (drule_tac N=N and g="f++fa" in MapN_extend_f) 
  apply (rotate_tac -7, erule thin_rl) apply clarsimp 
  apply (drule contained6, assumption)
  apply (subgoal_tac "fa x = None", simp add: map_add_def)
  apply (case_tac "x:dom fa")
   apply (drule_tac X="dom fa" and Y="AL_dom N'" and x=x and y=x in SetTriv106) apply assumption apply assumption apply simp
  apply clarsimp
apply (subgoal_tac "AL_dom N \<inter> AL_dom Na = {}")
prefer 2 apply (rule SetTriv103) apply (erule contained5) apply (erule SetTriv108) 
apply (drule_tac N=N in AL_sum_exists_AL) apply (erule exE, erule conjE) apply (rename_tac N_Na)
apply (frule_tac fN=fN and fM=NN in MapN_sum) 
  prefer 5 apply assumption
  prefer 2 apply assumption
  apply assumption
  apply clarsimp apply (rotate_tac -13, erule thin_rl) 
    apply (simp add: AL_sum_def)
    apply (erule disjE) apply (frule_tac m=fa and a=x in domI)
      apply (erule disjE) apply (frule_tac m=fa and a=y in domI)
        apply (drule_tac A="dom fa" and x=x and y=y in inj_onD, simp) apply assumption apply assumption apply simp
      apply clarsimp apply (erule disjE) apply (drule_tac X="AL_dom gN'" and x=fx and y=fx in SetTriv106)
                                           apply (rule SetTriv) prefer 2 apply (erule contained5) 
                                             apply (simp add: renUniState_def, clarsimp) 
                                             apply (drule_tac N=N and f=f in MapN_dom) apply (simp add: Img_def) apply (rule_tac x=y in exI, simp) apply (erule domI)
                                           apply (erule ranI)
                                         apply simp
                     apply clarsimp
    apply clarsimp apply (erule disjE) 
                     apply (erule disjE) apply (drule_tac X="AL_dom gN'" and x=fx and y=fx in SetTriv106)
                                           apply (rule SetTriv) prefer 2 apply (erule contained5) 
                                             apply (simp add: renUniState_def, clarsimp) 
                                             apply (drule_tac N=N and f=f in MapN_dom) apply (simp add: Img_def) apply (rule_tac x=x in exI, simp) apply (erule domI)
                                           apply (erule ranI)
                                         apply simp
                     apply clarsimp
                   apply clarsimp 
                     apply (erule disjE) apply (drule_tac d=x in AL_domD, clarsimp)
                       apply (erule disjE) apply (drule_tac d=y in AL_domD, clarsimp) 
                                           apply (simp add: renUniState_def, clarsimp) 
                                           apply (frule_tac f=f and c=x in MapN_D_left, assumption) apply clarsimp
                                           apply (frule_tac f=f and c=y in MapN_D_left, assumption) apply clarsimp 
                                           apply (frule_tac NN=N_Na and c=x in contained3, assumption) 
                                           apply (frule_tac NN=N_Na and c=y in contained3, assumption) 
                                           apply simp 
                       apply clarsimp
                     apply clarsimp
  apply (rotate_tac -9, erule thin_rl)
    apply (simp add: AL_sum_def, clarsimp) 
    apply (rule, simp add: renUniState_def, (erule conjE)+) apply fast apply fast
apply (erule exE, erule conjE) apply (rename_tac ffa_N_Na)
apply (subgoal_tac "inj_on (f ++ fa) (ObjIDs N_Na)") 
prefer 2 apply (rotate_tac -11) apply (erule thin_rl)
         apply (simp add: renUniState_def, clarsimp) 
         apply (rule_tac N=N in inj_on_MapN_sum) apply assumption+
                        apply (rule SetTriv103) apply (erule contained5) apply assumption  apply clarsimp
                        apply (rule SetTriv108) apply (rule SetTriv103) prefer 2 apply (erule SetTriv108) apply clarsimp
                        apply clarsimp apply assumption
apply (drule_tac NN=ffa_N_Na in unisat_MPextensional)
  apply (rotate_tac -12)  apply (erule thin_rl)
  apply (rule, rule) apply rule apply (drule AL_sum_split, assumption) 
                            apply (erule disjE) 
                              apply (erule AL_sum3, assumption)
                            apply (erule AL_sum4, assumption)
                 apply (drule AL_sum_split, assumption) 
                            apply (erule disjE) 
                              apply (erule AL_sum3, assumption)
                            apply (erule AL_sum4, assumption) 
  apply (erule MapN_AL_Aux1) 
apply (subgoal_tac "HP_good HH (AL_dom ffa_N_Na)")
prefer 2 apply (rotate_tac -13) apply(erule thin_rl)
         apply (subgoal_tac "HP_good fH_HH (AL_dom ffa_N_Na)")
           apply (erule_tac H=fH_HH in HP_good_subset) 
             apply (simp add: AL_sum_def)  
           apply simp
         apply (simp add: unisat_def State_welldef_def State_good_def) 
apply (drule_tac KK=HH and f="f++fa" and NN=ffa_N_Na and N=N_Na in MapHP_ReverseExists_Full3[rule_format])
  apply (rule contained_refl)
  apply (erule MapN_domf)
  apply assumption
  apply assumption
  apply assumption
  apply (rotate_tac -14) apply(erule thin_rl) 
           apply (rule SetTriv101) apply (erule AL_sum4b) 
           apply (simp add: unisat_def, (erule conjE)+) apply (erule State_welldef_D_Heap_ObjIDs) 
apply (erule exE, (erule conjE)+) 
apply (subgoal_tac "AL_dom H' \<inter> AL_dom Ha = {}")
prefer 2 apply (rotate_tac -20) apply (erule thin_rl)
         apply (rule, rule, clarsimp)
           apply (subgoal_tac "x:AL_dom N'") prefer 2 apply (simp add: renUniState_def Renames_STATE_def State_noDangColours_def, (erule conjE)+)
                                                      apply (drule_tac x=x and X="AL_dom H'" in SetTriv, assumption)  apply clarsimp
           apply (subgoal_tac "fa x = None") prefer 2 apply (case_tac "x:dom fa")
                                                        apply (drule_tac X="dom fa" and x=x and y=x in SetTriv106) apply assumption apply assumption apply simp
                                                      apply clarsimp
           apply (simp add: renUniState_def Renames_STATE_def, clarsimp)
           apply (drule AL_domD, clarsimp)
           apply (drule AL_domD, clarsimp)
           apply (drule_tac N=H' in MapHP_D_left) apply (erule_tac X="ObjIDs N'" in inj_on_subset) apply (simp add: State_noDangColours_def) apply assumption
           apply clarsimp 
           apply (drule_tac N=Ha in MapHP_D_left) apply assumption
                                                 apply assumption
           apply clarsimp 
           apply (drule_tac X="AL_dom gH'" and x=y and y=y in SetTriv106) apply (erule AL_domI) apply (erule AL_domI) apply simp
       apply fast
apply (frule_tac N=H' in AL_sum_exists_AL) apply (erule exE, erule conjE) apply (rename_tac H'Ha)
apply (subgoal_tac "AL_dom H \<inter> AL_dom Ha = {}")
prefer 2 apply (rotate_tac -23) apply (erule thin_rl)
         apply (erule SetTriv103, assumption)
apply (frule_tac N=H in AL_sum_exists_AL) apply (erule exE, rename_tac H_Ha, erule conjE) 
apply (frule_tac H=Na in  MapN_AL_Aux3, erule conjE)
apply (subgoal_tac "AL_dom H \<subseteq> ObjIDs N")
prefer 2 apply (rotate_tac -28) apply (erule thin_rl) apply (simp add: renUniState_def  Renames_STATE_def  State_noDangColours_def) 
apply (subgoal_tac "(H, f ++ fa, fH) : MapHP")
prefer 2 apply (rotate_tac -29) apply (erule thin_rl)
    apply (simp add: renUniState_def  Renames_STATE_def, (erule conjE)+)
    apply (erule_tac Y="AL_dom N" in MapHP_Fun_eqOn[rule_format]) apply simp
    apply (subgoal_tac "fa c = None", simp add: map_add_def) 
    apply (case_tac "c:dom fa")
      apply (drule_tac X="dom fa" and y=c in SetTriv106) 
        apply assumption 
        apply clarsimp
        apply simp
      apply clarsimp
    apply (simp add: State_noDangColours_def)
    apply (simp add: State_noDangColours_def State_good_def)
apply (frule_tac NM=H_Ha and fN=fH and X="AL_dom N_Na" in MapHP_sum) 
  apply assumption
  apply assumption
  apply assumption
  apply (rotate_tac -30) apply(erule thin_rl) 
    apply (rule_tac H=H and X="AL_dom N" in HP_good_subset)
      apply (simp add: renUniState_def  Renames_STATE_def State_noDangColours_def State_good_def, clarsimp) 
      apply (rule contained_refl)
      apply (erule AL_sum3b) 
  apply assumption
  apply (erule MapN_domf)
  apply (rotate_tac -30) apply(erule thin_rl) 
    apply (simp add: renUniState_def  Renames_STATE_def, (erule conjE)+) 
      apply (drule_tac H=H in MapHP_domf) apply simp (*apply (erule_tac Y="dom f" in SetTriv101) apply fast*)
  apply (erule SetTriv101) apply (rule SetTriv101) apply (rule ObjIDs_in_Dom) apply (erule MapN_domf)
  apply assumption
  apply (erule_tac X="ObjIDs N_Na" in inj_on_subset) 
      apply (erule_tac Y="ObjIDs N" in SetTriv101) 
        apply (rule contained_ObjIds_subset) apply (simp add: AL_sum_def)
  apply (rotate_tac -30) apply(erule thin_rl)
    apply (rule, rule, simp add: Img_def, clarsimp)
      apply (subgoal_tac "sa:AL_dom N'") 
      prefer 2 apply (erule contained6) apply (drule_tac x=sa and Y="ObjIDs N" in SetTriv, assumption) apply (erule SetTriv, rule ObjIDs_in_Dom) 
      apply (subgoal_tac "fa sa = None")
      prefer 2 apply (case_tac "sa:dom fa") apply (drule_tac X="dom fa" in SetTriv106) apply assumption apply assumption apply simp
               apply clarsimp
      apply (erule disjE) apply clarsimp apply clarsimp
                          apply (subgoal_tac "sa:AL_dom N", drule_tac H=N in AL_domD, clarsimp) 
                          apply (drule_tac N=N in MapN_D_left, assumption) apply clarsimp
                          apply (erule disjE) 
                            apply (drule_tac X="AL_dom gN'" in SetTriv106) 
                              apply (erule contained6) apply (erule AL_domI) 
                              apply (erule ranI) 
                              apply simp
                          apply clarsimp
                            apply (drule_tac X="AL_dom fH" and x=fc and y=fc in SetTriv106)
                              apply (simp add: renUniState_def Renames_STATE_def, (erule conjE)+) apply (drule_tac N=H in MapHP_dom)
                                apply (simp add: Img_def)  apply (rule_tac x=sa in exI, simp add: map_add_def)
                              apply (drule_tac N=Ha in MapHP_dom)
                                apply (simp add: Img_def)  apply (rule_tac x=sb in exI, simp add: map_add_def)
                              apply simp
                           apply (drule_tac x=sa and Y="ObjIDs N" in SetTriv, assumption) apply (erule SetTriv, rule ObjIDs_in_Dom) 
    apply fast
apply (erule exE, erule conjE) apply (rename_tac fH_HHmap)
apply (erule_tac x="map_compose I (f++fa)" in allE)
apply (erule_tac x=l1 in allE, erule_tac x=ops in allE)
apply (erule_tac x=s in allE, erule_tac x=h in allE)
apply clarsimp
apply (subgoal_tac "\<exists> N'Na . AL_sum N' Na N'Na \<and> N'Na:AL")
prefer 2 apply (rule AL_sum_exists_AL) apply (rule SetTriv108) apply (rotate_tac -1, erule thin_rl) apply clarsimp
apply (erule exE, rename_tac N'Na, (erule conjE)+)
apply (erule_tac x=Ha in allE, erule_tac x=Na in allE)
apply (erule_tac x=N_Na in allE, erule_tac x=H_Ha in allE)
apply (erule impE) apply (rule Ren_unisat) 
                     apply (erule_tac HH=fH_HHmap in unisat_HPextensional)
                       apply (erule AL_sum_extensional) apply assumption 
                       apply (erule MapHP_AL_right)
                     apply (simp add: renUniState_def Renames_STATE_def, clarsimp)
                       apply (rule, erule_tac Y="AL_dom N" in MAP_OPSTACK_Fun_eqOn[rule_format]) 
                         apply clarsimp apply (subgoal_tac "fa c = None", simp add: map_add_def) 
                                        apply (case_tac "c:dom fa") 
                                          apply (drule_tac X="dom fa" and y=c and x=c in SetTriv106, assumption) apply clarsimp apply simp 
                                        apply clarsimp
                         apply (simp add: State_noDangColours_def)
                      apply (rule, erule_tac Y="AL_dom N" in MAP_STORE_Fun_eqOn[rule_format]) 
                         apply clarsimp apply (subgoal_tac "fa c = None", simp add: map_add_def) 
                                        apply (case_tac "c:dom fa") 
                                          apply (drule_tac X="dom fa" and y=c and x=c in SetTriv106, assumption) apply clarsimp apply simp 
                                        apply clarsimp
                         apply (simp add: State_noDangColours_def) 
                      apply rule apply (simp add: AL_sum_def) apply fast
                      apply (rule State_noDangColours_HPsum)
                                                     apply (erule State_noDangColours_MPcontained) apply (simp add: AL_sum_def) apply assumption
                                                     prefer 2 apply assumption
                                                     apply (simp add: State_noDangColours_def, (erule conjE)+) 
                                                       apply (rule,simp add: AL_cod_emp)
                                                       apply (rule, erule SetTriv101) apply (rule ObjIDs_in_Dom)
                                                       apply (rule, erule HP_good_AbsFields)
                                                       apply (simp add: State_good_def) apply (rule AL_EMP)
                                                     apply (erule MapHP_AL_left)
apply clarsimp
apply (erule_tac x=H'Ha in allE, erule impE, assumption)
apply (erule impE) apply (erule SetTriv108)
apply (erule_tac x=N'Na in allE, erule impE, assumption)
apply clarsimp

apply (rule_tac x="(map_compose I1 (Invv (g++fa)))" in exI)

apply (drule_tac N=Na and g="g++fa" in MapN_extend_f) 
  apply (rotate_tac -2, erule thin_rl) apply clarsimp
apply (subgoal_tac "\<forall> c . c \<in> AL_dom N' \<longrightarrow> (g ++ fa) c = g c")
prefer 2 apply clarsimp 
         apply (subgoal_tac "fa c = None", simp add: map_add_def)
         apply (case_tac "c:dom fa")
             apply (drule_tac X="dom fa" in SetTriv106) apply assumption apply assumption apply simp
           apply clarsimp
(*apply (subgoal_tac "inj_on (g ++ fa) (ObjIDs N'Na)")
prefer 2 apply (erule thin_rl) apply (simp add: renState_def, clarsimp)
                                                   apply (erule inj_on_MapN_sum) apply assumption+*)
apply (subgoal_tac "contained N_Na N'Na")
prefer 2 apply (simp (no_asm) add: contained_def, clarsimp)
         apply (drule AL_sum_split, assumption)
         apply (erule disjE) 
           apply (erule AL_sum3) apply (erule contained3, assumption)
         apply (erule AL_sum4, assumption)
apply (subgoal_tac "(Ha, g ++ fa, HH) \<in> MapHP")
prefer 2 apply (erule_tac Y="AL_dom N_Na" in MapHP_Fun_eqOn[rule_format])
         apply (simp add: AL_sum_def)
         apply (erule disjE)
           apply (subgoal_tac "fa c = None", simp add: map_add_def)
             apply (subgoal_tac "c : dom f", clarsimp)
             apply (erule SetTriv) apply (simp add: renUniState_def, (erule conjE)+) 
           apply (case_tac "c:AL_dom Na", clarsimp)
             apply (drule_tac X="dom fa" in SetTriv106) apply (erule domI) apply (erule contained6, assumption) apply simp
           apply clarsimp
         apply clarsimp
       apply (erule SetTriv101) apply (rule ObjIDs_in_Dom)
       apply assumption
apply (subgoal_tac "HP_good H' (AL_dom N')")
prefer 2 apply (simp add: renUniState_def Renames_STATE_def State_noDangColours_def State_good_def, clarsimp) 
apply (subgoal_tac "(H', g ++ fa, gH') \<in> MapHP")
prefer 2 apply (simp add: renUniState_def Renames_STATE_def, (erule conjE)+) 
         apply (erule_tac Y="AL_dom N'" in MapHP_Fun_eqOn[rule_format]) 
           apply (erule_tac x=c in allE, erule mp, clarsimp)
           apply (rule_tac Y="ObjIDs N'" in SetTriv101) apply (simp add: State_noDangColours_def) apply (rule ObjIDs_in_Dom)
           apply clarsimp
(*apply (subgoal_tac "HP_good K' (AL_dom N')")
prefer 2 apply (simp add: renState_def Renames_STATE_def State_noDangColours_def State_good_def, clarsimp) 
apply (subgoal_tac "(K', g ++ fa, gK') \<in> MapHP")
prefer 2 apply (simp add: renState_def Renames_STATE_def, (erule conjE)+) 
         apply (erule_tac Y="AL_dom N'" in MapHP_Fun_eqOn[rule_format]) 
           apply (erule_tac x=c in allE, erule mp, clarsimp)
           apply (rule_tac Y="ObjIDs N'" in SetTriv101) apply (simp add: State_noDangColours_def) apply (rule ObjIDs_in_Dom)
           apply clarsimp
*)
apply (erule_tac S=S and \<Gamma>=\<Gamma> and H=H and N=N and f=f and fS=fS and f\<Gamma>=f\<Gamma> and fH=fH and fN=fN and 
                 S'=S' and \<Gamma>'=\<Gamma>' and H'=H' and N'=N' and g=g and gS'=gS' and g\<Gamma>'=g\<Gamma>' and gH'=gH' and gN'=gN' and 
                 fa=fa and NN=NN and gN'NN=gN'NN and fN_NN=fN_NN and fH_HH=fH_HH and gH'_HH=gH'_HH and HH=HH and Na=Na and 
                 N_Na=N_Na and ffa_N_Na=ffa_N_Na and  I=I and 
                 Ha=Ha and H'Ha=H'Ha and H_Ha=H_Ha and fH_HHmap=fH_HHmap and N'Na=N'Na and L=L 
                 in Invariant_UniRenAux) apply assumption+
done






end