(*<*)
theory jlapExample1 = ExampleBase:
(*>*)

subsection{*Examples*} 

subsubsection{*Tracking constants and copies*} 

text{*We start by defining method {\tt m1}.*}

consts y::Var
       C::Class
       M1::Method
       A::Field
       l::Var
       h::Var
       x::Var
       v::Var
       M2::Method
       M4::Method

constdefs Code1::"(Label, Instr) AssList"
"Code1 \<equiv> upd(upd(upd(upd(upd(upd emp
                    0 (load y))
                    1 dup)
                    2 (load this))
                    3 swap)
                    4 (putfield C A))
                    5 vreturn"

constdefs Body1:: Mbody
"Body1 \<equiv> ([y],Code1,0)"

consts plus::"Val \<Rightarrow> Val \<Rightarrow> Val"

text{*Likewise, we define method {\tt m2}.*}

constdefs Code2::"(Label, Instr) AssList"
"Code2 \<equiv> upd(upd(upd(upd(upd(upd(upd(upd(upd(upd(upd(upd(upd(upd(upd(upd(upd(upd(upd(upd(upd(upd(upd emp
                    0 (load l))
                    1 (store x))
                    2 (load h))
                    3 (iftrue 13))
                    4 (const (IVal 3)))
                    5 (store x))
                    6 (load l))
                    7 (load x))
                    8 (binop plus))
                    9 (new C))
                    10 swap)
                    11 (invokeV C M1))
                    12 vreturn)
                    13 (load x))
                    14 (const (IVal 3)))
                    15 (binop plus))
                    16 (store x))
                    17 (new C))
                    18 dup)
                    19 (load x))
                    20 (putfield C A))
                    21 (getfield C A))
                    22 vreturn"

constdefs Body2:: Mbody
"Body2 \<equiv> ([l,h],Code2,0)"

(*<*)
lemma getIns_M2_0:"get_ins Body2 0 = Some (load l)"
apply (simp add: Body2_def Code2_def get_ins_def)
apply (rule AL_update5, rule AL_update5, rule AL_update5, rule AL_update5)
apply (rule AL_update5, rule AL_update5, rule AL_update5, rule AL_update5)
apply (rule AL_update5, rule AL_update5, rule AL_update5, rule AL_update5)
apply (rule AL_update5, rule AL_update5, rule AL_update5, rule AL_update5)
apply (rule AL_update5, rule AL_update5, rule AL_update5, rule AL_update5)
apply (rule AL_update5, rule AL_update5, rule AL_update1)
apply simp+
done

lemma getIns_M2_1:"i =1 \<Longrightarrow> get_ins Body2 i = Some (store x)"
apply (simp add: Body2_def Code2_def get_ins_def)
apply (rule AL_update5, rule AL_update5, rule AL_update5, rule AL_update5)
apply (rule AL_update5, rule AL_update5, rule AL_update5, rule AL_update5)
apply (rule AL_update5, rule AL_update5, rule AL_update5, rule AL_update5)
apply (rule AL_update5, rule AL_update5, rule AL_update5, rule AL_update5)
apply (rule AL_update5, rule AL_update5, rule AL_update5, rule AL_update5)
apply (rule AL_update5, rule AL_update1)
apply simp+
done

lemma getIns_M2_2:"i=2 \<Longrightarrow> get_ins Body2 i = Some (load h)"
apply (simp add: Body2_def Code2_def get_ins_def)
apply (rule AL_update5, rule AL_update5, rule AL_update5, rule AL_update5)
apply (rule AL_update5, rule AL_update5, rule AL_update5, rule AL_update5)
apply (rule AL_update5, rule AL_update5, rule AL_update5, rule AL_update5)
apply (rule AL_update5, rule AL_update5, rule AL_update5, rule AL_update5)
apply (rule AL_update5, rule AL_update5, rule AL_update5, rule AL_update5)
apply (rule AL_update1)
apply simp+
done

lemma getIns_M2_3:"i=3 \<Longrightarrow> get_ins Body2 i = Some (iftrue 13)"
apply (simp add: Body2_def Code2_def get_ins_def)
apply (rule AL_update5, rule AL_update5, rule AL_update5, rule AL_update5)
apply (rule AL_update5, rule AL_update5, rule AL_update5, rule AL_update5)
apply (rule AL_update5, rule AL_update5, rule AL_update5, rule AL_update5)
apply (rule AL_update5, rule AL_update5, rule AL_update5, rule AL_update5)
apply (rule AL_update5, rule AL_update5, rule AL_update5, rule AL_update1)
apply simp+
done

lemma getIns_M2_4:"i=4 \<Longrightarrow> get_ins Body2 i = Some (const(IVal 3))"
apply (simp add: Body2_def Code2_def get_ins_def)
apply (rule AL_update5, rule AL_update5, rule AL_update5, rule AL_update5)
apply (rule AL_update5, rule AL_update5, rule AL_update5, rule AL_update5)
apply (rule AL_update5, rule AL_update5, rule AL_update5, rule AL_update5)
apply (rule AL_update5, rule AL_update5, rule AL_update5, rule AL_update5)
apply (rule AL_update5, rule AL_update5, rule AL_update1)
apply simp+
done

lemma getIns_M2_5:"i=5 \<Longrightarrow> get_ins Body2 i = Some (store x)"
apply (simp add: Body2_def Code2_def get_ins_def)
apply (rule AL_update5, rule AL_update5, rule AL_update5, rule AL_update5)
apply (rule AL_update5, rule AL_update5, rule AL_update5, rule AL_update5)
apply (rule AL_update5, rule AL_update5, rule AL_update5, rule AL_update5)
apply (rule AL_update5, rule AL_update5, rule AL_update5, rule AL_update5)
apply (rule AL_update5, rule AL_update1)
apply simp+
done

lemma getIns_M2_6:"i=6 \<Longrightarrow> get_ins Body2 i = Some (load l)"
apply (simp add: Body2_def Code2_def get_ins_def)
apply (rule AL_update5, rule AL_update5, rule AL_update5, rule AL_update5)
apply (rule AL_update5, rule AL_update5, rule AL_update5, rule AL_update5)
apply (rule AL_update5, rule AL_update5, rule AL_update5, rule AL_update5)
apply (rule AL_update5, rule AL_update5, rule AL_update5, rule AL_update5)
apply (rule AL_update1)
apply simp+
done

lemma getIns_M2_7:"i=7 \<Longrightarrow> get_ins Body2 i = Some (load x)"
apply (simp add: Body2_def Code2_def get_ins_def)
apply (rule AL_update5, rule AL_update5, rule AL_update5, rule AL_update5)
apply (rule AL_update5, rule AL_update5, rule AL_update5, rule AL_update5)
apply (rule AL_update5, rule AL_update5, rule AL_update5, rule AL_update5)
apply (rule AL_update5, rule AL_update5, rule AL_update5, rule AL_update1)
apply simp+
done

lemma getIns_M2_8:"i=8 \<Longrightarrow> get_ins Body2 i = Some (binop plus)"
apply (simp add: Body2_def Code2_def get_ins_def)
apply (rule AL_update5, rule AL_update5, rule AL_update5, rule AL_update5)
apply (rule AL_update5, rule AL_update5, rule AL_update5, rule AL_update5)
apply (rule AL_update5, rule AL_update5, rule AL_update5, rule AL_update5)
apply (rule AL_update5, rule AL_update5, rule AL_update1)
apply simp+
done

lemma getIns_M2_9:"i=9 \<Longrightarrow> get_ins Body2 i = Some (new C)"
apply (simp add: Body2_def Code2_def get_ins_def)
apply (rule AL_update5, rule AL_update5, rule AL_update5, rule AL_update5)
apply (rule AL_update5, rule AL_update5, rule AL_update5, rule AL_update5)
apply (rule AL_update5, rule AL_update5, rule AL_update5, rule AL_update5)
apply (rule AL_update5, rule AL_update1)
apply simp+
done

lemma getIns_M2_10:"i=10 \<Longrightarrow> get_ins Body2 i = Some swap"
apply (simp add: Body2_def Code2_def get_ins_def)
apply (rule AL_update5, rule AL_update5, rule AL_update5, rule AL_update5)
apply (rule AL_update5, rule AL_update5, rule AL_update5, rule AL_update5)
apply (rule AL_update5, rule AL_update5, rule AL_update5, rule AL_update5)
apply (rule AL_update1)
apply simp+
done

lemma getIns_M2_11:"i=11 \<Longrightarrow> get_ins Body2 i = Some (invokeV C M1)"
apply (simp add: Body2_def Code2_def get_ins_def)
apply (rule AL_update5, rule AL_update5, rule AL_update5, rule AL_update5)
apply (rule AL_update5, rule AL_update5, rule AL_update5, rule AL_update5)
apply (rule AL_update5, rule AL_update5, rule AL_update5, rule AL_update1)
apply simp+
done

lemma getIns_M2_12:"i=12 \<Longrightarrow> get_ins Body2 i = Some vreturn"
apply (simp add: Body2_def Code2_def get_ins_def)
apply (rule AL_update5, rule AL_update5, rule AL_update5, rule AL_update5)
apply (rule AL_update5, rule AL_update5, rule AL_update5, rule AL_update5)
apply (rule AL_update5, rule AL_update5, rule AL_update1)
apply simp+
done

lemma getIns_M2_13:"i=13 \<Longrightarrow> get_ins Body2 i = Some (load x)"
apply (simp add: Body2_def Code2_def get_ins_def)
apply (rule AL_update5, rule AL_update5, rule AL_update5, rule AL_update5)
apply (rule AL_update5, rule AL_update5, rule AL_update5, rule AL_update5)
apply (rule AL_update5, rule AL_update1)
apply simp+
done

lemma getIns_M2_14:"i=14 \<Longrightarrow> get_ins Body2 i = Some (const (IVal 3))"
apply (simp add: Body2_def Code2_def get_ins_def)
apply (rule AL_update5, rule AL_update5, rule AL_update5, rule AL_update5)
apply (rule AL_update5, rule AL_update5, rule AL_update5, rule AL_update5)
apply (rule AL_update1)
apply simp+
done

lemma getIns_M2_15:"i=15 \<Longrightarrow> get_ins Body2 i = Some (binop plus)"
apply (simp add: Body2_def Code2_def get_ins_def)
apply (rule AL_update5, rule AL_update5, rule AL_update5, rule AL_update5)
apply (rule AL_update5, rule AL_update5, rule AL_update5, rule AL_update1)
apply simp+
done

lemma getIns_M2_16:"i=16 \<Longrightarrow> get_ins Body2 i = Some (store x)"
apply (simp add: Body2_def Code2_def get_ins_def)
apply (rule AL_update5, rule AL_update5, rule AL_update5, rule AL_update5)
apply (rule AL_update5, rule AL_update5, rule AL_update1)
apply simp+
done

lemma getIns_M2_17:"i=17 \<Longrightarrow> get_ins Body2 i = Some (new C)"
apply (simp add: Body2_def Code2_def get_ins_def)
apply (rule AL_update5, rule AL_update5, rule AL_update5, rule AL_update5)
apply (rule AL_update5, rule AL_update1)
apply simp+
done

lemma getIns_M2_18:"i=18 \<Longrightarrow> get_ins Body2 i = Some dup"
apply (simp add: Body2_def Code2_def get_ins_def)
apply (rule AL_update5, rule AL_update5, rule AL_update5, rule AL_update5)
apply (rule AL_update1)
apply simp+
done

lemma getIns_M2_19:"i=19 \<Longrightarrow> get_ins Body2 i = Some (load x)"
apply (simp add: Body2_def Code2_def get_ins_def)
apply (rule AL_update5, rule AL_update5, rule AL_update5, rule AL_update1)
apply simp+
done

lemma getIns_M2_20:"i=20 \<Longrightarrow> get_ins Body2 i = Some (putfield C A)"
apply (simp add: Body2_def Code2_def get_ins_def)
apply (rule AL_update5, rule AL_update5, rule AL_update1)
apply simp+
done

lemma getIns_M2_21:"i=21 \<Longrightarrow> get_ins Body2 i = Some (getfield C A)"
apply (simp add: Body2_def Code2_def get_ins_def)
apply (rule AL_update5, rule AL_update1)
apply simp+
done

lemma getIns_M2_22:"i=22 \<Longrightarrow> get_ins Body2 i = Some vreturn"
apply (simp add: Body2_def Code2_def get_ins_def)
apply (rule AL_update1)
done
(*>*)

text{*Finally, method {\tt m4} from Figure 2.*}

constdefs Code4::"(Label, Instr) AssList"
"Code4 \<equiv> upd(upd(upd(upd(upd(upd(upd(upd(upd emp
                    0 (load l))
                    1 (const (IVal 3)))
                    2 (binop plus))
                    3 (store x))
                    4 (new C))
                    5 (load x))
                    6 (putfield C A))
                    7 (load x))
                    8 vreturn"

constdefs Body4:: Mbody
"Body4 \<equiv> ([l,h],Code4,0)"

(*<*)
lemma getIns_M4_0:"get_ins Body4 0 = Some (load l)"
apply (simp add: Body4_def Code4_def get_ins_def)
apply (rule AL_update5, rule AL_update5, rule AL_update5, rule AL_update5)
apply (rule AL_update5, rule AL_update5, rule AL_update5, rule AL_update5)
apply (rule AL_update1)
apply simp+
done

lemma getIns_M4_1:"i =1 \<Longrightarrow> get_ins Body4 i = Some (const(IVal 3))"
apply (simp add: Body4_def Code4_def get_ins_def)
apply (rule AL_update5, rule AL_update5, rule AL_update5, rule AL_update5)
apply (rule AL_update5, rule AL_update5, rule AL_update5, rule AL_update1)
apply simp+
done

lemma getIns_M4_2:"i=2 \<Longrightarrow> get_ins Body4 i = Some (binop plus)"
apply (simp add: Body4_def Code4_def get_ins_def)
apply (rule AL_update5, rule AL_update5, rule AL_update5, rule AL_update5)
apply (rule AL_update5, rule AL_update5, rule AL_update1)
apply simp+
done

lemma getIns_M4_3:"i=3 \<Longrightarrow> get_ins Body4 i = Some (store x)"
apply (simp add: Body4_def Code4_def get_ins_def)
apply (rule AL_update5, rule AL_update5, rule AL_update5, rule AL_update5)
apply (rule AL_update5, rule AL_update1)
apply simp+
done

lemma getIns_M4_4:"i=4 \<Longrightarrow> get_ins Body4 i = Some (new C)"
apply (simp add: Body4_def Code4_def get_ins_def)
apply (rule AL_update5, rule AL_update5, rule AL_update5, rule AL_update5)
apply (rule AL_update1)
apply simp+
done

lemma getIns_M4_5:"i=5 \<Longrightarrow> get_ins Body4 i = Some (load x)"
apply (simp add: Body4_def Code4_def get_ins_def)
apply (rule AL_update5, rule AL_update5, rule AL_update5, rule AL_update1)
apply simp+
done

lemma getIns_M4_6:"i=6 \<Longrightarrow> get_ins Body4 i = Some (putfield C A)"
apply (simp add: Body4_def Code4_def get_ins_def)
apply (rule AL_update5, rule AL_update5, rule AL_update1)
apply simp+
done

lemma getIns_M4_7:"i=7 \<Longrightarrow> get_ins Body4 i = Some (load x)"
apply (simp add: Body4_def Code4_def get_ins_def)
apply (rule AL_update5, rule AL_update1)
apply simp+
done

lemma getIns_M4_8:"i=8 \<Longrightarrow> get_ins Body4 i = Some vreturn"
apply (simp add: Body4_def Code4_def get_ins_def)
apply (rule AL_update1)
done
(*>*)

constdefs Class::Classdef
"Class \<equiv> emp[M1 \<mapsto> Body1][M2 \<mapsto> Body2][M4 \<mapsto> Body4]"

constdefs Prog1::Prog
"Prog1 \<equiv> emp[C \<mapsto> Class]"

text{*The unary verification of {\tt m1}, as described in Section 4.3.*}

lemma M1_unisound:
  "\<lbrakk>y \<noteq> this; \<Sigma>=([],emp[y\<mapsto>\<delta>][this\<mapsto>\<gamma>],emp[\<gamma>\<mapsto>(C,F)]);
     star (emp[\<gamma>\<mapsto>(classTP C)]) (emp[\<delta>\<mapsto>intTP]) N;
        H = emp[\<gamma>\<mapsto>(C,upd F A \<delta>)]\<rbrakk> 
 \<Longrightarrow> (U,\<Sigma>,N, Body1,0,False, H,\<delta>,N) : UniBS"
apply (rule UniRun)
apply (rule UniLoad)
  apply (simp add: get_ins_def Code1_def Body1_def)
    apply (rule AL_update5, rule AL_update5, rule AL_update5, rule AL_update5, rule AL_update5)
    apply (rule AL_update1) apply (simp, simp, simp, simp, simp)
  apply assumption
  apply (rule AL_update5, rule AL_update1) apply fastsimp
  apply simp
  apply simp
  apply simp
  (* apply fast *)
apply clarsimp
apply (rule UniInj)
apply (rule UniRun)
apply (rule UniDup)
  apply (simp add: get_ins_def Code1_def Body1_def)
    apply (rule AL_update5, rule AL_update5, rule AL_update5, rule AL_update5)
    apply (rule AL_update1) apply (simp, simp, simp, simp)
  apply fastsimp
  apply simp
  apply simp
  apply simp
  (* apply fast *)
apply clarsimp
apply (rule UniInj)
apply (rule UniRun)
apply (rule UniLoad)
  apply (simp add: get_ins_def Code1_def Body1_def)
    apply (rule AL_update5, rule AL_update5, rule AL_update5)
    apply (rule AL_update1a) apply (simp, simp, simp, simp)
  apply fastsimp
  apply (rule AL_update1)
  apply simp
  apply simp
  apply simp
  (* apply fast *)
apply clarsimp
apply (rule UniInj)
apply (rule UniRun)
apply (rule UniSwap)
  apply (simp add: get_ins_def Code1_def Body1_def)
    apply (rule AL_update5, rule AL_update5)
    apply (rule AL_update1a) apply (simp, simp, simp)
  apply fastsimp
  apply simp
  apply simp
  apply simp
  (* apply fast *)
apply clarsimp
apply (rule UniInj)
apply (rule UniRun)
apply (rule UniPut)
  apply (simp add: get_ins_def Code1_def Body1_def)
    apply (rule AL_update5)
    apply (rule AL_update1a) apply (simp, simp)
  apply fastsimp
  apply (rule AL_update1) 
  apply simp
  apply simp
  apply simp
  (* apply fast *)
apply clarsimp
apply (rule UniInj)
apply (rule UniVret)
  apply (simp add: get_ins_def Code1_def Body1_def)
    apply (rule AL_update1a) apply simp
  apply clarsimp apply (rule, simp) apply (rule, simp)
    apply (rule upd_upd)
  apply simp
done

text{*Next, the verification of {\tt m2}, as described in Section
5.3. We first define some auxiliary constructions.*}

constdefs mkStore::"Colour \<Rightarrow> Colour \<Rightarrow> (Var,Colour)AssList"
"mkStore \<gamma> \<delta> \<equiv> emp[l\<mapsto>\<gamma>][h\<mapsto>\<delta>]"

constdefs mkState::"Colour \<Rightarrow> Colour \<Rightarrow> STATE"
"mkState \<gamma> \<delta> \<equiv> ([],mkStore \<gamma> \<delta>,emp)"

consts mkMP_AuxC::"Colour list \<Rightarrow> MP \<Rightarrow> bool"
primrec
"mkMP_AuxC [] N = (N=emp)"
"mkMP_AuxC (\<gamma>#t) N = (\<exists> M . mkMP_AuxC t M \<and> star M (emp[\<gamma>\<mapsto>(classTP C)]) N)"

consts mkMP_AuxInt::"Colour list \<Rightarrow> MP \<Rightarrow> bool"
primrec
"mkMP_AuxInt [] N = (N=emp)"
"mkMP_AuxInt (\<gamma>#t) N = (\<exists> M . mkMP_AuxInt t M \<and> star M (emp[\<gamma>\<mapsto>intTP]) N)"

constdefs mkMP_Rel::"Colour list \<Rightarrow> Colour list \<Rightarrow> MP \<Rightarrow> bool"
"mkMP_Rel IntCols CCols N \<equiv> (\<exists> M L . mkMP_AuxInt IntCols M \<and> mkMP_AuxC CCols L \<and> star M L N \<and> N:AL)"

lemma mkMP_AuxC_dom[rule_format]: "\<forall> N . mkMP_AuxC Cols N \<longrightarrow> AL_dom N = set Cols"
apply (induct Cols) 
apply (simp add: AL_dom_emp)
apply clarsimp apply (erule_tac x=M in allE, simp add: star_def AL_sum_def AL_dom_upd1 AL_dom_emp) 
done

lemma mkMP_AuxInt_dom[rule_format]: "\<forall> N . mkMP_AuxInt Cols N \<longrightarrow> AL_dom N = set Cols"
apply (induct Cols) 
apply (simp add: AL_dom_emp)
apply clarsimp apply (erule_tac x=M in allE, simp add: star_def AL_sum_def AL_dom_upd1 AL_dom_emp) 
done

lemma mkMP_Rel_dom:"mkMP_Rel IntCols CCols N \<Longrightarrow> AL_dom N = set IntCols \<union> set CCols"
apply (simp add: mkMP_Rel_def) apply clarsimp
apply (drule mkMP_AuxC_dom)
apply (drule mkMP_AuxInt_dom)
apply (simp add: star_def AL_sum_def)
done

lemma mkMP_AuxC_dist[rule_format]: "\<forall> N . mkMP_AuxC Cols N \<longrightarrow> distinct Cols"
apply (induct Cols) 
apply simp
apply clarsimp apply (erule impE) apply (rule, assumption)
  apply (drule mkMP_AuxC_dom)
  apply (simp add: star_def AL_dom_upd1 AL_dom_emp)  
done

lemma mkMP_AuxInt_dist[rule_format]: "\<forall> N . mkMP_AuxInt Cols N \<longrightarrow> distinct Cols"
apply (induct Cols) 
apply simp
apply clarsimp apply (erule impE) apply (rule, assumption)
  apply (drule mkMP_AuxInt_dom)
  apply (simp add: star_def AL_dom_upd1 AL_dom_emp)  
done

lemma mkMP_Rel_dist:"mkMP_Rel IntCols CCols N \<Longrightarrow> distinct IntCols \<and> distinct CCols \<and> set IntCols \<inter> set CCols = {}"
apply (simp add: mkMP_Rel_def) apply clarsimp
apply (frule mkMP_AuxC_dist)
apply (frule mkMP_AuxInt_dist)
apply (drule mkMP_AuxC_dom)
apply (drule mkMP_AuxInt_dom)
apply (simp add: star_def AL_sum_def)
done

lemma mkMP_AuxInt_lookup[rule_format]: "\<forall> N . mkMP_AuxInt Cols N \<longrightarrow> \<gamma> mem Cols \<longrightarrow> N\<down>\<gamma>= Some intTP"
apply (induct Cols)
apply simp
apply clarsimp 
  apply (rule, simp add: star_def, clarsimp) apply (erule AL_sum4) apply (rule AL_update1)
  apply (simp add: star_def, clarsimp) apply (erule_tac x=M in allE, clarsimp)
     apply (erule AL_sum3) apply assumption
done

lemma mkMP_AuxC_lookup[rule_format]: "\<forall> N . mkMP_AuxC Cols N \<longrightarrow> \<gamma> mem Cols \<longrightarrow> N\<down>\<gamma>= Some (classTP C)"
apply (induct Cols)
apply simp
apply clarsimp 
  apply (rule, simp add: star_def, clarsimp) apply (erule AL_sum4) apply (rule AL_update1)
  apply (simp add: star_def, clarsimp) apply (erule_tac x=M in allE, clarsimp)
     apply (erule AL_sum3) apply assumption
done

lemma mkMP_Rel_Ilookup: "\<lbrakk>mkMP_Rel IntCols CCols N; \<gamma> mem IntCols\<rbrakk> \<Longrightarrow> N\<down>\<gamma>= Some intTP"
apply (simp add: mkMP_Rel_def star_def, clarsimp)
apply (erule AL_sum3) apply (erule mkMP_AuxInt_lookup) apply assumption
done
lemma mkMP_Rel_Clookup: "\<lbrakk>mkMP_Rel IntCols CCols N; \<gamma> mem CCols\<rbrakk> \<Longrightarrow> N\<down>\<gamma>= Some (classTP C)"
apply (simp add: mkMP_Rel_def star_def, clarsimp)
apply (erule AL_sum4) apply (erule mkMP_AuxC_lookup) apply assumption
done

lemma mkMP_Rel_extend:
  "\<lbrakk>mkMP_Rel ICols1 CCols1 N; mkMP_Rel ICols2 CCols2 M; N\<down>\<gamma> = Some tp; 
          set ICols1 \<subseteq> set ICols2; set CCols1 \<subseteq> set CCols2\<rbrakk>
          \<Longrightarrow> M\<down>\<gamma> = Some tp"
apply (frule mkMP_Rel_dom) apply (frule AL_domI) apply clarsimp
apply (erule disjE) apply (drule_tac \<gamma>=\<gamma> in mkMP_Rel_Ilookup) apply (simp add: mem_iff)
    apply clarsimp apply (erule mkMP_Rel_Ilookup) apply (simp add: mem_iff) apply fastsimp 
apply (drule_tac \<gamma>=\<gamma> in mkMP_Rel_Clookup) apply (simp add: mem_iff)
    apply clarsimp apply (erule mkMP_Rel_Clookup) apply (simp add: mem_iff) apply fastsimp 
done

text{*The first proof relating {\tt m2} to itself does not correlate
the allocations.*}

lemma M2_uncorrelated:
  "\<lbrakk>P=Prog1; M2 \<noteq> M1; M4 \<noteq> M1; y \<noteq> this; h \<noteq> l; x \<noteq> h;x \<noteq> l;
    \<forall> D . subclass_of D C \<longrightarrow> D=C; mkMP_Rel [\<gamma>, \<delta>, \<epsilon>] [] N;
    \<Phi>=(mkState \<gamma> \<delta>,N,mkState \<gamma> \<epsilon>); 
    mkMP_Rel [\<gamma>, \<delta>, \<epsilon>, \<alpha>, \<beta>] [\<mu>,\<nu>] M;isOfType plus intTP intTP intTP;
    \<Psi> = (([\<beta>], emp, emp[\<mu>\<mapsto>(C, emp[A\<mapsto>\<beta>])]),M, [\<beta>], emp, emp[\<nu>\<mapsto>(C, emp[A\<mapsto>\<beta>])])\<rbrakk> 
 \<Longrightarrow> (G, \<Phi>, Body2, 0, Body2, 0, False, \<Psi>) :Typing"
apply (rule UniInjectL)
apply (rule UniLoad)
  apply (rule getIns_M2_0)
  prefer 7 apply assumption 
  apply (simp add: mkState_def) apply fastsimp
  apply (simp add: mkStore_def) apply (rule AL_update5, rule AL_update1) apply assumption
  apply simp
  apply simp
  apply simp
  apply (rule UniCtxtVerified_emp)
  (* apply fast *)
apply clarsimp
apply (rule TypingInj)
apply (rule UniInjectL)
apply (rule UniStore)
  apply (rule getIns_M2_1) apply simp 
  prefer 6 apply fastsimp
  apply fastsimp
  apply simp 
  apply simp
  apply simp
  apply (rule UniCtxtVerified_emp)
  (* apply fast *)
apply clarsimp
apply (rule TypingInj)
apply (rule UniInjectL)
apply (rule UniLoad)
  apply (rule getIns_M2_2) apply simp
  prefer 7 apply fastsimp
  apply fastsimp
  apply (simp add: mkStore_def) apply (rule AL_update5, rule AL_update1) apply assumption
  apply simp
  apply simp
  apply simp
  apply (rule UniCtxtVerified_emp)
  (* apply fast *)
apply clarsimp
apply (rule TypingInj)
apply (rule UniInjectR)
apply (rule UniLoad)
  apply (rule getIns_M2_0)
  prefer 7 apply fastsimp
  apply (simp add: mkState_def) apply fastsimp
  apply (simp add: mkStore_def) apply (rule AL_update5, rule AL_update1) apply assumption
  apply simp
  apply simp
  apply simp
  apply (rule UniCtxtVerified_emp)
  (* apply fast *)
apply clarsimp
apply (rule TypingInj)
apply (rule UniInjectR)
apply (rule UniStore)
  apply (rule getIns_M2_1) apply simp 
  prefer 6 apply fastsimp
  apply fastsimp
  apply simp 
  apply simp
  apply simp
  apply (rule UniCtxtVerified_emp)
  (* apply fast *)
apply clarsimp
apply (rule TypingInj)
apply (rule UniInjectR)
apply (rule UniLoad)
  apply (rule getIns_M2_2) apply simp
  prefer 7 apply fastsimp
  apply fastsimp
  apply (simp add: mkStore_def) apply (rule AL_update5, rule AL_update1) apply assumption
  apply simp
  apply simp
  apply simp
  apply (rule UniCtxtVerified_emp)
  (* apply fast *)
apply clarsimp
apply (rule TypingInj)
apply (rule UniInjectL)
prefer 2 apply (rule UniCtxtVerified_emp)
prefer 2 apply fastsimp
apply (rule UniIf)
  apply (rule getIns_M2_3) apply simp
  apply fastsimp
  apply simp
  apply simp
  apply simp
  (* apply fast *)
apply clarsimp
apply rule
  (*4,3*) (*other case is: (13,3)*)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectR)
  prefer 2 apply (rule UniCtxtVerified_emp)
  prefer 2 apply fastsimp
  apply (rule UniIf)
    apply (rule getIns_M2_3) apply simp
    apply fastsimp
    apply simp
    apply simp
    apply simp
    (* apply fast *)
  apply clarsimp
  apply rule
    (*4,4*) (*other case is: (4,13)*)
    apply clarsimp
    apply (rule TypingInj)
    apply (rule_tac c=\<alpha> in TypingConstConst)
      apply (rule getIns_M2_4) apply simp
      apply (rule getIns_M2_4) apply simp
      apply fastsimp
      apply clarsimp apply (frule_tac N=N in mkMP_Rel_dom) apply (frule_tac N=M in mkMP_Rel_dom) 
             apply (drule_tac N=M in mkMP_Rel_dist) apply fastsimp 
    apply clarsimp
    apply (rule TypingInj)
    apply (rule UniInjectL)
    apply (rule UniStore)
      apply (rule getIns_M2_5) apply simp
      prefer 6 apply fastsimp
      apply fastsimp
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
    apply clarsimp
    apply (rule TypingInj)
    apply (rule UniInjectL)
    apply (rule UniLoad)
      apply (rule getIns_M2_6) apply simp
      prefer 7 apply fastsimp
      apply fastsimp
      apply (simp add: mkStore_def) apply (rule AL_update5, rule AL_update5, rule AL_update5) 
        apply (rule AL_update1) apply assumption+
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
    apply clarsimp
    apply (rule TypingInj)
    apply (rule UniInjectL)
    apply (rule UniLoad)
      apply (rule getIns_M2_7) apply simp
      prefer 7 apply fastsimp
      apply fastsimp
      apply (rule AL_update1) 
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
    apply clarsimp
    (*now that we have reached the binop instruction in the left component, 
       we proceed along the right component to the same point*)
    apply (rule TypingInj)
    apply (rule UniInjectR)
    apply (rule UniStore)
      apply (rule getIns_M2_5) apply simp
      prefer 6 apply fastsimp
      apply fastsimp
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
    apply clarsimp
    apply (rule TypingInj)
    apply (rule UniInjectR)
    apply (rule UniLoad)
      apply (rule getIns_M2_6) apply simp
      prefer 7 apply fastsimp
      apply fastsimp
      apply (simp add: mkStore_def) apply (rule AL_update5, rule AL_update5, rule AL_update5) 
        apply (rule AL_update1) apply assumption+
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
    apply clarsimp
    apply (rule TypingInj)
    apply (rule UniInjectR)
    apply (rule UniLoad)
      apply (rule getIns_M2_7) apply simp
      prefer 7 apply fastsimp
      apply fastsimp
      apply (rule AL_update1) 
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
    apply clarsimp
    apply (rule TypingInj)
    apply (rule_tac c=\<beta> in TypingBinopBinop)
      apply (rule getIns_M2_8) apply simp
      apply (rule getIns_M2_8) apply simp
      apply fastsimp
      apply clarsimp apply (frule_tac N=N in mkMP_Rel_dom) apply (frule_tac N=M in mkMP_Rel_dom) 
             apply (drule_tac N=M in mkMP_Rel_dist) apply (simp add: AL_dom_upd1) apply fastsimp 
      apply (rule AL_update1)
      apply (rule AL_update5) apply (erule mkMP_Rel_Ilookup) apply simp
        apply (drule_tac N=M in mkMP_Rel_dist) apply simp apply fast
      apply assumption
    apply clarsimp
    (*we again first procede in the left component as far as possible, in this case until
        we hit the return instruction*)
    apply (rule TypingInj)
    apply (rule UniInjectL)
    apply (rule_tac cl=\<mu> and D=C in UniNew)
      apply (rule getIns_M2_9) apply simp
      prefer 8 apply fastsimp
      apply fastsimp
      apply (drule mkMP_Rel_dom) apply (frule mkMP_Rel_dom) apply (drule mkMP_Rel_dist)  apply(simp add: AL_dom_upd1)
      apply simp
      apply (simp add: subclass_of_refl)
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
    apply clarsimp
    apply (rule TypingInj)
    apply (rule UniInjectL)
    apply (rule UniSwap)
      apply (rule getIns_M2_10) apply simp
      prefer 6 apply fastsimp
      apply fastsimp
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
    apply clarsimp
    apply (subgoal_tac "mbody_is C M1 ([y], Code1, 0)")
    prefer 2 apply (simp add: mbody_is_def Prog1_def)
        apply (subgoal_tac "emp[C\<mapsto>Class]\<down>C = Some Class", simp)
          apply (simp add: Class_def Body1_def)
          apply (rule AL_update5, rule AL_update5, rule AL_update1) apply assumption apply assumption
        apply (rule AL_update1)
    apply (rule TypingInj)
    apply (rule UniInjectL)
    apply (rule_tac HH="emp[\<mu>\<mapsto>(C, emp[A\<mapsto>\<beta>])]" and c=\<beta> in UniInvV3)
      apply (rule getIns_M2_11) apply simp
      apply assumption
      prefer 9 apply fastsimp
      apply fastsimp
      apply (rule absFrameCons) 
        apply (rule absFrameNil) apply fastsimp 
        apply simp
      apply (rule AL_update1)
      apply simp
      apply simp
      prefer 3 apply (rule UniCtxtVerified_emp)
      prefer 2 apply clarsimp apply (erule_tac x=E in allE, clarsimp)
        apply (rule, rule, rule, assumption)
      apply (subgoal_tac "({}, ([], emp[y\<mapsto>\<beta>][this\<mapsto>\<mu>], emp[\<mu>\<mapsto>(C, emp)]), N[\<alpha>\<mapsto>intTP][\<beta>\<mapsto>intTP][\<mu>\<mapsto>(classTP C)],
        Body1, 0, True, emp[\<mu>\<mapsto>(C, emp[A\<mapsto>\<beta>])], \<beta>, N[\<alpha>\<mapsto>intTP][\<beta>\<mapsto>intTP][\<mu>\<mapsto>(classTP C)])
       \<in> UniBS ")
      apply (subgoal_tac "Body1 = ([y], Code1, 0)", simp) apply (simp add: Body1_def)
      apply (rule UniInj)
      apply (subgoal_tac "AL_sum emp[\<mu>\<mapsto>(classTP C)][\<beta>\<mapsto>intTP] N[\<alpha>\<mapsto>intTP]
        N[\<alpha>\<mapsto>intTP][\<beta>\<mapsto>intTP][\<mu>\<mapsto>(classTP C)]")
      prefer 2 apply (simp add: AL_sum_def)
               apply (rule, simp add: AL_dom_emp AL_dom_upd1) apply fast
               apply (simp add: contained_def, rule)
                 apply clarsimp apply (drule AL_upd_split)
                         apply (erule disjE, clarsimp)
                           apply (rule AL_update5, rule AL_update1)
                           apply (drule_tac N=M in mkMP_Rel_dist) apply fastsimp
                         apply clarsimp
                           apply (drule AL_upd_split)
                           apply (erule disjE, clarsimp) apply (rule AL_update1)
                           apply (simp add: AL_emp1)
                 apply clarsimp apply (drule AL_upd_split)
                         apply (erule disjE, clarsimp) 
                           apply (rule AL_update5, rule AL_update5, rule AL_update1) 
                           apply (drule_tac N=M in mkMP_Rel_dist) apply fastsimp
                           apply (drule_tac N=M in mkMP_Rel_dist) apply fastsimp
                         apply clarsimp
                           apply (rule AL_update5, rule AL_update5, erule AL_update5)
                             apply assumption
                             apply (drule AL_domI) 
                               apply (drule_tac N=M in mkMP_Rel_dist) apply (drule_tac N=N in mkMP_Rel_dom) apply fastsimp
                             apply (drule AL_domI) 
                               apply (drule_tac N=M in mkMP_Rel_dist) apply (drule_tac N=N in mkMP_Rel_dom) apply fastsimp
      apply (rule_tac H=emp and N="N[\<alpha>\<mapsto>intTP]" and NN="emp[\<mu>\<mapsto>(classTP C)][\<beta>\<mapsto>intTP]" in UniBSFrame)
        apply (rule_tac \<gamma>=\<mu> and F=emp in M1_unisound) apply assumption apply fastsimp 
          apply (simp (no_asm) add: star_def AL_sum_def contained_def)
            apply (rule, simp add: AL_dom_upd1 AL_dom_emp)
            apply (rule, clarsimp)
              apply (rule AL_update5, assumption) apply (drule AL_domI) apply (drule_tac N=M in mkMP_Rel_dist)
                                                    apply (simp add: AL_dom_upd1 AL_dom_emp) apply fastsimp
            apply (rule, clarsimp) 
              apply (drule AL_upd_split)
              apply (erule disjE, clarsimp) apply (rule AL_update1)
              apply (simp add: AL_emp1)
            apply (rule, simp add: AL_dom_upd1 AL_dom_emp) apply (drule_tac N=M in mkMP_Rel_dist) apply fastsimp
            apply (rule AL_UPD, rule AL_UPD, rule AL_EMP)
          apply simp 
          apply (simp add: SD_sum_def) apply (rule, rule AL_sum_emp2) apply (simp add: AL_dom_emp) 
          apply (simp add: SD_sum_def) apply (rule, rule AL_sum_emp2) apply (simp add: AL_dom_emp)
        apply assumption
        apply assumption
        apply (drule_tac N=N in mkMP_Rel_dom) apply (frule_tac N=M in mkMP_Rel_dom) 
           apply (drule_tac N=M in mkMP_Rel_dist) apply (simp add: AL_dom_upd1 AL_dom_emp) apply fast 
        apply (rule AL_UPD, rule AL_UPD, rule AL_UPD) apply (simp add: mkMP_Rel_def) apply clarsimp
      (* apply fast*)
    apply clarsimp
    (*we've reached the return instruction, so now do the right component*)
    apply (rule TypingInj)
    apply (rule UniInjectR)
    apply (rule_tac cl=\<nu> and D=C in UniNew)
      apply (rule getIns_M2_9) apply simp
      prefer 8 apply fastsimp
      apply fastsimp
      apply (drule mkMP_Rel_dom) apply (frule mkMP_Rel_dom) apply (drule mkMP_Rel_dist)  apply(simp add: AL_dom_upd1) apply fastsimp
      apply simp
      apply (simp add: subclass_of_refl)
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
    apply clarsimp
    apply (rule TypingInj)
    apply (rule UniInjectR)
    apply (rule UniSwap)
      apply (rule getIns_M2_10) apply simp
      prefer 6 apply fastsimp
      apply fastsimp
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
    apply clarsimp
    apply (rule TypingInj)
    apply (rule UniInjectR)
    apply (rule_tac HH="emp[\<nu>\<mapsto>(C, emp[A\<mapsto>\<beta>])]" and c=\<beta> in UniInvV3)
      apply (rule getIns_M2_11) apply simp
      apply assumption
      prefer 9 apply fastsimp
      apply fastsimp
      apply (rule absFrameCons) 
        apply (rule absFrameNil) apply fastsimp 
        apply simp
      apply (rule AL_update1)
      apply simp
      apply simp
      prefer 3 apply (rule UniCtxtVerified_emp)
      prefer 2 apply clarsimp apply (erule_tac x=E in allE, clarsimp)
        apply (rule, rule, rule, assumption)
      apply (subgoal_tac "({}, ([], emp[y\<mapsto>\<beta>][this\<mapsto>\<nu>], emp[\<nu>\<mapsto>(C, emp)]), N[\<alpha>\<mapsto>intTP][\<beta>\<mapsto>intTP][\<mu>\<mapsto>(classTP C)][\<nu>\<mapsto>(classTP C)], Body1,
        0, True, emp[\<nu>\<mapsto>(C, emp[A\<mapsto>\<beta>])], \<beta>, M)
       \<in> UniBS")
      apply (subgoal_tac "Body1 = ([y], Code1, 0)", simp) apply (simp add: Body1_def)
      apply (rule UniInj)
      apply (subgoal_tac "AL_sum emp[\<nu>\<mapsto>(classTP C)][\<beta>\<mapsto>intTP] N[\<alpha>\<mapsto>intTP][\<mu>\<mapsto>(classTP C)] M")
      prefer 2 apply (simp add: AL_sum_def)
               apply (rule, drule_tac N=N in mkMP_Rel_dom) apply (frule_tac N=M in mkMP_Rel_dom) 
                 apply (drule_tac N=M in mkMP_Rel_dist) apply (simp add: AL_dom_upd1 AL_dom_emp) apply fast
               apply (simp add: contained_def, rule)
                 apply clarsimp apply (drule AL_upd_split)
                         apply (erule disjE, clarsimp)
                           apply (erule mkMP_Rel_Ilookup) apply simp
                         apply clarsimp
                           apply (drule AL_upd_split)
                           apply (erule disjE, clarsimp) 
                           apply (erule mkMP_Rel_Clookup) apply simp
                           apply (simp add: AL_emp1)
                 apply clarsimp apply (drule AL_upd_split)
                         apply (erule disjE, clarsimp) 
                           apply (erule mkMP_Rel_Clookup) apply simp
                         apply clarsimp
                           apply (drule AL_upd_split)
                           apply (erule disjE, clarsimp) 
                           apply (erule mkMP_Rel_Ilookup) apply simp
                         apply clarsimp apply (erule mkMP_Rel_extend) apply assumption apply assumption apply fastsimp apply fastsimp
      apply (rule_tac H=emp and N="N[\<alpha>\<mapsto>intTP][\<mu>\<mapsto>(classTP C)]" and NN="emp[\<nu>\<mapsto>(classTP C)][\<beta>\<mapsto>intTP]"in UniBSFrame)
        apply (rule_tac \<gamma>=\<nu> and F=emp in M1_unisound) apply assumption apply simp 
          apply (simp (no_asm) add: star_def AL_sum_def contained_def)
            apply (rule, simp add: AL_dom_upd1 AL_dom_emp)
            apply (rule, clarsimp)
              apply (rule AL_update5, assumption) apply (drule AL_domI) apply (drule_tac N=M in mkMP_Rel_dist)
                                                    apply (simp add: AL_dom_upd1 AL_dom_emp) apply fastsimp
            apply (rule, clarsimp) 
              apply (drule AL_upd_split)
              apply (erule disjE, clarsimp) apply (rule AL_update1)
              apply (simp add: AL_emp1)
            apply (rule, simp add: AL_dom_upd1 AL_dom_emp) apply (drule_tac N=M in mkMP_Rel_dist) apply fastsimp
            apply (rule AL_UPD, rule AL_UPD, rule AL_EMP)
          apply simp 
          apply (simp add: SD_sum_def) apply (rule, rule AL_sum_emp2) apply (simp add: AL_dom_emp) 
          apply (simp add: SD_sum_def) apply (rule, rule AL_sum_emp2) apply (simp add: AL_dom_emp)
        apply (simp (no_asm) add: AL_sum_def contained_def)
          apply (rule, simp add: AL_sum_def AL_dom_upd1 AL_dom_emp) apply fast
          apply (rule, clarsimp) 
            apply (drule AL_upd_split)
            apply (erule disjE, clarsimp) apply (rule AL_update5, rule AL_update5, rule AL_update1)
              apply (drule_tac N=M in mkMP_Rel_dist) apply fastsimp
              apply (drule_tac N=M in mkMP_Rel_dist) apply fastsimp
            apply (clarsimp, drule AL_upd_split)
            apply (erule disjE, clarsimp) apply (rule AL_update1)
            apply (simp add: AL_emp1)
          apply clarsimp
            apply (rule AL_update5)
              apply (drule AL_upd_split)
              apply (erule disjE, clarsimp) apply (rule AL_update1)
              apply clarsimp
              apply (rule AL_update5)
                apply (rule AL_update5) apply assumption
                apply (drule AL_domI, simp add: AL_dom_upd1) apply (drule mkMP_Rel_dom) apply (drule mkMP_Rel_dist) apply fastsimp 
              apply assumption
            apply (drule AL_domI, simp add: AL_dom_upd1) apply (drule mkMP_Rel_dom) apply (drule mkMP_Rel_dist) apply fastsimp
        apply assumption
        apply (drule mkMP_Rel_dom) apply (frule mkMP_Rel_dom) apply (drule mkMP_Rel_dist) apply (simp add: AL_dom_upd1 AL_dom_emp) apply fast 
        apply (simp add: mkMP_Rel_def, clarsimp)
      (* apply fast *)
    apply clarsimp
    (*now we've arrive at return instructions in both compoents*)
    apply (rule TypingInj)
    apply (rule_tac 
         c=\<beta> and S="[]" and \<Gamma>="(mkStore \<gamma> \<delta>)[x\<mapsto>\<gamma>][x\<mapsto>\<alpha>]" and
         d=\<beta> and T="[]" and \<Delta>="(mkStore \<gamma> \<epsilon>)[x\<mapsto>\<gamma>][x\<mapsto>\<alpha>]" in TypingRetRet)
      apply (rule getIns_M2_12) apply simp
      apply (rule getIns_M2_12) apply simp
      apply fastsimp
      apply simp
  (*Branch (4,13)*)
    apply clarsimp
    apply (rule TypingInj)
    apply (rule UniInjectR)
    apply (rule UniLoad)
      apply (rule getIns_M2_13) apply simp
      prefer 7 apply fastsimp
      apply fastsimp
      apply (rule AL_update1) 
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
    apply clarsimp
    apply (rule TypingInj)
    apply (rule_tac c=\<alpha> in TypingConstConst)
      apply (rule getIns_M2_4) apply simp
      apply (rule getIns_M2_14) apply simp
      apply fastsimp
      apply clarsimp apply (frule_tac N=N in mkMP_Rel_dom) apply (frule_tac N=M in mkMP_Rel_dom) 
             apply (drule_tac N=M in mkMP_Rel_dist) apply fastsimp 
    apply clarsimp
    apply (rule TypingInj)
    apply (rule UniInjectL)
    apply (rule UniStore)
      apply (rule getIns_M2_5) apply simp
      prefer 6 apply fastsimp
      apply fastsimp
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
    apply clarsimp
    apply (rule TypingInj)
    apply (rule UniInjectL)
    apply (rule UniLoad)
      apply (rule getIns_M2_6) apply simp
      prefer 7 apply fastsimp
      apply fastsimp
      apply (simp add: mkStore_def) apply (rule AL_update5, rule AL_update5, rule AL_update5) 
        apply (rule AL_update1) apply assumption+
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
    apply clarsimp
    apply (rule TypingInj)
    apply (rule UniInjectL)
    apply (rule UniLoad)
      apply (rule getIns_M2_7) apply simp
      prefer 7 apply fastsimp
      apply fastsimp
      apply (rule AL_update1) 
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
    (*now that we have reached the binop instruction in the left component, 
      (and are already at the binop in the right component*)
    apply clarsimp
    apply (rule TypingInj)
    apply (rule_tac c=\<beta> in TypingBinopBinop)
      apply (rule getIns_M2_8) apply simp
      apply (rule getIns_M2_15) apply simp
      apply fastsimp
      apply clarsimp apply (frule_tac N=N in mkMP_Rel_dom) apply (frule_tac N=M in mkMP_Rel_dom) 
             apply (drule_tac N=M in mkMP_Rel_dist) apply (simp add: AL_dom_upd1) apply fastsimp 
      apply (rule AL_update1)
      apply (rule AL_update5) apply (erule mkMP_Rel_Ilookup) apply simp
        apply (drule_tac N=M in mkMP_Rel_dist) apply simp apply fast
      apply assumption
    apply clarsimp
    (*we again first procede in the left component as far as possible, in this case until
        we hit the return instruction*)
    apply (rule TypingInj)
    apply (rule UniInjectL)
    apply (rule_tac cl=\<mu> and D=C in UniNew)
      apply (rule getIns_M2_9) apply simp
      prefer 8 apply fastsimp
      apply fastsimp
      apply (drule mkMP_Rel_dom) apply (frule mkMP_Rel_dom) apply (drule mkMP_Rel_dist) apply(simp add: AL_dom_upd1)
      apply simp
      apply (simp add: subclass_of_refl)
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
    apply clarsimp
    apply (rule TypingInj)
    apply (rule UniInjectL)
    apply (rule UniSwap)
      apply (rule getIns_M2_10) apply simp
      prefer 6 apply fastsimp
      apply fastsimp
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
    apply clarsimp
    apply (subgoal_tac "mbody_is C M1 ([y], Code1, 0)")
    prefer 2 apply (simp add: mbody_is_def Prog1_def)
        apply (subgoal_tac "emp[C\<mapsto>Class]\<down>C = Some Class", simp)
          apply (simp add: Class_def Body1_def)
          apply (rule AL_update5, rule AL_update5, rule AL_update1) apply assumption apply assumption
        apply (rule AL_update1)
    apply (rule TypingInj)
    apply (rule UniInjectL)
    apply (rule_tac HH="emp[\<mu>\<mapsto>(C, emp[A\<mapsto>\<beta>])]" and c=\<beta> in UniInvV3)
      apply (rule getIns_M2_11) apply simp
      apply assumption
      prefer 9 apply fastsimp
      apply fastsimp
      apply (rule absFrameCons) 
        apply (rule absFrameNil) apply fastsimp 
        apply simp
      apply (rule AL_update1)
      apply simp
      apply simp
      prefer 3 apply (rule UniCtxtVerified_emp)
      prefer 2 apply clarsimp apply (erule_tac x=E in allE, clarsimp)
        apply (rule, rule, rule, assumption)
      apply (subgoal_tac "({}, ([], emp[y\<mapsto>\<beta>][this\<mapsto>\<mu>], emp[\<mu>\<mapsto>(C, emp)]), N[\<alpha>\<mapsto>intTP][\<beta>\<mapsto>intTP][\<mu>\<mapsto>(classTP C)],
        Body1, 0, True, emp[\<mu>\<mapsto>(C, emp[A\<mapsto>\<beta>])], \<beta>, N[\<alpha>\<mapsto>intTP][\<beta>\<mapsto>intTP][\<mu>\<mapsto>(classTP C)])
       \<in> UniBS ")
      apply (subgoal_tac "Body1 = ([y], Code1, 0)", simp) apply (simp add: Body1_def)
      apply (rule UniInj)
      apply (subgoal_tac "AL_sum emp[\<mu>\<mapsto>(classTP C)][\<beta>\<mapsto>intTP] N[\<alpha>\<mapsto>intTP]
        N[\<alpha>\<mapsto>intTP][\<beta>\<mapsto>intTP][\<mu>\<mapsto>(classTP C)]")
      prefer 2 apply (simp add: AL_sum_def)
               apply (rule, simp add: AL_dom_emp AL_dom_upd1) apply fast
               apply (simp add: contained_def, rule)
                 apply clarsimp apply (drule AL_upd_split)
                         apply (erule disjE, clarsimp)
                           apply (rule AL_update5, rule AL_update1)
                           apply (drule_tac N=M in mkMP_Rel_dist) apply fastsimp
                         apply clarsimp
                           apply (drule AL_upd_split)
                           apply (erule disjE, clarsimp) apply (rule AL_update1)
                           apply (simp add: AL_emp1)
                 apply clarsimp apply (drule AL_upd_split)
                         apply (erule disjE, clarsimp) 
                           apply (rule AL_update5, rule AL_update5, rule AL_update1) 
                           apply (drule_tac N=M in mkMP_Rel_dist) apply fastsimp
                           apply (drule_tac N=M in mkMP_Rel_dist) apply fastsimp
                         apply clarsimp
                           apply (rule AL_update5, rule AL_update5, erule AL_update5)
                             apply assumption
                             apply (drule AL_domI) 
                               apply (drule_tac N=M in mkMP_Rel_dist) apply (drule_tac N=N in mkMP_Rel_dom) apply fastsimp
                             apply (drule AL_domI) 
                               apply (drule_tac N=M in mkMP_Rel_dist) apply (drule_tac N=N in mkMP_Rel_dom) apply fastsimp
      apply (rule_tac H=emp and N="N[\<alpha>\<mapsto>intTP]" and NN="emp[\<mu>\<mapsto>(classTP C)][\<beta>\<mapsto>intTP]" in UniBSFrame)
        apply (rule_tac \<gamma>=\<mu> and F=emp in M1_unisound) apply assumption apply fastsimp 
          apply (simp (no_asm) add: star_def AL_sum_def contained_def)
            apply (rule, simp add: AL_dom_upd1 AL_dom_emp)
            apply (rule, clarsimp)
              apply (rule AL_update5, assumption) apply (drule AL_domI) apply (drule_tac N=M in mkMP_Rel_dist)
                                                    apply (simp add: AL_dom_upd1 AL_dom_emp) apply fastsimp
            apply (rule, clarsimp) 
              apply (drule AL_upd_split)
              apply (erule disjE, clarsimp) apply (rule AL_update1)
              apply (simp add: AL_emp1)
            apply (rule, simp add: AL_dom_upd1 AL_dom_emp) apply (drule_tac N=M in mkMP_Rel_dist) apply fastsimp
            apply (rule AL_UPD, rule AL_UPD, rule AL_EMP)
          apply simp 
          apply (simp add: SD_sum_def) apply (rule, rule AL_sum_emp2) apply (simp add: AL_dom_emp) 
          apply (simp add: SD_sum_def) apply (rule, rule AL_sum_emp2) apply (simp add: AL_dom_emp)
        apply assumption
        apply assumption
        apply (drule_tac N=N in mkMP_Rel_dom) apply (frule_tac N=M in mkMP_Rel_dom) 
           apply (drule_tac N=M in mkMP_Rel_dist) apply (simp add: AL_dom_upd1 AL_dom_emp) apply fast 
        apply (rule AL_UPD, rule AL_UPD, rule AL_UPD) apply (simp add: mkMP_Rel_def) apply clarsimp
      (* apply fast *)
    apply clarsimp
    (*we've reached the return instruction, so now do the right component*)
    apply (rule TypingInj)
    apply (rule UniInjectR)
    apply (rule UniStore)
      apply (rule getIns_M2_16) apply simp
      prefer 6 apply fastsimp
      apply fastsimp
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
    apply clarsimp
    apply (rule TypingInj)
    apply (rule UniInjectR)
    apply (rule_tac cl=\<nu> and D=C in UniNew)
      apply (rule getIns_M2_17) apply simp
      prefer 8 apply fastsimp
      apply fastsimp
      apply (drule mkMP_Rel_dom) apply (frule mkMP_Rel_dom) apply (drule mkMP_Rel_dist)  apply(simp add: AL_dom_upd1) apply fastsimp
      apply simp
      apply (simp add: subclass_of_refl)
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
    apply clarsimp
    apply (rule TypingInj)
    apply (rule UniInjectR)
    apply (rule UniDup)
      apply (rule getIns_M2_18) apply simp
      prefer 6 apply fastsimp
      apply fastsimp
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
    apply clarsimp
    apply (rule TypingInj)
    apply (rule UniInjectR)
    apply (rule UniLoad)
      apply (rule getIns_M2_19) apply simp
      prefer 7 apply fastsimp
      apply fastsimp
      apply (rule AL_update1)
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
    apply clarsimp
    apply (rule TypingInj)
    apply (rule UniInjectR)
    apply (rule UniPut)
      apply (rule getIns_M2_20) apply simp
      prefer 7 apply fastsimp
      apply fastsimp
      apply (rule AL_update1)
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
    apply clarsimp
    apply (rule TypingInj)
    apply (rule UniInjectR)
    apply (rule UniGet)
      apply (rule getIns_M2_21) apply simp
      prefer 8 apply fastsimp
      apply fastsimp
      apply (rule AL_update1)
      apply (rule AL_update1)
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
    (*now we've arrived at return instructions in both compoents*)
    apply clarsimp
    apply (rule TypingInj)
    apply (rule_tac H=emp and N=emp and K=emp in TypingFrame)
      apply (rule TypingRetRet)
        apply (rule getIns_M2_12) apply simp
        apply (rule getIns_M2_22) apply simp
        apply simp
        apply simp
      apply (simp add: RSD_sum_def) apply (rule, simp) apply (rule, simp) apply (rule, simp) apply (rule, simp)
         apply (rule, simp) apply (rule, simp) apply (rule, rule AL_UPD, rule AL_EMP) 
         apply (rule, rule AL_UPD, rule AL_UPD, rule AL_EMP) 
         apply (rule, rule AL_UPD, rule AL_UPD, rule AL_UPD, rule AL_UPD) apply (simp add: mkMP_Rel_def, clarsimp)
         apply (rule, rule AL_sum_emp2) 
         apply (rule, rule AL_sum_emp2) 
         apply (rule, rule AL_sum_emp2) 
         apply (simp add: AL_dom_emp)
      apply (simp add: RSD_sum_def)
         apply (rule, rule AL_UPD, rule AL_EMP) 
         apply (rule, rule AL_UPD, rule AL_EMP) 
         apply (rule, simp add: mkMP_Rel_def, clarsimp)
         apply (rule, rule AL_sum_emp2) 
         apply (rule, simp add: upd_upd) apply (rule AL_sum_emp2) 
         apply (simp add: AL_dom_emp)
         apply (simp (no_asm) add: AL_sum_def contained_def)
           apply (rule, drule mkMP_Rel_dom, drule mkMP_Rel_dom, simp add: AL_dom_emp AL_dom_upd1) apply fast
           apply (simp add: AL_emp1, clarsimp)
           apply (drule AL_upd_split)
           apply (erule disjE, clarsimp)
             apply (erule mkMP_Rel_Clookup) apply simp apply clarsimp
           apply (drule AL_upd_split)
           apply (erule disjE, clarsimp)
             apply (erule mkMP_Rel_Clookup) apply simp apply clarsimp
           apply (drule AL_upd_split)
           apply (erule disjE, clarsimp)
             apply (erule mkMP_Rel_Ilookup) apply simp apply clarsimp
           apply (drule AL_upd_split)
           apply (erule disjE, clarsimp)
             apply (erule mkMP_Rel_Ilookup) apply simp apply clarsimp
           apply (erule mkMP_Rel_extend, assumption+) apply simp apply simp
(*13,3*)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectL)
  prefer 2 apply (rule UniCtxtVerified_emp)
  prefer 2 apply fastsimp
  apply (rule UniLoad)
    apply (rule getIns_M2_13) apply simp
    apply fastsimp
    apply (rule AL_update1)
    apply simp
    apply simp
    apply simp
    (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectR)
  prefer 2 apply (rule UniCtxtVerified_emp)
  prefer 2 apply fastsimp
  apply (rule UniIf)
    apply (rule getIns_M2_3) apply simp
    apply fastsimp
    apply simp
    apply simp
    apply simp
    (* apply fast *)
  apply clarsimp
  apply rule
    (*14,4*) (*other case is: (14,13)*)
    (*The proof of this is similar to the one of (4,14) above - just swap the two components*)
    apply clarsimp
    apply (rule TypingInj)
    apply (rule_tac c=\<alpha> in TypingConstConst)
      apply (rule getIns_M2_14) apply simp
      apply (rule getIns_M2_4) apply simp
      apply fastsimp
      apply clarsimp apply (frule_tac N=N in mkMP_Rel_dom) apply (frule_tac N=M in mkMP_Rel_dom) 
             apply (drule_tac N=M in mkMP_Rel_dist) apply fastsimp 
    apply clarsimp
    apply (rule TypingInj)
    apply (rule UniInjectR)
    apply (rule UniStore)
      apply (rule getIns_M2_5) apply simp
      prefer 6 apply fastsimp
      apply fastsimp
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
    apply clarsimp
    apply (rule TypingInj)
    apply (rule UniInjectR)
    apply (rule UniLoad)
      apply (rule getIns_M2_6) apply simp
      prefer 7 apply fastsimp
      apply fastsimp
      apply (simp add: mkStore_def) apply (rule AL_update5, rule AL_update5, rule AL_update5) 
        apply (rule AL_update1) apply assumption+
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
    apply clarsimp
    apply (rule TypingInj)
    apply (rule UniInjectR)
    apply (rule UniLoad)
      apply (rule getIns_M2_7) apply simp
      prefer 7 apply fastsimp
      apply fastsimp
      apply (rule AL_update1) 
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
    (*now that we have reached the binop instruction in the rightt component, 
      (and are already at the binop in the left component*)
    apply clarsimp
    apply (rule TypingInj)
    apply (rule_tac c=\<beta> in TypingBinopBinop)
      apply (rule getIns_M2_15) apply simp
      apply (rule getIns_M2_8) apply simp
      apply fastsimp
      apply clarsimp apply (frule_tac N=N in mkMP_Rel_dom) apply (frule_tac N=M in mkMP_Rel_dom) 
             apply (drule_tac N=M in mkMP_Rel_dist) apply (simp add: AL_dom_upd1) apply fastsimp 
      apply (rule AL_update1)
      apply (rule AL_update5) apply (erule mkMP_Rel_Ilookup) apply simp
        apply (drule_tac N=M in mkMP_Rel_dist) apply simp apply fast
      apply assumption 
    apply clarsimp
    (*we again first procede in the right component as far as possible, in this case until
        we hit the return instruction*)
    apply (rule TypingInj)
    apply (rule UniInjectR)
    apply (rule_tac cl=\<nu> and D=C in UniNew) 
      apply (rule getIns_M2_9) apply simp
      prefer 8 apply fastsimp
      apply fastsimp
      apply (drule mkMP_Rel_dom) apply (frule mkMP_Rel_dom) apply (drule mkMP_Rel_dist) apply(simp add: AL_dom_upd1)
      apply simp
      apply (simp add: subclass_of_refl)
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
    apply clarsimp
    apply (rule TypingInj)
    apply (rule UniInjectR)
    apply (rule UniSwap)
      apply (rule getIns_M2_10) apply simp
      prefer 6 apply fastsimp
      apply fastsimp
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
    apply clarsimp
    apply (subgoal_tac "mbody_is C M1 ([y], Code1, 0)")
    prefer 2 apply (simp add: mbody_is_def Prog1_def)
        apply (subgoal_tac "emp[C\<mapsto>Class]\<down>C = Some Class", simp)
          apply (simp add: Class_def Body1_def)
          apply (rule AL_update5, rule AL_update5, rule AL_update1) apply assumption apply assumption
        apply (rule AL_update1)
    apply (rule TypingInj)
    apply (rule UniInjectR)
    apply (rule_tac HH="emp[\<nu>\<mapsto>(C, emp[A\<mapsto>\<beta>])]" and c=\<beta> in UniInvV3)
      apply (rule getIns_M2_11) apply simp
      apply assumption
      prefer 9 apply fastsimp
      apply fastsimp
      apply (rule absFrameCons) 
        apply (rule absFrameNil) apply fastsimp 
        apply simp
      apply (rule AL_update1)
      apply simp
      apply simp
      prefer 3 apply (rule UniCtxtVerified_emp)
      prefer 2 apply clarsimp apply (erule_tac x=E in allE, clarsimp)
        apply (rule, rule, rule, assumption)
      apply (subgoal_tac "({}, ([], emp[y\<mapsto>\<beta>][this\<mapsto>\<nu>], emp[\<nu>\<mapsto>(C, emp)]), N[\<alpha>\<mapsto>intTP][\<beta>\<mapsto>intTP][\<nu>\<mapsto>(classTP C)],
        Body1, 0, True, emp[\<nu>\<mapsto>(C, emp[A\<mapsto>\<beta>])], \<beta>, N[\<alpha>\<mapsto>intTP][\<beta>\<mapsto>intTP][\<nu>\<mapsto>(classTP C)])
       \<in> UniBS ")
      apply (subgoal_tac "Body1 = ([y], Code1, 0)", simp) apply (simp add: Body1_def)
      apply (rule UniInj)
      apply (subgoal_tac "AL_sum emp[\<nu>\<mapsto>(classTP C)][\<beta>\<mapsto>intTP] N[\<alpha>\<mapsto>intTP] 
        N[\<alpha>\<mapsto>intTP][\<beta>\<mapsto>intTP][\<nu>\<mapsto>(classTP C)]")
      prefer 2 apply (simp add: AL_sum_def)
               apply (rule, simp add: AL_dom_emp AL_dom_upd1) apply fast
               apply (simp add: contained_def, rule)
                 apply clarsimp apply (drule AL_upd_split)
                         apply (erule disjE, clarsimp)
                           apply (rule AL_update5, rule AL_update1)
                           apply (drule_tac N=M in mkMP_Rel_dist) apply fastsimp
                         apply clarsimp
                           apply (drule AL_upd_split)
                           apply (erule disjE, clarsimp) apply (rule AL_update1)
                           apply (simp add: AL_emp1)
                 apply clarsimp 
                           apply (rule AL_update5, rule AL_update5, assumption) 
                             apply (drule AL_domI) 
                               apply (drule_tac N=M in mkMP_Rel_dist) apply (drule_tac N=N in mkMP_Rel_dom) 
                               apply (simp add: AL_dom_upd1) apply fastsimp
                             apply (drule AL_domI) 
                               apply (drule_tac N=M in mkMP_Rel_dist) apply (drule_tac N=N in mkMP_Rel_dom)
                               apply (simp add: AL_dom_upd1) apply fastsimp
      apply (rule_tac H=emp and N="N[\<alpha>\<mapsto>intTP]" and NN="emp[\<nu>\<mapsto>(classTP C)][\<beta>\<mapsto>intTP]" in UniBSFrame)
        apply (rule_tac \<gamma>=\<nu> and F=emp in M1_unisound) apply assumption apply fastsimp 
          apply (simp (no_asm) add: star_def AL_sum_def contained_def)
            apply (rule, simp add: AL_dom_upd1 AL_dom_emp)
            apply (rule, clarsimp)
              apply (rule AL_update5, assumption) apply (drule AL_domI) apply (drule_tac N=M in mkMP_Rel_dist)
                                                    apply (simp add: AL_dom_upd1 AL_dom_emp) apply fastsimp
            apply (rule, clarsimp) 
              apply (drule AL_upd_split)
              apply (erule disjE, clarsimp) apply (rule AL_update1)
              apply (simp add: AL_emp1)
            apply (rule, simp add: AL_dom_upd1 AL_dom_emp) apply (drule_tac N=M in mkMP_Rel_dist) apply fastsimp
            apply (rule AL_UPD, rule AL_UPD, rule AL_EMP)
          apply simp
          apply (simp add: SD_sum_def) apply (rule, rule AL_sum_emp2) apply (simp add: AL_dom_emp) 
          apply (simp add: SD_sum_def) apply (rule, rule AL_sum_emp2) apply (simp add: AL_dom_emp)
        apply assumption
        apply assumption
        apply (drule_tac N=N in mkMP_Rel_dom) apply (frule_tac N=M in mkMP_Rel_dom) 
           apply (drule_tac N=M in mkMP_Rel_dist) apply (simp add: AL_dom_upd1 AL_dom_emp) apply fast 
        apply (rule AL_UPD, rule AL_UPD, rule AL_UPD) apply (simp add: mkMP_Rel_def) apply clarsimp
      (* apply fast *)
    apply clarsimp
    (*we've reached the return instruction, so now do the left component*)
    apply (rule TypingInj)
    apply (rule UniInjectL)
    apply (rule UniStore)
      apply (rule getIns_M2_16) apply simp
      prefer 6 apply fastsimp
      apply fastsimp
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
    apply clarsimp
    apply (rule TypingInj)
    apply (rule UniInjectL)
    apply (rule_tac cl=\<mu> and D=C in UniNew)
      apply (rule getIns_M2_17) apply simp
      prefer 8 apply fastsimp
      apply fastsimp
      apply (drule mkMP_Rel_dom) apply (frule mkMP_Rel_dom) apply (drule mkMP_Rel_dist)  apply(simp add: AL_dom_upd1) 
      apply simp
      apply (simp add: subclass_of_refl)
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
    apply clarsimp
    apply (rule TypingInj)
    apply (rule UniInjectL)
    apply (rule UniDup)
      apply (rule getIns_M2_18) apply simp
      prefer 6 apply fastsimp
      apply fastsimp
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
    apply clarsimp
    apply (rule TypingInj)
    apply (rule UniInjectL)
    apply (rule UniLoad)
      apply (rule getIns_M2_19) apply simp
      prefer 7 apply fastsimp
      apply fastsimp
      apply (rule AL_update1)
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
    apply clarsimp
    apply (rule TypingInj)
    apply (rule UniInjectL)
    apply (rule UniPut)
      apply (rule getIns_M2_20) apply simp
      prefer 7 apply fastsimp
      apply fastsimp
      apply (rule AL_update1)
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
    apply clarsimp
    apply (rule TypingInj)
    apply (rule UniInjectL)
    apply (rule UniGet)
      apply (rule getIns_M2_21) apply simp
      prefer 8 apply fastsimp
      apply fastsimp
      apply (rule AL_update1)
      apply (rule AL_update1)
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
    (*now we've arrived at return instructions in both compoents*)
    apply clarsimp
    apply (rule TypingInj)
    apply (rule_tac H=emp and N=emp and K=emp in TypingFrame)
      apply (rule_tac c=\<beta> and S="[]" and \<Gamma>="(mkStore \<gamma> \<delta>)[x\<mapsto>\<gamma>][x\<mapsto>\<beta>]" and
       d=\<beta> and T="[]" and \<Delta>="(mkStore \<gamma> \<epsilon>)[x\<mapsto>\<gamma>][x\<mapsto>\<alpha>]" in TypingRetRet)
        apply (rule getIns_M2_22) apply simp
        apply (rule getIns_M2_12) apply simp
        apply simp
        apply simp
      apply (simp add: RSD_sum_def)
        apply (rule, rule AL_UPD, rule AL_UPD, rule AL_EMP)
        apply (rule, rule AL_UPD, rule AL_EMP)
        apply (rule, rule AL_UPD, rule AL_UPD, rule AL_UPD, rule AL_UPD, simp add: mkMP_Rel_def, clarsimp)
        apply (rule, rule AL_sum_emp2)
        apply (rule, rule AL_sum_emp2)
        apply (rule, rule AL_sum_emp2)
        apply (simp add: AL_dom_upd AL_dom_emp)
      apply (simp add: RSD_sum_def)
        apply (rule, rule AL_UPD, rule AL_EMP)
        apply (rule, rule AL_UPD, rule AL_EMP)
        apply (rule, simp add: mkMP_Rel_def, clarsimp)
        apply (rule, simp add: upd_upd) apply (rule AL_sum_emp2)          
        apply (rule, rule AL_sum_emp2)
        apply (rule, simp add: AL_sum_def)
         apply (simp add: AL_dom_emp)
         apply (simp (no_asm) add: AL_sum_def contained_def)
           apply (rule, drule mkMP_Rel_dom, drule mkMP_Rel_dom, simp add: AL_dom_emp AL_dom_upd1) apply fast
           apply (simp add: AL_emp1, clarsimp)
           apply (drule AL_upd_split)
           apply (erule disjE, clarsimp)
             apply (erule mkMP_Rel_Clookup) apply simp apply clarsimp
           apply (drule AL_upd_split)
           apply (erule disjE, clarsimp)
             apply (erule mkMP_Rel_Clookup) apply simp apply clarsimp
           apply (drule AL_upd_split)
           apply (erule disjE, clarsimp)
             apply (erule mkMP_Rel_Ilookup) apply simp apply clarsimp
           apply (drule AL_upd_split)
           apply (erule disjE, clarsimp)
             apply (erule mkMP_Rel_Ilookup) apply simp apply clarsimp
           apply (erule mkMP_Rel_extend, assumption+) apply simp apply simp
          apply (simp add: AL_dom_emp) 
  (*Branch (14,13)*)
    apply clarsimp
    apply (rule TypingInj)
    apply (rule UniInjectR)
    apply (rule UniLoad)
      apply (rule getIns_M2_13) apply simp
      prefer 7 apply fastsimp
      apply fastsimp
      apply (rule AL_update1) 
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
    apply clarsimp
    apply (rule TypingInj)
    apply (rule_tac c=\<alpha> in TypingConstConst)
      apply (rule getIns_M2_14) apply simp
      apply (rule getIns_M2_14) apply simp
      apply fastsimp
      apply clarsimp apply (frule_tac N=N in mkMP_Rel_dom) apply (frule_tac N=M in mkMP_Rel_dom) 
             apply (drule_tac N=M in mkMP_Rel_dist) apply fastsimp 
    apply clarsimp
    apply (rule TypingInj)
    apply (rule_tac c=\<beta> in TypingBinopBinop)
      apply (rule getIns_M2_15) apply simp
      apply (rule getIns_M2_15) apply simp
      apply fastsimp
      apply clarsimp apply (frule_tac N=N in mkMP_Rel_dom) apply (frule_tac N=M in mkMP_Rel_dom) 
             apply (drule_tac N=M in mkMP_Rel_dist) apply (simp add: AL_dom_upd1) apply fastsimp 
      apply (rule AL_update1)
      apply (rule AL_update5) apply (erule mkMP_Rel_Ilookup) apply simp
        apply (drule_tac N=M in mkMP_Rel_dist) apply simp apply fast
      apply assumption
    (*procede to the end in left component*)
    apply clarsimp
    apply (rule TypingInj)
    apply (rule UniInjectL)
    apply (rule UniStore)
      apply (rule getIns_M2_16) apply simp
      prefer 6 apply fastsimp
      apply fastsimp
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
    apply clarsimp
    apply (rule TypingInj)
    apply (rule UniInjectL)
    apply (rule_tac cl=\<mu> and D=C in UniNew)
      apply (rule getIns_M2_17) apply simp
      prefer 8 apply fastsimp
      apply fastsimp
      apply (drule mkMP_Rel_dom) apply (frule mkMP_Rel_dom) apply (drule mkMP_Rel_dist) apply(simp add: AL_dom_upd1)
      apply simp
      apply (simp add: subclass_of_refl)
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
    apply clarsimp
    apply (rule TypingInj)
    apply (rule UniInjectL)
    apply (rule UniDup)
      apply (rule getIns_M2_18) apply simp
      prefer 6 apply fastsimp
      apply fastsimp
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
    apply clarsimp
    apply (rule TypingInj)
    apply (rule UniInjectL)
    apply (rule UniLoad)
      apply (rule getIns_M2_19) apply simp
      prefer 7 apply fastsimp
      apply fastsimp
      apply (rule AL_update1)
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
    apply clarsimp
    apply (rule TypingInj)
    apply (rule UniInjectL)
    apply (rule UniPut)
      apply (rule getIns_M2_20) apply simp
      prefer 7 apply fastsimp
      apply fastsimp
      apply (rule AL_update1)
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
    apply clarsimp
    apply (rule TypingInj)
    apply (rule UniInjectL)
    apply (rule UniGet)
      apply (rule getIns_M2_21) apply simp
      prefer 8 apply fastsimp
      apply fastsimp
      apply (rule AL_update1)
      apply (rule AL_update1)
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  (*procede to the end in right component*)
    apply clarsimp
    apply (rule TypingInj)
    apply (rule UniInjectR)
    apply (rule UniStore)
      apply (rule getIns_M2_16) apply simp
      prefer 6 apply fastsimp
      apply fastsimp
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
    apply clarsimp
    apply (rule TypingInj)
    apply (rule UniInjectR)
    apply (rule_tac cl=\<nu> and D=C in UniNew)
      apply (rule getIns_M2_17) apply simp
      prefer 8 apply fastsimp
      apply fastsimp
      apply (drule mkMP_Rel_dom) apply (frule mkMP_Rel_dom) apply (drule mkMP_Rel_dist) apply(simp add: AL_dom_upd1) apply fast
      apply simp
      apply (simp add: subclass_of_refl)
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
    apply clarsimp
    apply (rule TypingInj)
    apply (rule UniInjectR)
    apply (rule UniDup)
      apply (rule getIns_M2_18) apply simp
      prefer 6 apply fastsimp
      apply fastsimp
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
    apply clarsimp
    apply (rule TypingInj)
    apply (rule UniInjectR)
    apply (rule UniLoad)
      apply (rule getIns_M2_19) apply simp
      prefer 7 apply fastsimp
      apply fastsimp
      apply (rule AL_update1)
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
    apply clarsimp
    apply (rule TypingInj)
    apply (rule UniInjectR)
    apply (rule UniPut)
      apply (rule getIns_M2_20) apply simp
      prefer 7 apply fastsimp
      apply fastsimp
      apply (rule AL_update1)
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
    apply clarsimp
    apply (rule TypingInj)
    apply (rule UniInjectR)
    apply (rule UniGet)
      apply (rule getIns_M2_21) apply simp
      prefer 8 apply fastsimp
      apply fastsimp
      apply (rule AL_update1)
      apply (rule AL_update1)
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
    (*now we've arrived at return instructions in both compoents*)
    apply clarsimp
    apply (rule TypingInj)
    apply (rule_tac H=emp and N=emp and K=emp in TypingFrame)
      apply (rule TypingRetRet)
        apply (rule getIns_M2_22) apply simp
        apply (rule getIns_M2_22) apply simp
      apply fastsimp
      apply simp
      apply (simp add: RSD_sum_def upd_upd) apply (rule, simp) apply (rule, simp) apply (rule, simp) apply (rule, simp)
         apply (rule, simp) apply (rule, simp) apply (rule, rule AL_UPD, rule AL_EMP) 
         apply (rule, rule AL_UPD, rule AL_EMP) 
         apply (rule, rule AL_UPD, rule AL_UPD, rule AL_UPD, rule AL_UPD) apply (simp add: mkMP_Rel_def, clarsimp)
         apply (rule, rule AL_sum_emp2) 
         apply (rule, rule AL_sum_emp2) 
         apply (rule, rule AL_sum_emp2) 
         apply (simp add: AL_dom_emp)
      apply (simp add: RSD_sum_def)
         apply (rule, rule AL_UPD, rule AL_EMP) 
         apply (rule, rule AL_UPD, rule AL_EMP) 
         apply (rule, simp add: mkMP_Rel_def, clarsimp)
         apply (rule, rule AL_sum_emp2) 
         apply (rule, rule AL_sum_emp2) 
         apply (simp add: AL_dom_emp)
         apply (simp (no_asm) add: AL_sum_def contained_def)
           apply (rule, drule mkMP_Rel_dom, drule mkMP_Rel_dom, simp add: AL_dom_emp AL_dom_upd1) apply fast
           apply (simp add: AL_emp1, clarsimp)
           apply (drule AL_upd_split)
           apply (erule disjE, clarsimp)
             apply (erule mkMP_Rel_Clookup) apply simp apply clarsimp
           apply (drule AL_upd_split)
           apply (erule disjE, clarsimp)
             apply (erule mkMP_Rel_Clookup) apply simp apply clarsimp
           apply (drule AL_upd_split)
           apply (erule disjE, clarsimp)
             apply (erule mkMP_Rel_Ilookup) apply simp apply clarsimp
           apply (drule AL_upd_split)
           apply (erule disjE, clarsimp)
             apply (erule mkMP_Rel_Ilookup) apply simp apply clarsimp
           apply (erule mkMP_Rel_extend, assumption+) apply simp apply simp
done

text{*The second proof correlates the allocations, i.e.~uses $\mu$ on
both sides. Hence, we don't need the colour $\nu$.*}

lemma M2_correlated:
  "\<lbrakk>P=Prog1; M2 \<noteq> M1; M4 \<noteq> M1; y \<noteq> this; h \<noteq> l; x \<noteq> h;x \<noteq> l;
    \<forall> D . subclass_of D C \<longrightarrow> D=C; mkMP_Rel [\<gamma>, \<delta>, \<epsilon>] [] N;
    \<Phi>=(mkState \<gamma> \<delta>,N,mkState \<gamma> \<epsilon>); 
    mkMP_Rel [\<gamma>, \<delta>, \<epsilon>, \<alpha>, \<beta>] [\<mu>] M;isOfType plus intTP intTP intTP;
    \<Psi> = (([\<beta>], emp, emp[\<mu>\<mapsto>(C, emp[A\<mapsto>\<beta>])]),M, [\<beta>], emp, emp[\<mu>\<mapsto>(C, emp[A\<mapsto>\<beta>])])\<rbrakk> 
 \<Longrightarrow> (G, \<Phi>, Body2, 0, Body2, 0, False, \<Psi>) :Typing"
apply (rule UniInjectL)
apply (rule UniLoad)
  apply (rule getIns_M2_0)
  prefer 7 apply assumption 
  apply (simp add: mkState_def) apply fastsimp
  apply (simp add: mkStore_def) apply (rule AL_update5, rule AL_update1) apply assumption
  apply simp
  apply simp
  apply simp
  apply (rule UniCtxtVerified_emp)
  (* apply fast *)
apply clarsimp
apply (rule TypingInj)
apply (rule UniInjectL)
apply (rule UniStore)
  apply (rule getIns_M2_1) apply simp 
  prefer 6 apply fastsimp
  apply fastsimp
  apply simp 
  apply simp
  apply simp
  apply (rule UniCtxtVerified_emp)
  (* apply fast *)
apply clarsimp
apply (rule TypingInj)
apply (rule UniInjectL)
apply (rule UniLoad)
  apply (rule getIns_M2_2) apply simp
  prefer 7 apply fastsimp
  apply fastsimp
  apply (simp add: mkStore_def) apply (rule AL_update5, rule AL_update1) apply assumption
  apply simp
  apply simp
  apply simp
  apply (rule UniCtxtVerified_emp)
  (* apply fast *)
apply clarsimp
apply (rule TypingInj)
apply (rule UniInjectR)
apply (rule UniLoad)
  apply (rule getIns_M2_0)
  prefer 7 apply fastsimp
  apply (simp add: mkState_def) apply fastsimp
  apply (simp add: mkStore_def) apply (rule AL_update5, rule AL_update1) apply assumption
  apply simp
  apply simp
  apply simp
  apply (rule UniCtxtVerified_emp)
  (* apply fast *)
apply clarsimp
apply (rule TypingInj)
apply (rule UniInjectR)
apply (rule UniStore)
  apply (rule getIns_M2_1) apply simp 
  prefer 6 apply fastsimp
  apply fastsimp
  apply simp 
  apply simp
  apply simp
  apply (rule UniCtxtVerified_emp)
  (* apply fast *)
apply clarsimp
apply (rule TypingInj)
apply (rule UniInjectR)
apply (rule UniLoad)
  apply (rule getIns_M2_2) apply simp
  prefer 7 apply fastsimp
  apply fastsimp
  apply (simp add: mkStore_def) apply (rule AL_update5, rule AL_update1) apply assumption
  apply simp
  apply simp
  apply simp
  apply (rule UniCtxtVerified_emp)
  (* apply fast *)
apply clarsimp
apply (rule TypingInj)
apply (rule UniInjectL)
prefer 2 apply (rule UniCtxtVerified_emp)
prefer 2 apply fastsimp
apply (rule UniIf)
  apply (rule getIns_M2_3) apply simp
  apply fastsimp
  apply simp
  apply simp
  apply simp
  (* apply fast *)
apply clarsimp
apply rule
  (*4,3*) (*other case is: (13,3)*)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectR)
  prefer 2 apply (rule UniCtxtVerified_emp)
  prefer 2 apply fastsimp
  apply (rule UniIf)
    apply (rule getIns_M2_3) apply simp
    apply fastsimp
    apply simp
    apply simp
    apply simp
    (* apply fast *)
  apply clarsimp
  apply rule
    (*4,4*) (*other case is: (4,13)*)
    apply clarsimp
    apply (rule TypingInj)
    apply (rule_tac c=\<alpha> in TypingConstConst)
      apply (rule getIns_M2_4) apply simp
      apply (rule getIns_M2_4) apply simp
      apply fastsimp
      apply clarsimp apply (frule_tac N=N in mkMP_Rel_dom) apply (frule_tac N=M in mkMP_Rel_dom) 
             apply (drule_tac N=M in mkMP_Rel_dist) apply fastsimp 
    apply clarsimp
    apply (rule TypingInj)
    apply (rule UniInjectL)
    apply (rule UniStore)
      apply (rule getIns_M2_5) apply simp
      prefer 6 apply fastsimp
      apply fastsimp
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
    apply clarsimp
    apply (rule TypingInj)
    apply (rule UniInjectL)
    apply (rule UniLoad)
      apply (rule getIns_M2_6) apply simp
      prefer 7 apply fastsimp
      apply fastsimp
      apply (simp add: mkStore_def) apply (rule AL_update5, rule AL_update5, rule AL_update5) 
        apply (rule AL_update1) apply assumption+
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
    apply clarsimp
    apply (rule TypingInj)
    apply (rule UniInjectL)
    apply (rule UniLoad)
      apply (rule getIns_M2_7) apply simp
      prefer 7 apply fastsimp
      apply fastsimp
      apply (rule AL_update1) 
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
    apply clarsimp
    (*now that we have reached the binop instruction in the left component, 
       we proceed along the right component to the same point*)
    apply (rule TypingInj)
    apply (rule UniInjectR)
    apply (rule UniStore)
      apply (rule getIns_M2_5) apply simp
      prefer 6 apply fastsimp
      apply fastsimp
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
    apply clarsimp
    apply (rule TypingInj)
    apply (rule UniInjectR)
    apply (rule UniLoad)
      apply (rule getIns_M2_6) apply simp
      prefer 7 apply fastsimp
      apply fastsimp
      apply (simp add: mkStore_def) apply (rule AL_update5, rule AL_update5, rule AL_update5) 
        apply (rule AL_update1) apply assumption+
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
    apply clarsimp
    apply (rule TypingInj)
    apply (rule UniInjectR)
    apply (rule UniLoad)
      apply (rule getIns_M2_7) apply simp
      prefer 7 apply fastsimp
      apply fastsimp
      apply (rule AL_update1) 
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
    apply clarsimp
    apply (rule TypingInj)
    apply (rule_tac c=\<beta> in TypingBinopBinop)
      apply (rule getIns_M2_8) apply simp
      apply (rule getIns_M2_8) apply simp
      apply fastsimp
      apply clarsimp apply (frule_tac N=N in mkMP_Rel_dom) apply (frule_tac N=M in mkMP_Rel_dom) 
             apply (drule_tac N=M in mkMP_Rel_dist) apply (simp add: AL_dom_upd1) apply fastsimp 
      apply (rule AL_update1)
      apply (rule AL_update5) apply (erule mkMP_Rel_Ilookup) apply simp
        apply (drule_tac N=M in mkMP_Rel_dist) apply simp apply fast
      apply assumption
    apply clarsimp
    (*we correlated the allocations*)
    apply (rule TypingInj)
    apply (rule_tac c=\<mu> and C=C in  TypingNewNew)
      apply (rule getIns_M2_9) apply simp
      apply (rule getIns_M2_9) apply simp
      apply fastsimp
      apply (drule mkMP_Rel_dom) apply (frule mkMP_Rel_dom) apply (drule mkMP_Rel_dist)  apply(simp add: AL_dom_upd1)
      apply (simp add: subclass_of_refl)
      apply (simp add: subclass_of_refl)
    apply clarsimp
    (*we now again first procede in both component independently as far as possible, in this case until
        we hit the return instruction*)
    apply (rule TypingInj)
    apply (rule UniInjectL)
    apply (rule UniSwap)
      apply (rule getIns_M2_10) apply simp
      prefer 6 apply fastsimp
      apply fastsimp
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
    apply clarsimp
    apply (subgoal_tac "mbody_is C M1 ([y], Code1, 0)")
    prefer 2 apply (simp add: mbody_is_def Prog1_def)
        apply (subgoal_tac "emp[C\<mapsto>Class]\<down>C = Some Class", simp)
          apply (simp add: Class_def Body1_def)
          apply (rule AL_update5, rule AL_update5, rule AL_update1) apply assumption apply assumption
        apply (rule AL_update1)
    apply (rule TypingInj)
    apply (rule UniInjectL)
    apply (rule_tac HH="emp[\<mu>\<mapsto>(C, emp[A\<mapsto>\<beta>])]" and c=\<beta> in UniInvV3)
      apply (rule getIns_M2_11) apply simp
      apply assumption
      prefer 9 apply fastsimp
      apply fastsimp
      apply (rule absFrameCons) 
        apply (rule absFrameNil) apply fastsimp 
        apply simp
      apply (rule AL_update1)
      apply simp
      apply simp
      prefer 3 apply (rule UniCtxtVerified_emp)
      prefer 2 apply clarsimp apply (erule_tac x=E in allE, clarsimp)
        apply (rule, rule, rule, assumption)
      apply (subgoal_tac "({}, ([], emp[y\<mapsto>\<beta>][this\<mapsto>\<mu>], emp[\<mu>\<mapsto>(C, emp)]), N[\<alpha>\<mapsto>intTP][\<beta>\<mapsto>intTP][\<mu>\<mapsto>(classTP C)],
        Body1, 0, True, emp[\<mu>\<mapsto>(C, emp[A\<mapsto>\<beta>])], \<beta>, N[\<alpha>\<mapsto>intTP][\<beta>\<mapsto>intTP][\<mu>\<mapsto>(classTP C)])
       \<in> UniBS ")
      apply (subgoal_tac "Body1 = ([y], Code1, 0)", simp) apply (simp add: Body1_def)
      apply (rule UniInj)
      apply (subgoal_tac "AL_sum emp[\<mu>\<mapsto>(classTP C)][\<beta>\<mapsto>intTP] N[\<alpha>\<mapsto>intTP]
        N[\<alpha>\<mapsto>intTP][\<beta>\<mapsto>intTP][\<mu>\<mapsto>(classTP C)]")
      prefer 2 apply (simp add: AL_sum_def)
               apply (rule, simp add: AL_dom_emp AL_dom_upd1) apply fast
               apply (simp add: contained_def, rule)
                 apply clarsimp apply (drule AL_upd_split)
                         apply (erule disjE, clarsimp)
                           apply (rule AL_update5, rule AL_update1)
                           apply (drule_tac N=M in mkMP_Rel_dist) apply fastsimp
                         apply clarsimp
                           apply (drule AL_upd_split)
                           apply (erule disjE, clarsimp) apply (rule AL_update1)
                           apply (simp add: AL_emp1)
                 apply clarsimp apply (drule AL_upd_split)
                         apply (erule disjE, clarsimp) 
                           apply (rule AL_update5, rule AL_update5, rule AL_update1) 
                           apply (drule_tac N=M in mkMP_Rel_dist) apply fastsimp
                           apply (drule_tac N=M in mkMP_Rel_dist) apply fastsimp
                         apply clarsimp
                           apply (rule AL_update5, rule AL_update5, erule AL_update5)
                             apply assumption
                             apply (drule AL_domI) 
                               apply (drule_tac N=M in mkMP_Rel_dist) apply (drule_tac N=N in mkMP_Rel_dom) apply fastsimp
                             apply (drule AL_domI) 
                               apply (drule_tac N=M in mkMP_Rel_dist) apply (drule_tac N=N in mkMP_Rel_dom) apply fastsimp
      apply (rule_tac H=emp and N="N[\<alpha>\<mapsto>intTP]" and NN="emp[\<mu>\<mapsto>(classTP C)][\<beta>\<mapsto>intTP]" in UniBSFrame)
        apply (rule_tac \<gamma>=\<mu> and F=emp in M1_unisound) apply assumption apply fastsimp 
          apply (simp (no_asm) add: star_def AL_sum_def contained_def)
            apply (rule, simp add: AL_dom_upd1 AL_dom_emp)
            apply (rule, clarsimp)
              apply (rule AL_update5, assumption) apply (drule AL_domI) apply (drule_tac N=M in mkMP_Rel_dist)
                                                    apply (simp add: AL_dom_upd1 AL_dom_emp) apply fastsimp
            apply (rule, clarsimp) 
              apply (drule AL_upd_split)
              apply (erule disjE, clarsimp) apply (rule AL_update1)
              apply (simp add: AL_emp1)
            apply (rule, simp add: AL_dom_upd1 AL_dom_emp) apply (drule_tac N=M in mkMP_Rel_dist) apply fastsimp
            apply (rule AL_UPD, rule AL_UPD, rule AL_EMP)
          apply simp 
          apply (simp add: SD_sum_def) apply (rule, rule AL_sum_emp2) apply (simp add: AL_dom_emp) 
          apply (simp add: SD_sum_def) apply (rule, rule AL_sum_emp2) apply (simp add: AL_dom_emp)
        apply assumption
        apply assumption
        apply (drule_tac N=N in mkMP_Rel_dom) apply (frule_tac N=M in mkMP_Rel_dom) 
           apply (drule_tac N=M in mkMP_Rel_dist) apply (simp add: AL_dom_upd1 AL_dom_emp) apply fast 
        apply (rule AL_UPD, rule AL_UPD, rule AL_UPD) apply (simp add: mkMP_Rel_def) apply clarsimp
      (* apply fast *)
    apply clarsimp
    (*we've reached the return instruction, so now do the right component*)
    apply (rule TypingInj)
    apply (rule UniInjectR)
    apply (rule UniSwap)
      apply (rule getIns_M2_10) apply simp
      prefer 6 apply fastsimp
      apply fastsimp
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
    apply clarsimp
    apply (rule TypingInj)
    apply (rule UniInjectR)
    apply (rule_tac HH="emp[\<mu>\<mapsto>(C, emp[A\<mapsto>\<beta>])]" and c=\<beta> in UniInvV3)
      apply (rule getIns_M2_11) apply simp
      apply assumption
      prefer 9 apply fastsimp
      apply fastsimp
      apply (rule absFrameCons) 
        apply (rule absFrameNil) apply fastsimp 
        apply simp
      apply (rule AL_update1)
      apply simp
      apply simp
      prefer 3 apply (rule UniCtxtVerified_emp)
      prefer 2 apply clarsimp apply (erule_tac x=E in allE, clarsimp)
        apply (rule, rule, rule, assumption)
      apply (subgoal_tac "({}, ([], emp[y\<mapsto>\<beta>][this\<mapsto>\<mu>], emp[\<mu>\<mapsto>(C, emp)]), N[\<alpha>\<mapsto>intTP][\<beta>\<mapsto>intTP][\<mu>\<mapsto>(classTP C)], Body1,
        0, True, emp[\<mu>\<mapsto>(C, emp[A\<mapsto>\<beta>])], \<beta>, M)
       \<in> UniBS")
      apply (subgoal_tac "Body1 = ([y], Code1, 0)", simp) apply (simp add: Body1_def)
      apply (rule UniInj)
      apply (subgoal_tac "AL_sum emp[\<mu>\<mapsto>(classTP C)][\<beta>\<mapsto>intTP] N[\<alpha>\<mapsto>intTP] M")
      prefer 2 apply (simp add: AL_sum_def)
               apply (rule, drule_tac N=N in mkMP_Rel_dom) apply (frule_tac N=M in mkMP_Rel_dom) 
                 apply (drule_tac N=M in mkMP_Rel_dist) apply (simp add: AL_dom_upd1 AL_dom_emp) apply fast
               apply (simp add: contained_def, rule)
                 apply clarsimp apply (drule AL_upd_split)
                         apply (erule disjE, clarsimp)
                           apply (erule mkMP_Rel_Ilookup) apply simp
                         apply clarsimp
                           apply (drule AL_upd_split)
                           apply (erule disjE, clarsimp) 
                             apply (erule mkMP_Rel_Clookup) apply simp
                           apply (simp add: AL_emp1)
                 apply clarsimp apply (drule AL_upd_split)
                         apply (erule disjE, clarsimp) 
                           apply (erule mkMP_Rel_Ilookup) apply simp
                         apply clarsimp apply (erule mkMP_Rel_extend) apply assumption apply assumption apply fastsimp apply fastsimp
      apply (rule_tac H=emp and N="N[\<alpha>\<mapsto>intTP]" and NN="emp[\<mu>\<mapsto>(classTP C)][\<beta>\<mapsto>intTP]"in UniBSFrame)
        apply (rule_tac \<gamma>=\<mu> and F=emp in M1_unisound) apply assumption apply simp 
          apply (simp (no_asm) add: star_def AL_sum_def contained_def)
            apply (rule, simp add: AL_dom_upd1 AL_dom_emp)
            apply (rule, clarsimp)
              apply (rule AL_update5, assumption) apply (drule AL_domI) apply (drule_tac N=M in mkMP_Rel_dist)
                                                    apply (simp add: AL_dom_upd1 AL_dom_emp) apply fastsimp
            apply (rule, clarsimp) 
              apply (drule AL_upd_split)
              apply (erule disjE, clarsimp) apply (rule AL_update1)
              apply (simp add: AL_emp1)
            apply (rule, simp add: AL_dom_upd1 AL_dom_emp) apply (drule_tac N=M in mkMP_Rel_dist) apply fastsimp
            apply (rule AL_UPD, rule AL_UPD, rule AL_EMP)
          apply simp 
          apply (simp add: SD_sum_def) apply (rule, rule AL_sum_emp2) apply (simp add: AL_dom_emp) 
          apply (simp add: SD_sum_def) apply (rule, rule AL_sum_emp2) apply (simp add: AL_dom_emp)
        apply (simp (no_asm) add: AL_sum_def contained_def)
          apply (rule, simp add: AL_sum_def AL_dom_upd1 AL_dom_emp) apply fast
          apply (rule, clarsimp) 
            apply (drule AL_upd_split)
            apply (erule disjE, clarsimp) apply (rule AL_update5, rule AL_update1)
              apply (drule_tac N=M in mkMP_Rel_dist) apply fastsimp
            apply (clarsimp, drule AL_upd_split)
            apply (erule disjE, clarsimp) apply (rule AL_update1)
            apply (simp add: AL_emp1)
          apply clarsimp
              apply (rule AL_update5)
                apply (rule AL_update5) apply assumption
                apply (drule AL_domI, simp add: AL_dom_upd1) apply (drule mkMP_Rel_dom) apply (drule mkMP_Rel_dist) apply fastsimp 
              apply (drule AL_domI, simp add: AL_dom_upd1) apply (drule mkMP_Rel_dom) apply (drule mkMP_Rel_dist) apply fastsimp 
              apply assumption
        apply (drule mkMP_Rel_dom) apply (frule mkMP_Rel_dom) apply (drule mkMP_Rel_dist) apply (simp add: AL_dom_upd1 AL_dom_emp) apply fast 
        apply (simp add: mkMP_Rel_def, clarsimp)
      (* apply fast *)
    apply clarsimp
    (*now we've arrive at return instructions in both compoents*)
    apply (rule TypingInj)
    apply (rule_tac 
         c=\<beta> and S="[]" and \<Gamma>="(mkStore \<gamma> \<delta>)[x\<mapsto>\<gamma>][x\<mapsto>\<alpha>]" and
         d=\<beta> and T="[]" and \<Delta>="(mkStore \<gamma> \<epsilon>)[x\<mapsto>\<gamma>][x\<mapsto>\<alpha>]" in TypingRetRet)
      apply (rule getIns_M2_12) apply simp
      apply (rule getIns_M2_12) apply simp
      apply fastsimp
      apply simp
  (*Branch (4,13)*)
    apply clarsimp
    apply (rule TypingInj)
    apply (rule UniInjectR)
    apply (rule UniLoad)
      apply (rule getIns_M2_13) apply simp
      prefer 7 apply fastsimp
      apply fastsimp
      apply (rule AL_update1) 
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
    apply clarsimp
    apply (rule TypingInj)
    apply (rule_tac c=\<alpha> in TypingConstConst)
      apply (rule getIns_M2_4) apply simp
      apply (rule getIns_M2_14) apply simp
      apply fastsimp
      apply clarsimp apply (frule_tac N=N in mkMP_Rel_dom) apply (frule_tac N=M in mkMP_Rel_dom) 
             apply (drule_tac N=M in mkMP_Rel_dist) apply fastsimp 
    apply clarsimp
    apply (rule TypingInj)
    apply (rule UniInjectL)
    apply (rule UniStore)
      apply (rule getIns_M2_5) apply simp
      prefer 6 apply fastsimp
      apply fastsimp
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
    apply clarsimp
    apply (rule TypingInj)
    apply (rule UniInjectL)
    apply (rule UniLoad)
      apply (rule getIns_M2_6) apply simp
      prefer 7 apply fastsimp
      apply fastsimp
      apply (simp add: mkStore_def) apply (rule AL_update5, rule AL_update5, rule AL_update5) 
        apply (rule AL_update1) apply assumption+
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
    apply clarsimp
    apply (rule TypingInj)
    apply (rule UniInjectL)
    apply (rule UniLoad)
      apply (rule getIns_M2_7) apply simp
      prefer 7 apply fastsimp
      apply fastsimp
      apply (rule AL_update1) 
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
    (*now that we have reached the binop instruction in the left component, 
      (and are already at the binop in the right component*)
    apply clarsimp
    apply (rule TypingInj)
    apply (rule_tac c=\<beta> in TypingBinopBinop)
      apply (rule getIns_M2_8) apply simp
      apply (rule getIns_M2_15) apply simp
      apply fastsimp
      apply clarsimp apply (frule_tac N=N in mkMP_Rel_dom) apply (frule_tac N=M in mkMP_Rel_dom) 
             apply (drule_tac N=M in mkMP_Rel_dist) apply (simp add: AL_dom_upd1) apply fastsimp 
      apply (rule AL_update1)
      apply (rule AL_update5) apply (erule mkMP_Rel_Ilookup) apply simp
        apply (drule_tac N=M in mkMP_Rel_dist) apply simp apply fast
      apply assumption
    apply (rule TypingInj)
    apply (rule UniInjectR)
    apply (rule UniStore)
      apply (rule getIns_M2_16) apply simp
      prefer 6 apply fastsimp
      apply fastsimp
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
    apply clarsimp
    (*we again correlate the allocations*)
    apply (rule TypingInj)
    apply (rule_tac c=\<mu> and C=C in TypingNewNew)
      apply (rule getIns_M2_9) apply simp
      apply (rule getIns_M2_17) apply simp
      apply fastsimp
      apply (drule mkMP_Rel_dom) apply (frule mkMP_Rel_dom) apply (drule mkMP_Rel_dist) apply(simp add: AL_dom_upd1)
      apply (simp add: subclass_of_refl)
      apply (simp add: subclass_of_refl)
    apply clarsimp
    (*again, we procede in the left component as far as possible, in this case until
        we hit the return instruction*)
    apply (rule TypingInj)
    apply (rule UniInjectL)
    apply (rule UniSwap)
      apply (rule getIns_M2_10) apply simp
      prefer 6 apply fastsimp
      apply fastsimp
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
    apply clarsimp
    apply (subgoal_tac "mbody_is C M1 ([y], Code1, 0)")
    prefer 2 apply (simp add: mbody_is_def Prog1_def)
        apply (subgoal_tac "emp[C\<mapsto>Class]\<down>C = Some Class", simp)
          apply (simp add: Class_def Body1_def)
          apply (rule AL_update5, rule AL_update5, rule AL_update1) apply assumption apply assumption
        apply (rule AL_update1)
    apply (rule TypingInj)
    apply (rule UniInjectL)
    apply (rule_tac HH="emp[\<mu>\<mapsto>(C, emp[A\<mapsto>\<beta>])]" and c=\<beta> in UniInvV3)
      apply (rule getIns_M2_11) apply simp
      apply assumption
      prefer 9 apply fastsimp
      apply fastsimp
      apply (rule absFrameCons) 
        apply (rule absFrameNil) apply fastsimp 
        apply simp
      apply (rule AL_update1)
      apply simp
      apply simp
      prefer 3 apply (rule UniCtxtVerified_emp)
      prefer 2 apply clarsimp apply (erule_tac x=E in allE, clarsimp)
        apply (rule, rule, rule, assumption)
      apply (subgoal_tac "({}, ([], emp[y\<mapsto>\<beta>][this\<mapsto>\<mu>], emp[\<mu>\<mapsto>(C, emp)]), N[\<alpha>\<mapsto>intTP][\<beta>\<mapsto>intTP][\<mu>\<mapsto>(classTP C)],
        Body1, 0, True, emp[\<mu>\<mapsto>(C, emp[A\<mapsto>\<beta>])], \<beta>, N[\<alpha>\<mapsto>intTP][\<beta>\<mapsto>intTP][\<mu>\<mapsto>(classTP C)])
       \<in> UniBS ")
      apply (subgoal_tac "Body1 = ([y], Code1, 0)", simp) apply (simp add: Body1_def)
      apply (rule UniInj)
      apply (subgoal_tac "AL_sum emp[\<mu>\<mapsto>(classTP C)][\<beta>\<mapsto>intTP] N[\<alpha>\<mapsto>intTP]
        N[\<alpha>\<mapsto>intTP][\<beta>\<mapsto>intTP][\<mu>\<mapsto>(classTP C)]")
      prefer 2 apply (simp add: AL_sum_def)
               apply (rule, simp add: AL_dom_emp AL_dom_upd1) apply fast
               apply (simp add: contained_def, rule)
                 apply clarsimp apply (drule AL_upd_split)
                         apply (erule disjE, clarsimp)
                           apply (rule AL_update5, rule AL_update1)
                           apply (drule_tac N=M in mkMP_Rel_dist) apply fastsimp
                         apply clarsimp
                           apply (drule AL_upd_split)
                           apply (erule disjE, clarsimp) apply (rule AL_update1)
                           apply (simp add: AL_emp1)
                 apply clarsimp apply (drule AL_upd_split)
                         apply (erule disjE, clarsimp) 
                           apply (rule AL_update5, rule AL_update5, rule AL_update1) 
                           apply (drule_tac N=M in mkMP_Rel_dist) apply fastsimp
                           apply (drule_tac N=M in mkMP_Rel_dist) apply fastsimp
                         apply clarsimp
                           apply (rule AL_update5, rule AL_update5, erule AL_update5)
                             apply assumption
                             apply (drule AL_domI) 
                               apply (drule_tac N=M in mkMP_Rel_dist) apply (drule_tac N=N in mkMP_Rel_dom) apply fastsimp
                             apply (drule AL_domI) 
                               apply (drule_tac N=M in mkMP_Rel_dist) apply (drule_tac N=N in mkMP_Rel_dom) apply fastsimp
      apply (rule_tac H=emp and N="N[\<alpha>\<mapsto>intTP]" and NN="emp[\<mu>\<mapsto>(classTP C)][\<beta>\<mapsto>intTP]" in UniBSFrame)
        apply (rule_tac \<gamma>=\<mu> and F=emp in M1_unisound) apply assumption apply fastsimp 
          apply (simp (no_asm) add: star_def AL_sum_def contained_def)
            apply (rule, simp add: AL_dom_upd1 AL_dom_emp)
            apply (rule, clarsimp)
              apply (rule AL_update5, assumption) apply (drule AL_domI) apply (drule_tac N=M in mkMP_Rel_dist)
                                                    apply (simp add: AL_dom_upd1 AL_dom_emp) apply fastsimp
            apply (rule, clarsimp) 
              apply (drule AL_upd_split)
              apply (erule disjE, clarsimp) apply (rule AL_update1)
              apply (simp add: AL_emp1)
            apply (rule, simp add: AL_dom_upd1 AL_dom_emp) apply (drule_tac N=M in mkMP_Rel_dist) apply fastsimp
            apply (rule AL_UPD, rule AL_UPD, rule AL_EMP)
          apply simp 
          apply (simp add: SD_sum_def) apply (rule, rule AL_sum_emp2) apply (simp add: AL_dom_emp) 
          apply (simp add: SD_sum_def) apply (rule, rule AL_sum_emp2) apply (simp add: AL_dom_emp)
        apply assumption
        apply assumption
        apply (drule_tac N=N in mkMP_Rel_dom) apply (frule_tac N=M in mkMP_Rel_dom) 
           apply (drule_tac N=M in mkMP_Rel_dist) apply (simp add: AL_dom_upd1 AL_dom_emp) apply fast 
        apply (rule AL_UPD, rule AL_UPD, rule AL_UPD) apply (simp add: mkMP_Rel_def) apply clarsimp
      (* apply fast *)
    apply clarsimp
    (*we've reached the return instruction, so now do the right component*)
    apply (rule TypingInj)
    apply (rule UniInjectR)
    apply (rule UniDup)
      apply (rule getIns_M2_18) apply simp
      prefer 6 apply fastsimp
      apply fastsimp
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
    apply clarsimp
    apply (rule TypingInj)
    apply (rule UniInjectR)
    apply (rule UniLoad)
      apply (rule getIns_M2_19) apply simp
      prefer 7 apply fastsimp
      apply fastsimp
      apply (rule AL_update1)
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
    apply clarsimp
    apply (rule TypingInj)
    apply (rule UniInjectR)
    apply (rule UniPut)
      apply (rule getIns_M2_20) apply simp
      prefer 7 apply fastsimp
      apply fastsimp
      apply (rule AL_update1)
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
    apply clarsimp
    apply (rule TypingInj)
    apply (rule UniInjectR)
    apply (rule UniGet)
      apply (rule getIns_M2_21) apply simp
      prefer 8 apply fastsimp
      apply fastsimp
      apply (rule AL_update1)
      apply (rule AL_update1)
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
    (*now we've arrived at return instructions in both compoents*)
    apply clarsimp
    apply (rule TypingInj)
    apply (rule_tac H=emp and N=emp and K=emp in TypingFrame)
      apply (rule TypingRetRet)
        apply (rule getIns_M2_12) apply simp
        apply (rule getIns_M2_22) apply simp
        apply simp
        apply simp
      apply (simp add: RSD_sum_def) apply (rule, simp) apply (rule, simp) apply (rule, simp) apply (rule, simp)
         apply (rule, simp) apply (rule, simp) apply (rule, rule AL_UPD, rule AL_EMP) 
         apply (rule, rule AL_UPD, rule AL_UPD, rule AL_EMP) 
         apply (rule, rule AL_UPD, rule AL_UPD, rule AL_UPD) apply (simp add: mkMP_Rel_def, clarsimp)
         apply (rule, rule AL_sum_emp2) 
         apply (rule, rule AL_sum_emp2) 
         apply (rule, rule AL_sum_emp2) 
         apply (simp add: AL_dom_emp)
      apply (simp add: RSD_sum_def)
         apply (rule, rule AL_UPD, rule AL_EMP) 
         apply (rule, simp add: mkMP_Rel_def, clarsimp)
         apply (rule, rule AL_sum_emp2) 
         apply (rule, simp add: upd_upd) apply (rule AL_sum_emp2) 
         apply (simp add: AL_dom_emp)
         apply (simp (no_asm) add: AL_sum_def contained_def)
           apply (rule, drule mkMP_Rel_dom, drule mkMP_Rel_dom, simp add: AL_dom_emp AL_dom_upd1) apply fast
           apply (simp add: AL_emp1, clarsimp)
           apply (drule AL_upd_split)
           apply (erule disjE, clarsimp)
             apply (erule mkMP_Rel_Clookup) apply simp apply clarsimp
           apply (drule AL_upd_split)
           apply (erule disjE, clarsimp)
             apply (erule mkMP_Rel_Ilookup) apply simp apply clarsimp
           apply (drule AL_upd_split)
           apply (erule disjE, clarsimp)
             apply (erule mkMP_Rel_Ilookup) apply simp apply clarsimp
           apply (erule mkMP_Rel_extend, assumption+) apply simp apply simp
(*13,3*)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectL)
  prefer 2 apply (rule UniCtxtVerified_emp)
  prefer 2 apply fastsimp
  apply (rule UniLoad)
    apply (rule getIns_M2_13) apply simp
    apply fastsimp
    apply (rule AL_update1)
    apply simp
    apply simp
    apply simp
    (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectR)
  prefer 2 apply (rule UniCtxtVerified_emp)
  prefer 2 apply fastsimp
  apply (rule UniIf)
    apply (rule getIns_M2_3) apply simp
    apply fastsimp
    apply simp
    apply simp
    apply simp
    (* apply fast *)
  apply clarsimp
  apply rule
    (*14,4*) (*other case is: (14,13)*)
    (*The proof of this is similar to the one of (4,14) above - just swap the two components*)
    apply clarsimp
    apply (rule TypingInj)
    apply (rule_tac c=\<alpha> in TypingConstConst)
      apply (rule getIns_M2_14) apply simp
      apply (rule getIns_M2_4) apply simp
      apply fastsimp
      apply clarsimp apply (frule_tac N=N in mkMP_Rel_dom) apply (frule_tac N=M in mkMP_Rel_dom) 
             apply (drule_tac N=M in mkMP_Rel_dist) apply fastsimp 
    apply clarsimp
    apply (rule TypingInj)
    apply (rule UniInjectR)
    apply (rule UniStore)
      apply (rule getIns_M2_5) apply simp
      prefer 6 apply fastsimp
      apply fastsimp
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
    apply clarsimp
    apply (rule TypingInj)
    apply (rule UniInjectR)
    apply (rule UniLoad)
      apply (rule getIns_M2_6) apply simp
      prefer 7 apply fastsimp
      apply fastsimp
      apply (simp add: mkStore_def) apply (rule AL_update5, rule AL_update5, rule AL_update5) 
        apply (rule AL_update1) apply assumption+
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
    apply clarsimp
    apply (rule TypingInj)
    apply (rule UniInjectR)
    apply (rule UniLoad)
      apply (rule getIns_M2_7) apply simp
      prefer 7 apply fastsimp
      apply fastsimp
      apply (rule AL_update1) 
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
    (*now that we have reached the binop instruction in the rightt component, 
      (and are already at the binop in the left component*)
    apply clarsimp
    apply (rule TypingInj)
    apply (rule_tac c=\<beta> in TypingBinopBinop)
      apply (rule getIns_M2_15) apply simp
      apply (rule getIns_M2_8) apply simp
      apply fastsimp
      apply clarsimp apply (frule_tac N=N in mkMP_Rel_dom) apply (frule_tac N=M in mkMP_Rel_dom) 
             apply (drule_tac N=M in mkMP_Rel_dist) apply (simp add: AL_dom_upd1) apply fastsimp 
      apply (rule AL_update1)
      apply (rule AL_update5) apply (erule mkMP_Rel_Ilookup) apply simp
        apply (drule_tac N=M in mkMP_Rel_dist) apply simp apply fast
      apply assumption 
    apply clarsimp
    apply (rule TypingInj)
    apply (rule UniInjectL)
    apply (rule UniStore)
      apply (rule getIns_M2_16) apply simp
      prefer 6 apply fastsimp
      apply fastsimp
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
    apply clarsimp
    (*we again correlate the allocations*)
    apply (rule TypingInj)
    apply (rule_tac c=\<mu> and C=C in TypingNewNew) 
      apply (rule getIns_M2_17) apply simp
      apply (rule getIns_M2_9) apply simp
      apply fastsimp
      apply (drule mkMP_Rel_dom) apply (frule mkMP_Rel_dom) apply (drule mkMP_Rel_dist) apply(simp add: AL_dom_upd1)
      apply (simp add: subclass_of_refl)
      apply (simp add: subclass_of_refl)
    (*Again, we procede in the right component as far as possible, in this case until
        we hit the return instruction*)
    apply clarsimp
    apply (rule TypingInj)
    apply (rule UniInjectR)
    apply (rule UniSwap)
      apply (rule getIns_M2_10) apply simp
      prefer 6 apply fastsimp
      apply fastsimp
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
    apply clarsimp
    apply (subgoal_tac "mbody_is C M1 ([y], Code1, 0)")
    prefer 2 apply (simp add: mbody_is_def Prog1_def)
        apply (subgoal_tac "emp[C\<mapsto>Class]\<down>C = Some Class", simp)
          apply (simp add: Class_def Body1_def)
          apply (rule AL_update5, rule AL_update5, rule AL_update1) apply assumption apply assumption
        apply (rule AL_update1)
    apply (rule TypingInj)
    apply (rule UniInjectR)
    apply (rule_tac HH="emp[\<mu>\<mapsto>(C, emp[A\<mapsto>\<beta>])]" and c=\<beta> in UniInvV3)
      apply (rule getIns_M2_11) apply simp
      apply assumption
      prefer 9 apply fastsimp
      apply fastsimp
      apply (rule absFrameCons) 
        apply (rule absFrameNil) apply fastsimp 
        apply simp
      apply (rule AL_update1)
      apply simp
      apply simp
      prefer 3 apply (rule UniCtxtVerified_emp)
      prefer 2 apply clarsimp apply (erule_tac x=E in allE, clarsimp)
        apply (rule, rule, rule, assumption)
      apply (subgoal_tac "({}, ([], emp[y\<mapsto>\<beta>][this\<mapsto>\<mu>], emp[\<mu>\<mapsto>(C, emp)]), N[\<alpha>\<mapsto>intTP][\<beta>\<mapsto>intTP][\<mu>\<mapsto>(classTP C)],
        Body1, 0, True, emp[\<mu>\<mapsto>(C, emp[A\<mapsto>\<beta>])], \<beta>, N[\<alpha>\<mapsto>intTP][\<beta>\<mapsto>intTP][\<mu>\<mapsto>(classTP C)])
       \<in> UniBS ")
      apply (subgoal_tac "Body1 = ([y], Code1, 0)", simp) apply (simp add: Body1_def)
      apply (rule UniInj)
      apply (subgoal_tac "AL_sum emp[\<mu>\<mapsto>(classTP C)][\<beta>\<mapsto>intTP] N[\<alpha>\<mapsto>intTP] N[\<alpha>\<mapsto>intTP][\<beta>\<mapsto>intTP][\<mu>\<mapsto>(classTP C)]")
      prefer 2 apply (simp add: AL_sum_def)
               apply (rule, simp add: AL_dom_emp AL_dom_upd1) apply fast
               apply (simp add: contained_def, rule)
                 apply clarsimp apply (drule AL_upd_split)
                         apply (erule disjE, clarsimp)
                           apply (rule AL_update5, rule AL_update1)
                           apply (drule_tac N=M in mkMP_Rel_dist) apply fastsimp
                         apply clarsimp
                           apply (drule AL_upd_split)
                           apply (erule disjE, clarsimp) apply (rule AL_update1)
                           apply (simp add: AL_emp1)
                 apply clarsimp 
                           apply (rule AL_update5, rule AL_update5, assumption) 
                             apply (drule AL_domI) 
                               apply (drule_tac N=M in mkMP_Rel_dist) apply (drule_tac N=N in mkMP_Rel_dom) 
                               apply (simp add: AL_dom_upd1) apply fastsimp
                             apply (drule AL_domI) 
                               apply (drule_tac N=M in mkMP_Rel_dist) apply (drule_tac N=N in mkMP_Rel_dom)
                               apply (simp add: AL_dom_upd1) apply fastsimp
      apply (rule_tac H=emp and N="N[\<alpha>\<mapsto>intTP]" and NN="emp[\<mu>\<mapsto>(classTP C)][\<beta>\<mapsto>intTP]" in UniBSFrame)
        apply (rule_tac \<gamma>=\<mu> and F=emp in M1_unisound) apply assumption apply fastsimp 
          apply (simp (no_asm) add: star_def AL_sum_def contained_def)
            apply (rule, simp add: AL_dom_upd1 AL_dom_emp)
            apply (rule, clarsimp)
              apply (rule AL_update5, assumption) apply (drule AL_domI) apply (drule_tac N=M in mkMP_Rel_dist)
                                                    apply (simp add: AL_dom_upd1 AL_dom_emp) apply fastsimp
            apply (rule, clarsimp) 
              apply (drule AL_upd_split)
              apply (erule disjE, clarsimp) apply (rule AL_update1)
              apply (simp add: AL_emp1)
            apply (rule, simp add: AL_dom_upd1 AL_dom_emp) apply (drule_tac N=M in mkMP_Rel_dist) apply fastsimp
            apply (rule AL_UPD, rule AL_UPD, rule AL_EMP)
          apply simp
          apply (simp add: SD_sum_def) apply (rule, rule AL_sum_emp2) apply (simp add: AL_dom_emp) 
          apply (simp add: SD_sum_def) apply (rule, rule AL_sum_emp2) apply (simp add: AL_dom_emp)
        apply assumption
        apply assumption
        apply (drule_tac N=N in mkMP_Rel_dom) apply (frule_tac N=M in mkMP_Rel_dom) 
           apply (drule_tac N=M in mkMP_Rel_dist) apply (simp add: AL_dom_upd1 AL_dom_emp) apply fast 
        apply (rule AL_UPD, rule AL_UPD, rule AL_UPD) apply (simp add: mkMP_Rel_def) apply clarsimp
      (* apply fast *)
    apply clarsimp
    (*we've reached the return instruction, so now do the left component*)
    apply (rule TypingInj)
    apply (rule UniInjectL)
    apply (rule UniDup)
      apply (rule getIns_M2_18) apply simp
      prefer 6 apply fastsimp
      apply fastsimp
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
    apply clarsimp
    apply (rule TypingInj)
    apply (rule UniInjectL)
    apply (rule UniLoad)
      apply (rule getIns_M2_19) apply simp
      prefer 7 apply fastsimp
      apply fastsimp
      apply (rule AL_update1)
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
    apply clarsimp
    apply (rule TypingInj)
    apply (rule UniInjectL)
    apply (rule UniPut)
      apply (rule getIns_M2_20) apply simp
      prefer 7 apply fastsimp
      apply fastsimp
      apply (rule AL_update1)
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
    apply clarsimp
    apply (rule TypingInj)
    apply (rule UniInjectL)
    apply (rule UniGet)
      apply (rule getIns_M2_21) apply simp
      prefer 8 apply fastsimp
      apply fastsimp
      apply (rule AL_update1)
      apply (rule AL_update1)
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
    (*now we've arrived at return instructions in both compoents*)
    apply clarsimp
    apply (rule TypingInj)
    apply (rule_tac H=emp and N=emp and K=emp in TypingFrame)
      apply (rule_tac c=\<beta> and S="[]" and \<Gamma>="(mkStore \<gamma> \<delta>)[x\<mapsto>\<gamma>][x\<mapsto>\<beta>]" and
       d=\<beta> and T="[]" and \<Delta>="(mkStore \<gamma> \<epsilon>)[x\<mapsto>\<gamma>][x\<mapsto>\<alpha>]" in TypingRetRet)
        apply (rule getIns_M2_22) apply simp
        apply (rule getIns_M2_12) apply simp
        apply simp
        apply simp
      apply (simp add: RSD_sum_def)
        apply (rule, rule AL_UPD, rule AL_UPD, rule AL_EMP)
        apply (rule, rule AL_UPD, rule AL_EMP)
        apply (rule, rule AL_UPD, rule AL_UPD, rule AL_UPD, simp add: mkMP_Rel_def, clarsimp)
        apply (rule, rule AL_sum_emp2)
        apply (rule, rule AL_sum_emp2)
        apply (rule, rule AL_sum_emp2)
        apply (simp add: AL_dom_upd AL_dom_emp)
      apply (simp add: RSD_sum_def)
        apply (rule, rule AL_UPD, rule AL_EMP)
        apply (rule, simp add: mkMP_Rel_def, clarsimp)
        apply (rule, simp add: upd_upd) apply (rule AL_sum_emp2)          
        apply (rule, rule AL_sum_emp2)
        apply (rule, simp add: AL_sum_def)
         apply (simp add: AL_dom_emp)
         apply (simp (no_asm) add: AL_sum_def contained_def)
           apply (rule, drule mkMP_Rel_dom, drule mkMP_Rel_dom, simp add: AL_dom_emp AL_dom_upd1) apply fast
           apply (simp add: AL_emp1, clarsimp)
           apply (drule AL_upd_split)
           apply (erule disjE, clarsimp)
             apply (erule mkMP_Rel_Clookup) apply simp apply clarsimp
           apply (drule AL_upd_split)
           apply (erule disjE, clarsimp)
             apply (erule mkMP_Rel_Ilookup) apply simp apply clarsimp
           apply (drule AL_upd_split)
           apply (erule disjE, clarsimp)
             apply (erule mkMP_Rel_Ilookup) apply simp apply clarsimp
           apply (erule mkMP_Rel_extend, assumption+) apply simp apply simp
          apply (simp add: AL_dom_emp) 
  (*Branch (14,13)*)
    apply clarsimp
    apply (rule TypingInj)
    apply (rule UniInjectR)
    apply (rule UniLoad)
      apply (rule getIns_M2_13) apply simp
      prefer 7 apply fastsimp
      apply fastsimp
      apply (rule AL_update1) 
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
    apply clarsimp
    apply (rule TypingInj)
    apply (rule_tac c=\<alpha> in TypingConstConst)
      apply (rule getIns_M2_14) apply simp
      apply (rule getIns_M2_14) apply simp
      apply fastsimp
      apply clarsimp apply (frule_tac N=N in mkMP_Rel_dom) apply (frule_tac N=M in mkMP_Rel_dom) 
             apply (drule_tac N=M in mkMP_Rel_dist) apply fastsimp 
    apply clarsimp
    apply (rule TypingInj)
    apply (rule_tac c=\<beta> in TypingBinopBinop)
      apply (rule getIns_M2_15) apply simp
      apply (rule getIns_M2_15) apply simp
      apply fastsimp
      apply clarsimp apply (frule_tac N=N in mkMP_Rel_dom) apply (frule_tac N=M in mkMP_Rel_dom) 
             apply (drule_tac N=M in mkMP_Rel_dist) apply (simp add: AL_dom_upd1) apply fastsimp 
      apply (rule AL_update1)
      apply (rule AL_update5) apply (erule mkMP_Rel_Ilookup) apply simp
        apply (drule_tac N=M in mkMP_Rel_dist) apply simp apply fast
      apply assumption
    (*procede to the allocation in left component*)
    apply clarsimp
    apply (rule TypingInj)
    apply (rule UniInjectL)
    apply (rule UniStore)
      apply (rule getIns_M2_16) apply simp
      prefer 6 apply fastsimp
      apply fastsimp
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
    apply clarsimp
    (*procede to the allocation in right component*)
    apply (rule TypingInj)
    apply (rule UniInjectR)
    apply (rule UniStore)
      apply (rule getIns_M2_16) apply simp
      prefer 6 apply fastsimp
      apply fastsimp
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
    apply clarsimp
    apply (rule TypingInj)
    apply (rule_tac c=\<mu> and C=C in TypingNewNew)
      apply (rule getIns_M2_17) apply simp
      apply (rule getIns_M2_17) apply simp
      apply fastsimp
      apply (drule mkMP_Rel_dom) apply (frule mkMP_Rel_dom) apply (drule mkMP_Rel_dist) apply(simp add: AL_dom_upd1)
      apply (simp add: subclass_of_refl)
      apply (simp add: subclass_of_refl)
    (*proced independently*)
    apply clarsimp
    apply (rule TypingInj)
    apply (rule UniInjectL)
    apply (rule UniDup)
      apply (rule getIns_M2_18) apply simp
      prefer 6 apply fastsimp
      apply fastsimp
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
    apply clarsimp
    apply (rule TypingInj)
    apply (rule UniInjectL)
    apply (rule UniLoad)
      apply (rule getIns_M2_19) apply simp
      prefer 7 apply fastsimp
      apply fastsimp
      apply (rule AL_update1)
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
    apply clarsimp
    apply (rule TypingInj)
    apply (rule UniInjectL)
    apply (rule UniPut)
      apply (rule getIns_M2_20) apply simp
      prefer 7 apply fastsimp
      apply fastsimp
      apply (rule AL_update1)
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
    apply clarsimp
    apply (rule TypingInj)
    apply (rule UniInjectL)
    apply (rule UniGet)
      apply (rule getIns_M2_21) apply simp
      prefer 8 apply fastsimp
      apply fastsimp
      apply (rule AL_update1)
      apply (rule AL_update1)
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  (*procede to the end in right component*)
    apply clarsimp
    apply (rule TypingInj)
    apply (rule UniInjectR)
    apply (rule UniDup)
      apply (rule getIns_M2_18) apply simp
      prefer 6 apply fastsimp
      apply fastsimp
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
    apply clarsimp
    apply (rule TypingInj)
    apply (rule UniInjectR)
    apply (rule UniLoad)
      apply (rule getIns_M2_19) apply simp
      prefer 7 apply fastsimp
      apply fastsimp
      apply (rule AL_update1)
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
    apply clarsimp
    apply (rule TypingInj)
    apply (rule UniInjectR)
    apply (rule UniPut)
      apply (rule getIns_M2_20) apply simp
      prefer 7 apply fastsimp
      apply fastsimp
      apply (rule AL_update1)
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
    apply clarsimp
    apply (rule TypingInj)
    apply (rule UniInjectR)
    apply (rule UniGet)
      apply (rule getIns_M2_21) apply simp
      prefer 8 apply fastsimp
      apply fastsimp
      apply (rule AL_update1)
      apply (rule AL_update1)
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
    (*now we've arrived at return instructions in both compoents*)
    apply clarsimp
    apply (rule TypingInj)
    apply (rule_tac H=emp and N=emp and K=emp in TypingFrame)
      apply (rule TypingRetRet)
        apply (rule getIns_M2_22) apply simp
        apply (rule getIns_M2_22) apply simp
      apply fastsimp
      apply simp
      apply (simp add: RSD_sum_def upd_upd) apply (rule, simp) apply (rule, simp) apply (rule, simp) apply (rule, simp)
         apply (rule, simp) apply (rule, simp) apply (rule, rule AL_UPD, rule AL_EMP) 
         apply (rule, rule AL_UPD, rule AL_UPD, rule AL_UPD) apply (simp add: mkMP_Rel_def, clarsimp)
         apply (rule, rule AL_sum_emp2) 
         apply (rule, rule AL_sum_emp2) 
         apply (rule, rule AL_sum_emp2) 
         apply (simp add: AL_dom_emp)
      apply (simp add: RSD_sum_def)
         apply (rule, rule AL_UPD, rule AL_EMP) 
         apply (rule, simp add: mkMP_Rel_def, clarsimp)
         apply (rule, rule AL_sum_emp2) 
         apply (simp add: AL_dom_emp)
         apply (simp (no_asm) add: AL_sum_def contained_def)
           apply (rule, drule mkMP_Rel_dom, drule mkMP_Rel_dom, simp add: AL_dom_emp AL_dom_upd1) apply fast
           apply (simp add: AL_emp1, clarsimp)
           apply (drule AL_upd_split)
           apply (erule disjE, clarsimp)
             apply (erule mkMP_Rel_Clookup) apply simp apply clarsimp
           apply (drule AL_upd_split)
           apply (erule disjE, clarsimp)
             apply (erule mkMP_Rel_Ilookup) apply simp apply clarsimp
           apply (drule AL_upd_split)
           apply (erule disjE, clarsimp)
             apply (erule mkMP_Rel_Ilookup) apply simp apply clarsimp
           apply (erule mkMP_Rel_extend, assumption+) apply simp apply simp
done

text{*Finally, we prove the equivalence between {\tt m2} and {\tt
m4}. Again, there are two proofs, differing in the correlation of
allocations.*}

lemma M2_M4_uncorrelated:
  "\<lbrakk>P=Prog1; M2 \<noteq> M1; M4 \<noteq> M1; y \<noteq> this; h \<noteq> l; x \<noteq> h;x \<noteq> l;
    \<forall> D . subclass_of D C \<longrightarrow> D=C; 
    mkMP_Rel [\<gamma>,\<delta>] [] N;
    \<Phi>=(mkState \<gamma> \<delta>,N,([],emp[l\<mapsto>\<gamma>],emp));  isOfType plus intTP intTP intTP;
    mkMP_Rel [\<gamma>,\<delta>,\<alpha>,\<beta>] [\<mu>,\<nu>] M;
    \<Psi> = (([\<beta>], emp, emp[\<mu>\<mapsto>(C, emp[A\<mapsto>\<beta>])]), M, [\<beta>], emp, emp[\<nu>\<mapsto>(C, emp[A\<mapsto>\<beta>])])\<rbrakk> 
 \<Longrightarrow> (G, \<Phi>, Body2, 0, Body4, 0, False, \<Psi>) :Typing"
(*<*)
apply (rule UniInjectL)
apply (rule UniLoad)
  apply (rule getIns_M2_0)
  prefer 7 apply assumption 
  apply (simp add: mkState_def) apply fastsimp
  apply (simp add: mkStore_def) apply (rule AL_update5, rule AL_update1) apply assumption
  apply simp
  apply simp
  apply simp
  apply (rule UniCtxtVerified_emp)
  (* apply fast *)
apply clarsimp
apply (rule TypingInj)
apply (rule UniInjectL)
apply (rule UniStore)
  apply (rule getIns_M2_1) apply simp 
  prefer 6 apply fastsimp
  apply fastsimp
  apply simp 
  apply simp
  apply simp
  apply (rule UniCtxtVerified_emp)
  (* apply fast *)
apply clarsimp
apply (rule TypingInj)
apply (rule UniInjectL)
apply (rule UniLoad)
  apply (rule getIns_M2_2) apply simp
  prefer 7 apply fastsimp
  apply fastsimp
  apply (simp add: mkStore_def) apply (rule AL_update5, rule AL_update1) apply assumption
  apply simp
  apply simp
  apply simp
  apply (rule UniCtxtVerified_emp)
  (* apply fast *)
apply clarsimp
apply (rule TypingInj)
apply (rule UniInjectR)
apply (rule UniLoad)
  apply (rule getIns_M4_0)
  prefer 7 apply fastsimp
  apply fastsimp
  apply (rule AL_update1) 
  apply simp
  apply simp
  apply simp
  apply (rule UniCtxtVerified_emp)
  (* apply fast *)
apply clarsimp
apply (rule TypingInj)
apply (rule UniInjectL)
prefer 2 apply (rule UniCtxtVerified_emp)
prefer 2 apply fastsimp
apply (rule UniIf)
  apply (rule getIns_M2_3) apply simp
  apply fastsimp
  apply simp
  apply simp
  apply simp
  (* apply fast *)
apply clarsimp
apply rule
  (*4,1*) (*other case is: (13,1)*)
  apply clarsimp
  apply (rule TypingInj)
    apply (rule_tac c=\<alpha> in TypingConstConst)
      apply (rule getIns_M2_4) apply simp
      apply (rule getIns_M4_1) apply simp
      apply fastsimp
      apply (drule mkMP_Rel_dom) apply (frule mkMP_Rel_dom) apply (drule mkMP_Rel_dist)  apply(simp add: AL_dom_upd1) apply fast
    apply clarsimp
    apply (rule TypingInj)
    apply (rule UniInjectL)
    apply (rule UniStore)
      apply (rule getIns_M2_5) apply simp
      prefer 6 apply fastsimp
      apply fastsimp
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
    apply clarsimp
    apply (rule TypingInj)
    apply (rule UniInjectL)
    apply (rule UniLoad)
      apply (rule getIns_M2_6) apply simp
      prefer 7 apply fastsimp
      apply fastsimp
      apply (simp add: mkStore_def) apply (rule AL_update5, rule AL_update5, rule AL_update5) 
        apply (rule AL_update1) apply assumption+
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
    apply clarsimp
    apply (rule TypingInj)
    apply (rule UniInjectL)
    apply (rule UniLoad)
      apply (rule getIns_M2_7) apply simp
      prefer 7 apply fastsimp
      apply fastsimp
      apply (rule AL_update1) 
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
    apply clarsimp
    (*now that we have reached the binop instruction in the both components*)
    apply (rule TypingInj)
    apply (rule_tac c=\<beta> in TypingBinopBinop)
      apply (rule getIns_M2_8) apply simp
      apply (rule getIns_M4_2) apply simp
      apply fastsimp
      apply clarsimp apply (frule_tac N=N in mkMP_Rel_dom) apply (frule_tac N=M in mkMP_Rel_dom) 
             apply (drule_tac N=M in mkMP_Rel_dist) apply (simp add: AL_dom_upd1) apply fastsimp 
      apply (rule AL_update1)
      apply (rule AL_update5) apply (erule mkMP_Rel_Ilookup) apply simp
        apply (drule_tac N=M in mkMP_Rel_dist) apply simp apply fast
      apply assumption
    apply clarsimp
    (*we again first procede in the left component as far as possible, in this case until
        we hit the return instruction*)
    apply (rule TypingInj)
    apply (rule UniInjectL)
    apply (rule_tac cl=\<mu> and D=C in UniNew)
      apply (rule getIns_M2_9) apply simp
      prefer 8 apply fastsimp
      apply fastsimp
      apply (drule mkMP_Rel_dom) apply (frule mkMP_Rel_dom) apply (drule mkMP_Rel_dist)  apply(simp add: AL_dom_upd1) 
      apply simp
      apply (simp add: subclass_of_refl)
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
    apply clarsimp
    apply (rule TypingInj)
    apply (rule UniInjectL)
    apply (rule UniSwap)
      apply (rule getIns_M2_10) apply simp
      prefer 6 apply fastsimp
      apply fastsimp
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
    apply clarsimp
    apply (subgoal_tac "mbody_is C M1 ([y], Code1, 0)")
    prefer 2 apply (simp add: mbody_is_def Prog1_def)
        apply (subgoal_tac "emp[C\<mapsto>Class]\<down>C = Some Class", simp)
          apply (simp add: Class_def Body1_def)
          apply (rule AL_update5, rule AL_update5, rule AL_update1) apply assumption apply assumption
        apply (rule AL_update1)
    apply (rule TypingInj)
    apply (rule UniInjectL)
    apply (rule_tac HH="emp[\<mu>\<mapsto>(C, emp[A\<mapsto>\<beta>])]" and c=\<beta> in UniInvV3)
      apply (rule getIns_M2_11) apply simp
      apply assumption
      prefer 9 apply fastsimp
      apply fastsimp
      apply (rule absFrameCons) 
        apply (rule absFrameNil) apply fastsimp 
        apply simp
      apply (rule AL_update1)
      apply simp
      apply simp
      prefer 3 apply (rule UniCtxtVerified_emp)
      prefer 2 apply clarsimp apply (erule_tac x=E in allE, clarsimp)
        apply (rule, rule, rule, assumption)
      apply (subgoal_tac "({}, ([], emp[y\<mapsto>\<beta>][this\<mapsto>\<mu>], emp[\<mu>\<mapsto>(C, emp)]), 
                           upd(upd(upd N \<alpha> intTP) \<beta> intTP) \<mu> (classTP C),
        Body1, 0, True, emp[\<mu>\<mapsto>(C, emp[A\<mapsto>\<beta>])], \<beta>, 
          upd(upd(upd N \<alpha> intTP) \<beta> intTP) \<mu> (classTP C))
       \<in> UniBS ")
      apply (subgoal_tac "Body1 = ([y], Code1, 0)", simp) apply (simp add: Body1_def)
      apply (rule UniInj)
      apply (subgoal_tac " AL_sum emp[\<mu>\<mapsto>(classTP C)][\<beta>\<mapsto>intTP] emp[\<gamma>\<mapsto>intTP][\<delta>\<mapsto>intTP][\<alpha>\<mapsto>intTP] N[\<alpha>\<mapsto>intTP][\<beta>\<mapsto>intTP][\<mu>\<mapsto>(classTP C)]")
      prefer 2 apply (simp add: AL_sum_def)
               apply (rule, drule mkMP_Rel_dom, simp add: AL_dom_emp AL_dom_upd1) apply fast
               apply (simp add: contained_def, rule)
                 apply clarsimp apply (drule AL_upd_split)
                         apply (erule disjE, clarsimp)
                           apply (rule AL_update5, rule AL_update1)
                           apply (drule_tac N=M in mkMP_Rel_dist) apply simp
                         apply clarsimp
                           apply (drule AL_upd_split)
                           apply (erule disjE, clarsimp) apply (rule AL_update1)
                           apply (simp add: AL_emp1)
                 apply clarsimp apply (drule AL_upd_split)
                         apply (erule disjE, clarsimp) 
                           apply (rule AL_update5, rule AL_update5, rule AL_update1) 
                           apply (drule_tac N=M in mkMP_Rel_dist) apply fastsimp 
                           apply (drule_tac N=M in mkMP_Rel_dist) apply fastsimp
                         apply clarsimp
                           apply (rule AL_update5, rule AL_update5, rule AL_update5) 
                             apply (drule AL_upd_split)
                             apply (erule disjE, clarsimp) 
                               apply (erule mkMP_Rel_Ilookup) apply simp
                             apply clarsimp
                             apply (drule AL_upd_split)
                             apply (erule disjE, clarsimp) 
                               apply (erule mkMP_Rel_Ilookup) apply simp
                             apply (simp add: AL_emp1)
                           apply assumption
                           apply (drule AL_domI, drule mkMP_Rel_dist, drule mkMP_Rel_dist, simp add: AL_dom_upd1 AL_dom_emp) apply fastsimp
                           apply (drule AL_domI, drule mkMP_Rel_dist, drule mkMP_Rel_dist, simp add: AL_dom_upd1 AL_dom_emp) apply fastsimp
      apply (rule_tac H=emp and N="emp[\<gamma>\<mapsto>intTP][\<delta>\<mapsto>intTP][\<alpha>\<mapsto>intTP]" and NN="emp[\<mu>\<mapsto>(classTP C)][\<beta>\<mapsto>intTP]" in UniBSFrame)
        apply (rule_tac \<gamma>=\<mu> and F=emp in M1_unisound) apply assumption apply fastsimp 
          apply (simp (no_asm) add: star_def AL_sum_def contained_def)
            apply (rule, simp add: AL_dom_upd1 AL_dom_emp)
            apply (rule, clarsimp)
              apply (rule AL_update5, assumption) apply (drule AL_domI) apply (drule_tac N=M in mkMP_Rel_dist)
                                                    apply (simp add: AL_dom_upd1 AL_dom_emp) apply fastsimp
            apply (rule, clarsimp) 
              apply (drule AL_upd_split)
              apply (erule disjE, clarsimp) apply (rule AL_update1)
              apply (simp add: AL_emp1)
            apply (rule, simp add: AL_dom_upd1 AL_dom_emp) apply (drule_tac N=M in mkMP_Rel_dist) apply fastsimp
            apply (rule AL_UPD, rule AL_UPD, rule AL_EMP)
          apply simp 
          apply (simp add: SD_sum_def) apply (rule, rule AL_sum_emp2) apply (simp add: AL_dom_emp) 
          apply (simp add: SD_sum_def) apply (rule, rule AL_sum_emp2) apply (simp add: AL_dom_emp)
        apply assumption
        apply assumption
        apply (drule_tac N=M in mkMP_Rel_dist) apply (simp add: AL_dom_upd1 AL_dom_emp) apply fast
        apply (rule AL_UPD, rule AL_UPD, rule AL_UPD) apply (simp add: mkMP_Rel_def, clarsimp)
      (* apply fast *)
    apply clarsimp
    (*we've reached the return instruction, so now do the right component*)
    apply (rule TypingInj)
    apply (rule UniInjectR)
    apply (rule UniStore)
      apply (rule getIns_M4_3) apply simp
      prefer 6 apply fastsimp
      apply fastsimp
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
    apply clarsimp
    apply (rule TypingInj)
    apply (rule UniInjectR)
    apply (rule_tac cl=\<nu> and D=C in UniNew)
      apply (rule getIns_M4_4) apply simp
      prefer 8 apply fastsimp
      apply fastsimp
      apply (drule mkMP_Rel_dom) apply (frule mkMP_Rel_dom) apply (drule mkMP_Rel_dist) apply(simp add: AL_dom_upd1) apply fast
      apply simp
      apply (simp add: subclass_of_refl)
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
    apply clarsimp
    apply (rule TypingInj)
    apply (rule UniInjectR)
    apply (rule UniLoad)
      apply (rule getIns_M4_5) apply simp
      prefer 7 apply fastsimp
      apply fastsimp
      apply (rule AL_update1)
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
    apply clarsimp
    apply (rule TypingInj)
    apply (rule UniInjectR)
    apply (rule UniPut)
      apply (rule getIns_M4_6) apply simp
      prefer 7 apply fastsimp
      apply fastsimp
      apply (rule AL_update1)
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp) 
      (* apply fast *)
    apply clarsimp
    apply (rule TypingInj)
    apply (rule UniInjectR)
    apply (rule UniLoad)
      apply (rule getIns_M4_7) apply simp
      prefer 7 apply fastsimp
      apply fastsimp
      apply (rule AL_update1)
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp) 
      (* apply fast *)
    apply clarsimp
    (*now we've arrive at return instructions in both compoents*)
    apply (rule TypingInj)
    apply (rule_tac H=emp and N=emp and K=emp in TypingFrame)
      apply (rule_tac 
         c=\<beta> and S="[]" and \<Gamma>="(mkStore \<gamma> \<delta>)[x\<mapsto>\<alpha>]" and
         d=\<beta> and T="[]" and \<Delta>="emp[l\<mapsto>\<gamma>][x\<mapsto>\<beta>]" in TypingRetRet)
        apply (rule getIns_M2_12) apply simp
        apply (rule getIns_M4_8) apply simp
        apply simp
        apply simp
      apply (simp add: RSD_sum_def mkStore_def upd_upd) apply (rule, rule AL_UPD, rule AL_EMP) 
         apply (rule, rule AL_UPD, rule AL_EMP) 
         apply (rule, rule AL_UPD, rule AL_UPD, rule AL_UPD, rule AL_UPD) apply (simp add: mkMP_Rel_def, clarsimp)
         apply (rule, rule AL_sum_emp2) 
         apply (rule, rule AL_sum_emp2) 
         apply (rule, rule AL_sum_emp2) 
         apply (simp add: AL_dom_emp)
      apply (simp add: RSD_sum_def)
         apply (rule, rule AL_UPD, rule AL_EMP) 
         apply (rule, rule AL_UPD, rule AL_EMP) 
         apply (rule, simp add: mkMP_Rel_def, clarsimp)
         apply (rule, rule AL_sum_emp2) 
         apply (rule, rule AL_sum_emp2) 
         apply (simp add: AL_dom_emp)
         apply (simp (no_asm) add: AL_sum_def contained_def)
           apply (rule, drule mkMP_Rel_dom, drule mkMP_Rel_dom, simp add: AL_dom_emp AL_dom_upd1) apply fast
           apply (simp add: AL_emp1, clarsimp)
           apply (drule AL_upd_split)
           apply (erule disjE, clarsimp)
             apply (erule mkMP_Rel_Clookup) apply simp apply clarsimp
           apply (drule AL_upd_split)
           apply (erule disjE, clarsimp)
             apply (erule mkMP_Rel_Clookup) apply simp apply clarsimp
           apply (drule AL_upd_split)
           apply (erule disjE, clarsimp)
             apply (erule mkMP_Rel_Ilookup) apply simp apply clarsimp
           apply (drule AL_upd_split)
           apply (erule disjE, clarsimp)
             apply (erule mkMP_Rel_Ilookup) apply simp apply clarsimp
           apply (erule mkMP_Rel_extend, assumption+) apply simp apply simp
  (*Branch (13,1)*)
    apply clarsimp
    apply (rule TypingInj)
    apply (rule UniInjectL)
    apply (rule UniLoad)
      apply (rule getIns_M2_13) apply simp
      prefer 7 apply fastsimp
      apply fastsimp
      apply (rule AL_update1) 
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
    apply clarsimp
    apply (rule TypingInj)
    apply (rule_tac c=\<alpha> in TypingConstConst)
      apply (rule getIns_M2_14) apply simp
      apply (rule getIns_M4_1) apply simp
      apply fastsimp
      apply (drule mkMP_Rel_dom) apply (frule mkMP_Rel_dom) apply (drule mkMP_Rel_dist)  apply(simp add: AL_dom_upd1) apply fast
    apply clarsimp
    apply (rule TypingInj)
    apply (rule_tac c=\<beta> in TypingBinopBinop)
      apply (rule getIns_M2_15) apply simp
      apply (rule getIns_M4_2) apply simp
      apply fastsimp
      apply clarsimp apply (frule_tac N=N in mkMP_Rel_dom) apply (frule_tac N=M in mkMP_Rel_dom) 
             apply (drule_tac N=M in mkMP_Rel_dist) apply (simp add: AL_dom_upd1) apply fastsimp 
      apply (rule AL_update1)
      apply (rule AL_update5) apply (erule mkMP_Rel_Ilookup) apply simp
        apply (drule_tac N=M in mkMP_Rel_dist) apply simp apply fast
      apply assumption
    apply clarsimp
    (*we again first procede in the left component as far as possible, in this case until
        we hit the return instruction*)
    apply (rule TypingInj)
    apply (rule UniInjectL)
    apply (rule UniStore)
      apply (rule getIns_M2_16) apply simp
      prefer 6 apply fastsimp
      apply fastsimp
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
    apply clarsimp
    apply (rule TypingInj)
    apply (rule UniInjectL)
    apply (rule_tac cl=\<mu> and D=C in UniNew)
      apply (rule getIns_M2_17) apply simp
      prefer 8 apply fastsimp
      apply fastsimp
      apply (drule mkMP_Rel_dom) apply (frule mkMP_Rel_dom) apply (drule mkMP_Rel_dist) apply(simp add: AL_dom_upd1) 
      apply simp
      apply (simp add: subclass_of_refl)
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
    apply clarsimp
    apply (rule TypingInj)
    apply (rule UniInjectL)
    apply (rule UniDup)
      apply (rule getIns_M2_18) apply simp
      prefer 6 apply fastsimp
      apply fastsimp
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
    apply clarsimp
    apply (rule TypingInj)
    apply (rule UniInjectL)
    apply (rule UniLoad)
      apply (rule getIns_M2_19) apply simp
      prefer 7 apply fastsimp
      apply fastsimp
      apply (rule AL_update1)
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
    apply clarsimp
    apply (rule TypingInj)
    apply (rule UniInjectL)
    apply (rule UniPut)
      apply (rule getIns_M2_20) apply simp
      prefer 7 apply fastsimp
      apply fastsimp
      apply (rule AL_update1)
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
    apply clarsimp
    apply (rule TypingInj)
    apply (rule UniInjectL)
    apply (rule UniGet)
      apply (rule getIns_M2_21) apply simp
      prefer 8 apply fastsimp
      apply fastsimp
      apply (rule AL_update1)
      apply (rule AL_update1)
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
    (*we've reached the return instruction, so now do the right component*)
    apply clarsimp
    apply (rule TypingInj)
    apply (rule UniInjectR)
    apply (rule UniStore)
      apply (rule getIns_M4_3) apply simp
      prefer 6 apply fastsimp
      apply fastsimp
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
    apply clarsimp
    apply (rule TypingInj)
    apply (rule UniInjectR)
    apply (rule_tac cl=\<nu> and D=C in UniNew)
      apply (rule getIns_M4_4) apply simp
      prefer 8 apply fastsimp
      apply fastsimp
      apply (drule mkMP_Rel_dom) apply (frule mkMP_Rel_dom) apply (drule mkMP_Rel_dist)  apply(simp add: AL_dom_upd1) apply fast
      apply simp
      apply (simp add: subclass_of_refl)
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
    apply clarsimp
    apply (rule TypingInj)
    apply (rule UniInjectR)
    apply (rule UniLoad)
      apply (rule getIns_M4_5) apply simp
      prefer 7 apply fastsimp
      apply fastsimp
      apply (rule AL_update1)
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
    apply clarsimp
    apply (rule TypingInj)
    apply (rule UniInjectR)
    apply (rule UniPut)
      apply (rule getIns_M4_6) apply simp
      prefer 7 apply fastsimp
      apply fastsimp
      apply (rule AL_update1)
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp) 
      (* apply fast *)
    apply clarsimp
    apply (rule TypingInj)
    apply (rule UniInjectR)
    apply (rule UniLoad)
      apply (rule getIns_M4_7) apply simp
      prefer 7 apply fastsimp
      apply fastsimp
      apply (rule AL_update1)
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp) 
      (* apply fast *)
    apply clarsimp
    (*now we've arrive at return instructions in both compoents*)
    apply (rule TypingInj)
    apply (rule_tac H=emp and N=emp and K=emp in TypingFrame)
      apply (rule_tac 
         c=\<beta> and S="[]" and \<Gamma>="(mkStore \<gamma> \<delta>)[x\<mapsto>\<beta>]" and
         d=\<beta> and T="[]" and \<Delta>="emp[l\<mapsto>\<gamma>][x\<mapsto>\<beta>]" in TypingRetRet)
        apply (rule getIns_M2_22) apply simp
        apply (rule getIns_M4_8) apply simp
        apply simp
        apply simp
      apply (simp add: RSD_sum_def mkStore_def upd_upd) apply (rule, rule AL_UPD, rule AL_EMP) 
         apply (rule, rule AL_UPD, rule AL_EMP) 
         apply (rule, rule AL_UPD, rule AL_UPD, rule AL_UPD, rule AL_UPD) apply (simp add: mkMP_Rel_def, clarsimp)
         apply (rule, rule AL_sum_emp2) 
         apply (rule, rule AL_sum_emp2) 
         apply (rule, rule AL_sum_emp2) 
         apply (simp add: AL_dom_emp)
      apply (simp add: RSD_sum_def)
         apply (rule, rule AL_UPD, rule AL_EMP) 
         apply (rule, rule AL_UPD, rule AL_EMP) 
         apply (rule, simp add: mkMP_Rel_def, clarsimp)
         apply (rule, rule AL_sum_emp2) 
         apply (rule, rule AL_sum_emp2) 
         apply (simp add: AL_dom_emp)
         apply (simp (no_asm) add: AL_sum_def contained_def)
           apply (rule, drule mkMP_Rel_dom, drule mkMP_Rel_dom, simp add: AL_dom_emp AL_dom_upd1) apply fast
           apply (simp add: AL_emp1, clarsimp)
           apply (drule AL_upd_split)
           apply (erule disjE, clarsimp)
             apply (erule mkMP_Rel_Clookup) apply simp apply clarsimp
           apply (drule AL_upd_split)
           apply (erule disjE, clarsimp)
             apply (erule mkMP_Rel_Clookup) apply simp apply clarsimp
           apply (drule AL_upd_split)
           apply (erule disjE, clarsimp)
             apply (erule mkMP_Rel_Ilookup) apply simp apply clarsimp
           apply (drule AL_upd_split)
           apply (erule disjE, clarsimp)
             apply (erule mkMP_Rel_Ilookup) apply simp apply clarsimp
           apply (erule mkMP_Rel_extend, assumption+) apply simp apply simp
done
(*>*)

lemma M2_M4_correlated:
  "\<lbrakk>P=Prog1; M2 \<noteq> M1; M4 \<noteq> M1; y \<noteq> this; h \<noteq> l; x \<noteq> h;x \<noteq> l;
    \<forall> D . subclass_of D C \<longrightarrow> D=C; mkMP_Rel [\<gamma>,\<delta>] [] N;
    \<Phi>=(mkState \<gamma> \<delta>,N,([],emp[l\<mapsto>\<gamma>],emp)); isOfType plus intTP intTP intTP;
     mkMP_Rel [\<gamma>,\<delta>,\<alpha>,\<beta>] [\<mu>] M;
    \<Psi> = (([\<beta>], emp, emp[\<mu>\<mapsto>(C, emp[A\<mapsto>\<beta>])]), M, [\<beta>], emp, emp[\<mu>\<mapsto>(C, emp[A\<mapsto>\<beta>])])\<rbrakk> 
 \<Longrightarrow> (G, \<Phi>, Body2, 0, Body4, 0, False, \<Psi>) :Typing"
(*<*)
apply (rule UniInjectL)
apply (rule UniLoad)
  apply (rule getIns_M2_0)
  prefer 7 apply assumption 
  apply (simp add: mkState_def) apply fastsimp
  apply (simp add: mkStore_def) apply (rule AL_update5, rule AL_update1) apply assumption
  apply simp
  apply simp
  apply simp
  apply (rule UniCtxtVerified_emp)
  (* apply fast *)
apply clarsimp
apply (rule TypingInj)
apply (rule UniInjectL)
apply (rule UniStore)
  apply (rule getIns_M2_1) apply simp 
  prefer 6 apply fastsimp
  apply fastsimp
  apply simp 
  apply simp
  apply simp
  apply (rule UniCtxtVerified_emp)
  (* apply fast *)
apply clarsimp
apply (rule TypingInj)
apply (rule UniInjectL)
apply (rule UniLoad)
  apply (rule getIns_M2_2) apply simp
  prefer 7 apply fastsimp
  apply fastsimp
  apply (simp add: mkStore_def) apply (rule AL_update5, rule AL_update1) apply assumption
  apply simp
  apply simp
  apply simp
  apply (rule UniCtxtVerified_emp)
  (* apply fast *)
apply clarsimp
apply (rule TypingInj)
apply (rule UniInjectR)
apply (rule UniLoad)
  apply (rule getIns_M4_0)
  prefer 7 apply fastsimp
  apply fastsimp
  apply (rule AL_update1) 
  apply simp
  apply simp
  apply simp
  apply (rule UniCtxtVerified_emp)
  (* apply fast *)
apply clarsimp
apply (rule TypingInj)
apply (rule UniInjectL)
prefer 2 apply (rule UniCtxtVerified_emp)
prefer 2 apply fastsimp
apply (rule UniIf)
  apply (rule getIns_M2_3) apply simp
  apply fastsimp
  apply simp
  apply simp
  apply simp
  (* apply fast *)
apply clarsimp
apply rule
  (*4,1*) (*other case is: (13,1)*)
  apply clarsimp
  apply (rule TypingInj)
    apply (rule_tac c=\<alpha> in TypingConstConst)
      apply (rule getIns_M2_4) apply simp
      apply (rule getIns_M4_1) apply simp
      apply fastsimp
      apply (drule mkMP_Rel_dom) apply (frule mkMP_Rel_dom) apply (drule mkMP_Rel_dist)  apply(simp add: AL_dom_upd1) apply fast
    apply clarsimp
    apply (rule TypingInj)
    apply (rule UniInjectL)
    apply (rule UniStore)
      apply (rule getIns_M2_5) apply simp
      prefer 6 apply fastsimp
      apply fastsimp
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
    apply clarsimp
    apply (rule TypingInj)
    apply (rule UniInjectL)
    apply (rule UniLoad)
      apply (rule getIns_M2_6) apply simp
      prefer 7 apply fastsimp
      apply fastsimp
      apply (simp add: mkStore_def) apply (rule AL_update5, rule AL_update5, rule AL_update5) 
        apply (rule AL_update1) apply assumption+
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
    apply clarsimp
    apply (rule TypingInj)
    apply (rule UniInjectL)
    apply (rule UniLoad)
      apply (rule getIns_M2_7) apply simp
      prefer 7 apply fastsimp
      apply fastsimp
      apply (rule AL_update1) 
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
    apply clarsimp
    (*now that we have reached the binop instruction in the both components*)
    apply (rule TypingInj)
    apply (rule_tac c=\<beta> in TypingBinopBinop)
      apply (rule getIns_M2_8) apply simp
      apply (rule getIns_M4_2) apply simp
      apply fastsimp
      apply clarsimp apply (frule_tac N=N in mkMP_Rel_dom) apply (frule_tac N=M in mkMP_Rel_dom) 
             apply (drule_tac N=M in mkMP_Rel_dist) apply (simp add: AL_dom_upd1) apply fastsimp 
      apply (rule AL_update1)
      apply (rule AL_update5) apply (erule mkMP_Rel_Ilookup) apply simp
        apply (drule_tac N=M in mkMP_Rel_dist) apply simp apply fast
      apply assumption
    (*in the left component, we've already arrived at the allocation instruction, 
           so we proceed in the right phrase until we're at the allocation, too*)
    apply clarsimp
    apply (rule TypingInj)
    apply (rule UniInjectR)
    apply (rule UniStore)
      apply (rule getIns_M4_3) apply simp
      prefer 6 apply fastsimp
      apply fastsimp
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
    (*now NewNew*)
    apply clarsimp
    apply (rule TypingInj)
    apply (rule_tac c=\<mu> and C=C in  TypingNewNew)
      apply (rule getIns_M2_9) apply simp
      apply (rule getIns_M4_4) apply simp
      apply fastsimp
      apply (drule mkMP_Rel_dom) apply (frule mkMP_Rel_dom) apply (drule mkMP_Rel_dist)  apply(simp add: AL_dom_upd1) 
      apply (simp add: subclass_of_refl)
      apply (simp add: subclass_of_refl)
    (*we again first procede in the left component as far as possible, in this case until
        we hit the return instruction*)
    apply clarsimp
    apply (rule TypingInj)
    apply (rule UniInjectL)
    apply (rule UniSwap)
      apply (rule getIns_M2_10) apply simp
      prefer 6 apply fastsimp
      apply fastsimp
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
    apply clarsimp
    apply (subgoal_tac "mbody_is C M1 ([y], Code1, 0)")
    prefer 2 apply (simp add: mbody_is_def Prog1_def)
        apply (subgoal_tac "emp[C\<mapsto>Class]\<down>C = Some Class", simp)
          apply (simp add: Class_def Body1_def)
          apply (rule AL_update5, rule AL_update5, rule AL_update1) apply assumption apply assumption
        apply (rule AL_update1)
    apply (rule TypingInj)
    apply (rule UniInjectL)
    apply (rule_tac HH="emp[\<mu>\<mapsto>(C, emp[A\<mapsto>\<beta>])]" and c=\<beta> in UniInvV3)
      apply (rule getIns_M2_11) apply simp
      apply assumption
      prefer 9 apply fastsimp
      apply fastsimp
      apply (rule absFrameCons) 
        apply (rule absFrameNil) apply fastsimp 
        apply simp
      apply (rule AL_update1)
      apply simp
      apply simp
      prefer 3 apply (rule UniCtxtVerified_emp)
      prefer 2 apply clarsimp apply (erule_tac x=E in allE, clarsimp)
        apply (rule, rule, rule, assumption)
      apply (subgoal_tac "({}, ([], emp[y\<mapsto>\<beta>][this\<mapsto>\<mu>], emp[\<mu>\<mapsto>(C, emp)]), 
                            N[\<alpha>\<mapsto>intTP][\<beta>\<mapsto>intTP][\<mu>\<mapsto>(classTP C)],
        Body1, 0, True, emp[\<mu>\<mapsto>(C, emp[A\<mapsto>\<beta>])], \<beta>, 
           N[\<alpha>\<mapsto>intTP][\<beta>\<mapsto>intTP][\<mu>\<mapsto>(classTP C)])
       \<in> UniBS ")
      apply (subgoal_tac "Body1 = ([y], Code1, 0)", simp) apply (simp add: Body1_def)
      apply (rule UniInj)
      apply (subgoal_tac "AL_sum emp[\<mu>\<mapsto>(classTP C)][\<beta>\<mapsto>intTP] emp[\<gamma>\<mapsto>intTP][\<delta>\<mapsto>intTP][\<alpha>\<mapsto>intTP] N[\<alpha>\<mapsto>intTP][\<beta>\<mapsto>intTP][\<mu>\<mapsto>(classTP C)]")
      prefer 2 apply (simp add: AL_sum_def)
               apply (rule, drule mkMP_Rel_dom, simp add: AL_dom_emp AL_dom_upd1) apply fast
               apply (simp add: contained_def, rule)
                 apply clarsimp apply (drule AL_upd_split)
                         apply (erule disjE, clarsimp)
                           apply (rule AL_update5, rule AL_update1)
                           apply (drule_tac N=M in mkMP_Rel_dist) apply fastsimp
                         apply clarsimp
                           apply (drule AL_upd_split)
                           apply (erule disjE, clarsimp) apply (rule AL_update1)
                           apply (simp add: AL_emp1)
                 apply clarsimp 
                           apply (rule AL_update5, rule AL_update5) 
                             apply (drule AL_upd_split)
                             apply (erule disjE, clarsimp) apply (rule AL_update1) apply clarsimp
                             apply (rule AL_update5)
                               apply (drule AL_upd_split)
                               apply (erule disjE, clarsimp) apply (erule mkMP_Rel_Ilookup) apply simp apply clarsimp
                               apply (drule AL_upd_split)
                               apply (erule disjE, clarsimp) apply (erule mkMP_Rel_Ilookup) apply simp apply (simp add: AL_emp1)
                             apply assumption
                           apply (drule AL_domI) 
                               apply (drule_tac N=M in mkMP_Rel_dist) apply (drule_tac N=N in mkMP_Rel_dom) 
                               apply (simp add: AL_dom_upd1 AL_dom_emp) apply fastsimp
                           apply (drule AL_domI) 
                               apply (drule_tac N=M in mkMP_Rel_dist) apply (drule_tac N=N in mkMP_Rel_dom)
                               apply (simp add: AL_dom_upd1 AL_dom_emp) apply fastsimp
      apply (rule_tac H=emp and N="emp[\<gamma>\<mapsto>intTP][\<delta>\<mapsto>intTP][\<alpha>\<mapsto>intTP]" and NN="emp[\<mu>\<mapsto>(classTP C)][\<beta>\<mapsto>intTP]" in UniBSFrame)
        apply (rule_tac \<gamma>=\<mu> and F=emp in M1_unisound) apply assumption apply fastsimp 
          apply (simp (no_asm) add: star_def AL_sum_def contained_def)
            apply (rule, simp add: AL_dom_upd1 AL_dom_emp)
            apply (rule, clarsimp)
              apply (rule AL_update5, assumption) apply (drule AL_domI) apply (drule_tac N=M in mkMP_Rel_dist)
                                                    apply (simp add: AL_dom_upd1 AL_dom_emp) apply fastsimp
            apply (rule, clarsimp) 
              apply (drule AL_upd_split)
              apply (erule disjE, clarsimp) apply (rule AL_update1)
              apply (simp add: AL_emp1)
            apply (rule, simp add: AL_dom_upd1 AL_dom_emp) apply (drule_tac N=M in mkMP_Rel_dist) apply fastsimp
            apply (rule AL_UPD, rule AL_UPD, rule AL_EMP)
          apply simp 
          apply (simp add: SD_sum_def) apply (rule, rule AL_sum_emp2) apply (simp add: AL_dom_emp) 
          apply (simp add: SD_sum_def) apply (rule, rule AL_sum_emp2) apply (simp add: AL_dom_emp)
        apply assumption
        apply assumption
        apply (drule mkMP_Rel_dom) apply (frule mkMP_Rel_dom) apply (drule mkMP_Rel_dist) apply (simp add: AL_dom_upd1 AL_dom_emp) apply fast
        apply (rule AL_UPD, rule AL_UPD, rule AL_UPD) apply (simp add: mkMP_Rel_def, clarsimp)
      (* apply fast *)
    apply clarsimp
    (*we've reached the return instruction, so now do the right component*)
    apply (rule TypingInj)
    apply (rule UniInjectR)
    apply (rule UniLoad)
      apply (rule getIns_M4_5) apply simp
      prefer 7 apply fastsimp
      apply fastsimp
      apply (rule AL_update1)
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
    apply clarsimp
    apply (rule TypingInj)
    apply (rule UniInjectR)
    apply (rule UniPut)
      apply (rule getIns_M4_6) apply simp
      prefer 7 apply fastsimp
      apply fastsimp
      apply (rule AL_update1)
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp) 
      (* apply fast *)
    apply clarsimp
    apply (rule TypingInj)
    apply (rule UniInjectR)
    apply (rule UniLoad)
      apply (rule getIns_M4_7) apply simp
      prefer 7 apply fastsimp
      apply fastsimp
      apply (rule AL_update1)
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp) 
      (* apply fast *)
    apply clarsimp
    (*now we've arrive at return instructions in both compoents*)
    apply (rule TypingInj)
    apply (rule_tac H=emp and N=emp and K=emp in TypingFrame)
      apply (rule_tac 
         c=\<beta> and S="[]" and \<Gamma>="(mkStore \<gamma> \<delta>)[x\<mapsto>\<alpha>]" and
         d=\<beta> and T="[]" and \<Delta>="emp[l\<mapsto>\<gamma>][x\<mapsto>\<beta>]" in TypingRetRet)
        apply (rule getIns_M2_12) apply simp
        apply (rule getIns_M4_8) apply simp
        apply simp
        apply simp
      apply (simp add: RSD_sum_def mkStore_def upd_upd) apply (rule, rule AL_UPD, rule AL_EMP) 
         apply (rule, rule AL_UPD, rule AL_UPD, rule AL_UPD) apply (simp add: mkMP_Rel_def, clarsimp)
         apply (rule, rule AL_sum_emp2) 
         apply (rule, rule AL_sum_emp2) 
         apply (rule, rule AL_sum_emp2) 
         apply (simp add: AL_dom_emp)
      apply (simp add: RSD_sum_def)
         apply (rule, rule AL_UPD, rule AL_EMP) 
         apply (rule, simp add: mkMP_Rel_def, clarsimp)
         apply (rule, rule AL_sum_emp2) 
         apply (simp add: AL_dom_emp)
         apply (simp (no_asm) add: AL_sum_def contained_def)
           apply (rule, drule mkMP_Rel_dom, drule mkMP_Rel_dom, simp add: AL_dom_emp AL_dom_upd1) apply fast
           apply (simp add: AL_emp1, clarsimp)
           apply (drule AL_upd_split)
           apply (erule disjE, clarsimp)
             apply (erule mkMP_Rel_Clookup) apply simp apply clarsimp
           apply (drule AL_upd_split)
           apply (erule disjE, clarsimp)
             apply (erule mkMP_Rel_Ilookup) apply simp apply clarsimp
           apply (drule AL_upd_split)
           apply (erule disjE, clarsimp)
             apply (erule mkMP_Rel_Ilookup) apply simp apply clarsimp
           apply (erule mkMP_Rel_extend, assumption+) apply simp apply simp
  (*Branch (13,1)*)
    apply clarsimp
    apply (rule TypingInj)
    apply (rule UniInjectL)
    apply (rule UniLoad)
      apply (rule getIns_M2_13) apply simp
      prefer 7 apply fastsimp
      apply fastsimp
      apply (rule AL_update1) 
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
    apply clarsimp
    apply (rule TypingInj)
    apply (rule_tac c=\<alpha> in TypingConstConst)
      apply (rule getIns_M2_14) apply simp
      apply (rule getIns_M4_1) apply simp
      apply fastsimp
      apply (drule mkMP_Rel_dom) apply (frule mkMP_Rel_dom) apply (drule mkMP_Rel_dist) apply(simp add: AL_dom_upd1) apply fast
    apply clarsimp
    apply (rule TypingInj)
    apply (rule_tac c=\<beta> in TypingBinopBinop)
      apply (rule getIns_M2_15) apply simp
      apply (rule getIns_M4_2) apply simp
      apply fastsimp
      apply clarsimp apply (frule_tac N=N in mkMP_Rel_dom) apply (frule_tac N=M in mkMP_Rel_dom) 
             apply (drule_tac N=M in mkMP_Rel_dist) apply (simp add: AL_dom_upd1) apply fastsimp 
      apply (rule AL_update1)
      apply (rule AL_update5) apply (erule mkMP_Rel_Ilookup) apply simp
        apply (drule_tac N=M in mkMP_Rel_dist) apply simp apply fast
      apply assumption
    apply clarsimp
    (*we again first procede in the left component as far as possible, in this case until
        we hit the allocation instruction*)
    apply (rule TypingInj)
    apply (rule UniInjectL)
    apply (rule UniStore)
      apply (rule getIns_M2_16) apply simp
      prefer 6 apply fastsimp
      apply fastsimp
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
    (*the same in the right component*)
    apply clarsimp
    apply (rule TypingInj)
    apply (rule UniInjectR)
    apply (rule UniStore)
      apply (rule getIns_M4_3) apply simp
      prefer 6 apply fastsimp
      apply fastsimp
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
    (*Now NewNew*)
    apply clarsimp   
    apply (rule TypingInj)
    apply (rule_tac c=\<mu> and C=C in TypingNewNew)
      apply (rule getIns_M2_17) apply simp
      apply (rule getIns_M4_4) apply simp
      apply fastsimp
      apply (drule mkMP_Rel_dom) apply (frule mkMP_Rel_dom) apply (drule mkMP_Rel_dist) apply(simp add: AL_dom_upd1)
      apply (simp add: subclass_of_refl)
      apply (simp add: subclass_of_refl)
    (*we again first procede in the left component as far as possible, in this case until
        we hit the return instruction*)
    apply clarsimp
    apply (rule TypingInj)
    apply (rule UniInjectL)
    apply (rule UniDup)
      apply (rule getIns_M2_18) apply simp
      prefer 6 apply fastsimp
      apply fastsimp
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
    apply clarsimp
    apply (rule TypingInj)
    apply (rule UniInjectL)
    apply (rule UniLoad)
      apply (rule getIns_M2_19) apply simp
      prefer 7 apply fastsimp
      apply fastsimp
      apply (rule AL_update1)
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
    apply clarsimp
    apply (rule TypingInj)
    apply (rule UniInjectL)
    apply (rule UniPut)
      apply (rule getIns_M2_20) apply simp
      prefer 7 apply fastsimp
      apply fastsimp
      apply (rule AL_update1)
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
    apply clarsimp
    apply (rule TypingInj)
    apply (rule UniInjectL)
    apply (rule UniGet)
      apply (rule getIns_M2_21) apply simp
      prefer 8 apply fastsimp
      apply fastsimp
      apply (rule AL_update1)
      apply (rule AL_update1)
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
    (*we've reached the return instruction, so now do the right component, also until we hit return*)
    apply clarsimp
    apply (rule TypingInj)
    apply (rule UniInjectR)
    apply (rule UniLoad)
      apply (rule getIns_M4_5) apply simp
      prefer 7 apply fastsimp
      apply fastsimp
      apply (rule AL_update1)
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
    apply clarsimp
    apply (rule TypingInj)
    apply (rule UniInjectR)
    apply (rule UniPut)
      apply (rule getIns_M4_6) apply simp
      prefer 7 apply fastsimp
      apply fastsimp
      apply (rule AL_update1)
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp) 
      (* apply fast *)
    apply clarsimp
    apply (rule TypingInj)
    apply (rule UniInjectR)
    apply (rule UniLoad)
      apply (rule getIns_M4_7) apply simp
      prefer 7 apply fastsimp
      apply fastsimp
      apply (rule AL_update1)
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp) 
      (* apply fast *)
    apply clarsimp
    (*now we've arrive at return instructions in both compoents*)
    apply (rule TypingInj)
    apply (rule_tac H=emp and N=emp and K=emp in TypingFrame)
      apply (rule_tac 
         c=\<beta> and S="[]" and \<Gamma>="(mkStore \<gamma> \<delta>)[x\<mapsto>\<beta>]" and
         d=\<beta> and T="[]" and \<Delta>="emp[l\<mapsto>\<gamma>][x\<mapsto>\<beta>]" in TypingRetRet)
        apply (rule getIns_M2_22) apply simp
        apply (rule getIns_M4_8) apply simp
        apply simp
        apply simp
      apply (simp add: RSD_sum_def mkStore_def upd_upd) 
         apply (rule, rule AL_UPD, rule AL_EMP) 
         apply (rule, rule AL_UPD, rule AL_UPD, rule AL_UPD) apply (simp add: mkMP_Rel_def, clarsimp)
         apply (rule, rule AL_sum_emp2) 
         apply (rule, rule AL_sum_emp2) 
         apply (rule, rule AL_sum_emp2) 
         apply (simp add: AL_dom_emp)
      apply (simp add: RSD_sum_def)
         apply (rule, rule AL_UPD, rule AL_EMP) 
         apply (rule, simp add: mkMP_Rel_def, clarsimp)
         apply (rule, rule AL_sum_emp2) 
         apply (simp add: AL_dom_emp)
         apply (simp (no_asm) add: AL_sum_def contained_def)
           apply (rule, drule mkMP_Rel_dom, drule mkMP_Rel_dom, simp add: AL_dom_emp AL_dom_upd1) apply fast
           apply (simp add: AL_emp1, clarsimp)
           apply (drule AL_upd_split)
           apply (erule disjE, clarsimp)
             apply (erule mkMP_Rel_Clookup) apply simp apply clarsimp
           apply (drule AL_upd_split)
           apply (erule disjE, clarsimp)
             apply (erule mkMP_Rel_Ilookup) apply simp apply clarsimp
           apply (drule AL_upd_split)
           apply (erule disjE, clarsimp)
             apply (erule mkMP_Rel_Ilookup) apply simp apply clarsimp
           apply (erule mkMP_Rel_extend, assumption+) apply simp apply simp
done
(*>*)

(*<*)
end
(*>*)