(*<*)
theory jlapExample2 = RSD_TYPING:
(*>*)

text{*The example at the of Section 5.3 is BodyPrivObjects below. We
frist verify some simpler programs*}

consts l::Var
       h::Var
       C::Class
       M::Method

constdefs Body1:: Mbody
"Body1 \<equiv> ([],upd(upd(upd(upd(upd(upd(upd(upd(upd(upd(upd emp
                    0 (const (IVal 2)))
                    1 (store l))
                    2 (load h))
                    3 (iftrue 7))
                    4 (const (IVal 7)))
                    5 (store h))
                    6 (goto 9))
                    7 (const (IVal 5)))
                    8 (store h))
                    9 (load l))
                    10 vreturn,0)"

constdefs Class1::Classdef
"Class1 \<equiv> emp[M \<mapsto> (Body1)]"

constdefs Prog1::Prog
"Prog1 \<equiv> emp[C \<mapsto> Class1]"

text{*In order to simplify the definition of administrative maps a
bit, we use colours constants and assert their distinctness as
assumptions of the lemmas.*}

consts red ::Colour
       green :: Colour
       blue :: Colour
       black::Colour
       white::Colour
       yellow ::Colour

constdefs \<phi>::"HP \<Rightarrow> HP \<Rightarrow> RSD"
"\<phi> H K \<equiv> ( ([],upd emp h green,H),
                 upd(upd emp green intTP) red intTP,
                 ([],upd emp h red,K))"

constdefs Assum1::"RSD \<Rightarrow> HP \<Rightarrow> HP \<Rightarrow> bool"
"Assum1 \<delta> H K \<equiv> distinct [green,red,blue,black,white] \<and> distinct [l,h] \<and>
           \<delta> = (([blue], emp, H),
         emp[green\<mapsto>intTP][red\<mapsto>intTP][blue\<mapsto>intTP][black\<mapsto>intTP][white\<mapsto>intTP], [blue], emp,
         K)"

lemma "Assum1 \<delta> H K \<Longrightarrow> ({}, \<phi> H K, Body1, 0, Body1, 0, False, \<delta>):Typing"
apply (simp add: \<phi>_def)
apply (rule_tac c=blue in  TypingConstConst)
  apply (simp add: Body1_def get_ins_def)  
  apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
  apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
  apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update1) 
  apply (simp,simp,simp,simp)
  apply (simp,simp,simp,simp)
  apply (simp,simp)
  apply (simp add: Body1_def get_ins_def)  
  apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
  apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
  apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update1) 
  apply (simp,simp,simp,simp)
  apply (simp,simp,simp,simp)
  apply (simp,simp)
  apply fastsimp
  apply (simp add: AL_dom_upd1 AL_dom_emp Assum1_def) apply fastsimp
apply (rule TypingInj)
apply (rule_tac U="{}" in UniInjectL)
  apply (rule UniStore)
  apply (simp add: Body1_def get_ins_def)  
  apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
  apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
  apply (rule AL_update5) apply (rule AL_update1) 
  apply (simp,simp,simp,simp)
  apply (simp,simp,simp,simp)
  apply simp
  apply simp
  apply simp
  apply simp
  apply simp
  apply (simp add: UniCtxtVerified_def)
  apply fastsimp
  (* apply fast *)
apply clarsimp
apply (rule TypingInj)
apply (rule_tac U="{}" in UniInjectR)
  apply (rule UniStore)
  apply (simp add: Body1_def get_ins_def)  
  apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
  apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
  apply (rule AL_update5) apply (rule AL_update1) 
  apply (simp,simp,simp,simp)
  apply (simp,simp,simp,simp)
  apply simp
  apply simp
  apply simp
  apply simp
  apply simp
  apply (simp add: UniCtxtVerified_def)
  apply fastsimp
  (* apply fast *)
apply clarsimp
apply (rule TypingInj)
apply (rule_tac U="{}" in UniInjectL)
  apply (rule UniLoad)
  apply (simp add: Body1_def get_ins_def)  
  apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
  apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
  apply (rule AL_update1a) 
  apply (simp,simp,simp,simp)
  apply (simp,simp,simp,simp)
  apply simp
  apply simp
  prefer 6 apply fastsimp
  apply (rule AL_update5, rule AL_update1) apply (simp add: Assum1_def)
  apply simp
  apply simp
  apply simp
  apply (simp add: UniCtxtVerified_def)
  (* apply fast *)
apply clarsimp
apply (rule TypingInj)
apply (rule_tac U="{}" in UniInjectR)
  apply (rule UniLoad)
  apply (simp add: Body1_def get_ins_def)  
  apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
  apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
  apply (rule AL_update1a) 
  apply (simp,simp,simp,simp)
  apply (simp,simp,simp,simp)
  apply simp
  apply simp
  prefer 6 apply fastsimp
  apply (rule AL_update5, rule AL_update1) apply (simp add: Assum1_def)
  apply simp
  apply simp
  apply simp
  apply (simp add: UniCtxtVerified_def)
  (* apply fast *)
apply clarsimp
apply (rule TypingInj)
apply (rule_tac U="{}" in UniInjectL)
  apply (rule UniIf)
  apply (simp add: Body1_def get_ins_def)  
  apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
  apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) 
  apply (rule AL_update1a) 
  apply (simp,simp,simp,simp)
  apply (simp,simp,simp,simp)
  apply simp
  apply simp
  apply simp
  apply simp
  apply (simp add: UniCtxtVerified_def)
  apply fastsimp
  (* apply fast *)
apply clarsimp
apply rule
  apply clarsimp
  (*4,3*)
    apply (rule TypingInj)
    apply (rule_tac U="{}" in UniInjectR)
      apply (rule UniIf)
      apply (simp add: Body1_def get_ins_def)  
      apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
      apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) 
      apply (rule AL_update1a) 
      apply (simp,simp,simp,simp)
      apply (simp,simp,simp,simp)
      apply simp
      apply simp
      apply simp
      apply simp
      apply (simp add: UniCtxtVerified_def)
      apply fastsimp
      (* apply fast *)
    apply clarsimp
    apply rule
    apply clarsimp
    (*4,4*)
      apply (rule TypingInj)
      apply (rule_tac U="{}" in UniInjectL)
        apply (rule_tac c=black in UniConst)
        apply (simp add: Body1_def get_ins_def)  
        apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
        apply (rule AL_update5) apply (rule AL_update5) 
        apply (rule AL_update1a) 
        apply (simp,simp,simp,simp)
        apply (simp,simp,simp,simp)
        prefer 6 apply fastsimp
        apply (simp add: AL_dom_upd1 AL_dom_emp Assum1_def) apply fastsimp
        apply simp
        apply simp
        apply simp
        apply (simp add: UniCtxtVerified_def)
        (* apply fast *)
      apply clarsimp
      apply (rule TypingInj)
      apply (rule_tac U="{}" in UniInjectR)
        apply (rule_tac c=white in UniConst)
        apply (simp add: Body1_def get_ins_def)  
        apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
        apply (rule AL_update5) apply (rule AL_update5) 
        apply (rule AL_update1a) 
        apply (simp,simp,simp,simp)
        apply (simp,simp,simp,simp)
        prefer 6 apply fastsimp
        apply (simp add: AL_dom_upd1 AL_dom_emp Assum1_def) apply fastsimp
        apply simp
        apply simp
        apply simp
        apply (simp add: UniCtxtVerified_def)
        (* apply fast *)
      apply clarsimp
      apply (rule TypingInj)
      apply (rule_tac U="{}" in UniInjectL)
        apply (rule UniStore)
        apply (simp add: Body1_def get_ins_def)  
        apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
        apply (rule AL_update5)
        apply (rule AL_update1a) 
        apply (simp,simp,simp,simp)
        apply (simp,simp,simp,simp)
        prefer 4 apply fastsimp
        apply simp
        apply simp
        apply (simp add: UniCtxtVerified_def)
        (* apply fast *)
      apply clarsimp
      apply (rule TypingInj)
      apply (rule_tac U="{}" in UniInjectR)
        apply (rule UniStore)
        apply (simp add: Body1_def get_ins_def)  
        apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
        apply (rule AL_update5)
        apply (rule AL_update1a) 
        apply (simp,simp,simp,simp)
        apply (simp,simp,simp,simp)
        prefer 4 apply fastsimp
        apply simp
        apply simp
        apply (simp add: UniCtxtVerified_def)
        (* apply fast *)
      apply clarsimp
      apply (rule TypingInj)
      apply (rule_tac U="{}" in UniInjectL)
        apply (rule UniGoto)
        apply (simp add: Body1_def get_ins_def)  
        apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
        apply (rule AL_update1a) 
        apply (simp,simp,simp,simp)
        apply (simp,simp,simp,simp)
        apply (simp add: UniCtxtVerified_def)
        apply fastsimp
        (* apply fast *)
      apply clarsimp
      apply (rule TypingInj)
      apply (rule_tac U="{}" in UniInjectR)
        apply (rule UniGoto)
        apply (simp add: Body1_def get_ins_def)  
        apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
        apply (rule AL_update1a) 
        apply (simp,simp,simp,simp)
        apply (simp,simp,simp,simp)
        apply (simp add: UniCtxtVerified_def)
        apply fastsimp
        (* apply fast *)
      apply clarsimp
      apply (rule TypingInj)
      apply (rule_tac U="{}" in UniInjectL)
        apply (rule UniLoad)
        apply (simp add: Body1_def get_ins_def)  
        apply (rule AL_update5) 
        apply (rule AL_update1) 
        apply (simp,simp)
        prefer 6 apply fastsimp
        apply (rule AL_update5) apply (rule AL_update1) apply (simp add: Assum1_def) apply fastsimp
        apply simp
        apply simp
        apply simp
        apply (simp add: UniCtxtVerified_def)
        (* apply fast *)
      apply clarsimp
      apply (rule TypingInj)
      apply (rule_tac U="{}" in UniInjectR)
        apply (rule UniLoad)
        apply (simp add: Body1_def get_ins_def)  
        apply (rule AL_update5) 
        apply (rule AL_update1) 
        apply (simp,simp)
        prefer 6 apply fastsimp
        apply (rule AL_update5) apply (rule AL_update1) apply (simp add: Assum1_def) apply fastsimp
        apply simp
        apply simp
        apply simp
        apply (simp add: UniCtxtVerified_def)
        (* apply fast *)
      apply clarsimp
      apply (rule TypingInj)
        apply (rule TypingRetRet)
        apply (simp add: Body1_def get_ins_def)  
        apply (rule AL_update1) 
        apply (simp add: Body1_def get_ins_def)  
        apply (rule AL_update1) 
        apply fastsimp
      apply (simp add: Assum1_def)
    (*4,7*)
    apply clarsimp
      apply (rule TypingInj)
      apply (rule_tac U="{}" in UniInjectL)
        apply (rule_tac c=black in UniConst)
        apply (simp add: Body1_def get_ins_def)  
        apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
        apply (rule AL_update5) apply (rule AL_update5) 
        apply (rule AL_update1a) 
        apply (simp,simp,simp,simp)
        apply (simp,simp,simp,simp)
        prefer 6 apply fastsimp
        apply (simp add: AL_dom_upd1 AL_dom_emp Assum1_def) apply fastsimp
        apply simp
        apply simp
        apply simp
        apply (simp add: UniCtxtVerified_def)
        (* apply fast *)
      apply clarsimp
      apply (rule TypingInj)
      apply (rule_tac U="{}" in UniInjectR)
        apply (rule_tac c=white in UniConst)
        apply (simp add: Body1_def get_ins_def)  
        apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
        apply (rule AL_update1) 
        apply (simp,simp,simp,simp)
        prefer 6 apply fastsimp
        apply (simp add: AL_dom_upd1 AL_dom_emp Assum1_def) apply fastsimp
        apply simp
        apply simp
        apply simp
        apply (simp add: UniCtxtVerified_def)
        (* apply fast *)
      apply clarsimp
      apply (rule TypingInj)
      apply (rule_tac U="{}" in UniInjectL)
        apply (rule UniStore)
        apply (simp add: Body1_def get_ins_def)  
        apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
        apply (rule AL_update5)
        apply (rule AL_update1a) 
        apply (simp,simp,simp,simp)
        apply (simp,simp,simp,simp)
        prefer 4 apply fastsimp
        apply simp
        apply simp
        apply (simp add: UniCtxtVerified_def)
        (* apply fast *)
      apply clarsimp
      apply (rule TypingInj)
      apply (rule_tac U="{}" in UniInjectR)
        apply (rule UniStore)
        apply (simp add: Body1_def get_ins_def)  
        apply (rule AL_update5) apply (rule AL_update5) 
        apply (rule AL_update1) 
        apply (simp,simp,simp,simp)
        prefer 4 apply fastsimp
        apply simp
        apply simp
        apply (simp add: UniCtxtVerified_def)
        (* apply fast *)
      apply clarsimp
      apply (rule TypingInj)
      apply (rule_tac U="{}" in UniInjectL)
        apply (rule UniGoto)
        apply (simp add: Body1_def get_ins_def)  
        apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
        apply (rule AL_update1a) 
        apply (simp,simp,simp,simp)
        apply (simp,simp,simp,simp)
        apply (simp add: UniCtxtVerified_def)
        apply fastsimp
        (* apply fast *)
      apply clarsimp
      apply (rule TypingInj)
      apply (rule_tac U="{}" in UniInjectL)
        apply (rule UniLoad)
        apply (simp add: Body1_def get_ins_def)  
        apply (rule AL_update5) 
        apply (rule AL_update1) 
        apply (simp,simp)
        prefer 6 apply fastsimp
        apply (rule AL_update5) apply (rule AL_update1) apply (simp add: Assum1_def) apply fastsimp
        apply simp
        apply simp
        apply simp
        apply (simp add: UniCtxtVerified_def)
        (* apply fast *)
      apply clarsimp
      apply (rule TypingInj)
      apply (rule_tac U="{}" in UniInjectR)
        apply (rule UniLoad)
        apply (simp add: Body1_def get_ins_def)  
        apply (rule AL_update5) 
        apply (rule AL_update1) 
        apply (simp,simp)
        prefer 6 apply fastsimp
        apply (rule AL_update5) apply (rule AL_update1) apply (simp add: Assum1_def) apply fastsimp
        apply simp
        apply simp
        apply simp
        apply (simp add: UniCtxtVerified_def)
        (* apply fast *)
      apply clarsimp
      apply (rule TypingInj)
        apply (rule TypingRetRet)
        apply (simp add: Body1_def get_ins_def)  
        apply (rule AL_update1) 
        apply (simp add: Body1_def get_ins_def)  
        apply (rule AL_update1) 
        apply fastsimp
      apply (simp add: Assum1_def)
  apply clarsimp
  (*7,3*)
    apply (rule TypingInj)
    apply (rule_tac U="{}" in UniInjectR)
      apply (rule UniIf)
      apply (simp add: Body1_def get_ins_def)  
      apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
      apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) 
      apply (rule AL_update1a) 
      apply (simp,simp,simp,simp)
      apply (simp,simp,simp,simp)
      apply simp
      apply simp
      apply simp
      apply simp
      apply (simp add: UniCtxtVerified_def)
      apply fastsimp
      (* apply fast *)
    apply clarsimp
    apply rule
    apply clarsimp
    (*7,4*)
      apply (rule TypingInj)
      apply (rule_tac U="{}" in UniInjectL)
        apply (rule_tac c=black in UniConst)
        apply (simp add: Body1_def get_ins_def)  
        apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) 
        apply (rule AL_update1) 
        apply (simp,simp,simp,simp)
        prefer 6 apply fastsimp
        apply (simp add: AL_dom_upd1 AL_dom_emp Assum1_def) apply fastsimp
        apply simp
        apply simp
        apply simp
        apply (simp add: UniCtxtVerified_def)
        (* apply fast *)
      apply clarsimp
      apply (rule TypingInj)
      apply (rule_tac U="{}" in UniInjectR)
        apply (rule_tac c=white in UniConst)
        apply (simp add: Body1_def get_ins_def)  
        apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
        apply (rule AL_update5) apply (rule AL_update5) 
        apply (rule AL_update1a) 
        apply (simp,simp,simp,simp)
        apply (simp,simp,simp,simp)
        prefer 6 apply fastsimp
        apply (simp add: AL_dom_upd1 AL_dom_emp Assum1_def) apply fastsimp
        apply simp
        apply simp
        apply simp
        apply (simp add: UniCtxtVerified_def)
        (* apply fast *)
      apply clarsimp
      apply (rule TypingInj)
      apply (rule_tac U="{}" in UniInjectL)
        apply (rule UniStore)
        apply (simp add: Body1_def get_ins_def)  
        apply (rule AL_update5) apply (rule AL_update5) 
        apply (rule AL_update1) 
        apply (simp,simp,simp,simp)
        prefer 4 apply fastsimp
        apply simp
        apply simp
        apply (simp add: UniCtxtVerified_def)
        (* apply fast *)
      apply clarsimp
      apply (rule TypingInj)
      apply (rule_tac U="{}" in UniInjectR)
        apply (rule UniStore)
        apply (simp add: Body1_def get_ins_def)  
        apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
        apply (rule AL_update5)
        apply (rule AL_update1a) 
        apply (simp,simp,simp,simp)
        apply (simp,simp,simp,simp)
        prefer 4 apply fastsimp
        apply simp
        apply simp
        apply (simp add: UniCtxtVerified_def)
        (* apply fast *)
      apply clarsimp
      apply (rule TypingInj)
      apply (rule_tac U="{}" in UniInjectR)
        apply (rule UniGoto)
        apply (simp add: Body1_def get_ins_def)  
        apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
        apply (rule AL_update1a) 
        apply (simp,simp,simp,simp)
        apply (simp,simp,simp,simp)
        apply (simp add: UniCtxtVerified_def)
        apply fastsimp
        (* apply fast *)
      apply clarsimp
      apply (rule TypingInj)
      apply (rule_tac U="{}" in UniInjectL)
        apply (rule UniLoad)
        apply (simp add: Body1_def get_ins_def)  
        apply (rule AL_update5) 
        apply (rule AL_update1) 
        apply (simp,simp)
        prefer 6 apply fastsimp
        apply (rule AL_update5) apply (rule AL_update1) apply (simp add: Assum1_def) apply fastsimp
        apply simp
        apply simp
        apply simp
        apply (simp add: UniCtxtVerified_def)
        (* apply fast *)
      apply clarsimp
      apply (rule TypingInj)
      apply (rule_tac U="{}" in UniInjectR)
        apply (rule UniLoad)
        apply (simp add: Body1_def get_ins_def)  
        apply (rule AL_update5) 
        apply (rule AL_update1) 
        apply (simp,simp)
        prefer 6 apply fastsimp
        apply (rule AL_update5) apply (rule AL_update1) apply (simp add: Assum1_def) apply fastsimp
        apply simp
        apply simp
        apply simp
        apply (simp add: UniCtxtVerified_def)
        (* apply fast *)
      apply clarsimp
      apply (rule TypingInj)
        apply (rule TypingRetRet)
        apply (simp add: Body1_def get_ins_def)  
        apply (rule AL_update1) 
        apply (simp add: Body1_def get_ins_def)  
        apply (rule AL_update1) 
        apply fastsimp
      apply (simp add: Assum1_def)
    (*7,7*)
    apply clarsimp
      apply (rule TypingInj)
      apply (rule_tac U="{}" in UniInjectL)
        apply (rule_tac c=black in UniConst)
        apply (simp add: Body1_def get_ins_def)  
        apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) 
        apply (rule AL_update1) 
        apply (simp,simp,simp,simp)
        prefer 6 apply fastsimp
        apply (simp add: AL_dom_upd1 AL_dom_emp Assum1_def) apply fastsimp
        apply simp
        apply simp
        apply simp
        apply (simp add: UniCtxtVerified_def)
        (* apply fast *)
      apply clarsimp
      apply (rule TypingInj)
      apply (rule_tac U="{}" in UniInjectR)
        apply (rule_tac c=white in UniConst)
        apply (simp add: Body1_def get_ins_def)  
        apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
        apply (rule AL_update1) 
        apply (simp,simp,simp,simp)
        prefer 6 apply fastsimp
        apply (simp add: AL_dom_upd1 AL_dom_emp Assum1_def) apply fastsimp
        apply simp
        apply simp
        apply simp
        apply (simp add: UniCtxtVerified_def)
        (* apply fast *)
      apply clarsimp
      apply (rule TypingInj)
      apply (rule_tac U="{}" in UniInjectL)
        apply (rule UniStore)
        apply (simp add: Body1_def get_ins_def)  
        apply (rule AL_update5) apply (rule AL_update5) 
        apply (rule AL_update1) 
        apply (simp,simp,simp,simp)
        prefer 4 apply fastsimp
        apply simp
        apply simp
        apply (simp add: UniCtxtVerified_def)
        (* apply fast *)
      apply clarsimp
      apply (rule TypingInj)
      apply (rule_tac U="{}" in UniInjectR)
        apply (rule UniStore)
        apply (simp add: Body1_def get_ins_def)  
        apply (rule AL_update5) apply (rule AL_update5) 
        apply (rule AL_update1) 
        apply (simp,simp,simp,simp)
        prefer 4 apply fastsimp
        apply simp
        apply simp
        apply (simp add: UniCtxtVerified_def)
        (* apply fast *)
      apply clarsimp
      apply (rule TypingInj)
      apply (rule_tac U="{}" in UniInjectL)
        apply (rule UniLoad)
        apply (simp add: Body1_def get_ins_def)  
        apply (rule AL_update5) 
        apply (rule AL_update1) 
        apply (simp,simp)
        prefer 6 apply fastsimp
        apply (rule AL_update5) apply (rule AL_update1) apply (simp add: Assum1_def) apply fastsimp
        apply simp
        apply simp
        apply simp
        apply (simp add: UniCtxtVerified_def)
        (* apply fast *)
      apply clarsimp
      apply (rule TypingInj)
      apply (rule_tac U="{}" in UniInjectR)
        apply (rule UniLoad)
        apply (simp add: Body1_def get_ins_def)  
        apply (rule AL_update5) 
        apply (rule AL_update1) 
        apply (simp,simp)
        prefer 6 apply fastsimp
        apply (rule AL_update5) apply (rule AL_update1) apply (simp add: Assum1_def) apply fastsimp
        apply simp
        apply simp
        apply simp
        apply (simp add: UniCtxtVerified_def)
        (* apply fast *)
      apply clarsimp
      apply (rule TypingInj)
        apply (rule TypingRetRet)
        apply (simp add: Body1_def get_ins_def)  
        apply (rule AL_update1) 
        apply (simp add: Body1_def get_ins_def)  
        apply (rule AL_update1) 
        apply fastsimp
      apply (simp add: Assum1_def)
done
       
constdefs Assum2::"RSD \<Rightarrow> HP \<Rightarrow> HP \<Rightarrow> bool"
"Assum2 \<delta> H K \<equiv> distinct [green,red,blue,black] \<and> distinct [l,h] \<and>
    \<delta> = (([blue], emp, H),
         emp[green\<mapsto>intTP][red\<mapsto>intTP][blue\<mapsto>intTP][black\<mapsto>intTP], [blue], emp,
         K)"

lemma "Assum2 \<delta> H K \<Longrightarrow> ({}, \<phi> H K, Body1, 0, Body1, 0, False, \<delta>):Typing"
apply (simp add: \<phi>_def)
apply (rule_tac c=blue in  TypingConstConst)
  apply (simp add: Body1_def get_ins_def)  
  apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
  apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
  apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update1) 
  apply (simp,simp,simp,simp)
  apply (simp,simp,simp,simp)
  apply (simp,simp)
  apply (simp add: Body1_def get_ins_def)  
  apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
  apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
  apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update1) 
  apply (simp,simp,simp,simp)
  apply (simp,simp,simp,simp)
  apply (simp,simp)
  apply fastsimp
  apply (simp add: AL_dom_upd1 AL_dom_emp Assum2_def) apply fastsimp
apply (rule TypingInj)
apply (rule_tac U="{}" in UniInjectL)
  apply (rule UniStore)
  apply (simp add: Body1_def get_ins_def)  
  apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
  apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
  apply (rule AL_update5) apply (rule AL_update1) 
  apply (simp,simp,simp,simp)
  apply (simp,simp,simp,simp)
  apply simp
  apply simp
  apply simp
  apply simp
  apply simp
  apply (simp add: UniCtxtVerified_def)
  apply fastsimp
  (* apply fast *)
apply clarsimp
apply (rule TypingInj)
apply (rule_tac U="{}" in UniInjectR)
  apply (rule UniStore)
  apply (simp add: Body1_def get_ins_def)  
  apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
  apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
  apply (rule AL_update5) apply (rule AL_update1) 
  apply (simp,simp,simp,simp)
  apply (simp,simp,simp,simp)
  apply simp
  apply simp
  apply simp
  apply simp
  apply simp
  apply (simp add: UniCtxtVerified_def)
  apply fastsimp
  (* apply fast *)
apply clarsimp
apply (rule TypingInj)
apply (rule_tac U="{}" in UniInjectL)
  apply (rule UniLoad)
  apply (simp add: Body1_def get_ins_def)  
  apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
  apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
  apply (rule AL_update1a) 
  apply (simp,simp,simp,simp)
  apply (simp,simp,simp,simp)
  apply simp
  apply simp
  prefer 6 apply fastsimp
  apply (rule AL_update5, rule AL_update1) apply (simp add: Assum2_def)
  apply simp
  apply simp
  apply simp
  apply (simp add: UniCtxtVerified_def)
  (* apply fast *)
apply clarsimp
apply (rule TypingInj)
apply (rule_tac U="{}" in UniInjectR)
  apply (rule UniLoad)
  apply (simp add: Body1_def get_ins_def)  
  apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
  apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
  apply (rule AL_update1a) 
  apply (simp,simp,simp,simp)
  apply (simp,simp,simp,simp)
  apply simp
  apply simp
  prefer 6 apply fastsimp
  apply (rule AL_update5, rule AL_update1) apply (simp add: Assum2_def)
  apply simp
  apply simp
  apply simp
  apply (simp add: UniCtxtVerified_def)
  (* apply fast *)
apply clarsimp
apply (rule TypingInj)
apply (rule_tac U="{}" in UniInjectL)
  apply (rule UniIf)
  apply (simp add: Body1_def get_ins_def)  
  apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
  apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) 
  apply (rule AL_update1a) 
  apply (simp,simp,simp,simp)
  apply (simp,simp,simp,simp)
  apply simp
  apply simp
  apply simp
  apply simp
  apply (simp add: UniCtxtVerified_def)
  apply fastsimp
  (* apply fast *)
apply clarsimp
apply rule
  apply clarsimp
  (*4,3*)
    apply (rule TypingInj)
    apply (rule_tac U="{}" in UniInjectR)
      apply (rule UniIf)
      apply (simp add: Body1_def get_ins_def)  
      apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
      apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) 
      apply (rule AL_update1a) 
      apply (simp,simp,simp,simp)
      apply (simp,simp,simp,simp)
      apply simp
      apply simp
      apply simp
      apply simp
      apply (simp add: UniCtxtVerified_def)
      apply fastsimp
      (* apply fast *)
    apply clarsimp
    apply rule
    apply clarsimp
    (*4,4*)
      apply (rule TypingInj)
        apply (rule_tac c=black in TypingConstConst)
        apply (simp add: Body1_def get_ins_def)  
        apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
        apply (rule AL_update5) apply (rule AL_update5) 
        apply (rule AL_update1a) 
        apply (simp,simp,simp,simp)
        apply (simp,simp,simp)
        apply (simp add: Body1_def get_ins_def)  
        apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
        apply (rule AL_update5) apply (rule AL_update5) 
        apply (rule AL_update1a) 
        apply (simp,simp,simp,simp)
        apply (simp,simp,simp)
        apply fastsimp
        apply (simp add: AL_dom_upd1 AL_dom_emp Assum2_def) apply fastsimp
      apply clarsimp
      apply (rule TypingInj)
      apply (rule_tac U="{}" in UniInjectL)
        apply (rule UniStore)
        apply (simp add: Body1_def get_ins_def)  
        apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
        apply (rule AL_update5)
        apply (rule AL_update1a) 
        apply (simp,simp,simp,simp)
        apply (simp,simp,simp,simp)
        prefer 4 apply fastsimp
        apply simp
        apply simp
        apply (simp add: UniCtxtVerified_def)
        (* apply fast *)
      apply clarsimp
      apply (rule TypingInj)
      apply (rule_tac U="{}" in UniInjectR)
        apply (rule UniStore)
        apply (simp add: Body1_def get_ins_def)  
        apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
        apply (rule AL_update5)
        apply (rule AL_update1a) 
        apply (simp,simp,simp,simp)
        apply (simp,simp,simp,simp)
        prefer 4 apply fastsimp
        apply simp
        apply simp
        apply (simp add: UniCtxtVerified_def)
        (* apply fast *)
      apply clarsimp
      apply (rule TypingInj)
      apply (rule_tac U="{}" in UniInjectL)
        apply (rule UniGoto)
        apply (simp add: Body1_def get_ins_def)  
        apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
        apply (rule AL_update1a) 
        apply (simp,simp,simp,simp)
        apply (simp,simp,simp,simp)
        apply (simp add: UniCtxtVerified_def)
        apply fastsimp
        (* apply fast *)
      apply clarsimp
      apply (rule TypingInj)
      apply (rule_tac U="{}" in UniInjectR)
        apply (rule UniGoto)
        apply (simp add: Body1_def get_ins_def)  
        apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
        apply (rule AL_update1a) 
        apply (simp,simp,simp,simp)
        apply (simp,simp,simp,simp)
        apply (simp add: UniCtxtVerified_def)
        apply fastsimp
        (* apply fast *)
      apply clarsimp
      apply (rule TypingInj)
      apply (rule_tac U="{}" in UniInjectL)
        apply (rule UniLoad)
        apply (simp add: Body1_def get_ins_def)  
        apply (rule AL_update5) 
        apply (rule AL_update1) 
        apply (simp,simp)
        prefer 6 apply fastsimp
        apply (rule AL_update5) apply (rule AL_update1) apply (simp add: Assum2_def) apply fastsimp
        apply simp
        apply simp
        apply simp
        apply (simp add: UniCtxtVerified_def)
        (* apply fast *)
      apply clarsimp
      apply (rule TypingInj)
      apply (rule_tac U="{}" in UniInjectR)
        apply (rule UniLoad)
        apply (simp add: Body1_def get_ins_def)  
        apply (rule AL_update5) 
        apply (rule AL_update1) 
        apply (simp,simp)
        prefer 6 apply fastsimp
        apply (rule AL_update5) apply (rule AL_update1) apply (simp add: Assum2_def) apply fastsimp
        apply simp
        apply simp
        apply simp
        apply (simp add: UniCtxtVerified_def)
        (* apply fast *)
      apply clarsimp
      apply (rule TypingInj)
        apply (rule TypingRetRet)
        apply (simp add: Body1_def get_ins_def)  
        apply (rule AL_update1) 
        apply (simp add: Body1_def get_ins_def)  
        apply (rule AL_update1) 
        apply fastsimp
      apply (simp add: Assum2_def)
    (*4,7*)
    apply clarsimp
      apply (rule TypingInj)
        apply (rule_tac c=black in TypingConstConst)
        apply (simp add: Body1_def get_ins_def)  
        apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
        apply (rule AL_update5) apply (rule AL_update5) 
        apply (rule AL_update1a) 
        apply (simp,simp,simp,simp)
        apply (simp,simp,simp)
        apply (simp add: Body1_def get_ins_def)  
        apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
oops
text{*The proof attempt using rule ConstConst for the instruction pair (4,7) rightly fails since the numbers are different.*}

consts x::Var 
       F :: Field

constdefs Body2:: Mbody
"Body2 \<equiv> ([],upd(upd(upd(upd(upd(upd(upd(upd(upd(upd(upd(upd(upd emp
                    0 (const (IVal 2)))
                    1 (store l))
                    2 (load h))
                    3 (iftrue 8))
                    4 (load x))
                    5 (const (IVal 7)))
                    6 (putfield C F))
                    7 (goto 11))
                    8 (load x))
                    9 (const (IVal 5)))
                    10 (putfield C F))
                    11 (load l))
                    12 vreturn,0)"

constdefs Class2::Classdef
"Class2 \<equiv> emp[M \<mapsto> (Body2)]"

constdefs Prog2::Prog
"Prog2 \<equiv> emp[C \<mapsto> Class2]"

constdefs \<psi>::RSD
"\<psi> \<equiv> ( ([],upd(upd emp h green) x yellow,upd emp yellow (C,emp)),
                 upd(upd(upd emp green intTP) red intTP) yellow (classTP C),
                 ([],upd(upd emp h red) x yellow,upd emp yellow (C,emp)))"
(*
lemma AL_upd_idempotent2:"MM[b\<mapsto>c][b\<mapsto>a] = MM[b\<mapsto>a]"
apply (simp add: upd_def)
apply (subgoal_tac "delete MM b = delete (delete MM b) b",clarsimp)
apply (rule AL_delete_idempotent)
done
*)
constdefs Assum3::"RSD \<Rightarrow> bool"
"Assum3 \<delta> \<equiv> distinct [green,red,blue,black,white,yellow] \<and> distinct [l,h,x] \<and>
           \<delta> = (([blue], emp, upd emp yellow (C,upd emp F black)),
         emp[green\<mapsto>intTP][red\<mapsto>intTP][yellow\<mapsto>(classTP C)]
            [blue\<mapsto>intTP][black\<mapsto>intTP][white\<mapsto>intTP], 
          ( [blue], emp, upd emp yellow (C,upd emp F white)))"
lemma "Assum3 \<delta> \<Longrightarrow> ({}, \<psi>, Body2, 0, Body2, 0, False, \<delta>):Typing"
apply (simp add: \<psi>_def)
apply (rule_tac c=blue in  TypingConstConst)
  apply (simp add: Body2_def get_ins_def)  
  apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
  apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
  apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
  apply (rule AL_update1) 
  apply (simp,simp,simp,simp)
  apply (simp,simp,simp,simp)
  apply (simp,simp,simp,simp)
  apply (simp add: Body2_def get_ins_def)  
  apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
  apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
  apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) 
  apply (rule AL_update1) 
  apply (simp,simp,simp,simp)
  apply (simp,simp,simp,simp)
  apply (simp,simp,simp,simp)
  apply fastsimp
  apply (simp add: AL_dom_upd1 AL_dom_emp Assum3_def) apply fastsimp
  apply simp
apply (rule TypingInj)
apply (rule_tac U="{}" in UniInjectL)
  apply (rule UniStore)
  apply (simp add: Body2_def get_ins_def)  
  apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
  apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
  apply (rule AL_update5)  apply (rule AL_update5) apply (rule AL_update5)
  apply (rule AL_update1) 
  apply (simp,simp,simp,simp)
  apply (simp,simp,simp,simp)
  apply (simp, simp, simp)
  apply simp
  apply simp
  apply simp
  apply simp
  apply (simp add: UniCtxtVerified_def)
  apply fastsimp
  (* apply fast *)
apply clarsimp
apply (rule TypingInj)
apply (rule_tac U="{}" in UniInjectR)
  apply (rule UniStore)
  apply (simp add: Body2_def get_ins_def)  
  apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
  apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
  apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
  apply (rule AL_update1) 
  apply (simp,simp,simp,simp)
  apply (simp,simp,simp,simp)
  apply (simp, simp, simp)
  apply simp
  apply simp
  apply simp
  apply simp
  apply (simp add: UniCtxtVerified_def)
  apply fastsimp
  (* apply fast *)
apply clarsimp
apply (rule TypingInj)
apply (rule_tac U="{}" in UniInjectL)
  apply (rule UniLoad)
  apply (simp add: Body2_def get_ins_def)  
  apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
  apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
  apply (rule AL_update5) apply (rule AL_update5)
  apply (rule AL_update1a) 
  apply (simp,simp,simp,simp)
  apply (simp,simp,simp,simp)
  apply (simp,simp,simp)
  apply simp
  prefer 6 apply fastsimp
  apply (rule AL_update5, rule AL_update5, rule AL_update1) apply (simp add: Assum3_def) apply fastsimp
     apply (simp add: Assum3_def)     
  apply simp
  apply simp
  apply simp
  apply (simp add: UniCtxtVerified_def)
  (* apply fast *)
apply clarsimp
apply (rule TypingInj)
apply (rule_tac U="{}" in UniInjectR)
  apply (rule UniLoad)
  apply (simp add: Body2_def get_ins_def)  
  apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
  apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
  apply (rule AL_update5) apply (rule AL_update5)
  apply (rule AL_update1a) 
  apply (simp,simp,simp,simp)
  apply (simp,simp,simp,simp)
  apply (simp, simp, simp)
  apply simp
  prefer 6 apply fastsimp
  apply (rule AL_update5, rule AL_update5, rule AL_update1) apply (simp add: Assum3_def) apply fastsimp
     apply (simp add: Assum3_def)
  apply simp
  apply simp
  apply simp
  apply (simp add: UniCtxtVerified_def)
  (* apply fast *)
apply clarsimp
apply (rule TypingInj)
apply (rule_tac U="{}" in UniInjectL)
  apply (rule UniIf)
  apply (simp add: Body2_def get_ins_def)  
  apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
  apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) 
  apply (rule AL_update1a) 
  apply (simp,simp,simp,simp)
  apply (simp,simp,simp,simp)
  apply (simp,simp,simp)
  apply simp
  apply simp
  apply simp
  apply (simp add: UniCtxtVerified_def)
  apply fastsimp
  (* apply fast *)
apply clarsimp
apply rule
  apply clarsimp
  (*4,3*)
    apply (rule TypingInj)
    apply (rule_tac U="{}" in UniInjectR)
      apply (rule UniIf)
      apply (simp add: Body2_def get_ins_def)  
      apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
      apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
      apply (rule AL_update1a) 
      apply (simp,simp,simp,simp)
      apply (simp,simp,simp,simp)
      apply (simp,simp,simp)
      apply simp
      apply simp
      apply simp
      apply (simp add: UniCtxtVerified_def)
      apply fastsimp
      (* apply fast *)
    apply clarsimp
    apply rule
    apply clarsimp
    (*4,4*)
      apply (rule TypingInj)
      apply (rule_tac U="{}" in UniInjectL)
        apply (rule UniLoad)
        apply (simp add: Body2_def get_ins_def)  
        apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) 
        apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) 
        apply (rule AL_update1a) 
        apply (simp,simp,simp,simp)
        apply (simp,simp,simp,simp)
        apply (simp,simp)
        prefer 6 apply fastsimp
        apply (rule AL_update5) apply (rule AL_update1) apply (simp add: Assum3_def) 
        apply simp
        apply simp
        apply simp
        apply (simp add: UniCtxtVerified_def)
        (* apply fast *)
      apply clarsimp
      apply (rule TypingInj)
      apply (rule_tac U="{}" in UniInjectR)
        apply (rule UniLoad)
        apply (simp add: Body2_def get_ins_def) 
        apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) 
        apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) 
        apply (rule AL_update1a) 
        apply (simp,simp,simp,simp)
        apply (simp,simp,simp,simp)
        apply (simp,simp) 
        prefer 6 apply fastsimp
        apply (rule AL_update5) apply (rule AL_update1) apply (simp add: Assum3_def) 
        apply simp
        apply simp
        apply simp
        apply (simp add: UniCtxtVerified_def)
        (* apply fast *)
      apply clarsimp
      apply (rule TypingInj)
      apply (rule_tac U="{}" in UniInjectL)
        apply (rule_tac c=black in UniConst)
        apply (simp add: Body2_def get_ins_def)  
        apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
        apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
        apply (rule AL_update1a) 
        apply (simp,simp,simp,simp)
        apply (simp,simp,simp,simp)
        apply simp
        prefer 6 apply fastsimp
        apply (simp add: AL_dom_upd1 AL_dom_emp Assum3_def) apply fastsimp
        apply simp
        apply simp
        apply simp
        apply (simp add: UniCtxtVerified_def)
        (* apply fast *)
      apply clarsimp
      apply (rule TypingInj)
      apply (rule_tac U="{}" in UniInjectR)
        apply (rule_tac c=white in UniConst)
        apply (simp add: Body2_def get_ins_def)  
        apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
        apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) 
        apply (rule AL_update1a) 
        apply (simp,simp,simp,simp)
        apply (simp,simp,simp,simp)
        apply simp
        prefer 6 apply fastsimp
        apply (simp add: AL_dom_upd1 AL_dom_emp Assum3_def) apply fastsimp
        apply simp
        apply simp
        apply simp
        apply (simp add: UniCtxtVerified_def)
        (* apply fast *)
      apply clarsimp
      apply (rule TypingInj)
      apply (rule_tac U="{}" in UniInjectL)
        apply (rule UniPut)
        apply (simp add: Body2_def get_ins_def)  
        apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
        apply (rule AL_update5) apply (rule AL_update5)
        apply (rule AL_update1a) 
        apply (simp,simp,simp,simp)
        apply (simp,simp,simp,simp)
        prefer 6 apply fastsimp
        apply (rule AL_update1)
        apply simp
        apply simp
        apply simp
        apply (simp add: UniCtxtVerified_def)
        (* apply fast *)
      apply clarsimp
      apply (rule TypingInj)
      apply (rule_tac U="{}" in UniInjectR)
        apply (rule UniPut)
        apply (simp add: Body2_def get_ins_def)  
        apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
        apply (rule AL_update5) apply (rule AL_update5)
        apply (rule AL_update1a) 
        apply (simp,simp,simp,simp)
        apply (simp,simp,simp,simp)
        prefer 6 apply fastsimp
        apply (rule AL_update1)
        apply simp
        apply simp
        apply simp
        apply (simp add: UniCtxtVerified_def)
        (* apply fast *)
      apply clarsimp
      apply (rule TypingInj)
      apply (rule_tac U="{}" in UniInjectL)
        apply (rule UniGoto)
        apply (simp add: Body2_def get_ins_def)  
        apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
         apply (rule AL_update5) apply (rule AL_update1a) 
        apply (simp,simp,simp,simp)
        apply (simp,simp,simp,simp)
        apply simp
        apply (simp add: UniCtxtVerified_def)
        apply fastsimp
        (* apply fast *)
      apply clarsimp
      apply (rule TypingInj)
      apply (rule_tac U="{}" in UniInjectR)
        apply (rule UniGoto)
        apply (simp add: Body2_def get_ins_def)  
        apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
        apply (rule AL_update5) apply (rule AL_update1a) 
        apply (simp,simp,simp,simp)
        apply (simp,simp,simp,simp)
        apply simp
        apply (simp add: UniCtxtVerified_def)
        apply fastsimp
        (* apply fast *)
      apply clarsimp
      apply (rule TypingInj)
      apply (rule_tac U="{}" in UniInjectL)
        apply (rule UniLoad)
        apply (simp add: Body2_def get_ins_def)  
        apply (rule AL_update5)
        apply (rule AL_update1) 
        apply (simp,simp)
        prefer 6 apply fastsimp
        apply (rule AL_update1) 
        apply simp
        apply simp
        apply simp
        apply (simp add: UniCtxtVerified_def)
        (* apply fast *)
      apply clarsimp
      apply (rule TypingInj)
      apply (rule_tac U="{}" in UniInjectR)
        apply (rule UniLoad)
        apply (simp add: Body2_def get_ins_def)  
        apply (rule AL_update5) 
        apply (rule AL_update1) 
        apply (simp,simp)
        prefer 6 apply fastsimp
        apply (rule AL_update1) 
        apply simp
        apply simp
        apply simp
        apply (simp add: UniCtxtVerified_def)
        (* apply fast *)
      apply clarsimp
      apply (rule TypingInj)
        apply (rule TypingRetRet)
        apply (simp add: Body2_def get_ins_def)  
        apply (rule AL_update1) 
        apply (simp add: Body2_def get_ins_def)  
        apply (rule AL_update1) 
        apply fastsimp
      apply (simp add: Assum3_def upd_upd) 
    (*4,8*)
    apply clarsimp
      apply (rule TypingInj)
      apply (rule_tac U="{}" in UniInjectL)
        apply (rule UniLoad)
        apply (simp add: Body2_def get_ins_def)
        apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
        apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)   
        apply (rule AL_update1a) 
        apply (simp,simp,simp,simp)
        apply (simp,simp,simp,simp)
        apply (simp,simp)
        prefer 6 apply fastsimp
        apply (rule AL_update5) apply (rule AL_update1) apply (simp add: Assum3_def) 
        apply simp
        apply simp
        apply simp
        apply (simp add: UniCtxtVerified_def)
        (* apply fast *)
      apply clarsimp
      apply (rule TypingInj)
      apply (rule_tac U="{}" in UniInjectL)
        apply (rule_tac c=black in UniConst)
        apply (simp add: Body2_def get_ins_def)  
        apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
        apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) 
        apply (rule AL_update1a) 
        apply (simp,simp,simp,simp)
        apply (simp,simp,simp,simp)
        apply simp
        prefer 6 apply fastsimp
        apply (simp add: AL_dom_upd1 AL_dom_emp Assum3_def) apply fastsimp
        apply simp
        apply simp
        apply simp
        apply (simp add: UniCtxtVerified_def)
        (* apply fast *)
      apply clarsimp
      apply (rule TypingInj)
      apply (rule_tac U="{}" in UniInjectR)
        apply (rule UniLoad)
        apply (simp add: Body2_def get_ins_def)
        apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
        apply (rule AL_update1a) 
        apply (simp,simp,simp,simp)
        apply (simp,simp)
        prefer 6 apply fastsimp
        apply (rule AL_update5) apply (rule AL_update1) apply (simp add: Assum3_def) 
        apply simp
        apply simp
        apply simp
        apply (simp add: UniCtxtVerified_def)
        (* apply fast *)
      apply clarsimp
      apply (rule TypingInj)
      apply (rule_tac U="{}" in UniInjectR)
        apply (rule_tac c=white in UniConst)
        apply (simp add: Body2_def get_ins_def)  
        apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) 
        apply (rule AL_update1a) 
        apply (simp,simp,simp,simp)
        apply simp
        prefer 6 apply fastsimp
        apply (simp add: AL_dom_upd1 AL_dom_emp Assum3_def) apply fastsimp
        apply simp
        apply simp
        apply simp
        apply (simp add: UniCtxtVerified_def)
        (* apply fast *)
      apply clarsimp
      apply (rule TypingInj)
      apply (rule_tac U="{}" in UniInjectL)
        apply (rule UniPut)
        apply (simp add: Body2_def get_ins_def)  
        apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
        apply (rule AL_update5) apply (rule AL_update5) 
        apply (rule AL_update1a) 
        apply (simp,simp,simp,simp)
        apply (simp,simp,simp,simp)
        prefer 6 apply fastsimp
        apply (rule AL_update1)
        apply simp
        apply simp
        apply simp
        apply (simp add: UniCtxtVerified_def)
        (* apply fast *)
      apply clarsimp
      apply (rule TypingInj)
      apply (rule_tac U="{}" in UniInjectR)
        apply (rule UniPut)
        apply (simp add: Body2_def get_ins_def)  
        apply (rule AL_update5) apply (rule AL_update5) 
        apply (rule AL_update1) 
        apply (simp,simp,simp)
        prefer 6 apply fastsimp
        apply (rule AL_update1)
        apply simp
        apply simp
        apply simp
        apply (simp add: UniCtxtVerified_def)
        (* apply fast *)
      apply clarsimp
      apply (rule TypingInj)
      apply (rule_tac U="{}" in UniInjectL)
        apply (rule UniGoto)
        apply (simp add: Body2_def get_ins_def)  
        apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
        apply (rule AL_update5) apply (rule AL_update1a) 
        apply (simp,simp,simp,simp)
        apply (simp,simp,simp,simp)
        apply simp
        apply (simp add: UniCtxtVerified_def)
        apply fastsimp
        (* apply fast *)
      apply clarsimp
      apply (rule TypingInj)
      apply (rule_tac U="{}" in UniInjectL)
        apply (rule UniLoad)
        apply (simp add: Body2_def get_ins_def)  
        apply (rule AL_update5) 
        apply (rule AL_update1) 
        apply (simp,simp)
        prefer 6 apply fastsimp
        apply (rule AL_update1) 
        apply simp
        apply simp
        apply simp
        apply (simp add: UniCtxtVerified_def)
        (* apply fast *)
      apply clarsimp
      apply (rule TypingInj)
      apply (rule_tac U="{}" in UniInjectR)
        apply (rule UniLoad)
        apply (simp add: Body2_def get_ins_def)  
        apply (rule AL_update5) 
        apply (rule AL_update1) 
        apply (simp,simp)
        prefer 6 apply fastsimp
        apply (rule AL_update1)
        apply simp
        apply simp
        apply simp
        apply (simp add: UniCtxtVerified_def)
        (* apply fast *)
      apply clarsimp
      apply (rule TypingInj)
        apply (rule TypingRetRet)
        apply (simp add: Body2_def get_ins_def)  
        apply (rule AL_update1) 
        apply (simp add: Body2_def get_ins_def)  
        apply (rule AL_update1) 
        apply fastsimp
      apply (simp add: Assum3_def upd_upd)
  apply clarsimp
  (*8,3*)
    apply (rule TypingInj)
    apply (rule_tac U="{}" in UniInjectR)
      apply (rule UniIf)
      apply (simp add: Body2_def get_ins_def)  
      apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
      apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) 
      apply (rule AL_update1a) 
      apply (simp,simp,simp,simp)
      apply (simp,simp,simp,simp)
      apply (simp,simp,simp,simp)
      apply simp
      apply simp
      apply (simp add: UniCtxtVerified_def)
      apply fastsimp
      (* apply fast *)
    apply clarsimp
    apply rule
    apply clarsimp
    (*8,4*)
      apply (rule TypingInj)
      apply (rule_tac U="{}" in UniInjectL)
        apply (rule UniLoad)
        apply (simp add: Body2_def get_ins_def)  
        apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) 
        apply (rule AL_update1) 
        apply (simp,simp,simp,simp)
        apply simp
        prefer 6 apply fastsimp
        apply (rule AL_update5) apply (rule AL_update1) apply (simp add: Assum3_def) 
        apply simp
        apply simp
        apply simp
        apply (simp add: UniCtxtVerified_def)
        (* apply fast *)
      apply clarsimp
      apply (rule TypingInj)
      apply (rule_tac U="{}" in UniInjectL)
        apply (rule_tac c=black in UniConst)
        apply (simp add: Body2_def get_ins_def)  
        apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) 
        apply (rule AL_update1) 
        apply (simp,simp,simp,simp)
        prefer 6 apply fastsimp
        apply (simp add: AL_dom_upd1 AL_dom_emp Assum3_def) apply fastsimp
        apply simp
        apply simp
        apply simp
        apply (simp add: UniCtxtVerified_def)
        (* apply fast *)
      apply clarsimp
      apply (rule TypingInj)
      apply (rule_tac U="{}" in UniInjectR)
        apply (rule UniLoad)
        apply (simp add: Body2_def get_ins_def)  
        apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
        apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) 
        apply (rule AL_update1a) 
        apply (simp,simp,simp,simp)
        apply (simp,simp,simp,simp)
        apply (simp, simp)
        prefer 6 apply fastsimp
        apply (rule AL_update5) apply (rule AL_update1) apply (simp add: Assum3_def) 
        apply simp
        apply simp
        apply simp
        apply (simp add: UniCtxtVerified_def)
        (* apply fast *)
      apply clarsimp
      apply (rule TypingInj)
      apply (rule_tac U="{}" in UniInjectR)
        apply (rule_tac c=white in UniConst)
        apply (simp add: Body2_def get_ins_def)  
        apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
        apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) 
        apply (rule AL_update1a) 
        apply (simp,simp,simp,simp)
        apply (simp,simp,simp,simp)
        apply simp
        prefer 6 apply fastsimp
        apply (simp add: AL_dom_upd1 AL_dom_emp Assum3_def) apply fastsimp
        apply simp
        apply simp
        apply simp
        apply (simp add: UniCtxtVerified_def)
        (* apply fast *)
      apply clarsimp
      apply (rule TypingInj)
      apply (rule_tac U="{}" in UniInjectL)
        apply (rule UniPut)
        apply (simp add: Body2_def get_ins_def)  
        apply (rule AL_update5) apply (rule AL_update5) 
        apply (rule AL_update1) 
        apply (simp,simp,simp)
        prefer 6 apply fastsimp
        apply (rule AL_update1)
        apply simp
        apply simp
        apply simp
        apply (simp add: UniCtxtVerified_def)
        (* apply fast *)
      apply clarsimp
      apply (rule TypingInj)
      apply (rule_tac U="{}" in UniInjectR)
        apply (rule UniPut)
        apply (simp add: Body2_def get_ins_def)  
        apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
        apply (rule AL_update5) apply (rule AL_update5)
        apply (rule AL_update1a) 
        apply (simp,simp,simp,simp)
        apply (simp,simp,simp,simp)
        prefer 6 apply fastsimp
        apply (rule AL_update1)
        apply simp
        apply simp
        apply simp
        apply (simp add: UniCtxtVerified_def)
        (* apply fast *)
      apply clarsimp
      apply (rule TypingInj)
      apply (rule_tac U="{}" in UniInjectR)
        apply (rule UniGoto)
        apply (simp add: Body2_def get_ins_def)  
        apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
        apply (rule AL_update5) apply (rule AL_update1a) 
        apply (simp,simp,simp,simp)
        apply (simp,simp,simp,simp)
        apply simp
        apply (simp add: UniCtxtVerified_def)
        apply fastsimp
        (* apply fast *)
      apply clarsimp
      apply (rule TypingInj)
      apply (rule_tac U="{}" in UniInjectL)
        apply (rule UniLoad)
        apply (simp add: Body2_def get_ins_def)  
        apply (rule AL_update5) 
        apply (rule AL_update1) 
        apply (simp,simp)
        prefer 6 apply fastsimp
        apply (rule AL_update1) 
        apply simp
        apply simp
        apply simp
        apply (simp add: UniCtxtVerified_def)
        (* apply fast *)
      apply clarsimp
      apply (rule TypingInj)
      apply (rule_tac U="{}" in UniInjectR)
        apply (rule UniLoad)
        apply (simp add: Body2_def get_ins_def)  
        apply (rule AL_update5) 
        apply (rule AL_update1) 
        apply (simp,simp)
        prefer 6 apply fastsimp
        apply (rule AL_update1) 
        apply simp
        apply simp
        apply simp
        apply (simp add: UniCtxtVerified_def)
        (* apply fast *)
      apply clarsimp
      apply (rule TypingInj)
        apply (rule TypingRetRet)
        apply (simp add: Body2_def get_ins_def)  
        apply (rule AL_update1) 
        apply (simp add: Body2_def get_ins_def)  
        apply (rule AL_update1) 
        apply fastsimp
      apply (simp add: Assum3_def upd_upd)
    (*7,7*)
    apply clarsimp
      apply (rule TypingInj)
      apply (rule_tac U="{}" in UniInjectL)
        apply (rule UniLoad)
        apply (simp add: Body2_def get_ins_def)  
        apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
        apply (rule AL_update1) 
        apply (simp,simp,simp,simp)
        apply simp
        prefer 6 apply fastsimp
        apply (rule AL_update5) apply (rule AL_update1) apply (simp add: Assum3_def) 
        apply simp
        apply simp
        apply simp
        apply (simp add: UniCtxtVerified_def)
        (* apply fast *)
      apply clarsimp
      apply (rule TypingInj)
      apply (rule_tac U="{}" in UniInjectL)
        apply (rule_tac c=black in UniConst)
        apply (simp add: Body2_def get_ins_def)  
        apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) 
        apply (rule AL_update1) 
        apply (simp,simp,simp,simp)
        prefer 6 apply fastsimp
        apply (simp add: AL_dom_upd1 AL_dom_emp Assum3_def) apply fastsimp
        apply simp
        apply simp
        apply simp
        apply (simp add: UniCtxtVerified_def)
        (* apply fast *)
      apply clarsimp
      apply (rule TypingInj)
      apply (rule_tac U="{}" in UniInjectR)
        apply (rule UniLoad)
        apply (simp add: Body2_def get_ins_def)  
        apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
        apply (rule AL_update1) 
        apply (simp,simp,simp,simp)
        apply simp
        prefer 6 apply fastsimp
        apply (rule AL_update5) apply (rule AL_update1) apply (simp add: Assum3_def) 
        apply simp
        apply simp
        apply simp
        apply (simp add: UniCtxtVerified_def)
        (* apply fast *)
      apply clarsimp
      apply (rule TypingInj)
      apply (rule_tac U="{}" in UniInjectR)
        apply (rule_tac c=white in UniConst)
        apply (simp add: Body2_def get_ins_def)  
        apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
        apply (rule AL_update1) 
        apply (simp,simp,simp,simp)
        prefer 6 apply fastsimp
        apply (simp add: AL_dom_upd1 AL_dom_emp Assum3_def) apply fastsimp
        apply simp
        apply simp
        apply simp
        apply (simp add: UniCtxtVerified_def)
        (* apply fast *)
      apply clarsimp
      apply (rule TypingInj)
      apply (rule_tac U="{}" in UniInjectL)
        apply (rule UniPut)
        apply (simp add: Body2_def get_ins_def)  
        apply (rule AL_update5) apply (rule AL_update5) 
        apply (rule AL_update1) 
        apply (simp,simp,simp)
        prefer 6 apply fastsimp
        apply (rule AL_update1)
        apply simp
        apply simp
        apply simp
        apply (simp add: UniCtxtVerified_def)
        (* apply fast *)
      apply clarsimp
      apply (rule TypingInj)
      apply (rule_tac U="{}" in UniInjectR)
        apply (rule UniPut)
        apply (simp add: Body2_def get_ins_def)  
        apply (rule AL_update5) apply (rule AL_update5) 
        apply (rule AL_update1) 
        apply (simp,simp,simp)
        prefer 6 apply fastsimp
        apply (rule AL_update1)
        apply simp
        apply simp
        apply simp
        apply (simp add: UniCtxtVerified_def)
        (* apply fast *)
      apply clarsimp
      apply (rule TypingInj)
      apply (rule_tac U="{}" in UniInjectL)
        apply (rule UniLoad)
        apply (simp add: Body2_def get_ins_def)  
        apply (rule AL_update5) 
        apply (rule AL_update1) 
        apply (simp,simp)
        prefer 6 apply fastsimp
        apply (rule AL_update1) 
        apply simp
        apply simp
        apply simp
        apply (simp add: UniCtxtVerified_def)
        (* apply fast *)
      apply clarsimp
      apply (rule TypingInj)
      apply (rule_tac U="{}" in UniInjectR)
        apply (rule UniLoad)
        apply (simp add: Body2_def get_ins_def)  
        apply (rule AL_update5) 
        apply (rule AL_update1) 
        apply (simp,simp)
        prefer 6 apply fastsimp
        apply (rule AL_update1) 
        apply simp
        apply simp
        apply simp
        apply (simp add: UniCtxtVerified_def)
        (* apply fast *)
      apply clarsimp
      apply (rule TypingInj)
        apply (rule TypingRetRet)
        apply (simp add: Body2_def get_ins_def)  
        apply (rule AL_update1) 
        apply (simp add: Body2_def get_ins_def)  
        apply (rule AL_update1) 
        apply fastsimp
      apply (simp add: Assum3_def upd_upd)
done
       
constdefs Assum4::"RSD \<Rightarrow> bool"
"Assum4 \<delta> \<equiv> distinct [green,red,blue,black,yellow] \<and> distinct [l,h,x] \<and>
           \<delta> = (([blue], emp, upd emp yellow (C,upd emp F black)),
         emp[green\<mapsto>intTP][red\<mapsto>intTP][yellow\<mapsto>(classTP C)]
            [blue\<mapsto>intTP][black\<mapsto>intTP], 
          ( [blue], emp, upd emp yellow (C,upd emp F black)))"
lemma "Assum4 \<delta> \<Longrightarrow> ({}, \<psi>, Body2, 0, Body2, 0, False, \<delta>):Typing"
apply (simp add: \<psi>_def)
apply (rule_tac c=blue in  TypingConstConst)
  apply (simp add: Body2_def get_ins_def)  
  apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
  apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
  apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
  apply (rule AL_update1) 
  apply (simp,simp,simp,simp)
  apply (simp,simp,simp,simp)
  apply (simp,simp,simp,simp)
  apply (simp add: Body2_def get_ins_def)  
  apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
  apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
  apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) 
  apply (rule AL_update1) 
  apply (simp,simp,simp,simp)
  apply (simp,simp,simp,simp)
  apply (simp,simp,simp,simp)
  apply fastsimp
  apply (simp add: AL_dom_upd1 AL_dom_emp Assum4_def) apply fastsimp
  apply simp
apply (rule TypingInj)
apply (rule_tac U="{}" in UniInjectL)
  apply (rule UniStore)
  apply (simp add: Body2_def get_ins_def)  
  apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
  apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
  apply (rule AL_update5)  apply (rule AL_update5) apply (rule AL_update5)
  apply (rule AL_update1) 
  apply (simp,simp,simp,simp)
  apply (simp,simp,simp,simp)
  apply (simp, simp, simp)
  apply simp
  apply simp
  apply simp
  apply simp
  apply (simp add: UniCtxtVerified_def)
  apply fastsimp
  (* apply fast *)
apply clarsimp
apply (rule TypingInj)
apply (rule_tac U="{}" in UniInjectR)
  apply (rule UniStore)
  apply (simp add: Body2_def get_ins_def)  
  apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
  apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
  apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
  apply (rule AL_update1) 
  apply (simp,simp,simp,simp)
  apply (simp,simp,simp,simp)
  apply (simp, simp, simp)
  apply simp
  apply simp
  apply simp
  apply simp
  apply (simp add: UniCtxtVerified_def)
  apply fastsimp
  (* apply fast *)
apply clarsimp
apply (rule TypingInj)
apply (rule_tac U="{}" in UniInjectL)
  apply (rule UniLoad)
  apply (simp add: Body2_def get_ins_def)  
  apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
  apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
  apply (rule AL_update5) apply (rule AL_update5)
  apply (rule AL_update1a) 
  apply (simp,simp,simp,simp)
  apply (simp,simp,simp,simp)
  apply (simp,simp,simp)
  apply simp
  prefer 6 apply fastsimp
  apply (rule AL_update5, rule AL_update5, rule AL_update1) apply (simp add: Assum4_def) apply fastsimp
     apply (simp add: Assum4_def)     
  apply simp
  apply simp
  apply simp
  apply (simp add: UniCtxtVerified_def)
  (* apply fast *)
apply clarsimp
apply (rule TypingInj)
apply (rule_tac U="{}" in UniInjectR)
  apply (rule UniLoad)
  apply (simp add: Body2_def get_ins_def)  
  apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
  apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
  apply (rule AL_update5) apply (rule AL_update5)
  apply (rule AL_update1a) 
  apply (simp,simp,simp,simp)
  apply (simp,simp,simp,simp)
  apply (simp, simp, simp)
  apply simp
  prefer 6 apply fastsimp
  apply (rule AL_update5, rule AL_update5, rule AL_update1) apply (simp add: Assum4_def) apply fastsimp
     apply (simp add: Assum4_def)
  apply simp
  apply simp
  apply simp
  apply (simp add: UniCtxtVerified_def)
  (* apply fast *)
apply clarsimp
apply (rule TypingInj)
apply (rule_tac U="{}" in UniInjectL)
  apply (rule UniIf)
  apply (simp add: Body2_def get_ins_def)  
  apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
  apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) 
  apply (rule AL_update1a) 
  apply (simp,simp,simp,simp)
  apply (simp,simp,simp,simp)
  apply (simp,simp,simp)
  apply simp
  apply simp
  apply simp
  apply (simp add: UniCtxtVerified_def)
  apply fastsimp
  (* apply fast *)
apply clarsimp
apply rule
  apply clarsimp
  (*4,3*)
    apply (rule TypingInj)
    apply (rule_tac U="{}" in UniInjectR)
      apply (rule UniIf)
      apply (simp add: Body2_def get_ins_def)  
      apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
      apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
      apply (rule AL_update1a) 
      apply (simp,simp,simp,simp)
      apply (simp,simp,simp,simp)
      apply (simp,simp,simp)
      apply simp
      apply simp
      apply simp
      apply (simp add: UniCtxtVerified_def)
      apply fastsimp
      (* apply fast *)
    apply clarsimp
    apply rule
    apply clarsimp
    (*4,4*)
      apply (rule TypingInj)
      apply (rule_tac U="{}" in UniInjectL)
        apply (rule UniLoad)
        apply (simp add: Body2_def get_ins_def)  
        apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) 
        apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) 
        apply (rule AL_update1a) 
        apply (simp,simp,simp,simp)
        apply (simp,simp,simp,simp)
        apply (simp,simp)
        prefer 6 apply fastsimp
        apply (rule AL_update5) apply (rule AL_update1) apply (simp add: Assum4_def) 
        apply simp
        apply simp
        apply simp
        apply (simp add: UniCtxtVerified_def)
        (* apply fast *)
      apply clarsimp
      apply (rule TypingInj)
      apply (rule_tac U="{}" in UniInjectR)
        apply (rule UniLoad)
        apply (simp add: Body2_def get_ins_def) 
        apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) 
        apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) 
        apply (rule AL_update1a) 
        apply (simp,simp,simp,simp)
        apply (simp,simp,simp,simp)
        apply (simp,simp) 
        prefer 6 apply fastsimp
        apply (rule AL_update5) apply (rule AL_update1) apply (simp add: Assum4_def) 
        apply simp
        apply simp
        apply simp
        apply (simp add: UniCtxtVerified_def)
        (* apply fast *)
      apply clarsimp
      apply (rule TypingInj)
        apply (rule_tac c=black in TypingConstConst)
        apply (simp add: Body2_def get_ins_def)  
        apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
        apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
        apply (rule AL_update1a) 
        apply (simp,simp,simp,simp)
        apply (simp,simp,simp,simp)
        apply (simp add: Body2_def get_ins_def)  
        apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
        apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
        apply (rule AL_update1a) 
        apply (simp,simp,simp,simp)
        apply (simp,simp,simp,simp)
        apply fastsimp
        apply (simp add: AL_dom_upd1 AL_dom_emp Assum4_def) apply fastsimp
      apply clarsimp
      apply (rule TypingInj)
      apply (rule_tac U="{}" in UniInjectL)
        apply (rule UniPut)
        apply (simp add: Body2_def get_ins_def)  
        apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
        apply (rule AL_update5) apply (rule AL_update5)
        apply (rule AL_update1a) 
        apply (simp,simp,simp,simp)
        apply (simp,simp,simp,simp)
        prefer 6 apply fastsimp
        apply (rule AL_update1)
        apply simp
        apply simp
        apply simp
        apply (simp add: UniCtxtVerified_def)
        (* apply fast *)
      apply clarsimp
      apply (rule TypingInj)
      apply (rule_tac U="{}" in UniInjectR)
        apply (rule UniPut)
        apply (simp add: Body2_def get_ins_def)  
        apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
        apply (rule AL_update5) apply (rule AL_update5)
        apply (rule AL_update1a) 
        apply (simp,simp,simp,simp)
        apply (simp,simp,simp,simp)
        prefer 6 apply fastsimp
        apply (rule AL_update1)
        apply simp
        apply simp
        apply simp
        apply (simp add: UniCtxtVerified_def)
        (* apply fast *)
      apply clarsimp
      apply (rule TypingInj)
      apply (rule_tac U="{}" in UniInjectL)
        apply (rule UniGoto)
        apply (simp add: Body2_def get_ins_def)  
        apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
         apply (rule AL_update5) apply (rule AL_update1a) 
        apply (simp,simp,simp,simp)
        apply (simp,simp,simp,simp)
        apply simp
        apply (simp add: UniCtxtVerified_def)
        apply fastsimp
        (* apply fast *)
      apply clarsimp
      apply (rule TypingInj)
      apply (rule_tac U="{}" in UniInjectR)
        apply (rule UniGoto)
        apply (simp add: Body2_def get_ins_def)  
        apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
        apply (rule AL_update5) apply (rule AL_update1a) 
        apply (simp,simp,simp,simp)
        apply (simp,simp,simp,simp)
        apply simp
        apply (simp add: UniCtxtVerified_def)
        apply fastsimp
        (* apply fast *)
      apply clarsimp
      apply (rule TypingInj)
      apply (rule_tac U="{}" in UniInjectL)
        apply (rule UniLoad)
        apply (simp add: Body2_def get_ins_def)  
        apply (rule AL_update5)
        apply (rule AL_update1) 
        apply (simp,simp)
        prefer 6 apply fastsimp
        apply (rule AL_update1) 
        apply simp
        apply simp
        apply simp
        apply (simp add: UniCtxtVerified_def)
        (* apply fast *)
      apply clarsimp
      apply (rule TypingInj)
      apply (rule_tac U="{}" in UniInjectR)
        apply (rule UniLoad)
        apply (simp add: Body2_def get_ins_def)  
        apply (rule AL_update5) 
        apply (rule AL_update1) 
        apply (simp,simp)
        prefer 6 apply fastsimp
        apply (rule AL_update1) 
        apply simp
        apply simp
        apply simp
        apply (simp add: UniCtxtVerified_def)
        (* apply fast *)
      apply clarsimp
      apply (rule TypingInj)
        apply (rule TypingRetRet)
        apply (simp add: Body2_def get_ins_def)  
        apply (rule AL_update1) 
        apply (simp add: Body2_def get_ins_def)  
        apply (rule AL_update1) 
        apply fastsimp
      apply (simp add: Assum4_def upd_upd) 
    (*4,8*)
    apply clarsimp
      apply (rule TypingInj)
      apply (rule_tac U="{}" in UniInjectL)
        apply (rule UniLoad)
        apply (simp add: Body2_def get_ins_def)
        apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
        apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)   
        apply (rule AL_update1a) 
        apply (simp,simp,simp,simp)
        apply (simp,simp,simp,simp)
        apply (simp,simp)
        prefer 6 apply fastsimp
        apply (rule AL_update5) apply (rule AL_update1) apply (simp add: Assum4_def) 
        apply simp
        apply simp
        apply simp
        apply (simp add: UniCtxtVerified_def)
        (* apply fast *)
      apply clarsimp
      apply (rule TypingInj)
      apply (rule_tac U="{}" in UniInjectR)
        apply (rule UniLoad)
        apply (simp add: Body2_def get_ins_def) 
        apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) 
        apply (rule AL_update1) 
        apply (simp,simp,simp,simp)
        apply simp
        prefer 6 apply fastsimp
        apply (rule AL_update5) apply (rule AL_update1) apply (simp add: Assum4_def) 
        apply simp
        apply simp
        apply simp
        apply (simp add: UniCtxtVerified_def)
        (* apply fast *)
      apply clarsimp
      apply (rule TypingInj)
        apply (rule_tac c=black in TypingConstConst)
        apply (simp add: Body2_def get_ins_def)  
        apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
        apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) 
        apply (rule AL_update1a) 
        apply (simp,simp,simp,simp)
        apply (simp,simp,simp,simp)
        apply (simp add: Body2_def get_ins_def)  
        apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) 
oops

text{*Again, the application of ConstConst rightly fails.*}

constdefs Body3:: Mbody
"Body3 \<equiv> ([],upd(upd(upd(upd(upd(upd(upd(upd(upd(upd emp
                    0 (load h))
                    1 (iftrue 6))
                    2 (const (IVal 2)))
                    3 (const (IVal 7)))
                    4 (store h))
                    5 vreturn)
                    6 (const (IVal 5)))
                    7 (store h))
                    8 (const (IVal 2)))
                    9 vreturn,0)"

constdefs Class3::Classdef
"Class3 \<equiv> emp[M \<mapsto> (Body3)]"

constdefs Prog3::Prog
"Prog3 \<equiv> emp[C \<mapsto> Class3]"

lemma "\<lbrakk>Assum1 \<delta> H K; H \<in> AL; K \<in> AL\<rbrakk> \<Longrightarrow> ({}, \<phi> H K, Body3, 0, Body3, 0, False, \<delta>):Typing"
apply (simp add: \<phi>_def)
apply (rule_tac U="{}" in UniInjectL)
  apply (rule UniLoad)
  apply (simp add: Body3_def get_ins_def)  
  apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
  apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
  apply (rule AL_update5) apply (rule AL_update1a) 
  apply (simp,simp,simp,simp)
  apply (simp,simp,simp,simp)
  apply simp
  apply simp
  apply simp
  prefer 6 apply fastsimp
  apply (rule AL_update1) 
  apply simp
  apply simp
  apply simp
  apply (simp add: UniCtxtVerified_def)
  (* apply fast *)
apply clarsimp
apply (rule TypingInj)
apply (rule_tac U="{}" in UniInjectR)
  apply (rule UniLoad)
  apply (simp add: Body3_def get_ins_def)  
  apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
  apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
  apply (rule AL_update5) apply (rule AL_update1a) 
  apply (simp,simp,simp,simp)
  apply (simp,simp,simp,simp)
  apply simp
  apply simp
  apply simp
  prefer 6 apply fastsimp
  apply (rule AL_update1) 
  apply simp
  apply simp
  apply simp
  apply (simp add: UniCtxtVerified_def)
  (* apply fast *)
apply clarsimp
apply (rule TypingInj)
apply (rule_tac U="{}" in UniInjectL)
  apply (rule UniIf)
  apply (simp add: Body3_def get_ins_def)  
  apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
  apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) 
  apply (rule AL_update1) 
  apply (simp,simp,simp,simp)
  apply (simp,simp,simp,simp)
  apply simp
  apply simp
  apply simp
  apply simp
  apply (simp add: UniCtxtVerified_def)
  apply fastsimp
  (* apply fast *)
apply clarsimp
apply rule
  (*2,1*)
  apply clarsimp
    apply (rule TypingInj)
    apply (rule_tac U="{}" in UniInjectR)
      apply (rule UniIf)
      apply (simp add: Body3_def get_ins_def)  
      apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
      apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) 
      apply (rule AL_update1) 
      apply (simp,simp,simp,simp)
      apply (simp,simp,simp,simp)
      apply simp
      apply simp
      apply simp
      apply simp
      apply (simp add: UniCtxtVerified_def)
      apply fastsimp
      (* apply fast *)
    apply clarsimp
    apply rule apply clarsimp
    (*2,2*)
      apply (rule TypingInj)
      apply (rule_tac c=blue in  TypingConstConst)
        apply (simp add: Body3_def get_ins_def)  
        apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
          apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update1a)
          apply (simp,simp,simp,simp)
          apply (simp,simp,simp,simp)
        apply (simp add: Body3_def get_ins_def)  
        apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
          apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update1a)
          apply (simp,simp,simp,simp)
          apply (simp,simp,simp,simp)
        apply fastsimp
        apply (simp add: AL_dom_upd1 AL_dom_emp Assum1_def) apply fastsimp
      apply clarsimp
      apply (rule TypingInj)
      apply (rule_tac U="{}" in UniInjectL)
        apply (rule_tac c=black in UniConst)
        apply (simp add: Body3_def get_ins_def)  
        apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
        apply (rule AL_update5) apply (rule AL_update5) 
        apply (rule AL_update1a) 
        apply (simp,simp,simp,simp)
        apply (simp,simp,simp,simp)
        prefer 6 apply fastsimp
        apply (simp add: AL_dom_upd1 AL_dom_emp Assum1_def) apply fastsimp
        apply simp
        apply simp
        apply simp
        apply (simp add: UniCtxtVerified_def)
        (* apply fast *)
      apply clarsimp
      apply (rule TypingInj)
      apply (rule_tac U="{}" in UniInjectR)
        apply (rule_tac c=white in UniConst)
        apply (simp add: Body3_def get_ins_def)  
        apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
        apply (rule AL_update5) apply (rule AL_update5) 
        apply (rule AL_update1a) 
        apply (simp,simp,simp,simp)
        apply (simp,simp,simp,simp)
        prefer 6 apply fastsimp
        apply (simp add: AL_dom_upd1 AL_dom_emp Assum1_def) apply fastsimp
        apply simp
        apply simp
        apply simp
        apply (simp add: UniCtxtVerified_def)
        (* apply fast *)
      apply clarsimp
      apply (rule TypingInj)
      apply (rule_tac U="{}" in UniInjectL)
        apply (rule UniStore)
        apply (simp add: Body3_def get_ins_def)  
        apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
        apply (rule AL_update5)
        apply (rule AL_update1a) 
        apply (simp,simp,simp,simp)
        apply (simp,simp,simp,simp)
        prefer 4 apply fastsimp
        apply simp
        apply simp
        apply (simp add: UniCtxtVerified_def)
        (* apply fast *)
      apply clarsimp
      apply (rule TypingInj)
      apply (rule_tac U="{}" in UniInjectR)
        apply (rule UniStore)
        apply (simp add: Body3_def get_ins_def)  
        apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
        apply (rule AL_update5)
        apply (rule AL_update1a) 
        apply (simp,simp,simp,simp)
        apply (simp,simp,simp,simp)
        prefer 4 apply fastsimp
        apply simp
        apply simp
        apply (simp add: UniCtxtVerified_def)
        (* apply fast *)
      apply clarsimp
      apply (rule TypingInj)
        apply (rule TypingRetRet)
        apply (simp add: Body3_def get_ins_def)    
          apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
          apply (rule AL_update1a) apply (simp,simp,simp,simp) apply simp
        apply (simp add: Body3_def get_ins_def)  
          apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
          apply (rule AL_update1a) apply (simp,simp,simp,simp) apply simp
        apply fastsimp
      apply (simp add: Assum1_def)
    (*2,6*)
    apply clarsimp
      apply (rule TypingInj)
      apply (rule_tac U="{}" in UniInjectR)
        apply (rule_tac c=white in UniConst)
        apply (simp add: Body3_def get_ins_def)  
        apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
        apply (rule AL_update1) 
        apply (simp,simp,simp,simp)
        prefer 6 apply fastsimp
        apply (simp add: AL_dom_upd1 AL_dom_emp Assum1_def) apply fastsimp
        apply simp
        apply simp
        apply simp
        apply (simp add: UniCtxtVerified_def)
        (* apply fast *)
      apply clarsimp
      apply (rule TypingInj)
      apply (rule_tac U="{}" in UniInjectR)
        apply (rule UniStore)
        apply (simp add: Body3_def get_ins_def)  
        apply (rule AL_update5) apply (rule AL_update5)
        apply (rule AL_update1) 
        apply (simp,simp,simp)
        apply simp
        prefer 4 apply fastsimp
        apply simp
        apply simp
        apply (simp add: UniCtxtVerified_def)
        (* apply fast *)
      apply clarsimp
      apply (rule TypingInj)
      apply (rule_tac c=blue in  TypingConstConst)
        apply (simp add: Body3_def get_ins_def)  
        apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
          apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update1a)
          apply (simp,simp,simp,simp)
          apply (simp,simp,simp,simp)
        apply (simp add: Body3_def get_ins_def)  
        apply (rule AL_update5) apply (rule AL_update1) apply simp
        apply fastsimp
        apply (simp add: AL_dom_upd1 AL_dom_emp Assum1_def) apply fastsimp
      apply clarsimp
      apply (rule TypingInj)
      apply (rule_tac U="{}" in UniInjectL)
        apply (rule_tac c=black in UniConst)
        apply (simp add: Body3_def get_ins_def)  
        apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
        apply (rule AL_update5) apply (rule AL_update5) 
        apply (rule AL_update1a) 
        apply (simp,simp,simp,simp)
        apply (simp,simp,simp,simp)
        prefer 6 apply fastsimp
        apply (simp add: AL_dom_upd1 AL_dom_emp Assum1_def) apply fastsimp
        apply simp
        apply simp
        apply simp
        apply (simp add: UniCtxtVerified_def)
        (* apply fast *)
      apply clarsimp
      apply (rule TypingInj)
      apply (rule_tac U="{}" in UniInjectL)
        apply (rule UniStore)
        apply (simp add: Body3_def get_ins_def)  
        apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) 
        apply (rule AL_update5) apply (rule AL_update1a) 
        apply (simp,simp,simp,simp) apply (simp,simp,simp,simp) 
        prefer 4 apply fastsimp
        apply simp
        apply simp
        apply (simp add: UniCtxtVerified_def)
        (* apply fast *)
      apply clarsimp
      apply (rule TypingInj)
        apply (rule TypingFrame) (*we use the Frame rule here as a to exploiot extensionality of RDS-components*)
          apply (rule_tac H=emp and N=emp and K=emp in  TypingRetRet)
          apply (simp add: Body3_def get_ins_def)    
            apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
            apply (rule AL_update1a) apply (simp,simp,simp,simp) apply simp
          apply (simp add: Body3_def get_ins_def)  
            apply (rule AL_update1) 
        apply simp
        apply simp
        apply (simp add: RSD_sum_def)
          apply (rule, simp)
          apply (rule, simp)
          apply (rule, simp)
          apply (rule, simp)
          apply (rule, simp)
          apply (rule, simp)
          apply (rule, rule AL_UPD, rule AL_UPD, rule AL_UPD, rule AL_UPD, rule AL_UPD, rule AL_EMP)
          apply (rule, rule AL_sum_emp1)
          apply (rule, rule AL_sum_emp1)
          apply (rule, rule AL_sum_emp1)
          apply (rule, simp add: AL_dom_emp)
          apply (rule, simp add: AL_dom_emp)
          apply (simp add: AL_dom_emp)
        apply (simp add: RSD_sum_def Assum1_def, (erule conjE)+)
          apply (rule, rule AL_UPD, rule AL_UPD, rule AL_UPD, rule AL_UPD, rule AL_UPD, rule AL_EMP)
          apply (rule, rule AL_sum_emp1)
          apply (rule, rule AL_sum_emp1)
          apply (rule, simp add: AL_sum_def)
            apply (rule, simp add: AL_dom_upd1 AL_dom_emp) apply fast
            apply (rule, rule contained_emp)
            apply (simp add: contained_def, clarsimp)
            apply (drule AL_upd_split)
            apply (erule disjE, clarsimp) apply (rule AL_update5a, rule AL_update1) apply assumption
            apply clarsimp
            apply (drule AL_upd_split)
            apply (erule disjE, clarsimp) apply (rule AL_update5a, rule AL_update5a, rule AL_update1) apply assumption apply assumption
            apply clarsimp
            apply (drule AL_upd_split)
            apply (erule disjE, clarsimp) apply (rule AL_update1) 
            apply clarsimp
            apply (drule AL_upd_split)
            apply (erule disjE, clarsimp) apply (rule AL_update5a, rule AL_update5a, rule AL_update5a, rule AL_update1) 
              apply assumption apply assumption apply assumption
            apply clarsimp
            apply (drule AL_upd_split)
            apply (erule disjE, clarsimp) apply (rule AL_update5a, rule AL_update5a, rule AL_update5a, rule AL_update5a, rule AL_update1) 
              apply assumption apply assumption apply assumption apply assumption
            apply (simp add: AL_emp1)
          apply (rule, simp add: AL_dom_emp)
          apply (rule, simp add: AL_dom_emp)
          apply (simp add: AL_dom_emp)
  (*6,1*)
  apply clarsimp
    apply (rule TypingInj)
    apply (rule_tac U="{}" in UniInjectR)
      apply (rule UniIf)
      apply (simp add: Body3_def get_ins_def)  
      apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
      apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) 
      apply (rule AL_update1) 
      apply (simp,simp,simp,simp)
      apply (simp,simp,simp,simp)
      apply simp
      apply simp
      apply simp
      apply simp
      apply (simp add: UniCtxtVerified_def)
      apply fastsimp
      (* apply fast *)
    apply clarsimp
    apply rule
    (*6,2*)    
      apply clarsimp
      apply (rule TypingInj)
      apply (rule_tac U="{}" in UniInjectL)
        apply (rule_tac c=white in UniConst)
        apply (simp add: Body3_def get_ins_def)  
        apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
        apply (rule AL_update1) 
        apply (simp,simp,simp,simp)
        prefer 6 apply fastsimp
        apply (simp add: AL_dom_upd1 AL_dom_emp Assum1_def) apply fastsimp
        apply simp
        apply simp
        apply simp
        apply (simp add: UniCtxtVerified_def)
        (* apply fast *)
      apply clarsimp
      apply (rule TypingInj)
      apply (rule_tac U="{}" in UniInjectL)
        apply (rule UniStore)
        apply (simp add: Body3_def get_ins_def)  
        apply (rule AL_update5) apply (rule AL_update5)
        apply (rule AL_update1) 
        apply (simp,simp,simp)
        apply simp
        prefer 4 apply fastsimp
        apply simp
        apply simp
        apply (simp add: UniCtxtVerified_def)
        (* apply fast *)
      apply clarsimp
      apply (rule TypingInj)
      apply (rule_tac c=blue in  TypingConstConst)
        apply (simp add: Body3_def get_ins_def)  
        apply (rule AL_update5) apply (rule AL_update1) apply simp
        apply (simp add: Body3_def get_ins_def)  
        apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
          apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update1a)
          apply (simp,simp,simp,simp)
          apply (simp,simp,simp,simp)
        apply fastsimp
        apply (simp add: AL_dom_upd1 AL_dom_emp Assum1_def) apply fastsimp
      apply clarsimp
      apply (rule TypingInj)
      apply (rule_tac U="{}" in UniInjectR)
        apply (rule_tac c=black in UniConst)
        apply (simp add: Body3_def get_ins_def)  
        apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
        apply (rule AL_update5) apply (rule AL_update5) 
        apply (rule AL_update1a) 
        apply (simp,simp,simp,simp)
        apply (simp,simp,simp,simp)
        prefer 6 apply fastsimp
        apply (simp add: AL_dom_upd1 AL_dom_emp Assum1_def) apply fastsimp
        apply simp
        apply simp
        apply simp
        apply (simp add: UniCtxtVerified_def)
        (* apply fast *)
      apply clarsimp
      apply (rule TypingInj)
      apply (rule_tac U="{}" in UniInjectR)
        apply (rule UniStore)
        apply (simp add: Body3_def get_ins_def)  
        apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) 
        apply (rule AL_update5) apply (rule AL_update1a) 
        apply (simp,simp,simp,simp) apply (simp,simp,simp,simp) 
        prefer 4 apply fastsimp
        apply simp
        apply simp
        apply (simp add: UniCtxtVerified_def)
        (* apply fast *)
      apply clarsimp
      apply (rule TypingInj)
        apply (rule TypingFrame) (*we use the Frame rule here as a to exploiot extensionality of RDS-components*)
          apply (rule_tac H=emp and N=emp and K=emp in  TypingRetRet)
          apply (simp add: Body3_def get_ins_def)  
            apply (rule AL_update1) 
          apply (simp add: Body3_def get_ins_def)    
            apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
            apply (rule AL_update1a) apply (simp,simp,simp,simp) apply simp
        apply simp
        apply simp
        apply (simp add: RSD_sum_def)
          apply (rule, simp)
          apply (rule, simp)
          apply (rule, simp)
          apply (rule, simp)
          apply (rule, simp)
          apply (rule, simp)
          apply (rule, rule AL_UPD, rule AL_UPD, rule AL_UPD, rule AL_UPD, rule AL_UPD, rule AL_EMP)
          apply (rule, rule AL_sum_emp1)
          apply (rule, rule AL_sum_emp1)
          apply (rule, rule AL_sum_emp1)
          apply (rule, simp add: AL_dom_emp)
          apply (rule, simp add: AL_dom_emp)
          apply (simp add: AL_dom_emp)
        apply (simp add: RSD_sum_def Assum1_def, (erule conjE)+)
          apply (rule, rule AL_UPD, rule AL_UPD, rule AL_UPD, rule AL_UPD, rule AL_UPD, rule AL_EMP)
          apply (rule, rule AL_sum_emp1)
          apply (rule, rule AL_sum_emp1)
          apply (rule, simp add: AL_sum_def)
            apply (rule, simp add: AL_dom_upd1 AL_dom_emp) apply fast
            apply (rule, rule contained_emp)
            apply (simp add: contained_def, clarsimp)
            apply (drule AL_upd_split)
            apply (erule disjE, clarsimp) apply (rule AL_update5a, rule AL_update1) apply assumption
            apply clarsimp
            apply (drule AL_upd_split)
            apply (erule disjE, clarsimp) apply (rule AL_update5a, rule AL_update5a, rule AL_update1) apply assumption apply assumption
            apply clarsimp
            apply (drule AL_upd_split)
            apply (erule disjE, clarsimp) apply (rule AL_update1) 
            apply clarsimp
            apply (drule AL_upd_split)
            apply (erule disjE, clarsimp) apply (rule AL_update5a, rule AL_update5a, rule AL_update5a, rule AL_update1) 
              apply assumption apply assumption apply assumption
            apply clarsimp
            apply (drule AL_upd_split)
            apply (erule disjE, clarsimp) apply (rule AL_update5a, rule AL_update5a, rule AL_update5a, rule AL_update5a, rule AL_update1) 
              apply assumption apply assumption apply assumption apply assumption
            apply (simp add: AL_emp1)
          apply (rule, simp add: AL_dom_emp)
          apply (rule, simp add: AL_dom_emp)
          apply (simp add: AL_dom_emp)
    (*6,6*)
    apply clarsimp
      apply (rule TypingInj)
      apply (rule_tac U="{}" in UniInjectL)
        apply (rule_tac c=black in UniConst)
        apply (simp add: Body3_def get_ins_def)  
        apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) 
        apply (rule AL_update1) 
        apply (simp,simp,simp,simp)
        prefer 6 apply fastsimp
        apply (simp add: AL_dom_upd1 AL_dom_emp Assum1_def) apply fastsimp
        apply simp
        apply simp
        apply simp
        apply (simp add: UniCtxtVerified_def)
        (* apply fast *)
      apply clarsimp
      apply (rule TypingInj)
      apply (rule_tac U="{}" in UniInjectR)
        apply (rule_tac c=white in UniConst)
        apply (simp add: Body3_def get_ins_def)  
        apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
        apply (rule AL_update1) 
        apply (simp,simp,simp,simp)
        prefer 6 apply fastsimp
        apply (simp add: AL_dom_upd1 AL_dom_emp Assum1_def) apply fastsimp
        apply simp
        apply simp
        apply simp
        apply (simp add: UniCtxtVerified_def)
        (* apply fast *)
      apply clarsimp
      apply (rule TypingInj)
      apply (rule_tac U="{}" in UniInjectL)
        apply (rule UniStore)
        apply (simp add: Body3_def get_ins_def)  
        apply (rule AL_update5) apply (rule AL_update5) 
        apply (rule AL_update1) 
        apply (simp,simp,simp,simp)
        prefer 4 apply fastsimp
        apply simp
        apply simp
        apply (simp add: UniCtxtVerified_def)
        (* apply fast *)
      apply clarsimp
      apply (rule TypingInj)
      apply (rule_tac U="{}" in UniInjectR)
        apply (rule UniStore)
        apply (simp add: Body3_def get_ins_def)  
        apply (rule AL_update5) apply (rule AL_update5) 
        apply (rule AL_update1) 
        apply (simp,simp,simp,simp)
        prefer 4 apply fastsimp
        apply simp
        apply simp
        apply (simp add: UniCtxtVerified_def)
        (* apply fast *)
      apply clarsimp
      apply (rule TypingInj)
      apply (rule_tac c=blue in  TypingConstConst)
        apply (simp add: Body3_def get_ins_def)  
        apply (rule AL_update5) apply (rule AL_update1) apply simp
        apply (simp add: Body3_def get_ins_def)  
        apply (rule AL_update5) apply (rule AL_update1) apply simp
        apply fastsimp
        apply (simp add: AL_dom_upd1 AL_dom_emp Assum1_def) apply fastsimp
      apply clarsimp
      apply (rule TypingInj)
        apply (rule TypingFrame) (*we use the Frame rule here as a to exploiot extensionality of RDS-components*)
          apply (rule_tac H=emp and N=emp and K=emp in  TypingRetRet)
          apply (simp add: Body3_def get_ins_def)  
            apply (rule AL_update1) 
          apply (simp add: Body3_def get_ins_def)    
            apply (rule AL_update1) 
        apply simp
        apply simp
        apply (simp add: RSD_sum_def)
          apply (rule, simp)
          apply (rule, simp)
          apply (rule, simp)
          apply (rule, simp)
          apply (rule, simp)
          apply (rule, simp)
          apply (rule, rule AL_UPD, rule AL_UPD, rule AL_UPD, rule AL_UPD, rule AL_UPD, rule AL_EMP)
          apply (rule, rule AL_sum_emp1)
          apply (rule, rule AL_sum_emp1)
          apply (rule, rule AL_sum_emp1)
          apply (rule, simp add: AL_dom_emp)
          apply (rule, simp add: AL_dom_emp)
          apply (simp add: AL_dom_emp)
        apply (simp add: RSD_sum_def Assum1_def, (erule conjE)+)
          apply (rule, rule AL_UPD, rule AL_UPD, rule AL_UPD, rule AL_UPD, rule AL_UPD, rule AL_EMP)
          apply (rule, rule AL_sum_emp1)
          apply (rule, rule AL_sum_emp1)
          apply (rule, simp add: AL_sum_def)
            apply (rule, simp add: AL_dom_upd1 AL_dom_emp) apply fast
            apply (rule, rule contained_emp)
            apply (simp add: contained_def, clarsimp)
            apply (drule AL_upd_split)
            apply (erule disjE, clarsimp) apply (rule AL_update5a, rule AL_update5a, rule AL_update1) apply assumption apply assumption
            apply clarsimp
            apply (drule AL_upd_split)
            apply (erule disjE, clarsimp) apply (rule AL_update1) 
            apply clarsimp
            apply (drule AL_upd_split)
            apply (erule disjE, clarsimp) apply (rule AL_update5a, rule AL_update1) apply assumption
            apply clarsimp
            apply (drule AL_upd_split)
            apply (erule disjE, clarsimp) apply (rule AL_update5a, rule AL_update5a, rule AL_update5a, rule AL_update1) 
              apply assumption apply assumption apply assumption
            apply clarsimp
            apply (drule AL_upd_split)
            apply (erule disjE, clarsimp) apply (rule AL_update5a, rule AL_update5a, rule AL_update5a, rule AL_update5a, rule AL_update1) 
              apply assumption apply assumption apply assumption apply assumption
            apply (simp add: AL_emp1)
          apply (rule, simp add: AL_dom_emp)
          apply (rule, simp add: AL_dom_emp)
          apply (simp add: AL_dom_emp)
done

constdefs Body4:: Mbody
"Body4 \<equiv> ([],upd(upd(upd(upd(upd(upd(upd(upd emp
                    0 (const (IVal 2)))
                    1 (load h))
                    2 (iftrue 5))
                    3 dup)
                    4 vreturn)
                    5 (store h))
                    6 (load h))
                    7 vreturn,0)"

constdefs Class4::Classdef
"Class4 \<equiv> emp[M \<mapsto> (Body4)]"

constdefs Prog4::Prog
"Prog4 \<equiv> emp[C \<mapsto> Class4]"

constdefs AssumProg4::"RSD \<Rightarrow> HP \<Rightarrow> HP \<Rightarrow> bool"
"AssumProg4 \<delta> H K \<equiv> distinct [green,red,blue,black,white] \<and> distinct [l,h] \<and>
           \<delta> = (([blue], emp, H),
         emp[green\<mapsto>intTP][red\<mapsto>intTP][blue\<mapsto>intTP], [blue], emp,
         K)"

lemma "\<lbrakk>AssumProg4 \<delta> H K; H \<in> AL; K \<in> AL\<rbrakk> \<Longrightarrow> ({}, \<phi> H K, Body4, 0, Body4, 0, False, \<delta>):Typing"
apply (simp add: \<phi>_def)
      apply (rule_tac c=blue in  TypingConstConst)
        apply (simp add: Body4_def get_ins_def)  
        apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
          apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update1)
          apply (simp,simp,simp,simp)
          apply (simp,simp,simp)
        apply (simp add: Body4_def get_ins_def)  
        apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
          apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update1)
          apply (simp,simp,simp,simp)
          apply (simp,simp,simp)
        apply fastsimp
        apply (simp add: AL_dom_upd1 AL_dom_emp AssumProg4_def) apply fastsimp
      apply clarsimp
      apply (rule TypingInj)
apply (rule_tac U="{}" in UniInjectL)
  apply (rule UniLoad)
  apply (simp add: Body4_def get_ins_def)  
  apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
  apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update1a) 
  apply (simp,simp,simp,simp)
  apply (simp,simp,simp)
  apply simp
  prefer 6 apply fastsimp
  apply (rule AL_update1) 
  apply simp
  apply simp
  apply simp
  apply (simp add: UniCtxtVerified_def)
  (* apply fast *)
apply clarsimp
apply (rule TypingInj)
apply (rule_tac U="{}" in UniInjectR)
  apply (rule UniLoad)
  apply (simp add: Body4_def get_ins_def)  
  apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
  apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update1a) 
  apply (simp,simp,simp,simp)
  apply (simp,simp,simp,simp)
  prefer 6 apply fastsimp
  apply (rule AL_update1) 
  apply simp
  apply simp
  apply simp
  apply (simp add: UniCtxtVerified_def)
  (* apply fast *)
apply clarsimp
apply (rule TypingInj)
apply (rule_tac U="{}" in UniInjectL)
  apply (rule UniIf)
  apply (simp add: Body4_def get_ins_def)  
  apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
  apply (rule AL_update5) 
  apply (rule AL_update1a) 
  apply (simp,simp,simp,simp)
  apply (simp,simp,simp,simp)
  apply simp
  apply simp
  apply (simp add: UniCtxtVerified_def)
  apply fastsimp
  (* apply fast *)
apply clarsimp
apply rule apply clarsimp
  (*3,2*)
    apply (rule TypingInj)
    apply (rule_tac U="{}" in UniInjectR)
      apply (rule UniIf)
      apply (simp add: Body4_def get_ins_def)  
      apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
      apply (rule AL_update5) 
      apply (rule AL_update1a) 
      apply (simp,simp,simp,simp)
      apply (simp,simp,simp,simp)
      apply simp
      apply simp
      apply (simp add: UniCtxtVerified_def)
      apply fastsimp
      (* apply fast *)
    apply clarsimp
    apply rule apply clarsimp
    (*3,3*)
      apply (rule TypingInj)
      apply (rule_tac U="{}" in UniInjectL)
        apply (rule UniDup)
        apply (simp add: Body4_def get_ins_def)  
        apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
        apply (rule AL_update1a) 
        apply (simp,simp,simp,simp)
        apply simp
        prefer 6 apply fastsimp
        apply (simp add: AL_dom_upd1 AL_dom_emp AssumProg4_def) apply fastsimp
        apply simp
        apply simp
        apply simp
        apply (simp add: UniCtxtVerified_def)
        (* apply fast *)
      apply clarsimp
      apply (rule TypingInj)
      apply (rule_tac U="{}" in UniInjectR)
        apply (rule UniDup)
        apply (simp add: Body4_def get_ins_def)  
        apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
        apply (rule AL_update1a) 
        apply (simp,simp,simp,simp)
        apply simp
        prefer 6 apply fastsimp
        apply (simp add: AL_dom_upd1 AL_dom_emp AssumProg4_def) apply fastsimp
        apply simp
        apply simp
        apply simp
        apply (simp add: UniCtxtVerified_def)
        (* apply fast *)
      apply clarsimp
      apply (rule TypingInj)
        apply (rule TypingRetRet)
        apply (simp add: Body4_def get_ins_def)    
          apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) 
          apply (rule AL_update1a) apply (simp,simp,simp,simp) 
        apply (simp add: Body4_def get_ins_def)  
          apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) 
          apply (rule AL_update1a) apply (simp,simp,simp,simp) 
        apply fastsimp
      apply (simp add: AssumProg4_def) 
    (*3,5*)
    apply clarsimp
      apply (rule TypingInj)
      apply (rule_tac U="{}" in UniInjectL)
        apply (rule UniDup)
        apply (simp add: Body4_def get_ins_def)  
        apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
        apply (rule AL_update1a) 
        apply (simp,simp,simp,simp)
        apply simp
        apply simp
        prefer 5 apply fastsimp
        apply simp
        apply simp
        apply simp
        apply (simp add: UniCtxtVerified_def)
        (* apply fast *)
      apply clarsimp
      apply (rule TypingInj)
      apply (rule_tac U="{}" in UniInjectR)
        apply (rule UniStore)
        apply (simp add: Body4_def get_ins_def)  
        apply (rule AL_update5) apply (rule AL_update5)
        apply (rule AL_update1) 
        apply (simp,simp,simp)
        apply simp
        prefer 4 apply fastsimp
        apply simp
        apply simp
        apply (simp add: UniCtxtVerified_def)
        (* apply fast *)
      apply clarsimp
      apply (rule TypingInj)
      apply (rule_tac U="{}" in UniInjectR)
        apply (rule UniLoad)
        apply (simp add: Body4_def get_ins_def)  
        apply (rule AL_update5) apply (rule AL_update1a)
          apply (simp,simp)
          apply simp
          prefer 6 apply fastsimp
          apply (rule AL_update1)
        apply simp
        apply simp
        apply simp
        apply (simp add: UniCtxtVerified_def)
        (* apply fast *)
      apply clarsimp
      apply (rule TypingInj)
          apply (rule TypingRetRet)
          apply (simp add: Body4_def get_ins_def) 
            apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) 
            apply (rule AL_update1a) apply (simp,simp,simp,simp) 
          apply (simp add: Body4_def get_ins_def)  
            apply (rule AL_update1) 
        apply fastsimp
        apply (simp add: AssumProg4_def)
  apply clarsimp
  (*5,2*)
    apply (rule TypingInj)
    apply (rule_tac U="{}" in UniInjectR)
      apply (rule UniIf)
      apply (simp add: Body4_def get_ins_def)  
      apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
      apply (rule AL_update5) 
      apply (rule AL_update1a) 
      apply (simp,simp,simp,simp)
      apply (simp,simp,simp,simp)
      apply simp
      apply simp
      apply (simp add: UniCtxtVerified_def)
      apply fastsimp
      (* apply fast *)
    apply clarsimp
    apply rule
    (*5,3*)    
      apply clarsimp
      apply (rule TypingInj)
      apply (rule_tac U="{}" in UniInjectR)
        apply (rule UniDup)
        apply (simp add: Body4_def get_ins_def)  
        apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
        apply (rule AL_update1a) 
        apply (simp,simp,simp,simp)
        apply simp
        apply simp
        prefer 5 apply fastsimp
        apply simp
        apply simp
        apply simp
        apply (simp add: UniCtxtVerified_def)
        (* apply fast *)
      apply clarsimp
      apply (rule TypingInj)
      apply (rule_tac U="{}" in UniInjectL)
        apply (rule UniStore)
        apply (simp add: Body4_def get_ins_def)  
        apply (rule AL_update5) apply (rule AL_update5)
        apply (rule AL_update1) 
        apply (simp,simp,simp)
        apply simp
        prefer 4 apply fastsimp
        apply simp
        apply simp
        apply (simp add: UniCtxtVerified_def)
        (* apply fast *)
      apply clarsimp
      apply (rule TypingInj)
      apply (rule_tac U="{}" in UniInjectL)
        apply (rule UniLoad)
        apply (simp add: Body4_def get_ins_def)  
        apply (rule AL_update5) apply (rule AL_update1a)
          apply (simp,simp)
          apply simp
          prefer 6 apply fastsimp
          apply (rule AL_update1)
        apply simp
        apply simp
        apply simp
        apply (simp add: UniCtxtVerified_def)
        (* apply fast *)
      apply clarsimp
      apply (rule TypingInj)
          apply (rule TypingRetRet)
          apply (simp add: Body4_def get_ins_def)  
            apply (rule AL_update1) 
          apply (simp add: Body4_def get_ins_def) 
            apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) 
            apply (rule AL_update1a) apply (simp,simp,simp,simp) 
        apply fastsimp
        apply (simp add: AssumProg4_def)
    (*5,5*)
    apply clarsimp
      apply (rule TypingInj)
      apply (rule_tac U="{}" in UniInjectL)
        apply (rule UniStore)
        apply (simp add: Body4_def get_ins_def)  
        apply (rule AL_update5) apply (rule AL_update5)
        apply (rule AL_update1) 
        apply (simp,simp,simp)
        apply simp
        prefer 4 apply fastsimp
        apply simp
        apply simp
        apply (simp add: UniCtxtVerified_def)
        (* apply fast *)
      apply clarsimp
      apply (rule TypingInj)
      apply (rule_tac U="{}" in UniInjectL)
        apply (rule UniLoad)
        apply (simp add: Body4_def get_ins_def)  
        apply (rule AL_update5) apply (rule AL_update1a)
          apply (simp,simp)
          apply simp
          prefer 6 apply fastsimp
          apply (rule AL_update1)
        apply simp
        apply simp
        apply simp
        apply (simp add: UniCtxtVerified_def)
        (* apply fast *)
      apply clarsimp
      apply (rule TypingInj)
      apply (rule_tac U="{}" in UniInjectR)
        apply (rule UniStore)
        apply (simp add: Body4_def get_ins_def)  
        apply (rule AL_update5) apply (rule AL_update5)
        apply (rule AL_update1) 
        apply (simp,simp,simp)
        apply simp
        prefer 4 apply fastsimp
        apply simp
        apply simp
        apply (simp add: UniCtxtVerified_def)
        (* apply fast *)
      apply clarsimp
      apply (rule TypingInj)
      apply (rule_tac U="{}" in UniInjectR)
        apply (rule UniLoad)
        apply (simp add: Body4_def get_ins_def)  
        apply (rule AL_update5) apply (rule AL_update1a)
          apply (simp,simp)
          apply simp
          prefer 6 apply fastsimp
          apply (rule AL_update1)
        apply simp
        apply simp
        apply simp
        apply (simp add: UniCtxtVerified_def)
        (* apply fast *)
      apply clarsimp
      apply (rule TypingInj)
          apply (rule TypingRetRet)
          apply (simp add: Body4_def get_ins_def) 
            apply (rule AL_update1) 
          apply (simp add: Body4_def get_ins_def)  
            apply (rule AL_update1) 
        apply fastsimp
        apply (simp add: AssumProg4_def)
done

constdefs Body5:: Mbody
"Body5 \<equiv> ([],upd(upd(upd(upd(upd(upd(upd emp
                    0 (load h))
                    1 (iftrue 5))
                    2 (const (IVal 2)))
                    3 dup)
                    4 vreturn)
                    5 (const (IVal 2)))
                    6 vreturn,0)"

constdefs Class5::Classdef
"Class5 \<equiv> emp[M \<mapsto> (Body5)]"

constdefs Prog5::Prog
"Prog5 \<equiv> emp[C \<mapsto> Class5]"

lemma "\<lbrakk>AssumProg4 \<delta> H K; H \<in> AL; K \<in> AL\<rbrakk> \<Longrightarrow> ({}, \<phi> H K, Body5, 0, Body5, 0, False, \<delta>):Typing"
apply (simp add: \<phi>_def)
apply (rule_tac U="{}" in UniInjectL)
  apply (rule UniLoad)
  apply (simp add: Body5_def get_ins_def)  
  apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
  apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update1) 
  apply (simp,simp,simp,simp)
  apply (simp,simp)
  apply simp
  prefer 6 apply fastsimp
  apply (rule AL_update1) 
  apply simp
  apply simp
  apply simp
  apply (simp add: UniCtxtVerified_def)
  (* apply fast *)
apply clarsimp
apply (rule TypingInj)
apply (rule_tac U="{}" in UniInjectR)
  apply (rule UniLoad)
  apply (simp add: Body5_def get_ins_def)  
  apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
  apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update1) 
  apply (simp,simp,simp,simp)
  apply (simp,simp)
  apply simp
  prefer 6 apply fastsimp
  apply (rule AL_update1) 
  apply simp
  apply simp
  apply simp
  apply (simp add: UniCtxtVerified_def)
  (* apply fast *)
apply clarsimp
apply (rule TypingInj)
apply (rule_tac U="{}" in UniInjectL)
  apply (rule UniIf)
  apply (simp add: Body5_def get_ins_def)  
  apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
  apply (rule AL_update5) apply (rule AL_update1a)
  apply (simp,simp,simp,simp)
  apply (simp,simp)
  apply simp
  apply simp
  prefer 4 apply fastsimp
  apply simp
  apply simp
  apply (simp add: UniCtxtVerified_def)
  (* apply fast *)
apply clarsimp
apply rule apply clarsimp
  (*2,1*)
    apply (rule TypingInj)
    apply (rule_tac U="{}" in UniInjectR)
      apply (rule UniIf)
      apply (simp add: Body5_def get_ins_def)  
      apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
      apply (rule AL_update5) apply (rule AL_update1a) 
      apply (simp,simp,simp,simp)
      apply (simp,simp,simp,simp)
      prefer 4 apply fastsimp
      apply simp
      apply simp
      apply (simp add: UniCtxtVerified_def)
      (* apply fast *)
    apply clarsimp
    apply rule apply clarsimp
    (*2,2*)
      apply (rule TypingInj)
      apply (rule_tac c=blue in  TypingConstConst)
        apply (simp add: Body5_def get_ins_def)  
        apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
          apply (rule AL_update1a) 
          apply (simp,simp,simp,simp) apply simp
        apply (simp add: Body5_def get_ins_def)  
        apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
          apply (rule AL_update1a) 
          apply (simp,simp,simp,simp) apply simp
        apply fastsimp
        apply (simp add: AL_dom_upd1 AL_dom_emp AssumProg4_def) apply fastsimp
      apply clarsimp
      apply (rule TypingInj)
      apply (rule_tac U="{}" in UniInjectL)
        apply (rule UniDup)
        apply (simp add: Body5_def get_ins_def)  
        apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) 
        apply (rule AL_update1a) 
        apply (simp,simp,simp,simp)
        prefer 6 apply fastsimp
        apply fastsimp
        apply simp
        apply simp
        apply simp
        apply (simp add: UniCtxtVerified_def)
        (* apply fast *)
      apply clarsimp
      apply (rule TypingInj)
      apply (rule_tac U="{}" in UniInjectR)
        apply (rule UniDup)
        apply (simp add: Body5_def get_ins_def)  
        apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) 
        apply (rule AL_update1a) 
        apply (simp,simp,simp,simp)
        prefer 6 apply fastsimp
        apply fastsimp
        apply simp
        apply simp
        apply simp
        apply (simp add: UniCtxtVerified_def)
        (* apply fast *)
      apply clarsimp
      apply (rule TypingInj)
        apply (rule TypingRetRet)
        apply (simp add: Body5_def get_ins_def)    
          apply (rule AL_update5) apply (rule AL_update5) 
          apply (rule AL_update1a) apply (simp,simp,simp) 
        apply (simp add: Body5_def get_ins_def)  
          apply (rule AL_update5) apply (rule AL_update5) 
          apply (rule AL_update1a) apply (simp,simp,simp) 
        apply fastsimp
      apply (simp add: AssumProg4_def)
    (*2,5*)
    apply clarsimp
      apply (rule TypingInj)
      apply (rule_tac c=blue in  TypingConstConst)
        apply (simp add: Body5_def get_ins_def)  
        apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
          apply (rule AL_update1a) 
          apply (simp,simp,simp,simp) apply simp
        apply (simp add: Body5_def get_ins_def)  
        apply (rule AL_update5) 
          apply (rule AL_update1) 
          apply simp
        apply fastsimp
        apply (simp add: AL_dom_upd1 AL_dom_emp AssumProg4_def) apply fastsimp
      apply clarsimp
      apply (rule TypingInj)
      apply (rule_tac U="{}" in UniInjectL)
        apply (rule UniDup)
        apply (simp add: Body5_def get_ins_def)  
        apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) 
        apply (rule AL_update1a) 
        apply (simp,simp,simp,simp)
        prefer 6 apply fastsimp
        apply fastsimp
        apply simp
        apply simp
        apply simp
        apply (simp add: UniCtxtVerified_def)
        (* apply fast *)
      apply clarsimp
      apply (rule TypingInj)
        apply (rule TypingRetRet)
        apply (simp add: Body5_def get_ins_def)    
          apply (rule AL_update5) apply (rule AL_update5) 
          apply (rule AL_update1a) apply (simp,simp,simp) 
        apply (simp add: Body5_def get_ins_def)  
          apply (rule AL_update1) 
        apply fastsimp
      apply (simp add: AssumProg4_def)
  (*5,1*)
  apply clarsimp
    apply (rule TypingInj)
    apply (rule_tac U="{}" in UniInjectR)
      apply (rule UniIf)
      apply (simp add: Body5_def get_ins_def)  
      apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
      apply (rule AL_update5) 
      apply (rule AL_update1) 
      apply (simp,simp,simp,simp)
      apply (simp,simp,simp,simp)
      apply simp
      apply (simp add: UniCtxtVerified_def)
      apply fastsimp
      (* apply fast *)
    apply clarsimp
    apply rule
    (*5,2*)    
      apply clarsimp
      apply (rule TypingInj)
      apply (rule_tac c=blue in  TypingConstConst)
        apply (simp add: Body5_def get_ins_def)  
        apply (rule AL_update5) 
          apply (rule AL_update1) 
          apply simp
        apply (simp add: Body5_def get_ins_def)  
        apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
          apply (rule AL_update1a) 
          apply (simp,simp,simp,simp) apply simp
        apply fastsimp
        apply (simp add: AL_dom_upd1 AL_dom_emp AssumProg4_def) apply fastsimp
      apply clarsimp
      apply (rule TypingInj)
      apply (rule_tac U="{}" in UniInjectR)
        apply (rule UniDup)
        apply (simp add: Body5_def get_ins_def)  
        apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) 
        apply (rule AL_update1a) 
        apply (simp,simp,simp,simp)
        prefer 6 apply fastsimp
        apply fastsimp
        apply simp
        apply simp
        apply simp
        apply (simp add: UniCtxtVerified_def)
        (* apply fast *)
      apply clarsimp
      apply (rule TypingInj)
        apply (rule TypingRetRet)
        apply (simp add: Body5_def get_ins_def)  
          apply (rule AL_update1) 
        apply (simp add: Body5_def get_ins_def)    
          apply (rule AL_update5) apply (rule AL_update5) 
          apply (rule AL_update1a) apply (simp,simp,simp) 
        apply fastsimp
      apply (simp add: AssumProg4_def)
    (*5,5*)
    apply clarsimp
      apply (rule TypingInj)
      apply (rule_tac c=blue in  TypingConstConst)
        apply (simp add: Body5_def get_ins_def)  
        apply (rule AL_update5) 
          apply (rule AL_update1) 
          apply simp
        apply (simp add: Body5_def get_ins_def)  
        apply (rule AL_update5) 
          apply (rule AL_update1) 
          apply simp
        apply fastsimp
        apply (simp add: AL_dom_upd1 AL_dom_emp AssumProg4_def) apply fastsimp
      apply clarsimp
      apply (rule TypingInj)
        apply (rule TypingRetRet)
        apply (simp add: Body5_def get_ins_def)  
          apply (rule AL_update1) 
        apply (simp add: Body5_def get_ins_def)    
          apply (rule AL_update1) 
        apply fastsimp
      apply (simp add: AssumProg4_def)
done

subsubsection{*Tracking the flow of values through (private) objects
(the example from Section 5.3)*}

consts z::Var

constdefs BodyPrivObjects:: Mbody
"BodyPrivObjects \<equiv> ([],upd(upd(upd(upd(upd(upd(upd(upd(upd(upd(upd(upd(upd(upd emp
                    0 (load l))
                    1 (store x))
                    2 (load h))
                    3 (iftrue 6))
                    4 (load x))
                    5 vreturn)
                    6 (new C))
                    7 (store z))
                    8 (load z))
                    9 (load l))
                    10 (putfield C F))
                    11 (load z))
                    12 (getfield C F))
                    13 vreturn,0)"

constdefs ClassPrivObjects::Classdef
"ClassPrivObjects \<equiv> emp[M \<mapsto> (BodyPrivObjects)]"

constdefs ProgPrivObjects::Prog
"ProgPrivObjects \<equiv> emp[C \<mapsto> ClassPrivObjects]"

constdefs \<phi>53 ::RSD
"\<phi>53 \<equiv> ( ([],upd(upd emp h green) l blue,emp),
                 upd(upd(upd emp green intTP) red intTP) blue intTP,
                 ([],upd(upd emp h red) l blue,emp))"

constdefs AssumPrivObjects::"RSD \<Rightarrow> bool"
"AssumPrivObjects \<delta> \<equiv> distinct [green,red,blue,black,white,yellow] \<and> distinct [l,h,x,z] 
          \<and> \<delta> = (([blue], emp, emp), emp[green\<mapsto>intTP][red\<mapsto>intTP][blue\<mapsto>intTP], ([blue], emp, emp))"

lemma "AssumPrivObjects \<delta> \<Longrightarrow> ({}, \<phi>53, BodyPrivObjects, 0, BodyPrivObjects, 0, False, \<delta>):Typing"
apply (simp add: \<phi>53_def)
apply (rule_tac U="{}" in UniInjectL)
  apply (rule UniLoad)
  apply (simp add: BodyPrivObjects_def get_ins_def)  
  apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
  apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
  apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
  apply (rule AL_update5) 
  apply (rule AL_update1) 
  apply (simp,simp,simp,simp)
  apply (simp,simp,simp,simp)
  apply (simp,simp,simp,simp)
  apply (simp,simp)
  prefer 6 apply fastsimp
  apply (rule AL_update1) 
  apply simp
  apply simp
  apply simp
  apply (simp add: UniCtxtVerified_def)
  (* apply fast *)
apply clarsimp
apply (rule TypingInj)
apply (rule_tac U="{}" in UniInjectL)
  apply (rule UniStore)
  apply (simp add: BodyPrivObjects_def get_ins_def)  
  apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
  apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
  apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
  apply (rule AL_update1) 
  apply (simp,simp,simp,simp)
  apply (simp,simp,simp,simp)
  apply (simp,simp,simp,simp)
  apply simp
  apply simp
  apply simp
  apply simp
  apply (simp add: UniCtxtVerified_def)
  apply fastsimp
  (* apply fast *)
apply clarsimp
apply (rule TypingInj)
apply (rule_tac U="{}" in UniInjectL)
  apply (rule UniLoad)
  apply (simp add: BodyPrivObjects_def get_ins_def)  
  apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
  apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
  apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) 
  apply (rule AL_update1a) 
  apply (simp,simp,simp,simp)
  apply (simp,simp,simp,simp)
  apply (simp,simp,simp,simp)
  apply simp
  prefer 6 apply fastsimp
  apply (rule AL_update5, rule AL_update5, rule AL_update1) 
    apply (simp add: AssumPrivObjects_def)
    apply (simp add: AssumPrivObjects_def) apply fastsimp
  apply simp
  apply simp
  apply simp
  apply (simp add: UniCtxtVerified_def)
  (* apply fast *)
apply clarsimp
apply (rule TypingInj)
apply (rule_tac U="{}" in UniInjectR)
  apply (rule UniLoad)
  apply (simp add: BodyPrivObjects_def get_ins_def)  
  apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
  apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
  apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
  apply (rule AL_update5) 
  apply (rule AL_update1) 
  apply (simp,simp,simp,simp)
  apply (simp,simp,simp,simp)
  apply (simp,simp,simp,simp)
  apply (simp,simp)
  prefer 6 apply fastsimp
  apply (rule AL_update1) 
  apply simp
  apply simp
  apply simp
  apply (simp add: UniCtxtVerified_def)
  (* apply fast *)
apply clarsimp
apply (rule TypingInj)
apply (rule_tac U="{}" in UniInjectR)
  apply (rule UniStore)
  apply (simp add: BodyPrivObjects_def get_ins_def)  
  apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
  apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
  apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
  apply (rule AL_update1) 
  apply (simp,simp,simp,simp)
  apply (simp,simp,simp,simp)
  apply (simp,simp,simp,simp)
  apply simp
  apply simp
  apply simp
  apply simp
  apply (simp add: UniCtxtVerified_def)
  apply fastsimp
  (* apply fast *)
apply clarsimp
apply (rule TypingInj)
apply (rule_tac U="{}" in UniInjectR)
  apply (rule UniLoad)
  apply (simp add: BodyPrivObjects_def get_ins_def)  
  apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
  apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
  apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) 
  apply (rule AL_update1a) 
  apply (simp,simp,simp,simp)
  apply (simp,simp,simp,simp)
  apply (simp,simp,simp,simp)
  apply simp
  prefer 6 apply fastsimp
  apply (rule AL_update5, rule AL_update5, rule AL_update1) 
    apply (simp add: AssumPrivObjects_def)
    apply (simp add: AssumPrivObjects_def) apply fastsimp
  apply simp
  apply simp
  apply simp
  apply (simp add: UniCtxtVerified_def)
  (* apply fast *)
apply clarsimp
apply (rule TypingInj)
apply (rule_tac U="{}" in UniInjectL)
  apply (rule UniIf)
  apply (simp add: BodyPrivObjects_def get_ins_def)  
  apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
  apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) 
  apply (rule AL_update5) apply (rule AL_update5) 
  apply (rule AL_update1a) 
  apply (simp,simp,simp,simp)
  apply (simp,simp,simp,simp)
  apply (simp,simp,simp)
  apply simp
  apply simp
  apply simp
  apply simp
  apply (simp add: UniCtxtVerified_def)
  apply fastsimp
  (* apply fast *)
apply clarsimp
apply rule
  apply clarsimp
  (*4,3*)
    apply (rule TypingInj)
    apply (rule_tac U="{}" in UniInjectR)
      apply (rule UniIf)
      apply (simp add: BodyPrivObjects_def get_ins_def)  
      apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
      apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) 
      apply (rule AL_update5) apply (rule AL_update5) 
      apply (rule AL_update1a) 
      apply (simp,simp,simp,simp)
      apply (simp,simp,simp,simp)
      apply (simp,simp,simp)
      apply simp
      apply simp
      apply simp
      apply simp
      apply (simp add: UniCtxtVerified_def)
      apply fastsimp
      (* apply fast *)
    apply clarsimp
    apply rule
    apply clarsimp
    (*4,4*)
      apply (rule TypingInj)
      apply (rule_tac U="{}" in UniInjectL)
        apply (rule UniLoad)
        apply (simp add: BodyPrivObjects_def get_ins_def)  
        apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) 
        apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) 
        apply (rule AL_update1a) 
        apply (simp,simp,simp,simp)
        apply (simp,simp,simp,simp)
        apply (simp,simp)
        apply simp
        prefer 6 apply fastsimp
        apply (rule AL_update1) 
        apply simp
        apply simp
        apply simp
        apply (simp add: UniCtxtVerified_def)
        (* apply fast *)
      apply clarsimp
      apply (rule TypingInj)
      apply (rule_tac U="{}" in UniInjectR)
        apply (rule UniLoad)
        apply (simp add: BodyPrivObjects_def get_ins_def) 
        apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) 
        apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) 
        apply (rule AL_update1a) 
        apply (simp,simp,simp,simp)
        apply (simp,simp,simp,simp)
        apply (simp,simp) 
        apply simp
        prefer 6 apply fastsimp
        apply (rule AL_update1) 
        apply simp
        apply simp
        apply simp
        apply (simp add: UniCtxtVerified_def)
        (* apply fast *)
      apply clarsimp
      apply (rule TypingInj)
        apply (rule TypingRetRet)
        apply (simp add: BodyPrivObjects_def get_ins_def) 
        apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) 
        apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) 
        apply (rule AL_update1a) 
        apply (simp,simp,simp,simp)
        apply (simp,simp,simp,simp)
        apply simp
        apply (simp add: BodyPrivObjects_def get_ins_def)  
        apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) 
        apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) 
        apply (rule AL_update1a) 
        apply (simp,simp,simp,simp)
        apply (simp,simp,simp,simp)
        apply simp
        apply fastsimp
      apply (simp add: AssumPrivObjects_def)
    (*4,6*)
    apply clarsimp
      apply (rule TypingInj)
      apply (rule_tac U="{}" and V="{}" and 
                     N''="emp[green\<mapsto>intTP][red\<mapsto>intTP][blue\<mapsto>intTP]" in TypingUniRetRet)
      prefer 2 apply (simp add: UniCtxtVerified_def)
      prefer 3 apply (simp add: UniCtxtVerified_def)
      prefer 3 apply fastsimp
      prefer 3 apply (simp add: AssumPrivObjects_def) apply fastsimp
      apply (rule UniRun)
        apply (rule UniLoad)
        apply (simp add: BodyPrivObjects_def get_ins_def)
        apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
        apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)   
        apply (rule AL_update1a) 
        apply (simp,simp,simp,simp)
        apply (simp,simp,simp,simp)
        apply (simp,simp)
        apply fastsimp
        apply (rule AL_update1)
        apply simp
        apply simp
        apply simp
        (* apply fast *)
      apply clarsimp
      apply (rule UniInj)
      apply (rule UniVret)
        apply (simp add: BodyPrivObjects_def get_ins_def)  
        apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
        apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
        apply (rule AL_update1a) 
        apply (simp,simp,simp,simp)
        apply (simp,simp,simp,simp)
        apply simp
        apply fastsimp
        apply simp
      apply (rule_tac d=black in UniBS_StaticGarbageColour)
      prefer 2  apply (simp add: DOM_def AssumPrivObjects_def AL_cod_emp AL_dom_emp AbsFields_emp)  apply fastsimp
      prefer 3 apply (simp add:DOM_def  AL_dom_upd1 AL_dom_emp AbsFields_emp AssumPrivObjects_def) apply clarsimp 
               apply (drule SetTriv, rule  AL_cod_upd1) apply clarsimp apply (erule disjE, simp) 
               apply (drule SetTriv, rule  AL_cod_upd1) apply clarsimp apply (erule disjE, simp) 
               apply (drule SetTriv, rule  AL_cod_upd1) apply clarsimp apply (erule disjE, simp) apply (simp add: AL_cod_emp)
      apply (rule_tac d=black in UniBS_StaticGarbageHP)
        prefer 5 apply (simp add:DOM_def  AL_dom_upd1 AL_dom_emp AbsFields_emp AssumPrivObjects_def) apply clarsimp 
                 apply (drule SetTriv, rule  AL_cod_upd1) apply clarsimp apply (erule disjE, simp) 
               apply (drule SetTriv, rule  AL_cod_upd1) apply clarsimp apply (erule disjE, simp) 
               apply (drule SetTriv, rule  AL_cod_upd1) apply clarsimp apply (erule disjE, simp) apply (simp add: AL_cod_emp) 
        prefer 5 apply (simp add: AL_dom_upd1 AL_dom_emp AssumPrivObjects_def) apply fastsimp
      apply (rule UniRun)
        apply (rule_tac cl=black and D=C in UniNew)
        apply (simp add: BodyPrivObjects_def get_ins_def)  
        apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
        apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) 
        apply (rule AL_update1) 
        apply (simp,simp,simp,simp)
        apply (simp,simp,simp)
        apply fastsimp
        apply (simp add: AL_dom_upd1 AL_dom_emp AssumPrivObjects_def) apply fastsimp
        apply simp
        apply (simp add: subclass_of_refl)
        apply simp
        apply simp
        (* apply fast *)
      apply clarsimp
      apply (rule UniInj)
        apply (rule UniRun)
          apply (rule UniStore)
          apply (simp add: BodyPrivObjects_def get_ins_def)  
          apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
          apply (rule AL_update5) apply (rule AL_update5) 
          apply (rule AL_update1) 
          apply (simp,simp,simp,simp)
          apply (simp,simp)
          apply fastsimp
          apply simp
          apply simp
          apply simp
          (* apply fast *)
        apply clarsimp
        apply (rule UniInj)
        apply (rule UniRun)
          apply (rule UniLoad)
          apply (simp add: BodyPrivObjects_def get_ins_def)
          apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
          apply (rule AL_update1) 
          apply (simp,simp,simp,simp)
          apply simp
          apply fastsimp
          apply (rule AL_update1) 
          apply simp
          apply simp
          apply simp
          (* apply fast *)
      apply clarsimp
      apply (rule UniInj)
      apply (rule UniRun)
        apply (rule UniLoad)
        apply (simp add: BodyPrivObjects_def get_ins_def)
        apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) 
        apply (rule AL_update1) 
        apply (simp,simp,simp,simp)
        apply fastsimp
        apply (rule AL_update5, rule AL_update5, rule AL_update1) 
          apply (simp add: AssumPrivObjects_def) apply fastsimp
          apply (simp add: AssumPrivObjects_def) apply fastsimp
        apply simp
        apply simp
        apply simp
        (* apply fast *)
      apply clarsimp
      apply (rule UniInj)
      apply (rule UniRun)
        apply (rule UniPut)
        apply (simp add: BodyPrivObjects_def get_ins_def)  
        apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) 
        apply (rule AL_update1) 
        apply (simp,simp,simp)
        apply fastsimp
        apply (rule AL_update1)
        apply simp
        apply simp
        apply simp
        (* apply fast *)
      apply clarsimp
      apply (rule UniInj)
      apply (rule UniRun)
        apply (rule UniLoad)
        apply (simp add: BodyPrivObjects_def get_ins_def)
        apply (rule AL_update5) apply (rule AL_update5) 
        apply (rule AL_update1) 
        apply (simp,simp)
        apply fastsimp
        apply (rule AL_update1) 
        apply simp
        apply simp
        apply simp
        (* apply fast *)
      apply clarsimp
      apply (rule UniInj)
      apply (rule UniRun)
        apply (rule_tac UniGet)
        apply (simp add: BodyPrivObjects_def get_ins_def)  
        apply (rule AL_update5) 
        apply (rule AL_update1) 
        apply simp
        apply fastsimp
        apply (rule AL_update1)
        apply (rule AL_update1)
        apply simp
        apply simp
        apply simp
        (* apply fast *)
      apply clarsimp
      apply (rule UniInj)
        apply (rule UniVret)
          apply (simp add: BodyPrivObjects_def get_ins_def)
          apply (rule AL_update1) 
          apply fastsimp
          apply simp
   apply (simp add: DOM_def AL_cod_emp AL_dom_upd1 AL_dom_emp AL_dom_delete AssumPrivObjects_def)
     apply (rule, fastsimp)
     apply (simp add: AbsFields_expand, clarsimp)
     apply (drule AL_delete6, clarsimp)
     apply (drule AL_update3) apply assumption
     apply (drule AL_update3) apply assumption
     apply (simp add: AL_emp1)
   apply (simp add: AL_dom_emp)
   apply (simp add: contained_def, clarsimp)
     apply (drule AL_upd_split)
                      apply (erule disjE, clarsimp) apply (rule AL_update5, rule AL_update1) apply (simp add: AssumPrivObjects_def) apply fastsimp
                      apply clarsimp apply (drule AL_upd_split)
                      apply (erule disjE, clarsimp) apply (rule AL_update5, rule AL_update5, rule AL_update1) 
                        apply (simp add: AssumPrivObjects_def) apply (simp add: AssumPrivObjects_def) apply fastsimp
                      apply clarsimp apply (drule AL_upd_split)
                      apply (erule disjE, clarsimp) apply (rule AL_update5, rule AL_update5, rule AL_update5, rule AL_update1) 
                        apply (simp add: AssumPrivObjects_def) apply (simp add: AssumPrivObjects_def) apply (simp add: AssumPrivObjects_def) apply fastsimp
                      apply (simp add: AL_emp1)
   apply (simp add: AL_delete_emp upd_def)
   apply (simp add: contained_def, clarsimp)
     apply (drule AL_upd_split)
                      apply (erule disjE, clarsimp) apply (rule AL_delete5) apply (simp add: AssumPrivObjects_def)
                        apply (rule AL_update5, rule AL_update1) apply (simp add: AssumPrivObjects_def) apply fastsimp 
     apply clarsimp
     apply (drule AL_upd_split)
                      apply (erule disjE, clarsimp) apply (rule AL_delete5) apply (simp add: AssumPrivObjects_def)
                        apply (rule AL_update5, rule AL_update5, rule AL_update1) apply (simp add: AssumPrivObjects_def) apply (simp add: AssumPrivObjects_def) apply fastsimp
     apply clarsimp
     apply (drule AL_upd_split)
                      apply (erule disjE, clarsimp) apply (rule AL_delete5) apply (simp add: AssumPrivObjects_def)
                        apply (rule AL_update5, rule AL_update5, rule AL_update5, rule AL_update1) 
                        apply (simp add: AssumPrivObjects_def) apply (simp add: AssumPrivObjects_def) apply (simp add: AssumPrivObjects_def) apply fastsimp
                 apply (simp add: AL_emp1)
   apply (simp add: AssumPrivObjects_def upd_def AL_delete_emp) 
   apply (simp add: AL_dom_upd1 AL_dom_emp)
   apply (simp add: AL_sum_def) apply (rule contained_refl)
  apply clarsimp
  (*6,3*)
    apply (rule TypingInj)
    apply (rule_tac U="{}" in UniInjectR)
      prefer 2 apply (simp add: UniCtxtVerified_def)
      prefer 2 apply fastsimp
      apply (rule UniIf)
      apply (simp add: BodyPrivObjects_def get_ins_def)  
      apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
      apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) 
      apply (rule AL_update5) apply (rule AL_update5)
      apply (rule AL_update1a) 
      apply (simp,simp,simp,simp)
      apply (simp,simp,simp,simp)
      apply (simp,simp,simp)
      apply fastsimp
      apply simp
      apply simp
      apply simp
      (* apply fast *)
    apply clarsimp
    apply rule
    (*6,4*)
    apply clarsimp
      apply (rule TypingInj)
      apply (rule_tac U="{}" and V="{}" and 
                     N'="emp[green\<mapsto>intTP][red\<mapsto>intTP][blue\<mapsto>intTP]" in TypingUniRetRet)
      prefer 2 apply (simp add: UniCtxtVerified_def)
      prefer 3 apply (simp add: UniCtxtVerified_def)
      prefer 3 apply fastsimp
      prefer 3 apply (simp add: AssumPrivObjects_def) apply fastsimp
      apply (rule_tac d=black in UniBS_StaticGarbageColour)
      prefer 2  apply (simp add: DOM_def AssumPrivObjects_def AL_cod_emp AL_dom_emp AbsFields_emp)  apply fastsimp
      prefer 3 apply (simp add: DOM_def AL_cod_emp AL_cod_upd1 AL_dom_emp AbsFields_emp) apply clarsimp
                   apply (drule AL_cod_split) apply (erule disjE) 
                   apply (drule AL_cod_split) apply (erule disjE)
                   apply (drule AL_cod_split) apply (simp add: AL_cod_emp AssumPrivObjects_def) 
                   apply (simp add: AssumPrivObjects_def) 
                   apply (simp add: AssumPrivObjects_def) 
      apply (rule_tac d=black in UniBS_StaticGarbageHP)
        prefer 5 apply (simp add: DOM_def AL_cod_emp AL_cod_upd1 AL_dom_emp AbsFields_emp) apply clarsimp
                   apply (drule AL_cod_split) apply (erule disjE) 
                   apply (drule AL_cod_split) apply (erule disjE)
                   apply (drule AL_cod_split) apply (simp add: AL_cod_emp AssumPrivObjects_def) 
                   apply (simp add: AssumPrivObjects_def) 
                   apply (simp add: AssumPrivObjects_def) 
      apply (rule UniRun)
        apply (rule_tac cl=black and D=C in UniNew)
        apply (simp add: BodyPrivObjects_def get_ins_def)  
        apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
        apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) 
        apply (rule AL_update1) 
        apply (simp,simp,simp,simp)
        apply (simp,simp,simp)
        apply fastsimp
        apply (simp add: AL_dom_upd1 AL_dom_emp AssumPrivObjects_def) apply fastsimp
        apply simp
        apply (simp add: subclass_of_refl)
        apply simp
        apply simp
        (* apply fast *)
      apply clarsimp
      apply (rule UniInj)
      apply (rule UniRun)
        apply (rule UniStore)
        apply (simp add: BodyPrivObjects_def get_ins_def)  
        apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
        apply (rule AL_update5) apply (rule AL_update5) 
        apply (rule AL_update1) 
        apply (simp,simp,simp,simp)
        apply (simp,simp)
        apply fastsimp
        apply simp
        apply simp
        apply simp
        (* apply fast *)
      apply clarsimp
      apply (rule UniInj)
      apply (rule UniRun)
        apply (rule UniLoad)
        apply (simp add: BodyPrivObjects_def get_ins_def)
        apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
        apply (rule AL_update1) 
        apply (simp,simp,simp,simp)
        apply simp
        apply fastsimp
        apply (rule AL_update1) 
        apply simp
        apply simp
        apply simp
        (* apply fast *)
      apply clarsimp
      apply (rule UniInj)
      apply (rule UniRun)
        apply (rule UniLoad)
        apply (simp add: BodyPrivObjects_def get_ins_def)
        apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) 
        apply (rule AL_update1) 
        apply (simp,simp,simp,simp)
        apply fastsimp
        apply (rule AL_update5, rule AL_update5, rule AL_update1) 
          apply (simp add: AssumPrivObjects_def) apply fastsimp
          apply (simp add: AssumPrivObjects_def) apply fastsimp
        apply simp
        apply simp
        apply simp
        (* apply fast *)
      apply clarsimp
      apply (rule UniInj)
      apply (rule UniRun)
        apply (rule UniPut)
        apply (simp add: BodyPrivObjects_def get_ins_def)  
        apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) 
        apply (rule AL_update1) 
        apply (simp,simp,simp)
        apply fastsimp
        apply (rule AL_update1)
        apply simp
        apply simp
        apply simp
        (* apply fast *)
      apply clarsimp
      apply (rule UniInj)
      apply (rule UniRun)
        apply (rule UniLoad)
        apply (simp add: BodyPrivObjects_def get_ins_def)
        apply (rule AL_update5) apply (rule AL_update5) 
        apply (rule AL_update1) 
        apply (simp,simp)
        apply fastsimp
        apply (rule AL_update1) 
        apply simp
        apply simp
        apply simp
        (* apply fast *)
      apply clarsimp
      apply (rule UniInj)
      apply (rule UniRun)
        apply (rule_tac UniGet)
        apply (simp add: BodyPrivObjects_def get_ins_def)  
        apply (rule AL_update5) 
        apply (rule AL_update1) 
        apply simp
        apply fastsimp
        apply (rule AL_update1)
        apply (rule AL_update1)
        apply simp
        apply simp
        apply simp
        (* apply fast *)
      apply clarsimp
      apply (rule UniInj)
        apply (rule UniVret)
          apply (simp add: BodyPrivObjects_def get_ins_def)
          apply (rule AL_update1) 
          apply fastsimp
          apply simp
   apply (simp add: DOM_def AL_cod_emp AL_dom_upd1 AL_dom_emp AL_dom_delete AssumPrivObjects_def)
     apply (rule, fastsimp)
     apply (simp add: AbsFields_expand, clarsimp)
     apply (drule AL_delete6, clarsimp)
     apply (drule AL_update3) apply assumption
     apply (drule AL_update3) apply assumption
     apply (simp add: AL_emp1)
   apply (simp add: AL_dom_emp)
   apply (simp add: contained_def, clarsimp)
     apply (drule AL_upd_split)
                      apply (erule disjE, clarsimp) apply (rule AL_update5, rule AL_update1) apply (simp add: AssumPrivObjects_def) apply fastsimp
                      apply clarsimp apply (drule AL_upd_split)
                      apply (erule disjE, clarsimp) apply (rule AL_update5, rule AL_update5, rule AL_update1) 
                        apply (simp add: AssumPrivObjects_def) apply (simp add: AssumPrivObjects_def) apply fastsimp
                      apply clarsimp apply (drule AL_upd_split)
                      apply (erule disjE, clarsimp) apply (rule AL_update5, rule AL_update5, rule AL_update5, rule AL_update1) 
                        apply (simp add: AssumPrivObjects_def) apply (simp add: AssumPrivObjects_def) apply (simp add: AssumPrivObjects_def) apply fastsimp
                      apply (simp add: AL_emp1)
   apply clarsimp apply (simp add: AL_dom_upd1 AL_dom_emp AssumPrivObjects_def) apply fastsimp
   apply (simp add: AL_delete_emp upd_def)
   apply (simp add: contained_def, clarsimp)
     apply (drule AL_upd_split)
                      apply (erule disjE, clarsimp) apply (rule AL_delete5) apply (simp add: AssumPrivObjects_def)
                        apply (rule AL_update5, rule AL_update1) apply (simp add: AssumPrivObjects_def) apply fastsimp 
     apply clarsimp
     apply (drule AL_upd_split)
                      apply (erule disjE, clarsimp) apply (rule AL_delete5) apply (simp add: AssumPrivObjects_def)
                        apply (rule AL_update5, rule AL_update5, rule AL_update1) apply (simp add: AssumPrivObjects_def) apply (simp add: AssumPrivObjects_def) apply fastsimp
     apply clarsimp
     apply (drule AL_upd_split)
                      apply (erule disjE, clarsimp) apply (rule AL_delete5) apply (simp add: AssumPrivObjects_def)
                        apply (rule AL_update5, rule AL_update5, rule AL_update5, rule AL_update1) 
                        apply (simp add: AssumPrivObjects_def) apply (simp add: AssumPrivObjects_def) apply (simp add: AssumPrivObjects_def) apply fastsimp
                 apply (simp add: AL_emp1)
   apply (simp add: AssumPrivObjects_def upd_def AL_delete_emp) 
      apply (rule UniRun)
        apply (rule UniLoad)
        apply (simp add: BodyPrivObjects_def get_ins_def)
        apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
        apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)   
        apply (rule AL_update1a) 
        apply (simp,simp,simp,simp)
        apply (simp,simp,simp,simp)
        apply (simp,simp)
        apply fastsimp
        apply (rule AL_update1)
        apply simp
        apply simp
        apply simp
        (* apply fast *)
      apply clarsimp
      apply (rule UniInj)
        apply (rule UniVret)
        apply (simp add: BodyPrivObjects_def get_ins_def)  
        apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) 
        apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) 
        apply (rule AL_update1a) 
        apply (simp,simp,simp,simp)
        apply (simp,simp,simp,simp)
        apply simp
        apply fastsimp
      apply simp
   apply simp
   apply (simp add: AL_sum_def)  apply (rule contained_refl) 
    (*6,6*)
      apply clarsimp
      apply (rule TypingInj)
      apply (rule_tac U="{}" and V="{}" and 
                     N'="emp[green\<mapsto>intTP][red\<mapsto>intTP][blue\<mapsto>intTP]" and 
                     N''="emp[green\<mapsto>intTP][red\<mapsto>intTP][blue\<mapsto>intTP]" in TypingUniRetRet)
      prefer 2 apply (simp add: UniCtxtVerified_def)
      prefer 3 apply (simp add: UniCtxtVerified_def)
      prefer 3 apply fastsimp
      prefer 3 apply (simp add: AssumPrivObjects_def) apply fastsimp
      apply (rule_tac d=black in UniBS_StaticGarbageColour)
      prefer 2  apply (simp add: DOM_def AssumPrivObjects_def AL_cod_emp AL_dom_emp AbsFields_emp) apply fastsimp
      prefer 3 apply (simp add:DOM_def  AL_dom_upd1 AL_dom_emp AbsFields_emp AssumPrivObjects_def) apply clarsimp 
               apply (drule SetTriv, rule  AL_cod_upd1) apply clarsimp apply (erule disjE, simp) 
               apply (drule SetTriv, rule  AL_cod_upd1) apply clarsimp apply (erule disjE, simp) 
               apply (drule SetTriv, rule  AL_cod_upd1) apply clarsimp apply (erule disjE, simp) apply (simp add: AL_cod_emp)
      apply (rule_tac d=black in UniBS_StaticGarbageHP)
        prefer 5 apply (simp add:DOM_def  AL_dom_upd1 AL_dom_emp AbsFields_emp AssumPrivObjects_def) apply clarsimp 
                 apply (drule SetTriv, rule  AL_cod_upd1) apply clarsimp apply (erule disjE, simp) 
               apply (drule SetTriv, rule  AL_cod_upd1) apply clarsimp apply (erule disjE, simp) 
               apply (drule SetTriv, rule  AL_cod_upd1) apply clarsimp apply (erule disjE, simp) apply (simp add: AL_cod_emp) 
        prefer 5 apply (simp add: AL_dom_upd1 AL_dom_emp AssumPrivObjects_def) apply fastsimp
      apply (rule UniRun)
        apply (rule_tac cl=black and D=C in UniNew)
        apply (simp add: BodyPrivObjects_def get_ins_def)  
        apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
        apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) 
        apply (rule AL_update1) 
        apply (simp,simp,simp,simp)
        apply (simp,simp,simp)
        apply fastsimp
        apply (simp add: AL_dom_upd1 AL_dom_emp AssumPrivObjects_def) apply fastsimp
        apply simp
        apply (simp add: subclass_of_refl)
        apply simp
        apply simp
        (* apply fast *)
      apply clarsimp
      apply (rule UniInj)
      apply (rule UniRun)
        apply (rule UniStore)
        apply (simp add: BodyPrivObjects_def get_ins_def)  
        apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
        apply (rule AL_update5) apply (rule AL_update5) 
        apply (rule AL_update1) 
        apply (simp,simp,simp,simp)
        apply (simp,simp)
        apply fastsimp
        apply simp
        apply simp
        apply simp
        (* apply fast *)
      apply clarsimp
      apply (rule UniInj)
      apply (rule UniRun)
        apply (rule UniLoad)
        apply (simp add: BodyPrivObjects_def get_ins_def)
        apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
        apply (rule AL_update1) 
        apply (simp,simp,simp,simp)
        apply simp
        apply fastsimp
        apply (rule AL_update1) 
        apply simp
        apply simp
        apply simp
        (* apply fast *)
      apply clarsimp
      apply (rule UniInj)
      apply (rule UniRun)
        apply (rule UniLoad)
        apply (simp add: BodyPrivObjects_def get_ins_def)
        apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) 
        apply (rule AL_update1) 
        apply (simp,simp,simp,simp)
        apply fastsimp
        apply (rule AL_update5, rule AL_update5, rule AL_update1) 
          apply (simp add: AssumPrivObjects_def) apply fastsimp
          apply (simp add: AssumPrivObjects_def) apply fastsimp
        apply simp
        apply simp
        apply simp
        (* apply fast *)
      apply clarsimp
      apply (rule UniInj)
      apply (rule UniRun)
        apply (rule UniPut)
        apply (simp add: BodyPrivObjects_def get_ins_def)  
        apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) 
        apply (rule AL_update1) 
        apply (simp,simp,simp)
        apply fastsimp
        apply (rule AL_update1)
        apply simp
        apply simp
        apply simp
        (* apply fast *)
      apply clarsimp
      apply (rule UniInj)
      apply (rule UniRun)
        apply (rule UniLoad)
        apply (simp add: BodyPrivObjects_def get_ins_def)
        apply (rule AL_update5) apply (rule AL_update5) 
        apply (rule AL_update1) 
        apply (simp,simp)
        apply fastsimp
        apply (rule AL_update1) 
        apply simp
        apply simp
        apply simp
        (* apply fast *)
      apply clarsimp
      apply (rule UniInj)
      apply (rule UniRun)
        apply (rule_tac UniGet)
        apply (simp add: BodyPrivObjects_def get_ins_def)  
        apply (rule AL_update5) 
        apply (rule AL_update1) 
        apply simp
        apply fastsimp
        apply (rule AL_update1)
        apply (rule AL_update1)
        apply simp
        apply simp
        apply simp
        (* apply fast *)
      apply clarsimp
      apply (rule UniInj)
        apply (rule UniVret)
          apply (simp add: BodyPrivObjects_def get_ins_def)
          apply (rule AL_update1) 
          apply fastsimp
          apply simp
   apply (simp add: DOM_def AL_cod_emp AL_dom_upd1 AL_dom_emp AL_dom_delete AssumPrivObjects_def)
     apply (rule, fastsimp)
     apply (simp add: AbsFields_expand, clarsimp)
     apply (drule AL_delete6, clarsimp)
     apply (drule AL_update3) apply assumption
     apply (drule AL_update3) apply assumption
     apply (simp add: AL_emp1)
   apply (simp add: AL_dom_emp)
   apply (simp add: contained_def, clarsimp)
     apply (drule AL_upd_split)
                      apply (erule disjE, clarsimp) apply (rule AL_update5, rule AL_update1) apply (simp add: AssumPrivObjects_def) apply fastsimp
                      apply clarsimp apply (drule AL_upd_split)
                      apply (erule disjE, clarsimp) apply (rule AL_update5, rule AL_update5, rule AL_update1) 
                        apply (simp add: AssumPrivObjects_def) apply (simp add: AssumPrivObjects_def) apply fastsimp
                      apply clarsimp apply (drule AL_upd_split)
                      apply (erule disjE, clarsimp) apply (rule AL_update5, rule AL_update5, rule AL_update5, rule AL_update1) 
                        apply (simp add: AssumPrivObjects_def) apply (simp add: AssumPrivObjects_def) apply (simp add: AssumPrivObjects_def) apply fastsimp
                      apply (simp add: AL_emp1)
   apply (simp add: AL_delete_emp upd_def)
   apply (simp add: contained_def, clarsimp)
     apply (drule AL_upd_split)
                      apply (erule disjE, clarsimp) apply (rule AL_delete5) apply (simp add: AssumPrivObjects_def)
                        apply (rule AL_update5, rule AL_update1) apply (simp add: AssumPrivObjects_def) apply fastsimp 
     apply clarsimp
     apply (drule AL_upd_split)
                      apply (erule disjE, clarsimp) apply (rule AL_delete5) apply (simp add: AssumPrivObjects_def)
                        apply (rule AL_update5, rule AL_update5, rule AL_update1) apply (simp add: AssumPrivObjects_def) apply (simp add: AssumPrivObjects_def) apply fastsimp
     apply clarsimp
     apply (drule AL_upd_split)
                      apply (erule disjE, clarsimp) apply (rule AL_delete5) apply (simp add: AssumPrivObjects_def)
                        apply (rule AL_update5, rule AL_update5, rule AL_update5, rule AL_update1) 
                        apply (simp add: AssumPrivObjects_def) apply (simp add: AssumPrivObjects_def) apply (simp add: AssumPrivObjects_def) apply fastsimp
                 apply (simp add: AL_emp1)
   apply (simp add: AssumPrivObjects_def upd_def AL_delete_emp) 

      apply (rule_tac d=black in UniBS_StaticGarbageColour)
      prefer 2  apply (simp add: DOM_def AssumPrivObjects_def AL_cod_emp AL_dom_emp AbsFields_emp) apply fastsimp
      prefer 3 apply (simp add:DOM_def  AL_dom_upd1 AL_dom_emp AbsFields_emp AssumPrivObjects_def) apply clarsimp 
               apply (drule SetTriv, rule  AL_cod_upd1) apply clarsimp apply (erule disjE, simp) 
               apply (drule SetTriv, rule  AL_cod_upd1) apply clarsimp apply (erule disjE, simp) 
               apply (drule SetTriv, rule  AL_cod_upd1) apply clarsimp apply (erule disjE, simp) apply (simp add: AL_cod_emp)
      apply (rule_tac d=black in UniBS_StaticGarbageHP)
        prefer 5 apply (simp add:DOM_def  AL_dom_upd1 AL_dom_emp AbsFields_emp AssumPrivObjects_def) apply clarsimp 
                 apply (drule SetTriv, rule  AL_cod_upd1) apply clarsimp apply (erule disjE, simp) 
               apply (drule SetTriv, rule  AL_cod_upd1) apply clarsimp apply (erule disjE, simp) 
               apply (drule SetTriv, rule  AL_cod_upd1) apply clarsimp apply (erule disjE, simp) apply (simp add: AL_cod_emp) 
        prefer 5 apply (simp add: AL_dom_upd1 AL_dom_emp AssumPrivObjects_def) apply fastsimp
      apply (rule UniRun)
        apply (rule_tac cl=black and D=C in UniNew)
        apply (simp add: BodyPrivObjects_def get_ins_def)  
        apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
        apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) 
        apply (rule AL_update1) 
        apply (simp,simp,simp,simp)
        apply (simp,simp,simp)
        apply fastsimp
        apply (simp add: AL_dom_upd1 AL_dom_emp AssumPrivObjects_def) apply fastsimp
        apply simp
        apply (simp add: subclass_of_refl)
        apply simp
        apply simp
        (* apply fast *)
      apply clarsimp
      apply (rule UniInj)
      apply (rule UniRun)
        apply (rule UniStore)
        apply (simp add: BodyPrivObjects_def get_ins_def)  
        apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
        apply (rule AL_update5) apply (rule AL_update5) 
        apply (rule AL_update1) 
        apply (simp,simp,simp,simp)
        apply (simp,simp)
        apply fastsimp
        apply simp
        apply simp
        apply simp
        (* apply fast *)
      apply clarsimp
      apply (rule UniInj)
      apply (rule UniRun)
        apply (rule UniLoad)
        apply (simp add: BodyPrivObjects_def get_ins_def)
        apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5)
        apply (rule AL_update1) 
        apply (simp,simp,simp,simp)
        apply simp
        apply fastsimp
        apply (rule AL_update1) 
        apply simp
        apply simp
        apply simp
        (* apply fast *)
      apply clarsimp
      apply (rule UniInj)
      apply (rule UniRun)
        apply (rule UniLoad)
        apply (simp add: BodyPrivObjects_def get_ins_def)
        apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) 
        apply (rule AL_update1) 
        apply (simp,simp,simp,simp)
        apply fastsimp
        apply (rule AL_update5, rule AL_update5, rule AL_update1) 
          apply (simp add: AssumPrivObjects_def) apply fastsimp
          apply (simp add: AssumPrivObjects_def) apply fastsimp
        apply simp
        apply simp
        apply simp
        (* apply fast *)
      apply clarsimp
      apply (rule UniInj)
      apply (rule UniRun)
        apply (rule UniPut)
        apply (simp add: BodyPrivObjects_def get_ins_def)  
        apply (rule AL_update5) apply (rule AL_update5) apply (rule AL_update5) 
        apply (rule AL_update1) 
        apply (simp,simp,simp)
        apply fastsimp
        apply (rule AL_update1)
        apply simp
        apply simp
        apply simp
        (* apply fast *)
      apply clarsimp
      apply (rule UniInj)
      apply (rule UniRun)
        apply (rule UniLoad)
        apply (simp add: BodyPrivObjects_def get_ins_def)
        apply (rule AL_update5) apply (rule AL_update5) 
        apply (rule AL_update1) 
        apply (simp,simp)
        apply fastsimp
        apply (rule AL_update1) 
        apply simp
        apply simp
        apply simp
        (* apply fast *)
      apply clarsimp
      apply (rule UniInj)
      apply (rule UniRun)
        apply (rule_tac UniGet)
        apply (simp add: BodyPrivObjects_def get_ins_def)  
        apply (rule AL_update5) 
        apply (rule AL_update1) 
        apply simp
        apply fastsimp
        apply (rule AL_update1)
        apply (rule AL_update1)
        apply simp
        apply simp
        apply simp
        (* apply fast *)
      apply clarsimp
      apply (rule UniInj)
        apply (rule UniVret)
          apply (simp add: BodyPrivObjects_def get_ins_def)
          apply (rule AL_update1) 
          apply fastsimp
          apply simp
   apply (simp add: DOM_def AL_cod_emp AL_dom_upd1 AL_dom_emp AL_dom_delete AssumPrivObjects_def)
     apply (rule, fastsimp)
     apply (simp add: AbsFields_expand, clarsimp)
     apply (drule AL_delete6, clarsimp)
     apply (drule AL_update3) apply assumption
     apply (drule AL_update3) apply assumption
     apply (simp add: AL_emp1)
   apply (simp add: AL_dom_emp)
   apply (simp add: contained_def, clarsimp)
     apply (drule AL_upd_split)
                      apply (erule disjE, clarsimp) apply (rule AL_update5, rule AL_update1) apply (simp add: AssumPrivObjects_def) apply fastsimp
                      apply clarsimp apply (drule AL_upd_split)
                      apply (erule disjE, clarsimp) apply (rule AL_update5, rule AL_update5, rule AL_update1) 
                        apply (simp add: AssumPrivObjects_def) apply (simp add: AssumPrivObjects_def) apply fastsimp
                      apply clarsimp apply (drule AL_upd_split)
                      apply (erule disjE, clarsimp) apply (rule AL_update5, rule AL_update5, rule AL_update5, rule AL_update1) 
                        apply (simp add: AssumPrivObjects_def) apply (simp add: AssumPrivObjects_def) apply (simp add: AssumPrivObjects_def) apply fastsimp
                      apply (simp add: AL_emp1)
   apply (simp add: AL_delete_emp upd_def)
   apply (simp add: contained_def, clarsimp)
     apply (drule AL_upd_split)
                      apply (erule disjE, clarsimp) apply (rule AL_delete5) apply (simp add: AssumPrivObjects_def)
                        apply (rule AL_update5, rule AL_update1) apply (simp add: AssumPrivObjects_def) apply fastsimp 
     apply clarsimp
     apply (drule AL_upd_split)
                      apply (erule disjE, clarsimp) apply (rule AL_delete5) apply (simp add: AssumPrivObjects_def)
                        apply (rule AL_update5, rule AL_update5, rule AL_update1) apply (simp add: AssumPrivObjects_def) apply (simp add: AssumPrivObjects_def) apply fastsimp
     apply clarsimp
     apply (drule AL_upd_split)
                      apply (erule disjE, clarsimp) apply (rule AL_delete5) apply (simp add: AssumPrivObjects_def)
                        apply (rule AL_update5, rule AL_update5, rule AL_update5, rule AL_update1) 
                        apply (simp add: AssumPrivObjects_def) apply (simp add: AssumPrivObjects_def) apply (simp add: AssumPrivObjects_def) apply fastsimp
                 apply (simp add: AL_emp1)
   apply (simp add: AssumPrivObjects_def upd_def AL_delete_emp) 

   apply simp
   apply (simp add: AL_sum_def) apply (rule contained_refl)
done
(*<*)
end
(*>*)
(*
Alternative to be tried out:
Derive Garbage rules for (big-step) relational judgement and then
verify the last branch (ie case (6,6)) using these, with rule NewNew instead of the two high-New rules.
*)