(*<*)
theory temp = ListSL_UnaryVerif:
(*>*)

lemma G3_verified_invocations_non_correlated:
  "\<lbrakk>TL \<noteq> HD; distinct [h, t, z, this]; distinct [NIL,CONS,LIST];       
    subclass_of NIL LIST;
    \<forall> D . subclass_of D  NIL \<longrightarrow> D = NIL; \<forall> D . subclass_of D CONS \<longrightarrow> D = CONS;
    mbody_is LIST Copy ListCopy; mbody_is LIST CrossCopy ListCopy;
    mbody_is NIL Copy NilCopy; mbody_is NIL CrossCopy NilCopy;
    mbody_is CONS Copy ConsCopy; mbody_is CONS CrossCopy Cross\<rbrakk> 
    \<Longrightarrow> CtxtVerified G3"
(*<*)
apply (simp add: G3_def CtxtVerified_def, clarsimp)
apply (rule, clarsimp) apply (rotate_tac -3, erule thin_rl, erule thin_rl)
  apply (simp add: RelSp2_def) 
  apply (rule, simp add: preserved_def starOptDEF, clarsimp)
    apply (rule, simp add: AL_sum_def, clarsimp) apply (erule contained_transitive, assumption)
    apply (simp add: preS_def AL_sum_def, clarsimp) apply (rule, fast) apply fast
  apply clarsimp
  apply (subgoal_tac "(G3,((a, aa, b), emp[\<gamma>\<mapsto>(classTP NIL)], a, aa, b), NilCopy, 0, NilCopy, 0, False, ([\<upsilon>], emp, H), ak, [\<upsilon>'], emp, K)
          \<in> Typing", simp add: G3_def RelSp2_def)
  apply (simp add: preS_def, clarsimp)
  apply (rename_tac N)
  apply (rule UniInjectL)
  apply (rule_tac cl=\<upsilon> and D=NIL and C=NIL in UniNew)
    apply (rule InstrNIL0)
    prefer 8 apply fastsimp
    apply fastsimp
    apply (simp add: starOptDEF AL_dom_upd1 AL_dom_emp)
    apply simp
    apply (simp add: subclass_of_refl)
    apply simp
    apply simp
    apply (rule UniCtxtVerified_emp)
    (* apply fast *)
    apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectR)
  apply (rule_tac cl=\<upsilon>' and D=NIL and C=NIL in UniNew)
    apply (rule InstrNIL0)
    prefer 8 apply fastsimp
    apply fastsimp
    apply (simp add: starOptDEF AL_dom_upd1 AL_dom_emp AL_sum_def) 
    apply simp
    apply (simp add: subclass_of_refl)
    apply simp
    apply simp
    apply (rule UniCtxtVerified_emp)
    (* apply fast *)
    apply clarsimp
    apply (rule TypingInj)
    apply (rule_tac H=emp and K=emp and N=emp in TypingFrame)
    apply (rule TypingRetRet)
      apply (rule InstrNIL1)
      apply (rule InstrNIL1)
      apply simp
      apply simp
      apply (simp add: RSD_sum_def) apply (rule, simp) apply (rule, simp) apply (rule, simp)
        apply (rule, simp) apply (rule, simp) apply (rule, simp) 
        apply (rule, rule AL_UPD, rule AL_UPD) apply (rule AL_EMP) 
        apply (rule, rule AL_UPD, rule AL_UPD) apply (rule AL_EMP)  
        apply (rule, rule AL_UPD, rule AL_UPD, rule AL_UPD) apply (rule AL_EMP)  
        apply (rule, rule AL_sum_emp2)
        apply (rule, rule AL_sum_emp2)
        apply (rule, rule AL_sum_emp2)
        apply (simp add: AL_dom_emp)
      apply (simp add: RSD_sum_def starOptDEF, clarsimp)
        apply (rule, simp add: AL_sum_def AL_dom_emp AL_dom_upd1) 
          apply (rule, simp (no_asm) add: contained_def, clarsimp) 
            apply (drule AL_upd_split)
            apply (erule disjE) apply clarsimp apply (erule contained3, rule AL_update1) 
            apply clarsimp 
            apply (drule AL_upd_split)
            apply (erule disjE) apply clarsimp apply (erule contained3, rule AL_update1) 
            apply (simp add: AL_emp1)
          apply (rule contained_emp)
        apply (rule, simp add: AL_sum_def AL_dom_emp AL_dom_upd1) 
          apply (rule, simp (no_asm) add: contained_def, clarsimp) 
            apply (drule AL_upd_split)
            apply (erule disjE) apply clarsimp apply (erule contained3, rule AL_update1) 
            apply clarsimp 
            apply (drule AL_upd_split)
            apply (erule disjE) apply clarsimp apply (erule contained3, rule AL_update1) 
            apply (simp add: AL_emp1)
          apply (rule contained_emp)
        apply (rule, simp add: AL_sum_def AL_dom_emp AL_dom_upd1) 
          apply (rule, simp (no_asm) add: contained_def, clarsimp) 
            apply (drule AL_upd_split)
            apply (erule disjE) apply clarsimp apply (erule contained3, rule AL_update1) 
            apply clarsimp 
            apply (drule AL_upd_split)
            apply (erule disjE) apply clarsimp apply (erule contained3, erule contained3, rule AL_update1) 
            apply clarsimp
            apply (drule AL_upd_split)
            apply (erule disjE) apply clarsimp apply (erule contained3, erule contained3, rule AL_update1) 
            apply (simp add: AL_emp1)
          apply (rule contained_emp)
        apply (rule, simp add: AL_dom_emp)
        apply (rule, simp add: AL_dom_emp)
        apply (simp add: AL_dom_emp)
(*n>0*)
apply (rule, clarsimp)
  apply (rotate_tac -3, erule thin_rl, erule thin_rl)
  apply (rule, simp add: preserved_def RelSp2_def preS_def starOptDEF, clarsimp)
    apply (simp add: AL_sum_def, clarsimp)  
      apply (rule, erule contained_transitive, assumption) 
      apply fast
  apply (subgoal_tac "(G3,((ad, ae, bb), af, ag, ah, bc),
           ConsCopy, 0, Cross, 0, False, (ai, aj, bd), ak, al, am, be)
          \<in> Typing", simp add: G3_def)
  apply (simp add: RelSp2_def preS_def, clarsimp)
  apply (case_tac "ListHP \<gamma> \<Lambda>", clarsimp,clarsimp)
  apply (simp add: starOptDEF, clarsimp)
  apply (rename_tac NMM' \<gamma> \<Lambda> \<upsilon> \<Upsilon> \<upsilon>' \<Upsilon>' HK HK' H N NM K K' M M')
  apply (case_tac \<Lambda>, clarsimp,clarsimp) 
  apply (case_tac "ListN b list", clarsimp,clarsimp) 
  apply (case_tac "ListHP b list", clarsimp,clarsimp) 
  apply (case_tac "ListN ba zs", clarsimp,clarsimp) 
  apply (case_tac "ListHP ba zs", clarsimp,clarsimp) 
  apply (case_tac "ListN bb zsa", clarsimp,clarsimp) 
  apply (case_tac "ListHP bb zsa", clarsimp,clarsimp) 
  apply (drule if_split, clarsimp)
  apply (drule if_split, clarsimp)
  apply (drule if_split, clarsimp)
  apply (drule if_split, clarsimp)
  apply (drule if_split, clarsimp)
  apply (drule if_split, clarsimp)
  apply (rename_tac \<epsilon> \<omega> \<Omega> \<theta> \<Theta> \<theta>' \<Theta>' N H M K M' K')
  apply (rule UniInjectL)
    apply (rule UniLoad)
      apply (rule InstrCONS0)
      prefer 7 apply fastsimp
      apply fastsimp
      apply (rule AL_update1)
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectR)
    apply (rule_tac cl=\<upsilon>' and C=CONS and D=CONS in UniNew)
      apply (rule InstrCROSS0)
      prefer 8 apply fastsimp    
      apply fastsimp
      apply (simp add: AL_sum_def AL_dom_upd1) 
      apply simp
      apply (simp add: subclass_of_refl)
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectL)
  prefer 3 apply fastsimp
  apply (rule UniGet)
      apply (rule InstrCONS1)
      apply fastsimp   
      apply (rule AL_update1)
      apply (rule AL_update4) apply (rule AL_update1) apply assumption
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectR)
  prefer 3 apply fastsimp
  apply (rule UniDup)
      apply (rule InstrCROSS1)
      apply fastsimp    
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectL)
  prefer 3 apply fastsimp
  apply (rule UniStore)
      apply (rule InstrCONS2)
      apply fastsimp    
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectR)
  prefer 3 apply fastsimp
  apply (rule UniDup)
      apply (rule InstrCROSS2)
      apply fastsimp    
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectL)
  prefer 3 apply fastsimp
  apply (rule UniLoad)
      apply (rule InstrCONS3)
      apply fastsimp    
      apply (rule AL_update4, rule AL_update1) apply fastsimp
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectR)
  prefer 3 apply fastsimp
  apply (rule UniLoad)
      apply (rule InstrCROSS3)
      apply fastsimp    
      apply (rule AL_update1) 
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectL)
  prefer 3 apply fastsimp
  apply (rule UniGet)
      apply (rule InstrCONS4)
      apply fastsimp    
      apply (rule AL_update1)
      apply (rule AL_update1) 
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectR)
  prefer 3 apply fastsimp
  apply (rule UniGet)
      apply (rule InstrCROSS4)
      apply fastsimp    
      apply (rule AL_update4, rule AL_update1) apply (simp add: AL_dom_upd1)
      apply (rule AL_update4, rule AL_update1) apply assumption
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectL)
  prefer 3 apply fastsimp
  apply (rule UniStore)
      apply (rule InstrCONS5)
      apply fastsimp    
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectL)
  prefer 3 apply fastsimp
  apply (rule UniLoad)
      apply (rule InstrCONS6)
      apply fastsimp    
      apply (rule AL_update1)
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectR)
  prefer 3 apply fastsimp
  apply (rule UniPut)
      apply (rule InstrCROSS5)
      apply fastsimp    
      apply (rule AL_update1) 
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectR)
  prefer 3 apply fastsimp
  apply (rule UniLoad)
      apply (rule InstrCROSS6)
      apply fastsimp    
      apply (rule AL_update1) 
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectR)
  prefer 3 apply fastsimp
  apply (rule UniGet)
      apply (rule InstrCROSS7)
      apply fastsimp    
      apply (rule AL_update4, rule AL_update4, rule AL_update1) apply (simp add: AL_dom_upd1) apply (simp add: AL_dom_upd1)
      apply (rule AL_update1) 
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
apply (subgoal_tac "AL_dom (H[\<gamma>\<mapsto>(CONS, emp[HD\<mapsto>\<epsilon>][TL\<mapsto>\<omega>])]) \<inter> AL_dom K = {}")
prefer 2 apply (simp add: AL_sum_def AL_dom_upd1)
apply (frule_tac M=K in AL_sum_exists_AL) apply (erule exE, rename_tac HH, erule conjE)
apply (subgoal_tac "AL_dom (H[\<gamma>\<mapsto>(CONS, emp[HD\<mapsto>\<epsilon>][TL\<mapsto>\<omega>])]) \<inter> AL_dom K'[\<upsilon>'\<mapsto>(CONS, emp[HD\<mapsto>\<epsilon>])] = {}")
prefer 2 apply (simp add: AL_sum_def AL_dom_upd1)
apply (frule_tac M="K'[\<upsilon>'\<mapsto>(CONS, emp[HD\<mapsto>\<epsilon>])]" in AL_sum_exists_AL) apply (erule exE, rename_tac HH', erule conjE)
apply (subgoal_tac "AL_dom N[\<gamma>\<mapsto>(classTP CONS)] \<inter> AL_dom M = {}")
prefer 2 apply (simp add: AL_sum_def AL_dom_upd1)
apply (frule_tac M=M in AL_sum_exists_AL) apply (erule exE, rename_tac NN, erule conjE)
apply (subgoal_tac "AL_dom NN \<inter> AL_dom M'[\<upsilon>'\<mapsto>(classTP CONS)] = {}")
prefer 2 apply (simp add: AL_sum_def AL_dom_upd1)
apply (frule_tac N=NN and M="M'[\<upsilon>'\<mapsto>(classTP CONS)]" in AL_sum_exists_AL) apply (erule exE, rename_tac NNN', erule conjE)
apply (subgoal_tac "(G3, (([\<theta>], emp[this\<mapsto>\<gamma>][h\<mapsto>\<epsilon>][t\<mapsto>\<omega>], HH), NNN', [\<theta>', \<upsilon>', \<upsilon>'], emp[this\<mapsto>\<gamma>],HH'),
           ConsCopy, Suc(Suc (Suc (Suc (Suc (Suc (Suc (Suc 0))))))), Cross, Suc(Suc (Suc (Suc (Suc (Suc (Suc (Suc (Suc 0)))))))), False, ([\<upsilon>], emp, HK), NMM', [\<upsilon>'], emp,
           HK')
          \<in> Typing")
prefer 2
  apply (rule UniInjectL)
  prefer 3 apply fastsimp
  apply (rule UniStore)
      apply (rule InstrCONS8)
      apply fastsimp    
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectR)
  prefer 3 apply fastsimp
  apply (rule UniPut)
      apply (rule InstrCROSS9)
      apply fastsimp    
      apply (erule AL_sum4, rule AL_update1)
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectL)
  apply (rule_tac cl=\<upsilon> and C=CONS and D=CONS in UniNew)
      apply (rule InstrCONS9)
      prefer 8 apply fastsimp    
      apply fastsimp
      apply (simp add: AL_sum_def AL_dom_upd1) apply clarsimp
      apply simp
      apply (simp add: subclass_of_refl)
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectL)
  prefer 3 apply fastsimp
  apply (rule UniStore)
      apply (rule InstrCONS10)
      apply fastsimp    
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectL)
  prefer 3 apply fastsimp
  apply (rule UniLoad)
      apply (rule InstrCONS11)
      apply fastsimp    
      apply (rule AL_update1)
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectL)
  prefer 3 apply fastsimp
  apply (rule UniLoad)
      apply (rule InstrCONS12)
      apply fastsimp    
      apply (rule AL_update4, rule AL_update4, rule AL_update4, rule AL_update1) apply clarsimp apply clarsimp apply clarsimp
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectL)
  prefer 3 apply fastsimp
  apply (rule UniPut)
      apply (rule InstrCONS13)
      apply fastsimp    
      apply (rule AL_update1)
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectL)
  prefer 3 apply fastsimp
  apply (rule UniLoad)
      apply (rule InstrCONS14)
      apply fastsimp    
      apply (rule AL_update1) 
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectL)
  prefer 3 apply fastsimp
  apply (rule UniLoad)
      apply (rule InstrCONS15)
      apply fastsimp    
      apply (rule AL_update4, rule AL_update1) apply clarsimp
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectL)
  prefer 3 apply fastsimp
  apply (rule UniPut)
      apply (rule InstrCONS16)
      apply fastsimp    
      apply (rule AL_update1)
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectL)
  prefer 3 apply fastsimp
  apply (rule UniLoad)
      apply (rule InstrCONS17)
      apply fastsimp    
      apply (rule AL_update1) 
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule_tac H=emp and N=emp and K=emp in TypingFrame)
  apply (rule TypingRetRet)
      apply (rule InstrCONS18)
      apply (rule InstrCROSS10)
      apply simp 
      apply simp
      apply (simp add: RSD_sum_def)
        apply (rule, simp)
        apply (rule, simp)
        apply (rule, simp)
        apply (rule, simp)
        apply (rule, simp)
        apply (rule, simp)
        apply (rule, rule AL_UPD, rule AL_UPD, erule AL_UPD)
        apply (rule, erule AL_UPD)
        apply (rule, erule AL_UPD)
        apply (rule, rule AL_sum_emp2)
        apply (rule, rule AL_sum_emp2)
        apply (rule, rule AL_sum_emp2)
        apply (simp add: AL_dom_emp AL_dom_upd1) 
      apply (simp add: RSD_sum_def)
        apply (simp (no_asm) add: AL_sum_def AL_dom_upd1 AL_dom_emp)
          apply (rule, simp add: AL_sum_def AL_dom_upd1 AL_dom_emp) 
          apply (simp add: contained_def, rule, clarsimp)
            apply (drule AL_upd_split)
            apply (erule disjE) apply clarsimp apply (erule AL_sum4) apply (rule AL_update1)
            apply clarsimp
            apply (drule AL_upd_split)
            apply (erule disjE) apply clarsimp 
            apply clarsimp
            apply (drule AL_upd_split)
            apply (erule disjE) apply clarsimp 
            apply clarsimp
            apply (frule AL_sum_split, assumption)
            apply (erule disjE) apply (erule AL_sum3) apply assumption 
            apply (erule AL_sum4) apply (rule AL_update4, assumption) apply (drule AL_domI, simp add: AL_dom_upd1 AL_sum_def)
          apply (rule, simp add: AL_emp1)
          apply (rule, simp add: AL_sum_def AL_dom_upd1 AL_dom_emp)
          apply (rule, clarsimp, drule AL_upd_split)
            apply (erule disjE, clarsimp) apply (erule AL_sum4) apply (rule AL_update1)
            apply clarsimp
            apply (drule AL_sum_split, assumption)
            apply (erule disjE) apply (erule AL_sum3) apply assumption
            apply (drule AL_upd_split)
            apply (erule disjE) apply clarsimp 
            apply clarsimp apply (erule AL_sum4) apply (erule AL_update4, assumption)
          apply (rule, simp add: AL_emp1)
          apply (rule, simp add: AL_sum_def AL_dom_upd1 AL_dom_emp) apply fast
          apply (rule, clarsimp, drule AL_upd_split)
            apply (erule disjE, clarsimp) apply (erule AL_sum3)  apply (erule AL_sum4) apply (rule AL_update1)
            apply clarsimp
            apply (drule AL_sum_split, assumption)
            apply (erule disjE) 
              apply (erule AL_sum3)
              apply (drule AL_sum_split, assumption)
              apply (erule disjE) apply (erule AL_sum3) apply assumption 
              apply (erule AL_sum4) apply (erule AL_update4) apply assumption
            apply (erule AL_sum4) apply assumption
          apply (simp add: AL_emp1)
apply (case_tac \<Omega>, clarsimp)
(*case \<Omega>=[]*)
apply (rule_tac U="W ConsCopy" and L="{Suc(Suc (Suc (Suc (Suc (Suc (Suc (Suc 0)))))))}" in UniInjectL)
  (*needs subclass_of NIL LIST; prefer 2 apply (erule W_ConsCopy_verified) apply simp apply simp apply assumption+*)
  prefer 3 apply fastsimp
  prefer 3 apply clarsimp
           apply (subgoal_tac "(G3, (?\<Sigma>1.1252 NMM' \<gamma> \<upsilon> \<upsilon>' HK HK' NM \<epsilon> \<omega> \<theta> \<theta>' HH HH' NN NNN', 
                 upd(upd(upd(upd emp \<omega> (classTP NIL)) \<gamma> (classTP CONS)) \<theta> (classTP NIL)) \<upsilon>' (classTP CONS),
                [\<omega>, \<upsilon>', \<upsilon>'], emp[this\<mapsto>\<gamma>], 
                upd(upd(upd(upd emp \<omega> (NIL, emp)) \<gamma> (CONS, emp[HD\<mapsto>\<epsilon>][TL\<mapsto>\<omega>])) \<upsilon>' (CONS, emp)) \<upsilon>' (CONS, emp[HD\<mapsto>\<epsilon>])),
           ConsCopy, Suc (Suc (Suc (Suc (Suc (Suc (Suc (Suc 0))))))), Cross, Suc (Suc (Suc (Suc (Suc (Suc (Suc (Suc 0))))))), True,
           ([\<upsilon>], emp, HK), NMM', [\<upsilon>'], emp, HK')
          \<in> Typing", assumption) 
           apply (rule TypingInj)
           apply (rule_tac U="W Cross" and L="{Suc (Suc (Suc (Suc (Suc (Suc (Suc (Suc (Suc 0))))))))}" in UniInjectR)
           prefer 3 apply fastsimp
           prefer 3 apply clarsimp
                    apply (erule TypingInj)
(*    apply (rule_tac c=\<theta>' and
                  HH="emp[\<omega>\<mapsto>(NIL, emp)][\<gamma>\<mapsto>(CONS, emp[HD\<mapsto>\<epsilon>][TL\<mapsto>\<omega>])][\<upsilon>'\<mapsto>(CONS, emp[HD\<mapsto>\<epsilon>])]" in UniInvV3)*)
    apply (rule_tac c=\<theta>' in UniInvV3)
    apply (rule InstrCROSS8)
    apply (simp add: ListCopy_def) 
    apply fastsimp    
    apply (rule absFrameNil) apply fastsimp
    apply (rule AL_update4, rule AL_update4, rule AL_update4, rule AL_update1) apply (simp add: AL_dom_upd1 AL_dom_emp)
      apply (simp add: AL_dom_upd1 AL_dom_emp) apply (simp add: AL_dom_upd1 AL_dom_emp)
    apply simp
    apply simp
    apply assumption
    apply clarsimp apply (erule_tac x=E in allE, erule impE, assumption) apply clarsimp
        apply (rule_tac x="emp[0 \<mapsto> (new NIL)][1 \<mapsto> vreturn]" in exI)
        apply (rule_tac x=0 in exI)
        apply (rule, simp add: NilCopy_def)
(*        apply (rule_tac \<Sigma>="([], emp[this\<mapsto>\<omega>], emp[\<omega>\<mapsto>(NIL, emp)])" and
                       H="emp[\<gamma>\<mapsto>(CONS, emp[HD\<mapsto>\<epsilon>][TL\<mapsto>\<omega>])][\<upsilon>'\<mapsto>(CONS, emp[HD\<mapsto>\<epsilon>])]" and
                       HH="emp[\<omega>\<mapsto>(NIL, emp)][\<theta>'\<mapsto>(NIL, emp)]" and
                       NN="emp[\<omega>\<mapsto>(classTP NIL)][\<theta>'\<mapsto>(classTP NIL)]" in UniBSFrame)*)
(*        apply (rule_tac \<Sigma>="([], emp[this\<mapsto>\<omega>], emp[\<omega>\<mapsto>(NIL, emp)])" and
                       H="emp[\<gamma>\<mapsto>(CONS, emp[HD\<mapsto>\<epsilon>][TL\<mapsto>\<omega>])]" and
                       N="emp[\<theta>\<mapsto>(classTP NIL)][\<gamma>\<mapsto>(classTP CONS)]" and
                       HH="emp[\<omega>\<mapsto>(NIL, emp)][\<theta>'\<mapsto>(NIL, emp)]" and
                       NN="emp[\<omega>\<mapsto>(classTP NIL)][\<theta>'\<mapsto>(classTP NIL)]" in UniBSFrame)*)
       apply (rule_tac \<Sigma>="([], emp[this\<mapsto>\<omega>], emp[\<omega>\<mapsto>(NIL, emp)])" and
                       H="emp[\<gamma>\<mapsto>(CONS, emp[HD\<mapsto>\<epsilon>][TL\<mapsto>\<omega>])][\<upsilon>'\<mapsto>(CONS, emp[HD\<mapsto>\<epsilon>])]" and
                       HH="emp[\<omega>\<mapsto>(NIL, emp)][\<theta>'\<mapsto>(NIL, emp)]"and
                       N="upd (upd (upd emp \<gamma> (classTP CONS)) \<theta> (classTP NIL)) \<upsilon>' (classTP CONS)" and
                       NN="emp[\<omega>\<mapsto>(classTP NIL)][\<theta>'\<mapsto>(classTP NIL)]" and
                       NNN="emp[\<omega>\<mapsto>(classTP NIL)]" in UniBSFrame)
         apply (rule UniAx) apply (simp add: W_def) apply (rule disjI1)
            apply (rule, simp add: NilCopy_def)
            apply (simp add: Sp_def) apply (rule_tac x=\<omega> in exI, simp add: preS_def starOpt_def star_def)
                                     apply (simp (no_asm) add: AL_sum_def AL_dom_upd1 AL_dom_emp contained_def)
                                     apply (rule, clarsimp)
                                       apply (rule AL_update4, assumption) 
                                       apply (drule AL_domI) apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp)
                                     apply (rule, clarsimp)
                                       apply (drule AL_upd_split)
                                       apply (erule disjE, clarsimp) apply (rule AL_update1)
                                       apply (simp add: AL_emp1)
                                     apply rule  apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp)
                                     apply (rule, rule AL_UPD, rule AL_UPD, rule AL_EMP)
                                     apply (rule, clarsimp)
                                       apply (rule AL_update4, assumption) 
                                       apply (drule AL_domI) apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp)
                                     apply (rule, clarsimp)
                                       apply (drule AL_upd_split)
                                       apply (erule disjE, clarsimp) apply (rule AL_update1)
                                       apply (simp add: AL_emp1)
                                     apply rule  apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp)
                                     apply (rule AL_UPD, rule AL_UPD, rule AL_EMP)
                apply (simp (no_asm) add: SD_sum_def AL_sum_def contained_def AL_dom_upd1 AL_dom_emp)
                                     apply (rule, clarsimp)
                                       apply (rule AL_update4, rule AL_update4, rule AL_update4, assumption) 
                                       apply (drule AL_domI) apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp)
                                       apply (drule AL_domI) apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp)
                                       apply (drule AL_domI) apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp)
                                     apply (rule, clarsimp)
                                       apply (drule AL_upd_split)
                                       apply (erule disjE, clarsimp) apply (rule AL_update1)
                                       apply clarsimp
                                       apply (rule AL_update4)
                                         apply (rule AL_update4)
                                          apply (drule AL_upd_split)
                                           apply (erule disjE, clarsimp) apply (rule AL_update1)
                                           apply (simp add: AL_emp1)
                                         apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp)
                                       apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp)
                                     apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp)
                apply (simp (no_asm) add: SD_sum_def AL_sum_def contained_def AL_dom_upd1 AL_dom_emp)
                                     apply (rule, simp add: AL_sum_def AL_dom_upd1 AL_dom_emp) apply fast
                                     apply (rule, clarsimp)
                                       apply (drule AL_upd_split)
                                       apply (erule disjE, clarsimp)
                                         apply (rule AL_sum4, assumption) apply (rule AL_update4) apply (rule AL_update1)
                                           apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp) 
                                       apply clarsimp apply (rule AL_sum3, assumption) apply (rule AL_update4) apply assumption
                                           apply (drule AL_domI) apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp) 
                                     apply (rule, clarsimp)
                                       apply (drule AL_upd_split)
                                       apply (erule disjE, clarsimp) apply (erule AL_sum4) apply (rule AL_update1)
                                       apply clarsimp
                                       apply (drule AL_upd_split)
                                       apply (erule disjE, clarsimp) apply (erule AL_sum3) apply (rule AL_update1)
                                       apply (simp add: AL_emp1)
                                     apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp) apply clarsimp
                apply (simp (no_asm) add: AL_sum_def contained_def AL_dom_upd1 AL_dom_emp)
                                     apply (rule, clarsimp)
                                       apply (rule AL_update4, rule AL_update4, rule AL_update4, assumption) 
                                         apply (drule AL_domI) apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp) 
                                         apply (drule AL_domI) apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp) 
                                         apply (drule AL_domI) apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp) 
                                     apply clarsimp
                                       apply (drule AL_upd_split)
                                       apply (erule disjE, clarsimp) apply (rule AL_update1)
                                       apply clarsimp
                                       apply (rule AL_update4) 
                                         apply (drule AL_upd_split)
                                         apply (erule disjE, clarsimp) apply (rule AL_update1)
                                         apply clarsimp
                                         apply (rule AL_update4) 
                                           apply (drule AL_upd_split)
                                           apply (erule disjE, clarsimp) apply (rule AL_update1)
                                           apply (simp add: AL_emp1)
                                         apply assumption
                                       apply assumption
(*                apply (subgoal_tac "AL_sum emp[\<omega>\<mapsto>(classTP NIL)][\<theta>'\<mapsto>(classTP NIL)] emp[\<theta>\<mapsto>(classTP NIL)][\<gamma>\<mapsto>(classTP CONS)] 
                                           (emp[\<omega>\<mapsto>(classTP NIL)][\<theta>'\<mapsto>(classTP NIL)][\<theta>\<mapsto>(classTP NIL)][\<gamma>\<mapsto>(classTP CONS)])", assumption)*)
                  apply (simp (no_asm) add: AL_sum_def contained_def AL_dom_upd1 AL_dom_emp)
                                     apply (rule, simp add: AL_sum_def AL_dom_upd1 AL_dom_emp) apply fast
                                     apply (rule, clarsimp)
                                       apply (drule AL_upd_split)
                                       apply (erule disjE,clarsimp)
                                         apply (erule AL_sum4) apply (rule AL_update4, rule AL_update1)
                                         apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp)
                                       apply clarsimp
                                         apply (erule AL_sum3) apply (erule AL_sum3)
                                         apply (rule AL_update4, assumption)
                                         apply (drule AL_domI) apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp)
                                     apply clarsimp
                                       apply (drule AL_upd_split)
                                       apply (erule disjE, clarsimp) apply (erule AL_sum4) apply (rule AL_update1)
                                       apply clarsimp
                                       apply (drule AL_upd_split)
                                       apply (erule disjE, clarsimp) apply (erule AL_sum3) apply (erule AL_sum4) apply (rule AL_update1)
                                       apply clarsimp
                                       apply (drule AL_upd_split)
                                       apply (erule disjE, clarsimp) apply (erule AL_sum3) apply (erule AL_sum3) apply (rule AL_update1)
                                       apply (simp add: AL_emp1)
                apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp) apply (rule, clarsimp) apply clarsimp
  prefer 2 apply (rule_tac c=\<theta> in UniInvV3)(*and
                  HH="emp[\<omega>\<mapsto>(NIL, emp)][\<theta>\<mapsto>(NIL, emp)][\<gamma>\<mapsto>(CONS, emp[HD\<mapsto>\<epsilon>][TL\<mapsto>\<omega>])]*)
    apply (rule InstrCONS7)
    apply (simp add: ListCopy_def)
    apply fastsimp
    apply (rule absFrameNil) apply fastsimp
    apply (rule AL_update4, rule AL_update1) apply (simp add: AL_dom_upd1 AL_dom_emp)
    apply simp
    apply simp
    apply (rule AL_UPD, rule AL_UPD, rule AL_UPD, rule AL_UPD, rule AL_EMP)
    apply clarsimp apply (erule_tac x=E in allE, erule impE, assumption) apply clarsimp
        apply (rule_tac x="emp[0 \<mapsto> (new NIL)][1 \<mapsto> vreturn]" in exI)
        apply (rule_tac x=0 in exI)
        apply (rule, simp add: NilCopy_def)
        apply (rule_tac \<Sigma>="([], emp[this\<mapsto>\<omega>], emp[\<omega>\<mapsto>(NIL, emp)])" and
                       H="emp[\<gamma>\<mapsto>(CONS, emp[HD\<mapsto>\<epsilon>][TL\<mapsto>\<omega>])]" and 
                       N="emp[\<gamma>\<mapsto>(classTP CONS)][\<upsilon>'\<mapsto>(classTP CONS)]" and
                       HH="emp[\<omega>\<mapsto>(NIL, emp)][\<theta>\<mapsto>(NIL, emp)]" and
                       NN="emp[\<omega>\<mapsto>(classTP NIL)][\<theta>\<mapsto>(classTP NIL)]" in UniBSFrame)
         apply (rule UniAx) apply (simp add: W_def) apply (rule disjI1)
            apply (rule, simp add: NilCopy_def)
            apply (simp add: Sp_def) apply (rule_tac x=\<omega> in exI, simp add: preS_def starOpt_def star_def)
                                     apply (simp (no_asm) add: AL_sum_def AL_dom_upd1 AL_dom_emp contained_def)
                                     apply (rule, simp)
                                     apply (rule, clarsimp)
                                       apply (rule AL_update4, assumption) 
                                       apply (drule AL_domI) apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp)
                                     apply (rule, clarsimp)
                                       apply (drule AL_upd_split)
                                       apply (erule disjE, clarsimp) apply (rule AL_update1)
                                       apply (simp add: AL_emp1)
                                     apply rule  apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp)
                                     apply (rule, rule AL_UPD, rule AL_UPD, rule AL_EMP)
                                     apply (rule, clarsimp)
                                       apply (rule AL_update4, assumption) 
                                       apply (drule AL_domI) apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp)
                                     apply (rule, clarsimp)
                                       apply (drule AL_upd_split)
                                       apply (erule disjE, clarsimp) apply (rule AL_update1)
                                       apply (simp add: AL_emp1)
                                     apply rule  apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp)
                                     apply (rule AL_UPD, rule AL_UPD, rule AL_EMP)
                apply (simp (no_asm) add: SD_sum_def AL_sum_def contained_def AL_dom_upd1 AL_dom_emp)
                                     apply (rule, clarsimp)
                                       apply (rule AL_update4, assumption) 
                                       apply (drule AL_domI) apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp)
                                     apply (rule, clarsimp)
                                       apply (drule AL_upd_split)
                                       apply (erule disjE, clarsimp) apply (rule AL_update1)
                                       apply (simp add: AL_emp1)
                                      apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp)
                apply (simp (no_asm) add: SD_sum_def AL_sum_def contained_def AL_dom_upd1 AL_dom_emp)
                                     apply (rule,simp add: AL_sum_def AL_dom_upd1 AL_dom_emp) apply fast
                                     apply (rule, clarsimp)
                                       apply (drule AL_upd_split)
                                       apply (erule disjE, clarsimp)
                                         apply (erule AL_sum4) apply (rule AL_update1) 
                                       apply clarsimp
                                          apply (erule AL_sum3)
                                         apply (rule AL_update4, assumption) 
                                         apply (drule AL_domI) apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp) 
                                     apply (rule, clarsimp)
                                       apply (erule AL_sum3)
                                       apply (drule AL_upd_split)
                                       apply (erule disjE, clarsimp) apply (rule AL_update1)
                                       apply (simp add: AL_emp1)
                                       apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp) apply clarsimp
                apply (simp (no_asm) add: AL_sum_def contained_def AL_dom_upd1 AL_dom_emp)
                                     apply (rule, clarsimp)
                                       apply (rule AL_update4, rule AL_update4, assumption) 
                                       apply (drule AL_domI) apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp) 
                                       apply (drule AL_domI) apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp) 
                                     apply clarsimp
                                       apply (drule AL_upd_split)
                                       apply (erule disjE, clarsimp) apply (rule AL_update1)
                                       apply clarsimp
                                       apply (rule AL_update4)
                                         apply (drule AL_upd_split)
                                         apply (erule disjE, clarsimp) apply (rule AL_update1)
                                         apply (simp add: AL_emp1)
                                       apply (drule AL_domI) apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp) 
                  apply (simp (no_asm) add: AL_sum_def contained_def AL_dom_upd1 AL_dom_emp)
                                     apply (rule, simp add: AL_sum_def AL_dom_upd1 AL_dom_emp) apply fast
                                     apply (rule, clarsimp)
                                       apply (rule AL_update4)
                                         apply (drule AL_upd_split)
                                         apply (erule disjE, clarsimp) apply (rule AL_update1)
                                         apply clarsimp
                                         apply (rule AL_update4, rule AL_update4, assumption) 
                                       apply (drule AL_domI) apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp) 
                                       apply (drule AL_domI) apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp) 
                                     apply (drule AL_domI) apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp) apply clarsimp 
                                   apply clarsimp
                                       apply (drule AL_upd_split)
                                       apply (erule disjE, clarsimp) apply (rule AL_update1)
                                       apply clarsimp
                                       apply (rule AL_update4)
                                         apply (drule AL_upd_split)
                                         apply (erule disjE, clarsimp) apply (rule AL_update4) apply (rule AL_update1)
                                           apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp) 
                                         apply (simp add: AL_emp1)
                                       apply (drule AL_domI) apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp) 
                apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp) apply clarsimp

(*Case last non-empty*)
prefer 3
apply clarsimp
  apply (case_tac "ListN ba zs", clarsimp, clarsimp) 
  apply (case_tac "ListHP ba zs", clarsimp, clarsimp)
  apply (case_tac "ListHP b list", clarsimp, clarsimp) 
  apply (case_tac "ListN b list", clarsimp, clarsimp)
  apply (case_tac "ListN bb zsa", clarsimp, clarsimp) 
  apply (case_tac "ListHP bb zsa", clarsimp, clarsimp)
  apply (drule if_split, clarsimp)
  apply (drule if_split, clarsimp)
  apply (drule if_split, clarsimp)
  apply (drule if_split, clarsimp)
  apply (drule if_split, clarsimp)
  apply (drule if_split, clarsimp)
  apply (rename_tac \<delta> \<alpha> A \<beta> B \<beta>' B' M K H N M' K')
  apply (subgoal_tac "AL_dom H[\<omega>\<mapsto>(CONS, emp[HD\<mapsto>\<delta>][TL\<mapsto>\<alpha>])] \<inter> AL_dom K[\<theta>\<mapsto>(CONS, emp[HD\<mapsto>\<delta>][TL\<mapsto>\<beta>])] = {}")
  prefer 2 apply (simp add: AL_dom_upd1)
  apply (frule_tac N="H[\<omega>\<mapsto>(CONS, emp[HD\<mapsto>\<delta>][TL\<mapsto>\<alpha>])]" and M="K[\<theta>\<mapsto>(CONS, emp[HD\<mapsto>\<delta>][TL\<mapsto>\<beta>])]" in AL_sum_exists_AL) 
          apply (erule exE, rename_tac KK, erule conjE)
  apply (subgoal_tac "AL_dom H[\<omega>\<mapsto>(CONS, emp[HD\<mapsto>\<delta>][TL\<mapsto>\<alpha>])] \<inter> AL_dom K'[\<theta>'\<mapsto>(CONS, emp[HD\<mapsto>\<delta>][TL\<mapsto>\<beta>'])] = {}")
  prefer 2 apply (simp add: AL_dom_upd1)
  apply (frule_tac N="H[\<omega>\<mapsto>(CONS, emp[HD\<mapsto>\<delta>][TL\<mapsto>\<alpha>])]" and M="K'[\<theta>'\<mapsto>(CONS, emp[HD\<mapsto>\<delta>][TL\<mapsto>\<beta>'])]" in AL_sum_exists_AL) 
          apply (erule exE, rename_tac KK', erule conjE)
  apply (subgoal_tac "AL_dom N[\<omega>\<mapsto>(classTP CONS)] \<inter> AL_dom M[\<theta>\<mapsto>(classTP CONS)] = {}")
  prefer 2 apply (simp add: AL_dom_upd1)
  apply (frule_tac N="N[\<omega>\<mapsto>(classTP CONS)]" and M="M[\<theta>\<mapsto>(classTP CONS)]" in AL_sum_exists_AL) 
          apply (erule exE, rename_tac MM, erule conjE) 
  apply (subgoal_tac "AL_dom MM \<inter> AL_dom M'[\<theta>'\<mapsto>(classTP CONS)] = {}")
  prefer 2 apply (simp add: AL_dom_upd1 AL_sum_def)
  apply (frule_tac N=MM and M="M'[\<theta>'\<mapsto>(classTP CONS)]" in AL_sum_exists_AL) 
          apply (erule exE, rename_tac MMM', erule conjE) 
apply (rule_tac U="W ConsCopy" and L="{Suc(Suc (Suc (Suc (Suc (Suc (Suc (Suc 0)))))))}" in UniInjectL)
  (*needs subclass_of NIL LIST; prefer 2 apply (erule W_ConsCopy_verified) apply simp apply simp apply assumption+*)
  prefer 3 apply fastsimp
  prefer 3 apply clarsimp
           apply (rule TypingInj)
           apply (rule_tac U="W Cross" and L="{Suc (Suc (Suc (Suc (Suc (Suc (Suc (Suc (Suc 0))))))))}" in UniInjectR)
           prefer 3 apply fastsimp
           prefer 3 apply clarsimp
                    apply (erule TypingInj)
(*    apply (rule_tac c=\<theta>' and
                  HH="emp[\<omega>\<mapsto>(NIL, emp)][\<gamma>\<mapsto>(CONS, emp[HD\<mapsto>\<epsilon>][TL\<mapsto>\<omega>])][\<upsilon>'\<mapsto>(CONS, emp[HD\<mapsto>\<epsilon>])]" in UniInvV3)*)
    apply (rule_tac c=\<theta>' and HH=HH' in UniInvV3)
(*    apply (rule InstrCONS7)
    apply (simp add: ListCopy_def) *)
    apply (rule InstrCROSS8)
    apply (simp add: ListCopy_def) 
    apply fastsimp    
    apply (rule absFrameNil) apply fastsimp
    apply (rule AL_update4, rule AL_update4, rule AL_update4) apply (rule AL_update1) apply (simp add: AL_dom_upd1 AL_dom_emp) 
      apply (simp add: AL_dom_upd1 AL_dom_emp) apply (simp add: AL_dom_upd1 AL_dom_emp) 
    apply simp
    apply simp
    apply assumption
    apply clarsimp
        apply (erule_tac x=E in allE, erule impE, assumption) apply clarsimp
(*        apply (rule_tac x="fst(snd ConsCopy)" in exI)*)
        apply (rule_tac x="fst(snd Cross)" in exI)
(*        apply (rule_tac x=0 in exI)
        apply (rule, simp add: ConsCopy_def)
*)        apply (rule_tac x=0 in exI)
        apply (rule, simp add: Cross_def)here
       apply (rule_tac \<Sigma>="([], emp[this\<mapsto>\<omega>], H[\<omega>\<mapsto>(CONS, emp[HD\<mapsto>\<delta>][TL\<mapsto>\<alpha>])])" and
                       H="K'[\<gamma>\<mapsto>(CONS, emp[HD\<mapsto>\<epsilon>][TL\<mapsto>\<omega>])][\<upsilon>'\<mapsto>(CONS, emp[HD\<mapsto>\<epsilon>])]" and
                       HH="H[\<omega>\<mapsto>(CONS,emp[HD\<mapsto>\<delta>][TL\<mapsto>\<alpha>])][\<theta>'\<mapsto>(CONS, emp[HD\<mapsto>\<delta>][TL\<mapsto>\<beta>'])]" and
                       NNN="N[\<omega>\<mapsto>(classTP CONS)]" and
                       NN=MM in UniBSFrame)
(*                       N="upd (upd (upd XXX \<gamma> (classTP CONS)) \<theta> (classTP NIL)) \<upsilon>' (classTP CONS)" and
                       NN="YYY[\<omega>\<mapsto>(classTP NIL)][\<theta>'\<mapsto>(classTP NIL)]" and
                       NNN="ZZZ" in UniBSFrame)
*)
(*       apply (rule_tac \<Sigma>="([], emp[this\<mapsto>\<omega>], emp[\<omega>\<mapsto>(NIL, emp)])" and
                       H="emp[\<gamma>\<mapsto>(CONS, emp[HD\<mapsto>\<epsilon>][TL\<mapsto>\<omega>])][\<upsilon>'\<mapsto>(CONS, emp[HD\<mapsto>\<epsilon>])]" and
                       HH="emp[\<omega>\<mapsto>(NIL, emp)][\<theta>'\<mapsto>(NIL, emp)]"and
                       N="upd (upd (upd emp \<gamma> (classTP CONS)) \<theta> (classTP NIL)) \<upsilon>' (classTP CONS)" and
                       NN="emp[\<omega>\<mapsto>(classTP NIL)][\<theta>'\<mapsto>(classTP NIL)]" and
                       NNN="emp[\<omega>\<mapsto>(classTP NIL)]" in UniBSFrame)
        apply (rule_tac H="emp[\<gamma>\<mapsto>(CONS, upd(upd emp HD \<epsilon>) TL \<omega>)]"
                     and K="upd(upd emp \<gamma> (CONS, upd(upd emp HD \<epsilon>) TL \<omega>)) \<upsilon>' (CONS, emp[HD\<mapsto>\<epsilon>])" 
                     and N="upd(upd emp \<gamma> (classTP CONS))\<upsilon>' (classTP CONS)"
                     and \<gamma>="(([],emp[this\<mapsto>\<omega>],upd H \<omega> (CONS, emp[HD\<mapsto>\<delta>][TL\<mapsto>\<alpha>])),
                              N[\<omega>\<mapsto>(classTP CONS)],
                             ([],emp[this\<mapsto>\<omega>],upd H \<omega> (CONS, emp[HD\<mapsto>\<delta>][TL\<mapsto>\<alpha>])))"in TypingFrame)*)
        apply (rule UniAx) apply(simp add: W_def) apply (rule disjI2)
            apply (rule_tac x="Suc (length A)" in exI, simp add: Sp_def Cross_def)
              apply (rule_tac x=\<omega> in exI, rule_tac x="(\<delta>,\<alpha>)#A" in exI, simp add: preS_def)
              apply (rule_tac x="(\<delta>,\<beta>)#B" in exI, simp add: starOpt_def star_def)
        prefer 2 apply (simp add: RSD_sum_def)
          apply (rule, rule AL_UPD, rule AL_UPD) apply (erule ListHP_AL)
          apply (rule, rule AL_UPD, rule AL_UPD, rule AL_UPD, rule AL_UPD) apply (erule ListHP_AL)
          apply (rule, rule AL_UPD, rule AL_UPD, rule AL_UPD) apply (erule ListN_AL)
          apply rule apply (simp (no_asm) add: AL_sum_def)
            apply rule apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp)
            apply (simp add: contained_def)
            apply (rule, clarsimp)
              apply (rule AL_update4, assumption)
              apply (drule_tac d=a in AL_domI, simp add: AL_dom_upd1) apply clarsimp
            apply clarsimp
              apply (drule AL_upd_split)
              apply (erule disjE) apply clarsimp apply (rule AL_update1)
              apply (simp add: AL_emp1)
          apply rule apply (simp (no_asm) add: AL_sum_def)
            apply rule apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp)
            apply (simp add: contained_def)
            apply (rule, clarsimp)
              apply (rule AL_update4, rule AL_update4, rule AL_update4, assumption)
              apply (drule_tac d=a in AL_domI, simp add: AL_dom_upd1) apply clarsimp
              apply (drule_tac d=a in AL_domI, simp add: AL_dom_upd1) apply clarsimp
              apply (drule_tac d=a in AL_domI, simp add: AL_dom_upd1) apply clarsimp
            apply clarsimp
              apply (drule AL_upd_split)
              apply (erule disjE) apply clarsimp apply (rule AL_update1)
              apply clarsimp
              apply (drule AL_upd_split)
              apply (erule disjE) apply clarsimp apply (rule AL_update4, rule AL_update4, rule AL_update1)
                apply assumption apply assumption
              apply (simp add: AL_emp1)
          apply rule apply (simp (no_asm) add: AL_sum_def)
            apply rule apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp)
            apply (simp add: contained_def)
            apply (rule, clarsimp)
              apply (rule AL_update4, rule AL_update4, assumption)
              apply (drule_tac d=a in AL_domI, simp add: AL_dom_upd1) apply clarsimp
              apply (drule_tac d=a in AL_domI, simp add: AL_sum_def AL_dom_upd1) apply clarsimp
            apply clarsimp
              apply (drule AL_upd_split)
              apply (erule disjE) apply clarsimp apply (rule AL_update1)
              apply clarsimp
              apply (drule AL_upd_split)
              apply (erule disjE) apply clarsimp apply (rule AL_update4, rule AL_update1)
                apply assumption 
              apply (simp add: AL_emp1)
          apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp)
        apply (rule TypingAx) apply (simp (no_asm_simp) add: G3_def)
          apply (rule disjI2)
          apply (rule_tac x="Suc(length A)" in exI, simp add: ConsCopy_def Cross_def  RelSp2_def preS_def)
          apply (rule_tac x=\<omega> in exI, rule_tac x="(\<delta>,\<alpha>)#A" in exI, clarsimp)
          apply (rule_tac x=\<theta> in exI, rule_tac x="(\<delta>,\<beta>)#B" in exI, clarsimp)
          apply (rule_tac x=\<theta>' in exI, rule_tac x="(\<delta>,\<beta>')#B'" in exI, clarsimp)
            apply (simp add: starOpt_def star_def)
            apply (rule, rule, assumption)
            apply (rule, assumption)
            apply (rule, rule, assumption)
            apply (rule, assumption)
            apply (rule, rule, rule, assumption)
            apply (rule, assumption)
            apply (rule, assumption)
            apply (rule, assumption)
            apply simp
        apply (simp add: RSD_sum_def)
          apply rule apply (simp (no_asm) add: AL_sum_def)
            apply rule apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp) apply fast
            apply (simp add: contained_def)
            apply (rule, clarsimp)
              apply (frule AL_sum_split, assumption)
              apply (erule disjE)
                apply (erule AL_sum3) apply (erule AL_update4) apply (drule AL_domI, simp add: AL_sum_def AL_dom_upd1) apply clarsimp
              apply (erule AL_sum4) apply assumption
            apply clarsimp
              apply (drule AL_upd_split)
              apply (erule disjE) apply clarsimp apply (erule AL_sum3) apply (rule AL_update1)
              apply (simp add: AL_emp1)
          apply rule apply (simp (no_asm) add: AL_sum_def)
            apply rule apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp) apply fast
            apply (simp add: contained_def)
            apply (rule, clarsimp)
              apply (frule AL_sum_split, assumption)
              apply (erule disjE)
                apply (erule AL_sum3) apply (erule AL_update4) apply (drule AL_domI, simp add: AL_sum_def AL_dom_upd1) apply clarsimp
              apply (erule AL_sum4) apply (rule AL_update4, assumption) apply (drule AL_domI, simp add: AL_sum_def AL_dom_upd1) apply clarsimp 
            apply clarsimp
              apply (drule AL_upd_split)
              apply (erule disjE) apply clarsimp apply (erule AL_sum4) apply (rule AL_update1)
              apply clarsimp
              apply (drule AL_upd_split)
              apply (erule disjE) apply clarsimp apply (erule AL_sum3) apply (rule AL_update1)
              apply (simp add: AL_emp1)
          apply rule apply (simp (no_asm) add: AL_sum_def)
            apply rule apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp) apply fast
            apply (simp add: contained_def)
            apply (rule, clarsimp)
              apply (drule AL_sum_split, assumption)
              apply (erule disjE)
                apply (frule AL_sum_split, assumption)
                apply (erule disjE) apply (erule AL_sum3) apply (erule AL_sum3) apply (erule AL_update4) 
                  apply (drule_tac H=MM in AL_domI, simp add: AL_sum_def AL_dom_upd1) apply clarsimp 
                apply (erule AL_sum3) apply (erule AL_sum4) apply assumption
              apply (erule AL_sum4) apply (rule AL_update4, assumption) 
                  apply (drule_tac H="M'[\<theta>'\<mapsto>(classTP CONS)]" in AL_domI, simp add: AL_sum_def AL_dom_upd1) apply clarsimp 
            apply clarsimp
              apply (drule AL_upd_split)
              apply (erule disjE) apply clarsimp apply (erule AL_sum4) apply (rule AL_update1)
              apply clarsimp
              apply (drule AL_upd_split)
              apply (erule disjE) apply clarsimp apply (erule AL_sum3) apply (erule AL_sum3) apply (rule AL_update1)
              apply (simp add: AL_emp1)
          apply (simp add: AL_dom_upd1 AL_dom_emp AL_sum_def) apply clarsimp apply (rule, clarsimp) apply (rule, clarsimp)
            apply (rule, clarsimp) apply clarsimp
done
subsubsection{*Verification of $G_3$ from Section 5.3*}

lemma G3_verified:
  "\<lbrakk>TL \<noteq> HD; distinct [h, t, z, this]; distinct [NIL,CONS,LIST];       
    \<forall> D . subclass_of D  NIL \<longrightarrow> D = NIL; \<forall> D . subclass_of D CONS \<longrightarrow> D = CONS;
    mbody_is LIST Copy ListCopy; mbody_is LIST CrossCopy ListCopy;
    mbody_is NIL Copy NilCopy; mbody_is NIL CrossCopy NilCopy;
    mbody_is CONS Copy ConsCopy; mbody_is CONS CrossCopy Cross\<rbrakk> 
    \<Longrightarrow> CtxtVerified G3"
(*<*)
apply (simp add: G3_def CtxtVerified_def, clarsimp)
apply (rule, clarsimp) apply (rotate_tac -3, erule thin_rl, erule thin_rl)
  apply (simp add: RelSp2_def) 
  apply (rule, simp add: preserved_def starOptDEF, clarsimp)
    apply (rule, simp add: AL_sum_def, clarsimp) apply (erule contained_transitive, assumption)
    apply (simp add: preS_def AL_sum_def, clarsimp) apply (rule, fast) apply fast
  apply clarsimp
  apply (subgoal_tac "(G3,((a, aa, b), emp[\<gamma>\<mapsto>(classTP NIL)], a, aa, b), NilCopy, 0, NilCopy, 0, False, ([\<upsilon>], emp, H), ak, [\<upsilon>'], emp, K)
          \<in> Typing", simp add: G3_def RelSp2_def)
  apply (simp add: preS_def, clarsimp)
  apply (rename_tac N)
  apply (rule UniInjectL)
  apply (rule_tac cl=\<upsilon> and D=NIL and C=NIL in UniNew)
    apply (rule InstrNIL0)
    prefer 8 apply fastsimp
    apply fastsimp
    apply (simp add: starOptDEF AL_dom_upd1 AL_dom_emp)
    apply simp
    apply (simp add: subclass_of_refl)
    apply simp
    apply simp
    apply (rule UniCtxtVerified_emp)
    (* apply fast *)
    apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectR)
  apply (rule_tac cl=\<upsilon>' and D=NIL and C=NIL in UniNew)
    apply (rule InstrNIL0)
    prefer 8 apply fastsimp
    apply fastsimp
    apply (simp add: starOptDEF AL_dom_upd1 AL_dom_emp AL_sum_def) 
    apply simp
    apply (simp add: subclass_of_refl)
    apply simp
    apply simp
    apply (rule UniCtxtVerified_emp)
    (* apply fast *)
    apply clarsimp
    apply (rule TypingInj)
    apply (rule_tac H=emp and K=emp and N=emp in TypingFrame)
    apply (rule TypingRetRet)
      apply (rule InstrNIL1)
      apply (rule InstrNIL1)
      apply simp
      apply simp
      apply (simp add: RSD_sum_def) apply (rule, simp) apply (rule, simp) apply (rule, simp)
        apply (rule, simp) apply (rule, simp) apply (rule, simp) 
        apply (rule, rule AL_UPD, rule AL_UPD) apply (rule AL_EMP) 
        apply (rule, rule AL_UPD, rule AL_UPD) apply (rule AL_EMP)  
        apply (rule, rule AL_UPD, rule AL_UPD, rule AL_UPD) apply (rule AL_EMP)  
        apply (rule, rule AL_sum_emp2)
        apply (rule, rule AL_sum_emp2)
        apply (rule, rule AL_sum_emp2)
        apply (simp add: AL_dom_emp)
      apply (simp add: RSD_sum_def starOptDEF, clarsimp)
        apply (rule, simp add: AL_sum_def AL_dom_emp AL_dom_upd1) 
          apply (rule, simp (no_asm) add: contained_def, clarsimp) 
            apply (drule AL_upd_split)
            apply (erule disjE) apply clarsimp apply (erule contained3, rule AL_update1) 
            apply clarsimp 
            apply (drule AL_upd_split)
            apply (erule disjE) apply clarsimp apply (erule contained3, rule AL_update1) 
            apply (simp add: AL_emp1)
          apply (rule contained_emp)
        apply (rule, simp add: AL_sum_def AL_dom_emp AL_dom_upd1) 
          apply (rule, simp (no_asm) add: contained_def, clarsimp) 
            apply (drule AL_upd_split)
            apply (erule disjE) apply clarsimp apply (erule contained3, rule AL_update1) 
            apply clarsimp 
            apply (drule AL_upd_split)
            apply (erule disjE) apply clarsimp apply (erule contained3, rule AL_update1) 
            apply (simp add: AL_emp1)
          apply (rule contained_emp)
        apply (rule, simp add: AL_sum_def AL_dom_emp AL_dom_upd1) 
          apply (rule, simp (no_asm) add: contained_def, clarsimp) 
            apply (drule AL_upd_split)
            apply (erule disjE) apply clarsimp apply (erule contained3, rule AL_update1) 
            apply clarsimp 
            apply (drule AL_upd_split)
            apply (erule disjE) apply clarsimp apply (erule contained3, erule contained3, rule AL_update1) 
            apply clarsimp
            apply (drule AL_upd_split)
            apply (erule disjE) apply clarsimp apply (erule contained3, erule contained3, rule AL_update1) 
            apply (simp add: AL_emp1)
          apply (rule contained_emp)
        apply (rule, simp add: AL_dom_emp)
        apply (rule, simp add: AL_dom_emp)
        apply (simp add: AL_dom_emp)
(*n>0*)
apply (rule, clarsimp)
  apply (rotate_tac -3, erule thin_rl, erule thin_rl)
  apply (rule, simp add: preserved_def RelSp2_def preS_def starOptDEF, clarsimp)
    apply (simp add: AL_sum_def, clarsimp)  
      apply (rule, erule contained_transitive, assumption) 
      apply fast
  apply (subgoal_tac "(G3,((ad, ae, bb), af, ag, ah, bc),
           ConsCopy, 0, Cross, 0, False, (ai, aj, bd), ak, al, am, be)
          \<in> Typing", simp add: G3_def)
  apply (simp add: RelSp2_def preS_def, clarsimp)
  apply (case_tac "ListHP \<gamma> \<Lambda>", clarsimp,clarsimp)
  apply (simp add: starOptDEF, clarsimp)
  apply (rename_tac NMM' \<gamma> \<Lambda> \<upsilon> \<Upsilon> \<upsilon>' \<Upsilon>' HK HK' H N NM K K' M M')
  apply (case_tac \<Lambda>, clarsimp,clarsimp) 
  apply (case_tac "ListN b list", clarsimp,clarsimp) 
  apply (case_tac "ListHP b list", clarsimp,clarsimp) 
  apply (case_tac "ListN ba zs", clarsimp,clarsimp) 
  apply (case_tac "ListHP ba zs", clarsimp,clarsimp) 
  apply (case_tac "ListN bb zsa", clarsimp,clarsimp) 
  apply (case_tac "ListHP bb zsa", clarsimp,clarsimp) 
  apply (drule if_split, clarsimp)
  apply (drule if_split, clarsimp)
  apply (drule if_split, clarsimp)
  apply (drule if_split, clarsimp)
  apply (drule if_split, clarsimp)
  apply (drule if_split, clarsimp)
  apply (rename_tac \<epsilon> \<omega> \<Omega> \<theta> \<Theta> \<theta>' \<Theta>' N H M K M' K')
  apply (rule UniInjectL)
    apply (rule UniLoad)
      apply (rule InstrCONS0)
      prefer 7 apply fastsimp
      apply fastsimp
      apply (rule AL_update1)
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectR)
    apply (rule_tac cl=\<upsilon>' and C=CONS and D=CONS in UniNew)
      apply (rule InstrCROSS0)
      prefer 8 apply fastsimp    
      apply fastsimp
      apply (simp add: AL_sum_def AL_dom_upd1) 
      apply simp
      apply (simp add: subclass_of_refl)
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectL)
  prefer 3 apply fastsimp
  apply (rule UniGet)
      apply (rule InstrCONS1)
      apply fastsimp   
      apply (rule AL_update1)
      apply (rule AL_update4) apply (rule AL_update1) apply assumption
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectR)
  prefer 3 apply fastsimp
  apply (rule UniDup)
      apply (rule InstrCROSS1)
      apply fastsimp    
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectL)
  prefer 3 apply fastsimp
  apply (rule UniStore)
      apply (rule InstrCONS2)
      apply fastsimp    
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectR)
  prefer 3 apply fastsimp
  apply (rule UniDup)
      apply (rule InstrCROSS2)
      apply fastsimp    
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectL)
  prefer 3 apply fastsimp
  apply (rule UniLoad)
      apply (rule InstrCONS3)
      apply fastsimp    
      apply (rule AL_update4, rule AL_update1) apply fastsimp
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectR)
  prefer 3 apply fastsimp
  apply (rule UniLoad)
      apply (rule InstrCROSS3)
      apply fastsimp    
      apply (rule AL_update1) 
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectL)
  prefer 3 apply fastsimp
  apply (rule UniGet)
      apply (rule InstrCONS4)
      apply fastsimp    
      apply (rule AL_update1)
      apply (rule AL_update1) 
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectR)
  prefer 3 apply fastsimp
  apply (rule UniGet)
      apply (rule InstrCROSS4)
      apply fastsimp    
      apply (rule AL_update4, rule AL_update1) apply (simp add: AL_dom_upd1)
      apply (rule AL_update4, rule AL_update1) apply assumption
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectL)
  prefer 3 apply fastsimp
  apply (rule UniStore)
      apply (rule InstrCONS5)
      apply fastsimp    
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectL)
  prefer 3 apply fastsimp
  apply (rule UniLoad)
      apply (rule InstrCONS6)
      apply fastsimp    
      apply (rule AL_update1)
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectR)
  prefer 3 apply fastsimp
  apply (rule UniPut)
      apply (rule InstrCROSS5)
      apply fastsimp    
      apply (rule AL_update1) 
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectR)
  prefer 3 apply fastsimp
  apply (rule UniLoad)
      apply (rule InstrCROSS6)
      apply fastsimp    
      apply (rule AL_update1) 
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectR)
  prefer 3 apply fastsimp
  apply (rule UniGet)
      apply (rule InstrCROSS7)
      apply fastsimp    
      apply (rule AL_update4, rule AL_update4, rule AL_update1) apply (simp add: AL_dom_upd1) apply (simp add: AL_dom_upd1)
      apply (rule AL_update1) 
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
apply (subgoal_tac "AL_dom (H[\<gamma>\<mapsto>(CONS, emp[HD\<mapsto>\<epsilon>][TL\<mapsto>\<omega>])]) \<inter> AL_dom K = {}")
prefer 2 apply (simp add: AL_sum_def AL_dom_upd1)
apply (frule_tac M=K in AL_sum_exists_AL) apply (erule exE, rename_tac HH, erule conjE)
apply (subgoal_tac "AL_dom (H[\<gamma>\<mapsto>(CONS, emp[HD\<mapsto>\<epsilon>][TL\<mapsto>\<omega>])]) \<inter> AL_dom K'[\<upsilon>'\<mapsto>(CONS, emp[HD\<mapsto>\<epsilon>])] = {}")
prefer 2 apply (simp add: AL_sum_def AL_dom_upd1)
apply (frule_tac M="K'[\<upsilon>'\<mapsto>(CONS, emp[HD\<mapsto>\<epsilon>])]" in AL_sum_exists_AL) apply (erule exE, rename_tac HH', erule conjE)
apply (subgoal_tac "AL_dom N[\<gamma>\<mapsto>(classTP CONS)] \<inter> AL_dom M = {}")
prefer 2 apply (simp add: AL_sum_def AL_dom_upd1)
apply (frule_tac M=M in AL_sum_exists_AL) apply (erule exE, rename_tac NN, erule conjE)
apply (subgoal_tac "AL_dom NN \<inter> AL_dom M'[\<upsilon>'\<mapsto>(classTP CONS)] = {}")
prefer 2 apply (simp add: AL_sum_def AL_dom_upd1)
apply (frule_tac N=NN and M="M'[\<upsilon>'\<mapsto>(classTP CONS)]" in AL_sum_exists_AL) apply (erule exE, rename_tac NNN', erule conjE)
apply (subgoal_tac "(G3, (([\<theta>], emp[this\<mapsto>\<gamma>][h\<mapsto>\<epsilon>][t\<mapsto>\<omega>], HH), NNN', [\<theta>', \<upsilon>', \<upsilon>'], emp[this\<mapsto>\<gamma>],HH'),
           ConsCopy, Suc(Suc (Suc (Suc (Suc (Suc (Suc (Suc 0))))))), Cross, Suc(Suc (Suc (Suc (Suc (Suc (Suc (Suc (Suc 0)))))))), False, ([\<upsilon>], emp, HK), NMM', [\<upsilon>'], emp,
           HK')
          \<in> Typing")
prefer 2
  apply (rule UniInjectL)
  prefer 3 apply fastsimp
  apply (rule UniStore)
      apply (rule InstrCONS8)
      apply fastsimp    
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectR)
  prefer 3 apply fastsimp
  apply (rule UniPut)
      apply (rule InstrCROSS9)
      apply fastsimp    
      apply (erule AL_sum4, rule AL_update1)
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectL)
  apply (rule_tac cl=\<upsilon> and C=CONS and D=CONS in UniNew)
      apply (rule InstrCONS9)
      prefer 8 apply fastsimp    
      apply fastsimp
      apply (simp add: AL_sum_def AL_dom_upd1) apply clarsimp
      apply simp
      apply (simp add: subclass_of_refl)
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectL)
  prefer 3 apply fastsimp
  apply (rule UniStore)
      apply (rule InstrCONS10)
      apply fastsimp    
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectL)
  prefer 3 apply fastsimp
  apply (rule UniLoad)
      apply (rule InstrCONS11)
      apply fastsimp    
      apply (rule AL_update1)
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectL)
  prefer 3 apply fastsimp
  apply (rule UniLoad)
      apply (rule InstrCONS12)
      apply fastsimp    
      apply (rule AL_update4, rule AL_update4, rule AL_update4, rule AL_update1) apply clarsimp apply clarsimp apply clarsimp
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectL)
  prefer 3 apply fastsimp
  apply (rule UniPut)
      apply (rule InstrCONS13)
      apply fastsimp    
      apply (rule AL_update1)
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectL)
  prefer 3 apply fastsimp
  apply (rule UniLoad)
      apply (rule InstrCONS14)
      apply fastsimp    
      apply (rule AL_update1) 
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectL)
  prefer 3 apply fastsimp
  apply (rule UniLoad)
      apply (rule InstrCONS15)
      apply fastsimp    
      apply (rule AL_update4, rule AL_update1) apply clarsimp
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectL)
  prefer 3 apply fastsimp
  apply (rule UniPut)
      apply (rule InstrCONS16)
      apply fastsimp    
      apply (rule AL_update1)
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectL)
  prefer 3 apply fastsimp
  apply (rule UniLoad)
      apply (rule InstrCONS17)
      apply fastsimp    
      apply (rule AL_update1) 
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule_tac H=emp and N=emp and K=emp in TypingFrame)
  apply (rule TypingRetRet)
      apply (rule InstrCONS18)
      apply (rule InstrCROSS10)
      apply simp 
      apply simp
      apply (simp add: RSD_sum_def)
        apply (rule, simp)
        apply (rule, simp)
        apply (rule, simp)
        apply (rule, simp)
        apply (rule, simp)
        apply (rule, simp)
        apply (rule, rule AL_UPD, rule AL_UPD, erule AL_UPD)
        apply (rule, erule AL_UPD)
        apply (rule, erule AL_UPD)
        apply (rule, rule AL_sum_emp2)
        apply (rule, rule AL_sum_emp2)
        apply (rule, rule AL_sum_emp2)
        apply (simp add: AL_dom_emp AL_dom_upd1) 
      apply (simp add: RSD_sum_def)
        apply (simp (no_asm) add: AL_sum_def AL_dom_upd1 AL_dom_emp)
          apply (rule, simp add: AL_sum_def AL_dom_upd1 AL_dom_emp) 
          apply (simp add: contained_def, rule, clarsimp)
            apply (drule AL_upd_split)
            apply (erule disjE) apply clarsimp apply (erule AL_sum4) apply (rule AL_update1)
            apply clarsimp
            apply (drule AL_upd_split)
            apply (erule disjE) apply clarsimp 
            apply clarsimp
            apply (drule AL_upd_split)
            apply (erule disjE) apply clarsimp 
            apply clarsimp
            apply (frule AL_sum_split, assumption)
            apply (erule disjE) apply (erule AL_sum3) apply assumption 
            apply (erule AL_sum4) apply (rule AL_update4, assumption) apply (drule AL_domI, simp add: AL_dom_upd1 AL_sum_def)
          apply (rule, simp add: AL_emp1)
          apply (rule, simp add: AL_sum_def AL_dom_upd1 AL_dom_emp)
          apply (rule, clarsimp, drule AL_upd_split)
            apply (erule disjE, clarsimp) apply (erule AL_sum4) apply (rule AL_update1)
            apply clarsimp
            apply (drule AL_sum_split, assumption)
            apply (erule disjE) apply (erule AL_sum3) apply assumption
            apply (drule AL_upd_split)
            apply (erule disjE) apply clarsimp 
            apply clarsimp apply (erule AL_sum4) apply (erule AL_update4, assumption)
          apply (rule, simp add: AL_emp1)
          apply (rule, simp add: AL_sum_def AL_dom_upd1 AL_dom_emp) apply fast
          apply (rule, clarsimp, drule AL_upd_split)
            apply (erule disjE, clarsimp) apply (erule AL_sum3)  apply (erule AL_sum4) apply (rule AL_update1)
            apply clarsimp
            apply (drule AL_sum_split, assumption)
            apply (erule disjE) 
              apply (erule AL_sum3)
              apply (drule AL_sum_split, assumption)
              apply (erule disjE) apply (erule AL_sum3) apply assumption 
              apply (erule AL_sum4) apply (erule AL_update4) apply assumption
            apply (erule AL_sum4) apply assumption
          apply (simp add: AL_emp1)
apply (case_tac \<Omega>, clarsimp)
(*case \<Omega>=[]*)
  apply (rule TypingInvVInvV3)
    apply (rule InstrCONS7)
    apply (simp add: ListCopy_def) 
    apply (rule InstrCROSS8)
    apply (simp add: ListCopy_def) 
    apply fastsimp    
    apply (rule absFrameNil) apply fastsimp
    apply (rule absFrameNil) apply fastsimp
    apply clarsimp apply (erule TypingInj) 
    apply (rule AL_update4) apply (rule AL_update1) apply (simp add: AL_dom_upd1 AL_dom_emp) 
    apply (rule AL_update4) apply (rule AL_update4, rule AL_update4, rule AL_update1) 
      apply (simp add: AL_dom_upd1 AL_dom_emp) apply (simp add: AL_dom_upd1 AL_dom_emp) 
      apply (simp add: AL_dom_upd1 AL_dom_emp)
    apply clarsimp
        apply (subgoal_tac "D1'=NIL", clarsimp) prefer 2 apply (erule_tac x=D1' in allE, erule mp, assumption)
        apply (subgoal_tac "D2'=NIL", clarsimp) prefer 2 apply (erule_tac x=D2' in allE, erule mp, assumption)
        apply (rule_tac x="emp[0 \<mapsto> (new NIL)][1 \<mapsto> vreturn]" in exI)
        apply (rule_tac x="emp[0 \<mapsto> (new NIL)][1 \<mapsto> vreturn]" in exI)
        apply (rule_tac x=0 in exI)
        apply (rule, simp add: NilCopy_def) 
        apply (rule_tac x=0 in exI)
        apply (rule, simp add: NilCopy_def) 
        apply (subgoal_tac "AL_dom emp[\<omega>\<mapsto>(NIL, emp)] \<inter> AL_dom emp[\<theta>\<mapsto>(NIL, emp)] = {}")
        prefer 2 apply (simp add: AL_dom_upd1 AL_dom_emp)
        apply (frule_tac M="emp[\<theta>\<mapsto>(NIL, emp)]" and N="emp[\<omega>\<mapsto>(NIL, emp)]" in AL_sum_exists_AL)
        apply (erule exE) apply (rename_tac HHKK, erule conjE)
        apply (subgoal_tac "AL_dom emp[\<omega>\<mapsto>(NIL, emp)] \<inter> AL_dom emp[\<theta>'\<mapsto>(NIL, emp)] = {}")
        prefer 2 apply (simp add: AL_dom_upd1 AL_dom_emp)
        apply (frule_tac M="emp[\<theta>'\<mapsto>(NIL, emp)]" and N="emp[\<omega>\<mapsto>(NIL, emp)]" in AL_sum_exists_AL)
        apply (erule exE) apply (rename_tac HHKK', erule conjE)
        apply (subgoal_tac "AL_dom emp[\<omega>\<mapsto>(classTP NIL)] \<inter> AL_dom emp[\<theta>\<mapsto>(classTP NIL)] = {}")
        prefer 2 apply (simp add: AL_dom_upd1 AL_dom_emp)
        apply (frule_tac M="emp[\<theta>\<mapsto>(classTP NIL)]" and N="emp[\<omega>\<mapsto>(classTP NIL)]" in AL_sum_exists_AL)
        apply (erule exE) apply (rename_tac NNMM, erule conjE)
        apply (subgoal_tac "AL_dom NNMM \<inter> AL_dom emp[\<theta>'\<mapsto>(classTP NIL)] = {}")
        prefer 2 apply (simp add: AL_dom_upd1 AL_dom_emp AL_sum_def)
        apply (frule_tac M="emp[\<theta>'\<mapsto>(classTP NIL)]" and N=NNMM in AL_sum_exists_AL)
        apply (erule exE) apply (rename_tac NNMM', erule conjE)
        apply (rule_tac \<gamma>="(([],emp[this\<mapsto>\<omega>],emp[\<omega>\<mapsto>(NIL, emp)]),emp[\<omega>\<mapsto>(classTP NIL)],([],emp[this\<mapsto>\<omega>],emp[\<omega>\<mapsto>(NIL, emp)]))"
                     and H="emp[\<gamma>\<mapsto>(CONS, upd(upd emp HD \<epsilon>) TL \<omega>)]"
                     and N="upd(upd emp \<gamma> (classTP CONS)) \<upsilon>' (classTP CONS)"
                     and K="upd(upd emp \<gamma> (CONS, upd(upd emp HD \<epsilon>) TL \<omega>)) \<upsilon>' (CONS, emp[HD\<mapsto>\<epsilon>])"
                    in TypingFrame)
        prefer 2 apply (simp add: RSD_sum_def)
                 apply (rule, rule AL_UPD, rule AL_UPD, rule AL_EMP)
                 apply (rule, rule AL_UPD, rule AL_UPD, rule AL_UPD, rule AL_UPD, rule AL_EMP)
                 apply (rule, rule AL_UPD, rule AL_UPD, rule AL_UPD, rule AL_EMP)
                 apply (rule, simp (no_asm) add: AL_sum_def)
                   apply (simp add: AL_dom_upd1 AL_dom_emp contained_def)
                   apply (rule, clarsimp) 
                     apply (drule AL_upd_split)
                     apply (erule disjE, clarsimp) apply (rule AL_update4) apply (rule AL_update1) apply assumption
                     apply (simp add: AL_emp1)
                   apply clarsimp 
                     apply (drule AL_upd_split)
                     apply (erule disjE, clarsimp) apply (rule AL_update1)
                     apply (simp add: AL_emp1)
                 apply (rule, simp (no_asm) add: AL_sum_def)
                   apply (simp add: AL_dom_upd1 AL_dom_emp contained_def)
                   apply (rule, clarsimp) 
                     apply (drule AL_upd_split)
                     apply (erule disjE, clarsimp) apply (rule AL_update4) apply (rule AL_update4) 
                        apply (rule AL_update4) apply (rule AL_update1) apply assumption apply assumption apply assumption
                     apply (simp add: AL_emp1)
                   apply clarsimp 
                     apply (drule AL_upd_split)
                     apply (erule disjE, clarsimp) apply (rule AL_update1)
                     apply (clarsimp, drule AL_upd_split)
                     apply (erule disjE, clarsimp) apply (rule AL_update4, rule AL_update4) apply (rule AL_update1)
                       apply assumption apply assumption
                     apply (simp add: AL_emp1)
                 apply (rule, simp (no_asm) add: AL_sum_def)
                   apply (simp add: AL_dom_upd1 AL_dom_emp contained_def)
                   apply (rule, clarsimp) 
                     apply (drule AL_upd_split)
                     apply (erule disjE, clarsimp) apply (rule AL_update4) apply (rule AL_update4) 
                       apply (rule AL_update1) apply assumption apply assumption 
                     apply (simp add: AL_emp1)
                   apply clarsimp 
                     apply (drule AL_upd_split)
                     apply (erule disjE, clarsimp) apply (rule AL_update1)
                     apply (clarsimp, drule AL_upd_split)
                     apply (erule disjE, clarsimp) apply (rule AL_update4) apply (rule AL_update1)
                       apply assumption 
                     apply (simp add: AL_emp1)
                 apply (simp add: AL_dom_upd1 AL_dom_emp)
        apply (rule TypingAx) apply (simp add: G3_def) apply (rule disjI1)
                              apply (simp add: RelSp2_def)
                              apply (rule, simp add: NilCopy_def)
                              apply (rule_tac x=\<omega> in exI, rule_tac x="[]" in exI)
                              apply (simp add: preS_def)
                              apply (rule_tac x=\<theta> in exI, rule_tac x="[]" in exI) apply (simp add: star_def starOpt_def)
                              apply (rule_tac x=\<theta>' in exI, rule_tac x="[]" in exI)
                              apply (rule, rule, assumption)
                              apply (rule, assumption)
                              apply (rule, assumption)
                              apply (rule, rule, rule_tac x="emp[\<theta>'\<mapsto>(NIL,emp)]" in exI) apply (rule, simp)
                              apply (rule, assumption)
                              apply (rule, assumption)
                              apply assumption
                         apply (rule, rule, rule, assumption)
                         apply (rule, assumption) 
                         apply (rule, rule_tac x="emp[\<theta>'\<mapsto>(classTP NIL)]" in exI) apply (rule, simp)
                              apply (rule, assumption)
                              apply (rule, assumption)
                              apply assumption
                         apply simp
        apply (simp add: RSD_sum_def)
          apply (rule, simp (no_asm) add: AL_sum_def)
                   apply (rule, simp add: AL_sum_def  AL_dom_upd1 AL_dom_emp) apply fast
                   apply (simp add: contained_def)
                   apply (rule, clarsimp) 
                     apply (frule AL_sum_split, assumption) 
                     apply (erule disjE) 
                       apply (drule AL_upd_split)
                       apply (erule disjE, clarsimp) apply (erule AL_sum3, rule AL_update4) apply (rule AL_update1) 
                         apply (simp add: AL_dom_upd1)
                       apply (simp add: AL_emp1)
                     apply (drule AL_upd_split)
                     apply (erule disjE, clarsimp) apply (erule AL_sum4, rule AL_update1) 
                     apply (simp add: AL_emp1)
                   apply clarsimp
                     apply (drule AL_upd_split)
                     apply (erule disjE, clarsimp) apply (erule AL_sum3, rule AL_update1) 
                     apply (simp add: AL_emp1)
          apply (rule, simp (no_asm) add: AL_sum_def)
                   apply (rule, simp add: AL_sum_def  AL_dom_upd1 AL_dom_emp) apply fast
                   apply (simp add: contained_def)
                   apply (rule, clarsimp) 
                     apply (frule AL_sum_split, assumption) 
                     apply (erule disjE) 
                       apply (drule AL_upd_split)
                       apply (erule disjE, clarsimp) apply (erule AL_sum3, rule AL_update4) apply (rule AL_update1) 
                         apply (simp add: AL_dom_upd1)
                       apply (simp add: AL_emp1)
                     apply (drule AL_upd_split)
                     apply (erule disjE, clarsimp) apply (erule AL_sum4, rule AL_update4, rule AL_update1) 
                       apply (drule AL_domI, simp add: AL_sum_def AL_dom_upd1)
                     apply (simp add: AL_emp1)
                   apply clarsimp
                     apply (drule AL_upd_split)
                     apply (erule disjE, clarsimp) apply (erule AL_sum4, rule AL_update1) 
                     apply clarsimp
                     apply (drule AL_upd_split)
                     apply (erule disjE, clarsimp) apply (erule AL_sum3, rule AL_update1) 
                     apply (simp add: AL_emp1)
          apply (rule, simp (no_asm) add: AL_sum_def)
                   apply (rule, simp add: AL_sum_def  AL_dom_upd1 AL_dom_emp) apply fast
                   apply (simp add: contained_def)
                   apply (rule, clarsimp) 
                     apply (drule AL_sum_split, assumption) 
                     apply (erule disjE) 
                       apply (frule AL_sum_split, assumption)
                       apply (erule disjE) 
                         apply (drule AL_upd_split)
                         apply (erule disjE, clarsimp) apply (erule AL_sum3) apply (erule AL_sum3, rule AL_update4) apply (rule AL_update1) 
                           apply (simp add: AL_dom_upd1)
                         apply (simp add: AL_emp1)
                       apply (drule AL_upd_split)
                       apply (erule disjE, clarsimp) apply (erule AL_sum3) apply(erule AL_sum4, rule AL_update1) 
                       apply (simp add: AL_emp1)
                     apply (rule AL_sum4, assumption) apply (rule AL_update4, assumption) 
                       apply (drule_tac H="emp[\<theta>'\<mapsto>(classTP NIL)]" in AL_domI, simp add: AL_sum_def AL_dom_upd1)
                   apply clarsimp
                     apply (drule AL_upd_split)
                     apply (erule disjE, clarsimp) apply (erule AL_sum4) apply(rule AL_update1)
                     apply clarsimp 
                     apply (erule AL_sum3)
                     apply (drule AL_upd_split)
                     apply (erule disjE, clarsimp) apply (erule AL_sum3) apply(rule AL_update1)
                     apply (simp add: AL_emp1)
          apply (simp add: AL_dom_upd1 AL_dom_emp AL_sum_def) apply (rule, clarsimp) 
            apply (rule, clarsimp) apply (rule, clarsimp) apply clarsimp 
(*Case last non-empty*)
apply clarsimp
  apply (case_tac "ListN ba zs", clarsimp, clarsimp) 
  apply (case_tac "ListHP ba zs", clarsimp, clarsimp)
  apply (case_tac "ListHP b list", clarsimp, clarsimp) 
  apply (case_tac "ListN b list", clarsimp, clarsimp)
  apply (case_tac "ListN bb zsa", clarsimp, clarsimp) 
  apply (case_tac "ListHP bb zsa", clarsimp, clarsimp)
  apply (drule if_split, clarsimp)
  apply (drule if_split, clarsimp)
  apply (drule if_split, clarsimp)
  apply (drule if_split, clarsimp)
  apply (drule if_split, clarsimp)
  apply (drule if_split, clarsimp)
  apply (rename_tac \<delta> \<alpha> A \<beta> B \<beta>' B' M K H N M' K')
  apply (subgoal_tac "AL_dom H[\<omega>\<mapsto>(CONS, emp[HD\<mapsto>\<delta>][TL\<mapsto>\<alpha>])] \<inter> AL_dom K[\<theta>\<mapsto>(CONS, emp[HD\<mapsto>\<delta>][TL\<mapsto>\<beta>])] = {}")
  prefer 2 apply (simp add: AL_dom_upd1)
  apply (frule_tac N="H[\<omega>\<mapsto>(CONS, emp[HD\<mapsto>\<delta>][TL\<mapsto>\<alpha>])]" and M="K[\<theta>\<mapsto>(CONS, emp[HD\<mapsto>\<delta>][TL\<mapsto>\<beta>])]" in AL_sum_exists_AL) 
          apply (erule exE, rename_tac KK, erule conjE)
  apply (subgoal_tac "AL_dom H[\<omega>\<mapsto>(CONS, emp[HD\<mapsto>\<delta>][TL\<mapsto>\<alpha>])] \<inter> AL_dom K'[\<theta>'\<mapsto>(CONS, emp[HD\<mapsto>\<delta>][TL\<mapsto>\<beta>'])] = {}")
  prefer 2 apply (simp add: AL_dom_upd1)
  apply (frule_tac N="H[\<omega>\<mapsto>(CONS, emp[HD\<mapsto>\<delta>][TL\<mapsto>\<alpha>])]" and M="K'[\<theta>'\<mapsto>(CONS, emp[HD\<mapsto>\<delta>][TL\<mapsto>\<beta>'])]" in AL_sum_exists_AL) 
          apply (erule exE, rename_tac KK', erule conjE)
  apply (subgoal_tac "AL_dom N[\<omega>\<mapsto>(classTP CONS)] \<inter> AL_dom M[\<theta>\<mapsto>(classTP CONS)] = {}")
  prefer 2 apply (simp add: AL_dom_upd1)
  apply (frule_tac N="N[\<omega>\<mapsto>(classTP CONS)]" and M="M[\<theta>\<mapsto>(classTP CONS)]" in AL_sum_exists_AL) 
          apply (erule exE, rename_tac MM, erule conjE) 
  apply (subgoal_tac "AL_dom MM \<inter> AL_dom M'[\<theta>'\<mapsto>(classTP CONS)] = {}")
  prefer 2 apply (simp add: AL_dom_upd1 AL_sum_def)
  apply (frule_tac N=MM and M="M'[\<theta>'\<mapsto>(classTP CONS)]" in AL_sum_exists_AL) 
          apply (erule exE, rename_tac MMM', erule conjE) 
  apply (rule TypingInvVInvV3)
    apply (rule InstrCONS7)
    apply (simp add: ListCopy_def) 
    apply (rule InstrCROSS8)
    apply (simp add: ListCopy_def) 
    apply fastsimp    
    apply (rule absFrameNil) apply fastsimp
    apply (rule absFrameNil) apply fastsimp
    apply clarsimp apply (erule TypingInj)
    apply (rule AL_update4) apply (rule AL_update1) apply (simp add: AL_dom_upd1 AL_dom_emp) 
    apply (rule AL_update4, rule AL_update4, rule AL_update4) apply (rule AL_update1) apply (simp add: AL_dom_upd1 AL_dom_emp) 
       apply (simp add: AL_dom_upd1 AL_dom_emp)  apply (simp add: AL_dom_upd1 AL_dom_emp) 
    apply clarsimp
        apply (subgoal_tac "D1'=CONS", clarsimp) prefer 2 apply (erule_tac x=D1' in allE, erule mp, assumption)
        apply (subgoal_tac "D2'=CONS", clarsimp) prefer 2 apply (erule_tac x=D2' in allE, erule mp, assumption)
        apply (rule_tac x="fst(snd ConsCopy)" in exI)
        apply (rule_tac x="fst(snd Cross)" in exI)
        apply (rule_tac x=0 in exI)
        apply (rule, simp add: ConsCopy_def)
        apply (rule_tac x=0 in exI)
        apply (rule, simp add: Cross_def)
        apply (rule_tac H="emp[\<gamma>\<mapsto>(CONS, upd(upd emp HD \<epsilon>) TL \<omega>)]"
                     and K="upd(upd emp \<gamma> (CONS, upd(upd emp HD \<epsilon>) TL \<omega>)) \<upsilon>' (CONS, emp[HD\<mapsto>\<epsilon>])" 
                     and N="upd(upd emp \<gamma> (classTP CONS))\<upsilon>' (classTP CONS)"
                     and \<gamma>="(([],emp[this\<mapsto>\<omega>],upd H \<omega> (CONS, emp[HD\<mapsto>\<delta>][TL\<mapsto>\<alpha>])),
                              N[\<omega>\<mapsto>(classTP CONS)],
                             ([],emp[this\<mapsto>\<omega>],upd H \<omega> (CONS, emp[HD\<mapsto>\<delta>][TL\<mapsto>\<alpha>])))"in TypingFrame)
        prefer 2 apply (simp add: RSD_sum_def)
          apply (rule, rule AL_UPD, rule AL_UPD) apply (erule ListHP_AL)
          apply (rule, rule AL_UPD, rule AL_UPD, rule AL_UPD, rule AL_UPD) apply (erule ListHP_AL)
          apply (rule, rule AL_UPD, rule AL_UPD, rule AL_UPD) apply (erule ListN_AL)
          apply rule apply (simp (no_asm) add: AL_sum_def)
            apply rule apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp)
            apply (simp add: contained_def)
            apply (rule, clarsimp)
              apply (rule AL_update4, assumption)
              apply (drule_tac d=a in AL_domI, simp add: AL_dom_upd1) apply clarsimp
            apply clarsimp
              apply (drule AL_upd_split)
              apply (erule disjE) apply clarsimp apply (rule AL_update1)
              apply (simp add: AL_emp1)
          apply rule apply (simp (no_asm) add: AL_sum_def)
            apply rule apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp)
            apply (simp add: contained_def)
            apply (rule, clarsimp)
              apply (rule AL_update4, rule AL_update4, rule AL_update4, assumption)
              apply (drule_tac d=a in AL_domI, simp add: AL_dom_upd1) apply clarsimp
              apply (drule_tac d=a in AL_domI, simp add: AL_dom_upd1) apply clarsimp
              apply (drule_tac d=a in AL_domI, simp add: AL_dom_upd1) apply clarsimp
            apply clarsimp
              apply (drule AL_upd_split)
              apply (erule disjE) apply clarsimp apply (rule AL_update1)
              apply clarsimp
              apply (drule AL_upd_split)
              apply (erule disjE) apply clarsimp apply (rule AL_update4, rule AL_update4, rule AL_update1)
                apply assumption apply assumption
              apply (simp add: AL_emp1)
          apply rule apply (simp (no_asm) add: AL_sum_def)
            apply rule apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp)
            apply (simp add: contained_def)
            apply (rule, clarsimp)
              apply (rule AL_update4, rule AL_update4, assumption)
              apply (drule_tac d=a in AL_domI, simp add: AL_dom_upd1) apply clarsimp
              apply (drule_tac d=a in AL_domI, simp add: AL_sum_def AL_dom_upd1) apply clarsimp
            apply clarsimp
              apply (drule AL_upd_split)
              apply (erule disjE) apply clarsimp apply (rule AL_update1)
              apply clarsimp
              apply (drule AL_upd_split)
              apply (erule disjE) apply clarsimp apply (rule AL_update4, rule AL_update1)
                apply assumption 
              apply (simp add: AL_emp1)
          apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp)
        apply (rule TypingAx) apply (simp (no_asm_simp) add: G3_def)
          apply (rule disjI2)
          apply (rule_tac x="Suc(length A)" in exI, simp add: ConsCopy_def Cross_def  RelSp2_def preS_def)
          apply (rule_tac x=\<omega> in exI, rule_tac x="(\<delta>,\<alpha>)#A" in exI, clarsimp)
          apply (rule_tac x=\<theta> in exI, rule_tac x="(\<delta>,\<beta>)#B" in exI, clarsimp)
          apply (rule_tac x=\<theta>' in exI, rule_tac x="(\<delta>,\<beta>')#B'" in exI, clarsimp)
            apply (simp add: starOpt_def star_def)
            apply (rule, rule, assumption)
            apply (rule, assumption)
            apply (rule, rule, assumption)
            apply (rule, assumption)
            apply (rule, rule, rule, assumption)
            apply (rule, assumption)
            apply (rule, assumption)
            apply (rule, assumption)
            apply simp
        apply (simp add: RSD_sum_def)
          apply rule apply (simp (no_asm) add: AL_sum_def)
            apply rule apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp) apply fast
            apply (simp add: contained_def)
            apply (rule, clarsimp)
              apply (frule AL_sum_split, assumption)
              apply (erule disjE)
                apply (erule AL_sum3) apply (erule AL_update4) apply (drule AL_domI, simp add: AL_sum_def AL_dom_upd1) apply clarsimp
              apply (erule AL_sum4) apply assumption
            apply clarsimp
              apply (drule AL_upd_split)
              apply (erule disjE) apply clarsimp apply (erule AL_sum3) apply (rule AL_update1)
              apply (simp add: AL_emp1)
          apply rule apply (simp (no_asm) add: AL_sum_def)
            apply rule apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp) apply fast
            apply (simp add: contained_def)
            apply (rule, clarsimp)
              apply (frule AL_sum_split, assumption)
              apply (erule disjE)
                apply (erule AL_sum3) apply (erule AL_update4) apply (drule AL_domI, simp add: AL_sum_def AL_dom_upd1) apply clarsimp
              apply (erule AL_sum4) apply (rule AL_update4, assumption) apply (drule AL_domI, simp add: AL_sum_def AL_dom_upd1) apply clarsimp 
            apply clarsimp
              apply (drule AL_upd_split)
              apply (erule disjE) apply clarsimp apply (erule AL_sum4) apply (rule AL_update1)
              apply clarsimp
              apply (drule AL_upd_split)
              apply (erule disjE) apply clarsimp apply (erule AL_sum3) apply (rule AL_update1)
              apply (simp add: AL_emp1)
          apply rule apply (simp (no_asm) add: AL_sum_def)
            apply rule apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp) apply fast
            apply (simp add: contained_def)
            apply (rule, clarsimp)
              apply (drule AL_sum_split, assumption)
              apply (erule disjE)
                apply (frule AL_sum_split, assumption)
                apply (erule disjE) apply (erule AL_sum3) apply (erule AL_sum3) apply (erule AL_update4) 
                  apply (drule_tac H=MM in AL_domI, simp add: AL_sum_def AL_dom_upd1) apply clarsimp 
                apply (erule AL_sum3) apply (erule AL_sum4) apply assumption
              apply (erule AL_sum4) apply (rule AL_update4, assumption) 
                  apply (drule_tac H="M'[\<theta>'\<mapsto>(classTP CONS)]" in AL_domI, simp add: AL_sum_def AL_dom_upd1) apply clarsimp 
            apply clarsimp
              apply (drule AL_upd_split)
              apply (erule disjE) apply clarsimp apply (erule AL_sum4) apply (rule AL_update1)
              apply clarsimp
              apply (drule AL_upd_split)
              apply (erule disjE) apply clarsimp apply (erule AL_sum3) apply (erule AL_sum3) apply (rule AL_update1)
              apply (simp add: AL_emp1)
          apply (simp add: AL_dom_upd1 AL_dom_emp AL_sum_def) apply clarsimp apply (rule, clarsimp) apply (rule, clarsimp)
            apply (rule, clarsimp) apply clarsimp
done
(*>*)

text{*Thus, $G_3$ is in particular verified for the program $CROSS$.*}

lemma G3_verified_CROSS:
  "\<lbrakk>TL \<noteq> HD; distinct [h, t, z, this]; distinct [NIL,CONS,LIST];       
    \<forall> D . subclass_of D  NIL \<longrightarrow> D = NIL; \<forall> D . subclass_of D CONS \<longrightarrow> D = CONS;
    P=CROSS; OptCopy \<noteq> Copy; CrossCopy \<noteq> Copy\<rbrakk> 
    \<Longrightarrow> CtxtVerified G3"
(*<*)
apply (erule G3_verified, assumption+)
apply (simp add: CROSS_def mbody_is_def, clarsimp)
  apply (rule_tac x=CrossListClass in exI)
  apply rule
    apply (subgoal_tac " emp[LIST\<mapsto>CrossListClass][NIL\<mapsto>CrossNilClass][CONS\<mapsto>CrossConsClass]\<down>LIST = Some CrossListClass", simp)
    apply (rule AL_update4, rule AL_update4, rule AL_update1) apply simp apply simp
  apply (simp add: CrossListClass_def) apply (rule AL_update4, rule AL_update4, rule AL_update1) apply (assumption, assumption)
apply (simp add: CROSS_def mbody_is_def, clarsimp)
  apply (rule_tac x=CrossListClass in exI)
  apply rule
    apply (subgoal_tac "emp[LIST\<mapsto>CrossListClass][NIL\<mapsto>CrossNilClass][CONS\<mapsto>CrossConsClass]\<down>LIST = Some CrossListClass", simp)
    apply (rule AL_update4, rule AL_update4, rule AL_update1) apply simp apply simp
  apply (simp add: CrossListClass_def) apply (rule AL_update1)
apply (simp add: CROSS_def mbody_is_def, clarsimp)
  apply (rule_tac x=CrossNilClass in exI)
  apply rule
    apply (subgoal_tac "emp[LIST\<mapsto>CrossListClass][NIL\<mapsto>CrossNilClass][CONS\<mapsto>CrossConsClass]\<down>NIL = Some CrossNilClass", simp)
    apply (rule AL_update4, rule AL_update1) apply fastsimp 
  apply (simp add: CrossNilClass_def) apply (rule AL_update4, rule AL_update4, rule AL_update1) apply (assumption, assumption)
apply (simp add: CROSS_def mbody_is_def, clarsimp)
  apply (rule_tac x=CrossNilClass in exI)
  apply rule
    apply (subgoal_tac "emp[LIST\<mapsto>CrossListClass][NIL\<mapsto>CrossNilClass][CONS\<mapsto>CrossConsClass]\<down>NIL = Some CrossNilClass", simp)
    apply (rule AL_update4, rule AL_update1) apply fastsimp 
  apply (simp add: CrossNilClass_def) apply (rule AL_update1) 
apply (simp add: CROSS_def mbody_is_def, clarsimp)
  apply (rule_tac x=CrossConsClass in exI)
  apply rule
    apply (subgoal_tac "emp[LIST\<mapsto>CrossListClass][NIL\<mapsto>CrossNilClass][CONS\<mapsto>CrossConsClass]\<down>CONS = Some CrossConsClass", simp)
    apply (rule AL_update1) 
  apply (simp add: CrossConsClass_def) apply (rule AL_update4, rule AL_update4, rule AL_update1) apply (assumption, assumption)
apply (simp add: CROSS_def mbody_is_def, clarsimp)
  apply (rule_tac x=CrossConsClass in exI)
  apply rule
    apply (subgoal_tac "emp[LIST\<mapsto>CrossListClass][NIL\<mapsto>CrossNilClass][CONS\<mapsto>CrossConsClass]\<down>CONS = Some CrossConsClass", simp)
    apply (rule AL_update1) 
  apply (simp add: CrossConsClass_def) apply (rule AL_update1) 
done
(*>*)

(*requires ListSL_UnaryVerif  *)
  prefer 3 apply fastsimp
  (*prefer 2 apply simp*)
defer
apply clarsimp
apply (rule TypingInj)
apply (rule_tac U="W Cross" and L="{Suc(Suc(Suc(Suc (Suc (Suc (Suc (Suc (Suc 0))))))))}" in UniInjectR)
 (* prefer 2 apply (erule W_ConsOpt_verified) apply simp apply simp apply assumption+*)
  prefer 3 apply fastsimp
(*  prefer 2 apply simp *)
  apply (rule_tac c=\<theta>' and
                  HH="emp[\<omega>\<mapsto>(NIL, emp)][\<gamma>\<mapsto>(CONS, emp[HD\<mapsto>\<epsilon>][TL\<mapsto>\<omega>])][\<upsilon>'\<mapsto>(CONS, emp[HD\<mapsto>\<epsilon>])]" in UniInvV3)
    apply (rule InstrCROSS8)
    apply (simp add: ListCopy_def) 
    apply fastsimp    
    apply (rule absFrameNil) apply fastsimp
    apply (rule AL_update4, rule AL_update4, rule AL_update4, rule AL_update1) apply (simp add: AL_dom_upd1 AL_dom_emp)
      apply (simp add: AL_dom_upd1 AL_dom_emp) apply (simp add: AL_dom_upd1 AL_dom_emp)
    apply simp
    apply simp
 prefer 4 apply clarsimp apply (rule_tac H=emp and K=emp and N=emp in TypingFrame) apply (erule TypingInj)
          apply (simp add:RSD_sum_def)
          apply (rule, rule AL_UPD, rule AL_UPD, rule AL_UPD,rule AL_EMP)
          apply (rule, rule AL_UPD, rule AL_UPD, rule AL_UPD,rule AL_EMP)
          apply rule
          prefer 2 apply (rule, simp (no_asm) add: AL_sum_def)
                     apply (rule, simp add: AL_sum_def AL_dom_emp AL_dom_upd1) apply fast
                     apply (simp (no_asm) add: contained_def) 
                     apply (rule, clarsimp)
                       apply (frule AL_sum_split,assumption)
                       apply (erule disjE)
                         apply (drule AL_upd_split)
                           apply (erule disjE) apply clarsimp apply (rule AL_update1) apply clarsimp 
                           apply (rule AL_update4, rule AL_update4, assumption)
                             apply (drule AL_domI) apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp) hereXXXXXX apply fastsimp
            apply clarsimp 
            apply (drule AL_upd_split)
            apply (erule disjE) apply clarsimp apply (erule contained3, rule AL_update1) 
            apply (simp add: AL_emp1)
          apply (rule contained_emp)
 apply (simp (no_asm) add: AL_sum_def)
                     apply (rule, simp add: AL_sum_dom)
          apply (rule, subgoal_tac "NNN' : AL", assumption
    prefer 2 apply clarsimp apply (erule_tac x=E in allE, erule impE, assumption) apply clarsimp
        apply (rule_tac x="emp[0 \<mapsto> (new NIL)][1 \<mapsto> vreturn]" in exI)
        apply (rule_tac x=0 in exI)
        apply (rule, simp add: NilCopy_def)
        apply (rule_tac \<Sigma>="([], emp[this\<mapsto>\<omega>], emp[\<omega>\<mapsto>(NIL, emp)])" and
                       H="emp[\<gamma>\<mapsto>(CONS, emp[HD\<mapsto>\<epsilon>][TL\<mapsto>\<omega>])][\<upsilon>'\<mapsto>(CONS, emp[HD\<mapsto>\<epsilon>])]" and
                       HH="emp[\<omega>\<mapsto>(NIL, emp)][\<theta>'\<mapsto>(NIL, emp)]" and
                       NN="emp[\<omega>\<mapsto>(classTP NIL)][\<theta>'\<mapsto>(classTP NIL)]" in UniBSFrame)
(*        apply (rule_tac \<Sigma>="([], emp[this\<mapsto>\<omega>], emp[\<omega>\<mapsto>(NIL, emp)])" and
                       H="emp[\<gamma>\<mapsto>(CONS, emp[HD\<mapsto>\<epsilon>][TL\<mapsto>\<omega>])]" and
                       N="emp[\<theta>\<mapsto>(classTP NIL)][\<gamma>\<mapsto>(classTP CONS)]" and
                       HH="emp[\<omega>\<mapsto>(NIL, emp)][\<theta>'\<mapsto>(NIL, emp)]" and
                       NN="emp[\<omega>\<mapsto>(classTP NIL)][\<theta>'\<mapsto>(classTP NIL)]" in UniBSFrame)*)
         apply (rule UniAx) apply (simp add: W_def) apply (rule disjI1)
            apply (rule, simp add: NilCopy_def)
            apply (simp add: Sp_def) apply (rule_tac x=\<omega> in exI, simp add: preS_def starOpt_def star_def)
                                     apply (simp (no_asm) add: AL_sum_def AL_dom_upd1 AL_dom_emp contained_def)
                                     apply (rule, simp)
                                     apply (rule, clarsimp)
                                       apply (rule AL_update4, assumption) 
                                       apply (drule AL_domI) apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp)
                                     apply (rule, clarsimp)
                                       apply (drule AL_upd_split)
                                       apply (erule disjE, clarsimp) apply (rule AL_update1)
                                       apply (simp add: AL_emp1)
                                     apply rule  apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp)
                                     apply (rule, rule AL_UPD, rule AL_UPD, rule AL_EMP)
                                     apply (rule, clarsimp)
                                       apply (rule AL_update4, assumption) 
                                       apply (drule AL_domI) apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp)
                                     apply (rule, clarsimp)
                                       apply (drule AL_upd_split)
                                       apply (erule disjE, clarsimp) apply (rule AL_update1)
                                       apply (simp add: AL_emp1)
                                     apply rule  apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp)
                                     apply (rule AL_UPD, rule AL_UPD, rule AL_EMP)
                apply (simp (no_asm) add: SD_sum_def AL_sum_def contained_def AL_dom_upd1 AL_dom_emp)
                                     apply (rule, clarsimp)
                                       apply (rule AL_update4, rule AL_update4, rule AL_update4, assumption) 
                                       apply (drule AL_domI) apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp)
                                       apply (drule AL_domI) apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp)
                                       apply (drule AL_domI) apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp)
                                     apply (rule, clarsimp)
                                       apply (drule AL_upd_split)
                                       apply (erule disjE, clarsimp) apply (rule AL_update1)
                                       apply clarsimp
                                       apply (rule AL_update4)
                                         apply (rule AL_update4)
                                          apply (drule AL_upd_split)
                                           apply (erule disjE, clarsimp) apply (rule AL_update1)
                                           apply (simp add: AL_emp1)
                                         apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp)
                                       apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp)
                                     apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp)
                apply (simp (no_asm) add: SD_sum_def AL_sum_def contained_def AL_dom_upd1 AL_dom_emp)
                                     apply (rule, clarsimp)
                                       apply (rule AL_update4, assumption) 
                                       apply (drule AL_domI) apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp) apply clarsimp
                                     apply (rule, clarsimp)
                                       apply (drule AL_upd_split)
                                       apply (erule disjE, clarsimp) apply (rule AL_update1)
                                       apply (simp add: AL_emp1)
                                      apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp) apply clarsimp
                apply (simp (no_asm) add: AL_sum_def contained_def AL_dom_upd1 AL_dom_emp)
                                     apply (rule, clarsimp)
                                       apply (rule AL_update4, rule AL_update4, assumption) 
                                         apply (drule AL_domI) apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp) 
                                         apply (drule AL_domI) apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp) 
                                     apply clarsimp
                                       apply (drule AL_upd_split)
                                       apply (erule disjE, clarsimp) apply (rule AL_update1)
                                       apply clarsimp
                                       apply (rule AL_update4) 
                                         apply (drule AL_upd_split)
                                         apply (erule disjE, clarsimp) apply (rule AL_update1)
                                         apply (simp add: AL_emp1)
                                       apply assumption
                apply (subgoal_tac "AL_sum emp[\<omega>\<mapsto>(classTP NIL)][\<theta>'\<mapsto>(classTP NIL)] emp[\<theta>\<mapsto>(classTP NIL)][\<gamma>\<mapsto>(classTP CONS)] 
                                           (emp[\<omega>\<mapsto>(classTP NIL)][\<theta>'\<mapsto>(classTP NIL)][\<theta>\<mapsto>(classTP NIL)][\<gamma>\<mapsto>(classTP CONS)])", assumption)
                  apply (simp (no_asm) add: AL_sum_def contained_def AL_dom_upd1 AL_dom_emp)
                                     apply (rule, clarsimp)
                                       apply (rule AL_update4, rule AL_update4, assumption) 
                                       apply (drule AL_domI) apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp) apply clarsimp
                                       apply (drule AL_domI) apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp) apply clarsimp
                                     apply clarsimp
                                       apply (drule AL_upd_split)
                                       apply (erule disjE, clarsimp) apply (rule AL_update1)
                                       apply clarsimp
                                       apply (rule AL_update4)
                                         apply (drule AL_upd_split)
                                         apply (erule disjE, clarsimp) apply (rule AL_update1)
                                         apply (simp add: AL_emp1)
                                       apply assumption
                apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp) apply (rule, clarsimp) apply clarsimp
                apply (rule AL_UPD, rule AL_UPD, rule AL_UPD, rule AL_UPD, rule AL_EMP)



  apply (rule TypingInvVInvV3)
    apply (rule InstrCONS7)
    apply (simp add: ListCopy_def) 
    apply (rule InstrCROSS8)
    apply (simp add: ListCopy_def) 
    apply fastsimp    
    apply (rule absFrameNil) apply fastsimp
    apply (rule absFrameNil) apply fastsimp
    apply clarsimp apply (erule TypingInj) 
    apply (rule AL_update4) apply (rule AL_update1) apply (simp add: AL_dom_upd1 AL_dom_emp) 
    apply (rule AL_update4) apply (rule AL_update4, rule AL_update4, rule AL_update1) 
      apply (simp add: AL_dom_upd1 AL_dom_emp) apply (simp add: AL_dom_upd1 AL_dom_emp) 
      apply (simp add: AL_dom_upd1 AL_dom_emp)
    apply clarsimp
        apply (subgoal_tac "D1'=NIL", clarsimp) prefer 2 apply (erule_tac x=D1' in allE, erule mp, assumption)
        apply (subgoal_tac "D2'=NIL", clarsimp) prefer 2 apply (erule_tac x=D2' in allE, erule mp, assumption)
        apply (rule_tac x="emp[0 \<mapsto> (new NIL)][1 \<mapsto> vreturn]" in exI)
        apply (rule_tac x="emp[0 \<mapsto> (new NIL)][1 \<mapsto> vreturn]" in exI)
        apply (rule_tac x=0 in exI)
        apply (rule, simp add: NilCopy_def) 
        apply (rule_tac x=0 in exI)
        apply (rule, simp add: NilCopy_def) 
        apply (subgoal_tac "AL_dom emp[\<omega>\<mapsto>(NIL, emp)] \<inter> AL_dom emp[\<theta>\<mapsto>(NIL, emp)] = {}")
        prefer 2 apply (simp add: AL_dom_upd1 AL_dom_emp)
        apply (frule_tac M="emp[\<theta>\<mapsto>(NIL, emp)]" and N="emp[\<omega>\<mapsto>(NIL, emp)]" in AL_sum_exists_AL)
        apply (erule exE) apply (rename_tac HHKK, erule conjE)
        apply (subgoal_tac "AL_dom emp[\<omega>\<mapsto>(NIL, emp)] \<inter> AL_dom emp[\<theta>'\<mapsto>(NIL, emp)] = {}")
        prefer 2 apply (simp add: AL_dom_upd1 AL_dom_emp)
        apply (frule_tac M="emp[\<theta>'\<mapsto>(NIL, emp)]" and N="emp[\<omega>\<mapsto>(NIL, emp)]" in AL_sum_exists_AL)
        apply (erule exE) apply (rename_tac HHKK', erule conjE)
        apply (subgoal_tac "AL_dom emp[\<omega>\<mapsto>(classTP NIL)] \<inter> AL_dom emp[\<theta>\<mapsto>(classTP NIL)] = {}")
        prefer 2 apply (simp add: AL_dom_upd1 AL_dom_emp)
        apply (frule_tac M="emp[\<theta>\<mapsto>(classTP NIL)]" and N="emp[\<omega>\<mapsto>(classTP NIL)]" in AL_sum_exists_AL)
        apply (erule exE) apply (rename_tac NNMM, erule conjE)
        apply (subgoal_tac "AL_dom NNMM \<inter> AL_dom emp[\<theta>'\<mapsto>(classTP NIL)] = {}")
        prefer 2 apply (simp add: AL_dom_upd1 AL_dom_emp AL_sum_def)
        apply (frule_tac M="emp[\<theta>'\<mapsto>(classTP NIL)]" and N=NNMM in AL_sum_exists_AL)
        apply (erule exE) apply (rename_tac NNMM', erule conjE)
        apply (rule_tac \<gamma>="(([],emp[this\<mapsto>\<omega>],emp[\<omega>\<mapsto>(NIL, emp)]),emp[\<omega>\<mapsto>(classTP NIL)],([],emp[this\<mapsto>\<omega>],emp[\<omega>\<mapsto>(NIL, emp)]))"
                     and H="emp[\<gamma>\<mapsto>(CONS, upd(upd emp HD \<epsilon>) TL \<omega>)]"
                     and N="upd(upd emp \<gamma> (classTP CONS)) \<upsilon>' (classTP CONS)"
                     and K="upd(upd emp \<gamma> (CONS, upd(upd emp HD \<epsilon>) TL \<omega>)) \<upsilon>' (CONS, emp[HD\<mapsto>\<epsilon>])"
                    in TypingFrame)
        prefer 2 apply (simp add: RSD_sum_def)
                 apply (rule, rule AL_UPD, rule AL_UPD, rule AL_EMP)
                 apply (rule, rule AL_UPD, rule AL_UPD, rule AL_UPD, rule AL_UPD, rule AL_EMP)
                 apply (rule, rule AL_UPD, rule AL_UPD, rule AL_UPD, rule AL_EMP)
                 apply (rule, simp (no_asm) add: AL_sum_def)
                   apply (simp add: AL_dom_upd1 AL_dom_emp contained_def)
                   apply (rule, clarsimp) 
                     apply (drule AL_upd_split)
                     apply (erule disjE, clarsimp) apply (rule AL_update4) apply (rule AL_update1) apply assumption
                     apply (simp add: AL_emp1)
                   apply clarsimp 
                     apply (drule AL_upd_split)
                     apply (erule disjE, clarsimp) apply (rule AL_update1)
                     apply (simp add: AL_emp1)
                 apply (rule, simp (no_asm) add: AL_sum_def)
                   apply (simp add: AL_dom_upd1 AL_dom_emp contained_def)
                   apply (rule, clarsimp) 
                     apply (drule AL_upd_split)
                     apply (erule disjE, clarsimp) apply (rule AL_update4) apply (rule AL_update4) 
                        apply (rule AL_update4) apply (rule AL_update1) apply assumption apply assumption apply assumption
                     apply (simp add: AL_emp1)
                   apply clarsimp 
                     apply (drule AL_upd_split)
                     apply (erule disjE, clarsimp) apply (rule AL_update1)
                     apply (clarsimp, drule AL_upd_split)
                     apply (erule disjE, clarsimp) apply (rule AL_update4, rule AL_update4) apply (rule AL_update1)
                       apply assumption apply assumption
                     apply (simp add: AL_emp1)
                 apply (rule, simp (no_asm) add: AL_sum_def)
                   apply (simp add: AL_dom_upd1 AL_dom_emp contained_def)
                   apply (rule, clarsimp) 
                     apply (drule AL_upd_split)
                     apply (erule disjE, clarsimp) apply (rule AL_update4) apply (rule AL_update4) 
                       apply (rule AL_update1) apply assumption apply assumption 
                     apply (simp add: AL_emp1)
                   apply clarsimp 
                     apply (drule AL_upd_split)
                     apply (erule disjE, clarsimp) apply (rule AL_update1)
                     apply (clarsimp, drule AL_upd_split)
                     apply (erule disjE, clarsimp) apply (rule AL_update4) apply (rule AL_update1)
                       apply assumption 
                     apply (simp add: AL_emp1)
                 apply (simp add: AL_dom_upd1 AL_dom_emp)
        apply (rule TypingAx) apply (simp add: G3_def) apply (rule disjI1)
                              apply (simp add: RelSp2_def)
                              apply (rule, simp add: NilCopy_def)
                              apply (rule_tac x=\<omega> in exI, rule_tac x="[]" in exI)
                              apply (simp add: preS_def)
                              apply (rule_tac x=\<theta> in exI, rule_tac x="[]" in exI) apply (simp add: star_def starOpt_def)
                              apply (rule_tac x=\<theta>' in exI, rule_tac x="[]" in exI)
                              apply (rule, rule, assumption)
                              apply (rule, assumption)
                              apply (rule, assumption)
                              apply (rule, rule, rule_tac x="emp[\<theta>'\<mapsto>(NIL,emp)]" in exI) apply (rule, simp)
                              apply (rule, assumption)
                              apply (rule, assumption)
                              apply assumption
                         apply (rule, rule, rule, assumption)
                         apply (rule, assumption) 
                         apply (rule, rule_tac x="emp[\<theta>'\<mapsto>(classTP NIL)]" in exI) apply (rule, simp)
                              apply (rule, assumption)
                              apply (rule, assumption)
                              apply assumption
                         apply simp
        apply (simp add: RSD_sum_def)
          apply (rule, simp (no_asm) add: AL_sum_def)
                   apply (rule, simp add: AL_sum_def  AL_dom_upd1 AL_dom_emp) apply fast
                   apply (simp add: contained_def)
                   apply (rule, clarsimp) 
                     apply (frule AL_sum_split, assumption) 
                     apply (erule disjE) 
                       apply (drule AL_upd_split)
                       apply (erule disjE, clarsimp) apply (erule AL_sum3, rule AL_update4) apply (rule AL_update1) 
                         apply (simp add: AL_dom_upd1)
                       apply (simp add: AL_emp1)
                     apply (drule AL_upd_split)
                     apply (erule disjE, clarsimp) apply (erule AL_sum4, rule AL_update1) 
                     apply (simp add: AL_emp1)
                   apply clarsimp
                     apply (drule AL_upd_split)
                     apply (erule disjE, clarsimp) apply (erule AL_sum3, rule AL_update1) 
                     apply (simp add: AL_emp1)
          apply (rule, simp (no_asm) add: AL_sum_def)
                   apply (rule, simp add: AL_sum_def  AL_dom_upd1 AL_dom_emp) apply fast
                   apply (simp add: contained_def)
                   apply (rule, clarsimp) 
                     apply (frule AL_sum_split, assumption) 
                     apply (erule disjE) 
                       apply (drule AL_upd_split)
                       apply (erule disjE, clarsimp) apply (erule AL_sum3, rule AL_update4) apply (rule AL_update1) 
                         apply (simp add: AL_dom_upd1)
                       apply (simp add: AL_emp1)
                     apply (drule AL_upd_split)
                     apply (erule disjE, clarsimp) apply (erule AL_sum4, rule AL_update4, rule AL_update1) 
                       apply (drule AL_domI, simp add: AL_sum_def AL_dom_upd1)
                     apply (simp add: AL_emp1)
                   apply clarsimp
                     apply (drule AL_upd_split)
                     apply (erule disjE, clarsimp) apply (erule AL_sum4, rule AL_update1) 
                     apply clarsimp
                     apply (drule AL_upd_split)
                     apply (erule disjE, clarsimp) apply (erule AL_sum3, rule AL_update1) 
                     apply (simp add: AL_emp1)
          apply (rule, simp (no_asm) add: AL_sum_def)
                   apply (rule, simp add: AL_sum_def  AL_dom_upd1 AL_dom_emp) apply fast
                   apply (simp add: contained_def)
                   apply (rule, clarsimp) 
                     apply (drule AL_sum_split, assumption) 
                     apply (erule disjE) 
                       apply (frule AL_sum_split, assumption)
                       apply (erule disjE) 
                         apply (drule AL_upd_split)
                         apply (erule disjE, clarsimp) apply (erule AL_sum3) apply (erule AL_sum3, rule AL_update4) apply (rule AL_update1) 
                           apply (simp add: AL_dom_upd1)
                         apply (simp add: AL_emp1)
                       apply (drule AL_upd_split)
                       apply (erule disjE, clarsimp) apply (erule AL_sum3) apply(erule AL_sum4, rule AL_update1) 
                       apply (simp add: AL_emp1)
                     apply (rule AL_sum4, assumption) apply (rule AL_update4, assumption) 
                       apply (drule_tac H="emp[\<theta>'\<mapsto>(classTP NIL)]" in AL_domI, simp add: AL_sum_def AL_dom_upd1)
                   apply clarsimp
                     apply (drule AL_upd_split)
                     apply (erule disjE, clarsimp) apply (erule AL_sum4) apply(rule AL_update1)
                     apply clarsimp 
                     apply (erule AL_sum3)
                     apply (drule AL_upd_split)
                     apply (erule disjE, clarsimp) apply (erule AL_sum3) apply(rule AL_update1)
                     apply (simp add: AL_emp1)
          apply (simp add: AL_dom_upd1 AL_dom_emp AL_sum_def) apply (rule, clarsimp) 
            apply (rule, clarsimp) apply (rule, clarsimp) apply clarsimp 
(*Case last non-empty*)
apply clarsimp
  apply (case_tac "ListN ba zs", clarsimp, clarsimp) 
  apply (case_tac "ListHP ba zs", clarsimp, clarsimp)
  apply (case_tac "ListHP b list", clarsimp, clarsimp) 
  apply (case_tac "ListN b list", clarsimp, clarsimp)
  apply (case_tac "ListN bb zsa", clarsimp, clarsimp) 
  apply (case_tac "ListHP bb zsa", clarsimp, clarsimp)
  apply (drule if_split, clarsimp)
  apply (drule if_split, clarsimp)
  apply (drule if_split, clarsimp)
  apply (drule if_split, clarsimp)
  apply (drule if_split, clarsimp)
  apply (drule if_split, clarsimp)
  apply (rename_tac \<delta> \<alpha> A \<beta> B \<beta>' B' M K H N M' K')
  apply (subgoal_tac "AL_dom H[\<omega>\<mapsto>(CONS, emp[HD\<mapsto>\<delta>][TL\<mapsto>\<alpha>])] \<inter> AL_dom K[\<theta>\<mapsto>(CONS, emp[HD\<mapsto>\<delta>][TL\<mapsto>\<beta>])] = {}")
  prefer 2 apply (simp add: AL_dom_upd1)
  apply (frule_tac N="H[\<omega>\<mapsto>(CONS, emp[HD\<mapsto>\<delta>][TL\<mapsto>\<alpha>])]" and M="K[\<theta>\<mapsto>(CONS, emp[HD\<mapsto>\<delta>][TL\<mapsto>\<beta>])]" in AL_sum_exists_AL) 
          apply (erule exE, rename_tac KK, erule conjE)
  apply (subgoal_tac "AL_dom H[\<omega>\<mapsto>(CONS, emp[HD\<mapsto>\<delta>][TL\<mapsto>\<alpha>])] \<inter> AL_dom K'[\<theta>'\<mapsto>(CONS, emp[HD\<mapsto>\<delta>][TL\<mapsto>\<beta>'])] = {}")
  prefer 2 apply (simp add: AL_dom_upd1)
  apply (frule_tac N="H[\<omega>\<mapsto>(CONS, emp[HD\<mapsto>\<delta>][TL\<mapsto>\<alpha>])]" and M="K'[\<theta>'\<mapsto>(CONS, emp[HD\<mapsto>\<delta>][TL\<mapsto>\<beta>'])]" in AL_sum_exists_AL) 
          apply (erule exE, rename_tac KK', erule conjE)
  apply (subgoal_tac "AL_dom N[\<omega>\<mapsto>(classTP CONS)] \<inter> AL_dom M[\<theta>\<mapsto>(classTP CONS)] = {}")
  prefer 2 apply (simp add: AL_dom_upd1)
  apply (frule_tac N="N[\<omega>\<mapsto>(classTP CONS)]" and M="M[\<theta>\<mapsto>(classTP CONS)]" in AL_sum_exists_AL) 
          apply (erule exE, rename_tac MM, erule conjE) 
  apply (subgoal_tac "AL_dom MM \<inter> AL_dom M'[\<theta>'\<mapsto>(classTP CONS)] = {}")
  prefer 2 apply (simp add: AL_dom_upd1 AL_sum_def)
  apply (frule_tac N=MM and M="M'[\<theta>'\<mapsto>(classTP CONS)]" in AL_sum_exists_AL) 
          apply (erule exE, rename_tac MMM', erule conjE) 
  apply (rule TypingInvVInvV3)
    apply (rule InstrCONS7)
    apply (simp add: ListCopy_def) 
    apply (rule InstrCROSS8)
    apply (simp add: ListCopy_def) 
    apply fastsimp    
    apply (rule absFrameNil) apply fastsimp
    apply (rule absFrameNil) apply fastsimp
    apply clarsimp apply (erule TypingInj)
    apply (rule AL_update4) apply (rule AL_update1) apply (simp add: AL_dom_upd1 AL_dom_emp) 
    apply (rule AL_update4, rule AL_update4, rule AL_update4) apply (rule AL_update1) apply (simp add: AL_dom_upd1 AL_dom_emp) 
       apply (simp add: AL_dom_upd1 AL_dom_emp)  apply (simp add: AL_dom_upd1 AL_dom_emp) 
    apply clarsimp
        apply (subgoal_tac "D1'=CONS", clarsimp) prefer 2 apply (erule_tac x=D1' in allE, erule mp, assumption)
        apply (subgoal_tac "D2'=CONS", clarsimp) prefer 2 apply (erule_tac x=D2' in allE, erule mp, assumption)
        apply (rule_tac x="fst(snd ConsCopy)" in exI)
        apply (rule_tac x="fst(snd Cross)" in exI)
        apply (rule_tac x=0 in exI)
        apply (rule, simp add: ConsCopy_def)
        apply (rule_tac x=0 in exI)
        apply (rule, simp add: Cross_def)
        apply (rule_tac H="emp[\<gamma>\<mapsto>(CONS, upd(upd emp HD \<epsilon>) TL \<omega>)]"
                     and K="upd(upd emp \<gamma> (CONS, upd(upd emp HD \<epsilon>) TL \<omega>)) \<upsilon>' (CONS, emp[HD\<mapsto>\<epsilon>])" 
                     and N="upd(upd emp \<gamma> (classTP CONS))\<upsilon>' (classTP CONS)"
                     and \<gamma>="(([],emp[this\<mapsto>\<omega>],upd H \<omega> (CONS, emp[HD\<mapsto>\<delta>][TL\<mapsto>\<alpha>])),
                              N[\<omega>\<mapsto>(classTP CONS)],
                             ([],emp[this\<mapsto>\<omega>],upd H \<omega> (CONS, emp[HD\<mapsto>\<delta>][TL\<mapsto>\<alpha>])))"in TypingFrame)
        prefer 2 apply (simp add: RSD_sum_def)
          apply (rule, rule AL_UPD, rule AL_UPD) apply (erule ListHP_AL)
          apply (rule, rule AL_UPD, rule AL_UPD, rule AL_UPD, rule AL_UPD) apply (erule ListHP_AL)
          apply (rule, rule AL_UPD, rule AL_UPD, rule AL_UPD) apply (erule ListN_AL)
          apply rule apply (simp (no_asm) add: AL_sum_def)
            apply rule apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp)
            apply (simp add: contained_def)
            apply (rule, clarsimp)
              apply (rule AL_update4, assumption)
              apply (drule_tac d=a in AL_domI, simp add: AL_dom_upd1) apply clarsimp
            apply clarsimp
              apply (drule AL_upd_split)
              apply (erule disjE) apply clarsimp apply (rule AL_update1)
              apply (simp add: AL_emp1)
          apply rule apply (simp (no_asm) add: AL_sum_def)
            apply rule apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp)
            apply (simp add: contained_def)
            apply (rule, clarsimp)
              apply (rule AL_update4, rule AL_update4, rule AL_update4, assumption)
              apply (drule_tac d=a in AL_domI, simp add: AL_dom_upd1) apply clarsimp
              apply (drule_tac d=a in AL_domI, simp add: AL_dom_upd1) apply clarsimp
              apply (drule_tac d=a in AL_domI, simp add: AL_dom_upd1) apply clarsimp
            apply clarsimp
              apply (drule AL_upd_split)
              apply (erule disjE) apply clarsimp apply (rule AL_update1)
              apply clarsimp
              apply (drule AL_upd_split)
              apply (erule disjE) apply clarsimp apply (rule AL_update4, rule AL_update4, rule AL_update1)
                apply assumption apply assumption
              apply (simp add: AL_emp1)
          apply rule apply (simp (no_asm) add: AL_sum_def)
            apply rule apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp)
            apply (simp add: contained_def)
            apply (rule, clarsimp)
              apply (rule AL_update4, rule AL_update4, assumption)
              apply (drule_tac d=a in AL_domI, simp add: AL_dom_upd1) apply clarsimp
              apply (drule_tac d=a in AL_domI, simp add: AL_sum_def AL_dom_upd1) apply clarsimp
            apply clarsimp
              apply (drule AL_upd_split)
              apply (erule disjE) apply clarsimp apply (rule AL_update1)
              apply clarsimp
              apply (drule AL_upd_split)
              apply (erule disjE) apply clarsimp apply (rule AL_update4, rule AL_update1)
                apply assumption 
              apply (simp add: AL_emp1)
          apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp)
        apply (rule TypingAx) apply (simp (no_asm_simp) add: G3_def)
          apply (rule disjI2)
          apply (rule_tac x="Suc(length A)" in exI, simp add: ConsCopy_def Cross_def  RelSp2_def preS_def)
          apply (rule_tac x=\<omega> in exI, rule_tac x="(\<delta>,\<alpha>)#A" in exI, clarsimp)
          apply (rule_tac x=\<theta> in exI, rule_tac x="(\<delta>,\<beta>)#B" in exI, clarsimp)
          apply (rule_tac x=\<theta>' in exI, rule_tac x="(\<delta>,\<beta>')#B'" in exI, clarsimp)
            apply (simp add: starOpt_def star_def)
            apply (rule, rule, assumption)
            apply (rule, assumption)
            apply (rule, rule, assumption)
            apply (rule, assumption)
            apply (rule, rule, rule, assumption)
            apply (rule, assumption)
            apply (rule, assumption)
            apply (rule, assumption)
            apply simp
        apply (simp add: RSD_sum_def)
          apply rule apply (simp (no_asm) add: AL_sum_def)
            apply rule apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp) apply fast
            apply (simp add: contained_def)
            apply (rule, clarsimp)
              apply (frule AL_sum_split, assumption)
              apply (erule disjE)
                apply (erule AL_sum3) apply (erule AL_update4) apply (drule AL_domI, simp add: AL_sum_def AL_dom_upd1) apply clarsimp
              apply (erule AL_sum4) apply assumption
            apply clarsimp
              apply (drule AL_upd_split)
              apply (erule disjE) apply clarsimp apply (erule AL_sum3) apply (rule AL_update1)
              apply (simp add: AL_emp1)
          apply rule apply (simp (no_asm) add: AL_sum_def)
            apply rule apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp) apply fast
            apply (simp add: contained_def)
            apply (rule, clarsimp)
              apply (frule AL_sum_split, assumption)
              apply (erule disjE)
                apply (erule AL_sum3) apply (erule AL_update4) apply (drule AL_domI, simp add: AL_sum_def AL_dom_upd1) apply clarsimp
              apply (erule AL_sum4) apply (rule AL_update4, assumption) apply (drule AL_domI, simp add: AL_sum_def AL_dom_upd1) apply clarsimp 
            apply clarsimp
              apply (drule AL_upd_split)
              apply (erule disjE) apply clarsimp apply (erule AL_sum4) apply (rule AL_update1)
              apply clarsimp
              apply (drule AL_upd_split)
              apply (erule disjE) apply clarsimp apply (erule AL_sum3) apply (rule AL_update1)
              apply (simp add: AL_emp1)
          apply rule apply (simp (no_asm) add: AL_sum_def)
            apply rule apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp) apply fast
            apply (simp add: contained_def)
            apply (rule, clarsimp)
              apply (drule AL_sum_split, assumption)
              apply (erule disjE)
                apply (frule AL_sum_split, assumption)
                apply (erule disjE) apply (erule AL_sum3) apply (erule AL_sum3) apply (erule AL_update4) 
                  apply (drule_tac H=MM in AL_domI, simp add: AL_sum_def AL_dom_upd1) apply clarsimp 
                apply (erule AL_sum3) apply (erule AL_sum4) apply assumption
              apply (erule AL_sum4) apply (rule AL_update4, assumption) 
                  apply (drule_tac H="M'[\<theta>'\<mapsto>(classTP CONS)]" in AL_domI, simp add: AL_sum_def AL_dom_upd1) apply clarsimp 
            apply clarsimp
              apply (drule AL_upd_split)
              apply (erule disjE) apply clarsimp apply (erule AL_sum4) apply (rule AL_update1)
              apply clarsimp
              apply (drule AL_upd_split)
              apply (erule disjE) apply clarsimp apply (erule AL_sum3) apply (erule AL_sum3) apply (rule AL_update1)
              apply (simp add: AL_emp1)
          apply (simp add: AL_dom_upd1 AL_dom_emp AL_sum_def) apply clarsimp apply (rule, clarsimp) apply (rule, clarsimp)
            apply (rule, clarsimp) apply clarsimp
done
(*>*)
lemma 
(*<*)
end
(*>*)