theory RSDSound = RSD_TYPING + UniSound + BinaryRenSound:  

lemma TypingSoundAux:
  "(G, \<gamma>, M, l, MM, ll, b, \<delta>):Typing \<Longrightarrow> 
   \<forall> n k. CtxtValidN n G \<longrightarrow> (b \<longrightarrow> k=n) \<longrightarrow> ((\<not> b) \<longrightarrow> k=Suc n) \<longrightarrow>
         SecN k \<gamma> M l MM ll \<delta>"
(*<*)
apply (erule Typing.induct)
(*TypingUniRetRet*)
apply (rule)+
apply (simp only: SecN_def)
apply (subgoal_tac "(U, (fst \<Sigma>, fst(snd \<Sigma>), snd(snd \<Sigma>)), N, M, l, b, H, c, N') \<in> UniBS")
prefer 2 apply (case_tac \<Sigma>) apply clarsimp
apply (drule UniBS_Sound, assumption)
apply (subgoal_tac "(V, (fst \<Pi>, fst(snd \<Pi>), snd(snd \<Pi>)), N, MM, ll, b, K, d, N'') \<in> UniBS")
prefer 2 apply (case_tac \<Pi>) apply clarsimp
apply (drule UniBS_Sound, assumption)
apply (subgoal_tac "preserved (\<Sigma>, N, \<Pi>) (([c], emp, H), NN, [d], emp, K)", rule, assumption)
prefer 2 apply (simp add: preserved_def, clarsimp) apply (erule contained_transitive, simp add: AL_sum_def)
apply (rule allI)+
apply rule
apply (rule allI)+
apply (rule impI)+
apply (simp only: UniBS_UniSec_def)
apply (erule conjE)+
apply (erule_tac x=s in allE, erule_tac x=I in allE, erule_tac x=na in allE)
apply (erule_tac x=h in allE, erule_tac x=v in allE, erule_tac x=Ha in allE)
apply (erule_tac x=Na in allE, erule_tac x="fst(snd \<gamma>1)" in allE, erule_tac x="fst \<gamma>1" in allE)
apply (subgoal_tac "AL_dom N' \<inter> AL_dom Na = {}")
prefer 2 apply (rule_tac Y="AL_dom NN" in SetTriv103) apply (rule contained5) apply (simp add: AL_sum_def)
         apply (rotate_tac -2, erule thin_rl, erule thin_rl) apply (simp add: RSD_sum_def) apply (case_tac \<delta>1, clarsimp)
apply (frule AL_sum_exists_AL) apply (erule exE, rename_tac N'Na, erule conjE)
apply (erule_tac x="fst \<delta>1" in allE, erule_tac x=N'Na in allE)
apply (rotate_tac 8) apply (erule thin_rl, erule thin_rl, erule thin_rl)
apply (erule impE, clarsimp) apply (simp add: unisat_sat)
apply (erule impE, clarsimp)
  apply (drule_tac N=N in RSD_sum_SD_sum) apply simp
apply (erule impE, clarsimp)
  apply (drule_tac N=NN in RSD_sum_SD_sum) apply simp
apply (erule impE, clarsimp)
  apply (drule_tac N=N in RSD_sum_SD_sum) apply simp
apply (erule impE, assumption)
apply (erule impE, assumption)
apply (erule impE, assumption)
apply (erule impE, assumption)
apply (erule impE, simp add: RSD_sum_def) apply clarsimp
apply (erule impE, simp add: RSD_sum_def) apply clarsimp
apply (erule impE, simp add: RSD_sum_def) apply clarsimp
apply (erule impE, assumption) 
apply (erule impE, assumption) 
apply (erule exE)+ apply (erule conjE)+ 
apply (erule_tac x=t in allE, erule_tac x=J in allE, erule_tac x=m in allE)
apply (erule_tac x=ka in allE, erule_tac x=w in allE, erule_tac x=Ka in allE)
apply (erule_tac x=Na in allE, erule_tac x="fst(snd \<gamma>1)" in allE, erule_tac x="snd(snd \<gamma>1)" in allE)
apply (erule_tac x="snd(snd \<delta>1)" in allE)
apply (subgoal_tac "AL_dom N'' \<inter> AL_dom Na = {}")
prefer 2 apply (rule_tac Y="AL_dom NN" in SetTriv103) apply (rule contained5) apply (simp add: AL_sum_def)
         apply (rotate_tac -2, erule thin_rl, erule thin_rl) apply (simp add: RSD_sum_def) apply (case_tac \<delta>1, clarsimp)
apply (frule_tac N=N'' in AL_sum_exists_AL) apply (erule exE, rename_tac N''Na, erule conjE)
apply (erule_tac x=N''Na in allE)
apply clarsimp
apply (erule impE) apply (simp add: unisat_sat)
apply (erule impE)
  apply (drule_tac N=N in RSD_sum_SD_sum) apply simp
apply (erule impE)
  apply (drule_tac N=NN in RSD_sum_SD_sum) apply simp
apply (erule impE)
  apply (drule_tac N=N in RSD_sum_SD_sum) apply simp
apply (erule impE, simp add: RSD_sum_def) 
apply (erule impE, simp add: RSD_sum_def) 
apply (erule impE, simp add: RSD_sum_def) 
  apply (erule exE, rename_tac J1, erule conjE) 
  apply (rule_tac x=I1 in exI, rule_tac x=J1 in exI, simp add: unisat_sat)
  apply (simp add: RSD_sum_def SD_sum_def, clarsimp)
  apply rule apply (erule  unisat_MP_contained)
             apply (simp (no_asm) add: contained_def, clarsimp) apply (drule AL_sum_split, assumption) 
                                                                apply (erule disjE, erule AL_sum3) apply (erule AL_sum3, assumption)
                                                                apply (erule AL_sum4, assumption) 
              apply (simp add: AL_sum_def) 
  apply rule apply (erule  unisat_MP_contained)
             apply (simp (no_asm) add: contained_def, clarsimp) apply (drule AL_sum_split, assumption) 
                                                                apply (erule disjE, erule AL_sum3) apply (erule AL_sum4, assumption)
                                                                apply (erule AL_sum4, assumption) 
              apply (simp add: AL_sum_def) 
apply clarsimp
  apply (case_tac "ca:AL_dom ax")
    apply (subgoal_tac "Invariant ca ([c], emp, bo) ([v], emp, h) I1 ax (af, ag, bk) (ar, as, bi) I")
    prefer 2 apply (erule_tac x=ca in allE, erule mp) apply assumption
    apply (subgoal_tac "Invariant ca ([d], emp, bs) ([w], emp, ka) J1 ax (ad, ae, bl) (at, au, bj) J")
    prefer 2 apply (erule_tac x=ca in allE, erule mp) apply assumption
    apply (drule_tac H=ax in AL_domD, clarsimp)
    apply (subgoal_tac "x = intTP", clarsimp)
    prefer 2 apply (simp add: preserved_def) 
             apply (drule AL_sum_split, assumption)
             apply (erule disjE) apply (drule contained3, assumption) apply (drule AL_sum3, assumption) apply clarsimp
             apply (subgoal_tac "Na\<down>ca = Some intTP", clarsimp)
             apply (drule_tac H=NN and x=ca in AL_sum4) apply assumption apply clarsimp
    apply (subgoal_tac "singleVal ca ((af, ag, bk), ax, ad, ae, bl) (ar, as, bi) I (at, au, bj) J")
      apply (simp add: singleVal_def Invariant_def ValRepEQ, (erule conjE)+)
      apply (rule twSet_Triv9)
      apply (erule twSet_Triv10) apply assumption apply assumption
      apply (case_tac "ca:DOM(af, ag, bk)")
        apply (subgoal_tac "uniqueValues (af, ag, bk) (ar, as, bi) I")
          apply (simp add: uniqueValues_def)
          apply (erule_tac x=ca in allE, erule impE, assumption, erule exE)
          apply (case_tac "ca:DOM(ad, ae, bl)")
            apply (subgoal_tac "uniqueValues (ad, ae, bl) (at, au, bj) J")
              apply (simp add: uniqueValues_def)
            apply (simp add: unisat_def StateSatisfiesAbstraction_def) 
          apply (simp add: singleVal_def) apply (rule twSetEmpR) apply (erule ValuesRepresented_notin_DOM) apply simp 
        apply (simp add: unisat_def StateSatisfiesAbstraction_def) 
      apply (case_tac "ca:DOM(ad, ae, bl)")
        apply (subgoal_tac "uniqueValues (ad, ae, bl) (at, au, bj) J")
          apply (simp add: uniqueValues_def)
          apply (erule_tac x=ca in allE, erule impE, assumption, erule exE)
          apply (simp add: singleVal_def) apply (rule twSetEmpL) apply (erule ValuesRepresented_notin_DOM) apply simp 
        apply (simp add: unisat_def StateSatisfiesAbstraction_def) 
      apply (simp add: singleVal_def) apply (rule twSetEmp) apply (erule ValuesRepresented_notin_DOM) apply (erule ValuesRepresented_notin_DOM)
          apply (simp add: unisat_def, clarsimp)
          apply (frule SetTriv, erule_tac \<Sigma>="([c], emp, bo)" in State_welldef_DOM_ALdom) 
           apply (frule SetTriv, erule_tac \<Sigma>="([d], emp, bs)" in State_welldef_DOM_ALdom) apply (simp add: AL_sum_def) apply clarsimp
           apply (subgoal_tac "ca:AL_dom N' \<inter> AL_dom N''", clarsimp) apply fast 
(*UniInjectL*)
apply clarsimp
apply (frule UniSS_L_notEmpty) apply (erule exE, rename_tac l1)
apply (drule UniSS_SoundUni, assumption, clarsimp) 
apply (drule  UniSS_UniSec_UniSS_Sec)
apply (simp add: SecN_def)
apply (subgoal_tac " preserved ((ah, ai, bd), N1, ad, ae, bb) ((aj, ak, be), al, am, an, bf)")
prefer 2 apply (erule_tac x=l1 in allE, clarsimp)
apply (subgoal_tac "preserved ((af, ag, bc), N, ad, ae, bb) ((aj, ak, be), al, am, an, bf)", rule, assumption)
prefer 2 apply (rotate_tac 1, erule thin_rl) apply (simp add: preserved_def, clarsimp)
         apply (rule, erule contained_transitive, assumption)
         apply (erule SetTriv101, assumption)
apply clarsimp
apply (erule eval_cases) apply clarsimp apply clarsimp
apply (subgoal_tac "AL_dom bd \<inter> AL_dom H = {}")
prefer 2 apply (rotate_tac -1, erule thin_rl) apply (rotate_tac 1, erule thin_rl)
         apply (simp add: preserved_def, clarsimp) apply (simp add: RSD_sum_def, (erule conjE)+)
         apply (erule_tac Y="AL_dom be" in SetTriv103)
         apply assumption
apply (frule_tac N=bd in AL_sum_exists_AL) apply (erule exE, rename_tac bd_H, erule conjE)
apply (drule RSD_sum_SD_sum) apply clarsimp
apply (simp add: UniSS_Sec_def)
  apply (erule_tac x=ao in allE, erule_tac x=ap in allE, erule_tac x=bg in allE)
  apply (erule_tac x=aq in allE, erule_tac x=ar in allE, erule_tac x=bh in allE)
  apply (rotate_tac -1, erule_tac x=I in allE, rotate_tac -1, erule_tac x=J in allE)
  apply (rotate_tac -1, erule_tac x=nb in allE, rotate_tac -1, erule_tac x=lla in allE)
  apply (erule_tac x=bo in allE, erule_tac x=bp in allE, erule_tac x=bq in allE)
  apply (erule_tac x=H in allE, erule_tac x=Na in allE, erule_tac x=au in allE)
  apply (erule_tac x=as in allE, erule_tac x=at in allE, erule_tac x=bi in allE)
  apply (erule_tac x=ah in allE, erule_tac x=ai in allE, erule_tac x=bd_H in allE)
  apply clarsimp
apply (subgoal_tac "AL_dom N1 \<inter> AL_dom Na = {}")
prefer 2 apply (rotate_tac -1, erule thin_rl) apply (rotate_tac 1, erule thin_rl)
         apply (simp add: preserved_def, clarsimp) apply (simp add: RSD_sum_def, (erule conjE)+)
         apply (rule_tac Y="AL_dom al" in SetTriv103)
           apply clarsimp apply (erule contained6, assumption)
         apply assumption
apply (frule_tac N=N1 in AL_sum_exists_AL) apply (erule exE, rename_tac N1_Na, erule conjE)
apply (erule_tac x=N1_Na in allE, erule_tac x=av in allE)
apply (erule_tac x=aw in allE, erule_tac x=bj in allE)
apply (erule impE, assumption) 
apply (erule impE, simp add: SD_sum_def)
apply clarsimp
apply (erule impE) apply (rotate_tac 1, erule thin_rl)  apply (simp add: sat_def welldef_def State_welldef_def)
apply (erule impE) apply (rotate_tac 1, erule thin_rl)  apply (simp add: sat_def welldef_def State_welldef_def State_good_def) 
apply (erule conjE)
apply (erule exE)+
apply (erule conjE)+
apply (erule_tac x=lla in allE, erule impE, assumption) apply (erule conjE)
apply (erule_tac x=n in allE, clarsimp)
apply (erule_tac x=ma in allE, erule_tac x=m in allE, erule impE, erule Arith_12) 
  apply (simp add: RSD_sum_def SD_sum_def, clarsimp)
  apply (erule_tac x=bo in allE, erule_tac x=bp in allE, erule_tac x=bq in allE,
          erule_tac x=h in allE, erule_tac x=v in allE, clarsimp)
  apply (erule_tac x=aq in allE, erule_tac x=ar in allE, erule_tac x=bh in allE,
          erule_tac x=k in allE, erule_tac x=w in allE, clarsimp)
  apply (erule_tac x=H in allE, erule_tac x=Na in allE, erule_tac x=K in allE)
  apply (erule_tac x=bd_H in allE, erule_tac x=N1_Na in allE, erule_tac x=bj in allE, clarsimp)
  apply (erule_tac x=bk in allE, erule_tac x=az in allE, erule_tac x=bn in allE, clarsimp)
  apply (erule_tac x=I1 in allE, erule_tac x=J1 in allE, clarsimp)
  apply (erule impE) apply (simp add: sat_def welldef_def State_welldef_def State_good_def)
  apply clarsimp
  apply (rule, rule)
  apply (rule, assumption)
  apply clarsimp
  apply (subgoal_tac "contained au N1_Na")
  prefer 2 apply (simp (no_asm) add: contained_def, clarsimp) 
           apply (drule AL_sum_split, assumption) 
           apply (rotate_tac -1, erule disjE) 
             apply (erule AL_sum3) apply (erule contained3, assumption)
           apply (erule AL_sum4, assumption)
  apply (rotate_tac 26)
  apply (erule_tac x=c in allE, erule impE, assumption)
  apply (erule_tac x=c in allE, erule impE) apply (erule contained6, assumption)
  apply (erule conjE)+ 
  apply rule apply (rotate_tac -1, erule thin_rl) apply (rotate_tac -3, erule thin_rl)
    apply (simp add: Invariant_def, clarsimp)
    apply (rule, rule, erule impE, assumption)
      apply (erule impE, erule SetTriv, erule contained_ObjIds_subset) apply simp
    apply (erule SetTriv101) apply assumption
  apply (rotate_tac -2, erule thin_rl) apply (rotate_tac -1, erule thin_rl) 
    apply (simp add: Invariant_def, clarsimp)
    apply (rule, rule, erule impE, assumption)
      apply (erule impE, erule SetTriv, erule contained_ObjIds_subset) apply simp
    apply (erule SetTriv101) apply assumption
(*UniInjectR*)
apply clarsimp
apply (frule UniSS_L_notEmpty) apply (erule exE, rename_tac l1)
apply (drule UniSS_SoundUni, assumption, clarsimp) 
apply (drule  UniSS_UniSec_UniSS_Sec)
apply (simp add: SecN_def)
apply (subgoal_tac "preserved ((ah, ai, bd), N1, af, ag, bc) ((aj, ak, be), al, am, an, bf)")
prefer 2 apply (erule_tac x=l1 in allE, clarsimp)
apply (subgoal_tac "preserved ((ah, ai, bd), N, ad, ae, bb) ((aj, ak, be), al, am, an, bf)", rule, assumption)
prefer 2 apply (rotate_tac 1, erule thin_rl) apply (simp add: preserved_def, clarsimp)
         apply (rule, erule contained_transitive, assumption)
         apply (erule SetTriv101, assumption)
apply clarsimp
apply (rotate_tac -1, erule eval_cases) apply clarsimp apply clarsimp
apply (subgoal_tac "AL_dom bc \<inter> AL_dom K = {}")
prefer 2 apply (rotate_tac -3, erule thin_rl) apply (rotate_tac 3, erule thin_rl)
         apply (simp add: preserved_def, clarsimp) apply (simp add: RSD_sum_def, (erule conjE)+)
         apply (erule_tac Y="AL_dom bf" in SetTriv103)
         apply assumption
apply (frule_tac N=bc in AL_sum_exists_AL) apply (erule exE, rename_tac bc_K, erule conjE)
apply (drule RSD_sum_SD_sum) apply clarsimp
apply (drule sat_symm)
apply (simp add: UniSS_Sec_def)
  apply (erule_tac x=aq in allE, erule_tac x=ar in allE, erule_tac x=bh in allE)
  apply (erule_tac x=ao in allE, erule_tac x=ap in allE, erule_tac x=bg in allE)
  apply (rotate_tac -1, erule_tac x=J in allE, rotate_tac -1, erule_tac x=I in allE)
  apply (rotate_tac -1, erule_tac x=nb in allE, rotate_tac -1, erule_tac x=lla in allE)
  apply (erule_tac x=bo in allE, erule_tac x=bp in allE, erule_tac x=bq in allE)
  apply (erule_tac x=K in allE, erule_tac x=Na in allE, erule_tac x=au in allE)
  apply (erule_tac x=av in allE, erule_tac x=aw in allE, erule_tac x=bj in allE)
  apply (erule_tac x=af in allE, erule_tac x=ag in allE, erule_tac x=bc_K in allE)
  apply clarsimp
apply (subgoal_tac "AL_dom N1 \<inter> AL_dom Na = {}")
prefer 2 apply (rotate_tac -1, erule thin_rl) apply (rotate_tac 1, erule thin_rl)
         apply (simp add: preserved_def, clarsimp) apply (simp add: RSD_sum_def, (erule conjE)+)
         apply (rule_tac Y="AL_dom al" in SetTriv103)
           apply clarsimp apply (erule contained6, assumption)
         apply assumption
apply (frule_tac N=N1 in AL_sum_exists_AL) apply (erule exE, rename_tac N1_Na, erule conjE)
apply (erule_tac x=N1_Na in allE, erule_tac x=as in allE)
apply (erule_tac x=at in allE, erule_tac x=bi in allE)
apply (erule impE, assumption) 
apply (erule impE, simp add: SD_sum_def) 
apply (erule impE, assumption) 
apply clarsimp
apply (erule impE) apply (rotate_tac 1, erule thin_rl)  apply (simp add: sat_def welldef_def State_welldef_def)
apply (erule impE) apply (rotate_tac 1, erule thin_rl)  apply (simp add: sat_def welldef_def State_welldef_def State_good_def) 
apply (erule conjE)
apply (erule exE)+
apply (erule conjE)+
apply (erule_tac x=lla in allE, erule impE, assumption) apply (erule conjE)
apply (erule_tac x=n in allE, clarsimp)
apply (erule_tac x=na in allE, erule_tac x=ma in allE, erule impE, erule Arith_13) 
  apply (simp add: RSD_sum_def SD_sum_def, clarsimp)
  apply (erule_tac x=ao in allE, erule_tac x=ap in allE, erule_tac x=bg in allE,
          erule_tac x=h in allE, erule_tac x=v in allE, clarsimp)
  apply (erule_tac x=bo in allE, erule_tac x=bp in allE, erule_tac x=bq in allE,
          erule_tac x=k in allE, erule_tac x=w in allE, clarsimp)
  apply (erule_tac x=H in allE, erule_tac x=Na in allE, erule_tac x=K in allE)
  apply (erule_tac x=bi in allE, erule_tac x=N1_Na in allE, erule_tac x=bc_K in allE, clarsimp)
  apply (erule_tac x=bk in allE, erule_tac x=az in allE, erule_tac x=bn in allE, clarsimp)
  apply (erule_tac x=J1 in allE, erule_tac x=I1 in allE, erule impE, erule sat_symm)
  apply (erule impE) apply (simp add: sat_def welldef_def State_welldef_def State_good_def)
  apply clarsimp
  apply (rule, rule)
  apply (rule, assumption)
  apply clarsimp
  apply (subgoal_tac "contained au N1_Na")
  prefer 2 apply (simp (no_asm) add: contained_def, clarsimp) 
           apply (drule AL_sum_split, assumption) 
           apply (rotate_tac -1, erule disjE) 
             apply (erule AL_sum3) apply (erule contained3, assumption)
           apply (erule AL_sum4, assumption)
  apply (rotate_tac 26)
  apply (erule_tac x=c in allE, erule impE, assumption)
  apply (erule_tac x=c in allE, erule impE) apply (erule contained6, assumption)
  apply (erule conjE)+ 
  apply rule
    apply (rotate_tac -1, erule thin_rl) apply (rotate_tac -2, erule thin_rl)
    apply (simp add: Invariant_def, clarsimp)
    apply (rule, rule, erule impE, assumption)
      apply (erule impE, erule SetTriv, erule contained_ObjIds_subset) apply simp
    apply (erule SetTriv101) apply assumption
  apply (rotate_tac -2, erule thin_rl) apply (rotate_tac -2, erule thin_rl)
    apply (simp add: Invariant_def, clarsimp)
    apply (rule, rule, erule impE, assumption)
      apply (erule impE, erule SetTriv, erule contained_ObjIds_subset) apply simp
    apply (erule SetTriv101) apply assumption
(*InvSInvV*)
apply (rule, rule, rule, rule, rule)
apply (erule_tac x=n in allE, erule_tac x=n in allE)
apply (erule impE, assumption)
apply clarsimp
apply (erule InvSInvVSound) apply assumption+ apply clarsimp 
(*InvSInvV3*)
apply (rule, rule, rule, rule, rule)
apply (erule_tac x=n in allE, erule_tac x=n in allE)
apply (erule impE, assumption)
apply clarsimp
apply (erule InvSInvV3Sound) apply assumption+
  apply (rule, rule) apply (erule_tac x=D2' in allE, erule impE, assumption) 
  apply (erule exE)+ apply (rule_tac x=code2' in exI)  apply (rule_tac x=l2' in exI) apply clarsimp 
(*Frame*)
apply clarsimp
apply (erule_tac x=n in allE, clarsimp)
apply (erule_tac x=k in allE, clarsimp)
apply (erule thin_rl) apply (rotate_tac -4, erule thin_rl, erule thin_rl, erule thin_rl)
apply (simp add: SecN_def) apply clarsimp
apply (subgoal_tac "preserved ((as, at, bh), au, av, aw, bi) ((ai, aj, bd), ak, al, am, be) ", clarsimp)
prefer 2
  apply (rotate_tac -1, erule thin_rl, simp add: preserved_def RSD_sum_def, clarsimp)
  apply (rule, simp (no_asm) add: contained_def, clarsimp)
    apply (drule AL_sum_split, assumption)
    apply (erule disjE) 
      apply (drule contained3, assumption) apply (erule AL_sum3, assumption)
    apply (erule AL_sum4, assumption)
  apply (simp add: AL_sum_def) apply (rule, erule SetTriv101) apply fast apply fast
apply (erule_tac x=n in allE, erule_tac x=m in allE, clarsimp)
apply (erule_tac x=ax in allE)
apply (erule_tac x=ay in allE)
apply (erule_tac x=bj in allE)
apply (erule_tac x=h in allE)
apply (erule_tac x=v in allE, clarsimp)
apply (erule_tac x=az in allE)
apply (erule_tac x=bk in allE)
apply (erule_tac x=bl in allE)
apply (erule_tac x=ka in allE)
apply (erule_tac x=w in allE, clarsimp)
apply (subgoal_tac "\<exists> Hx . AL_sum H Ha Hx \<and> Hx:AL", erule exE, erule conjE)
prefer 2 apply (rule AL_sum_exists_AL) apply (rotate_tac -3, erule thin_rl, erule thin_rl, erule thin_rl) 
         apply (simp add: RSD_sum_def AL_sum_def) apply clarsimp
         apply (rotate_tac -9) apply fast
apply (subgoal_tac "\<exists> Kx . AL_sum K Ka Kx \<and> Kx:AL", erule exE, erule conjE)
prefer 2 apply (rule AL_sum_exists_AL) apply (rotate_tac -5, erule thin_rl, erule thin_rl, erule thin_rl) 
         apply (simp add: RSD_sum_def AL_sum_def) apply clarsimp
         apply (rotate_tac -5) apply fast
apply (subgoal_tac "\<exists> Nx . AL_sum N Na Nx \<and> Nx:AL", erule exE, erule conjE)
prefer 2 apply (rule AL_sum_exists_AL) apply (rotate_tac -7, erule thin_rl, erule thin_rl, erule thin_rl) 
         apply (simp add: RSD_sum_def AL_sum_def) apply clarsimp
         apply (rotate_tac -6) apply fast
apply (erule_tac x=Hx in allE)
apply (erule_tac x=Nx in allE)
apply (erule_tac x=Kx in allE)
apply (erule_tac x=bm in allE)
apply (erule_tac x=bn in allE)
apply (erule_tac x=bo in allE)
apply (erule_tac x=bp in allE)
apply (erule_tac x=bq in allE)
apply (erule_tac x=br in allE)
apply (erule_tac x=bs in allE)
apply clarsimp
apply (simp add: RSD_sum_def, clarsimp)
apply (frule_tac H=bb in AL_sum_sum) apply assumption apply assumption
apply (frule_tac H=bc in AL_sum_sum) apply assumption apply assumption
apply (frule_tac H=af in AL_sum_sum) apply assumption apply assumption
apply (erule_tac x=bv in allE)
apply (erule_tac x=bw in allE)
apply (erule_tac x=bz in allE)
apply (erule_tac x=I in allE)
apply (erule_tac x=J in allE)
apply clarsimp
apply (erule impE)
     apply (rule, erule AL_sum_sum) apply assumption apply assumption
     apply (rule, erule AL_sum_sum) apply assumption apply assumption 
     apply (rule, erule AL_sum_sum) apply assumption apply assumption 
     apply (simp add: AL_sum_def, clarsimp) 
      apply rule apply (erule SetTriv113, assumption)
      apply rule apply (erule SetTriv113, assumption)
      apply (erule SetTriv113, assumption)
apply (erule impE) apply (simp add: AL_sum_def, clarsimp)
    apply (rule, erule SetTriv113, assumption) 
    apply (rule, erule SetTriv113, assumption)  
    apply (erule SetTriv113, assumption)
apply clarsimp
(*ConstConst*)
apply clarsimp
apply (erule_tac x=n in allE, erule impE, assumption)
apply (erule ConstConst_Sound) apply assumption apply fastsimp 
  apply assumption apply simp 
(*BinopBinop*)
apply clarsimp
apply (erule_tac x=n in allE, erule impE, assumption)
apply (erule BinopBinop_Sound) apply assumption apply fastsimp apply assumption 
  apply assumption apply assumption apply assumption apply simp
(*NewNew*)
apply clarsimp
apply (erule_tac x=n in allE, erule impE, assumption)
apply (erule NewNew_Sound2_13) apply assumption apply assumption 
  apply assumption apply assumption apply assumption 
(*InvSInvS*)
apply clarsimp 
apply (erule_tac x=n in allE, clarsimp)
apply (erule_tac x=n in allE, clarsimp)
apply (erule InvSInvS_Sound) apply assumption apply fastsimp 
  apply assumption apply assumption apply simp apply assumption apply assumption 
(*InvVInvV*)
apply (rule, rule, rule, rule, rule)
apply (erule_tac x=n in allE, erule_tac x=n in allE)
apply (erule impE, assumption)
apply clarsimp
apply (erule InvVInvV_Sound) apply assumption+ apply clarsimp
(*InvVInvV3*)
apply (rule, rule, rule, rule, rule)
apply (erule_tac x=n in allE, erule_tac x=n in allE)
apply (erule impE, assumption)
apply clarsimp
apply (erule InvVInvV3_Sound) apply assumption+ 
  apply clarsimp
  apply (erule_tac x=D1' in allE, erule impE, assumption)
  apply (erule_tac x=D2' in allE, erule impE, assumption)
  apply (erule exE)+ apply (erule conjE)+ 
  apply (erule exE)+ apply (erule conjE)+ 
  apply (rule, rule, rule, rule, assumption)
  apply (rule, rule, assumption)
  apply assumption
(*RetRet*)
apply clarsimp 
apply (simp only: SecN_def)
apply (subgoal_tac "preserved ((c # S, \<Gamma>, H), N, d # T, \<Delta>, K) (([c], emp, H), N, [d], emp, K)", rule, assumption)
prefer 2 apply (simp add: preserved_def) apply (rule contained_refl)
apply clarsimp
apply (erule eval_cases)
prefer 2 apply clarsimp  apply (drule RetElim1, assumption) apply simp
apply (erule eval_cases) 
prefer 2 apply clarsimp  apply (drule RetElim1, assumption) apply simp
apply clarsimp
apply (rule_tac x=I in exI, rule_tac x=J in exI, simp add: RSD_sum_def, clarsimp)
apply rule apply (rule_tac os=os and s=s and osa=osa and sa=sa and S=S and \<Gamma>=\<Gamma> and T=T and \<Delta>=\<Delta> in sat_HDHD) 
           apply (rule sat_MPextensional)
             apply (rule sat_leftHPextensional)
               apply (rule sat_symm)
             apply (rule sat_leftHPextensional)
               apply (erule sat_symm)
               apply (erule AL_sum_extensional, assumption) 
               apply assumption
             apply (erule AL_sum_extensional, assumption) 
             apply assumption
           apply (erule AL_sum_extensional, assumption) 
           apply assumption
apply clarsimp
  apply rule
      apply (simp add: Invariant_def ValRepEQ)
      apply (subgoal_tac "ValuesRepresented ca ([c], emp, bf) ([v], emp, h) I = ValuesRepresented ca ([c], emp, bd) ([v], emp, h) I", clarsimp) 
                   apply (erule SetTriv) apply (rule SetTriv101) apply (rule_tac S=S and ops=os in ValuesRepresented_HD)
                      apply (rule ValuesRepresented13)
                 apply (rule ValuesRepresented_HPextensional) 
                   apply (erule AL_sum_extensional, assumption)
  apply (simp add: Invariant_def ValRepEQ)
      apply (subgoal_tac "ValuesRepresented ca ([d], emp, bg) ([w], emp, k) J = ValuesRepresented ca ([d], emp, be) ([w], emp, k) J", clarsimp) 
                   apply (erule SetTriv) apply (rule SetTriv101) apply (rule_tac S=T and ops=osa in ValuesRepresented_HD)
                      apply (rule ValuesRepresented13)
                 apply (rule ValuesRepresented_HPextensional) 
                   apply (erule AL_sum_extensional, assumption)
(*Inj*)
apply (case_tac \<gamma>, clarsimp)
apply (erule_tac x=n in allE, clarsimp)
apply (erule SecN_subN) apply simp
(*Ax*)
apply clarsimp
apply (simp add: CtxtValidN_def)
(*IfIf*)
apply clarsimp
apply (erule_tac x=n in allE, clarsimp)
apply (erule_tac x=n in allE, clarsimp)
apply (simp (no_asm) add: SecN_def)
apply (subgoal_tac "preserved ((c # S, \<Gamma>, H), N, c # T, \<Delta>, K) ((ad, ae, bb), af, ag, ah, bc)", clarsimp)
prefer 2 apply (simp add: SecN_def preserved_def)
apply (simp add: RSD_sum_def, clarsimp)
apply (subgoal_tac "\<exists> u u1 ops ops1. ai = u # ops \<and> ak = u1 # ops1 \<and> u=u1", clarsimp)
prefer 2
  apply (simp add: sat_def, clarsimp)
  apply (erule_tac x=c in allE, erule impE) 
    apply (erule AL_sum3) apply assumption
  apply (simp add: StateSatisfiesAbstraction_def, clarsimp)
  apply (case_tac ai, clarsimp, clarsimp)
  apply (case_tac ak, clarsimp, clarsimp)
  apply (simp add: singleVal_def)
  apply (subgoal_tac "am : ValuesRepresented c (c # S, \<Gamma>, bf) (am # list, aj, bd) I")
  prefer 2 apply (rule ValuesRepresented2)
  apply (subgoal_tac "ai : ValuesRepresented c (c # T, \<Delta>, bg) (ai # lista, al, be) J")
  prefer 2 apply (rule ValuesRepresented2)
  apply (erule impE) apply (simp add: DOM_def)
  apply (erule twSet.elims)
    apply clarsimp
    apply clarsimp
    apply clarsimp
    apply clarsimp
apply (drule sat_Tail)
apply (drule sat_symm)
apply (drule sat_Tail)
apply (drule sat_symm)
(*thus, apply (subgoal_tac "sat (ops, aj, bd) (ops1, al, be) ((S, \<Gamma>, bf), ao, T, \<Delta>, bg) I J has been established")*)
  apply (erule eval_cases) apply clarsimp apply clarsimp
  apply (drule IfElim1, assumption) apply clarsimp
  apply (erule eval_cases) apply clarsimp apply clarsimp
  apply (drule IfElim1, assumption) apply clarsimp
  apply (simp add: TRUE_def)
  apply (erule disjE, clarsimp)
    apply (rotate_tac 6) apply (erule thin_rl)
    apply (simp add: SecN_def, erule conjE)
    apply (erule_tac x=ma in allE, erule_tac x=mb in allE, erule impE, erule Arith7)
    apply (erule_tac x=ops in allE, erule_tac x=aj in allE, erule_tac x=bd in allE)
    apply (erule_tac x=h in allE, erule_tac x=v in allE, clarsimp)
    apply (erule_tac x=ops1 in allE, erule_tac x=al in allE, erule_tac x=be in allE)
    apply (erule_tac x=k in allE, erule_tac x=w in allE, clarsimp)
    apply (erule_tac x=Ha in allE, erule_tac x=Na in allE, erule_tac x=Ka in allE)
    apply (simp add: RSD_sum_def)
    apply (erule_tac x=bf in allE, erule_tac x=ao in allE, erule_tac x=bg in allE)
    apply (erule_tac x=bh in allE, erule_tac x=at in allE, erule_tac x=bi in allE)
    apply clarsimp
    apply (erule_tac x=I in allE, erule_tac x=J in allE, clarsimp)
    apply (rule_tac x=I1 in exI, rule_tac x=J1 in exI)(*    apply (rule_tac x=bh in exI, rule_tac x=ai in exI, rule_tac x=bi in exI, clarsimp)*)
    apply clarsimp
    apply (erule_tac x=ca in allE, clarsimp)
    apply rule
      apply (rotate_tac -1, erule thin_rl)
      apply (simp add: Invariant_def ValRepEQ, clarsimp)
      apply (drule SetTriv, assumption) apply (erule SetTriv, rule ValuesRepresented9) 
      apply (rotate_tac -2, erule thin_rl)
      apply (rotate_tac -2, erule thin_rl)
      apply (simp add: Invariant_def ValRepEQ, clarsimp)
      apply (drule SetTriv, assumption) apply (erule SetTriv, rule ValuesRepresented9) 
  apply clarsimp
    apply (rotate_tac 7) apply (erule thin_rl)
    apply (simp add: SecN_def, erule conjE)
    apply (erule_tac x=ma in allE, erule_tac x=mb in allE, erule impE, erule Arith7)
    apply (erule_tac x=ops in allE, erule_tac x=aj in allE, erule_tac x=bd in allE)
    apply (erule_tac x=h in allE, erule_tac x=v in allE, clarsimp)
    apply (erule_tac x=ops1 in allE, erule_tac x=al in allE, erule_tac x=be in allE)
    apply (erule_tac x=k in allE, erule_tac x=w in allE, clarsimp)
    apply (simp add: RSD_sum_def)
    apply (erule_tac x=Ha in allE, erule_tac x=Na in allE, erule_tac x=Ka in allE)
    apply (erule_tac x=bf in allE, erule_tac x=ao in allE, erule_tac x=bg in allE)
    apply (erule_tac x=bh in allE, erule_tac x=at in allE, erule_tac x=bi in allE)
    apply (erule_tac x=I in allE, erule_tac x=J in allE)
    apply clarsimp
    apply (rule_tac x=I1 in exI, rule_tac x=J1 in exI)
    apply clarsimp
    apply (erule_tac x=ca in allE, clarsimp)
    apply rule
      apply (rotate_tac -1, erule thin_rl)
      apply (simp add: Invariant_def ValRepEQ, clarsimp)
      apply (drule SetTriv, assumption) apply (erule SetTriv, rule ValuesRepresented9) 
      apply (rotate_tac -2, erule thin_rl)
      apply (simp add: Invariant_def ValRepEQ, clarsimp)
      apply (drule SetTriv, assumption) apply (erule SetTriv, rule ValuesRepresented9) 
(*Ren*)
apply rule apply rule
apply simp
apply (rule impI)+
apply (erule_tac x=n in allE, erule impE, assumption)
apply (erule RenSound) apply assumption apply assumption apply assumption apply assumption apply assumption
done
(*>*)

text{*From the auxiliary lemma we easily obtin the following.*}

lemma TypingSound_validCtxt[rule_format]:
  "\<lbrakk>(G, \<gamma>, M, l, MM, ll, b, \<delta>):Typing; CtxtValid G\<rbrakk>
   \<Longrightarrow> Sec \<gamma> M l MM ll \<delta>"
(*<*)
apply (drule TypingSoundAux)
apply (rule SecN_Sec)
apply (case_tac b)
  apply clarsimp 
  apply (erule_tac x=n in allE, erule mp)
  apply (erule CtxtValid_CtxtValidN)
apply clarsimp 
  apply (erule_tac x=n in allE, erule impE)
  apply (erule CtxtValid_CtxtValidN) 
  apply (erule SecN_subN) apply simp
done
(*>*)

lemma CtxtVerified_emp: "CtxtVerified {}"
(*<*)by (simp add: CtxtVerified_def AL_emp1)(*>*)

lemma CtxtVerified_CtxtValidN[rule_format]:
"CtxtVerified G \<longrightarrow> CtxtValidN n G"
(*<*)
apply (induct n)
  apply (simp add: CtxtValidN_def CtxtVerified_def, clarsimp)
  apply (simp add: SecN_def, clarsimp)  
  apply (drule no_zero_height_Exec_derivs) apply simp
apply clarsimp
   apply (simp (no_asm) only: CtxtValidN_def) 
   apply (rule allI)+ apply rule
   apply (unfold CtxtVerified_def)
   apply (erule_tac x=M in allE, erule_tac x=l in allE)
   apply (erule_tac x=MM in allE, erule_tac x=ll in allE)
   apply (erule_tac x=\<gamma> in allE, erule_tac x=\<delta> in allE)
   apply clarsimp
   apply (drule TypingSoundAux) apply (erule_tac x=n in allE, erule_tac x="Suc n" in allE, clarsimp)
done
(*>*)

text{*Thus, formal derivability entails semantic validity of
contexts.*}

lemma CtxtVerified_CtxtValid: "CtxtVerified U \<Longrightarrow> CtxtValid U"
(*<*)
apply (rule CtxtValidN_CtxtValid)
apply clarsimp
apply (erule CtxtVerified_CtxtValidN)
done
(*>*)

text{*From this, we conclude soundness with respect to formally justified
contexts.*}

theorem Typing_Sound[rule_format]:
 "\<lbrakk>(G, \<gamma>, M, l, MM, ll, b, \<delta>):Typing; CtxtVerified G\<rbrakk>
   \<Longrightarrow> Sec \<gamma> M l MM ll \<delta>"
apply (erule TypingSound_validCtxt)
apply (erule CtxtVerified_CtxtValid)
done

end
