theory RuleNewNew = SatSec + INSTR_NEW:

lemma ValuesRespresentedNewNew1_13:
   "\<lbrakk>c \<notin> AL_dom NN; NN\<down>ca = Some tp; State_welldef (S, \<Gamma>, HH) NN\<rbrakk>
   \<Longrightarrow> ValuesRepresented ca (S, \<Gamma>, HH[c\<mapsto>(C, emp)]) (ops, s, h[(nextLoc h)\<mapsto>(C, emp)])
                   (\<lambda>x. if x = c then Some (nextLoc h) else I x)
       \<subseteq> ValuesRepresented ca (S, \<Gamma>, HH) (ops, s, h) I"
apply clarsimp
apply (frule AL_domI)
  apply (simp add: ValuesRepresented_def, clarsimp)
  apply (erule disjE, clarsimp) 
    apply (case_tac "ca=c", clarsimp) apply clarsimp apply (simp add: AL_dom_upd1)
  apply clarsimp
    apply (drule AL_upd_split)
    apply (erule disjE, clarsimp)
      apply (simp add: AL_emp1)
    apply clarsimp
      apply (case_tac "d=c", clarsimp) apply clarsimp
      apply (drule State_welldef_Heap_lookup_dom) apply assumption 
      apply (drule AL_upd_split)
        apply (erule disjE, clarsimp) apply (simp add: AL_emp1)
        apply clarsimp
done

lemma ValuesRespresentedNewNew1_TL_13:
   "\<lbrakk> c \<notin> AL_dom NN; NN\<down>ca = Some tp; State_welldef (S, \<Gamma>, HH) NN\<rbrakk>
   \<Longrightarrow> ValuesRepresented ca (c # S, \<Gamma>, HH[c\<mapsto>(C, emp)]) (RVal (Loc (nextLoc h)) # ops, s, h[(nextLoc h)\<mapsto>(C, emp)])
                   (\<lambda>x. if x = c then Some (nextLoc h) else  I x)
       \<subseteq> ValuesRepresented ca (S, \<Gamma>, HH) (ops, s, h) I"
apply (rule SetTriv109)
apply (rule ValuesRepresented1) apply (drule AL_domI) apply fast
apply (erule ValuesRespresentedNewNew1_13) apply assumption+
done

lemma State_welldef_NewNew3:
 "\<lbrakk> State_welldef (S, \<Gamma>, HH) NN; c \<notin> AL_dom NN; subclass_of C1 C\<rbrakk> 
  \<Longrightarrow> State_welldef (S, \<Gamma>, HH[c\<mapsto>(C1, emp)]) NN[c\<mapsto>(classTP C)]"
apply (simp add: State_welldef_def, clarsimp)
apply (simp add: AL_dom_upd1)
apply (rule, fast)
apply (rule, fast)
apply (rule, fast)
apply (subgoal_tac "c \<notin>AL_dom HH")
  apply (drule_tac C=C1 in AbsFields_insert_freshLoc) apply clarsimp
  apply (rule, fast)
  apply (simp add: ObjIDs_insertObj)
  apply (rule, fast)
  apply (rule, fast)
  apply (rule, simp add: State_good_def, clarsimp)
    apply (rule, erule AL_UPD)
    apply (simp add: HP_good_def) apply clarsimp apply (drule AL_upd_split) apply (erule disjE, clarsimp) 
                                                                            apply (rule, rule AL_EMP) apply (simp add: AL_cod_emp)
                                                                          apply clarsimp apply (erule_tac x=ca in allE, clarsimp)
                                                                            apply (drule SetTriv, assumption) apply (simp add: AL_dom_upd1)
(*    apply (erule HP_good_insert) apply assumption apply assumption*)
    apply (erule AL_UPD)
apply clarsimp  apply fast
done


lemma NewNew_Invariant2_13:
  "\<lbrakk> Invariant ca \<Sigma> ([v], emp, k) I1 N[c\<mapsto>(classTP C)] (c # S, \<Gamma>, H[c\<mapsto>(C1, emp)])
     (RVal (Loc (nextLoc h)) # ops, s, h[(nextLoc h)\<mapsto>(C1, emp)]) (\<lambda>x. if x = c then Some (nextLoc h) else I x);
     ca \<in> AL_dom N; c\<notin> AL_dom N; State_welldef (S, \<Gamma>, H) N; subclass_of C1 C\<rbrakk>
   \<Longrightarrow> Invariant ca \<Sigma> ([v], emp, k) I1 N (S, \<Gamma>, H) (ops,s,h) I"
apply (simp add: Invariant_def ValRepEQ, clarsimp)
apply (frule AL_domD, clarsimp)
apply (rule, clarsimp) apply (erule impE) apply (simp add: ObjIDs_insertObj) apply clarsimp
  apply (erule SetTriv101) 
  apply (erule ValuesRespresentedNewNew1_TL_13) apply assumption apply assumption 
done

lemma ValuesRepresented_DOM: "\<exists> v . v:ValuesRepresented c \<Sigma> \<tau> J \<Longrightarrow> c:DOM \<Sigma>"
apply clarsimp
apply (case_tac "c \<in> DOM \<Sigma>", assumption)
apply (drule_tac \<tau>=\<tau> and J=J in ValuesRepresented_notin_DOM) apply fast
done

lemma NewNew_Sound2_13:
  "\<lbrakk>get_ins M l = Some (new C1); get_ins MM ll = Some (new C2); c \<notin> AL_dom N; 
     subclass_of C1 C; subclass_of C2 C;
     SecN n ((c # S, \<Gamma>, H[c\<mapsto>(C1, emp)]), N[c\<mapsto>(classTP C)], c # T, \<Delta>, K[c\<mapsto>(C2, emp)]) 
              M (Suc l) MM (Suc ll) (\<Sigma>,af,\<Pi>)\<rbrakk>
   \<Longrightarrow> SecN (Suc n) ((S, \<Gamma>, H), N, T, \<Delta>, K) M l MM ll (\<Sigma>,af,\<Pi>)"
(*NewNew*)
apply (simp add: SecN_def, clarsimp)
apply (subgoal_tac "preserved ((S, \<Gamma>, H), N, T, \<Delta>, K) (\<Sigma>, af, \<Pi>)")
prefer 2 apply (rotate_tac -1, erule thin_rl)
         apply (simp add: preserved_def, clarsimp)
         apply (case_tac \<Sigma>, clarsimp)
         apply (rule, rule contained_transitive) prefer 2 apply assumption apply (rule contained_upd) apply assumption
         apply (rule, rule SetTriv101) prefer 2 apply assumption apply (rule AL_dom_upd)
         apply (rule SetTriv101) prefer 2 apply assumption apply (rule AL_dom_upd)
apply (rule, assumption)
apply clarsimp
apply (erule eval_cases) apply clarsimp apply clarify
apply (drule NewElim1) apply assumption apply clarify
apply (erule eval_cases) apply clarsimp apply clarify
apply (drule NewElim1) apply assumption apply clarify
apply (erule_tac x=ma in allE, erule_tac x=mb in allE, rotate_tac -1, erule impE, erule Arith_14) 
apply (erule_tac x="RVal (Loc ap) # a" in allE)
apply (erule_tac x=aa in allE)
apply (erule_tac x="b[ap\<mapsto>(C1, emp)]" in allE)
apply (erule_tac x=h in allE)
apply (erule_tac x=v in allE, clarsimp)
apply (erule_tac x="RVal (Loc as) # ab" in allE)
apply (erule_tac x=ac in allE)
apply (erule_tac x="ba[as\<mapsto>(C2, emp)]" in allE)
apply (erule_tac x=k in allE)
apply (erule_tac x=w in allE, clarsimp)
apply (erule_tac x=Ha in allE, erule_tac x=Na in allE, erule_tac x=Ka in allE)
apply (subgoal_tac "c\<notin> AL_dom afa")
prefer 2 
  apply (rotate_tac -1, erule thin_rl) 
    apply (simp add: RSD_sum_def preserved_def, clarsimp) apply (case_tac \<Sigma>, clarsimp)  apply (case_tac \<Pi>, clarsimp)  
    apply (simp add: AL_sum_def, clarsimp)
    apply (drule_tac X="AL_dom af" and x=c and y=c in SetTriv106) 
      apply (erule contained6) apply (rule AL_dom_upd2) apply assumption
      apply simp
apply (simp add: unisat_sat) apply clarsimp
apply (frule_tac b=b and c=c and C=C1 and D=C in unisat_NewSubclass)
  apply assumption
  apply assumption
  apply assumption
apply (frule_tac b=ba and c=c and C=C2 and D=C in unisat_NewSubclass)
  apply assumption
  apply assumption
  apply assumption
apply (subgoal_tac "State_welldef (ad, ae, bb) afa")
prefer 2 apply (simp only: unisat_def)
apply (subgoal_tac "uniqueValues (c # ad, ae, bb[c\<mapsto>(C1, emp)]) (RVal (Loc ap) # a, aa, b[ap\<mapsto>(C1, emp)])
         (\<lambda>x. if x = c then Some ap else I x)")
prefer 2 apply (erule_tac h=b and c=c and C=C1 and D=C and ops=a and s=aa and I=I in uniqueValues_NewSubclass)
           apply assumption apply assumption apply assumption
           apply (simp only: unisat_def StateSatisfiesAbstraction_def) 
           apply (simp only: unisat_def StateSatisfiesAbstraction_def) 
apply (subgoal_tac "State_welldef (ag, ah, bc) afa")
prefer 2 apply (simp only: unisat_def)
apply (subgoal_tac "uniqueValues (c # ag, ah, bc[c\<mapsto>(C2, emp)]) (RVal (Loc as) # ab, ac, ba[as\<mapsto>(C2, emp)])
         (\<lambda>x. if x = c then Some as else J x)")
prefer 2 apply (erule_tac h=ba and c=c and C=C2 and D=C and ops=ab and s=ac and I=J in uniqueValues_NewSubclass)
           apply assumption apply assumption apply assumption
           apply (simp only: unisat_def StateSatisfiesAbstraction_def) 
           apply (simp only: unisat_def StateSatisfiesAbstraction_def) 
apply (erule_tac x="c # ad" in allE, erule_tac x=ae in allE, erule_tac x="bb[c\<mapsto>(C1, emp)]" in allE)
apply (erule_tac x="afa[c\<mapsto>(classTP C)]" in allE)
apply (erule_tac x="c # ag" in allE, erule_tac x=ah in allE, erule_tac x="bc[c\<mapsto>(C2, emp)]" in allE)
apply (erule_tac x=ai in allE, erule_tac x=aj in allE, erule_tac x=bd in allE)
apply (erule_tac x=ak in allE)
apply (erule_tac x=al in allE, erule_tac x=am in allE, erule_tac x=be in allE)
apply (erule_tac x="(\<lambda>x. if x = c then Some ap else I x)" in allE)
apply (erule_tac x="(\<lambda>x. if x = c then Some as else J x)" in allE)
apply (erule impE)
  apply rule apply assumption
  apply rule apply assumption
  apply clarsimp apply (simp add: uniqueValues_def singleVal_def) 
                 apply (case_tac "ca:DOM (c # ad, ae, bb[c\<mapsto>(C1, emp)])")
                   apply (erule_tac x=ca in allE, erule impE, assumption) apply (erule exE) 
                   apply (case_tac "ca \<in> DOM (c # ag, ah, bc[c\<mapsto>(C2, emp)])")
                     apply (erule_tac x=ca in allE, erule impE, assumption) apply (erule exE) 
                     apply (rule twSetVW, assumption, assumption)
                       apply (drule AL_upd_split)
                         apply (erule disjE) apply clarsimp
                         apply clarsimp apply (erule_tac x=ca in allE, clarsimp)
                           apply (subgoal_tac "va:ValuesRepresented ca (ad, ae, bb) (a, aa, b) I")
                           prefer 2 apply (rule_tac X="ValuesRepresented ca (c # ad, ae, bb[c\<mapsto>(C1, emp)]) (RVal (Loc ap) # a, aa, b[ap\<mapsto>(C1, emp)])
         (\<lambda>x. if x = c then Some ap else I x)" in SetTriv) apply fast
                                    apply (rule SetTriv109) apply (rule ValuesRepresented1) apply fast
                                    apply (rule_tac N=afa in New_ValuesRepresented21New13)
                                      apply (erule State_welldef_lookupHeap)
                                      apply (erule AL_domI) apply fast
                           apply (subgoal_tac "vb:ValuesRepresented ca (ag, ah, bc) (ab, ac, ba) J")
                           prefer 2 apply (rule_tac X="ValuesRepresented ca (c # ag, ah, bc[c\<mapsto>(C2, emp)]) (RVal (Loc as) # ab, ac, ba[as\<mapsto>(C2, emp)])
         (\<lambda>x. if x = c then Some as else J x)" in SetTriv) apply fast
                                    apply (rule SetTriv109) apply (rule ValuesRepresented1) apply fast
                                    apply (rule_tac N=afa in New_ValuesRepresented21New13)
                                      apply (erule State_welldef_lookupHeap)
                                      apply (erule AL_domI) apply fast
                            apply (erule impE) apply rule apply (rule_tac \<tau>="(a, aa, b)" and J=I in ValuesRepresented_DOM) apply (rule, assumption)
                                       apply (rule_tac \<tau>="(ab, ac, ba)" and J=J in ValuesRepresented_DOM) apply (rule, assumption)
                            apply (erule twSet.elims) apply clarsimp apply clarsimp apply clarsimp apply clarsimp
                     apply (rule twSetEmpR) apply (erule ValuesRepresented_notin_DOM) apply assumption
                   apply (case_tac "ca \<in> DOM (c # ag, ah, bc[c\<mapsto>(C2, emp)])")
                     apply (erule_tac x=ca in allE, erule impE, assumption) apply (erule exE)
                     apply (rule twSetEmpL) apply (erule ValuesRepresented_notin_DOM) apply simp
                   apply (rule twSetEmp) apply (erule ValuesRepresented_notin_DOM) apply (erule ValuesRepresented_notin_DOM) 
apply (erule impE) apply (simp add: RSD_sum_def) apply clarsimp 
                   apply (rule, erule AL_UPD) 
                   apply (rule, erule AL_UPD) 
                   apply (rule, erule AL_UPD)
                   apply (subgoal_tac "c\<notin> AL_dom bb") 
                     apply (rule, rule AL_sum_upd_upd2, assumption) apply clarsimp apply (drule AL_sum4a, assumption) apply simp 
                       apply assumption 
                   apply (subgoal_tac "c\<notin> AL_dom bc") 
                   apply (rule, rule AL_sum_upd_upd2, assumption) apply clarsimp apply (drule AL_sum4a, assumption) apply simp 
                       apply assumption 
                   apply (rule, rule AL_sum_upd_upd2, assumption) apply clarsimp apply (drule AL_sum4a, assumption) apply simp 
                       apply assumption 
                   apply (rule, simp add: AL_dom_upd1) apply clarsimp apply (drule AL_sum4a, assumption) apply simp
                   apply (rule, simp add: AL_dom_upd1) apply clarsimp apply (drule AL_sum4a, assumption) apply simp
                   apply (simp add: AL_dom_upd1) apply clarsimp apply (drule AL_sum4a, assumption) apply simp
                 apply (simp add: unisat_def, clarsimp) apply (drule State_welldef_lookupHeap1, assumption) apply fast 
                 apply (simp add: unisat_def, clarsimp) apply (drule State_welldef_lookupHeap1, assumption) apply fast 
apply (erule impE) apply assumption 
apply clarsimp 
apply (rule_tac x=I1 in exI, simp)
apply (rule_tac x=J1 in exI, simp)
apply (rule, rule)
apply (rotate_tac -2, erule_tac x=ca in allE, erule impE) apply (simp add: AL_dom_upd1)
apply (erule conjE)
apply rule
  apply (erule NewNew_Invariant2_13) apply assumption+
  apply (erule NewNew_Invariant2_13) apply assumption+ 
done 

lemma NewNew_Sound:
  "\<lbrakk>get_ins M l = Some (new C); get_ins MM ll = Some (new C); c \<notin> AL_dom N;
        SecN n ((c # S, \<Gamma>, H[c\<mapsto>(C, emp)]), N[c\<mapsto>(classTP C)], c # T, \<Delta>, K[c\<mapsto>(C, emp)]) M (Suc l) MM (Suc ll) (\<Sigma>,af,\<Pi>)\<rbrakk>
       \<Longrightarrow> SecN (Suc n) ((S, \<Gamma>, H), N, T, \<Delta>, K) M l MM ll (\<Sigma>,af,\<Pi>)"
apply (subgoal_tac "subclass_of C C")
apply (erule_tac NewNew_Sound2_13) apply assumption+ apply (simp add: subclass_of_refl)
done


end