theory Rules_UniBasic = UniSatSec:

(*possibly additional lemmas in the marked place of UniTying*)

lemma ValuesRepresented_State_welldef1:
 "\<lbrakk> State_welldef (S, \<Gamma>, H) N; c \<notin> AL_dom N\<rbrakk> 
 \<Longrightarrow> ValuesRepresented c ([c], emp, H) ([v], emp, h) I = {v}"
apply (simp add: ValuesRepresented_def, rule, clarsimp)
apply (erule disjE, clarsimp)
  apply (erule disjE, clarsimp) apply (simp add: AL_emp1)
  apply (erule disjE, clarsimp) apply (drule State_welldef_lookupHeap1) apply assumption apply simp 
  apply clarsimp apply (drule State_welldef_Field_lookup) apply assumption apply assumption apply clarsimp apply (drule_tac H=N in AL_domI) apply simp
apply clarsimp
done


lemma UniConst_SoundUni:
"\<lbrakk>get_ins M l = Some (const (IVal i)); \<Sigma> = (S, \<Gamma>, H); c \<notin> AL_dom N; L = {l + 1}; \<Pi> = (c # S, \<Gamma>, H); NN = N[c\<mapsto>intTP]\<rbrakk>
       \<Longrightarrow> get_ins M l \<noteq> Some vreturn \<and>
          (\<forall>n S \<Gamma> H Sp \<Gamma>p Hp.
              UniCtxtUniValidN n U \<longrightarrow>
              \<Sigma> = (S, \<Gamma>, H) \<longrightarrow> \<Pi> = (Sp, \<Gamma>p, Hp) \<longrightarrow> AL_dom H \<subseteq> AL_dom Hp \<and> contained N NN \<and> UniSS_UniSecN (Suc n) \<Sigma> N \<Pi> NN M l L)"
apply (simp only : UniSS_UniSecN_def)
apply (rule, simp)
apply (rule allI)+ apply (rule impI)+
apply (rule, simp)
apply (rule, erule contained_upd) 
apply (rule, simp)
apply (rule, erule contained_upd) 
apply clarsimp
apply (drule ConstElim1) apply assumption apply clarsimp
apply (rule_tac x=I in exI)
apply (simp add: SD_sum_def, clarsimp)
(*apply (rule_tac x=bc in exI, rule_tac x="N0[c\<mapsto>(intTP, qq)]" in exI, simp)*)
apply (subgoal_tac "c \<notin> AL_dom Nx") 
prefer 2 apply (subgoal_tac "c:AL_dom N[c\<mapsto>intTP]", fast) 
         apply (rule AL_dom_upd2)
apply (subgoal_tac "\<forall>x ca. (N0[c\<mapsto>intTP]\<down>x = Some ca) = (N1\<down>x = Some ca)")
prefer 2 apply clarsimp 
         apply rule apply (drule AL_upd_split)
                    apply (erule disjE, clarsimp) 
                      apply (erule AL_sum3, rule AL_update1)
                    apply clarsimp
                    apply (drule AL_sum_split, assumption)
                    apply (erule disjE)
                      apply (erule AL_sum3) apply (erule AL_update5) apply assumption
                    apply (erule AL_sum4, assumption)
         apply (drule AL_sum_split, assumption)
         apply (erule disjE) 
           apply (drule AL_upd_split)
           apply (erule disjE, clarsimp)
             apply (rule AL_update1)
           apply clarsimp
           apply (rule AL_update5) apply (erule AL_sum3, assumption) apply assumption
         apply (rule AL_update5) apply (erule AL_sum4, assumption) apply (drule_tac H=Nx in AL_domI) apply fast
apply (subgoal_tac "\<forall>x c. (bc\<down>x = Some c) = (bb\<down>x = Some c)")
prefer 2 apply (erule AL_sum_extensional, assumption)
apply (rule, simp add: unisat_def, clarsimp) 
  apply (subgoal_tac "State_welldef (S, \<Gamma>, bc) N0")
  prefer 2 apply (erule State_welldef_HPextensional) apply (erule AL_sum_extensional, assumption) apply assumption 
  apply rule apply (drule State_welldef_ConsCons) apply assumption apply assumption apply assumption
             apply (rule_tac H=bb in State_welldef_HPextensional)
               apply (erule  State_welldef_MPextensional) apply clarsimp apply assumption
             apply clarsimp apply assumption
  apply (rule StateSatisfiesAbstraction_HP_extensional)
    apply (rule_tac N="N0[c\<mapsto>intTP]" in StateSatisfiesAbstraction_MPextensional)
      apply (erule StateSatisfiesAbstraction_freshInt) apply simp apply assumption apply (simp add: AL_sum_def) 
      apply clarsimp 
    apply clarsimp
apply clarsimp
apply (rule_tac H=bb in Invariant_leftHPextensional)
  apply (simp add: Invariant_def ValRepEQ) 
  apply (subgoal_tac "ca \<noteq> c") prefer 2 apply (simp add: AL_sum_def) apply fastsimp
  apply (rule SetTriv109)
    apply (erule ValuesRepresented1)
    apply simp
  apply (rule allI)+ apply rule apply fast
apply clarsimp
apply assumption
done

lemma UniUnop_SoundUni:
"\<lbrakk>get_ins M l = Some (unop f); \<Sigma> = (c # S, \<Gamma>, H); N\<down>c = Some tp; d \<notin> AL_dom N; \<Pi> = (d # S, \<Gamma>, H); NN = N[d\<mapsto>intTP]; L = {l + 1};
  \<forall> v . typecorrect v tp \<longrightarrow> typecorrect (f v) intTP\<rbrakk>
       \<Longrightarrow> get_ins M l \<noteq> Some vreturn \<and>
          (\<forall>n S \<Gamma> H Sp \<Gamma>p Hp.
              UniCtxtUniValidN n U \<longrightarrow>
              \<Sigma> = (S, \<Gamma>, H) \<longrightarrow> \<Pi> = (Sp, \<Gamma>p, Hp) \<longrightarrow> AL_dom H \<subseteq> AL_dom Hp \<and> contained N NN \<and> UniSS_UniSecN (Suc n) \<Sigma> N \<Pi> NN M l L)"
apply (simp only : UniSS_UniSecN_def)
apply (rule, simp)
apply (rule allI)+ apply (rule impI)+
apply (rule, simp)
apply (rule, erule contained_upd) 
apply (rule, simp)
apply (rule, erule contained_upd) 
apply clarsimp
apply (drule UnopElim1) apply assumption apply clarsimp
apply (rule_tac x=I in exI)
apply (simp add: SD_sum_def, clarsimp)
(*apply (rule_tac x=bc in exI, rule_tac x="N0[d\<mapsto>(intTP, q)]" in exI, simp)*)
apply (subgoal_tac "d \<notin> AL_dom Nx") 
prefer 2 apply (subgoal_tac "d:AL_dom N[d\<mapsto>intTP]", fast) 
         apply (rule AL_dom_upd2) 
apply (subgoal_tac "\<forall>x ca. (N0[d\<mapsto>intTP]\<down>x = Some ca) = (N1\<down>x = Some ca)")
prefer 2 apply clarsimp 
         apply rule apply (drule AL_upd_split)
                    apply (erule disjE, clarsimp) 
                      apply (erule AL_sum3, rule AL_update1)
                    apply clarsimp
                    apply (drule AL_sum_split, assumption)
                    apply (erule disjE)
                      apply (erule AL_sum3) apply (erule AL_update5) apply assumption
                    apply (erule AL_sum4, assumption)
         apply (drule AL_sum_split, assumption)
         apply (erule disjE) 
           apply (drule AL_upd_split)
           apply (erule disjE, clarsimp)
             apply (rule AL_update1)
           apply clarsimp
           apply (rule AL_update5) apply (erule AL_sum3, assumption) apply assumption
         apply (rule AL_update5) apply (erule AL_sum4, assumption) apply (drule_tac H=Nx in AL_domI) apply fast
apply (subgoal_tac "\<forall>x c. (bb\<down>x = Some c) = (bc\<down>x = Some c)")
prefer 2 apply (erule AL_sum_extensional, assumption)
apply (subgoal_tac "contained N0 N1")
prefer 2 apply (simp (no_asm) add: contained_def, clarsimp)
         apply (frule AL_sum_split, assumption)
         apply (erule disjE) 
           apply (erule AL_sum3, erule AL_update5) 
           apply (drule_tac d=a in AL_domI) apply (simp add: AL_sum_def) apply fastsimp
         apply (erule AL_sum4, assumption)
apply (drule unisat_HPextensional) apply assumption apply assumption
apply (rule, simp add: unisat_def, clarsimp) 
  apply rule apply (drule State_welldef_Tail) 
             apply (rule State_welldef_MPextensional)
               apply (erule State_welldef_ConsCons) apply assumption apply assumption apply assumption
             apply clarsimp apply assumption
  apply (rule_tac N="N0[d\<mapsto>intTP]" in  StateSatisfiesAbstraction_MPextensional)
    apply (rule StateSatisfiesAbstraction_freshInt)
      apply (erule StateSatisfiesAbstraction_Tail) 
      apply (erule_tac x=v in allE, erule mp) apply (simp add: StateSatisfiesAbstraction_def State_typecorrect_def Opstack_typecorrect_def, clarsimp) 
        apply (erule_tac x=0 in allE, clarsimp) apply (drule AL_sum3) apply assumption apply clarsimp
      apply (erule State_welldef_Tail) apply (simp add: AL_sum_def)
    apply clarsimp
apply clarsimp
apply (rule_tac H=bb in Invariant_leftHPextensional)
  apply (simp add: Invariant_def ValRepEQ) 
  apply (subgoal_tac "ca \<noteq> d") prefer 2 apply (simp add: AL_sum_def) apply fastsimp
  apply (rule SetTriv109) apply (erule ValuesRepresented1)  apply (rule ValuesRepresented9)
  apply (rule allI)+ apply rule apply fast
apply clarsimp
apply assumption
done



lemma UniBinop_SoundUni:
"\<lbrakk>get_ins M l = Some (binop f); \<Sigma> = (c1 # c2 # S, \<Gamma>, H); N\<down>c1 = Some tp1; N\<down>c2 = Some tp2; c \<notin> AL_dom N; \<Pi> = (c # S, \<Gamma>, H);
        NN = N[c\<mapsto>intTP]; L = {l + 1}; \<forall> v w . typecorrect v tp1 \<longrightarrow> typecorrect w tp2 \<longrightarrow> typecorrect (f v w) intTP\<rbrakk>
       \<Longrightarrow> get_ins M l \<noteq> Some vreturn \<and>
          (\<forall>n S \<Gamma> H Sp \<Gamma>p Hp.
              UniCtxtUniValidN n U \<longrightarrow> \<Sigma> = (S, \<Gamma>, H) \<longrightarrow> \<Pi> = (Sp, \<Gamma>p, Hp) \<longrightarrow> AL_dom H \<subseteq> AL_dom Hp \<and> contained N NN \<and> UniSS_UniSecN (Suc n) \<Sigma> N \<Pi> NN M l L)"
apply (simp only : UniSS_UniSecN_def)
apply (rule, simp)
apply (rule allI)+ apply (rule impI)+
apply (rule, simp)
apply (rule, erule contained_upd) 
apply (rule, simp)
apply (rule, erule contained_upd) 
apply clarsimp
apply (drule BinopElim1) apply assumption apply clarsimp
apply (rule_tac x=I in exI)
apply (simp add: SD_sum_def, clarsimp)
(*apply (rule_tac x=bc in exI, rule_tac x="N0[d\<mapsto>(intTP, q)]" in exI, simp)*)
apply (subgoal_tac "c \<notin> AL_dom Nx") 
prefer 2 apply (subgoal_tac "c:AL_dom N[c\<mapsto>intTP]", fast) 
         apply (rule AL_dom_upd2) 
apply (subgoal_tac "\<forall>x ca. (N0[c\<mapsto>intTP]\<down>x = Some ca) = (N1\<down>x = Some ca)")
prefer 2 apply clarsimp 
         apply rule apply (drule AL_upd_split)
                    apply (erule disjE, clarsimp) 
                      apply (erule AL_sum3, rule AL_update1)
                    apply clarsimp
                    apply (drule AL_sum_split, assumption)
                    apply (erule disjE)
                      apply (erule AL_sum3) apply (erule AL_update5) apply assumption
                    apply (erule AL_sum4, assumption)
         apply (drule AL_sum_split, assumption)
         apply (erule disjE) 
           apply (drule AL_upd_split)
           apply (erule disjE, clarsimp)
             apply (rule AL_update1)
           apply clarsimp
           apply (rule AL_update5) apply (erule AL_sum3, assumption) apply assumption
         apply (rule AL_update5) apply (erule AL_sum4, assumption) apply (drule_tac H=Nx in AL_domI) apply fast
apply (subgoal_tac "\<forall>x d. (bb\<down>x = Some d) = (bc\<down>x = Some d)")
prefer 2 apply (erule AL_sum_extensional, assumption)
apply (subgoal_tac "contained N0 N1")
prefer 2 apply (simp (no_asm) add: contained_def, clarsimp)
         apply (frule AL_sum_split, assumption)
         apply (erule disjE) 
           apply (erule AL_sum3, erule AL_update5) 
           apply (drule_tac d=a in AL_domI) apply (simp add: AL_sum_def) apply fastsimp
         apply (erule AL_sum4, assumption)
apply (drule unisat_HPextensional) apply assumption apply assumption
apply (rule, simp add: unisat_def, clarsimp) 
  apply rule apply (drule State_welldef_Tail) 
             apply (drule State_welldef_Tail) 
             apply (rule State_welldef_MPextensional)
               apply (erule State_welldef_ConsCons) apply assumption apply assumption apply assumption
             apply clarsimp apply assumption
  apply (rule_tac N="N0[c\<mapsto>intTP]" in  StateSatisfiesAbstraction_MPextensional)
    apply (rule StateSatisfiesAbstraction_freshInt)
      apply (rule StateSatisfiesAbstraction_Tail) 
      apply (erule StateSatisfiesAbstraction_Tail) 
      apply (erule_tac x=v in allE, erule impE) apply (simp add: StateSatisfiesAbstraction_def State_typecorrect_def Opstack_typecorrect_def, clarsimp) 
        apply (erule_tac x=0 in allE, clarsimp) apply (drule_tac x=c1 in AL_sum3) apply assumption apply clarsimp
      apply (erule_tac x=w in allE, erule mp) apply (simp add: StateSatisfiesAbstraction_def State_typecorrect_def Opstack_typecorrect_def, clarsimp) 
        apply (erule_tac x=1 in allE, clarsimp) apply (drule_tac x=c2 in AL_sum3) apply assumption apply clarsimp
      apply (rule State_welldef_Tail) apply (erule State_welldef_Tail)
      apply (simp add: AL_sum_def)
    apply clarsimp
apply clarsimp
apply (rule_tac H=bb in Invariant_leftHPextensional)
  apply (simp add: Invariant_def ValRepEQ) 
  apply (subgoal_tac "ca \<noteq> c") prefer 2 apply (simp add: AL_sum_def) apply fastsimp
  apply (rule SetTriv109) apply (erule ValuesRepresented1) 
                                apply (rule SetTriv101) apply (rule ValuesRepresented9) apply (rule ValuesRepresented9)
  apply (rule allI)+ apply rule apply fast
apply clarsimp
apply assumption
done



lemma UniPop_SoundUni:
"\<lbrakk>get_ins M l = Some pop; \<Sigma> = (c # S, \<Gamma>, H); L = {l + 1}; \<Pi> = (S, \<Gamma>, H); NN = N\<rbrakk>
       \<Longrightarrow> get_ins M l \<noteq> Some vreturn \<and>
          (\<forall>n S \<Gamma> H Sp \<Gamma>p Hp.
              UniCtxtUniValidN n U \<longrightarrow> \<Sigma> = (S, \<Gamma>, H) \<longrightarrow> \<Pi> = (Sp, \<Gamma>p, Hp) \<longrightarrow> AL_dom H \<subseteq> AL_dom Hp \<and> contained N NN \<and> UniSS_UniSecN (Suc n) \<Sigma> N \<Pi> NN M l L)"
apply (simp only : UniSS_UniSecN_def)
apply (rule, simp)
apply (rule allI)+ apply (rule impI)+
apply (rule, simp)
apply (rule, rule contained_refl) 
apply (rule, simp)
apply (rule, rule contained_refl) 
apply clarsimp
apply (drule PopElim1) apply assumption apply clarsimp
apply (rule_tac x=I in exI)
apply (simp add: SD_sum_def, clarsimp)
apply (subgoal_tac "\<forall>x d. (bb\<down>x = Some d) = (bc\<down>x = Some d)")
prefer 2 apply (erule AL_sum_extensional, assumption)
apply (subgoal_tac "\<forall>x d. (N0\<down>x = Some d) = (N1\<down>x = Some d)")
prefer 2 apply (erule AL_sum_extensional, assumption)
apply (drule unisat_HPextensional) apply assumption apply assumption
apply (rule, simp add: unisat_def, clarsimp) 
  apply rule apply (rule State_welldef_Tail) apply (erule State_welldef_MPextensional) apply clarsimp apply assumption
  apply (rule StateSatisfiesAbstraction_Tail)
             apply (erule  StateSatisfiesAbstraction_MPextensional) apply clarsimp 
apply clarsimp
apply (rule_tac H=bb in Invariant_leftHPextensional)
  apply (simp add: Invariant_def ValRepEQ)
  apply (rule ValuesRepresented9)
  apply (rule allI)+ apply rule apply fast
apply clarsimp
apply assumption
done

lemma ValuesRepresented_Dup:
  "ValuesRepresented ca (c # c # S, \<Gamma>, bc) (v # v # ops, aa, b) I = ValuesRepresented ca (c # S, \<Gamma>, bc) (v # ops, aa, b) I"
apply rule apply (simp add: ValuesRepresented_def, clarsimp)
      apply (case_tac n, clarsimp) apply (erule_tac x=0 in allE, clarsimp) 
      apply clarsimp apply (erule_tac x=nat in allE, clarsimp)
apply (simp add: ValuesRepresented_def, clarsimp)
      apply (case_tac n, clarsimp) apply (erule_tac x=0 in allE, clarsimp)
      apply clarsimp  apply (erule_tac x="Suc(Suc nat)" in allE, clarsimp)
done

lemma UniDup_SoundUni:
"\<lbrakk>get_ins M l = Some dup; \<Sigma> = (c # S, \<Gamma>, H); \<Pi> = (c # c # S, \<Gamma>, H); NN = N; L = {l + 1}\<rbrakk>
       \<Longrightarrow> get_ins M l \<noteq> Some vreturn \<and>
          (\<forall>n S \<Gamma> H Sp \<Gamma>p Hp.
              UniCtxtUniValidN n U \<longrightarrow>
              \<Sigma> = (S, \<Gamma>, H) \<longrightarrow> \<Pi> = (Sp, \<Gamma>p, Hp) \<longrightarrow> AL_dom H \<subseteq> AL_dom Hp \<and> contained N NN \<and> UniSS_UniSecN (Suc n) \<Sigma> N \<Pi> NN M l L)"
apply (simp only : UniSS_UniSecN_def)
apply (rule, simp)
apply (rule allI)+ apply (rule impI)+
apply (rule, simp)
apply (rule, rule contained_refl) 
apply (rule, simp)
apply (rule, rule contained_refl) 
apply clarsimp
apply (drule DupElim1) apply assumption apply clarsimp
apply (rule_tac x=I in exI)
apply (simp add: SD_sum_def, clarsimp)
apply (subgoal_tac "\<forall>x d. (bb\<down>x = Some d) = (bc\<down>x = Some d)")
prefer 2 apply (erule AL_sum_extensional, assumption)
apply (subgoal_tac "\<forall>x d. (N0\<down>x = Some d) = (N1\<down>x = Some d)")
prefer 2 apply (erule AL_sum_extensional, assumption)
apply (subgoal_tac "AL_dom N1 = AL_dom N0") 
prefer 2 apply (simp add: AL_dom_def)
apply (subgoal_tac "ObjIDs N1 = ObjIDs N0") 
prefer 2 apply (simp add: ObjIDs_def)
apply (drule unisat_HPextensional) apply assumption apply assumption
apply (rule, simp add: unisat_def, clarsimp)
  apply rule apply (simp add: State_welldef_def, clarsimp) apply (simp add: State_good_def)  
  apply (simp add: StateSatisfiesAbstraction_def, clarsimp) 
  apply (subgoal_tac "State_typecorrect N1 (c # c # S, \<Gamma>, bc) (v # v # ops, aa, b) I", rule, assumption) 
  prefer 2 apply (simp add: State_typecorrect_def Opstack_typecorrect_def)
           apply rule apply clarsimp
             apply (case_tac na, clarsimp) apply (erule_tac x=0 in allE, clarsimp)
             apply (case_tac nat, clarsimp) apply (erule_tac x=0 in allE, clarsimp)
           apply clarsimp apply (erule_tac x="Suc nata" in allE, clarsimp)
           apply (rule, simp add: Store_typecorrect_def)
           apply (simp add: Heap_typecorrect_def Fields_typecorrect_def HeapAbstractsAt_def) 
  apply (simp add: uniqueValues_def)
    apply (rule, clarsimp)
      apply (erule_tac x=ca in allE, erule impE) apply (simp add: DOM_def)
      apply (erule exE) apply (rule_tac x=va in exI)
      apply (simp add:  ValuesRepresented_Dup)
    apply (simp add: DOM_def)  
apply clarsimp
apply (rule_tac H=bb in Invariant_leftHPextensional)
  apply (simp add: Invariant_def ValRepEQ)
  apply (rule SetTriv109) apply (rule ValuesRepresented_Dup) apply simp 
  apply (rule allI)+ apply rule apply fast
apply clarsimp
apply assumption 
done

lemma ValuesRepresented_Swap:
  "ValuesRepresented ca (d # c # S, \<Gamma>, bc) (w # v # ops, aa, b) I = ValuesRepresented ca (c # d # S, \<Gamma>, bc) (v # w # ops, aa, b) I"
apply rule apply (simp add: ValuesRepresented_def, clarsimp)
      apply (case_tac n, clarsimp) apply (erule_tac x="Suc 0" in allE, clarsimp) apply clarsimp
      apply (case_tac nat, clarsimp) apply (erule_tac x=0 in allE, clarsimp) apply clarsimp
      apply (erule_tac x="Suc(Suc nata)" in allE, clarsimp)
apply (simp add: ValuesRepresented_def, clarsimp)
      apply (case_tac n, clarsimp) apply (erule_tac x="Suc 0" in allE, clarsimp) apply clarsimp
      apply (case_tac nat, clarsimp) apply (erule_tac x=0 in allE, clarsimp) apply clarsimp
      apply (erule_tac x="Suc(Suc nata)" in allE, clarsimp)
done

lemma UniSwap_SoundUni:
"\<lbrakk>get_ins M l = Some swap; \<Sigma> = (c # d # S, \<Gamma>, H); \<Pi> = (d # c # S, \<Gamma>, H); NN = N; L = {l + 1}\<rbrakk>
       \<Longrightarrow> get_ins M l \<noteq> Some vreturn \<and>
          (\<forall>n S \<Gamma> H Sp \<Gamma>p Hp.
              UniCtxtUniValidN n U \<longrightarrow>
              \<Sigma> = (S, \<Gamma>, H) \<longrightarrow> \<Pi> = (Sp, \<Gamma>p, Hp) \<longrightarrow> AL_dom H \<subseteq> AL_dom Hp \<and> contained N NN \<and> UniSS_UniSecN (Suc n) \<Sigma> N \<Pi> NN M l L)"
apply (simp only : UniSS_UniSecN_def)
apply (rule, simp)
apply (rule allI)+ apply (rule impI)+
apply (rule, simp)
apply (rule, rule contained_refl) 
apply (rule, simp)
apply (rule, rule contained_refl) 
apply clarsimp
apply (drule SwapElim1) apply assumption apply clarsimp
apply (rule_tac x=I in exI)
apply (simp add: SD_sum_def, clarsimp)
apply (subgoal_tac "\<forall>x d. (bb\<down>x = Some d) = (bc\<down>x = Some d)")
prefer 2 apply (erule AL_sum_extensional, assumption)
apply (subgoal_tac "\<forall>x d. (N0\<down>x = Some d) = (N1\<down>x = Some d)")
prefer 2 apply (erule AL_sum_extensional, assumption)
apply (subgoal_tac "AL_dom N1 = AL_dom N0") 
prefer 2 apply (simp add: AL_dom_def)
apply (subgoal_tac "ObjIDs N1 = ObjIDs N0") 
prefer 2 apply (simp add: ObjIDs_def)
apply (subgoal_tac "AbsFields bb = AbsFields bc") 
prefer 2 apply (simp add: AbsFields_expand)
apply (drule unisat_HPextensional) apply assumption apply assumption
apply (rule, simp add: unisat_def, clarsimp)
  apply rule apply (rule_tac N=N0 in State_welldef_MPextensional) 
               apply (simp add: State_welldef_def, clarsimp) apply (simp add: State_good_def)  
               apply (rule SetTriv109) prefer 2 apply assumption apply fast
             apply clarsimp apply assumption
  apply (simp add: StateSatisfiesAbstraction_def)
    apply (subgoal_tac "State_typecorrect N1 (d # c # S, \<Gamma>, bc) (w # v # ops, aa, b) I", rule, assumption)
    prefer 2 apply (simp add: State_typecorrect_def Store_typecorrect_def
                            Opstack_typecorrect_def, clarsimp) 
             apply rule apply clarsimp
             apply (case_tac na, clarsimp) apply (erule_tac x="Suc 0" in allE, clarsimp) apply clarsimp
             apply (case_tac nat, clarsimp) apply (erule_tac x=0 in allE, clarsimp) apply clarsimp
             apply (erule_tac x="Suc(Suc nata)" in allE, clarsimp)
             apply (simp add: Heap_typecorrect_def HeapAbstractsAt_def Fields_typecorrect_def)
   apply (rule, simp add: uniqueValues_def, clarsimp)
     apply (erule_tac x=ca in allE, erule impE, simp add: DOM_def) apply fastsimp
     apply (erule exE) apply (rule_tac x=va in exI) apply (simp add:ValuesRepresented_Swap) 
   apply (erule conjE)+
     apply (simp add: DOM_def) apply (rule SetTriv101) prefer 2 apply assumption apply fast
apply clarsimp
apply (rule_tac H=bb in Invariant_leftHPextensional)
  apply (simp add: Invariant_def ValRepEQ) 
  apply (rule SetTriv109) apply (rule ValuesRepresented_Swap) apply simp
  apply (rule allI)+ apply rule apply fast
apply clarsimp
apply assumption 
done

lemma ValuesRepresented_Load:
 "\<lbrakk>\<Gamma>\<down>x = Some c ; aa\<down>x = Some v\<rbrakk>
       \<Longrightarrow> ValuesRepresented ca (c # S, \<Gamma>, bc) (v # a, aa, b) I = ValuesRepresented ca (S, \<Gamma>, bc) (a, aa, b) I"
apply rule
  apply (simp add: ValuesRepresented_def, clarsimp)
  apply (case_tac n, clarsimp) apply clarsimp
  apply (erule_tac x=nat in allE, clarsimp)
apply (simp add: ValuesRepresented_def, clarsimp)
  apply (erule_tac x="Suc n" in allE, clarsimp)
done

lemma UniLoad_SoundUni:
"\<lbrakk>get_ins M l = Some (load x); \<Sigma> = (S, \<Gamma>, H); \<Gamma>\<down>x = Some c; \<Pi> = (c # S, \<Gamma>, H); NN = N; L = {l + 1}\<rbrakk>
       \<Longrightarrow> get_ins M l \<noteq> Some vreturn \<and>
          (\<forall>n S \<Gamma> H Sp \<Gamma>p Hp.
              UniCtxtUniValidN n U \<longrightarrow>
              \<Sigma> = (S, \<Gamma>, H) \<longrightarrow> \<Pi> = (Sp, \<Gamma>p, Hp) \<longrightarrow> AL_dom H \<subseteq> AL_dom Hp \<and> contained N NN \<and> UniSS_UniSecN (Suc n) \<Sigma> N \<Pi> NN M l L)"
apply (simp only : UniSS_UniSecN_def)
apply (rule, simp)
apply (rule allI)+ apply (rule impI)+
apply (rule, simp)
apply (rule, rule contained_refl) 
apply (rule, simp)
apply (rule, rule contained_refl) 
apply clarsimp
apply (drule LoadElim1) apply assumption apply clarsimp
apply (rule_tac x=I in exI)
apply (simp add: SD_sum_def, clarsimp)
apply (subgoal_tac "\<forall>x d. (bb\<down>x = Some d) = (bc\<down>x = Some d)")
prefer 2 apply (erule AL_sum_extensional, assumption)
apply (subgoal_tac "\<forall>x d. (N0\<down>x = Some d) = (N1\<down>x = Some d)")
prefer 2 apply (erule AL_sum_extensional, assumption)
apply (subgoal_tac "AL_dom N1 = AL_dom N0") 
prefer 2 apply (simp add: AL_dom_def)
apply (subgoal_tac "AL_dom bb = AL_dom bc") 
prefer 2 apply (simp add: AL_dom_def)
apply (subgoal_tac "ObjIDs N1 = ObjIDs N0") 
prefer 2 apply (simp add: ObjIDs_def)
apply (subgoal_tac "AbsFields bb = AbsFields bc") 
prefer 2 apply (simp add: AbsFields_expand)
apply (drule unisat_HPextensional) apply assumption apply assumption 
apply (subgoal_tac "c:AL_cod \<Gamma>") prefer 2 apply (erule AL_codI)
apply (subgoal_tac " StateSatisfiesAbstraction (v # a, aa, b) (c # S, \<Gamma>, bc) N1 I")
prefer 2 apply (simp add:unisat_def, clarsimp) 
  apply (simp add: StateSatisfiesAbstraction_def, clarsimp) 
    apply (rule, simp add:  State_typecorrect_def Opstack_typecorrect_def Store_typecorrect_def, clarsimp)
      apply (rule, clarsimp)
        apply (case_tac na, clarsimp) 
          apply (erule_tac x=x in allE, erule_tac x=c in allE, erule impE, assumption) apply clarsimp apply clarsimp
      apply (simp add: Heap_typecorrect_def HeapAbstractsAt_def Fields_typecorrect_def) 
    apply (rule, simp add: uniqueValues_def, clarsimp)
      apply (erule_tac x=ca in allE, erule impE, simp add: DOM_def) apply (drule AL_codI) apply fast
      apply (erule exE) apply (rule_tac x=va in exI) apply (simp add: ValuesRepresented_Load)
    apply (simp add: DOM_def) apply (rule SetTriv101) prefer 2 apply assumption apply fast  
apply (rule, simp add: unisat_def, clarsimp)
  apply (rule_tac N=N0 in State_welldef_MPextensional)
               apply (simp add: State_welldef_def, clarsimp) 
               apply (rule, erule SetTriv) apply assumption
               apply rule apply fast
               apply (simp add: State_good_def) 
             apply clarsimp apply assumption
apply clarsimp
apply (rule_tac H=bb in Invariant_leftHPextensional)
  apply (simp add: Invariant_def ValRepEQ) 
  apply (rule SetTriv109) apply (erule ValuesRepresented_Load) apply assumption apply simp
  apply (rule allI)+ apply rule apply fast
apply clarsimp
apply assumption
done

lemma ValuesRepresented_Store:
  "ValuesRepresented ca (S, \<Gamma>[x\<mapsto>c], bc) (ad, aa[x\<mapsto>v], b) I \<subseteq> ValuesRepresented ca (c # S, \<Gamma>, bc) (v # ad, aa, b) I"
  apply (simp add: ValuesRepresented_def, clarsimp)
  apply (erule disjE) apply clarsimp apply (erule_tac x="Suc n" in allE, clarsimp)
  apply (erule disjE) apply clarsimp apply (drule AL_upd_split) 
                                     apply (erule disjE, simp add: AL_update1) apply clarsimp apply (erule_tac x=0 in allE, clarsimp) 
                                     apply clarsimp apply (drule AL_update3) apply assumption apply (erule_tac x=xaa in allE, clarsimp) 
                                     apply assumption
done

lemma UniStore_SoundUni:
"\<lbrakk>get_ins M l = Some (store x); \<Sigma> = (c # S, \<Gamma>, H); \<Pi> = (S, upd \<Gamma> x c, H); NN = N; L = {l + 1}\<rbrakk>
       \<Longrightarrow> get_ins M l \<noteq> Some vreturn \<and>
          (\<forall>n S \<Gamma> H Sp \<Gamma>p Hp.
              UniCtxtUniValidN n U \<longrightarrow>
              \<Sigma> = (S, \<Gamma>, H) \<longrightarrow> \<Pi> = (Sp, \<Gamma>p, Hp) \<longrightarrow> AL_dom H \<subseteq> AL_dom Hp \<and> contained N NN \<and> UniSS_UniSecN (Suc n) \<Sigma> N \<Pi> NN M l L)"
apply (simp only : UniSS_UniSecN_def)
apply (rule, simp)
apply (rule allI)+ apply (rule impI)+
apply (rule, simp)
apply (rule, rule contained_refl) 
apply (rule, simp)
apply (rule, rule contained_refl) 
apply clarsimp
apply (drule StoreElim1) apply assumption apply clarsimp
apply (rule_tac x=I in exI)
apply (simp add: SD_sum_def, clarsimp)
apply (subgoal_tac "\<forall>x d. (bb\<down>x = Some d) = (bc\<down>x = Some d)")
prefer 2 apply (erule AL_sum_extensional, assumption)
apply (subgoal_tac "\<forall>x d. (N0\<down>x = Some d) = (N1\<down>x = Some d)")
prefer 2 apply (erule AL_sum_extensional, assumption)
apply (subgoal_tac "AL_dom N1 = AL_dom N0") 
prefer 2 apply (simp add: AL_dom_def)
apply (subgoal_tac "AL_dom bb = AL_dom bc") 
prefer 2 apply (simp add: AL_dom_def)
apply (subgoal_tac "ObjIDs N1 = ObjIDs N0") 
prefer 2 apply (simp add: ObjIDs_def)
apply (subgoal_tac "AbsFields bb = AbsFields bc") 
prefer 2 apply (simp add: AbsFields_expand)
apply (drule unisat_HPextensional) apply assumption apply assumption
apply (subgoal_tac " StateSatisfiesAbstraction (ab, aa[x\<mapsto>v], b) (S, \<Gamma>[x\<mapsto>c], bc) N1 I")
prefer 2 apply (simp add: unisat_def)
  apply (simp add: StateSatisfiesAbstraction_def, clarsimp) 
  apply (subgoal_tac "State_typecorrect N1 (S, \<Gamma>[x\<mapsto>c], bc) (ab, aa[x\<mapsto>v], b) I", rule, assumption)
  prefer 2 apply (simp add:  State_typecorrect_def Opstack_typecorrect_def Heap_typecorrect_def
                            Fields_typecorrect_def HeapAbstractsAt_def Store_typecorrect_def, clarsimp)
      apply (rule, clarsimp) apply (erule_tac x="Suc na" in allE, clarsimp) 
      apply clarsimp
        apply (drule AL_upd_split)
        apply (erule disjE, clarsimp) apply (erule_tac x=0 in allE, clarsimp) apply (simp add: AL_update1)
        apply clarsimp apply (erule_tac x=xa in allE, erule_tac x=ca in allE, clarsimp) 
          apply (rule_tac x=va in exI, simp) apply (erule AL_update5) apply assumption
    apply (rule, simp add: uniqueValues_def, clarsimp)
      apply (erule_tac x=ca in allE, erule impE, simp add: DOM_def)
       apply (erule disjE, fast)
       apply (erule disjE) apply (drule SetTriv, rule AL_cod_upd1) apply fast
       apply fast
      apply (erule exE) apply (rule_tac x=va in exI)
        apply (subgoal_tac "Values_Represented ca (S, \<Gamma>[x\<mapsto>c], bc) (ab, aa[x\<mapsto>v], b) I = {va}", simp add: ValRepEQ)
        apply (subgoal_tac "Values_Represented ca (c # S, \<Gamma>, bc) (v # ab, aa, b) I = {va}")
        prefer 2 apply (simp add: ValRepEQ) apply (rotate_tac -2, erule thin_rl)
        apply (simp add: Values_Represented_def)
        apply (rule, clarsimp)
          apply (rule, rule_tac Y="OpsValues_Represented ca (c # S) (v # ab)" in SetTriv101)
            apply (erule thin_rl, simp add: OpsValues_Represented_def, clarsimp) apply (rule_tac x="Suc na" in exI, simp)
            apply fast
          apply (rule, rule_tac Y="OpsValues_Represented ca (c # S) (v # ab) \<union> StoreValues_Represented ca \<Gamma> aa" in SetTriv101)
          apply (erule thin_rl, simp add: StoreValues_Represented_def OpsValues_Represented_def, clarsimp) 
            apply (drule AL_upd_split)
            apply (erule disjE, clarsimp) apply (simp add: AL_update1)
              apply (rule_tac x=0 in exI, simp)
            apply clarsimp apply (erule_tac x=xaa in allE, clarsimp)
              apply (drule AL_upd_split) apply clarsimp  
            apply fast
          apply (rule, fast)
          apply fast
        apply clarsimp
          apply (subgoal_tac "va:OpsValues_Represented ca (c # S) (v # ab) \<union> StoreValues_Represented ca \<Gamma> aa \<union> AddrValues_Represented ca bc I \<union>
        FieldValues_Represented ca bc I b") prefer 2 apply fast
          apply (subgoal_tac "OpsValues_Represented ca (c # S) (v # ab) \<union> StoreValues_Represented ca \<Gamma> aa \<union> AddrValues_Represented ca bc I \<union>
        FieldValues_Represented ca bc I b \<subseteq> {va}") prefer 2 apply (rotate_tac -1, erule thin_rl) apply fastsimp
          apply (erule thin_rl)
          apply clarsimp
          apply (case_tac "c=ca", clarsimp) 
(*          apply (drule_tac \<Sigma>="(S, \<Gamma>[x\<mapsto>c], bd)" in State_typecorrect_VR_notEmpty) apply assumption *)
            apply (erule disjE) apply(simp add: OpsValues_Represented_def StoreValues_Represented_def, clarsimp) 
              apply (case_tac na, clarsimp) apply (erule_tac x=x in allE, simp add: AL_update1) 
              apply clarsimp apply (erule_tac x=nat in allE, simp)
            apply (erule disjE) apply (simp add: StoreValues_Represented_def, clarsimp)
              apply (subgoal_tac "v=va", clarsimp)
              prefer 2 apply (subgoal_tac "v:OpsValues_Represented c (c # S) (v # ab)")
                         apply (drule SetTriv, assumption) apply clarsimp 
                       apply (simp add: OpsValues_Represented_def) apply (rule_tac x=0 in exI, simp)
              apply (erule_tac x=x in allE, simp add: AL_update1) 
            apply assumption 
          apply (erule disjE) apply(simp add: OpsValues_Represented_def, clarsimp) 
              apply (case_tac na, clarsimp) 
              apply clarsimp apply (erule_tac x=nat in allE, simp)
            apply (erule disjE) apply (simp add: StoreValues_Represented_def, clarsimp)
              apply (subgoal_tac "\<exists> w . w:Values_Represented ca (S, \<Gamma>[x\<mapsto>c], bc) (ab, aa[x\<mapsto>v], b) I", erule exE)
              prefer 2 apply (drule_tac \<Sigma>="(S, \<Gamma>[x\<mapsto>c], bc)" in State_typecorrect_VR_notEmpty) apply assumption apply fast  
              apply (simp add: Values_Represented_def)
              apply (erule disjE) apply (subgoal_tac "w=va", clarsimp) 
                                  apply (subgoal_tac "w:OpsValues_Represented ca (c # S) (v # ab)") 
                                    apply (drule SetTriv, assumption) apply clarsimp 
                                  apply (simp add:OpsValues_Represented_def, clarsimp) 
                                    apply (rule_tac x="Suc na" in exI, simp)
              apply (erule disjE) apply (subgoal_tac "w=va", clarsimp) 
                                    apply (simp add: StoreValues_Represented_def, clarsimp)
                                  apply (subgoal_tac "w:{v. \<exists>x. \<Gamma>\<down>x = Some ca \<and> aa\<down>x = Some v}") 
                                    apply (drule SetTriv, assumption) apply clarsimp 
                                  apply (simp add: StoreValues_Represented_def, clarsimp) 
                                  apply (drule AL_upd_split)
                                  apply (erule disjE, clarsimp) apply clarsimp
                                  apply (drule AL_upd_split)
                                  apply (erule disjE, clarsimp) apply clarsimp apply (rule_tac x=xaa in exI, simp)
              apply (erule disjE) apply (frule SetTriv, assumption) apply clarsimp
              apply (frule SetTriv, assumption) apply clarsimp 
           apply assumption 
    apply (simp add: DOM_def) apply (rule SetTriv101) prefer 2 apply assumption
      apply (rule SetTriv114)
      apply (subgoal_tac " AL_cod \<Gamma>[x\<mapsto>c] \<subseteq> insert c (AL_cod \<Gamma>)") apply (erule thin_rl, erule thin_rl, erule thin_rl, erule thin_rl)
       apply (erule thin_rl, erule thin_rl, erule thin_rl, erule thin_rl) apply (erule thin_rl, erule thin_rl, erule thin_rl, erule thin_rl) 
       apply (erule thin_rl, erule thin_rl, erule thin_rl, erule thin_rl) apply (erule thin_rl, erule thin_rl, erule thin_rl) 
       apply (erule thin_rl, erule thin_rl, erule thin_rl)  apply (erule thin_rl, erule thin_rl, erule thin_rl) apply fast
      apply (rule SetTriv101) apply (rule AL_cod_upd1) apply simp
apply (rule, simp add: unisat_def, clarsimp)
  apply (rule_tac N=N0 in State_welldef_MPextensional)
               apply (simp add: State_welldef_def, clarsimp) 
               apply rule apply (rule SetTriv101) apply (rule AL_cod_upd1) apply simp
               apply rule apply (rule SetTriv101) prefer 2 apply assumption 
               apply (rule SetTriv114)
               apply (subgoal_tac " AL_cod \<Gamma>[x\<mapsto>c] \<subseteq> insert c (AL_cod \<Gamma>)") apply (erule thin_rl, erule thin_rl, erule thin_rl, erule thin_rl)
                 apply (erule thin_rl, erule thin_rl, erule thin_rl, erule thin_rl) apply (erule thin_rl, erule thin_rl, erule thin_rl, erule thin_rl) 
                 apply (erule thin_rl, erule thin_rl, erule thin_rl, erule thin_rl) apply (erule thin_rl, erule thin_rl, erule thin_rl, erule thin_rl) 
                 apply (erule thin_rl, erule thin_rl, erule thin_rl, erule thin_rl) apply (erule thin_rl, erule thin_rl, erule thin_rl) apply fast 
              apply (rule SetTriv101) apply (rule AL_cod_upd1) apply simp
              apply (simp add: State_good_def, clarsimp) apply (erule AL_UPD) 
            apply clarsimp apply assumption
apply clarsimp
apply (rule_tac H=bb in Invariant_leftHPextensional)
  apply (simp add: Invariant_def ValRepEQ) 
  apply (rule SetTriv101) apply (rule ValuesRepresented_Store)  apply simp
  apply (rule allI)+ apply rule apply fast
apply clarsimp
apply assumption
done    

end