theory UniSound = UniSatSec + UniTyping + Garbage + UnaryRenSound:

lemma UniTypingSoundAux[rule_format]:
  "((U,\<Sigma>, N, M, l, \<Pi>, NN, L) : UniSS \<longrightarrow>
   get_ins M l \<noteq> Some vreturn \<and>
   (\<forall> n S \<Gamma> H Sp \<Gamma>p Hp. UniCtxtUniValidN n U \<longrightarrow> \<Sigma> = (S,\<Gamma>,H) \<longrightarrow> \<Pi> = (Sp,\<Gamma>p,Hp) \<longrightarrow>
                      (AL_dom H \<subseteq> AL_dom Hp \<and> contained N NN \<and> UniSS_UniSecN (Suc n) \<Sigma> N \<Pi> NN M l L)))
  \<and>
   ((U,\<Sigma>, N, M,l,b,HH,c,NN) : UniBS \<longrightarrow> 
    (\<forall> n k S \<Gamma> H. UniCtxtUniValidN n U \<longrightarrow> \<Sigma> = (S,\<Gamma>,H) \<longrightarrow>
                  (b \<longrightarrow> k=n) \<longrightarrow> ((\<not> b) \<longrightarrow> k=Suc n) \<longrightarrow> 
                  (AL_dom H \<subseteq> AL_dom HH \<and> contained N NN \<and> UniBS_UniSecN k \<Sigma> N HH c NN M l)))"
apply (rule UniSS_UniBS.induct)
(*UniBS_StaticGarbageHP*)
apply clarsimp
apply (erule_tac x=n in allE, clarsimp)
apply (erule_tac x=k in allE, clarsimp)
apply (erule UniBS_StaticGarbageHP_sound) apply simp+
(*UniBS_StaticGarbageColour*)
apply clarsimp
apply (erule_tac x=n in allE, clarsimp)
apply (erule_tac x=k in allE, clarsimp)
apply (erule UniBS_StaticGarbageColour_sound) apply simp+
(*UniSSPost_extensional*)
apply (erule conjE)+
apply clarsimp
apply (erule_tac x=n in allE, erule impE, assumption)
apply (erule conjE)+
apply (subgoal_tac "AL_dom Ha \<subseteq> AL_dom K \<and> contained N MM", erule conjE)
prefer 2 apply rule apply (erule SetTriv101) apply (simp add: AL_dom_def)
         apply (simp (no_asm) add: contained_def, clarsimp)
           apply (drule contained3, assumption) apply clarsimp
apply (rule, assumption)
apply (rule, assumption)
apply (simp only: UniSS_UniSecN_def, (erule conjE)+)
apply (rule, simp)
apply (rule,simp) 
apply (rule, rule)
apply (erule_tac x=na in allE, erule impE, assumption)
apply (rule allI)+
apply (rule impI)+
apply (erule_tac x=\<sigma> in allE, erule_tac x=I in allE, erule_tac x=l1 in allE)
apply (erule_tac x=\<sigma>1 in allE, erule_tac x=Hb in allE, erule_tac x=Nx in allE)
apply (erule_tac x=N0 in allE, erule_tac x=\<Sigma>0 in allE, erule_tac x=\<Pi>0 in allE)
apply (erule_tac x=N1 in allE)
apply (erule impE, assumption)+
apply (erule impE, simp add: SD_sum_def, clarsimp)
   apply (subgoal_tac "AL_dom K = AL_dom H")
     apply rule apply (simp add: AL_sum_def, clarsimp)
     apply (simp (no_asm) add: contained_def, clarsimp) apply (erule contained3, assumption)
     apply simp
   apply (simp add: AL_dom_def)
apply (erule impE, assumption)+
apply (erule impE) apply (subgoal_tac "AL_dom NN = AL_dom MM", clarsimp) apply (simp add: AL_dom_def)
apply (erule impE) apply (subgoal_tac "AL_dom NN = AL_dom MM", simp add: AL_sum_def) 
                     apply (simp (no_asm) add: contained_def, clarsimp) apply (erule contained3, assumption)
                   apply (simp add: AL_dom_def)
apply (erule impE, assumption)+ 
apply assumption 
(*UniBSPost_extensional*)
apply (rule allI)+
apply (rule impI)+
apply (erule_tac x=n in allE, erule_tac x=k in allE, erule_tac x=S in allE) 
apply (erule_tac x=\<Gamma> in allE, erule_tac x=Ha in allE)
apply (erule impE, assumption)+
apply (erule conjE)+
apply (subgoal_tac "AL_dom Ha \<subseteq> AL_dom K \<and> contained N MM", erule conjE)
prefer 2 apply rule apply (erule SetTriv101) apply (simp add: AL_dom_def)
         apply (simp (no_asm) add: contained_def, clarsimp)
           apply (drule contained3, assumption) apply clarsimp
apply (rule, assumption)
apply (rule, assumption)
apply (simp only: UniBS_UniSecN_def, (erule conjE)+)
apply (rule, simp)
apply (rule,simp) 
apply (rule, rule)
apply (erule_tac x=na in allE, erule impE, assumption)
apply (rule allI)+
apply (rule impI)+
apply (erule_tac x=\<sigma> in allE, erule_tac x=I in allE, erule_tac x=h in allE)
apply (erule_tac x=v in allE, erule_tac x=Hb in allE, erule_tac x=Nx in allE)
apply (erule_tac x=N0 in allE, erule_tac x=\<Sigma>0 in allE, erule_tac x=\<Pi>0 in allE)
apply (erule_tac x=N1 in allE)
apply (erule impE, assumption)+
apply (rotate_tac -1, erule impE, simp add: SD_sum_def, clarsimp)
   apply (subgoal_tac "AL_dom K = AL_dom H")
     apply rule apply (simp add: AL_sum_def, clarsimp)
     apply (simp (no_asm) add: contained_def, clarsimp) apply (erule contained3, assumption)
     apply simp
   apply (simp add: AL_dom_def)
apply (erule impE, assumption)+
apply (rotate_tac -1, erule impE) apply (subgoal_tac "AL_dom N' = AL_dom MM", clarsimp) apply (simp add: AL_dom_def)
apply (rotate_tac -1, erule impE) apply (subgoal_tac "AL_dom N' = AL_dom MM", simp add: AL_sum_def) 
                     apply (simp (no_asm) add: contained_def, clarsimp) apply (erule contained3, assumption)
                   apply (simp add: AL_dom_def)
apply (erule impE, assumption)+ 
apply assumption
(*Goto*)
apply clarsimp
apply (rule, rule contained_refl)
apply (simp only: UniSS_UniSecN_def)
apply (rule, clarsimp)
apply (rule, rule contained_refl)
apply (rule allI, rule)
apply (rule allI)+
apply (rule impI)+
apply (rule_tac x=I in exI)
apply clarsimp
apply (drule GotoElim1) apply assumption
apply clarsimp
apply (rule, simp add: SD_sum_def, clarsimp)
apply (rule unisat_HPextensional)
apply (erule unisat_MPextensional)
apply (erule AL_sum_extensional) apply assumption apply assumption
apply (erule AL_sum_extensional) apply assumption apply assumption
apply (rule, rule)
apply (simp add: Invariant_def SD_sum_def ValRepEQ)
  apply clarsimp
  apply (subgoal_tac "ValuesRepresented c (S, \<Gamma>, bd) (ab, ac, ba) I = ValuesRepresented c (S, \<Gamma>, bc) (ab, ac, ba) I", simp) 
  apply (rule ValuesRepresented_HPextensional) apply (erule AL_sum_extensional) apply assumption 
(*Ren*)
apply clarsimp
apply (erule_tac x=n in allE, clarsimp)
apply (frule_tac f=f and g=g in renUniState_preserved) apply assumption 
  apply assumption  apply assumption apply assumption apply simp apply assumption
apply (erule conjE)+
apply (rule, simp)
apply (rule, assumption)
apply (rule UnaryRen_UniSound) apply assumption apply assumption 
  apply assumption apply assumption apply assumption apply assumption
(*SSFrame*)
apply clarsimp
apply (erule_tac x=n in allE, erule impE, assumption)
apply (erule thin_rl)
apply (subgoal_tac "AL_dom Ha \<subseteq> AL_dom Hp \<and> contained NNN1 NN1", clarsimp)
prefer 2
  apply (rule, simp add : AL_sum_def SD_sum_def, clarsimp)
    apply rule apply fast apply fast
  apply (simp (no_asm) add: contained_def, clarsimp)
    apply (drule AL_sum_split, assumption)
    apply (erule disjE) 
      apply (drule contained3, assumption) apply (erule AL_sum3, assumption)
    apply (erule AL_sum4, assumption)
apply (simp only: UniSS_UniSecN_def, (erule conjE)+)
apply (rule, clarsimp)
apply (rule, assumption)
apply (rule allI, rule)
apply (erule_tac x=na in allE, erule impE, assumption)
apply (rule allI)+ apply (rule impI)+
apply (erule_tac x=\<sigma> in allE, erule_tac x=I in allE)
apply (erule_tac x=l1 in allE, erule_tac x=\<sigma>1 in allE)
apply (subgoal_tac "AL_dom H \<inter> AL_dom Hb = {}")
prefer 2 apply (rotate_tac -2,erule thin_rl, erule thin_rl) 
         apply (simp add: SD_sum_def AL_sum_def) apply clarsimp
         apply (rule SetTriv103) prefer 2 apply assumption apply fast 
apply (frule_tac N=H and M=Hb in AL_sum_exists_AL) apply (erule exE, rename_tac H_Hb, erule conjE) 
apply (erule_tac x=H_Hb in allE)
apply (subgoal_tac "AL_dom N \<inter> AL_dom Nx = {}")
prefer 2 apply (rotate_tac -1,erule thin_rl) 
         apply (simp add: SD_sum_def AL_sum_def) apply clarsimp
         apply (rule SetTriv103) prefer 2 apply assumption apply fast 
apply (frule_tac N=N and M=Nx in AL_sum_exists_AL) apply (erule exE, rename_tac N_Nx, erule conjE)
apply (erule_tac x=N_Nx in allE)
apply (erule_tac x=N0 in allE)
apply (erule_tac x=\<Sigma>0 in allE)
apply (erule_tac x=\<Pi>0 in allE)
apply (erule_tac x=N1 in allE)
apply (erule impE,assumption)
apply (erule impE,simp add: SD_sum_def) apply clarsimp 
  apply rule apply (erule AL_sum_sum) apply assumption apply assumption 
  apply (simp add: AL_sum_def, clarsimp) apply fast
apply (erule impE,simp add: SD_sum_def) apply clarsimp 
  apply rule apply (erule AL_sum_sum) apply assumption apply assumption 
  apply (simp add: AL_sum_def, clarsimp) apply fast
apply (erule impE, simp add: AL_sum_def, (erule conjE)+)
  apply (rule, fast)
  apply (rule, erule contained_transitive, assumption)
  apply (simp (no_asm) add: contained_def, clarsimp)
  apply (frule AL_domI, clarsimp)
  apply (erule disjE)
    apply (drule AL_domD, clarsimp)
    apply (drule_tac NN=NNN1 in contained3, assumption)
    apply (drule_tac NN=N_Nx in contained3, assumption) apply clarsimp
    apply (erule_tac NN=N0 in contained3, assumption) 
  apply (drule AL_domD, clarsimp)
    apply (drule_tac NN=N_Nx in contained3, assumption) apply clarsimp
    apply (erule contained3, assumption)
apply (erule impE, simp add: AL_sum_def, clarsimp) apply fast
apply (erule impE, simp add: AL_sum_def, (erule conjE)+)
  apply (rule, fast)
  apply (rule, erule contained_transitive, assumption)
  apply (simp (no_asm) add: contained_def, clarsimp)
  apply (frule AL_domI, clarsimp)
  apply (erule disjE)
    apply (drule AL_domD, clarsimp)
    apply (drule_tac NN=NN1 in contained3, assumption)
    apply (drule_tac NN=N_Nx in contained3, assumption) apply clarsimp
    apply (erule contained3, assumption) 
  apply (drule AL_domD, clarsimp)
    apply (drule_tac NN=N_Nx in contained3, assumption) apply clarsimp
    apply (erule contained3, assumption)
apply (erule impE, assumption)
apply (erule impE, assumption)
apply (erule impE, assumption)
apply (erule impE, simp)
apply (erule impE, simp)
apply (erule impE, assumption)
apply (erule impE, assumption)
apply (erule exE)+ apply (erule conjE)+
apply (rule_tac x=I1 in exI, simp)
(*BSFrame*)
apply clarsimp
apply (erule_tac x=n in allE, erule impE, assumption)
apply (erule thin_rl)
apply (erule_tac x=k in allE, clarsimp)
apply (rotate_tac 5) apply (erule thin_rl, erule thin_rl, erule thin_rl)
apply (subgoal_tac "AL_dom Ha \<subseteq> AL_dom HHH \<and> contained NNN1 NN1", clarsimp)
prefer 2
  apply (rule, simp add : AL_sum_def SD_sum_def, clarsimp)
    apply rule apply fast apply fast
  apply (simp (no_asm) add: contained_def, clarsimp)
    apply (drule AL_sum_split, assumption)
    apply (erule disjE) 
      apply (drule contained3, assumption) apply (erule AL_sum3, assumption)
    apply (erule AL_sum4, assumption)
apply (simp only: UniBS_UniSecN_def, (erule conjE)+)
apply (rule, clarsimp)
apply (rule, simp)
apply (rule allI, rule)
apply (erule_tac x=n in allE, erule impE, assumption)
apply (rule allI)+ apply (rule impI)+
apply (erule_tac x=\<sigma> in allE, erule_tac x=I in allE)
apply (erule_tac x=h in allE, erule_tac x=v in allE)
apply (subgoal_tac "AL_dom H \<inter> AL_dom Hb = {}")
prefer 2 apply (rotate_tac -2,erule thin_rl, erule thin_rl) 
         apply (simp add: SD_sum_def AL_sum_def) apply clarsimp
         apply (rule SetTriv103) prefer 2 apply assumption apply fast 
apply (frule_tac N=H and M=Hb in AL_sum_exists_AL) apply (erule exE, rename_tac H_Hb, erule conjE) 
apply (erule_tac x=H_Hb in allE)
apply (subgoal_tac "AL_dom N \<inter> AL_dom Nx = {}")
prefer 2 apply (rotate_tac -1,erule thin_rl) 
         apply (simp add: SD_sum_def AL_sum_def) apply clarsimp
         apply (rule SetTriv103) prefer 2 apply assumption apply fast 
apply (frule_tac N=N and M=Nx in AL_sum_exists_AL) apply (erule exE, rename_tac N_Nx, erule conjE)
apply (erule_tac x=N_Nx in allE)
apply (erule_tac x=N0 in allE)
apply (erule_tac x=\<Sigma>0 in allE)
apply (erule_tac x=\<Pi>0 in allE)
apply (erule_tac x=N1 in allE)
apply (erule impE,assumption)
apply (erule impE,simp add: SD_sum_def) apply clarsimp 
  apply rule apply (erule AL_sum_sum) apply assumption apply assumption 
  apply (simp add: AL_sum_def, clarsimp) apply fast
apply (erule impE,simp add: SD_sum_def) apply clarsimp 
  apply rule apply (erule AL_sum_sum) apply assumption apply assumption 
  apply (simp add: AL_sum_def, clarsimp) apply fast
apply (erule impE, simp add: AL_sum_def, (erule conjE)+)
  apply (rule, fast)
  apply (rule, erule contained_transitive, assumption)
  apply (simp (no_asm) add: contained_def, clarsimp)
  apply (frule AL_domI, clarsimp)
  apply (erule disjE)
    apply (drule AL_domD, clarsimp)
    apply (drule_tac NN=NNN1 in contained3, assumption)
    apply (drule_tac NN=N_Nx in contained3, assumption) apply clarsimp
    apply (erule_tac NN=N0 in contained3, assumption) 
  apply (drule AL_domD, clarsimp)
    apply (drule_tac NN=N_Nx in contained3, assumption) apply clarsimp
    apply (erule contained3, assumption)
apply (erule impE, simp add: AL_sum_def, clarsimp) apply fast
apply (erule impE, simp add: AL_sum_def, (erule conjE)+)
  apply (rule, fast)
  apply (rule, erule contained_transitive, assumption)
  apply (simp (no_asm) add: contained_def, clarsimp)
  apply (frule AL_domI, clarsimp)
  apply (erule disjE)
    apply (drule AL_domD, clarsimp)
    apply (drule_tac NN=NN1 in contained3, assumption)
    apply (drule_tac NN=N_Nx in contained3, assumption) apply clarsimp
    apply (erule contained3, assumption) 
  apply (drule AL_domD, clarsimp)
    apply (drule_tac NN=N_Nx in contained3, assumption) apply clarsimp
    apply (erule contained3, assumption)
apply (erule impE, assumption)
apply (erule impE, assumption)
apply (erule impE, assumption)
apply (erule impE, simp)
apply (erule impE, simp)
apply (erule impE, assumption)
apply (erule impE, assumption)
apply (erule exE)+ apply (erule conjE)+
apply (rule_tac x=I1 in exI, simp)
(*Const*)
apply (erule UniConst_SoundUni) apply assumption+ 
(*Pop*)
apply (erule UniPop_SoundUni) apply assumption+ 
(*Dup*)
apply (erule UniDup_SoundUni) apply assumption+ 
(*Swap*)
apply (erule UniSwap_SoundUni) apply assumption+ 
(*Load*)
apply (erule UniLoad_SoundUni) apply assumption+ 
(*Store*)
apply (erule UniStore_SoundUni) apply assumption+ 
(*Unop*)
apply (erule UniUnop_SoundUni) apply assumption+ 
(*Binop*)
apply (erule UniBinop_SoundUni) apply assumption+ 
(*BinopNEW
apply (erule UniBinop_SoundUniNEW) apply assumption+ *)
(*Put*)
apply (erule UniPut_SoundUni) apply assumption+ 
(*Get*)
apply (drule_tac U=U in UniGet_SoundUni) apply assumption+ 
(*New*)
apply (drule_tac c=cl and N=N and \<Sigma>="(S, \<Gamma>, H)" and U=U in UniNew_SoundUniSubclass) apply fastsimp apply assumption 
  apply simp apply simp  apply simp apply assumption apply clarsimp
(*InvS*)
apply (rule, clarsimp)
apply (rule, rule, rule, rule)
apply (rule, rule, rule, rule)
apply (rule, rule)
apply (erule_tac x=n in allE, erule_tac x=n in allE)
apply (erule_tac x="[]" in allE, erule_tac x=\<Gamma>1 in allE)
apply (erule_tac x=H in allE)
apply (erule impE, assumption)
apply (erule impE, simp)
apply (erule impE, simp)
apply (erule impE, simp)
apply (rule, simp)
apply (rule, simp)
apply (erule conjE)+
apply (erule Uni_InvS_SoundUni) apply assumption+
(*the rules InvV, InvV2 are sound, but we havent adapted the proofs in ruluniInvV to UniSec yet*)
(*InvV 
apply (rule, clarsimp)
apply (rule, rule, rule, rule)
apply (rule, rule, rule, rule)
apply (rule, rule)
apply (subgoal_tac "AL_dom Ha \<subseteq> AL_dom Hp \<and> contained N NN", erule conjE)
prefer 2 apply (erule_tac x=C in allE, erule_tac x=code in allE, erule_tac x=l0 in allE)
           apply (erule impE) apply (simp add: subclass_of_refl)
           apply (erule impE, assumption) 
           apply (erule conjE)
           apply (erule_tac x=n in allE, erule_tac x=n in allE, erule_tac x="[]" in allE,
                    erule_tac x="upd \<Gamma>1 this d" in allE, erule_tac x=H in allE, clarsimp)
apply (rule, assumption)
apply (rule, assumption)
apply (erule Uni_InvV_Sound) apply assumption apply assumption apply assumption apply assumption
   apply assumption apply assumption apply assumption apply assumption apply assumption
   apply clarsimp apply assumption apply assumption
(InvV2)
apply (rule, clarsimp)
apply (rule, rule, rule, rule)
apply (rule, rule, rule, rule)
apply (rule, rule)
apply (subgoal_tac "AL_dom Ha \<subseteq> AL_dom Hp \<and> contained N NN", erule conjE)
prefer 2 apply (erule_tac x=D in allE, clarsimp) 
         apply (erule impE, simp add: subclass_of_refl) apply clarsimp  
apply (rule, assumption)
apply (rule, assumption)
apply (erule Uni_InvV2_Sound) apply assumption apply assumption apply assumption apply assumption
   apply assumption apply assumption apply assumption apply assumption apply assumption
   apply clarsimp apply assumption apply assumption
*)
(*InvV3*)
apply (rule, clarsimp)
apply (rule, rule, rule, rule)
apply (rule, rule, rule, rule)
apply (rule, rule)
apply (subgoal_tac "AL_dom Ha \<subseteq> AL_dom Hp \<and> contained N NN", erule conjE)
prefer 2 apply (erule_tac x=D in allE, clarsimp) 
         apply (erule impE, simp add: subclass_of_refl) apply clarsimp  
apply (rule, assumption)
apply (rule, assumption)
apply (erule Uni_InvV3_SoundUni) apply assumption apply assumption apply assumption apply assumption
   apply assumption apply assumption apply assumption apply assumption
   apply clarsimp apply assumption apply assumption
(*Iftrue*)
apply (simp only: UniSS_UniSecN_def)
apply rule apply simp
apply (rule allI)+
apply (rule impI)+
apply (rule, simp)
apply (rule, rule contained_refl)
apply (rule, simp)
apply (rule, rule contained_refl)
apply clarsimp
apply (drule IfElim1) apply assumption
apply (simp add: SD_sum_def, clarsimp)
apply (subgoal_tac "\<forall>x c. (be\<down>x = Some c) = (bf\<down>x = Some c)")
prefer 2 apply (erule AL_sum_extensional, assumption) 
apply (subgoal_tac "\<forall>x c. (N0\<down>x = Some c) = (N1\<down>x = Some c)")
prefer 2 apply (erule AL_sum_extensional, assumption) 
apply (subgoal_tac "ObjIDs N1 = ObjIDs N0")
prefer 2 apply (simp add: ObjIDs_def)
apply (drule_tac HH=bf in unisat_HPextensional)
  apply assumption apply assumption
apply (drule_tac NN=N1 in unisat_MPextensional) apply assumption apply assumption
apply (erule disjE) apply clarify
  apply (rule, simp)
  apply (rule_tac x=I in exI)
  apply rule apply (erule unisat_Tail)
  apply clarsimp
    apply (rule_tac H=be in Invariant_leftHPextensional) 
      apply (simp add: Invariant_def ValRepEQ)
      apply (rule ValuesRepresented9) 
    apply clarsimp
    apply assumption
apply clarify
  apply (rule, simp)
  apply (rule_tac x=I in exI)
  apply rule apply (erule unisat_Tail)
  apply clarsimp
    apply (rule_tac H=be in Invariant_leftHPextensional) 
      apply (simp add: Invariant_def ValRepEQ)
      apply (rule ValuesRepresented9) 
      apply (rule allI)+ apply rule apply fast
    apply clarsimp
    apply assumption
(*Vret*)
apply (simp only: UniSS_UniSecN_def)
apply (rule allI)+
apply (rule impI)+
apply (rule, simp)
apply (rule, rule contained_refl)
apply clarsimp
apply (simp add: UniBS_UniSecN_def)
apply (rule, rule contained_refl)
apply (rule, rule)
apply (rule allI)+
apply (rule impI)+
apply (rule allI)+
apply (rule impI)+
apply (rule allI)+
apply (rule impI)+
apply (drule ExecElim1) apply clarsimp
apply (simp add: SD_sum_def, clarsimp)
apply (subgoal_tac "\<forall>x c. (bb\<down>x = Some c) = (bc\<down>x = Some c)")
prefer 2 apply (erule AL_sum_extensional, assumption) 
apply (subgoal_tac "\<forall>x c. (N0\<down>x = Some c) = (N1\<down>x = Some c)")
prefer 2 apply (erule AL_sum_extensional, assumption) 
apply (subgoal_tac "ObjIDs N1 = ObjIDs N0")
prefer 2 apply (simp add: ObjIDs_def)
apply (drule_tac HH=bc in unisat_HPextensional)
  apply assumption apply assumption
apply (drule_tac NN=N1 in unisat_MPextensional) apply assumption apply assumption
apply (erule disjE, clarsimp)
  apply (simp add: unisat_def, clarsimp) 
  apply (rule, simp add: State_welldef_def, clarsimp)
    apply (simp add: AL_cod_emp)
    apply (rule, fast)
    apply (simp add: State_good_def) apply (rule AL_EMP)
  apply (rule_tac x=I in exI)
  apply (rule, simp add: StateSatisfiesAbstraction_def, clarsimp)
  apply (subgoal_tac "State_typecorrect N1 ([c], emp, bc) ([v], emp, ba) I",rule,assumption)
  prefer 2 apply (simp add: State_typecorrect_def, clarsimp)
    apply (simp add: Opstack_typecorrect_def Store_typecorrect_def)
    apply rule apply (erule_tac x=0 in allE, clarsimp)
    apply rule apply clarsimp apply (simp add: AL_emp1)
    apply (subgoal_tac "DOM ([c], emp, bc) \<subseteq> DOM (c # S, \<Gamma>', bc)")
      apply (rule, simp add: uniqueValues_def, clarsimp)
        apply (erule_tac x=ca in allE, erule impE, erule SetTriv, assumption)
        apply (erule exE) apply (rule_tac x=va in exI)
        apply rule apply (rule_tac Y="ValuesRepresented ca (c # S, \<Gamma>', bc) (v # ops, ac, ba) I" in SetTriv101) 
          apply (rule SetTriv101, rule ValuesRepresented_HD) apply (rule ValuesRepresented13) apply simp 
        apply (subgoal_tac "\<exists> w . w: ValuesRepresented ca ([c], emp, bc) ([v], emp, ba) I", erule exE)
          apply (subgoal_tac "w=va", clarsimp)
          apply (drule_tac x=w and Y="ValuesRepresented ca (c # S, \<Gamma>', bc) (v # ops, ac, ba) I" in SetTriv)
          apply (rule SetTriv101, rule ValuesRepresented_HD) apply (rule ValuesRepresented13) apply simp 
        apply (subgoal_tac " ValuesRepresented ca ([c], emp, bc) ([v], emp, ba) I \<noteq> {}") apply fast
        apply (subgoal_tac " Values_Represented ca ([c], emp, bc) ([v], emp, ba) I \<noteq> {}") apply (simp add: ValRepEQ)
        apply (erule State_typecorrect_VR_notEmpty) apply assumption
      apply (rule SetTriv101) prefer 2 apply assumption apply fast 
    apply (rule DOM_1)
  apply clarsimp  
  apply (rule_tac H=bb in Invariant_leftHPextensional) 
    apply (simp add: Invariant_def ValRepEQ)
    apply (rule SetTriv101)  apply (rule_tac S=S and ops=ops in ValuesRepresented_HD)
                                   apply (rule_tac \<Gamma>=\<Gamma>' and s=ac in ValuesRepresented13)
  apply clarsimp
  apply assumption
apply (erule exE)+ apply (erule conjE)+
  apply (drule RetElim1) apply assumption apply clarsimp 
(*Run*)
apply clarsimp
  apply (frule UniSS_L_notEmpty) apply (erule exE, rename_tac l')
  apply (erule_tac x=n in allE, clarsimp)
  apply (subgoal_tac "AL_dom bb \<subseteq> AL_dom H \<and> contained N' N''", erule conjE)
  prefer 2 apply (erule_tac x=l' in allE, clarsimp)
  apply (subgoal_tac "AL_dom Ha \<subseteq> AL_dom H \<and> contained N N''")
  prefer 2 apply (rule, fast)
           apply (erule contained_transitive) apply assumption
  apply (erule thin_rl, unfold UniBS_UniSecN_def UniSS_UniSecN_def)
  apply (erule conjE)+
  apply (rule, assumption)
  apply (rule, assumption)
  apply (rule, rotate_tac -1, erule thin_rl, erule thin_rl, simp) 
  apply (rule, assumption)
  apply (rule, rule)
  apply (rule allI)+
  apply (rule impI)+
  apply (drule ExecElim2)
  apply (erule disjE, clarsimp) 
  apply (erule exE)+ apply (erule conjE)+
  apply (rotate_tac 1, erule_tac x=nb in allE, erule impE) apply simp (*apply (, erule Arith_17, assumption) *)
  apply (erule_tac x=\<sigma> in allE, rotate_tac -1, erule_tac x=I in allE)
  apply (erule_tac x=ll in allE, rotate_tac -1, erule_tac x=t in allE)
  apply (erule_tac x=Hb in allE, erule_tac x=Nx in allE, erule_tac x=N0 in allE, erule_tac x=\<Sigma>0 in allE) 
  apply (subgoal_tac "AL_dom bb \<inter> AL_dom Hb = {}")
  prefer 2 apply (rotate_tac -2, erule thin_rl, erule thin_rl)
           apply (simp add: SD_sum_def, clarsimp)
           apply (erule SetTriv103) apply assumption
  apply (frule_tac N=bb in AL_sum_exists_AL) apply (erule exE, rename_tac bb_Hb, erule conjE)
  apply (subgoal_tac "AL_dom N' \<inter> AL_dom Nx = {}")
  prefer 2 apply (rotate_tac -5, erule thin_rl, erule thin_rl)
           apply (rule_tac Y="AL_dom N''" in SetTriv103) apply (erule contained5) apply assumption
  apply (frule_tac N=N' in AL_sum_exists_AL) apply (erule exE, rename_tac N'Nx, erule conjE)
  apply (erule_tac x="(ad, ae, bb_Hb)" in allE, erule_tac x=N'Nx in allE)
  apply (erule impE, assumption)
  apply (erule impE) apply (rotate_tac -7, erule thin_rl) apply (simp add: SD_sum_def)
  apply (erule impE) apply (rotate_tac -7, erule thin_rl) apply (simp add: SD_sum_def)
  apply (erule impE, assumption)
  apply (erule impE, assumption)
  apply (erule impE, assumption)
  apply (erule impE, assumption)
  apply (erule impE, assumption)
  apply (erule impE, assumption)
  apply (erule impE, assumption)
  apply (erule impE) apply (rotate_tac -7, erule thin_rl) apply simp 
  apply (erule impE, assumption)
  apply (erule impE, assumption)
  apply (erule exE)+ apply (erule conjE)+
  apply (erule_tac x=ll in allE, erule impE, assumption, erule conjE)
  apply (erule_tac x=n in allE, erule impE, assumption)
  apply (erule conjE)+
  apply (erule_tac x=m in allE, erule impE, erule Arith_18, assumption)
  apply (erule_tac x=t in allE, erule_tac x=I1 in allE)
  apply (erule_tac x=h in allE, erule_tac x=v in allE, rotate_tac -1, erule_tac x=Hb in allE)
  apply (erule_tac x=Nx in allE, erule_tac x=N'Nx in allE)
  apply (erule_tac x="(ad, ae, bb_Hb)" in allE, erule_tac x=\<Pi>0 in allE)
  apply (erule_tac x=N1 in allE)
  apply (erule impE, assumption)
  apply (erule impE, simp add: SD_sum_def)
  apply (erule impE, assumption)
  apply (erule impE, assumption)
  apply (erule impE, assumption)
  apply (erule impE, assumption)
  apply (erule impE, assumption)
  apply (erule impE, assumption)
  apply (erule impE, assumption)
  apply (erule impE, simp)
  apply (erule impE, assumption)
  apply (erule impE, assumption)
  apply (erule impE, assumption)
  apply (erule exE)+ apply (erule conjE)+
  apply (rule_tac x=I1a in exI, simp)
  apply (subgoal_tac "contained N0 N'Nx")
  prefer 2 apply (rotate_tac -8)
           apply (erule thin_rl, erule thin_rl, erule thin_rl)
           apply (rotate_tac 3)
           apply (erule thin_rl, erule thin_rl)
           apply (simp (no_asm) add: contained_def, clarsimp)
           apply (drule AL_sum_split, assumption)
           apply (erule disjE)
             apply (erule AL_sum3) apply (erule contained3, assumption)
           apply (erule AL_sum4, assumption)           
  apply (rule, rule)
  apply (erule_tac x=d in allE, erule impE, assumption)
  apply (erule_tac x=d in allE, erule impE) apply (erule contained6) apply assumption
  apply (erule conjE)+
    apply (simp add: Invariant_def, clarsimp)
    apply (rule, rule) apply (erule impE, assumption)
                       apply (erule impE) apply (erule SetTriv, erule contained_ObjIds_subset)
                       apply simp
    apply (erule SetTriv101) apply assumption
(*Inj*)
apply (rule allI)+
apply (rule impI)+
apply (rotate_tac -1, erule thin_rl)
apply (erule impE, fast)
apply clarify
apply (erule_tac x=n in allE, erule_tac x="Suc n" in allE)
apply (erule_tac x=S in allE, erule_tac x=\<Gamma> in allE, erule_tac x=Ha in allE)
apply (erule impE, assumption)
apply (erule impE, simp)
apply (erule impE, simp)
apply (erule impE, simp)
apply (erule conjE)+
apply (rule, assumption)
apply (rule, assumption)
apply (rule, assumption)
apply (rule, assumption)
apply (rule, rule)
apply (erule_tac x=na in allE, erule mp, simp)
(*Ax*)
apply (rule allI)+
apply (rule impI)+
apply (rotate_tac -1, erule thin_rl)
apply (erule impE, fast)
apply clarify
apply clarsimp
apply (simp add: UniCtxtUniValidN_def UniBS_UniSecN_def)
done

lemma UniTypingSoundSS_N[rule_format]:
  "((U,\<Sigma>, N, M, l, \<Pi>, NN, L) : UniSS \<longrightarrow>
   get_ins M l \<noteq> Some vreturn \<and>
   (\<forall> n S \<Gamma> H Sp \<Gamma>p Hp. UniCtxtUniValidN n U \<longrightarrow> \<Sigma> = (S,\<Gamma>,H) \<longrightarrow> \<Pi> = (Sp,\<Gamma>p,Hp) \<longrightarrow>
                      (AL_dom H \<subseteq> AL_dom Hp \<and> contained N NN \<and> UniSS_UniSecN (Suc n) \<Sigma> N \<Pi> NN M l L)))"
apply (insert UniTypingSoundAux [of U \<Sigma> N M l \<Pi> NN L True H c]) apply fastsimp
done

lemma UniTypingSoundBS_N[rule_format]:
 "((U,\<Sigma>, N, M,l,b,HH,c,NN) : UniBS \<longrightarrow> 
    (\<forall> n k S \<Gamma> H. UniCtxtUniValidN n U \<longrightarrow> \<Sigma> = (S,\<Gamma>,H) \<longrightarrow>
                  (b \<longrightarrow> k=n) \<longrightarrow> ((\<not> b) \<longrightarrow> k=Suc n) \<longrightarrow> 
                  (AL_dom H \<subseteq> AL_dom HH \<and> contained N NN \<and> UniBS_UniSecN k \<Sigma> N HH c NN M l)))"
apply (insert UniTypingSoundAux [of U \<Sigma> N M l \<Pi> NN L b HH c]) apply fastsimp
done

lemma UniTypingSoundSS_validCtxt[rule_format]:
 "\<lbrakk>(U,\<Sigma>, N, M, l, \<Pi>, NN, L) : UniSS; UniCtxtUniValid U\<rbrakk>
  \<Longrightarrow> get_ins M l \<noteq> Some vreturn \<and>
   (\<forall> S \<Gamma> H Sp \<Gamma>p Hp. \<Sigma> = (S,\<Gamma>,H) \<longrightarrow> \<Pi> = (Sp,\<Gamma>p,Hp) \<longrightarrow>
                      (AL_dom H \<subseteq> AL_dom Hp \<and> contained N NN \<and> UniSS_UniSec \<Sigma> N \<Pi> NN M l L))"
apply (subgoal_tac "\<forall> n .get_ins M l \<noteq> Some vreturn \<and>
       (\<forall>S \<Gamma> H Sp \<Gamma>p Hp. \<Sigma> = (S, \<Gamma>, H) \<longrightarrow> \<Pi> = (Sp, \<Gamma>p, Hp) \<longrightarrow> AL_dom H \<subseteq> AL_dom Hp \<and> contained N NN \<and> UniSS_UniSecN n \<Sigma> N \<Pi> NN M l L)")
  apply clarsimp apply (erule UniSS_UniSecN_UniSS_UniSec)
apply (drule UniTypingSoundSS_N)
apply clarsimp
apply (erule_tac x=n in allE, erule impE, erule UniCtxtUniValid_UniCtxtUniValidN)
apply clarsimp
apply (erule UniSS_UniSecN_subN) apply simp
done

lemma UniTypingSoundBS_UnivalidCtxt[rule_format]:
 "\<lbrakk>(U,\<Sigma>, N, M, l, b, HH, c, NN) : UniBS; UniCtxtUniValid U; \<Sigma> = (S,\<Gamma>,H)\<rbrakk>
  \<Longrightarrow> (AL_dom H \<subseteq> AL_dom HH \<and> contained N NN \<and> UniBS_UniSec \<Sigma> N HH c NN M l)"
apply (subgoal_tac "\<forall> n .AL_dom H \<subseteq> AL_dom HH \<and> contained N NN \<and> UniBS_UniSecN n \<Sigma> N HH c NN M l")
  apply clarsimp apply (erule UniBS_UniSecN_UniBS_UniSec)
apply rule
apply (case_tac b)
  apply (drule_tac n=n and k=n in UniTypingSoundBS_N)
  apply (erule  UniCtxtUniValid_UniCtxtUniValidN)
  apply fastsimp
  apply simp
  apply simp
  apply clarsimp
apply (drule_tac n=n and k="Suc n" in UniTypingSoundBS_N)
  apply (erule  UniCtxtUniValid_UniCtxtUniValidN)
  apply fastsimp
  apply simp
  apply simp
  apply clarsimp
  apply (erule UniBS_UniSecN_subN) apply simp
done

text{*Indeed, formal derivability entails semantic validity of
contexts.*}

lemma UniCtxtVerified_UniCtxtUniValidN[rule_format]:
"UniCtxtVerified U \<longrightarrow> UniCtxtUniValidN n U"
(*<*)
apply (induct n)
  apply (simp add: UniCtxtUniValidN_def UniCtxtVerified_def, clarsimp)
  apply (simp add: UniBS_UniSecN_def, clarsimp)
  apply (drule no_zero_height_Exec_derivs) apply simp
apply clarsimp
   apply (simp (no_asm) add: UniCtxtUniValidN_def) apply clarsimp
   apply (subgoal_tac " AL_dom H \<subseteq> AL_dom H' \<and> contained N N' \<and>
                         (U, (S,\<Gamma>,H), N, (a,aa,b),l,False,H',c,N') : UniBS")
   prefer 2 apply (simp add: UniCtxtVerified_def)
   apply clarsimp
   apply (drule_tac n=n and k="Suc n" in UniTypingSoundBS_N)
   apply assumption
   apply fastsimp
   apply simp
   apply simp
   apply clarsimp
done
(*>*)

lemma UniCtxtVerified_UniCtxtUniValid: "UniCtxtVerified U \<Longrightarrow> UniCtxtUniValid U"
(*<*)
apply (rule UniCtxtUniValidN_UniCtxtUniValid)
apply clarsimp
apply (erule UniCtxtVerified_UniCtxtUniValidN)
done
(*>*)

text{*Thus, we conclude soundness with respect to formally justified
contexts.*}

theorem UniSS_SoundUni[rule_format]:
 "\<lbrakk>(U,(S,\<Gamma>,H), N, M, l, (Sp,\<Gamma>p,Hp), NN, L) : UniSS; UniCtxtVerified U\<rbrakk>
  \<Longrightarrow> get_ins M l \<noteq> Some vreturn \<and> AL_dom H \<subseteq> AL_dom Hp \<and> 
      contained N NN \<and> UniSS_UniSec (S,\<Gamma>,H) N (Sp,\<Gamma>p,Hp) NN M l L"
apply (drule UniTypingSoundSS_validCtxt)
apply (erule UniCtxtVerified_UniCtxtUniValid)
apply clarsimp
done

theorem UniBS_Sound[rule_format]:
 "\<lbrakk>(U,(S,\<Gamma>,H), N, M, l, b, HH, c, NN) : UniBS; UniCtxtVerified U\<rbrakk>
  \<Longrightarrow> AL_dom H \<subseteq> AL_dom HH \<and> contained N NN \<and> UniBS_UniSec (S,\<Gamma>,H) N HH c NN M l"
apply (drule UniTypingSoundBS_UnivalidCtxt)
apply (erule UniCtxtVerified_UniCtxtUniValid)
apply fastsimp
apply clarsimp
done

end